// AYTools.h
// Performed by Denis Cote May 5, 1998
// Last Updated Jun 09, 2006
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef ___DCTools___
#define ___DCTools___
#define DCTOOLS_SUPPORT
///////////////////////////////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <errno.h>
///////////////////////////////////////////////////////////////////////////////////////////////////
// LOCAL MACRO
///////////////////////////////////////////////////////////////////////////////////////////////////
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef Not
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef _DEBUG
#define ErrorBeep(A) MessageBeep(A) // MB_ICONEXCLAMATION | MB_ICONASTERISK | MB_ICONHAND | MB_ICONQUESTION
#else
#define ErrorBeep(A)
#endif

#ifdef _DEBUG
#define BeepForError() MessageBeep(MB_ICONEXCLAMATION) // MB_ICONEXCLAMATION | MB_ICONASTERISK | MB_ICONHAND | MB_ICONQUESTION
#else
#define BeepForError()
#endif

#ifdef _DEBUG
#define TestBeep() Beep(1200, 50)
#else
#define TestBeep()
#endif

#define FullBeep() Beep(100, 50)

#define Not  !
#define And  &
#define Or   |
#define Xor  ^
#define Exclude &~

#define NullString _T("")

#define Forever() while(TRUE)

#define KB (1024U)
#define MB (1024U * KB)
#define GB (1024U * MB)
#define DISKTRANSFER (32 * MB)

#define SECOND      (1000)
#define MINUTE      (60 * SECOND)
#define QUARTERHOUR (15 * MINUTE)
#define HALFHOUR    (30 * MINUTE)
#define HOUR        (60 * MINUTE)
#define DAY         (24 * HOUR)

#define TSECOND      (1)
#define TMINUTE      (60 * TSECOND)
#define TQUARTERHOUR (15 * TMINUTE)
#define THALFHOUR    (30 * TMINUTE)
#define THOUR        (60 * TMINUTE)
#define TDAY         (24 * THOUR)

#define SizeOf(VarName,VarType) (sizeof(VarName) * sizeof(VarType))

#define LenOf(VarName)          (sizeof(VarName) / sizeof(VarName[0]))

#define LenOfTChar(VarName)     (sizeof(VarName) / sizeof(TCHAR))
#define LenOfWChar(VarName)     (sizeof(VarName) / sizeof(WCHAR))
#define LenOfAChar(VarName)     (sizeof(VarName))

#define LenInTChar(Value)       ((Value)         / sizeof(TCHAR))
#define LenInWChar(Value)       ((Value)         / sizeof(WCHAR))
#define LenInAChar(Value)       ((Value))

#define SizeFromTCharLen(Value) ((Value)         * sizeof(TCHAR))

/* DC:: DEFINE BY STUPID SQLTYPES.H AS AN OXYMORON FORM A MORON AT MS...
#undef  SBYTE
#undef  SBOOL
#undef  SSHORT
#undef  SLONG
#undef  SINT
#undef  SWORD
#undef  SDWORD
*/

#define VBYTE  volatile BYTE
#define GBYTE  static   BYTE

#define VBOOL  volatile BOOL
#define GBOOL  static   BOOL

#define VINT   volatile INT
#define GINT   static   INT

#define VUINT  volatile UINT
#define GUINT  static   UINT

#define VLONG  volatile LONG
#define GLONG  static   LONG

#define VSHORT volatile SHORT
#define GSHORT static   SHORT

#define VWORD  volatile WORD
#define GWORD  static   WORD

#define VDWORD volatile DWORD
#define GDWORD static   DWORD

typedef const BYTE                CBYTE;
typedef const BYTE                *PCBYTE;
typedef const BYTE far            *LPCBYTE;
typedef int MSG;

#define BIT0  1
#define BIT1  2
#define BIT2  4
#define BIT3  8
#define BIT4  16
#define BIT5  32
#define BIT6  64
#define BIT7  128
#define BIT8  256
#define BIT9  512
#define BIT10 1024
#define BIT11 2048
#define BIT12 4096
#define BIT13 8192
#define BIT14 16384
#define BIT15 32768

#define CR   _T("\r")
#define LF   _T("\n")
#define CRLF _T("\r\n")
//#define EOL  "\r\n"
#define EOL  "\n"

#define Max(a,b)            (((a) > (b)) ? (a) : (b))
#define Min(a,b)            (((a) < (b)) ? (a) : (b))
#define Diff(X , Y)         ((X > Y) ? (X - Y) : (Y - X))

#define IsInRange(Val, Mini, Maxi) ((Val >= Mini) && (Val < Maxi))

#define RotateInRange(Val, Mini, Maxi)  (Val > Maxi ? Mini : (Val < Mini ? Mini : Val))

#define MakeInRange(Val, Mini, Maxi) min( max(Val, Mini), Maxi)
// MakePtr is a macro that allows you to easily add to values (including
// pointers) together without dealing with C's pointer arithmetic.  It
// essentially treats the last two parameters as DWORDs.  The first
// parameter is used to typecast the result to the appropriate pointer type.
#define MakePtr( cast, ptr, addValue ) (cast)( (DWORD)(ptr) + (DWORD)(addValue))
///////////////////////////////////////////////////////////////////////////////////////////////////
#define ALIGN_DWORD( type, p ) ( (type)(((DWORD)p+3) & ~3 ))
#define ALIGN_WORD( type, p ) ( (type)(((DWORD)p+1) & ~1 ))

///////////////////////////////////////////////////////////////////////////////////////////////////
#define DCGetOverlappedResult(S, O, N, B, E) GetOverlappedResult((HANDLE)S, O, N, B)
///////////////////////////////////////////////////////////////////////////////////////////////////
// TYPE MISSING SUPPORT
///////////////////////////////////////////////////////////////////////////////////////////////////
typedef const void * PCVOID;

///////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef _DEBUG
#define DEBUG_BREAK()    DebugBreak()
#else
#define DEBUG_BREAK()
#endif

///////////////////////////////////////////////////////////////////////////////////////////////////
typedef union {
   DWORD   AsDword;
   long    AsLong;
   WORD    AsWord  [2];
   short   AsShort [2];
   BYTE    AsByte  [4];
   char    AsChar  [4];

   float   AsFloat;

} TYPES, PTYPES;
///////////////////////////////////////////////////////////////////////////////////////////////////
// MEM SUPPORT
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static WORD  SWAPWORD(WORD Value)
{
WORD  TempValue  = (Value << 8);
      TempValue |= (Value >> 8);

    return TempValue;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static DWORD SWAPDWORD(DWORD Value)
{
DWORD TempValue  = (SWAPWORD(LOWORD(Value)) << 16 );
      TempValue |= (SWAPWORD(HIWORD(Value))  & 0xFFFF );

    return TempValue;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static BOOL IsMemEmpty( void * Mem, DWORD SizeofMem){
DWORD   looper;
LPBYTE  TheMem = (LPBYTE)Mem;

    for(looper = 0; looper < SizeofMem;looper++){
       if(*TheMem++){
          return FALSE;
       }
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static BOOL IsMemDirty( void * Mem, DWORD SizeofMem){
DWORD   looper;
LPBYTE  TheMem = (LPBYTE)Mem;

    for(looper = 0; looper < SizeofMem;looper++){
       if(*TheMem++){
          return TRUE;
       }
    }
    return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline void EmptyMemory (void * MemPtr, size_t Lenght)
{
unsigned char * ThisPtr = (unsigned char *)MemPtr;

    while(Lenght--){
       *ThisPtr++ = 0;
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// RECT SUPPORT...
///////////////////////////////////////////////////////////////////////////////////////////////////
const RECT NullRect = {0,0,0,0};
///////////////////////////////////////////////////////////////////////////////////////////////////
#define GetRectWidth(R)   abs(R.right   - R.left)
#define GetRectHeight(R)  abs(R.bottom  - R.top)

#define GetPRectWidth(R)  abs(R->right  - R->left)
#define GetPRectHeight(R) abs(R->bottom - R->top)

__forceinline static BOOL IsEmptyRect(LPCRECT ThisRect)
{
    if((ThisRect->left  == ThisRect->right)
    || (ThisRect->top   == ThisRect->bottom)){
       return TRUE;
    }
    return FALSE;
}
__forceinline static BOOL IsNullRect(LPCRECT ThisRect)
{
    if((ThisRect->top   == 0)
    && (ThisRect->top   == ThisRect->bottom)
    && (ThisRect->left  == 0)
    && (ThisRect->left  == ThisRect->right)
    ){
       return TRUE;
    }
    return FALSE;
}
__forceinline static BOOL IsNormalRect(LPCRECT ThisRect)
{
    if((ThisRect->left  >= ThisRect->right)
    || (ThisRect->top   >= ThisRect->bottom)){
       return FALSE;
    }
    return TRUE;
}
__forceinline static BOOL IsAbNormalRect(LPCRECT ThisRect)
{
    if((ThisRect->right  <= ThisRect->left)
    || (ThisRect->bottom <= ThisRect->top)){
       return TRUE;
    }
    return FALSE;
}
__forceinline static void NormalizeRect(LPRECT ThisRect)
{
int TempPos;

    if(ThisRect->left     > ThisRect->right){
       TempPos            = ThisRect->left;
       ThisRect->left     = ThisRect->right;
       ThisRect->right    = TempPos;
    }
	if(ThisRect->top      > ThisRect->bottom){
		TempPos           = ThisRect->top;
		ThisRect->top     = ThisRect->bottom;
		ThisRect->bottom  = TempPos;
	}
}
__forceinline static void MoveRect(LPRECT ThisRect, int X, int Y)
{
    ThisRect->left       += X;
    ThisRect->right      += X;
	ThisRect->top        += Y;
	ThisRect->bottom     += Y;
}
__forceinline static void InflateRect(LPRECT ThisRect, LPCRECT ThatRect)
{
	ThisRect->left       -= ThatRect->left;
	ThisRect->top        -= ThatRect->top;
	ThisRect->right      += ThatRect->right;
	ThisRect->bottom     += ThatRect->bottom;
}
__forceinline static void InflateRect(LPRECT ThisRect, int left, int top, int right, int bottom)
{
	ThisRect->left       -= left;
	ThisRect->top        -= top;
	ThisRect->right      += right;
	ThisRect->bottom     += bottom;
}
__forceinline static void DeflateRect(LPRECT ThisRect, LPCRECT ThatRect)
{
	ThisRect->left       += ThatRect->left;
	ThisRect->top        += ThatRect->top;
	ThisRect->right      -= ThatRect->right;
	ThisRect->bottom     -= ThatRect->bottom;
}
__forceinline static void DeflateRect(LPRECT ThisRect, int left, int top, int right, int bottom)
{
	ThisRect->left       += left;
	ThisRect->top        += top;
	ThisRect->right      -= right;
	ThisRect->bottom     -= bottom;
}
__forceinline static BOOL IsIntersectRect(LPCRECT ThisRect, LPCRECT ThatRect)
{
    if(IsEmptyRect(ThisRect) || IsEmptyRect(ThatRect)){
       return FALSE;
    }
    if((ThisRect->left  > ThatRect->right)  || (ThisRect->right  < ThatRect->left)) {
       return FALSE;
    }
    if((ThisRect->top   > ThatRect->bottom) || (ThisRect->bottom < ThatRect->top)) {
       return FALSE;
    }
    return TRUE;
}
__forceinline static BOOL IsRectInRect(LPCRECT ThisRect, LPCRECT ThatRect)
{
    if(IsEmptyRect(ThisRect) || IsEmptyRect(ThatRect)){
       return FALSE;
    }
    if((ThisRect->left  >= ThatRect->left)  && (ThisRect->right  <= ThatRect->right)
    && (ThisRect->top   >= ThatRect->top)   && (ThisRect->bottom <= ThatRect->bottom)
    ){
       return TRUE;
    }
    return FALSE;
}
__forceinline static BOOL IsRect16(LPCRECT ThisRect)
{
long Width,     Height;
long MinShort = (SHORT)MINSHORT, MaxShort = MAXSHORT;

    if(IsEmptyRect(ThisRect)){
       return FALSE;
    }
    Width                     = GetPRectWidth(ThisRect);
    Height                    = GetPRectHeight(ThisRect);
    // IF TOO NEGATIVE
    if((ThisRect->top         < MinShort)
    || (ThisRect->left        < MinShort)
    || (Width                 < MinShort)
    || (Height                < MinShort)
    ){
       return FALSE;
    }
    // IF TOO POSITIVE
    if((ThisRect->top         > MaxShort)
    || (ThisRect->left        > MaxShort)
    || (Width                 > MaxShort)
    || (Height                > MaxShort)
    ){
       return FALSE;
    }
    return TRUE;
}
__forceinline static DWORD SizeOfRect(LPCRECT ThisRect)
{
DWORD ThisRectWidth, ThisRectHeight, ThisRectSize = 0;

    if(IsEmptyRect(ThisRect)){
       return 0;
    }
    ThisRectWidth        = abs((ThisRect->right  - ThisRect->left));
    ThisRectHeight       = abs((ThisRect->bottom - ThisRect->top));
    ThisRectSize         = ThisRectWidth         * ThisRectHeight;

    return ThisRectSize;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
// CLIP SUPPORT...
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static BOOL SubRect(LPRECT ThisRect, LPCRECT ThatRect)
{
BOOL bRet = FALSE;

    if(IsEmptyRect(ThisRect) || IsEmptyRect(ThatRect)){
       return FALSE;
    }
    if(IsIntersectRect(ThisRect, ThatRect) ){

       // TOP
       if((ThisRect->top     < ThatRect->top)
       && (ThisRect->bottom <= ThatRect->bottom)
       && (ThisRect->left   >= ThatRect->left)
       && (ThisRect->right  <= ThatRect->right)
       ){
          ThisRect->bottom   = ThatRect->top;      bRet              = TRUE;
       }
       // BOTTOM
       if((ThisRect->bottom  > ThatRect->bottom)
       && (ThisRect->top    >= ThatRect->top)
       && (ThisRect->left   >= ThatRect->left)
       && (ThisRect->right  <= ThatRect->right)
       ){
          ThisRect->top      = ThatRect->bottom;   bRet              = TRUE;
       }
       // LEFT
       if((ThisRect->left    < ThatRect->left)
       && (ThisRect->right  <= ThatRect->right)
       && (ThisRect->top    >= ThatRect->top)
       && (ThisRect->bottom <= ThatRect->bottom)
       ){
          ThisRect->right    = ThatRect->left;     bRet              = TRUE;
       }
       // RIGHT
       if((ThisRect->right   > ThatRect->right)
       && (ThisRect->left   >= ThatRect->left)
       && (ThisRect->top    >= ThatRect->top)
       && (ThisRect->bottom <= ThatRect->bottom)
       ){
          ThisRect->left     = ThatRect->right;    bRet              = TRUE;
       }
       return bRet;
    }
    return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
#if 0 // DC
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static BOOL SubtractRect(LPRECT ThisRect, LPCRECT ThatRect)
{
BOOL bRet = FALSE;

       // IF INSIDE EMPTY IT!
       if((ThisRect->top        >= ThatRect->top)
       && (ThisRect->bottom     <= ThatRect->bottom)
       && (ThisRect->left       >= ThatRect->left)
       && (ThisRect->right      <= ThatRect->right)
       ){
          ThisRect->top          =
          ThisRect->bottom       =
          ThisRect->left         =
          ThisRect->right        = 0;
          return TRUE;
       }
       if((ThisRect->left       >= ThatRect->left)
       && (ThisRect->right      <= ThatRect->right)
       ){
          // TOP
          if((ThisRect->top     >= ThatRect->top)
          && (ThisRect->bottom  <= ThatRect->bottom)
          ){
             ThisRect->top       = ThatRect->bottom;   bRet              = TRUE;
          } else
          // BOTTOM
          if((ThisRect->bottom  >= ThatRect->bottom)
          && (ThisRect->top     <= ThatRect->top)
          ){
             ThisRect->bottom    = ThatRect->top;      bRet              = TRUE;
          }
       } else
       if((ThisRect->top        >= ThatRect->top)
       && (ThisRect->bottom     <= ThatRect->bottom)
       ){
          // LEFT
          if((ThisRect->left    >= ThatRect->left)
          && (ThisRect->right   <= ThatRect->right)
          ){
             ThisRect->left     = ThatRect->right;     bRet              = TRUE;
          }
          // RIGHT
          if((ThisRect->right   >= ThatRect->right)
          && (ThisRect->left    <= ThatRect->left)
          ){
             ThisRect->right     = ThatRect->left;     bRet              = TRUE;
          }
       }
       return bRet;
}
#else
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static BOOL SubtractRect(LPRECT ThisRect, LPCRECT ThatRect)
{
BOOL bRet = FALSE;

       // IF INSIDE EMPTY IT!
       if((ThisRect->top        >= ThatRect->top)
       && (ThisRect->bottom     <= ThatRect->bottom)
       && (ThisRect->left       >= ThatRect->left)
       && (ThisRect->right      <= ThatRect->right)
       ){
          ThisRect->top          =
          ThisRect->bottom       =
          ThisRect->left         =
          ThisRect->right        = 0;
          return TRUE;
       }
       if((ThisRect->left       >= ThatRect->left)
       && (ThisRect->right      <= ThatRect->right)
       ){
          // TOP
          if((ThisRect->top     >= ThatRect->top)
          && (ThisRect->top     <= ThatRect->bottom)
          ){
             ThisRect->top       = ThatRect->bottom;         bRet = TRUE;
          } else
          // BOTTOM
          if((ThisRect->bottom  <= ThatRect->bottom)
          && (ThisRect->bottom  >= ThatRect->top)
          ){
             ThisRect->bottom    = ThatRect->top;            bRet = TRUE;
          }
       } else
       if((ThisRect->top        >= ThatRect->top)
       && (ThisRect->bottom     <= ThatRect->bottom)
       ){
          // LEFT
          if((ThisRect->left    >= ThatRect->left)
          && (ThisRect->left    <= ThatRect->right)
          ){
             ThisRect->left     = ThatRect->right;           bRet = TRUE;
          }
          // RIGHT
          if((ThisRect->right   <= ThatRect->right)
          && (ThisRect->right   >= ThatRect->left)
          ){
             ThisRect->right     = ThatRect->left;           bRet = TRUE;
          }
       }
       return bRet;
}

#endif
///////////////////////////////////////////////////////////////////////////////////////////////////
// THIS ROUTINE EXPAND RECTANGLE TO THE POINT OF ENCAPSULATING ANOTHER RECT...
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static BOOL AppendRect(LPRECT ThisRect, LPCRECT ThatRect)
{
BOOL bRet = FALSE;

       if(IsNullRect(ThatRect)){
          return FALSE;
       }
       if(IsNullRect(ThisRect)){
          *ThisRect          = *ThatRect;
          return TRUE;
       }
       // TOP
       if((ThisRect->top     > ThatRect->top)
       ){
          ThisRect->top      = ThatRect->top;      bRet              = TRUE;
       }
       // BOTTOM
       if((ThisRect->bottom  < ThatRect->bottom)
       ){
          ThisRect->bottom  = ThatRect->bottom;    bRet              = TRUE;
       }
       // LEFT
       if((ThisRect->left    > ThatRect->left)
       ){
          ThisRect->left     = ThatRect->left;     bRet              = TRUE;
       }
       // RIGHT
       if((ThisRect->right   < ThatRect->right)
       ){
          ThisRect->right    = ThatRect->right;    bRet              = TRUE;
       }
       return bRet;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
// CLIP A RECT AND RETURN BOOL TRUE IF IN CLIPPED AREA, FALSE IF IT IS OUTISDE THE CLIPPED AREA.
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static BOOL ClipRect(LPRECT ThisRect, LPRECT ThisClipRect)
{
    if(IsEmptyRect(ThisRect) || IsEmptyRect(ThisClipRect)){
       return FALSE;
    }
    if(IsIntersectRect(ThisRect, ThisClipRect) ){

       if(ThisRect->left    < ThisClipRect->left){
          ThisRect->left    = ThisClipRect->left;
       } else
       if(ThisRect->left    > ThisClipRect->right){
          ThisRect->left    = ThisClipRect->right;
       }
       if(ThisRect->right   < ThisClipRect->left){
          ThisRect->right   = ThisClipRect->left;
       } else
       if(ThisRect->right   > ThisClipRect->right){
          ThisRect->right   = ThisClipRect->right;
       }
       if(ThisRect->top     < ThisClipRect->top){
          ThisRect->top     = ThisClipRect->top;
       } else
       if(ThisRect->top     > ThisClipRect->bottom){
          ThisRect->top     = ThisClipRect->bottom;
       }
       if(ThisRect->bottom  < ThisClipRect->top){
          ThisRect->bottom  = ThisClipRect->top;
       } else
       if(ThisRect->bottom  > ThisClipRect->bottom){
          ThisRect->bottom  = ThisClipRect->bottom;
       }
       return TRUE;
    }
    return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static BOOL ClipRectangle(long *StartX, long *StartY, long *DeltaX, long *DeltaY, LPRECT ThisClipRect)
{
RECT ThisRect;

    ThisRect.left  = *StartX;    ThisRect.right   = *DeltaX;
    ThisRect.top   = *StartY;    ThisRect.bottom  = *DeltaY;

    if(IsEmptyRect(&ThisRect) || IsEmptyRect(ThisClipRect)){
       return FALSE;
    }
    if(IsIntersectRect(&ThisRect, ThisClipRect) ){

       if(ThisRect.left     < ThisClipRect->left){
          *StartX           = ThisClipRect->left;
       } else
       if(ThisRect.left     > ThisClipRect->right){
          *StartX           = ThisClipRect->right;
       }
       if(ThisRect.right    > ThisClipRect->right){
          *DeltaX           = ThisClipRect->right;
       } else
       if(ThisRect.right    < ThisClipRect->left){
          *DeltaX           = ThisClipRect->left;
       }
       if(ThisRect.top      < ThisClipRect->top){
          *StartY           = ThisClipRect->top;
       } else
       if(ThisRect.top      > ThisClipRect->bottom){
          *StartY           = ThisClipRect->bottom;
       }
       if(ThisRect.bottom   > ThisClipRect->bottom){
          *DeltaY           = ThisClipRect->bottom;
       } else
       if(ThisRect.bottom   < ThisClipRect->top){
          *DeltaY           = ThisClipRect->top;
       }
       return TRUE;
    }
    return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
// BOOL TRUE IF IN CLIP AREA, FALSE IF IT IS OUTISDE THE CLIPPED AREA.
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static BOOL ClipPoint(LPPOINT ThisPoint, LPRECT ThisClipRect)
{
    if((ThisPoint->x  < ThisClipRect->left) || (ThisPoint->x  > ThisClipRect->right)){
       return FALSE;
    }
    if((ThisPoint->y  < ThisClipRect->top)  || (ThisPoint->y  > ThisClipRect->bottom) ){
       return FALSE;
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static BOOL ClipXY(long X, long Y, LPRECT ThisClipRect)
{
    if((X  < ThisClipRect->left) || (X  > ThisClipRect->right)){
       return FALSE;
    }
    if((Y  < ThisClipRect->top)  || (Y  > ThisClipRect->bottom) ){
       return FALSE;
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static BOOL IsPointInRect(LPRECT TheRect, LPPOINT ThePoint)
{
    if((ThePoint->x < TheRect->left) || (ThePoint->x > TheRect->right)){
       return FALSE;
    }
    if((ThePoint->y < TheRect->top)  || (ThePoint->y > TheRect->bottom)){
       return FALSE;
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static void CenterRect (PRECT ThisRect, LPRECT TheOutRect)
{
long Width, Height;

    Width            = GetPRectWidth(ThisRect);
    Height           = GetPRectHeight(ThisRect);
    ThisRect->left   = (GetPRectWidth(TheOutRect)  >> 1) - (Width >> 1);
    ThisRect->right  = ThisRect->left               + Width;
    ThisRect->top    = (GetPRectHeight(TheOutRect) >> 1) - (Height >> 1);
    ThisRect->bottom = ThisRect->top                + Height;
}
#ifdef _MFC
/////////////////////////////////////////////////////////////////////////////
// GRect - A 2-D rectangle, similar to Windows RECT structure.
typedef const RECT* LPCRECT;    // pointer to read/only RECT

class GRect : public tagRECT
{
public:
	// uninitialized rectangle
	GRect();
	// from left, top, right, and bottom
	GRect(int l, int t, int r, int b);
	// copy constructor
	GRect(const RECT& srcRect);
	// from a pointer to another rect
	GRect(LPCRECT lpSrcRect);
	// from a point and size
	GRect(POINT point, SIZE size);
	// from two points
	GRect(POINT topLeft, POINT bottomRight);

// Attributes (in addition to RECT members)

	// retrieves the width
	int Width() const;
	// returns the height
	int Height() const;
	// returns the size
	CSize Size() const;
	// reference to the top-left point
	CPoint& TopLeft();
	// reference to the bottom-right point
	CPoint& BottomRight();
	// const reference to the top-left point
	const CPoint& TopLeft() const;
	// const reference to the bottom-right point
	const CPoint& BottomRight() const;
	// the geometric center point of the rectangle
	CPoint CenterPoint() const;
	// swap the left and right
	void SwapLeftRight();
	static void SwapLeftRight(LPRECT lpRect);

	// convert between GRect and LPRECT/LPCRECT (no need for &)
	operator LPRECT();
	operator LPCRECT() const;

	// returns TRUE if rectangle has no area
	BOOL IsRectEmpty() const;
	// returns TRUE if rectangle is at (0,0) and has no area
	BOOL IsRectNull() const;
	// returns TRUE if point is within rectangle
	BOOL PtInRect(POINT point) const;

    // Operations
	// set rectangle from left, top, right, and bottom
	void SetRect(int x1, int y1, int x2, int y2);
	void SetRect(POINT topLeft, POINT bottomRight);
	// empty the rectangle
	void SetRectEmpty();
	// copy from another rectangle
	void CopyRect(LPCRECT lpSrcRect);
	// TRUE if exactly the same as another rectangle
	BOOL EqualRect(LPCRECT lpRect) const;

	// inflate rectangle's width and height without
	// moving its top or left
	void InflateRect(int x, int y);
	void InflateRect(SIZE size);
	void InflateRect(LPCRECT lpRect);
	void InflateRect(int l, int t, int r, int b);
	// deflate the rectangle's width and height without
	// moving its top or left
	void DeflateRect(int x, int y);
	void DeflateRect(SIZE size);
	void DeflateRect(LPCRECT lpRect);
	void DeflateRect(int l, int t, int r, int b);

	// translate the rectangle by moving its top and left
	void OffsetRect(int x, int y);
	void OffsetRect(SIZE size);
	void OffsetRect(POINT point);
	void NormalizeRect();

	// set this rectangle to intersection of two others
	BOOL IntersectRect(LPCRECT lpRect1, LPCRECT lpRect2);

	// set this rectangle to bounding union of two others
	BOOL UnionRect(LPCRECT lpRect1, LPCRECT lpRect2);

	// set this rectangle to minimum of two others
	BOOL SubtractRect(LPCRECT lpRectSrc1, LPCRECT lpRectSrc2);

    // Additional Operations
	void operator=(const RECT& srcRect);
	BOOL operator==(const RECT& rect) const;
	BOOL operator!=(const RECT& rect) const;

    void operator+=(POINT point);
	void operator-=(POINT point);

    void operator+=(SIZE size);
	void operator-=(SIZE size);

	void operator+=(LPCRECT lpRect);
	void operator-=(LPCRECT lpRect);

	void operator&=(const RECT& rect);
	void operator|=(const RECT& rect);

    // Operators returning GRect values
	GRect operator+(POINT point) const;
	GRect operator-(POINT point) const;

    GRect operator+(LPCRECT lpRect) const;
	GRect operator-(LPCRECT lpRect) const;

	GRect operator+(SIZE size) const;
	GRect operator-(SIZE size) const;

    GRect operator&(const RECT& rect2) const;
	GRect operator|(const RECT& rect2) const;
	GRect MulDiv(int nMultiplier, int nDivisor) const;
};
// GRect Vs CRect
inline GRect::GRect()
{
    // RANDOM FILLED
}
inline GRect::GRect(int l, int t, int r, int b)
{
    left = l; top = t; right = r; bottom = b;
}
inline GRect::GRect(const RECT& srcRect)
{
    ::CopyRect(this, &srcRect);
}
inline GRect::GRect(LPCRECT lpSrcRect)
{
    ::CopyRect(this, lpSrcRect);
}
inline GRect::GRect(POINT point, SIZE size)
{
right = (left = point.x) + size.cx; bottom = (top = point.y) + size.cy;
}
inline GRect::GRect(POINT topLeft, POINT bottomRight)
{
left = topLeft.x; top = topLeft.y; right = bottomRight.x; bottom = bottomRight.y;
}
inline int GRect::Width() const
{
    return right - left;  // DC  + 1 SPECIAL RECT VS GRECT
}
inline int GRect::Height() const
{
    return bottom - top;  // DC  + 1 SPECIAL RECT VS GRECT
}
inline CSize GRect::Size() const
{
    return CSize(right - left, bottom - top);
}
inline CPoint& GRect::TopLeft()
{
    return *((CPoint*)this);
}
inline CPoint& GRect::BottomRight()
{
    return *((CPoint*)this+1);
}
inline const CPoint& GRect::TopLeft() const
{
    return *((CPoint*)this);
}
inline const CPoint& GRect::BottomRight() const
{
    return *((CPoint*)this+1);
}
inline CPoint GRect::CenterPoint() const
{
    return CPoint((left+right)/2, (top+bottom)/2);
}
inline void GRect::SwapLeftRight()
{
    SwapLeftRight(LPRECT(this));
}
inline void GRect::SwapLeftRight(LPRECT lpRect)
{
LONG temp = lpRect->left; lpRect->left = lpRect->right; lpRect->right = temp;
}
inline GRect::operator LPRECT()
{
    return this;
}
inline GRect::operator LPCRECT() const
{
    return this;
}
inline BOOL GRect::IsRectEmpty() const
{
    return ::IsRectEmpty(this);
}
inline BOOL GRect::IsRectNull() const
{
    return (left == 0 && right == 0 && top == 0 && bottom == 0);
}
inline BOOL GRect::PtInRect(POINT point) const
{
    return ::PtInRect(this, point);
}
inline void GRect::SetRect(int x1, int y1, int x2, int y2)
{
    ::SetRect(this, x1, y1, x2, y2);
}
inline void GRect::SetRect(POINT topLeft, POINT bottomRight)
{
    ::SetRect(this, topLeft.x, topLeft.y, bottomRight.x, bottomRight.y);
}
inline void GRect::SetRectEmpty()
{
    ::SetRectEmpty(this);
}
inline void GRect::CopyRect(LPCRECT lpSrcRect)
{
    ::CopyRect(this, lpSrcRect);
}
inline BOOL GRect::EqualRect(LPCRECT lpRect) const
{
    return ::EqualRect(this, lpRect);
}
inline void GRect::InflateRect(int x, int y)
{
    ::InflateRect(this, x, y);
}
inline void GRect::InflateRect(SIZE size)
{
    ::InflateRect(this, size.cx, size.cy);
}
inline void GRect::DeflateRect(int x, int y)
{
    ::InflateRect(this, -x, -y);
}
inline void GRect::DeflateRect(SIZE size)
{
    ::InflateRect(this, -size.cx, -size.cy);
}
inline void GRect::OffsetRect(int x, int y)
{
    ::OffsetRect(this, x, y);
}
inline void GRect::OffsetRect(POINT point)
{
    ::OffsetRect(this, point.x, point.y);
}
inline void GRect::OffsetRect(SIZE size)
{
    ::OffsetRect(this, size.cx, size.cy);
}
inline BOOL GRect::IntersectRect(LPCRECT lpRect1, LPCRECT lpRect2)
{
    return ::IntersectRect(this, lpRect1, lpRect2);
}
inline BOOL GRect::UnionRect(LPCRECT lpRect1, LPCRECT lpRect2)
{
    return ::UnionRect(this, lpRect1, lpRect2);
}
inline void GRect::operator=(const RECT& srcRect)
{
    ::CopyRect(this, &srcRect);
}
inline BOOL GRect::operator==(const RECT& rect) const
{
    return ::EqualRect(this, &rect);
}
inline BOOL GRect::operator!=(const RECT& rect) const
{
    return !::EqualRect(this, &rect);
}

inline void GRect::operator+=(LPCRECT lpRect)
{
    InflateRect(lpRect);
}
inline void GRect::operator-=(LPCRECT lpRect)
{
    DeflateRect(lpRect);
}

inline void GRect::operator+=(POINT point)
{
    ::OffsetRect(this, point.x, point.y);
}
inline void GRect::operator-=(POINT point)
{
    ::OffsetRect(this, -point.x, -point.y);
}

inline void GRect::operator+=(SIZE size)
{
    ::OffsetRect(this, size.cx, size.cy);
}
inline void GRect::operator-=(SIZE size)
{
    ::OffsetRect(this, -size.cx, -size.cy);
}



inline void GRect::operator&=(const RECT& rect)
{
    ::IntersectRect(this, this, &rect);
}
inline void GRect::operator|=(const RECT& rect)
{
    ::UnionRect(this, this, &rect);
}

inline GRect GRect::operator+(POINT pt) const
{
GRect rect(*this); ::OffsetRect(&rect, pt.x, pt.y); return rect;
}
inline GRect GRect::operator-(POINT pt) const
{
GRect rect(*this); ::OffsetRect(&rect, -pt.x, -pt.y); return rect;
}

inline GRect GRect::operator+(SIZE size) const
{
GRect rect(*this); ::OffsetRect(&rect, size.cx, size.cy); return rect;
}
inline GRect GRect::operator-(SIZE size) const
{
GRect rect(*this); ::OffsetRect(&rect, -size.cx, -size.cy); return rect;
}
inline GRect GRect::operator+(LPCRECT lpRect) const
{
GRect rect(this); rect.InflateRect(lpRect); return rect;
}
inline GRect GRect::operator-(LPCRECT lpRect) const
{
GRect rect(this); rect.DeflateRect(lpRect); return rect;
}

inline GRect GRect::operator&(const RECT& rect2) const
{
GRect rect; ::IntersectRect(&rect, this, &rect2);
	return rect;
}
inline GRect GRect::operator|(const RECT& rect2) const
{
GRect rect; ::UnionRect(&rect, this, &rect2);
	return rect;
}
inline BOOL GRect::SubtractRect(LPCRECT lpRectSrc1, LPCRECT lpRectSrc2)
{
    return ::SubtractRect(this, lpRectSrc1, lpRectSrc2);
}
#endif // #ifdef _MFC

#endif // #ifndef Not
///////////////////////////////////////////////////////////////////////////////////////////////////

#define CompareMemory memcmp

///////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef __StringCopy__
#define __StringCopy__
// DC ALWAYS PASS MAXBUFFER IN SIZEOF
__inline int StringLen (LPCTSTR Src, int MaxBuffer ){
int Count = 0;
int MaxCount          = LenInTChar(MaxBuffer);

   if(Src            == NULL){
      return 0;
   }
   while((*Src)      && (MaxCount > 1)
   ){
     Src++; MaxCount--; Count++;
   }
   return Count;
}
__inline int AStringLen (LPCSTR Src, int MaxBuffer ){
int Count = 0;
int MaxCount          = LenInAChar(MaxBuffer);

   if(Src            == NULL){
      return 0;
   }
   while((*Src)      && (MaxCount > 1)
   ){
     Src++;  MaxCount--; Count++;
   }
   return Count;
}
__inline int WStringLen (LPCWSTR Src, int MaxBuffer ){
int Count = 0;
int MaxCount          = LenInWChar(MaxBuffer);

   if(Src            == NULL){
      return 0;
   }
   while((*Src)      && (MaxCount > 1)
   ){
     Src++; MaxCount--; Count++;
   }
   return Count;
}

__inline int StringCopy (LPTSTR Dest, LPCTSTR Src, int MaxBuffer ){
int Count = 0;
int MaxCount           = LenInTChar(MaxBuffer);

   if((Dest == NULL) || (Src == NULL)){
     // return NULL;
	   return 0;
   }
   //wcsncpy((wchar_t *)Dest,(const wchar_t *)Src, MaxCount);
   //return(wcslen((wchar_t *)Dest));
   //strncpy(Dest,Src, MaxCount);
   //return(strlen(Dest));

   while((*Src) && (MaxCount > 1)){
     *Dest++ = *Src++; MaxCount--; Count++;
   }
   if((MaxCount > 0)){
     *Dest++ = 0; *Dest++ = 0;
   }
   return(Count);
}
__inline int WStringCopy (LPWSTR Dest, LPCWSTR Src, int MaxBuffer )
{
int Count = 0;
int MaxCount          = LenInWChar(MaxBuffer);

   if((Dest == NULL) || (Src == NULL)){
	   // return NULL;
	   	   return 0;
   }
   //wcsncpy((wchar_t *)Dest,(const wchar_t *)Src, MaxCount);
   //return(wcslen((wchar_t *)Dest));
   //strncpy(Dest,Src, MaxCount);
   //return(strlen(Dest));

   while((*Src) && (MaxCount > 1)){
     *Dest++ = *Src++; MaxCount--; Count++;
   }
   if((MaxCount > 0)){
     *Dest++ = 0; *Dest++ = 0;
   }
   return(Count);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__inline int StringAppend (PTSTR Dest, PCTSTR Src, int MaxBuffer )
{
int Count = 0;
int MaxCount          = LenInTChar(MaxBuffer);

   if((Dest == NULL) || (Src == NULL) || (MaxCount < 1)){
	   // return NULL;
	   	   return 0;
   }
   while((*Dest) && (MaxCount > 1)){
      Dest++; MaxCount--; Count++;
   }
   while((*Src) && (MaxCount > 1)){
      *Dest++ = *Src++; MaxCount--; Count++;
   }
   if((MaxCount      > 0)){
      *Dest++        = 0;
   }
   return(Count);
}
__inline int WStringAppend (PWSTR Dest, PCWSTR Src, int MaxBuffer )
{
int Count = 0;
int MaxCount          = LenInWChar(MaxBuffer);

   if((Dest == NULL) || (Src == NULL) || (MaxCount < 1)){
	   // return NULL;
	   	   return 0;
   }
   while((*Dest) && (MaxCount > 1)){
      Dest++; MaxCount--; Count++;
   }
   while((*Src) && (MaxCount > 1)){
      *Dest++ = *Src++; MaxCount--; Count++;
   }
   if((MaxCount      > 0)){
      *Dest++        = 0;
   }
   return(Count);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__inline int StringCompare (PTSTR Dest, PCTSTR Src, int MaxBuffer )
{
int Diff = 0;
int MaxCount          = LenInTChar(MaxBuffer);

   if((Dest == NULL) || (Src == NULL)){
	   // return NULL;
	   	   return 0;
   }
   while((MaxCount > 0)){
      Diff     = *Dest++ - *Src++; MaxCount--;
      if(Diff != 0){
         break;
      }
      if((*Dest == 0) && (*Src == 0)){
         break;
      }
   }
   return(Diff);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__inline int StringFind (PTSTR Findee, PCTSTR Finder, int MaxBuffer )
{
int FirstPos = -1;
int NextPos  =  0;
int ThisPos  =  0;
int MaxCount          = LenInTChar(MaxBuffer);

   while((Findee[ThisPos]) && (NextPos < MaxCount)){

     if(Findee[ThisPos++] == Finder[NextPos]){
        NextPos++;
        if(FirstPos == -1){
           FirstPos  = ThisPos -1;
        }
     } else {
        NextPos      =  0;
        FirstPos     = -1;
     }
   }
   if(NextPos == MaxCount){
      return FirstPos;
   }
   return(-1);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__inline long ParseDecimal(PCTSTR &StrSrc, long MaxLen = 256) // atoi, strol, ToAsci, atof, _ecvt, _fcvt, _gcvt
{
long  Value = 0;
BYTE  Digit = 0;

    while((MaxLen > 0) && (*StrSrc >= '0') && (*StrSrc <= '9') ){
        Digit  = (*StrSrc++ - '0');
        Value  = (Value * 10) + Digit;
        MaxLen--;
    }
    return Value;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
__inline void InvertMem(LPDWORD dest,  LPDWORD source, long maxbuf) //  AUTO ALIGNED TO 4 BYTES
{
    maxbuf         >>= 2;
    while( maxbuf   >= 0 ){
       *dest++       = *source++ ^ 0xFFFFFFFF;
       maxbuf--;
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////

__inline void FastMemCopy(LPDWORD dest,  LPDWORD source, long maxbuf) //  AUTO ALIGNED TO 4 BYTES
{
	memcpy(dest,source,maxbuf);
#if 0 //AY
#ifdef _WIN64
   MoveMemory(dest, source, maxbuf);
#else
   __asm{
   MOV ECX,maxbuf
   SHR ECX,2
   MOV ESI,source
   MOV EDI,dest
   CLD
   REP MOVSD
   }
#endif
#endif //AY
}
///////////////////////////////////////////////////////////////////////////////////////////////////
#endif // #ifndef __StringCopy__

///////////////////////////////////////////////////////////////////////////////////////////////////
void TriggerDebugger  ();// FOR DEBUGING IT WILL GENERATE A DIVIDE BY ZERO ERROR
void WaitForDebugger  ();// FOR DEBUGING IT WILL GENERATE A DIVIDE BY ZERO ERROR
BOOL CheckBreakStatus ();
///////////////////////////////////////////////////////////////////////////////////////////////////
class DCFloodFill {
public:
      DCFloodFill();

      int      m_ScanWidth,    m_ScanHeight;
      COLORREF m_PixelColor,   m_ReplaceColor,   m_NewColor;

      virtual int FillImage (int  StartX, int StartY );
      virtual COLORREF ExtractPixel (int X, int Y) = 0;
      virtual void     DrawLine     (int X, int Y, int XTo) = 0;

private:
      int FloodFill (int  StartX, int StartY );
      /////////////////////////////////////////////////////////////////////////////
      int _inline ScanLeftEdge (int X, int Y)
      {
          while (X > 0) {
             m_PixelColor      = ExtractPixel (X - 1, Y);
             if((m_PixelColor != m_ReplaceColor)){
                break;
             }
             --X;
          }
          return X;
      }
      int _inline ScanRightEdge (int X, int Y)
      {
          while (X < (m_ScanWidth)) {
             m_PixelColor      = ExtractPixel (X, Y);
             if((m_PixelColor != m_ReplaceColor)){
                break;
             }
             ++X;
          }
          return X;
      }
};
///////////////////////////////////////////////////////////////////////////////////////////////////
// Error handling for applications in
// "Multitheading Applications in Win32"
//
// The function PrintError() is marked as __inline so that it can be included from one or more C
// or C++ files without multiple definition errors. For the examples in this book, this works fine.
// To use the PrintError() in an application, it should be taken out, placed in its own source file,
// and the "__inline" declaration removed so the function will be globally available.
///////////////////////////////////////////////////////////////////////////////////////////////////
// DEBUG SUPPORT...
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef __OutputDebugError__
#define __OutputDebugError__
///////////////////////////////////////////////////////////////////////////////////////////////////
#define OutputCommonError(a, b)  OutputWinError (a,_T(__FILE__), (__LINE__),b)
#define OutputDebugError(a)      OutputWinError (a,_T(__FILE__), (__LINE__),GetLastError())
///////////////////////////////////////////////////////////////////////////////////////////////////
__inline void OutputWinError (LPCTSTR linedesc, LPCTSTR filename, int lineno, DWORD errnum)
{
LPTSTR  PtrErrBuffer = NULL;
TCHAR   ErrStringBuf[1024];

    // DEFAULT STRING
    wsprintf (ErrStringBuf,1024, _T("\nThe following call failed at line %d in %s:\n\n")
                            _T("    %s\n\nReason: Unknown\n"), lineno, filename, linedesc);
#ifndef __LINUX__
    if((FormatMessage (FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS | FORMAT_MESSAGE_MAX_WIDTH_MASK,
		                NULL,
		                errnum,
		                MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		                (LPTSTR)&PtrErrBuffer,
		                sizeof(ErrStringBuf),
		                NULL )) != 0){
       if(PtrErrBuffer){
          wsprintf (ErrStringBuf,1024, _T("\nThe following call failed at line %d in %s:\n\n")
                           _T("    %s\n\nReason: %s\n"), lineno, filename, linedesc, PtrErrBuffer);
          LocalFree(PtrErrBuffer);
       }
    }
#endif
    OutputDebugString(ErrStringBuf);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
#endif // #ifndef OutputDebugError
///////////////////////////////////////////////////////////////////////////////////////////////////
extern "C" {
///////////////////////////////////////////////////////////////////////////////////////////////////
int       HandleLastCommonError        (void);
int       HandleLastSocketError        (void);
int       HandleCommonError            (DWORD Errno);
int       HandleMsgCommonError         (LPCTSTR msg, DWORD Errno);
int       HandleMsgLastCommonError     (LPCTSTR msg);

#define HandleHardError(a) if ((a == 0)) MsgBoxExitError (#a,_T(__FILE__), (__LINE__),GetLastError())
#define HandleSoftError(a) if ((a == 0)) MsgBoxWinError  (#a,_T(__FILE__), (__LINE__),GetLastError())

#define HandleDebugError(a)      MsgBoxWinError (a,_T(__FILE__), (__LINE__),GetLastError())
///////////////////////////////////////////////////////////////////////////////////////////////////
void      MsgBoxWinError               (LPCTSTR linedesc, LPCTSTR filename, int lineno, DWORD errnum);
///////////////////////////////////////////////////////////////////////////////////////////////////
void      MsgBoxExitError              (LPCTSTR linedesc, LPCTSTR filename, int lineno, DWORD errnum);
///////////////////////////////////////////////////////////////////////////////////////////////////
DWORD __fastcall BeginDelay            ();
BOOL  __fastcall NotInDelay            (DWORD DelayStart, DWORD TheDelay);
BOOL  __fastcall StillInDelay          (DWORD DelayStart, DWORD TheDelay);
void  __fastcall WaitIfInDelay         (DWORD DelayStart, DWORD TheDelay);

long  __fastcall DelayTimeSpent        (DWORD DelayStart, DWORD FromPoint);
long  __fastcall DelayTimeLeft         (DWORD DelayStart, DWORD TheDelay);

void  __fastcall WaitDelay             (DWORD TheDelay);
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  __fastcall NotYieldInDelay       (DWORD DelayStart, DWORD TheDelay);
BOOL  __fastcall StillYieldInDelay     (DWORD DelayStart, DWORD TheDelay);
void  __fastcall YieldIfInDelay        (DWORD DelayStart, DWORD TheDelay);
void  __fastcall YieldDelay            (DWORD TheDelay);
///////////////////////////////////////////////////////////////////////////////////////////////////
void  __fastcall YieldPaintIfInDelay   (DWORD DelayStart, DWORD TheDelay);
void  __fastcall YieldPaintDelay       (DWORD TheDelay);

///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  __fastcall NotSleepInDelay       (DWORD DelayStart, DWORD TheDelay);
BOOL  __fastcall StillSleepInDelay     (DWORD DelayStart, DWORD TheDelay);
void  __fastcall SleepIfInDelay        (DWORD DelayStart, DWORD TheDelay);
void  __fastcall SleepDelay            (DWORD TheDelay);
void  __fastcall SleepTillEndDelay     (DWORD DelayStart, DWORD TheDelay);

///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  __fastcall SleepTillTrueDelay     (volatile BOOL & CheckStatus, DWORD TheDelay);
BOOL  __fastcall WaitTillTrueDelay      (volatile BOOL & CheckStatus, DWORD TheDelay);
BOOL  __fastcall YieldTillTrueDelay     (volatile BOOL & CheckStatus, DWORD TheDelay);

BOOL  __fastcall SleepTillFalseDelay    (volatile BOOL & CheckStatus, DWORD TheDelay);
BOOL  __fastcall WaitTillFalseDelay     (volatile BOOL & CheckStatus, DWORD TheDelay);
BOOL  __fastcall YieldTillFalseDelay    (volatile BOOL & CheckStatus, DWORD TheDelay);


///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL      IsValidMemoryPointer         (PVOID   UserPtr);
BOOL      IsValidCodePointer           (FARPROC UserPtr);

#define   VerifyCodePtr(A)             (Not IsValidCodePointer(A))
#define   IsBadWritePtr(A,B)             (Not IsValidMemoryPointer(A))
BOOL      IsNullString                 (LPCTSTR  string);

BYTE      GetXorParity                 (LPCSTR theData, int Length);

DWORD     ConvertToValue               (LPCTSTR InputStr, DWORD MaxLen );// atoi, _ttol, strol, ToAsci, atof, _ecvt, _fcvt, _gcvt

// FROM VZ...
int       ConvertToAsciiChar           (LPSTR  OutputBuffer, DWORD OutputSize, LPCTSTR SourceBuffer, DWORD SourceSizeInChar);


///////////////////////////////////////////////////////////////////////////////////////////////////
// MOUSEDOWN SUPPORT...
///////////////////////////////////////////////////////////////////////////////////////////////////
HWND      InitStillDown                (HWND hobj);
WORD      StillDown                    (MSG  *Msg, HWND hobj);
void      ReleaseStillDown             ();



HANDLE __cdecl   BeginThreadEx         (PVOID, unsigned, unsigned (__stdcall *) (void *), PVOID, unsigned, unsigned *);

} // extern "C" {
///////////////////////////////////////////////////////////////////////////////////////////////////
// FROM DCIMPLEMENT.H
class DCTimeout {
public:
      DCTimeout();

      DWORD Start;
      DWORD Now;
      DWORD Delay;

      void   BeginDelay        (DWORD Duration);
      void   EndDelay          ();

      /////////////////////////////////////////////////////////////////////////////////////////////
      void   WaitDelay         (DWORD Duration);
      void   YieldDelay        (DWORD Duration);
      void   SleepDelay        (DWORD Duration);
      /////////////////////////////////////////////////////////////////////////////////////////////
      void   WaitIfInDelay     ();
      void   YieldIfInDelay    ();
      void   SleepIfInDelay    ();
      void   SleepTillEndDelay ();
      /////////////////////////////////////////////////////////////////////////////////////////////
      BOOL   NotInDelay        ();
      BOOL   StillInDelay      ();
      BOOL   SleepInDelay      ();
      long   DelayTimeLeft     ();
      /////////////////////////////////////////////////////////////////////////////////////////////
      BOOL   NotYieldInDelay   ();
      BOOL   StillYieldInDelay ();
      /////////////////////////////////////////////////////////////////////////////////////////////
      BOOL   NotSleepInDelay   ();
      BOOL   StillSleepInDelay ();
};
///////////////////////////////////////////////////////////////////////////////////////////////////
CString   DCFormat                     (LPCTSTR lpszFormat, ...);
CString   StringLastError              (DWORD Errno);

///////////////////////////////////////////////////////////////////////////////////////////////////
// BITMAP SUPPORT...
///////////////////////////////////////////////////////////////////////////////////////////////////
typedef struct {
    DWORD InBytes, InBits, InPixels;
} BMPWIDTHINFO, *LPBMPWIDTHINFO;

typedef struct {
    BITMAPINFOHEADER    bmiHeader;
    RGBQUAD             bmiColors[256];
} BITMAPINFO256, FAR *LPBITMAPINFO256, *PBITMAPINFO256;

///////////////////////////////////////////////////////////////////////////////////////////////////
#define GetBGR_RedValue(rgb)     ((BYTE)( (rgb)  >> 16)       & 0xFF)
#define GetBGR_GreenValue(rgb)   ((BYTE)( (rgb)  >>  8)       & 0xFF)
#define GetBGR_BlueValue(rgb)    ((BYTE)( (rgb)       )       & 0xFF)

#define GetRGB_RedValue(rgb)     ((BYTE)( (rgb)       )       & 0xFF)
#define GetRGB_GreenValue(rgb)   ((BYTE)( (rgb)  >>  8)       & 0xFF)
#define GetRGB_BlueValue(rgb)    ((BYTE)( (rgb)  >> 16)       & 0xFF)



char *    strrev                 (char * szT);
wchar_t * wstrrev                (wchar_t * szT);
void      _mbstowcsz             (PTSTR dest, PCSTR src,  DWORD len);
void      _wmbstowcsz            (LPSTR dest, PCTSTR src, DWORD len);
long      InterlockedIncrement   (long * ref);
long      InterlockedDecrement   (long * ref);

wchar_t * _wcsupr                (wchar_t * str);
wchar_t * _wcslwr                (wchar_t * str);


///////////////////////////////////////////////////////////////////////////////////////////////////
#endif // ___DCTools___
///////////////////////////////////////////////////////////////////////////////////////////////////
