// MacString.h: interface. Adaptation of the classic DCString for Mac and Carbon...
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef DC_STRING_INCLUDED
#define DC_STRING_INCLUDED
///////////////////////////////////////////////////////////////////////////////////////////////////
// #include <fixalloc.h> // NOT USED HERE
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef CALL_INLINE
#define CALL_INLINE inline
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _MAC_
#ifdef __LINUX__
#ifndef _UNICODE
    #define AToI             atoi
    #define IToA             itoa
	#define _ttoi atoi

    #define TStrLen          strlen
    #define TStrSpan         strspn
    #define TStrCSpan        strcspn
    #define TStrChr          strchr
    #define TStrnCopy        strncpy

    #define TStrColl         strcoll

    #define TStrCmp          strcmp
    #define TStrICmp         stricmp
    #define TStrNICmp        strnicmp

    #define TStrSrchChrSet   strpbrk
    #define TStrSrchSubStr   strstr
    #define TStrSrchLastChar strrchr

    #define TStrToUpper      _tcsupr
    #define TStrToLower      _tcslwr

    #define TStrReverse      _tcsrev

    #define TFormatStrArg    sprintf  
	#define TFormatStr       vsprintf 

    #define lstrlenA         strlen

    /* Old CString implement
    inline char *       _strinc       (const char * _pc)                       { return (char *)(_pc + 1); }
    inline char *       _strninc      (const char * _pc,   size_t _sz)         { return (char *)(_pc + _sz); }

    inline char *       _strdec       (const char * _cpc1, const char * _cpc2) { return (char *)((_cpc1) >= (_cpc2) ? NULL : (_cpc2 - 1)); }
    inline unsigned int _strnextc     (const char * _cpc)                      { return (unsigned int)*_cpc; }
    inline size_t       _strncnt      (const char * _cpc,  size_t _sz)         { size_t len; len  = strlen(_cpc); return (len > _sz) ? _sz : len; }
    inline char *       _strspnp      (const char * _cpc1, const char * _cpc2) { return (*(_cpc1 += strspn(_cpc1, _cpc2)) != '\0') ? (char*)_cpc1 : NULL; }
    __int64 __cdecl _wtoi64(PCWSTR nptr)
    {
    CHAR astring [I64_SIZE_LENGTH];

        WideCharToMultiByte (CP_ACP, 0, nptr, -1, astring, I64_SIZE_LENGTH, NULL, NULL);
        return (_atoi64(astring));
    }
    */

#else  // #ifndef _UNICODE

    #define AToI(I)          ConvertToValue (I, SafeStrlen(I) )// wcstol //_wtoi
    #define IToA             ltowcs //_itow
    #define _ttoi AToI       // wcstol

    #define TStrLen          wcslen
    #define TStrSpan         wcsspn
    #define TStrCSpan        wcscspn
    #define TStrChr          wcschr
    #define TStrnCopy        wcsncpy

    #define TStrColl         wcscoll

    #define TStrCmp          wcscmp
    #define TStrICmp         wcscasecmp
    #define TStrNICmp        wcsncasecmp

    #define TStrSrchChrSet   wcspbrk
    #define TStrSrchSubStr   wcsstr
    #define TStrSrchLastChar wcsrchr

    #define TStrToUpper      _wcsupr
    #define TStrToLower      _wcslwr

    #define TStrReverse      wstrrev

    #define TFormatStrArg    vswprintf  // swprintf // vswprintf
	#define TFormatStr       swprintf   

    #define lstrlenA         strlen

#endif // #ifndef _UNICODE
#else  // __LINUX__
///////////////////////////////////////////////////////////////////////////////////////////////////
    #define AToI             _ttoi      // atoi atoi _wtoi  _ttol atol atol _wtol atof
    #define IToA             _itot      // _itoa _itoa _itow 

    #define TStrLen          _tcslen    // _tcsclen strlen _mbslen wcslen 
    #define TStrSpan         _tcsspn    // strspn _mbsspn  wcsspn  
    #define TStrCSpan        _tcscspn   // strcspn _mbscspn  wcscspn  
    #define TStrChr          _tcschr    // strchr _mbschr  wcschr  
    #define TStrnCopy        _tcsncpy   // strncpy _mbsnbcpy  wcsncpy  

    #define TStrColl         _tcscoll   // strcoll _mbscoll wcscoll 

    #define TStrCmp          _tcscmp    // strcmp  _mbscmp  wcscmp  
    #define TStrICmp         _tcsicmp   // _stricmp _mbsicmp _wcsicmp 
    #define TStrNICmp        _tcsnicmp  // _strnicmp _mbsnbicmp _wcsnicmp 

    #define TStrSrchChrSet   _tcspbrk   // strpbrk _mbspbrk  wcspbrk  
    #define TStrSrchSubStr   _tcsstr    // strstr  _mbsstr  wcsstr
    #define TStrSrchLastChar _tcsrchr   // strrchr _mbsrchr  wcsrchr  

    #define TStrToUpper      _tcsupr    // _strupr _mbsupr  _wcsupr  
    #define TStrToLower      _tcslwr    // _strlwr _mbslwr  _wcslwr  

    #define TStrReverse      _tcsrev    // _strrev _wcsrev 

    #define TFormatStrArg    _vstprintf // vsprintf  vsprintf  vswprintf  
    #define TFormatStr       _stprintf  // sprintf sprintf swprintf 

    /* Old CString implement
    inline char *       _strinc       (const char * _pc)                       { return (char *)(_pc + 1); }
    inline char *       _strninc      (const char * _pc,   size_t _sz)         { return (char *)(_pc + _sz); }

    inline char *       _strdec       (const char * _cpc1, const char * _cpc2) { return (char *)((_cpc1) >= (_cpc2) ? NULL : (_cpc2 - 1)); }
    inline unsigned int _strnextc     (const char * _cpc)                      { return (unsigned int)*_cpc; }
    inline size_t       _strncnt      (const char * _cpc,  size_t _sz)         { size_t len; len  = strlen(_cpc); return (len > _sz) ? _sz : len; }
    inline char *       _strspnp      (const char * _cpc1, const char * _cpc2) { return (*(_cpc1 += strspn(_cpc1, _cpc2)) != '\0') ? (char*)_cpc1 : NULL; }
    __int64 __cdecl _wtoi64(PCWSTR nptr)
    {
    CHAR astring [I64_SIZE_LENGTH];

        WideCharToMultiByte (CP_ACP, 0, nptr, -1, astring, I64_SIZE_LENGTH, NULL, NULL);
        return (_atoi64(astring));
    }
    */

#endif // 
///////////////////////////////////////////////////////////////////////////////////////////////////
// REPLACE THE INFAMOUS MEANINGLESS _strinc
///////////////////////////////////////////////////////////////////////////////////////////////////
CALL_INLINE PTSTR           _XNextCharPtr  (PCTSTR _pc)               { return (PTSTR)(_pc + 1); }

#ifndef __LINUX__
typedef const UINT            RESID;
#endif

#define SizeOfTChar(VarName) (sizeof(VarName) / sizeof(TCHAR))

///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
typedef struct _DCStringData
{

    long   Refs;            // reference count
    int    DataLength;      // length of data (including terminator)
    int    AllocLength;     // length of allocation
    TCHAR  Content[1];      // 1 among the many bytes of the allocated string
} DCStringData,  * PDCStringData;
///////////////////////////////////////////////////////////////////////////////////////////////////
class DCString
{
public:
   ~DCString                   ();
    DCString                   ();

#ifndef __LINUX__
    DCString                   (RESID              ParmID);
#endif

    DCString                   (const DCString&    StringSrc);
    DCString                   (TCHAR              ParmChar,   int RepeatCount = 1);
    DCString                   (PCTSTR             StringPtr);
    DCString                   (PCTSTR             StringPtr,  int Length);

    ///////////////////////////////////////////////////////////////////////////////////////////////
    // Attributes & Operations
    ///////////////////////////////////////////////////////////////////////////////////////////////
    int      GetAllocLength    () const;
    int      GetLength         () const;
    BOOL     IsEmpty           () const;
    void     Empty             ();

    ///////////////////////////////////////////////////////////////////////////////////////////////
    // ACCESS TO STRING IMPLEMENTATION BUFFER AS "C" CHARACTER ARRAY
    // GET POINTER TO MODIFIABLE BUFFER AT LEAST AS LONG AS MINBUFLENGTH
    ///////////////////////////////////////////////////////////////////////////////////////////////
    PTSTR    GetBuffer         (int MinBufLength);
    ///////////////////////////////////////////////////////////////////////////////////////////////
    // RELEASE BUFFER, SETTING LENGTH TO NEWLENGTH (OR TO FIRST NUL IF -1)
    ///////////////////////////////////////////////////////////////////////////////////////////////
    void     ReleaseBuffer     (int NewLength = -1);
    ///////////////////////////////////////////////////////////////////////////////////////////////
    // GET POINTER TO MODIFIABLE BUFFER EXACTLY AS LONG AS NEWLENGTH
    ///////////////////////////////////////////////////////////////////////////////////////////////
    PTSTR    GetBufferSetLength(int NewLength);
    ///////////////////////////////////////////////////////////////////////////////////////////////
    // RELEASE MEMORY ALLOCATED TO BUT UNUSED BY STRING
    ///////////////////////////////////////////////////////////////////////////////////////////////
    void     FreeExtra         ();

    ///////////////////////////////////////////////////////////////////////////////////////////////
    // OVERLOADED ASSIGNMENT
    ///////////////////////////////////////////////////////////////////////////////////////////////
    TCHAR operator[]           (int Index) const;
    operator PCTSTR            () const;
    operator void *            () const;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    // SET STRING CONTENT
    ///////////////////////////////////////////////////////////////////////////////////////////////
    const  DCString& operator =(TCHAR              ParmChar);
    const  DCString& operator =(PCTSTR             ParmStringPtr);

#ifndef __LINUX__
    const  DCString& operator =(RESID              ParmID);
#endif

    const  DCString& operator =(const DCString&    StringSrc);

    ///////////////////////////////////////////////////////////////////////////////////////////////
    // STRING CONCATENATION
    ///////////////////////////////////////////////////////////////////////////////////////////////
    const  DCString& operator+=(TCHAR              ParmChar);
    const  DCString& operator+=(PCTSTR             ParmStringPtr);
#ifndef __LINUX__
    const  DCString& operator+=(RESID              ParmID);
#endif
    const  DCString& operator+=(const DCString&    StringSrc);

    ///////////////////////////////////////////////////////////////////////////////////////////////
    // STRING ADDITION ALSO USE MACRO FOR OTHER TYPE I.E. STR = MCCFSTR("1") + MCCFSTR("2")
    ///////////////////////////////////////////////////////////////////////////////////////////////
    friend DCString  operator +(const DCString&    StringSrc,     TCHAR             theChar);
    friend DCString  operator +(TCHAR              theChar,       const DCString&   StringSrc);
    ///////////////////////////////////////////////////////////////////////////////////////////////
    friend DCString  operator +(const DCString&    StringSrc,     PCTSTR            ParmStringPtr);
    friend DCString  operator +(PCTSTR             ParmStringPtr, const DCString&   StringSrc);
    ///////////////////////////////////////////////////////////////////////////////////////////////
    friend DCString  operator +(const DCString&    String1,       const DCString&   String2);


    ///////////////////////////////////////////////////////////////////////////////////////////////
    // STRING COMPARISON
    ///////////////////////////////////////////////////////////////////////////////////////////////
    int      Compare           (PCTSTR ParmStringPtr) const;
    int      CompareNoCase     (PCTSTR ParmStringPtr) const;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    TCHAR    GetAt             (int Index) const;
    void     SetAt             (int Index, TCHAR ParmChar);

    ///////////////////////////////////////////////////////////////////////////////////////////////
    // SIMPLE SUB-STRING EXTRACTION
    ///////////////////////////////////////////////////////////////////////////////////////////////
    DCString Mid               (int First, int Count) const;
    DCString Mid               (int First) const;
    DCString Left              (int Count) const;
    DCString Right             (int Count) const;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    // TRIMMING WHITESPACE (EITHER SIDE)
    ///////////////////////////////////////////////////////////////////////////////////////////////
    void     TrimRight         ();
    void     TrimLeft          ();

    ///////////////////////////////////////////////////////////////////////////////////////////////
    // TRIMMING ANYTHING (EITHER SIDE) REMOVE CONTINUOUS OCCURRENCES OF TARGET STARTING FROM RIGHT
    ///////////////////////////////////////////////////////////////////////////////////////////////
    void     TrimRight         (TCHAR  Target);
    // REMOVE CONTINUOUS OCCCURRENCES OF CHARACTERS IN PASSED STRING,
    void     TrimRight         (PCTSTR Targets);
    // REMOVE CONTINUOUS OCCURRENCES OF CHTARGET STARTING FROM LEFT
    void     TrimLeft          (TCHAR  Target);
    void     TrimLeft          (PCTSTR Targets);

    ///////////////////////////////////////////////////////////////////////////////////////////////
    // ADVANCED MANIPULATION REPLACE OCCURRENCES OF CHOLD WITH CHNEW
    ///////////////////////////////////////////////////////////////////////////////////////////////
    int      Replace           (TCHAR   CharOld, TCHAR  CharNew);
    int      Replace           (PCTSTR  StrOld,  PCTSTR StrNew);
    int      Remove            (TCHAR   CharRemove);
    ///////////////////////////////////////////////////////////////////////////////////////////////
    // INSERT CHARACTER AT ZERO-BASED INDEX; CONCATENATES IF INDEX IS PAST END OF STRING
    ///////////////////////////////////////////////////////////////////////////////////////////////
    int      Insert            (int Start, TCHAR  theChar);
    int      Insert            (int Start, PCTSTR pstr);
    ///////////////////////////////////////////////////////////////////////////////////////////////
    // DELETE NCOUNT CHARACTERS STARTING AT ZERO-BASED INDEX
    ///////////////////////////////////////////////////////////////////////////////////////////////
    int      Delete            (int Start, int    Count = 1);

    ///////////////////////////////////////////////////////////////////////////////////////////////
    // SEARCHING FIND CHARACTER STARTING AT LEFT, -1 IF NOT FOUND
    ///////////////////////////////////////////////////////////////////////////////////////////////
    int      ReverseFind       (TCHAR  theChar) const;      // search from end string
    int      Find              (TCHAR  theChar) const;
    int      Find              (TCHAR  theChar, int nStart) const;
    int      Find              (PCTSTR pszSub) const;
    int      Find              (PCTSTR pszSub, int nStart) const;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    // NLS AWARE CONVERSION
    ///////////////////////////////////////////////////////////////////////////////////////////////
    void     MakeUpper         ();
    void     MakeLower         ();

    ///////////////////////////////////////////////////////////////////////////////////////////////
    // PRINTF-LIKE FORMATTING USING VARIABLE ARGUMENTS PARAMETER
    ///////////////////////////////////////////////////////////////////////////////////////////////
    void     FormatV           (PCTSTR pszFormat, va_list argList);
    void     Format            (PCTSTR pszFormat, ...);
#ifndef __LINUX__
    void     Format            (RESID  FormatID, ...);
    BOOL     LoadString        (RESID  ParmID);
#endif

///////////////////////////////////////////////////////////////////////////////////////////////////

    ///////////////////////////////////////////////////////////////////////////////////////////////
    // NOT AVALABLE ON MAC...
    ///////////////////////////////////////////////////////////////////////////////////////////////
    // FIND FIRST INSTANCE OF ANY CHARACTER IN PASSED STRING
    ///////////////////////////////////////////////////////////////////////////////////////////////
    int      FindOneOf         (PCTSTR pszCharSet) const;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    // NLS AWARE CONVERSION
    ///////////////////////////////////////////////////////////////////////////////////////////////
    void     MakeReverse       ();

    ///////////////////////////////////////////////////////////////////////////////////////////////
    // NLS AWARE COMPARISON
    ///////////////////////////////////////////////////////////////////////////////////////////////
    int      Collate           (PCTSTR StringPtr) const;
    int      CollateNoCase     (PCTSTR StringPtr) const;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    //  CHARACTERS FROM BEGINNING THAT ARE ALSO IN PASSED STRING
    ///////////////////////////////////////////////////////////////////////////////////////////////
    DCString SpanIncluding     (PCTSTR pszCharSet) const;
    DCString SpanExcluding     (PCTSTR pszCharSet) const;

///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
// EXTRA SUPPORT FOR CONVERGING BETWEEN CHAR AND WIDECHAR
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef _UNICODE

    DCString                   (PCSTR   ParmStringPtr);
    const  DCString& operator =(PCSTR   ParmStringPtr);
    const  DCString& operator+=(PCSTR   ParmStringPtr);

    static int    SafeStrlen   (PCSTR  StringPtr);

#else

    DCString                   (PCWSTR  ParmStringPtr);
    const  DCString& operator =(PCWSTR  ParmStringPtr);
    const  DCString& operator+=(PCWSTR  ParmStringPtr);

    static int    SafeStrlen   (PCWSTR StringPtr);

#endif // #ifdef _UNICODE
///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
protected:
    PTSTR                          m_pchData;   // pointer to ref counted string data

    void          Init             ();

    void          AllocCopy        (DCString& Dest, int CpyLen, int CpyIndex, int ExtraLen) const;
    BOOL          AllocBuffer      (int ParmLen);

#ifndef __LINUX__
    void          AssignCopy       (RESID           ParmID);
#endif

    void          AssignCopy       (const DCString& StringSrc);
    void          AssignCopy       (int   SrcLen,   PCTSTR SrcData);

    void          ConcatCopy       (int   Src1Len,  PCTSTR Src1Data, int Src2Len, PCTSTR Src2Data);
    void          ConcatInPlace    (int   SrcLen,   PCTSTR SrcData);


    BOOL          CopyBeforeWrite  ();
    BOOL          AllocBeforeWrite (int nLen);

    static int    SafeStrlen       (PCTSTR StringPtr);

    void          Release          ();
    static void   Release          (PDCStringData Data);
    static void   FreeData         (PDCStringData Data);

    PDCStringData DetachData       ();

private:
    DCStringData *                 m_StringData;
};
///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
CALL_INLINE DCString::operator PCTSTR () const                    { return m_StringData->Content; }
CALL_INLINE DCString::operator void * () const                    { return m_StringData->Content; }

///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
CALL_INLINE BOOL operator==(const DCString& s1, const DCString& s2) { return s1.Compare(s2) == 0; }
CALL_INLINE BOOL operator==(const DCString& s1, PCTSTR s2)          { return s1.Compare(s2) == 0; }
CALL_INLINE BOOL operator==(PCTSTR s1,          const DCString& s2) { return s2.Compare(s1) == 0; }
CALL_INLINE BOOL operator!=(const DCString& s1, const DCString& s2) { return s1.Compare(s2) != 0; }
CALL_INLINE BOOL operator!=(const DCString& s1, PCTSTR s2)          { return s1.Compare(s2) != 0; }
CALL_INLINE BOOL operator!=(PCTSTR s1,          const DCString& s2) { return s2.Compare(s1) != 0; }
CALL_INLINE BOOL operator <(const DCString& s1, const DCString& s2) { return s1.Compare(s2)  < 0; }
CALL_INLINE BOOL operator <(const DCString& s1, PCTSTR s2)          { return s1.Compare(s2)  < 0; }
CALL_INLINE BOOL operator <(PCTSTR s1,          const DCString& s2) { return s2.Compare(s1)  > 0; }
CALL_INLINE BOOL operator >(const DCString& s1, const DCString& s2) { return s1.Compare(s2)  > 0; }
CALL_INLINE BOOL operator >(const DCString& s1, PCTSTR s2)          { return s1.Compare(s2)  > 0; }
CALL_INLINE BOOL operator >(PCTSTR s1,          const DCString& s2) { return s2.Compare(s1)  < 0; }
CALL_INLINE BOOL operator<=(const DCString& s1, const DCString& s2) { return s1.Compare(s2) <= 0; }
CALL_INLINE BOOL operator<=(const DCString& s1, PCTSTR s2)          { return s1.Compare(s2) <= 0; }
CALL_INLINE BOOL operator<=(PCTSTR s1,          const DCString& s2) { return s2.Compare(s1) >= 0; }
CALL_INLINE BOOL operator>=(const DCString& s1, const DCString& s2) { return s1.Compare(s2) >= 0; }
CALL_INLINE BOOL operator>=(const DCString& s1, PCTSTR s2)          { return s1.Compare(s2) >= 0; }
CALL_INLINE BOOL operator>=(PCTSTR s1,          const DCString& s2) { return s2.Compare(s1) <= 0; }

///////////////////////////////////////////////////////////////////////////////////////////////////
// MAKE TO DCString SUPPORT MACRO WITH LOCALIZABLE RESOURCES...
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef __LINUX__
#define RESIT(TheCFStr)    (RESID)(TheCFStr)
#define RESCFSTR(TheStr)   (RESID)(TheStr)
#define MCRES(TheCFStr)    DCString((RESID)(TheCFStr))
#define MCRESCFSTR(TheStr) DCString((RESID)(TheStr))
#endif
#define MCCFSTR(TheStr)    DCString((TheStr))

///////////////////////////////////////////////////////////////////////////////////////////////////
#else  // #ifndef _MAC_
///////////////////////////////////////////////////////////////////////////////////////////////////
#define DCString McString

///////////////////////////////////////////////////////////////////////////////////////////////////
#endif // #ifndef _MAC_
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef __LINUX__
typedef DCString CString;
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////
#endif // DC_STRING_INCLUDED
///////////////////////////////////////////////////////////////////////////////////////////////////
