// DCToolsImplement.h
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef __DCTOOLSIMPLEMENT__
#ifdef __AFX_H__


///////////////////////////////////////////////////////////////////////////////////////////////////
#include <afxtempl.h>
#include <afxmt.h>
///////////////////////////////////////////////////////////////////////////////////////////////////
// OTHER TOOLBOX
///////////////////////////////////////////////////////////////////////////////////////////////////
#include "Regiskey.h"    // New: CRegisKey
#include "DCRegistry.h"


///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
class DCTimeStamp {
public:
      DCTimeStamp()                {InitStampTime          (); };

      DWORD                        m_InitStampTime;
      DWORD                        m_LastStampTime;
      DWORD                        m_CurStampTime;

      DWORD                        m_LapTime;
      DWORD                        m_LapMinute;
      DWORD                        m_LapSeconde;
      DWORD                        m_LapMilli;

      DWORD                        m_DifTime;
      DWORD                        m_DifMinute;
      DWORD                        m_DifSeconde;
      DWORD                        m_DifMilli;

      /////////////////////////////////////////////////////////////////////////////////////////////
      void  InitStampTime         ()
      {
          m_InitStampTime        =
          m_LastStampTime        =
          m_CurStampTime         = GetTickCount();

          m_LapTime              =
          m_LapMinute            =
          m_LapSeconde           =
          m_LapMilli             =

          m_DifTime              =
          m_DifMinute            =
          m_DifSeconde           =
          m_DifMilli             = 0;
      };
      /////////////////////////////////////////////////////////////////////////////////////////////
      DWORD GetCurrentMark         ()
      {
      DWORD CurStampTime         = GetTickCount();
      DWORD CurDiff              = 0;

          if(CurStampTime        < m_InitStampTime){
             CurDiff             = (m_InitStampTime - CurStampTime);
          } else {
             CurDiff             = (CurStampTime    - m_InitStampTime);
          }
          return CurDiff;
      }
      /////////////////////////////////////////////////////////////////////////////////////////////
      DWORD GetCurrentDiff         ()
      {
      DWORD CurStampTime         = GetTickCount();
      DWORD CurDiff              = 0;

          if(CurStampTime        < m_LastStampTime){
             CurDiff             = (m_LastStampTime - CurStampTime);
          } else {
             CurDiff             = (CurStampTime    - m_LastStampTime);
          }
          return CurDiff;
      }
      /////////////////////////////////////////////////////////////////////////////////////////////
      BOOL   StampTime             ()
      {
          m_LastStampTime        = m_CurStampTime;
          m_CurStampTime         = GetTickCount();

          if(m_CurStampTime      < m_LastStampTime){
             m_DifTime           = (m_LastStampTime - m_CurStampTime);
          } else {
             m_DifTime           = (m_CurStampTime  - m_LastStampTime);
          }
          if(m_CurStampTime      < m_InitStampTime){
             m_LapTime           = (m_InitStampTime - m_CurStampTime);
          } else {
             m_LapTime           = (m_CurStampTime  - m_InitStampTime);
          }
          m_LapMinute            = (m_LapTime       / 60000);
          m_LapSeconde           = (m_LapTime       / 1000);
          m_LapMilli             = (m_LapTime)      - (m_LapSeconde * 1000);

          m_DifMinute            = (m_DifTime       / 60000);
          m_DifSeconde           = (m_DifTime       / 1000);
          m_DifMilli             = (m_DifTime)      - (m_DifSeconde * 1000);
      };
      /////////////////////////////////////////////////////////////////////////////////////////////
      CString   ReportDifTime      (LPCTSTR SrcRep)
      {
      CString   Info (SrcRep);

          StampTime                ();
          Info.Format(_T("%s Stamp: %10u, Dur: %5d:%2d.%.3d "), Info, m_DifMinute, m_DifTime, m_DifSeconde, m_DifMilli);
          return Info;
      };
      /////////////////////////////////////////////////////////////////////////////////////////////
      CString   ReportLapTime      (LPCTSTR SrcRep)
      {
      CString   Info (SrcRep);

          StampTime                ();
          Info.Format(_T("%s Stamp: %10u, Dur: %5d:%2d.%.3d "), Info, m_LapMinute, m_LapTime, m_LapSeconde, m_LapMilli);
          return Info;
      };
};

///////////////////////////////////////////////////////////////////////////////////////////////////
class DCTimeout {
public:
      DCTimeout();

      DWORD Start;
      DWORD Now;
      DWORD Delay;

      void   BeginDelay        (DWORD Duration);
      void   EndDelay          ();

      /////////////////////////////////////////////////////////////////////////////////////////////
      void   WaitDelay         (DWORD Duration);
      void   YieldDelay        (DWORD Duration);
      void   SleepDelay        (DWORD Duration);
      /////////////////////////////////////////////////////////////////////////////////////////////
      void   WaitIfInDelay     ();
      void   YieldIfInDelay    ();
      void   SleepIfInDelay    ();
      void   SleepTillEndDelay ();
      /////////////////////////////////////////////////////////////////////////////////////////////
      BOOL   NotInDelay        ();
      BOOL   StillInDelay      ();
      BOOL   SleepInDelay      ();
      long   DelayTimeLeft     ();
      /////////////////////////////////////////////////////////////////////////////////////////////
      BOOL   NotYieldInDelay   ();
      BOOL   StillYieldInDelay ();
      /////////////////////////////////////////////////////////////////////////////////////////////
      BOOL   NotSleepInDelay   ();
      BOOL   StillSleepInDelay ();
};
///////////////////////////////////////////////////////////////////////////////////////////////////
class DCEvent : public CEvent
{
      DECLARE_DYNAMIC(DCEvent)

public:
      DCEvent  (BOOL bInitiallyOwn = FALSE, BOOL bManualReset = FALSE,
                LPCTSTR lpszName = NULL, LPSECURITY_ATTRIBUTES lpsaAttribute = NULL)
               :CEvent(bInitiallyOwn, bManualReset, lpszName, lpsaAttribute) { }

      operator HANDLE() const
      {
          return m_hObject;
      }
      BOOL virtual Wait (DWORD Timeout = INFINITE);
};
///////////////////////////////////////////////////////////////////////////////////////////////////
class DCMutexEvent : public DCEvent
{
      DECLARE_DYNAMIC(DCMutexEvent)

public:
      DCMutexEvent  (BOOL bInitiallyOwn = TRUE, BOOL bManualReset = FALSE,
                LPCTSTR lpszName = NULL, LPSECURITY_ATTRIBUTES lpsaAttribute = NULL)
               :DCEvent(bInitiallyOwn, bManualReset, lpszName, lpsaAttribute)
      {
          // SetEvent();
      }
      BOOL Lock(DWORD Timeout = INFINITE);
      BOOL Unlock();
};
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef WINSOCK_VERSION
///////////////////////////////////////////////////////////////////////////////////////////////////
class DCNetClient
{
public:

    DCNetClient()
    {
        m_TheClientSocket     = INVALID_SOCKET;
        m_TheSocketEvent      = WSA_INVALID_EVENT;
        m_ShutDownEvent       = WSA_INVALID_EVENT;
        m_SocketSleepTime     = 1;
        m_SocketIOTimeout     = INFINITE;
        ZeroMemory(&m_HostIP,   sizeof(m_HostIP));
    }
    DCNetClient(DWORD Timeout)
    {
        m_TheClientSocket     = INVALID_SOCKET;
        m_TheSocketEvent      = WSA_INVALID_EVENT;
        m_ShutDownEvent       = WSA_INVALID_EVENT;
        m_SocketSleepTime     = 1;
        m_SocketIOTimeout     = Timeout;
        ZeroMemory(&m_HostIP,   sizeof(m_HostIP));
    }
    ~DCNetClient()
    {
        ClosePort();
    }
    BOOL  IsPortOpen            ()
    {
        if(m_TheClientSocket != INVALID_SOCKET){
           return TRUE;
        }
        return FALSE;
    }
    WSAEVENT                    m_ShutDownEvent;       // EXTERNAL EVENT FOR SHUTDOWN
    WSAEVENT                    m_TheSocketEvent;
    SOCKET                      m_TheClientSocket;
    SOCKADDR_IN                 m_HostIP;
    DWORD                       m_SocketSleepTime;
    DWORD                       m_SocketIOTimeout;
    CCriticalSection            m_CriticalSockAccess;

    CString                     m_Status, m_Echo, m_Error;

#ifndef EchoText
    void  EchoText              (LPCTSTR Text)             { m_Echo                = Text; }
    void  EchoStatus            (LPCTSTR Text)             { m_Status              = Text; }
    void  EchoError             (LPCTSTR Text)             { m_Error               = Text; AfxMessageBox(Text, MB_SYSTEMMODAL); }
    void  EchoThisError         (LPCTSTR Text, DWORD Errno)
    {
    CString FailText;

        FailText.Format(CString(Text)+_T(" Error: %d"), Errno);
        EchoError(FailText);
    }
#endif

    // LOW LEVEL...
    long  CheckNetEvent         (WSAEVENT TheEvent); // RETURN THE EVENT
    BOOL  CheckSockError        ();
    BOOL  WriteNetStream        (LPCVOID BufferToWrite, DWORD SizeofBufferToWrite);
    DWORD ReadNetStream         (LPVOID  BufferToRead,  DWORD SizeofBufferToRead);

    // HIGH LEVEL...            // HOSTADDRESS = TCP/IP OR NET NAME...
    BOOL  ClosePort             ();
    BOOL  OpenPort              (LPCTSTR RemoteHostAddress, LPCTSTR PortNum);

    long  CheckEvent   ();
    long  HandleEvent  ();

    BOOL  Write                 (LPCVOID BufferToWrite, DWORD SizeofBufferToWrite);
    BOOL  Read                  (LPVOID  BufferToRead,  DWORD SizeofBufferToRead);
};
///////////////////////////////////////////////////////////////////////////////////////////////////
#define PWM_SERVEREVENT     WM_USER + 0x808
#define PWM_CLIENTEVENT     WM_USER + 0x809
///////////////////////////////////////////////////////////////////////////////////////////////////
class DCNetServer
{
public:

    DCNetServer()
    {
        m_hWnd                = NULL;
        m_PortNo              = 0;
        m_TheSocketPort       = INVALID_SOCKET;
        m_TheSocketEvent      = WSA_INVALID_EVENT;
        m_ShutDownEvent       = WSA_INVALID_EVENT;
        m_SocketSleepTime     = 1;
        m_SocketTimeout       = 60000;

        m_ClientTimeOut       = 30 * SECOND;
        ZeroMemory(&m_HostIP,   sizeof(m_HostIP));
    }
    DCNetServer(DWORD Timeout)
    {
        m_hWnd                = NULL;
        m_PortNo              = 0;
        m_TheSocketPort       = INVALID_SOCKET;
        m_TheSocketEvent      = WSA_INVALID_EVENT;
        m_ShutDownEvent       = WSA_INVALID_EVENT;
        m_SocketSleepTime     = 1;
        m_SocketTimeout       = Timeout;

        m_ClientTimeOut       = 30 * SECOND;
        ZeroMemory(&m_HostIP,   sizeof(m_HostIP));
    }
    ~DCNetServer()
    {
        CloseServer();
    }
    BOOL  IsPortOpen            ()
    {
        if(m_TheSocketPort   != INVALID_SOCKET){
           return TRUE;
        }
        return FALSE;
    }
    HWND                        m_hWnd;
    DWORD                       m_PortNo;
    WSAEVENT                    m_ShutDownEvent;       // EXTERNAL EVENT FOR SHUTDOWN
    WSAEVENT                    m_TheSocketEvent;
    SOCKET                      m_TheSocketPort;
    SOCKADDR_IN                 m_HostIP;
    DWORD                       m_SocketSleepTime;
    DWORD                       m_SocketTimeout;

    DWORD                       m_ClientTimeOut;
    DCTimeout                   m_LastClientTimeOut;
    CCriticalSection            m_CriticalSockAccess;

    CString                     m_Status, m_Echo, m_Error;

#ifndef EchoText
    void  EchoText              (LPCTSTR Text){ m_Echo                = Text; }
    void  EchoStatus            (LPCTSTR Text){ m_Status              = Text; }
    void  EchoError             (LPCTSTR Text){ m_Error              += Text; AfxMessageBox(Text, MB_SYSTEMMODAL); }
    void  EchoThisError         (LPCTSTR Text, DWORD Errno)
    {
    CString FailText;

        FailText.Format(CString(Text)+_T(" Error: %d"), Errno);
        EchoError(FailText);
    }
#endif

    BOOL   CloseServer          ();
    BOOL   StartServer          (HWND hWnd, DWORD ListenPort);

    long   CheckServerEvent     (HWND hWnd, WPARAM wParam, LPARAM lParam);
    HANDLE WaitForNetClient     (HWND hWnd, SOCKET &SocketPort, SOCKADDR_IN &Address);


    DWORD  ReadNetStream        (HANDLE hClient, HANDLE Event, LPVOID  BufferToRead,  DWORD SizeofBufferToRead);
    BOOL   WriteNetStream       (HANDLE hClient, HANDLE Event, LPCVOID BufferToWrite, DWORD SizeofBufferToWrite);

    BOOL   ReadStream           (HANDLE hClient, HANDLE Event, LPVOID  BufferToRead,  DWORD SizeofBufferToRead);
    BOOL   WriteStream          (HANDLE hClient, HANDLE Event, LPCVOID BufferToRead,  DWORD SizeofBufferToRead);
};
///////////////////////////////////////////////////////////////////////////////////////////////////
#endif // #ifdef WINSOCK_VERSION
///////////////////////////////////////////////////////////////////////////////////////////////////
class CSysTime
{
public:
    CSysTime()
    {
       GetCurrentTime ();
    }
    ~CSysTime()
    {
    }
    CTime m_TheTime;
    ///////////////////////////////////////////////////////////////////////////
    void GetCurrentTime ()
    {
       m_TheTime   = CTime::GetCurrentTime();
    }
    ///////////////////////////////////////////////////////////////////////////
    CTimeSpan DiffTime  (CSysTime &CmpTime)
    {
    CTimeSpan DelayTime;

       DelayTime = CmpTime.m_TheTime - m_TheTime;
       return DelayTime;
    }
    BOOL ConvertToFileTime (FILETIME & TheFileTime)
    {
    SYSTEMTIME TheSystemTime;

       m_TheTime.GetAsSystemTime(TheSystemTime);
       return ::SystemTimeToFileTime(&TheSystemTime, &TheFileTime);
    }
    BOOL ConvertFromFileTime (FILETIME & TheFileTime)
    {
    SYSTEMTIME TheSystemTime;
    BOOL bRet;

       bRet = ::FileTimeToSystemTime(&TheFileTime, &TheSystemTime);

       CTime m_ThisTime(TheSystemTime);
       m_TheTime = m_ThisTime;

       return bRet;
    }
    BOOL ConvertFromSystemTime (SYSTEMTIME & TheSystemTime)
    {
    BOOL bRet = TRUE;

       CTime m_ThisTime(TheSystemTime);
       m_TheTime = m_ThisTime;

       return bRet;
    }
    BOOL ConvertToSystemTime (SYSTEMTIME & TheSystemTime)
    {
    BOOL bRet;

       bRet = m_TheTime.GetAsSystemTime(TheSystemTime);

       return bRet;
    }
    void SetYear (WORD ParmValue)
    {
    SYSTEMTIME  TheSystemTime;

        ConvertToSystemTime        (TheSystemTime);
        TheSystemTime.wYear      = ParmValue;
        TheSystemTime.wDayOfWeek = 0;
        ConvertFromSystemTime      (TheSystemTime);
    }
    void AddMonth (WORD ParmValue)
    {
    SYSTEMTIME  TheSystemTime;
    WORD        TheNewMonth;

        ConvertToSystemTime        (TheSystemTime);
        TheNewMonth              = TheSystemTime.wMonth;
        TheNewMonth             += ParmValue;
        if(TheNewMonth           > 12){
           TheNewMonth           = 1;
           TheSystemTime.wYear   ++;
        }
        TheSystemTime.wMonth     = TheNewMonth;
        TheSystemTime.wDayOfWeek = 0;
        ConvertFromSystemTime      (TheSystemTime);
    }
    void RewMonth (WORD ParmValue)
    {
    SYSTEMTIME  TheSystemTime;
    WORD        TheNewMonth;

        ConvertToSystemTime        (TheSystemTime);
        TheNewMonth              = TheSystemTime.wMonth;
        TheNewMonth             -= ParmValue;
        if(TheNewMonth           < 1){
           TheNewMonth           = 12;
           TheSystemTime.wYear   --;
        }
        TheSystemTime.wMonth     = TheNewMonth;
        TheSystemTime.wDayOfWeek = 0;
        ConvertFromSystemTime      (TheSystemTime);
    }
    void SetMonth (WORD ParmValue)
    {
    SYSTEMTIME  TheSystemTime;

        ConvertToSystemTime        (TheSystemTime);
        TheSystemTime.wMonth     = ParmValue;
        TheSystemTime.wDayOfWeek = 0;
        ConvertFromSystemTime      (TheSystemTime);
    }
    void AddDays (WORD ParmValue)
    {
    SYSTEMTIME  TheSystemTime;
    WORD        TheNewDay;

        ConvertToSystemTime        (TheSystemTime);
        TheNewDay                = TheSystemTime.wDay;
        TheNewDay               += ParmValue;
        if(TheNewDay             > 31){                 // WE WILL NEED EXTRA LOGIC HERE FOR END OF MONTH
           TheNewDay             = 1;
           AddMonth                (1);
        }
        TheSystemTime.wDay       = TheNewDay;
        TheSystemTime.wDayOfWeek = 0;
        ConvertFromSystemTime      (TheSystemTime);
    }
    void RewDays (WORD ParmValue)
    {
    SYSTEMTIME  TheSystemTime;
    WORD        TheNewDay;

        ConvertToSystemTime        (TheSystemTime);
        TheNewDay                = TheSystemTime.wDay;
        TheNewDay               -= ParmValue;
        if(TheNewDay             < 1){                 // WE WILL NEED EXTRA LOGIC HERE FOR END OF MONTH
           TheNewDay             = 31;
           RewMonth                (1);
        }
        TheSystemTime.wDay       = TheNewDay;
        TheSystemTime.wDayOfWeek = 0;
        ConvertFromSystemTime      (TheSystemTime);
    }
    void SetDay (WORD ParmValue)
    {
    SYSTEMTIME  TheSystemTime;

        ConvertToSystemTime        (TheSystemTime);
        TheSystemTime.wDay       = ParmValue;
        TheSystemTime.wDayOfWeek = 0;
        ConvertFromSystemTime      (TheSystemTime);
    }
    void SetDate (WORD ParmYear, WORD ParmMonth, WORD ParmDay)
    {
    SYSTEMTIME  TheSystemTime;

        ConvertToSystemTime        (TheSystemTime);
        TheSystemTime.wYear      = ParmYear;
        TheSystemTime.wMonth     = ParmMonth;
        TheSystemTime.wDay       = ParmDay;
        TheSystemTime.wDayOfWeek = 0;
        ConvertFromSystemTime      (TheSystemTime);
    }
    void SetHour (WORD ParmHour)
    {
    SYSTEMTIME  TheSystemTime;

        ConvertToSystemTime        (TheSystemTime);
        TheSystemTime.wHour      = ParmHour;
        ConvertFromSystemTime      (TheSystemTime);
    }
    void SetMinute (WORD ParmMinute)
    {
    SYSTEMTIME  TheSystemTime;

        ConvertToSystemTime        (TheSystemTime);
        TheSystemTime.wMinute    = ParmMinute;
        ConvertFromSystemTime      (TheSystemTime);
    }
    void SetSecond (WORD ParmSec)
    {
    SYSTEMTIME  TheSystemTime;

        ConvertToSystemTime        (TheSystemTime);
        TheSystemTime.wSecond    = ParmSec;
        ConvertFromSystemTime      (TheSystemTime);
    }
    void SetTime (WORD ParmHour, WORD ParmMinute, WORD ParmSec)
    {
    SYSTEMTIME  TheSystemTime;

        ConvertToSystemTime        (TheSystemTime);
        TheSystemTime.wHour      = ParmHour;
        TheSystemTime.wMinute    = ParmMinute;
        TheSystemTime.wSecond    = ParmSec;
        ConvertFromSystemTime      (TheSystemTime);
    }
    ///////////////////////////////////////////////////////////////////////////
    // _T("%D days, %H:%M:%S") strftime() time_t FORMAT SEE BELOW
    ///////////////////////////////////////////////////////////////////////////
    CString FormatDiffTime  (CSysTime &CmpTime, LPCTSTR pFormat)
    {
    CTimeSpan DelayTime;

       DelayTime = DiffTime  (CmpTime);
       return DelayTime.Format(pFormat);
    }
    /*/////////////////////////////////////////////////////////////////////////
    %a   Abbreviated weekday name
    %A   Full weekday name

    %b   Abbreviated month name
    %B   Full month name

    %c   Date and time representation appropriate for locale

    %d   Day of month as decimal number (01 - 31)

    %H   Hour in 24-hour format (00 - 23)

    %I   Hour in 12-hour format (01 - 12)

    %j   Day of year as decimal number (001 - 366)

    %m   Month as decimal number (01 - 12)

    %M   Minute as decimal number (00 - 59)

    %p   Current locales A.M./P.M. indicator for 12-hour clock

    %S   Second as decimal number (00 - 59)

    %U   Week of year as decimal number, with Sunday as first day of week (00 - 53)

    %w   Weekday as decimal number (0 - 6; Sunday is 0)
    %W   Week of year as decimal number, with Monday as first day of week (00 - 53)

    %x   Date representation for current locale
    %X   Time representation for current locale

    %y   Year without century, as decimal number (00 - 99)
    %Y   Year with century, as decimal number
    %z, %Z Time-zone name or abbreviation; no characters if time zone is unknown

    %%   Percent sign
    *//////////////////////////////////////////////////////////////////////////
    int SearchMonth (CString SubString) // 0 Mean not found.
    {
    static TCHAR * MonthAbreviated [] = {{NULL}, {_T("JAN")}, {_T("FEB")}, {_T("MAR")}, {_T("APR")},
                                                 {_T("MAY")}, {_T("JUN")}, {_T("JUL")}, {_T("AUG")},
                                                 {_T("SEP")}, {_T("OCT")}, {_T("NOV")}, {_T("DEC")} };
    int Looper;

        SubString = SubString.Left(3); SubString.MakeUpper();
        for(Looper = 1; Looper <= 12; Looper++){
           if(SubString == MonthAbreviated [Looper]){
              return Looper;
           }
        }
        return 1;
    }
    ///////////////////////////////////////////////////////////////////////////
    int SearchDay   (CString SubString) // 0 Mean not found.
    {
    static TCHAR * DayAbreviated   [] = {{_T("SUN")}, {_T("MON")}, {_T("TUE")}, {_T("WED")},
                                         {_T("THU")}, {_T("FRI")}, {_T("SAT")} };
    int Looper;

        SubString = SubString.Left(3); SubString.MakeUpper();
        for(Looper = 0; Looper <= 6; Looper++){
           if(SubString == DayAbreviated [Looper]){
              return Looper;
           }
        }
        return 0;
    }
    ///////////////////////////////////////////////////////////////////////////
    // ENGLISH FORMAT ONLY
    ///////////////////////////////////////////////////////////////////////////
    BOOL ReadFormattedStringDateAndTime (LPCTSTR TheFormat, LPCTSTR TheInput)
    {
    SYSTEMTIME InSystemTime; ZeroMemory(&InSystemTime, sizeof(InSystemTime));
    LPCTSTR    ParseTheFormat = TheFormat; if(TheFormat == NULL){ return FALSE; }
    LPCTSTR    ParseTheInput  = TheInput;  if(TheInput  == NULL){ return FALSE; }
    CString    SubString;
    TCHAR      ParseCode      = 0;
    int        DayOfYear      = 0;
    int        WeekOfyear     = 0;
    int        Century        = 1900;
    int        TempValue      = 0;

        // GIVE THE CURRENT TIME AS DEFAULT
        ConvertToSystemTime (InSystemTime);
        while((ParseCode = *ParseTheFormat++) && (*ParseTheInput)){
            switch(ParseCode){
            case '%':
                 SubString = ParseTheInput;
                 switch(ParseCode = *ParseTheFormat++){
                 case 'a':   // %a   Abbreviated weekday name
                      InSystemTime.wDayOfWeek = SearchDay(ParseTheInput);
                      ParseTheInput += 3;
                      break;
                 case 'A':   // %A   Full weekday name
                      InSystemTime.wDayOfWeek = SearchDay(ParseTheInput);
                      while(IsCharAlpha(*ParseTheInput)) ParseTheInput++; // Skipit!
                      break;

                 case 'b':   // %b   Abbreviated month name
                      InSystemTime.wMonth = SearchMonth(ParseTheInput);
                      ParseTheInput += 3;
                      break;
                 case 'B':   // %B   Full month name
                      InSystemTime.wMonth = SearchMonth(ParseTheInput);
                      while(IsCharAlpha(*ParseTheInput)) ParseTheInput++; // Skipit!
                      break;

                 case 'c':   // %c   Date and time representation appropriate for locale
                      // FORMAT UNSUPPORTED.
                      return FALSE;
                 case 'd':   // %d   Day of month as decimal number (01 - 31)
                      SubString      = SubString.Left(2);
                      TempValue      = _ttoi (SubString);

                      if(TempValue   > 31) { TempValue  =  1; }
                      if(TempValue   <  1) { TempValue  =  1; }
                      InSystemTime.
                      wDay           = TempValue;
                      ParseTheInput += 2;
                      break;
                 case 'H':   // %H   Hour in 24-hour format (00 - 23)
                      SubString      = SubString.Left(2);
                      TempValue      = _ttoi (SubString);
                      if(TempValue   > 23) { TempValue  =  1; }
                      InSystemTime.
                      wHour          = TempValue;
                      ParseTheInput += 2;
                      break;
                 case 'I':   // %I   Hour in 12-hour format (00  - 11)
                      SubString      = SubString.Left(2);
                      TempValue      = _ttoi (SubString);
                      if(TempValue   > 12) { TempValue  =  0; }
                      InSystemTime.
                      wHour          = TempValue;
                      ParseTheInput += 2;
                      break;
                 case 'j':   // %j   Day of year as decimal number (001 - 366)
                      SubString      = SubString.Left(3);
                      TempValue      = _ttoi (SubString);
                      DayOfYear      = TempValue;
                      ParseTheInput += 3;
                      break;
                 case 'm':   // %m   Month as decimal number (01 - 12)
                      SubString      = SubString.Left(2);
                      TempValue      = _ttoi (SubString);
                      if(TempValue   > 12) { TempValue  =  1; }
                      if(TempValue   <  1) { TempValue  =  1; }
                      InSystemTime.
                      wMonth         = TempValue;
                      ParseTheInput += 2;
                      break;
                 case 'M':   // %M   Minute as decimal number (00 - 59)
                      SubString      = SubString.Left(2);
                      TempValue      = _ttoi (SubString);
                      if(TempValue   > 59) { TempValue  =  0; }
                      InSystemTime.
                      wMinute        = TempValue;
                      ParseTheInput += 2;
                      break;
                 case 'p':   // %p   Current locales A.M./P.M. indicator for 12-hour clock
                      SubString      = SubString.Left(2); SubString.MakeUpper();
                      if(SubString  == _T("PM")){
                         TempValue   = InSystemTime.wHour;
                         if(TempValue   > 23) { TempValue  =  0; }
                         InSystemTime.
                         wHour       = TempValue;
                      }
                      ParseTheInput += 2;
                      break;
                 case 'S':   // %S   Second as decimal number (00 - 59)
                      SubString      = SubString.Left(2);
                      TempValue      = _ttoi (SubString);
                      if(TempValue   > 59) { TempValue  =  0; }
                      InSystemTime.
                      wSecond        = TempValue;
                      ParseTheInput += 2;
                      break;
                 case 'U':   // %U   Week of year as decimal number, with Sunday as first day of week (00 - 53)
                      SubString      = SubString.Left(2);
                      TempValue      = _ttoi (SubString);
                      WeekOfyear     = TempValue;
                      ParseTheInput += 2;
                      break;
                 case 'w':   // %w   Weekday as decimal number (0 - 6; Sunday is 0)
                      SubString      = SubString.Left(2);
                      TempValue      = _ttoi (SubString);
                      if(TempValue   >  6) { TempValue  =  0; }
                      InSystemTime.
                      wDayOfWeek     = TempValue;
                      ParseTheInput += 2;
                      break;
                 case 'W':   // %W   Week of year as decimal number, with Monday as first day of week (00 - 53)
                      SubString      = SubString.Left(2);
                      TempValue      = _ttoi (SubString);
                      WeekOfyear     = TempValue;
                      ParseTheInput += 2;
                      break;
                 case 'x':   // %x   Date representation for current locale
                      // FORMAT UNSUPPORTED.
                      return FALSE;
                 case 'X':   // %X   Time representation for current locale
                      // FORMAT UNSUPPORTED.
                      return FALSE;
                 case 'y':   // %y   Year without century, as decimal number (00 - 99)
                      // IT IS NOT RECOMMENDED TO USE THIS FORMAT EVER SINCE IN 90 YEARS WE RESTART THE CYCLE OF YEAR 2000 ABOUT DATE.
                      // FOR ME, THIS SHOULD NOT EVEN BE A DATE FORMAT...
                      // BUT OF COURSE I WILL PUT LOGIC HERE TO GO BEHOND THAT BUT ANYWAY I WILL BE LONG DEAD. SOME DAY THEY'LL LEARN DC.
                      // OR I AM ALIVE AT THE AGE 122 YEARS OLD THEN COMME TO ME WE SHOULD HAVE A DISCUSSION...
                      SubString      = SubString.Left(2);
                      TempValue      = _ttoi (SubString);

                      if((InSystemTime.wYear % 100) <= 90){ //
                         Century     = (((InSystemTime.wYear - 100) / 100) * 100); // PREVIOUS CENTURY...
                      } else {
                         Century     = ((InSystemTime.wYear  / 100) * 100); // CURRENT CENTURY
                      }
                      if(TempValue   > 99) { TempValue  =  0; }
                      InSystemTime.
                      wYear          = Century + TempValue;
                      ParseTheInput += 2;
                      break;
                 case 'Y':   // %Y   Year with century, as decimal number
                      SubString      = SubString.Left(4);
                      TempValue      = _ttoi (SubString);
                      InSystemTime.
                      wYear          = TempValue;
                      ParseTheInput += 4;
                      break;
                 case 'z':   // %z   Time-zone abbreviation; no characters if time zone is unknown
                      // FORMAT UNSUPPORTED.
                      return FALSE;
                 case 'Z':   // %Z   Time-zone Full name ; no characters if time zone is unknown
                      // FORMAT UNSUPPORTED.
                      return FALSE;
                 default:
                 case '%':   // %%   Percent sign
                      ParseTheInput++; // Skipit!
                      break;
                 }
                 break;

            default:
                 ParseTheInput++;
                 break;
            }
        }
        ConvertFromSystemTime (InSystemTime);
        return TRUE;
    }
    ///////////////////////////////////////////////////////////////////////////
    // _T("Day of week: %a, Month: %b Date: %d, Year: %Y, Time: %H:%M:%S") = "Fri, Mar 19, 1999, 10:21:36" );
    ///////////////////////////////////////////////////////////////////////////
    CString Format( LPCTSTR pFormat )
    {
       return m_TheTime.Format( pFormat );
    }
    CString Format( UINT nFormatID )
    {
       return m_TheTime.Format( nFormatID );
    }
};
SYSTEMTIME  ConvertDateTimeToSystemTime (DWORD ThisDate, DWORD ThisTime);
BOOL        ConvertSysTimeToDateTime    (CSysTime & ThisSysTime, PDWORD ThisDate, PDWORD ThisTime);
CTimeSpan   BuildTimeSpan               (DWORD ThisTime);
///////////////////////////////////////////////////////////////////////////////////////////////////
// Microsoft Systems Journal -- October 1999
// Improved CCommandLineInfo parses arbitrary switches.
//
//    CCommandLineInfoEx cmdinfo;
//    ParseCommandLine(cmdinfo); // (from app object)
//
// After parsing, you can call GetOption to get the value of any switch. Eg:
//
//    if (cmdinfo.GetOption("nologo")) {
//       // handle it
//    }
//
// to get the value of a string option, type
//
//    CString filename;
//    if (cmdinfo.GetOption("f", filename)) {
//       // now filename is string following -f option
//    }
//
///////////////////////////////////////////////////////////////////////////////////////////////////
#if 0 // DEFAULT CCommandLineInfoEx....
class CCommandLineInfoEx : public CCommandLineInfo {
public:
   BOOL GetOption(LPCTSTR option, CString& val)
   {
      return m_options.Lookup(option, val);
   }
   BOOL GetOption(LPCTSTR option) {
      return GetOption(option, CString());
   }
   protected:
   CMapStringToString m_options;                  // hash of options
   CString            m_sLastOption;              // last option encountered
   virtual void ParseParam(const TCHAR* pszParam, BOOL bFlag, BOOL bLast)
   {
      if(bFlag) {                                 // this is a "flag" (begins with / or -)
         m_options[pszParam]       = "TRUE";      // default value is "TRUE"
         m_sLastOption             = pszParam;    // save in case other value specified
      } else if(Not m_sLastOption.IsEmpty()) {
         m_options[m_sLastOption]  = pszParam;    // last token was option: set value
         m_sLastOption.Empty();                   // clear
      }
      // Call base class so MFC can see this param/token.
      CCommandLineInfo::ParseParam(pszParam, bFlag, bLast);
   }
};
#endif // DEFAULT CCommandLineInfoEx....
///////////////////////////////////////////////////////////////////////////////////////////////////
// NEW CUSTOM: CCommandLineInfoEx....
class CCommandLineInfoEx : public CCommandLineInfo {
public:
   BOOL               m_UnregServer;
   BOOL               m_RegServer;
   BOOL               m_Service;

   CCommandLineInfoEx() : CCommandLineInfo ()
   {
       m_UnregServer = FALSE;
       m_RegServer   = FALSE;
       m_Service     = FALSE;
   }
   BOOL GetOption(LPCTSTR option, CString& val)
   {
      return m_options.Lookup(option, val);
   }
   BOOL GetOption(LPCTSTR option) {
      return GetOption(option, CString());
   }
   protected:
   CMapStringToString m_options;                  // hash of options
   CString            m_sLastOption;              // last option encountered
   virtual void ParseParam(const TCHAR* pszParam, BOOL bFlag, BOOL bLast)
   {
   TCHAR  ThisKey[2] = {0,0};

      if(bFlag) {                                 // this is a "flag" (begins with / or -)

         if(lstrcmpi(pszParam, _T("UnregServer")) == 0){
            m_UnregServer       = TRUE;
         } else
         if(lstrcmpi(pszParam, _T("RegServer"))   == 0){
            m_RegServer         = TRUE;
         } else
         if(lstrcmpi(pszParam, _T("Service"))     == 0){
            m_Service           = TRUE;
         } else {
            ThisKey[0]          = pszParam[0];    // set the key to the first char
            m_options[ThisKey]  = &pszParam[1];   // set the value to the following string
            m_sLastOption       = ThisKey;        // save in case other value specified
         }

      } else if(Not m_sLastOption.IsEmpty()) {
         m_options[m_sLastOption]  = pszParam;    // last token was option: set value
         m_sLastOption.Empty();                   // clear
      }
      // Call base class so MFC can see this param/token.
      CCommandLineInfo::ParseParam(pszParam, bFlag, bLast);
   }
};
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef __AFXWIN_H__
#ifndef _NO_AFXWINDOWS_SUPPORT
///////////////////////////////////////////////////////////////////////////////////////////////////
DWORD     FillFileFormatList           (CListBox &theList,   CString FormatList);
DWORD     FillFileFormatCombo          (CComboBox &theCombo, CString FormatList);

DWORD     PopUpMenu                    (int ResID);

///////////////////////////////////////////////////////////////////////////////////////////////////
// FILTER EXAMPLE _T("Zip Files (*.zip)|*.zip||");
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL      BrowseForPath                (HWND hwnd, CString &SelPath, LPCTSTR AskText);
BOOL      BrowseForFile                (CString &TheFile, CString Filter);
BOOL      BrowseToCreateFile           (CString &TheFile, CString Filter);

HDC       GetDefaultPrinterDC          (HWND hwnd);
HDC       GetDCFromPrinterSetup        (HWND hwnd);


///////////////////////////////////////////////////////////////////////////////////////////////////
#endif // _NO_AFXWINDOWS_SUPPORT
#endif // __AFXWIN_H__
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
// IN .CPP
///////////////////////////////////////////////////////////////////////////////////////////////////
CString   StringLastError                (DWORD Errno);
///////////////////////////////////////////////////////////////////////////////////////////////////
CString   ProcessStdString               (CString theInput);
CString   ProcessStdNumString            (CString theInput);
CString   ProcessStdOutput               (CString theInput);

CString   ConvertToString                (DWORD   Value, BOOL IsSigned, int Base);
LONG      ConvertHexToBin                (LPBYTE RawData, LPCTSTR m_RawMsg, DWORD SizeofRawData);

LPCTSTR   GetCommonDomainNameFromSuffix  (CString ThisSuffix);
BOOL      IsCommonDomain                 (CString ThisSuffix);

LPCTSTR   GetCountryDomainNameFromSuffix (CString ThisSuffix);
BOOL      IsCountryDomain                (CString ThisSuffix);
CString   GetCurrentDomainName           (CString ThisUrl);

CString   GetCurrentParameterStr         (CString ThisUrl, CString ThisParameter, CString Default);
DWORD     GetCurrentParameterValue       (CString ThisUrl, CString ThisParameter, DWORD Default);



///////////////////////////////////////////////////////////////////////////////////////////////////
extern "C" {
///////////////////////////////////////////////////////////////////////////////////////////////////


BYTE      GetXorParity                 (LPCSTR  theData, int Length);

LPCTSTR   BooleanStr                   (BOOL State);
BOOL      GetBooleanStrValue           (LPCTSTR StateString);

DWORD     ConvertToValue               (LPCTSTR InputStr, DWORD MaxLen );// atoi, _ttol, strol, ToAsci, atof, _ecvt, _fcvt, _gcvt
double    StringToFloat                (LPCTSTR InputStr, DWORD MaxLen);

BOOL      SaveTextFile                 (LPCTSTR theFilename,  CString &theText );
BOOL      AppendTextFile               (LPCTSTR theFilename,  CString &theText );
BOOL      ReadTextFile                 (LPCTSTR theFilename,  CString &theText );


BOOL      RunSysInfo                   ();
HINSTANCE RunLink                      (LPCTSTR LinkName);
HINSTANCE RunLinkMode                  (LPCTSTR LinkName, int ShowMode); // SW_HIDE


BOOL      EmptyFolder                  (LPCTSTR FolderPath);
BOOL      DeleteFolder                 (LPCTSTR FolderPath);

BOOL      UserConFirm                  (LPCTSTR AskFor);
///////////////////////////////////////////////////////////////////////////////////////////////////
HANDLE __cdecl   BeginThreadEx         (PVOID, unsigned, unsigned (__stdcall *) (void *), PVOID, unsigned, unsigned *);

///////////////////////////////////////////////////////////////////////////////////////////////////
DWORD __fastcall BeginDelay            ();
BOOL  __fastcall NotInDelay            (DWORD DelayStart, DWORD TheDelay);
BOOL  __fastcall StillInDelay          (DWORD DelayStart, DWORD TheDelay);
void  __fastcall WaitIfInDelay         (DWORD DelayStart, DWORD TheDelay);

long  __fastcall DelayTimeSpent        (DWORD DelayStart, DWORD FromPoint);
long  __fastcall DelayTimeLeft         (DWORD DelayStart, DWORD TheDelay);

void  __fastcall WaitDelay             (DWORD TheDelay);
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  __fastcall NotYieldInDelay       (DWORD DelayStart, DWORD TheDelay);
BOOL  __fastcall StillYieldInDelay     (DWORD DelayStart, DWORD TheDelay);
void  __fastcall YieldIfInDelay        (DWORD DelayStart, DWORD TheDelay);
void  __fastcall YieldDelay            (DWORD TheDelay);
///////////////////////////////////////////////////////////////////////////////////////////////////
void  __fastcall YieldPaintIfInDelay   (DWORD DelayStart, DWORD TheDelay);
void  __fastcall YieldPaintDelay       (DWORD TheDelay);

///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  __fastcall NotSleepInDelay       (DWORD DelayStart, DWORD TheDelay);
BOOL  __fastcall StillSleepInDelay     (DWORD DelayStart, DWORD TheDelay);
void  __fastcall SleepIfInDelay        (DWORD DelayStart, DWORD TheDelay);
void  __fastcall SleepDelay            (DWORD TheDelay);
void  __fastcall SleepTillEndDelay     (DWORD DelayStart, DWORD TheDelay);

///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  __fastcall SleepTillTrueDelay     (volatile BOOL & CheckStatus, DWORD TheDelay);
BOOL  __fastcall WaitTillTrueDelay      (volatile BOOL & CheckStatus, DWORD TheDelay);
BOOL  __fastcall YieldTillTrueDelay     (volatile BOOL & CheckStatus, DWORD TheDelay);

BOOL  __fastcall SleepTillFalseDelay    (volatile BOOL & CheckStatus, DWORD TheDelay);
BOOL  __fastcall WaitTillFalseDelay     (volatile BOOL & CheckStatus, DWORD TheDelay);
BOOL  __fastcall YieldTillFalseDelay    (volatile BOOL & CheckStatus, DWORD TheDelay);

///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL             SleepForInterLocked   (LONG volatile * RefCheck, DWORD TheDelay);

BOOL             YieldForInterLocked   (LONG volatile * RefCheck, DWORD TheDelay);

///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL      GetPrivateProfileBoolean     (LPCTSTR SectionName, LPCTSTR KeyName, LPCTSTR FileName, BOOL   DefVal);
BOOL      SetPrivateProfileBoolean     (LPCTSTR SectionName, LPCTSTR KeyName, LPCTSTR FileName, BOOL   TheVal);
DWORD     GetPrivateProfileValue       (LPCTSTR SectionName, LPCTSTR KeyName, LPCTSTR FileName, DWORD  DefVal);
BOOL      SetPrivateProfileValue       (LPCTSTR SectionName, LPCTSTR KeyName, LPCTSTR FileName, DWORD  TheVal);
double    GetPrivateProfileDouble      (LPCTSTR SectionName, LPCTSTR KeyName, LPCTSTR FileName, double DefVal);
BOOL      SetPrivateProfileDouble      (LPCTSTR SectionName, LPCTSTR KeyName, LPCTSTR FileName, double TheVal);
///////////////////////////////////////////////////////////////////////////////////////////////////

BOOL      IsValidMemoryPointer         (PVOID   UserPtr);
BOOL      IsValidCodePointer           (FARPROC UserPtr);

#define   VerifyCodePtr(A)             (Not IsValidCodePointer(A))

double    GetDlgItemFloat              (HWND hDlg, WORD ID);
BOOL      SetDlgItemFloat              (HWND hDlg, WORD ID, double theVal);

int       ComboBoxFindString           (HWND hwnd, UINT theBox, LPCTSTR thetext);
int       ListBoxFindString            (HWND hwnd, UINT theBox, LPCTSTR thetext);
int       SelectComboBox               (HWND hwnd, UINT theBox, LPCTSTR thestr);
int       SelectListBox                (HWND hwnd, UINT theBox, LPCTSTR thestr);

WORD      FillListFromTable            (HWND ObjID, WORD Msg, LPSTR TblList );
WORD      FillComboFromRes             (HWND hParent, int ObjID, HINSTANCE hInstance, int ResID );

///////////////////////////////////////////////////////////////////////////////////////////////////
#define RT_DLGINIT  MAKEINTRESOURCE(240)
#define RT_TOOLBAR  MAKEINTRESOURCE(241)
#define WIN16_LB_ADDSTRING  0x0401
#define WIN16_CB_ADDSTRING  0x0403
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL      ApplyDlgInit                 (HWND hParent, HINSTANCE hInstance, int ResID);

BOOL      SaveResToFile                (LPCTSTR FileName, HINSTANCE hInstance, int ResID, LPCTSTR ResType, WORD LanguageID);

BOOL      LoadResToMem                 (PBYTE Buf, DWORD BufSize, HINSTANCE hInstance, int ResID, LPCTSTR ResType, WORD LanguageID);
DWORD     LoadResMem                   (PBYTE & Buf, HINSTANCE hInstance, int ResID, LPCTSTR ResType, WORD LanguageID);
void      FreeResMem                   (PBYTE & Buf);

///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL      WaitTillKeypress             ();


///////////////////////////////////////////////////////////////////////////////////////////////////
// MOUSEDOWN SUPPORT...
///////////////////////////////////////////////////////////////////////////////////////////////////
HWND      InitStillDown                (HWND hobj);
WORD      StillDown                    (MSG  *Msg, HWND hobj);
void      ReleaseStillDown             ();

BOOL      StillMessage                 ();

int       GetScrollerInfo              (HWND hWnd, int ScrollType, SCROLLINFO * ScrollInfo);
///////////////////////////////////////////////////////////////////////////////////////////////////
void      DrawLineSelect               (HDC hDC,   LPPOINT ptSrc1, LPPOINT ptDst2);
void      DrawFrameSelect              (HDC hDC,   LPRECT RectToSelect);
int       MoveFrameCollection          (HWND hWnd, LPRECT RectToProcess[], int RectCount, double ZoomRatio, LPSIZE ImageSize);

int       MoveFrameSelect              (HWND hWnd, LPRECT RectToProcess, double ZoomRatio, LPSIZE ImageSize, void (*UpdateStatusRect)(LPRECT));
int       ResizeFrameSelect            (HWND hWnd, LPRECT RectToProcess, double ZoomRatio, LPSIZE ImageSize, int FromWhatAngle, void (*UpdateStatusRect)(LPRECT));
int       ResizeLineSelect             (HWND hWnd, LPPOINT PointSrc, LPPOINT PointDst, double ZoomRatio, LPSIZE ImageSize, void (*UpdateStatusPoint)(LPPOINT IGPoint));

///////////////////////////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////////////////////////
enum      {CurNoWhere, CurInside, CurTopLeft, CurTopMid, CurTopRight, CurMidLeft, CurMidRight, CurBottomLeft, CurBottomMid, CurBottomRight};

int       GetRectanglePos              (LPPOINT CurrentPoint, LPRECT RectToProcess);
LPCTSTR   GetRectangleMousePos         (LPPOINT CurrentPoint, LPRECT RectToProcess);
///////////////////////////////////////////////////////////////////////////////////////////////////
void      DeleteLog                    (LPCTSTR theFilename);
void      ClearLog                     (LPCTSTR theFilename);
void      CheckLog                     (LPCTSTR theFilename);

int       LogToFile                    (LPCTSTR theFilename, LPCTSTR LogEntry );

void      ViewLog                      (LPCTSTR theFilename);

///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL      WriteToConsole               (LPCTSTR Filename);

#define   DeleteBinaryFile             DeleteLog
#define   ClearBinaryFile              ClearLog

HANDLE    CreateBinaryFile             (LPCTSTR Filename);
HANDLE    OpenBinaryFileAtPosition     (LPCTSTR Filename, DWORD SeekTo);
HANDLE    OpenBinaryFileForReadingAtPosition (LPCTSTR Filename, DWORD SeekTo);

DWORD     ReadBinaryFile               (HANDLE hFile, LPBYTE Data, DWORD SizeData);
DWORD     WriteBinaryFile              (HANDLE hFile, LPBYTE Data, DWORD SizeData);

DWORD     SaveBinaryFile               (LPCTSTR Filename, PBYTE FileData, DWORD LenData );
DWORD     SaveBinaryFileAppend         (LPCTSTR Filename, PBYTE FileData, DWORD LenData );
DWORD     LoadBinaryFileOffset         (LPCTSTR Filename, PBYTE FileData, DWORD LenData, DWORD SeekOffset );
#define LoadBinaryFile(F,D,L) LoadBinaryFileOffset(F, D, L, 0 )

///////////////////////////////////////////////////////////////////////////////////////////////////
// BITMAP SUPPORT...
///////////////////////////////////////////////////////////////////////////////////////////////////
typedef struct {
    DWORD InBytes, InBits, InPixels;
} BMPWIDTHINFO, *LPBMPWIDTHINFO;

typedef struct {
    BITMAPINFOHEADER    bmiHeader;
    RGBQUAD             bmiColors[256];
} BITMAPINFO256, FAR *LPBITMAPINFO256, *PBITMAPINFO256;

typedef struct {
    WORD Hue;
    WORD Luminance;
    WORD Saturation;
} HLSINFO, *LPHLSINFO;

typedef struct tagLOGPALETTE256 {
    WORD          palVersion;
    WORD          palNumEntries;
    PALETTEENTRY  palPalEntry[256];
} LOGPALETTE256, *PLOGPALETTE256, NEAR *NPLOGPALETTE256, FAR *LPLOGPALETTE256;
///////////////////////////////////////////////////////////////////////////////////////////////////
#define GetBGR_RedValue(rgb)     ((BYTE)( (rgb)  >> 16)       & 0xFF)
#define GetBGR_GreenValue(rgb)   ((BYTE)( (rgb)  >>  8)       & 0xFF)
#define GetBGR_BlueValue(rgb)    ((BYTE)( (rgb)       )       & 0xFF)

#define GetRGB_RedValue(rgb)     ((BYTE)( (rgb)       )       & 0xFF)
#define GetRGB_GreenValue(rgb)   ((BYTE)( (rgb)  >>  8)       & 0xFF)
#define GetRGB_BlueValue(rgb)    ((BYTE)( (rgb)  >> 16)       & 0xFF)

#define PALVERSION   0x300
#define IS_WIN30_DIB(DIBHEAD)       ((*(LPDWORD)(DIBHEAD)) == sizeof(BITMAPINFOHEADER))

///////////////////////////////////////////////////////////////////////////////////////////////////
int         CountPalEntriesOnDevice      (HDC hDC);
BOOL        CheckSupportedBitmapFormat   (DWORD BitCount, DWORD ReqCompression);

COLORREF    SwapRendAndBlue              (COLORREF ThePixColor);
WORD        CountBitmapPaletteColors     (LPBITMAPINFOHEADER BmpHead);
WORD        GetPaletteSize               (LPBITMAPINFOHEADER BmpHead);
DWORD       RoundBitmapWidth             (DWORD SrcWidth,DWORD bits, LPBMPWIDTHINFO WidthInfo);
DWORD       GetBitmapWidthInBits         (DWORD SrcWidth,DWORD bits);
DWORD       GetBitmapWidthInPixel        (DWORD SrcWidth,DWORD bits);
DWORD       GetBitmapWidthInBytes        (DWORD SrcWidth,DWORD bits);

DWORD       GetDIBWidth                  (LPBYTE DIBMemPtr);
DWORD       GetDIBHeight                 (LPBYTE DIBMemPtr);
LPBYTE      FindDIBBits                  (LPBYTE DIBMemPtr);

HPALETTE    CreateDIBPalette             (HANDLE hDIB);
HPALETTE    GetSystemPalette             (void);

WORD        GetHalftoneSytemPaletteColors(LPPALETTEENTRY BmpColorTable, int ColorCount);

void        SetPaletteColorEntry         (LPPALETTEENTRY Palette, BYTE Entry, COLORREF ThisColor);
COLORREF    GetPaletteColorEntry         (LPPALETTEENTRY Palette, BYTE Entry );

void        SetPaletteColor              (LPRGBQUAD Palette, BYTE Entry, COLORREF ThisColor);
COLORREF    GetPaletteColor              (LPRGBQUAD Palette, BYTE Entry );

BOOL        SaveRawRGBPalette            (LPCTSTR FileName, LPRGBQUAD Palette, DWORD PaletteCount);


void        SwapRGBQUAD                  (LPRGBQUAD Palette, WORD NumEntry);
void        ShiftRGBQUAD                 (LPRGBQUAD Palette, WORD NumEntry);


void        SetBitmapRes                 (LPBITMAPINFOHEADER BmpHead, DWORD XRes, DWORD YRes);
void        GetBitmapRes                 (LPBITMAPINFOHEADER BmpHead, DWORD* XRes, DWORD* YRes);

PBITMAPINFO InitBitmapInfoStruct         (HBITMAP hBmp);
void        InitBitmapHeader             (LPBITMAPINFOHEADER BmpHead, int Width, int Height, DWORD XRes, DWORD YRes, DWORD bits);
void        InitFileBitmapInfo           (LPBITMAPFILEHEADER FileHead, LPBITMAPINFOHEADER BmpHead);
BOOL        DoFlipBitmap                 (PBYTE iMAGE, DWORD WidthInByte, DWORD NumOfLines);

BOOL        SaveDIB                      (HGLOBAL hDib, LPCTSTR FileName);
BOOL        SaveBitmap                   (LPCTSTR FileName, PBYTE ImageData, PBITMAPINFOHEADER BmpHead);

BOOL        SaveHBitmap                  (LPCTSTR FileName, HDC hDc,   HBITMAP hBitmap);
BOOL        SaveWindowBitmap             (LPCTSTR FileName, HWND hWnd, BOOL WithCaption);

HGLOBAL     LoadBitmapFile               (LPCTSTR FileName);

HGLOBAL     CreateDIB                    (DWORD WidthInPixel, DWORD Height, WORD BitCount);

HANDLE      AllocDIBMemory               (LPBITMAPINFOHEADER BmpHead, HBITMAP hBitmap);
HBITMAP     DIBToBitmap                  (HGLOBAL hDIB, HPALETTE hPal);
HGLOBAL     BitmapToDIB                  (HBITMAP hBitmap, HPALETTE hPal);

HGLOBAL     HBitmapToDIB                 (HDC hDC, HBITMAP hBitmap);

HGLOBAL     ChangeDIBFormat              (HGLOBAL hDIB, WORD BitCount, DWORD ReqCompression);
HGLOBAL     ChangeBitmapFormat           (HBITMAP hBitmap, WORD BitCount, DWORD ReqCompression, HPALETTE hPal);

HBITMAP     CopyDC                       (HDC hDc);
HBITMAP     CopyWindowDC                 (HDC hDc, LPRECT WinRect);

HBITMAP     CopyScreenToBitmap           (LPRECT ParmClipRect);
HGLOBAL     CopyScreenToDIB              (LPRECT ParmClipRect);
HGLOBAL     CopyWindowToDIB              (HWND hWnd, BOOL WithCaption);

///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL      CopyTextToClipboard          (HWND ForWho, LPCTSTR Text, DWORD  Length);

BOOL      CopyHBitmapToClipboard       (HBITMAP hBitmap);
BOOL      CopyBitmapToClipboard        (PBITMAPINFO BitmapInfo, PBYTE ImageBuffer);
HGLOBAL   PasteClipBoard               (UINT RequestedFormat); // CF_DIB, CF_TEXT, CF_METAFILEPICT,CF_SYLK,CF_WAVE
BOOL      CopyRawMemoryToClipboard     (PBYTE RawMemory, long Width, long Height, int BitPerPixel);


HGLOBAL   CopyHandle                   (HGLOBAL hMem);

///////////////////////////////////////////////////////////////////////////////////////////////////
typedef BOOL (CALLBACK* HEAPENUMPROC)       (PHEAPENTRY32,      LPARAM);
typedef BOOL (CALLBACK* THREADENUMPROC)     (PTHREADENTRY32,    LPARAM);
typedef BOOL (CALLBACK* MODULEENUMPROC)     (PMODULEENTRY32,    LPARAM);
typedef BOOL (CALLBACK* PROCESSENUMPROC)    (PPROCESSENTRY32,   LPARAM);

///////////////////////////////////////////////////////////////////////////////////////////////////
void      SetThreadName                (DWORD dwThreadID, LPCSTR szThreadName);
int       IsValidThread                (HANDLE ParmThread);
int       IsRunningThread              (HANDLE ParmThread);

DWORD     FindProcessId                (PCTSTR  ParmProcessName);
BOOL      GetProcessName               (DWORD   ParmProcessId, CString & ProcessName);

BOOL      EnumHeapProcess              (DWORD ParmProcessId, HEAPENUMPROC   CallUpFunc, LPARAM Param);
BOOL      EnumModulesProcess           (DWORD ParmProcessId, MODULEENUMPROC CallUpFunc, LPARAM Param);
BOOL      EnumThreadProcess            (DWORD ParmProcessId, THREADENUMPROC CallUpFunc, LPARAM Param);
BOOL      EnumProcess                  (PROCESSENUMPROC      CallUpFunc,    LPARAM Param);

BOOL      GetJobList                   (HANDLE JobSession, PJOBOBJECT_BASIC_PROCESS_ID_LIST JobList, DWORD BufferSize);
BOOL      SuspendJobList               (HANDLE JobSession);
BOOL      ResumeJobList                (HANDLE JobSession);

BOOL      SuspendProcess               (DWORD  ParmProcessId);
BOOL      SuspendJob                   (HANDLE JobSession);
BOOL      ResumeProcess                (DWORD  ParmProcessId);
BOOL      ResumeJob                    (HANDLE JobSession);


int       GetCurrentUserName           (LPTSTR UserName, DWORD SizeOfUserName);
PSID      GetCurrentUserSid            ();
PSID      GetCurrentOwnerSid           ();


#if USE_TS

typedef BOOL (CALLBACK* WTSPROCESSENUMPROC) (PWTS_PROCESS_INFO, LPARAM);

BOOL      EnumTerminalProcess            (WTSPROCESSENUMPROC   CallUpFunc,    LPARAM Param);
BOOL      IsProcessATsClient             (DWORD ProcessId);
BOOL      WeAreATsClient                 ();

DWORD     GetSessionIdFromUserName       (HANDLE hServer, CString UserName);
DWORD     GetSessionIdFromClientName     (HANDLE hServer, CString ClientName);
DWORD     GetSessionIdFromStationName    (HANDLE hServer, CString StationName);


BOOL      GetSessionUserName             (HANDLE hServer, DWORD SessionId, CString & UserName);
BOOL      GetSessionClientName           (HANDLE hServer, DWORD SessionId, CString & ClientName);
BOOL      GetSessionStationName          (HANDLE hServer, DWORD SessionId, CString & StationName);
BOOL      GetSessionClientState          (HANDLE hServer, DWORD SessionId, volatile long &RqstState);

DWORD     GetCurrentSessionId            ();
BOOL      GetCurrentSessionClientName    (CString & ClientName);
BOOL      GetCurrentSessionWinStationName(CString & StationName);

BOOL      SuspendUserSession             (PDWORD ThreadList, DWORD SizeOfList); // ON RETURN THE LIST OF SUSPENDED
BOOL      ResumeUserSession              (PDWORD ThreadList, DWORD SizeOfList); // RESUME BASED ON A LIST OF SUSPENDED


LONG      LogOffTSUser                   (HANDLE hServer, CString ParmUserName);
LONG      LogOffTSClient                 (HANDLE hServer, CString ParmClientName);
LONG      LogOffTSStation                (HANDLE hServer, CString ParmStationName);
LONG      LogOffOrpheanTSStation         (HANDLE hServer);


///////////////////////////////////////////////////////////////////////////////////////////////////
#endif// #if USE_TS
///////////////////////////////////////////////////////////////////////////////////////////////////


BOOL      TerminateApplication         (DWORD ParmProcessId, HANDLE ForceEvent, DWORD TimeLimit, PCTSTR OptionnalInfo);

DWORD     CountAppWindows              ();

BOOL      IsProcessStalled             (DWORD ProcessID); // IS PROCESS RESPONDING
BOOL      IsWindowStalled              (HWND       hWnd); //
BOOL      FindMainWindowProcess        (DWORD ParmProcessId, HWND * FoundHwnd);


BOOL      IsAppStartedVisible          ();

BOOL      IsDir                        (CString Filename);
BOOL      IsPathFormatted              (CString Filename);
BOOL      AskPathFormatted             (HWND hwnd,CString &SelPath,LPCTSTR AskText);
BOOL      GetExtension                 (CString &Filename);
void      RemoveExtension              (CString &Filename);
BOOL      ExtractFileName              (CString &Filename);
BOOL      ExtractPathName              (CString &Filename);

BOOL      GetModulePath                (HMODULE Module, CString &ModulePath);

BOOL      IsFolderEmpty                (LPCTSTR FolderPath);
BOOL      RemoveFolder                 (LPCTSTR PathToStart, LPCTSTR FolderPath);

BOOL      DirExist                     (LPCTSTR FileName);
BOOL      IsValidDirName               (LPCTSTR DirName);

DWORD     TheFileSize                  (LPCTSTR FileName);
BOOL      GetFileCreationTime          (LPCTSTR FileName, SYSTEMTIME* FileStamp);
BOOL      GetFileLastAccessTime        (LPCTSTR FileName, SYSTEMTIME* FileStamp);
BOOL      GetFileLastWriteTime         (LPCTSTR FileName, SYSTEMTIME* FileStamp);






HRESULT   CreateShortCut               (LPCTSTR ThisTargetSourcePathObj, LPCTSTR ThisShortCutPathLink, LPCTSTR ThisLinkDesc);
HRESULT   CreateInternetShortCut       (LPCTSTR ThisTargetSourcePathObj, LPCTSTR ThisShortCutPathLink, LPCTSTR ThisLinkDesc);
HRESULT   ResolveShortCut              (HWND hWnd, LPCTSTR ThisShortCutPathLink);
HRESULT   GetShortCutTarget            (HWND hWnd, LPCTSTR ThisShortCutPathLink, LPTSTR ThisTarget);

BOOL      DCMoveFile                   (LPCTSTR lpExistingFileName, LPCTSTR lpNewFileName);
BOOL      DeleteFiles                  (LPCTSTR FilePath, LPCTSTR FileMask);

BOOL      FileExist                    (LPCTSTR FileName);
BOOL      IsValidFileName              (LPCTSTR FileName);

BOOL      GetVersionByHandle           (HMODULE Module, LPTSTR ReturnInfo, int ReturnLen );
BOOL      GetVersionByName             (LPTSTR FullModulePath, LPTSTR ReturnInfo, int ReturnLen );

BOOL      OpenVersionInfoByHandle      (HMODULE Module, PTCHAR *VerBuffer, int *VerLen );
BOOL      OpenVersionInfo              (PTCHAR FullModulePath,  PTCHAR *VerBuffer, int *VerLen);
BOOL      CloseVersionInfo             (PTCHAR VerBuffer, int VerLen);

BOOL      RunApplication               (LPCTSTR Program, LPCTSTR CommandLine);
BOOL      RunInstaller                 (LPCTSTR ProgramFile, LPCTSTR CommandLine, BOOL WaitMode, PDWORD ExitCode);// IN PROGRAMFILE JUST THE FILENAME NO PATH IT WILL FIND IT!

BOOL      RunHiddenApplication         (PROCESS_INFORMATION *UserProcessInfo, LPCTSTR UserPath, LPCTSTR Program, LPCTSTR CommandLine);
BOOL      RunApplicationAsUser         (PROCESS_INFORMATION *UserProcessInfo, HANDLE UserToken, LPCTSTR UserPath, LPCTSTR Program, LPCTSTR CommandLine);

BOOL      RunProcess                   (PROCESS_INFORMATION *UserProcessInfo, LPCTSTR Program, LPCTSTR CommandLine);

BOOL      RunSubProcess                (LPCTSTR UserPath, LPCTSTR Program, LPCTSTR CommandLine, DWORD Timeout);

long      CountCurrentProccess         ();
long      CountProccess                (CString BaseName);

DWORD     GetValue                     (LPCTSTR  String);
long      HexVal                       (LPCTSTR  string);
BOOL      IsValidHandle                (HANDLE  hObject);
BOOL      ShareHandle                  (HANDLE ProcessHandle, HANDLE TargetProcessHandle, HANDLE &SharedHandle);
HANDLE    ShareObject                  (HANDLE ParmHandle, HANDLE ExtProcess);

BOOL      IsNullString                 (LPCTSTR  string);

DWORD     GetPhysFreeMemory            ();
DWORD     GetFreeMemory                ();
DWORD     GetUseableMemory             ();
void      GetDesktopSize               (LPSIZE DeskArea);

BOOL      IsRunningOnWinNT             (void);
BOOL      AllowFullAccessToObject      (HANDLE Handle);
BOOL      AllowFullAccessToFilename    (LPCTSTR TheFilename);


BOOL      IsAdminMode                  ();
BOOL      IsRemoteSession              (void);

FARPROC   WINAPI InterceptImportedFunction      ( IN LPTSTR    HModuleName,    IN LPTSTR    FunctionName, IN FARPROC   NewFunction, OUT FARPROC* CallerSlotAddress );
FARPROC*  WINAPI SearchNReplaceImportedFunction ( IN HMODULE   FunctionModule, IN FARPROC   FunctionPtr,  IN FARPROC   NewFunction);
FARPROC*  WINAPI SearchForImportedFunction      ( IN HMODULE   FunctionModule, IN FARPROC   FunctionPtr);

void      ReleaseWSASupport            ();
BOOL      InitWSASupport               ();

BOOL      ConnectToInternet            (HWND hWnd);
void      RunInetConnectionPanel       (HWND hParent);
void      RunInetInternetControlPanel  (HWND hParent);


void      PressKey                     (BYTE theVKey);
void      ReleaseKey                   (BYTE theVKey);
void      SendKeyText                  (CString theText);
void      EditPaste                    (HWND hWindow);

///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
class CShellFileTypes
{
public:
    CShellFileTypes                         ()
    {
        m_CurrentWin                      = 0;
        m_hMainWnd                        = 0;
        m_AtomApp                         = 0;
        m_AtomSystemTopic                 = 0;

        m_PreviousWndProc                 = NULL;
    }
    ~CShellFileTypes                        ()
    {
    }

    CWnd *                                  m_CurrentWin;
    HWND                                    m_hMainWnd;
    ATOM                                    m_AtomApp;
    ATOM                                    m_AtomSystemTopic;

    WNDPROC                                 m_PreviousWndProc;

    BOOL    EnableShellCommand              (CWnd * CurrentWin);
    BOOL    ProcessShellCommand             ();

    BOOL    ReleaseAtom                     ();
    BOOL    ExecuteDDECommand               (LPCTSTR Command);


    LRESULT OnShellDDEInitiate              (WPARAM wParam, LPARAM lParam);
    LRESULT OnShellDDEExecute               (WPARAM wParam, LPARAM lParam);
    LRESULT OnShellDDETerminate             (WPARAM wParam, LPARAM lParam);

    // OVERLOADING:
    virtual BOOL OnOpenAppFile              (LPCTSTR CmdLine);
    virtual BOOL OnUnregisterShellFileTypes ();
};
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL      RegisterShellFileType        (CString ParmFileTypeId, CString ParmFileTypeName, CString ParmFilterExt, int ParmIconID);
BOOL      UnregisterShellFileType      (CString ParmFileTypeId, CString ParmFilterExt);

BOOL      WriteRegisterKey             (LPCTSTR Key, LPCTSTR Value, LPCTSTR ValueName = NULL);
BOOL      RemoveRegisterKey            (LPCTSTR Key);
void      GetModuleShortFileName       (HINSTANCE hInst, CString& ShortName);
///////////////////////////////////////////////////////////////////////////////////////////////////

BOOL      EnableBallonTips               (BOOL Enable);


///////////////////////////////////////////////////////////////////////////////////////////////////
} // extern "C" {
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
#endif // __AFX_H__


// ALWAYS ACCESSIBLE TOOLS...
///////////////////////////////////////////////////////////////////////////////////////////////////
extern "C" {
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef __oleacc_h__
///////////////////////////////////////////////////////////////////////////////////////////////////

UINT GetUIElementName            (IAccessible* pacc, VARIANT* pvarChild, LPTSTR lpszName,  UINT cchName);
UINT GetUIElementRole            (IAccessible* pacc, VARIANT* pvarChild, LPTSTR lpszRole,  UINT cchRole,  DWORD* dwRole);
UINT GetUIElementState           (IAccessible* pacc, VARIANT* pvarChild, LPTSTR lpszState, UINT cchState, DWORD* dwState);
UINT GetWindowClassForUIElement  (IAccessible* pacc, LPTSTR lpszClass, UINT cchClass);

BOOL FindChild (IAccessible* paccParent, LPCTSTR szName, DWORD dwRole, LPCTSTR szClass, IAccessible** ppaccChild, VARIANT* pvarChild);
///////////////////////////////////////////////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////


void      LogSystemEvent               (LPCTSTR ServiceName, LPCTSTR pFormat, ...);
BOOL      CmdStartService              (LPTSTR ServiceName);
BOOL      CmdStopService               (LPTSTR ServiceName);

///////////////////////////////////////////////////////////////////////////////////////////////////
} // extern "C" {
///////////////////////////////////////////////////////////////////////////////////////////////////

#endif // __DCTOOLSIMPLEMENT__
///////////////////////////////////////////////////////////////////////////////////////////////////
