// DeviceHandle.cpp
///////////////////////////////////////////////////////////////////////////////////////////////////
#include "StdAfx.h"

///////////////////////////////////////////////////////////////////////////////////////////////////
// EXTERNAL MEMBER
LONG        FrameError;
LONG        RcvError;
LONG        ImageError;

CRect       CurFocusRect;
ULONG       CurFocusWindId;
ULONG       CurFocusObjectId;
ULONG       CurFocusChildId;
ULONG       CurFocusLimit;
CString     CurFocusText;
///////////////////////////////////////////////////////////////////////////////////////////////////
// PRIVATE ONLY
///////////////////////////////////////////////////////////////////////////////////////////////////
BYTE        CommandCode          = 0xE0;
BOOL        UseParity            = TRUE;
BOOL        EnableUnpackAndDraw  = TRUE;
BOOL        EnableStatusBar      = FALSE;

DWORD       TempBufferSize       = IMAGETEMP_BUFFERSIZE;
BYTE        TempBuffer            [IMAGETEMP_BUFFERSIZE + 4];
BYTE        UncompressTempBuffer  [IMAGETEMP_BUFFERSIZE + 4];
BYTE        TempImageBuffer       [IMAGETEMP_BUFFERSIZE + 4];
BYTE        TempPaletteBuffer     [2 * KB];

BYTE        CurrentMenuData       [MAXMENUTEMPLATE + 2];

#if USE_PAINTDRAW
PPdaMenuTemplate    CurrentMenuTemplate  = (PPdaMenuTemplate)CurrentMenuData;
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////
CString     PDAUserID     ("DenisCo");     // THE SPACE IS THERE INTENTIONNALLY FOR THE LEN
CString     PDAUserPsw    ("Terminator");  // THE SPACE IS THERE INTENTIONNALLY FOR THE LEN

CString     PDASerialNo   ("PD12345678");  // THE SPACE IS THERE INTENTIONNALLY FOR THE LEN
CString     PDABrandName  ("INetPad");     // THE SPACE IS THERE INTENTIONNALLY FOR THE LEN
CString     PDAModelName  ("Emulator");    // THE SPACE IS THERE INTENTIONNALLY FOR THE LEN
CString     PDAEncryptKey ("");            // THE SPACE IS THERE INTENTIONNALLY FOR THE LEN


CString     PDAIMEIKey    ; // ("");            // THE SPACE IS THERE INTENTIONNALLY FOR THE LEN
CString     PDAIMSIKey    ; // ("");            // THE SPACE IS THERE INTENTIONNALLY FOR THE LEN
CString     PDACCIDKey    ; // ("");            // THE SPACE IS THERE INTENTIONNALLY FOR THE LEN
CString     PDASimTelKey  ; // ("");            // THE SPACE IS THERE INTENTIONNALLY FOR THE LEN

WORD        FirmwareVersion       = 0x0700;

BYTE        PDAIntegrationLevel   = 0;

DWORD       RequireCompressMethod = 0;
DWORD       RequireColorMode      = 0;
BOOL        EnabledRequireCompressMethod = FALSE;
BOOL        EnabledRequireColorMode      = FALSE;

DWORD       PlayTable  [256];
BOOL        InPlayBackMode               = FALSE;
BOOL        PlayNextStep                 = FALSE;
BOOL        PlayTillNextPage             = FALSE;

DCTimeout   TestTimer;

CString     PDAGpsPosition  = _T("45.503285 -73.566355");   // : MONTREAL OFFICE

CCriticalSection    CriticalGpsAccess;                      //

///////////////////////////////////////////////////////////////////////////////////////////////////
extern "C" {
///////////////////////////////////////////////////////////////////////////////////////////////////
#if 0
///////////////////////////////////////////////////////////////////////////////////////////////////
BYTE   AckQueue          [256];
BYTE   AckStart        = 0;
BYTE   AckEnd          = 0;
///////////////////////////////////////////////////////////////////////////////////////////////////
void EmptyAckQueue () // IN SEND THREAD ONLY NOT MADE FOR READ THREAD
{
    // THE READ THREAD SHOULD BE CLOSE BEFORE THIS OPERATION IT IS ASSUMED
    AckStart  = AckEnd;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL PushAckQueue (BYTE FrameID)// IN READ THREAD
{
    long TimeOutCount = 200; // MAX = 1 second.
    while( AckEnd == (BYTE)(AckStart -1)){
       Sleep(5);
       if(TimeOutCount-- < 0){
          // should say time out on debug view
	      // get out of here it is hang!
	      EchoError ("Receiving thread hanging more than 1 secs because buffer is full");
	      return FALSE;
       }
    }
    AckQueue[AckEnd] = FrameID;
    AckEnd++;
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL PopAckQueue (BYTE &FrameID) // IN SEND THREAD
{
    if(AckEnd  != (AckStart)){
       FrameID  = AckQueue[AckStart++];
 	   return TRUE;
	}
    return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
#endif
// NewAck
///////////////////////////////////////////////////////////////////////////////////////////////////
CCriticalSection         CriticalQueueAccess;
///////////////////////////////////////////////////////////////////////////////////////////////////
BYTE   AckQueue          [256];
BYTE   AckSeqQueue       [256];
BYTE   AckFrmQueue       [256];
BYTE   AckPhaseQueue     [256];
BYTE   AckStateQueue     [256];
BYTE   AckStart          = 0;
BYTE   AckEnd            = 0;
///////////////////////////////////////////////////////////////////////////////////////////////////
void EmptyAckQueue () // IN SEND THREAD ONLY NOT MADE FOR READ THREAD
{
CSingleLock AccessSingleLock(&CriticalQueueAccess);

    if(AccessSingleLock.Lock()){
       // THE READ THREAD SHOULD BE CLOSE BEFORE THIS OPERATION IT IS ASSUMED
       AckStart  = AckEnd   = 0;
       ZeroMemory(AckQueue,      sizeof(AckQueue));
       ZeroMemory(AckSeqQueue,   sizeof(AckSeqQueue));
       ZeroMemory(AckFrmQueue,   sizeof(AckFrmQueue));
       ZeroMemory(AckPhaseQueue, sizeof(AckPhaseQueue));
       ZeroMemory(AckStateQueue, sizeof(AckStateQueue));

       AccessSingleLock.Unlock();
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL PushNackQueue (BYTE AckType, BYTE SeqID, BYTE FrameID, BYTE CurrentPhase,  BYTE Reason)// IN READ THREAD
{
ACKSTATUS   NAckReason = (ACKSTATUS)Reason;
long        TimeOutCount = 200; // MAX = 1 second.

CSingleLock AccessSingleLock(&CriticalQueueAccess);

    if(AccessSingleLock.Lock()){
/*
       while( AckEnd == (BYTE)(AckStart -1)){
          Sleep(5);
          if(TimeOutCount-- < 0){
             // should say time out on debug view
	         // get out of here it is hang!
	         EchoError (_T("Receiving thread hanging more than 1 secs because buffer is full"));
	         return FALSE;
          }
       }
*/
       AckQueue      [AckEnd] = AckType;
       AckFrmQueue   [AckEnd] = FrameID;
       AckSeqQueue   [AckEnd] = SeqID;
       AckPhaseQueue [AckEnd] = CurrentPhase;
       AckStateQueue [AckEnd] = NAckReason; // FAILLURE
       AckEnd++;

       AccessSingleLock.Unlock();
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL PushAckQueue (BYTE AckType, BYTE SeqID, BYTE FrameID, BYTE CurrentPhase)// IN READ THREAD
{
CSingleLock AccessSingleLock(&CriticalQueueAccess);

    if((Palm.InitSequenceComplete        != FALSE)
    || (Not WaitForConnect)
    ){
       if(Not EnableAckPacket){
           return TRUE;
       }
    }

    if(AccessSingleLock.Lock()){
/*
       long TimeOutCount = 200; // MAX = 1 second.
       while( AckEnd == (BYTE)(AckStart -1)){
          Sleep(5);
          if(TimeOutCount-- < 0){
             // should say time out on debug view
	         // get out of here it is hang!
	         EchoError (_T("Receiving thread hanging more than 1 secs because buffer is full"));
	         return FALSE;
          }
       }
*/
       AckQueue      [AckEnd] = AckType;
       AckFrmQueue   [AckEnd] = FrameID;
       AckSeqQueue   [AckEnd] = SeqID;
       AckPhaseQueue [AckEnd] = CurrentPhase;
       AckStateQueue [AckEnd] = ACK_FRAME_SUCCESSFULL; // SUCCESSFULL
       AckEnd++;
       AccessSingleLock.Unlock();
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL PopAckQueue (BYTE &AckType, BYTE &SeqID, BYTE &FrameID, BYTE &CurrentPhase, BYTE &CurrentState) // IN SEND THREAD
{
BOOL        bRet        = FALSE;
CSingleLock AccessSingleLock(&CriticalQueueAccess);

    if(AccessSingleLock.Lock()){
       if(AckEnd       != (AckStart)){
          AckType       =             AckQueue      [AckStart];
          SeqID         =             AckSeqQueue   [AckStart];
          FrameID       =             AckFrmQueue   [AckStart];
          CurrentPhase  =             AckPhaseQueue [AckStart];
          CurrentState  = (ACKSTATUS) AckStateQueue [AckStart];
          AckStart++;
 	      bRet          =  TRUE;
	   }
       AccessSingleLock.Unlock();
    }
    return bRet;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL PushFrameAckQueue (BYTE SeqID, BYTE FrameID, BYTE CurrentPhase)// IN READ THREAD
{
    return PushAckQueue (0xd0, SeqID, FrameID, CurrentPhase);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL PushFrameNackQueue (BYTE SeqID, BYTE FrameID, BYTE CurrentPhase,  BYTE Reason)// IN READ THREAD
{
    return PushNackQueue (0xd0, SeqID, FrameID, CurrentPhase, Reason);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
// ScrollAck
///////////////////////////////////////////////////////////////////////////////////////////////////
BYTE   ScrollAckQueue          [256];
BYTE   ScrollAckStart        = 0;
BYTE   ScrollAckEnd          = 0;
///////////////////////////////////////////////////////////////////////////////////////////////////
void EmptyScrollAckQueue () // IN SEND THREAD ONLY NOT MADE FOR READ THREAD
{
CSingleLock AccessSingleLock(&CriticalQueueAccess);

    if(AccessSingleLock.Lock()){
       // THE READ THREAD SHOULD BE CLOSE BEFORE THIS OPERATION IT IS ASSUMED
       ScrollAckStart  = ScrollAckEnd = 0;
       ZeroMemory(ScrollAckQueue, sizeof(ScrollAckQueue));

       AccessSingleLock.Unlock();
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL PushScrollAckQueue (BYTE ScrollID)// IN READ THREAD
{
    return PushAckQueue (0xA0, ScrollID, FRAMEUNKNW, 0);

#if 0
CSingleLock AccessSingleLock(&CriticalQueueAccess);

    if(AccessSingleLock.Lock()){
/*
       long TimeOutCount = 200; // MAX = 1 second.
       while( ScrollAckEnd == (BYTE)(ScrollAckStart -1)){
          Sleep(5);
          if(TimeOutCount-- < 0){
             // should say time out on debug view
	         // get out of here it is hang!
	         EchoError (_T("Receiving thread hanging more than 1 secs because buffer is full"));
	         return FALSE;
          }
       }
*/
       ScrollAckQueue      [ScrollAckEnd] = ScrollID;
       ScrollAckEnd++;
       AccessSingleLock.Unlock();
    }
    return TRUE;
#endif
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL PopScrollAckQueue (BYTE &ScrollID) // IN SEND THREAD
{
BOOL        bRet        = FALSE;
CSingleLock AccessSingleLock(&CriticalQueueAccess);

    if(AccessSingleLock.Lock()){
       if(ScrollAckEnd != (ScrollAckStart)){
          ScrollID      = ScrollAckQueue      [ScrollAckStart];
          ScrollAckStart++;
 	      bRet = TRUE;
	   }
       AccessSingleLock.Unlock();
    }
    return bRet;
}
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
// Construction/Destruction
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL GetFocusInfo(long FrameID, PFOCUSINFO FocusInfo, int ExtraLen)
{
DWORD  TotalData;

    if(Not RecvData ((PBYTE)&FocusInfo->X, ExtraLen)){
       RcvError++;
       return FALSE;
    }
    //EchoFrame(FrameID, FocusInfo->X, FocusInfo->Y, FocusInfo->W, FocusInfo->H, FocusInfo->SumData);
    // IF RETURN = FALSE THEN IT IS FRAME ERROR!!!
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL GetFrameInfo(long FrameID, PFRAMEINFO FrameInfo, int ExtraLen)
{
DWORD  TotalData;

    if(Not RecvData ((PBYTE)&FrameInfo->X, ExtraLen)){
       RcvError++;
       return FALSE;
    }
    //EchoFrame(FrameID, FrameInfo->X, FrameInfo->Y, FrameInfo->W, FrameInfo->H, FrameInfo->SumData);
    // IF RETURN = FALSE THEN IT IS FRAME ERROR!!!
    if(FrameInfo->X < 0){
       FrameError++;
       return FALSE;
    } else if(FrameInfo->X  > Palm.VirtualScreenWidth){
       FrameError++;
       return FALSE;
    } else if(FrameInfo->W > (Palm.VirtualScreenWidth - FrameInfo->X)){
       FrameError++;
       return FALSE;
    }

    if(FrameInfo->Y < 0){
       FrameError++;
       return FALSE;
    } else if(FrameInfo->Y > (Palm.MemoryScreenHeight)){
       FrameError++;
       return FALSE;
    } else if(FrameInfo->H > ((Palm.MemoryScreenHeight) - FrameInfo->Y)){
       FrameError++;
       return FALSE;
    }
    TotalData = FrameInfo->W * FrameInfo->H;
    if((TotalData == 0)){
       FrameError++;
       return FALSE;
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL GetColorFrameInfo(long FrameID, PCOLORFRAMEINFO ColorFrameInfo, int ExtraLen)
{
DWORD  TotalData;

    if(Not RecvData ((PBYTE)&ColorFrameInfo->X, ExtraLen)){
       RcvError++;
       return FALSE;
    }
    //EchoFrame(FrameID, ColorFrameInfo->X, ColorFrameInfo->Y, ColorFrameInfo->W, ColorFrameInfo->H, ColorFrameInfo->SumData);
    // IF RETURN = FALSE THEN IT IS FRAME ERROR!!!
    if(ColorFrameInfo->X < 0){
       FrameError++;
       return FALSE;
    } else if(ColorFrameInfo->X  > Palm.VirtualScreenWidth){
       FrameError++;
       return FALSE;
    } else if(ColorFrameInfo->W > (Palm.VirtualScreenWidth - ColorFrameInfo->X)){
       FrameError++;
       return FALSE;
    }

    if(ColorFrameInfo->Y < 0){
       FrameError++;
       return FALSE;
    } else if(ColorFrameInfo->Y > (Palm.MemoryScreenHeight)){
       FrameError++;
       return FALSE;
    } else if(ColorFrameInfo->H > ((Palm.MemoryScreenHeight) - ColorFrameInfo->Y)){
       FrameError++;
       return FALSE;
    }
    TotalData = ColorFrameInfo->W * ColorFrameInfo->H;
    if((TotalData == 0)){
       FrameError++;
       return FALSE;
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL GetScrollDelta (CPoint &Delta, LPRECT DestRect, LPPOINT ScrPoint)
{
BOOL    bRet       = FALSE;

    Delta.x        = DestRect->left - ScrPoint->x;
    Delta.y        = DestRect->top  - ScrPoint->y;

    if(Delta.x    != 0){
       bRet = TRUE;
    }
    if(Delta.y    != 0) {
       bRet = TRUE;
    }
    return bRet;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL GetScrollRefreshRect (CRect &RefreshRect, LPRECT DestRect, LPPOINT ScrPoint)
{
CPoint  Delta;
BOOL    bRet       = TRUE;

    RefreshRect    = *DestRect;

    if(GetScrollDelta (Delta, DestRect, ScrPoint) == FALSE){
       return FALSE;
    }
    if(Delta.x            < 0){
       RefreshRect.left   = RefreshRect.right;
       RefreshRect.right  = RefreshRect.right   + abs(Delta.x);
    } else if(Delta.x     > 0){
       RefreshRect.left   = ScrPoint->x;
       RefreshRect.right  = ScrPoint->x         + abs(Delta.x);
    }
    if(Delta.y            < 0){
       RefreshRect.top    = RefreshRect.bottom;
       RefreshRect.bottom = RefreshRect.bottom  + abs(Delta.y);
    } else if(Delta.y     > 0){
       RefreshRect.top    = ScrPoint->y;
       RefreshRect.bottom = ScrPoint->y         + abs(Delta.y);
    }
    return bRet;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL HandleScrollCommand (BYTE CommandBuffer[8])
{
SERVERSCROLLINFO  ServerScrollInfo;
DESTSCROLLINFO    DestScrollInfo;
CRect             RefreshRect;
WORD              NewX, NewY, X, Y, W, H;
RECT              DestRect;
POINT             ScrPoint;
BYTE              ScrollID;

    EchoTask(CommandBuffer);

    ServerScrollInfo = *(SERVERSCROLLINFO*)CommandBuffer;

    if(Not RecvData((PBYTE)&DestScrollInfo, sizeof(DestScrollInfo))){
       RcvError++;
       EchoRcvError(-2, RcvError);
       return FALSE;
    }

    X        = ServerScrollInfo.XSrc;
    Y        = ServerScrollInfo.YSrc;

    NewX     = DestScrollInfo.XDst;
    NewY     = DestScrollInfo.YDst;

    W        = DestScrollInfo.WDst;
    H        = DestScrollInfo.HDst;

    ScrollID = ServerScrollInfo.ScrollID;

    EchoScroll( ScrollID,  NewX,  NewY,  X,  Y,  W,  H);

    // SECURITY SINCE OUR ROUTINE DOES NOT SUPPORT LINE 0
    // LOOK IN : CopyRoughMonoLine FOR WARNING COMMENT.
    PushScrollAckQueue(ScrollID);

    if((NewY       == 0) || (Y       == 0)){
       NewY       += 1;
       Y          += 1;
       H          -= 1;
    }
    if(W          > Palm.VirtualScreenWidth){
       EchoError(_T("Scroll failed: Width overflow"));
       return TRUE;
    }
    if(H          > Palm.VirtualScreenHeight){
       EchoError(_T("Scroll failed: Height overflow"));
       return TRUE;
    }
    if((X + W)    > Palm.VirtualScreenWidth){
       EchoError(_T("Scroll failed: X + W overflow"));
       return TRUE;
    }
    if((Y + H)    > Palm.VirtualScreenHeight){
       EchoError(_T("Scroll failed: Y + H overflow"));
       return TRUE;
    }

    if((NewX + W) > Palm.VirtualScreenWidth){
       EchoError(_T("Scroll failed: NewX + W overflow"));
       return TRUE;
    }
    if((NewY + H) > Palm.VirtualScreenHeight){
       EchoError(_T("Scroll failed: NewY + H overflow"));
       return TRUE;
    }

    MemRectCopyData   (NewX, NewY, X, Y, W, H);

    ScrPoint.x      = X;
    ScrPoint.y      = Y;

    DestRect.left   = NewX;
    DestRect.right  = DestRect.left  + W;
    DestRect.top    = NewY;
    DestRect.bottom = DestRect.top   + H;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    if(GetScrollRefreshRect (RefreshRect, &DestRect, &ScrPoint)){
/*     // DC SINCE IT WILL BE HANDLE BY SERVER...
       RefreshRect.left    = RefreshRect.left   & ~7;      // BEFORE WIDTH() CALC.
       ClearRectData (RefreshRect.left,    RefreshRect.top,
                      RefreshRect.Width(), RefreshRect.Height(), 1);
*/
       RefreshIPalm   ();
    } else {
       EchoError(_T("Scroll GetScrollRefreshRect failed "));;
    }
    ///////////////////////////////////////////////////////////////////////////////////////////////
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  HandleScreenCommand (BYTE CommandBuffer[8])
{
FRAMEINFO   FrameInfo;
BYTE        SeqID;
BYTE        FrameID   = 0;
BYTE        FillLow;
BYTE        FillHigh;
int         Compression, FillMode, CurrentPhase, StepLine, InitialPhase;
BOOL        IsTransparent   = FALSE;
WORD        DataCount;
BYTE        XorParity  = 0;
BYTE        HostParity = 0;
BYTE        ExtraLen   = 0;
DWORD       FrameTimeIn, FrameTimeOut, InputSize, SumData, PacketSize;
CString     Info;
PBYTE       SrcBuffer  = NULL;

    ZeroMemory     (&FrameInfo, sizeof(FrameInfo));
    FrameID      = (CommandBuffer[3]);
    SeqID        = (CommandBuffer[2]);

    // HostParity   = (CommandBuffer[3]); // IT HAS BEEN MOVE TO THE END OF DATA WHEN REQUESTED

    FillMode       = (CommandBuffer[4]  & 1);
    CurrentPhase   = (CommandBuffer[4]  & 0x0E) >> 1; // BIN MASK 1110 >> 1
  	StepLine       = ((CommandBuffer[4] & 0x70) / 16) + 1;
    InitialPhase   = ((CommandBuffer[4] & 0x80) != 0);
	Compression    = ((CommandBuffer[5] & 0x7F));
    IsTransparent  = ((CommandBuffer[5] & 0x80));
	ExtraLen       = ((CommandBuffer[6]));

    EchoTask(CommandBuffer);

    if((Not GetFrameInfo(FrameID, &FrameInfo, ExtraLen))
    && ((FillMode & 1) == 0)
    ){
       EchoFrameError     (SeqID, FrameID, FrameInfo.X, FrameInfo.Y, FrameInfo.W, FrameInfo.H, FrameInfo.SumData);
       PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_FRAME);
       return FALSE;
    }
    InputSize    = FrameInfo.SumData - 1; // - 1 NEW XORFEATURE

    if(InputSize >= TempBufferSize) {
       FrameError++;
       EchoFrameError     (SeqID, FrameID, FrameInfo.X, FrameInfo.Y, FrameInfo.W, FrameInfo.H, FrameInfo.SumData);
       PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_IMAGESIZE);
       return FALSE;
    }
	if(FillMode & 1){
       RecvData (&FillLow, 1);
       RecvData (&FillHigh, 1);

       if(FrameID == FRAMECLEAR){
          Palm.ResetReceivedFrameCounter();
       }
       if(FrameID == FRAMERESYNC){
          EchoSync(SeqID, FrameID);
          PushFrameAckQueue (SeqID, FrameID, CurrentPhase);
       } else
       if((FrameInfo.W != 0) && (FrameInfo.H != 0)){
          //FillRectData(FrameInfo.X, FrameInfo.Y, FrameInfo.W, FrameInfo.H, FillLow, FillHigh);
          ClearRectData(FrameInfo.X, FrameInfo.Y, FrameInfo.W, FrameInfo.H, StepLine);
          EchoFill(SeqID, FrameID, FrameInfo.X, FrameInfo.Y, FrameInfo.W, FrameInfo.H, MAKEWORD(FillLow, FillHigh));
          PushFrameAckQueue (SeqID, FrameID, CurrentPhase);
          RefreshIPalm ();
       } else {
          EchoFrameError     (SeqID, FrameID, FrameInfo.X, FrameInfo.Y, FrameInfo.W, FrameInfo.H, FrameInfo.SumData);
          PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_IMAGESIZE);
       }
    } else {

       EchoFrame(SeqID, FrameID, FrameInfo.X, FrameInfo.Y, FrameInfo.W, FrameInfo.H, FrameInfo.SumData);

       FrameTimeIn = GetTickCount();
       if(Not RecvData(TempBuffer, FrameInfo.SumData)){
          RcvError++;
          EchoError(_T("Receive Error data missing"));
          PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_RECEIVE);
          return FALSE;
       }
       FrameTimeOut = GetTickCount();
       Info.Format(_T("Time to received: %d"), abs(FrameTimeOut - FrameTimeIn));
       //EchoText(Info);

       XorParity     = GetXorParity  ((LPCSTR)TempBuffer, InputSize);
       HostParity    = (TempBuffer[InputSize]);
       if(XorParity != HostParity){
          EchoError(_T("Parity Error in image data "));
          if(UseParity){
             PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_PARITY);
             return FALSE;
          }
       }

       if(EnableUnpackAndDraw == FALSE){
          PushFrameAckQueue (SeqID, FrameID, CurrentPhase);// BEFORE
          return TRUE;
       }
       DataCount = (32 + (FrameInfo.H * (FrameInfo.W / 8)));
       PacketSize = FrameInfo.H * (FrameInfo.W / 8 );

       if(DataCount <= TempBufferSize){

	      switch(Compression){
#if USE_NCOMPRESS
          case PD_COMPRESS_N3:

               if(Not N3Uncompress(UncompressTempBuffer, DataCount, TempBuffer, InputSize)){
    	          ImageError++;
                  EchoImageError(-3, InputSize);
                  PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_COMPRESSION);
                  return FALSE;
		       }
               SrcBuffer = &UncompressTempBuffer[0];
               break;

          case PD_COMPRESS_N4:

               if(Not N4Uncompress(UncompressTempBuffer, DataCount, FrameInfo.W, FrameInfo.H, TempBuffer, InputSize)){
    	          ImageError++;
                  EchoImageError(-3, InputSize);
                  PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_COMPRESSION);
                  return FALSE;
		       }
               SrcBuffer = &UncompressTempBuffer[0];
               break;
#endif
#if USE_GCOMPRESS
          case PD_COMPRESS_G4:

               if(Not G4Uncompress(UncompressTempBuffer, DataCount, FrameInfo.W, FrameInfo.H, TempBuffer, InputSize)){
    	          ImageError++;
                  EchoImageError(-3, InputSize);
                  PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_COMPRESSION);
                  return FALSE;
		       }
               SrcBuffer = &UncompressTempBuffer[0];
               break;

          case PD_COMPRESS_G3:

               if(Not G3Uncompress(UncompressTempBuffer, DataCount, TempBuffer, InputSize)){
    	          ImageError++;
                  EchoImageError(-3, InputSize);
                  PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_COMPRESSION);
                  return FALSE;
		       }
               SrcBuffer = &UncompressTempBuffer[0];
               break;
#endif
          case PD_COMPRESS_ZIP:
               if(Not ZUncompress(UncompressTempBuffer, DataCount, TempBuffer, InputSize)){
    	          ImageError++;
                  EchoImageError(-3, InputSize);
                  PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_COMPRESSION);
                  return FALSE;
		       }
               SrcBuffer = &UncompressTempBuffer[0];
               break;

          case PD_COMPRESS_NONE:
               if(((FrameInfo.H * (FrameInfo.W / 8)) / StepLine) > InputSize){
                  ImageError++;
                  EchoImageError(0, InputSize);
                  PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_IMAGESIZE);
                  return FALSE;
               }
               SrcBuffer = &TempBuffer[0];
               break;

          default:
    	       ImageError++;
               EchoImageError(-3, InputSize);
               PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_COMPRESSION);
               return FALSE;
          }

          if (( FrameID >= FRAMEKEYBD - 10 ) && ( FrameID < FRAMEKEYBD )) {   // not a keyboard table
             PaintRectData(FrameInfo.X, FrameInfo.Y, FrameInfo.W / 8, FrameInfo.H, SrcBuffer, StepLine, InitialPhase);
          } else {
             SumData = ConvertMonoImageToColor  ( TempImageBuffer, SrcBuffer, PacketSize);
             PaintRectData(FrameInfo.X, FrameInfo.Y, FrameInfo.W, FrameInfo.H, TempImageBuffer, StepLine, InitialPhase);
          }

          PushFrameAckQueue (SeqID, FrameID, CurrentPhase);// AFTER
          RefreshIPalm ();
       } else {
          ImageError++;
          EchoError(_T("Insufisant temporary buffer."));
          EchoImageError(0, InputSize);
          PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_BUFFER);
       }
    }
	return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall SendFocusText (DWORD WId, DWORD OId, DWORD CId, LPCTSTR FocusText)
{DLL_THREAD_MANAGEMENT();

FOCUSINFO      FocusInfo;
WORD           ExtraLen      = 0;
WORD           ThisStrLen    = SizeFromTCharLen(StringLen(FocusText, 4096) + 1);
CString        Info;
BOOL           Ret           = FALSE;

    FillMemory       (&FocusInfo, sizeof(FOCUSINFO), 0x00);

    FocusInfo.Command        = CommandCode;
    FocusInfo.SubCommand     = 'f';
    FocusInfo.Bitfields      = 0;

    FocusInfo.ExtraLen       = 20 + ThisStrLen;
    FocusInfo.Terminator     = 0x1a;

    FocusInfo.WinId          = WId;
    FocusInfo.ObjectId       = OId;
    FocusInfo.ChildId        = CId;
    FocusInfo.StringLen      = ThisStrLen;
    StringCopy                 (FocusInfo.String, FocusText, ThisStrLen);

    Ret = WriteChannelBuffer((LPCSTR)&FocusInfo, 8 + FocusInfo.ExtraLen);
	if(Not Ret){
       EchoSendError(_T("Focus Event! failled to send"));
	   return FALSE;
	}
    return TRUE;
}
LPCTSTR __stdcall GetCurrentFocusText           (long * WId, long * OId, long * CId, long * Restricted)
{DLL_THREAD_MANAGEMENT();

    *WId        = CurFocusWindId;
    *OId        = CurFocusObjectId;
    *CId        = CurFocusChildId;
    *Restricted = CurFocusLimit;
    return CurFocusText;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL HandleFocusRectCommand (BYTE CommandBuffer[8])
{
FOCUSINFO      FocusInfo;
BYTE           FrameID         = 0;
WORD           ExtraLen        = 0;
CString        Info;
BOOL           Overloaded      = FALSE;

    EchoTask(CommandBuffer);
    FillMemory       (&FocusInfo, sizeof(FOCUSINFO), 0x00);
    CopyMemory       (&FocusInfo, CommandBuffer, 8);

    Overloaded               = FocusInfo.Bitfields & 1;
    ExtraLen                 = FocusInfo.ExtraLen;

	if((Not GetFocusInfo(FrameID, &FocusInfo, ExtraLen))
    ){
       // EchoFrameError(SeqID, FrameID, FocusInfo.X, FocusInfo.Y, FocusInfo.W, FocusInfo.H, FocusInfo.WinId);
       return FALSE;
    }
    if((CurFocusWindId      != FocusInfo.WinId)
    || (CurFocusObjectId    != FocusInfo.ObjectId)
    || (CurFocusChildId     != FocusInfo.ChildId)
    || (CurFocusRect.left   != FocusInfo.X)
    || (CurFocusRect.top    != FocusInfo.Y)
    || (CurFocusRect.right  != FocusInfo.X + FocusInfo.W)
    || (CurFocusRect.bottom != FocusInfo.Y + FocusInfo.H)
    || (CurFocusText        != FocusInfo.String)
    ){
       CurFocusWindId        = FocusInfo.WinId;
       CurFocusObjectId      = FocusInfo.ObjectId;
       CurFocusChildId       = FocusInfo.ChildId;
       CurFocusLimit         = FocusInfo.Bitfields;
       CurFocusText          = FocusInfo.String;
       CurFocusRect.left     = FocusInfo.X;
       CurFocusRect.top      = FocusInfo.Y;
       CurFocusRect.right    = FocusInfo.X + FocusInfo.W;
       CurFocusRect.bottom   = FocusInfo.Y + FocusInfo.H;
#if USE_EVENTFIRE
       FireOnNewFocus          (CurFocusWindId, CurFocusObjectId, CurFocusChildId, CurFocusLimit);
#endif
       RefreshIPalm();
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL HandleColorImageCommand (BYTE CommandBuffer[8]) {

COLORFRAMEINFO ColorFrameInfo;
BYTE           SeqID;
BYTE           FrameID;
BYTE           FillLow;
BYTE           FillHigh;
int            Compression,      FillMode, CurrentPhase, StepLine, DataCount, InitialPhase;
BYTE           XorParity       = 0;
BYTE           HostParity      = 0;
BYTE           ExtraLen        = 0;
DWORD          FrameTimeIn,      FrameTimeOut, InputSize, SourceImageSize, SumData;
PBYTE          SrcBuffer       = NULL;
BYTE           CacheAction     = 0;
DWORD          CacheFrame      = 0, CacheImage = 0;
BOOL           IsTransparent   = FALSE;
CString        Info;

    ZeroMemory       (&ColorFrameInfo, sizeof(ColorFrameInfo));
    FrameID        = (CommandBuffer[3]);
    SeqID          = (CommandBuffer[2]);
    FillMode       = (CommandBuffer[4]  & 1);
    CurrentPhase   = (CommandBuffer[4]  & 0x0E) >> 1; // BIN MASK 1110 >> 1
  	StepLine       = ((CommandBuffer[4] & 0x70) / 16) + 1;
    InitialPhase   = ((CommandBuffer[4] & 0x80) != 0);
	Compression    = ((CommandBuffer[5] & 0x7F));
    IsTransparent  = ((CommandBuffer[5] & 0x80));
    ExtraLen       = ((CommandBuffer[6]));

    EchoTask(CommandBuffer);
    if(FrameID    == FRAMEMENU){
       EchoText(_T("Receiving Color Menu..."));
    }
	if((Not GetColorFrameInfo(FrameID, &ColorFrameInfo, ExtraLen))
    && ((FillMode & 1) == 0)
    ){
       EchoFrameError     (SeqID, FrameID, ColorFrameInfo.X, ColorFrameInfo.Y, ColorFrameInfo.W, ColorFrameInfo.H, ColorFrameInfo.SumData);
       PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_FRAME);
       return FALSE;
    }
    ////////////////////////////////////////////////////////////////////////////////////
    //    Cache processing RETREIVING
    ////////////////////////////////////////////////////////////////////////////////////

    if((UseCacheMemory) && (ColorFrameInfo.Features & 1)){

       CacheAction       = ColorFrameInfo.CacheAction;

       if(CacheAction   == 'R'){        // RETRIEVE FRAME FROM CACHE

          CacheFrame     = ColorFrameInfo.MemAddress;
          CacheImage     = (CacheFrame + sizeof(ColorFrameInfo));

          CopyMemory(&ColorFrameInfo, &PDACache[CacheFrame], sizeof(ColorFrameInfo));
          if((ColorFrameInfo.Command[0] != 0xE0) || (ColorFrameInfo.Command[7] != 0x1A)){
             // NOT A FRAME INFO
             Info.Format(_T("???? Failed to retrieve from Cache: FrameID = %d"), FrameID);
             EchoText(Info);
             PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_CACHEFAILED);
             return FALSE;
          }
          InputSize    =  ColorFrameInfo.SumData - 1; // - 1 NEW XORFEATURE
          CopyMemory(&TempBuffer[0], &PDACache[CacheImage], ColorFrameInfo.SumData);

          EchoFrame(SeqID, FrameID, ColorFrameInfo.X, ColorFrameInfo.Y, ColorFrameInfo.W, ColorFrameInfo.H, ColorFrameInfo.SumData);

          Info.Format(_T("Retrieved from Cache: FrameID = %d"), ColorFrameInfo.Command[3]);
          EchoText(Info);
          goto DataReceived;
       }
    }
    ////////////////////////////////////////////////////////////////////////////////////

    InputSize     =  ColorFrameInfo.SumData - 1; // - 1 NEW XORFEATURE
    if(InputSize >= TempBufferSize) {
       FrameError++;
       EchoFrameError     (SeqID, FrameID, ColorFrameInfo.X, ColorFrameInfo.Y, ColorFrameInfo.W, ColorFrameInfo.H, ColorFrameInfo.SumData);
       PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_IMAGESIZE);
       return FALSE;
    }
	if (FillMode & 1){
       RecvData (&FillLow, 1);
       RecvData (&FillHigh, 1);

       if(FrameID == FRAMECLEAR){
          Palm.ResetReceivedFrameCounter();
       }
       if(FrameID == FRAMERESYNC){
          EchoSync(SeqID, FrameID);
          PushFrameAckQueue (SeqID, FrameID, CurrentPhase);
       } else
       if((ColorFrameInfo.W != 0) && (ColorFrameInfo.H != 0)){
          //FillRectData(ColorFrameInfo.X, ColorFrameInfo.Y, ColorFrameInfo.W, ColorFrameInfo.H, FillLow, FillHigh);
          ClearRectData(ColorFrameInfo.X, ColorFrameInfo.Y, ColorFrameInfo.W, ColorFrameInfo.H, StepLine);
          EchoFill(SeqID, FrameID, ColorFrameInfo.X, ColorFrameInfo.Y, ColorFrameInfo.W, ColorFrameInfo.H, MAKEWORD(FillLow, FillHigh));
          PushFrameAckQueue (SeqID, FrameID, CurrentPhase);
          RefreshIPalm ();

       } else {
          EchoFrameError     (SeqID, FrameID, ColorFrameInfo.X, ColorFrameInfo.Y, ColorFrameInfo.W, ColorFrameInfo.H, ColorFrameInfo.SumData);
          PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_IMAGESIZE);
       }
    } else {

       EchoFrame(SeqID, FrameID, ColorFrameInfo.X, ColorFrameInfo.Y, ColorFrameInfo.W, ColorFrameInfo.H, ColorFrameInfo.SumData);

       FrameTimeIn = GetTickCount();
       if(Not RecvData(TempBuffer, ColorFrameInfo.SumData)){
          RcvError++;
          EchoError(_T("???? Receive Error: data missing"));
          PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_RECEIVE);
          return FALSE;
       }
       FrameTimeOut = GetTickCount();
       Info.Format(_T("Time to received: %d"), abs(FrameTimeOut - FrameTimeIn));
       //EchoText(Info);

       ////////////////////////////////////////////////////////////////////////////////////
       DataReceived:
       ////////////////////////////////////////////////////////////////////////////////////

       XorParity     = GetXorParity  ((LPCSTR)TempBuffer, InputSize);
       HostParity    = (TempBuffer[InputSize]);
       if(XorParity != HostParity){
          EchoError(_T("???? Parity Error in image data "));
          if(UseParity){
             PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_PARITY);
             return FALSE;
          }
       }
       ////////////////////////////////////////////////////////////////////////////////////
       //    Cache processing STORING
       ////////////////////////////////////////////////////////////////////////////////////
       if((UseCacheMemory) && (ColorFrameInfo.Features & 1)){
          if(CacheAction == 'S'){  // Store data to Cache

             CacheFrame  = ColorFrameInfo.MemAddress;
             CacheImage  = (CacheFrame + sizeof(ColorFrameInfo));

             CopyMemory (&ColorFrameInfo.Command[0], &CommandBuffer[0], 8);
             CopyMemory (&PDACache[CacheFrame],      &ColorFrameInfo,   sizeof(ColorFrameInfo));
             CopyMemory (&PDACache[CacheImage],      &TempBuffer[0],    ColorFrameInfo.SumData);

             Info.Format(_T("Stored to Cache: FrameID = %d"), FrameID);
             EchoText(Info);
          }
       }
       ////////////////////////////////////////////////////////////////////////////////////
       if(EnableUnpackAndDraw == FALSE){
          PushFrameAckQueue (SeqID, FrameID, CurrentPhase);// BEFORE
          return TRUE;
       }
       DataCount       = (32 + (ColorFrameInfo.H * ColorFrameInfo.W ));

       if(DataCount   <= TempBufferSize) {

          InitUnZipFrame(ColorFrameInfo.X, ColorFrameInfo.Y, ColorFrameInfo.W, ColorFrameInfo.H, ColorFrameInfo.BitPerPixel, IsTransparent,
          InputSize, StepLine, InitialPhase, Palm.ScreenPointer, TempBuffer);

	      switch(Compression){
#if USE_JCOMPRESS
          case PD_COMPRESS_JPEG:
               if(JUncompressFrame (ColorFrameInfo.X, ColorFrameInfo.Y, ColorFrameInfo.W, ColorFrameInfo.H, ColorFrameInfo.BitPerPixel,
                                    InputSize, StepLine, InitialPhase, Palm.ScreenPointer, TempBuffer)
               ){
                 goto AckUnpackCode;
               } else {
    	          ImageError++;
                  EchoImageError(-3, InputSize);
                  PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_COMPRESSION);
                  return FALSE;
               }
               break;
#endif
          case PD_COMPRESS_ZIP:

               if(UnzipImageFrame () == Z_OK)
               {
                 goto AckUnpackCode;
               } else {
    	          ImageError++;
                  EchoImageError(-3, InputSize);
                  PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_COMPRESSION);
                  return FALSE;
               }
               break;

          case PD_COMPRESS_NONE:
               if(PaintUnCompresedFrame () == Z_OK)
               {
                 goto AckUnpackCode;
               } else {
    	          ImageError++;
                  EchoImageError(-3, InputSize);
                  PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_UNSUPPORTED);
                  return FALSE;
               }
               break;

          default:
               ImageError++;
               EchoError(_T("This compression is not supported in ColorImage command."));
               PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_UNSUPPORTED);
               return FALSE;
          }
          //PaintRectData(ColorFrameInfo.X, ColorFrameInfo.Y, ColorFrameInfo.W, ColorFrameInfo.H, SrcBuffer, StepLine, InitialPhase);

AckUnpackCode:
          Palm.RecvedFrameCounter[FrameID]++;
          PushFrameAckQueue (SeqID, FrameID, CurrentPhase);// AFTER
          RefreshIPalm ();
       } else {
          ImageError++;
          EchoError(_T("Insufficient temporary buffer size."));
          EchoImageError(0, InputSize);
          PushFrameNackQueue (SeqID, FrameID, CurrentPhase, NACK_ERROR_BUFFER);
       }
    }
	return TRUE;
}
#if 1
///////////////////////////////////////////////////////////////////////////////////////////////////
// TEMPORARY BUFFERING UNTIL SUPPORT FROM JPEG ITSELF...
///////////////////////////////////////////////////////////////////////////////////////////////////
BYTE           MultiPacketCumulator                [(2 * MB)];
DWORD          MultiPacketCumulatorSize;
BYTE           MultiHostParity;
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL StoreInPacketCumulator (PBYTE TempBuffer, DWORD InputSize)
{
    if((InputSize + MultiPacketCumulatorSize) > sizeof(MultiPacketCumulator)){
       MultiPacketCumulatorSize += InputSize;
       return FALSE;
    }
    CopyMemory(&MultiPacketCumulator[MultiPacketCumulatorSize], TempBuffer, InputSize);
    MultiPacketCumulatorSize += InputSize;
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL ClearPacketCumulator ()
{
    if(MultiPacketCumulatorSize){
       ZeroMemory(MultiPacketCumulator, MultiPacketCumulatorSize);
    }
    MultiPacketCumulatorSize = 0;
    MultiHostParity          = 0;
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL ProcessMultiPackImage (PCOLORFRAMEINFO ColorFrameInfo, BYTE SeqID,  BOOL NeedAck)
{
BYTE  PacketID, ImageIndX, XorParity      = 0; // NOT USED HERE BUT COULD BE!
BOOL  IsTransparent, IsLastPacket;
DWORD InputSize;
int   DataCount    = 0, Compression;

    if(ColorFrameInfo == NULL){
       return FALSE;
    }
    ImageIndX      = ((ColorFrameInfo->Command[3]));             //((CommandBuffer[3]));
    PacketID       = ((ColorFrameInfo->Command[4] & 0x7F));      //((CommandBuffer[4] & 0x7F));
    IsLastPacket   = ((ColorFrameInfo->Command[4] & 0x80) != 0); //((CommandBuffer[4] & 0x80) != 0);
	Compression    = ((ColorFrameInfo->Command[5] & 0x7F));      //((CommandBuffer[5] & 0x7F));
    IsTransparent  = ((ColorFrameInfo->Command[5] & 0x80) != 0); //((CommandBuffer[5] & 0x80) != 0);

    InputSize     =  ColorFrameInfo->SumData;
    DataCount       = (32 + (ColorFrameInfo->H * ColorFrameInfo->W));

    if(PacketID    == 0){
       if(ClearPacketCumulator()) {
          if(NeedAck){
             PushFrameAckQueue (SeqID, ImageIndX, 0); // AFTER
          }
          RefreshIPalm ();
          return TRUE;
       }
    }
    if(PacketID    == 1){
       ClearPacketCumulator ();
    }
    if(StoreInPacketCumulator(TempBuffer, InputSize) == FALSE){
       ImageError++;
       EchoImageError(-2, MultiPacketCumulatorSize);
       if(NeedAck){
          PushFrameNackQueue (SeqID, ImageIndX, 0, NACK_ERROR_COMPRESSION);
       }
       return FALSE;
    }
    if(IsLastPacket == FALSE){
       if(NeedAck){
          PushFrameAckQueue (SeqID, ImageIndX, 0); // AFTER
       }
       RefreshIPalm ();
       return TRUE;
    }
/*
    XorParity     = GetXorParity  ((LPCSTR)TempBuffer, InputSize);
    HostParity    = (TempBuffer[InputSize]);
    if(XorParity != HostParity){
       EchoError(_T("Parity Error in image data "));
       if(UseParity){
          PushFrameNackQueue (SeqID, ImageIndX, 0, NACK_ERROR_PARITY);
          return FALSE;
       }
    }
*/
    ///////////////////////////////////////////////////////////////////////////////////////////////
    // PROCEED FROM BUFFER ONLY
    ///////////////////////////////////////////////////////////////////////////////////////////////
    if(DataCount   <= TempBufferSize) {

       InitUnZipFrame(ColorFrameInfo->X, ColorFrameInfo->Y, ColorFrameInfo->W, ColorFrameInfo->H, ColorFrameInfo->BitPerPixel, IsTransparent,
                      MultiPacketCumulatorSize, 1, 0, Palm.ScreenPointer, MultiPacketCumulator);

	   switch(Compression){
#if USE_JCOMPRESS
       case PD_COMPRESS_JPEG:
/*
            if(JUncompressPacket (ColorFrameInfo->X, ColorFrameInfo->Y, ColorFrameInfo->W, ColorFrameInfo->H, ColorFrameInfo->BitPerPixel,
                                 MultiPacketCumulatorSize, ImageIndX, PacketField, Palm.ScreenPointer, MultiPacketCumulator)
*/

            if(JUncompressFrame (ColorFrameInfo->X, ColorFrameInfo->Y, ColorFrameInfo->W, ColorFrameInfo->H, ColorFrameInfo->BitPerPixel,
                                 MultiPacketCumulatorSize, 1, 0, Palm.ScreenPointer, MultiPacketCumulator)
            ){
              goto AckUnpackCode;
            } else {
    	       ImageError++;
               EchoImageError(-3, MultiPacketCumulatorSize);
               if(NeedAck){
                  PushFrameNackQueue (SeqID, ImageIndX, 0, NACK_ERROR_COMPRESSION);
               }
               return FALSE;
            }
            break;
#endif
       case PD_COMPRESS_ZIP: // WE'LL HAVE TO SUPPORT MULTIPLE PACKET!

            if(UnzipImageFrame () == Z_OK)
            {
              goto AckUnpackCode;
            } else {
    	       ImageError++;
               EchoImageError(-3, MultiPacketCumulatorSize);
               if(NeedAck){
                  PushFrameNackQueue (SeqID, ImageIndX, 0, NACK_ERROR_COMPRESSION);
               }
               return FALSE;
            }
            break;

       case PD_COMPRESS_NONE: // WE'LL HAVE TO SUPPORT MULTIPLE PACKET!
            if(PaintUnCompresedFrame () == Z_OK)
            {
              goto AckUnpackCode;
            } else {
    	       ImageError++;
               EchoImageError(-3, MultiPacketCumulatorSize);
               if(NeedAck){
                  PushFrameNackQueue (SeqID, ImageIndX, 0, NACK_ERROR_UNSUPPORTED);
               }
               return FALSE;
            }
            break;

       default:
            ImageError++;
            EchoError(_T("This compression is not supported in ColorImage command."));
            if(NeedAck){
               PushFrameNackQueue (SeqID, ImageIndX, 0, NACK_ERROR_UNSUPPORTED);
            }
            return FALSE;
       }
       //PaintRectData(ColorFrameInfo->X, ColorFrameInfo->Y, ColorFrameInfo->W, ColorFrameInfo->H, SrcBuffer, 1, 0);

AckUnpackCode:
       if(NeedAck){
          PushFrameAckQueue (SeqID, ImageIndX, 0);// AFTER
       }
       RefreshIPalm ();
    } else {
       ImageError++;
       EchoError(_T("Insufficient temporary buffer size."));
       EchoImageError(0, MultiPacketCumulatorSize);
       if(NeedAck){
          PushFrameNackQueue (SeqID, ImageIndX, 0, NACK_ERROR_BUFFER);
       }
    }
	return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL HandleMultiPackColorImageCommand (BYTE CommandBuffer[8])
{
COLORFRAMEINFO ColorFrameInfo;
BYTE           SeqID;
BYTE           ImageIndX;
BOOL           bRet = FALSE;
BYTE           ExtraLen;

BYTE           CacheAction     = 0;
DWORD          CacheFrame      = 0, CacheImage = 0;
BYTE           XorParity       = 0; // NOT USED HERE BUT COULD BE!
DWORD          FrameTimeIn,      FrameTimeOut, InputSize;
CString        Info;

    ZeroMemory       (&ColorFrameInfo, sizeof(ColorFrameInfo));

    SeqID          = ((CommandBuffer[2]));
    ImageIndX      = ((CommandBuffer[3]));
    ExtraLen       = ((CommandBuffer[6]));

    EchoTask(CommandBuffer);

    ///////////////////////////////////////////////////////////////////////////////////////////////
	if(Not GetColorFrameInfo(ImageIndX, &ColorFrameInfo, ExtraLen)){
       EchoFrameError     (SeqID, ImageIndX, ColorFrameInfo.X, ColorFrameInfo.Y, ColorFrameInfo.W, ColorFrameInfo.H, ColorFrameInfo.SumData);
       PushFrameNackQueue (SeqID, ImageIndX, 0, NACK_ERROR_FRAME);
       return FALSE;
    }
    CopyMemory(&ColorFrameInfo.Command[0], &CommandBuffer[0], 8);
    ///////////////////////////////////////////////////////////////////////////////////////////////
    //    Cache processing RETREIVING
    ///////////////////////////////////////////////////////////////////////////////////////////////
    if((UseCacheMemory) && (ColorFrameInfo.Features & 1)){

       CacheAction       = ColorFrameInfo.CacheAction;

       if(CacheAction   == 'R'){        // RETRIEVE FRAME FROM CACHE

          CacheFrame     = ColorFrameInfo.MemAddress;
          CacheImage     = (CacheFrame + sizeof(ColorFrameInfo));

          CopyMemory(&ColorFrameInfo, &PDACache[CacheFrame], sizeof(ColorFrameInfo));
          if((ColorFrameInfo.Command[0] != 0xE0) || (ColorFrameInfo.Command[7] != 0x1A)){
             // NOT A FRAME INFO
             Info.Format(_T("???? Failed to retrieve from Cache: ImageIndX = %d"), ImageIndX);
             EchoText(Info);
             PushFrameNackQueue (SeqID, ImageIndX, 0, NACK_ERROR_CACHEFAILED);
             return FALSE;
          }
          InputSize    =  ColorFrameInfo.SumData; // DC NOT  - 1 NEW XORFEATURE
          CopyMemory(&TempBuffer[0], &PDACache[CacheImage], ColorFrameInfo.SumData);

          EchoFrame(SeqID, ImageIndX, ColorFrameInfo.X, ColorFrameInfo.Y, ColorFrameInfo.W, ColorFrameInfo.H, ColorFrameInfo.SumData);
          Info.Format(_T("Retrieved from Cache: ImageIndX = %d"), ImageIndX);
          EchoText(Info);
          goto DataReceived;
       }
    }
    ///////////////////////////////////////////////////////////////////////////////////////////////

    InputSize     =  ColorFrameInfo.SumData; // DC NOT - 1 FOR NEW XORFEATURE
    if(InputSize >= TempBufferSize) {
       FrameError++;
       EchoFrameError     (SeqID, ImageIndX, ColorFrameInfo.X, ColorFrameInfo.Y, ColorFrameInfo.W, ColorFrameInfo.H, ColorFrameInfo.SumData);
       PushFrameNackQueue (SeqID, ImageIndX, 0, NACK_ERROR_IMAGESIZE);
       return FALSE;
    }
    EchoFrame(SeqID, ImageIndX, ColorFrameInfo.X, ColorFrameInfo.Y, ColorFrameInfo.W, ColorFrameInfo.H, ColorFrameInfo.SumData);

    FrameTimeIn = GetTickCount();
    if(Not RecvData(TempBuffer, ColorFrameInfo.SumData)){
       RcvError++;
       EchoError(_T("???? Receive Error: data missing"));
       PushFrameNackQueue (SeqID, ImageIndX, 0, NACK_ERROR_RECEIVE);
       return FALSE;
    }
    FrameTimeOut = GetTickCount();
    Info.Format(_T("Time to received: %d"), abs(FrameTimeOut - FrameTimeIn));
    //EchoText(Info);

    ///////////////////////////////////////////////////////////////////////////////////////////////
    DataReceived:
    ///////////////////////////////////////////////////////////////////////////////////////////////
    // SINCE WE USE TCP/IP WHICH GUARANTY DELIVERY INTEGRITTY XOR IS BEING DROP..
    // WE WILL HAVE TO SUPPORT XOR IN MULTIPLE PACKET...

    // XorParity     = GetXorParity  ((LPCSTR)TempBuffer, InputSize);

    ///////////////////////////////////////////////////////////////////////////////////////////////
    //    Cache processing STORING
    ///////////////////////////////////////////////////////////////////////////////////////////////
    if((UseCacheMemory) && (ColorFrameInfo.Features & 1)){
       if(CacheAction == 'S'){  // Store data to Cache

          CacheFrame  = ColorFrameInfo.MemAddress;
          CacheImage  = (CacheFrame + sizeof(ColorFrameInfo));

          CopyMemory (&ColorFrameInfo.Command[0], &CommandBuffer[0], 8);
          CopyMemory (&PDACache[CacheFrame],      &ColorFrameInfo,   sizeof(ColorFrameInfo));
          CopyMemory (&PDACache[CacheImage],      &TempBuffer[0],    ColorFrameInfo.SumData);

          Info.Format(_T("Stored to Cache: ImageIndX = %d"), ImageIndX);
          EchoText(Info);
       }
    }
    ///////////////////////////////////////////////////////////////////////////////////////////////
    if(EnableUnpackAndDraw == FALSE){
       PushFrameAckQueue (SeqID, ImageIndX, 0); // BEFORE
       return TRUE;
    }
    //DataCount       = (32 + (ColorFrameInfo.H * ColorFrameInfo.W ));

    ///////////////////////////////////////////////////////////////////////////////////////////////
    // THIS IS THE PART WHERE WE DECIDE TO STORE AND/OR RETREIVE AND/OR PROCESS THE BUFFER
    ///////////////////////////////////////////////////////////////////////////////////////////////
    bRet = ProcessMultiPackImage(&ColorFrameInfo, SeqID, TRUE);
    if(Not bRet){
       EchoError(_T("Failed to Process MultiPack Image!"));
    }
    return bRet;
}
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL HandlePaletteCommand (BYTE CommandBuffer[8])
{
PALETTEINFO PaletteInfo;
DWORD       BufferLength, CompressedSize, PaletteBufLen = 2048;
WORD        NumOfColors,  Bits;
BYTE        UncompPalBuffer       [2 * KB];
BYTE        SeqID, FrameID, Action;

    PaletteInfo    = *(PALETTEINFO*) CommandBuffer;

    SeqID          = PaletteInfo.SequenceID;
    FrameID        = PaletteInfo.FrameID;
    Action         = PaletteInfo.Action;

    EchoText (_T(" Received Palette! "));
    EchoPalette(SeqID, FrameID, Action);

    BufferLength = PaletteInfo.ExtraLen;

    ZeroMemory(TempPaletteBuffer, sizeof(TempPaletteBuffer));

    if(Not RecvData( (PBYTE)TempPaletteBuffer, BufferLength)){
	    RcvError++;
        EchoError (_T("Error in reading a command"));
	    return FALSE;
    }
    Bits = TempPaletteBuffer[4];
    switch (Bits){
    case 1:  NumOfColors = 2;   break;
    case 3:  NumOfColors = 8;   break;
    case 4:  NumOfColors = 16;  break;
    case 8:  NumOfColors = 256; break;
    }
    if (TempPaletteBuffer[0]     == 'C') {                // color palette block

        if (TempPaletteBuffer[3] == 'Z') {

            CompressedSize        = TempPaletteBuffer[2];
            CompressedSize      <<= 8;
            CompressedSize       += TempPaletteBuffer[1];
            CompressedSize       -= 6;                    // 6 bytes beside data in palette block

            if(Not (ZUncompress (UncompPalBuffer, PaletteBufLen, &TempPaletteBuffer[5], CompressedSize))) {
               PushFrameNackQueue (SeqID, FrameID, 1, NACK_ERROR_COMPRESSION);
               return FALSE;
            }
            UpdateRGBQuad     (UncompPalBuffer, NumOfColors);
        } else if (TempPaletteBuffer[3] == PD_COMPRESS_NONE) {
            UpdateRGBQuad     (&TempPaletteBuffer[5], NumOfColors);
        } else {
           ImageError++;
           EchoError(_T("This compression is not supported in Palette command."));
           PushFrameNackQueue (SeqID, FrameID, 1, NACK_ERROR_UNSUPPORTED);
           return FALSE;
        }
    }
    PushFrameAckQueue (PaletteInfo.SequenceID, PaletteInfo.FrameID, 1);
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL HandleStringCommand (BYTE CommandBuffer[8])
{
long        DstX, DstY, ThisStrLen, Looper;
BYTE        theLSB, theMSB, theByte;
//CString     StringOut;
LPSTR       StringOut = NULL;

    ThisStrLen = CommandBuffer[6];
    //StringOut = _T("");

    EchoTask(CommandBuffer);
    if(Not RecvData(TempBuffer, ThisStrLen)){
       RcvError++;
       EchoRcvError(-2, RcvError);
       return FALSE;
    }

    StringOut = new char[ThisStrLen];
    if(StringOut){

       theLSB = CommandBuffer[2];
       theMSB = CommandBuffer[3];
       DstX   = (long)(theLSB) + ((long)(theMSB) * 256);
       theLSB = CommandBuffer[4];
       theMSB = CommandBuffer[5];
       DstY   = (long)(theLSB) + ((long)(theMSB) * 256);

       if (DstY > (Palm.MemoryScreenHeight)) {
          DstY = DstY - (Palm.MemoryScreenHeight);
       }
       for( Looper = 0; Looper < ThisStrLen; Looper++){
          theByte = TempBuffer[Looper];
          if (theByte == 0) {
             ThisStrLen = Looper;
             break;
          }
//          StringOut += (theByte);
          StringOut [Looper] = theByte;
       }
       DisplayString(DstX, DstY, StringOut, ThisStrLen);
       delete [] StringOut;

       return TRUE;
    } else {
       EchoError(_T("Failed to allocate memory in Handle String Command()!"));;
       return FALSE;
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL HandleReRouteCommand (BYTE CommandBuffer[8])
{
CString       Info,            TempString;
REROUTEINFO   ReRouteHeader;
char          RouteBuffer      [2048];
DWORD         RouteLooper    = 0;
LPSTR         BlockString;
WORD          BlockLen;
int           Locate;

    EchoTask(CommandBuffer);
    ReRouteHeader            = *(REROUTEINFO*)       CommandBuffer;

    ZeroMemory(RouteBuffer,                          sizeof(RouteBuffer));

    if((ReRouteHeader.Len)  && (ReRouteHeader.Len <= sizeof(RouteBuffer))){

       if(Not RecvData ((PBYTE)RouteBuffer, ReRouteHeader.Len)){
          RcvError++;
          EchoRcvError(-2, RcvError);
          return FALSE;
       }
       ///////////////////////////////////////////////////////////////////
       while( RouteLooper < ReRouteHeader.Len){

          BlockLen    = RouteBuffer  [RouteLooper + 1];
          BlockString = &RouteBuffer [RouteLooper + 2];
          ////////////////////////////////////////////////////////////////
          switch(RouteBuffer[RouteLooper]){
          case 'R': // ROUTE STRING...
               TempString         = BlockString;
               EchoText((LPCTSTR)   TempString);
               if((Locate         = TempString.Find(_T(":"))) > 0 ){
                  SetPortName       (TempString.Left(Locate));
                  SetPortSetting    (TempString.Mid(Locate    + 1));
               } else {
                  SetPortName       (TempString);
               }
               break;
          case 0:
               BlockLen = 1; // ASSUME PADDING OF ZERO... THAT SHOULD NEVER HAPPEND ...
               break;
          }
          RouteLooper += BlockLen;
       }
       return TRUE;
    }
    return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL HandleInitCommand (BYTE CommandBuffer[8])
{
CString       Info,
              TempUserID,    TempPswd,
              TempSerialID,  TempBrandName, TempModel, TempEncryptKey,
              TempDialNumber;
LPSTR         BlockString;
char          InitBuffer     [4096];
DWORD         InitLooper   = 0;
WORD          BlockLen;
INITINFO      InitInfo;
CACHEINFO     CacheInfo;
BYTE          XorParity, XorCheck;

    EchoTask(CommandBuffer);
    InitInfo            = *(INITINFO*) CommandBuffer;
    ZeroMemory(InitBuffer, sizeof(InitBuffer));

    if((InitInfo.Len) && (InitInfo.Len <= sizeof(InitBuffer))){

       if(Not RecvData ((PBYTE)InitBuffer, InitInfo.Len)){
          RcvError++;
          EchoRcvError(-2, RcvError);
          return FALSE;
       }
       InitLooper = 0;
       ///////////////////////////////////////////////////////////////////

       while( InitLooper < InitInfo.Len){

          BlockLen    = InitBuffer  [InitLooper + 1];
          BlockString = &InitBuffer [InitLooper + 2];
          ////////////////////////////////////////////////////////////////
          // SWITCH ON INIT SUBBLOCK USE THE SECOND BYTE AS A LEN OF BLOCK
          // IF THE BLOCK IS RECOGNIZED PROCESS IT
          // UNLESS THE VALUE IS ZERO WHICH IT IS ASSUME TO BE PADDING JUST IGNORE THE BYTE.
          // OTHERWISE JUST SKIP IT...
          switch(InitBuffer[InitLooper]){
          case 'U': // USERID
               XorParity    = *BlockString ++;
               XorCheck     = GetXorParity  (BlockString, AStringLen(BlockString, (BlockLen - 2)));
               if(XorCheck != XorParity){
                  EchoError(_T("Xor parity Faillure In USERID string from Server"));;
               }
               TempUserID                 = BlockString;
               SetPdaUserName              (TempUserID);
               break;
          case 'P': // PASSWORD
               XorParity    = *BlockString ++;
               XorCheck     = GetXorParity  (BlockString, AStringLen(BlockString, (BlockLen - 2)));
               if(XorCheck != XorParity){
                  EchoError(_T("Xor parity Faillure In PASSWORD string from Server"));;
               }
               TempPswd                   = BlockString;
               SetPdaPassword              (TempPswd);
               break;
          case 'S': // SERIAL ID
               XorParity    = *BlockString ++;
               XorCheck     = GetXorParity  (BlockString, AStringLen(BlockString, (BlockLen - 2)));
               if(XorCheck != XorParity){
                  EchoError(_T("Xor parity Faillure In SERIAL ID string from Server"));;
               }
               TempSerialID               = BlockString;
               SetPdaSerialNo              (TempSerialID);
               break;
          case 'B': // BRAND NAME
               XorParity    = *BlockString ++;
               XorCheck     = GetXorParity  (BlockString, AStringLen(BlockString, (BlockLen - 2)));
               if(XorCheck != XorParity){
                  EchoError(_T("Xor parity Faillure In BRAND NAME string from Server"));;
               }
               TempBrandName              = BlockString;
               SetPdaBrandName             (TempBrandName);
               break;
          case 'M': // MODEL NAME
               XorParity    = *BlockString ++;
               XorCheck     = GetXorParity  (BlockString, AStringLen(BlockString, (BlockLen - 2)));
               if(XorCheck != XorParity){
                  EchoError(_T("Xor parity Faillure In MODEL NAME string from Server"));;
               }
               TempModel                  = BlockString;
               SetPdaModelName             (TempModel);
               break;
          case 'K': // ECRYPTION KEY
               XorParity    = *BlockString ++;
               XorCheck     = GetXorParity  (BlockString, AStringLen(BlockString, (BlockLen - 2)));
               if(XorCheck != XorParity){
                  EchoError(_T("Xor parity Faillure In ECRYPTION KEY string from Server"));;
               }
               TempEncryptKey             = BlockString;
               SetPdaEncryptkey            (TempEncryptKey);
               break;

          case 'D': // CACHE DATA STORAGE
               //
               if(UseCacheMemory){
                  CopyMemory               (&CacheInfo, &InitBuffer [InitLooper], sizeof(CacheInfo));
                  switch(CacheInfo.Action){
                  case 'R': // RESET
                       ZeroMemory            (PDACache, (CacheMemorySize * 512 * KB));
                       ZeroMemory            (&LinksInfo, (sizeof(LinksInfo)));
                       Info.Format(_T("Resetting Cache!"));
                       EchoText(Info);
                       break;
                  case 'U':
                       Info.Format(_T("Updating Cache!"));
                       EchoText(Info);
                       break;

                  default:
                      break;
                  }
                  MaxPageSize             = CacheInfo.MaxPageSize;
                  MemChunkSize            = CacheInfo.ChunkSize;
                  MaxNumOfPages           = ((CacheMemorySize * 512) / MaxPageSize);

                  LinksInfo.MaxPageSize   = MaxPageSize;
                  LinksInfo.CacheID       = CacheInfo.CacheID;
               }
               break;

          case 0:
               BlockLen = 1; // ASSUME PADDING OF ZERO... THAT SHOULD NEVER HAPPEND ...
               break;
          default:
               break;
          }
          // EchoText((LPTSTR)BlockString);
          InitLooper += BlockLen;
       }
#if USE_EVENTFIRE
       if(TempUserID   != _T("")){
          OnRegisterUser (TempUserID, TempPswd);
       }
       if(TempSerialID != _T("")){
          OnRegisterSerial (TempSerialID, TempBrandName, TempModel, TempEncryptKey);
       }
#endif
    }
    if(InitInfo.Action == 'R'){ // THEN IT IS A REQUEST
       SendAnInit ('S'); //   ScheduledInit    = TRUE;
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL HandleResetConfig (BYTE CommandBuffer[8])
{
CString       Info, TempInitModemString,  TempDialNumber, TempString;
int           Locate;
LPSTR         BlockString;
char          InitBuffer    [8192];
BYTE          SettingsStack [32];
BYTE          theLSB, theMSB;
DWORD         InitLooper;
WORD          BlockLen, TempLen;
INITINFO      ConfigInfo;
BYTE          XorParity, XorCheck;

    short    BaudSpeed                   = 96;
    BOOL     AutoRedial                  = TRUE;
    short    RedialDelay                 = 5;
    short    TimeoutConnect              = 30;

    ZeroMemory(&SettingsStack,             sizeof(SettingsStack));

    EchoTask(CommandBuffer);
    ConfigInfo          = *(INITINFO*) CommandBuffer;
    ZeroMemory(InitBuffer, sizeof(InitBuffer));

    if((ConfigInfo.Len) && (ConfigInfo.Len <= sizeof(InitBuffer))){

       if(Not RecvData ((PBYTE)InitBuffer, ConfigInfo.Len)){
          RcvError++;
          EchoRcvError(-2, RcvError);
          return FALSE;
       }
       InitLooper = 0;
       ///////////////////////////////////////////////////////////////////

       while( InitLooper < ConfigInfo.Len){

          BlockLen    = InitBuffer  [InitLooper + 1];
          BlockString = &InitBuffer [InitLooper + 2];
          ////////////////////////////////////////////////////////////////
          // SWITCH ON INIT SUBBLOCK USE THE SECOND BYTE AS A LEN OF BLOCK
          // IF THE BLOCK IS RECOGNIZED PROCESS IT
          // UNLESS THE VALUE IS ZERO WHICH IT IS ASSUME TO BE PADDING JUST IGNORE THE BYTE.
          // OTHERWISE JUST SKIP IT...
          switch(InitBuffer[InitLooper]){
          case 'I': // INITMODEMSTRING
               XorParity    = *BlockString ++;
               XorCheck     = GetXorParity  (BlockString, AStringLen(BlockString, (BlockLen - 2)));
               if(XorCheck != XorParity){
                  EchoError(_T("Xor parity Faillure In INITMODEMSTRING string from Server"));;
               }
               TempInitModemString        = BlockString;
               break;

          case 'D': // DIALNUMBER OR IP ADDRESS
               XorParity    = *BlockString ++;
               XorCheck     = GetXorParity  (BlockString, AStringLen(BlockString, (BlockLen - 2)));
               if(XorCheck != XorParity){
                  EchoError(_T("Xor parity Faillure In DIALNUMBER string from Server"));;
               }
               TempString        = BlockString;
               if( (Locate       = TempString.Find(_T(":"))) > 0 ){
                  SetPortName      (TempString.Left(Locate));
                  SetPortSetting   (TempString.Mid(Locate+1));
               } else {
                  TempDialNumber = TempString;
               }
               break;

          case 'S': // SETTINGS STACK
               TempLen = (((BlockLen) > sizeof(SettingsStack)) ? sizeof(SettingsStack) : (BlockLen));
               CopyMemory (SettingsStack, &InitBuffer [InitLooper], TempLen);

               theLSB           = SettingsStack[2];
               theMSB           = SettingsStack[3];
               BaudSpeed        = (long)(theLSB) + ((long)(theMSB) * 256);

               AutoRedial       = (SettingsStack [4] & 1);

               theLSB           = SettingsStack[6];
               theMSB           = SettingsStack[7];
               TimeoutConnect   = (long)(theLSB) + ((long)(theMSB) * 256);

               theLSB           = SettingsStack[8];
               theMSB           = SettingsStack[9];
               RedialDelay      = (long)(theLSB) + ((long)(theMSB) * 256);

               break;

          case 0:
               BlockLen = 1; // ASSUME PADDING OF ZERO... THAT SHOULD NEVER HAPPEND ...
               break;
          default:
               break;
          }
          // EchoText((LPTSTR)BlockString);
          InitLooper += BlockLen;
       }
       if(TempDialNumber      == ""){
          TempDialNumber       = GetModemDialStr ();
       }
       if(TempInitModemString == ""){
          TempInitModemString  = GetModemInitStr ();
       }
#if USE_EVENTFIRE
       OnConfigChange    (BaudSpeed,
                          AutoRedial,
                          RedialDelay,
                          TimeoutConnect,
                          TempInitModemString,
                          TempDialNumber );
#endif
    }
    if(ConfigInfo.Action == 'R'){ //THEN IT IS A REQUEST
       SendAConfig();
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL HandleBeaconCommand (BYTE CommandBuffer[8])
{
BYTE XLSB, XMSB, YLSB, YMSB;
long VirtualX, VirtualY;

    EchoTask(CommandBuffer);
    EchoBeacon(CommandBuffer);

    // PADREFRESH = 0,PADSETPOS = 1, PADADRESSDOWN = 2, WEBINTRANSITION = 4, PDAPAGEREADY = 0X10
    if (CommandBuffer[6] & PADADRESSDOWN) {
       Palm.AddressStatus = TRUE;
    } else {
       Palm.AddressStatus = FALSE;
    }
    if(CommandBuffer[6] & WEBINTRANSITION){

       Palm.TransitStatus = 1;
       RefreshIPalm();
    } else {
       if(Palm.TransitStatus){
          Palm.TransitStatus = 0;
          RefreshIPalm();
/*
          if(AutoTestMode){ // NAVIGATE EVERY 30 SEC
             TestTimer.BeginDelay(30000);
          }
*/
       }
    }
    if(CommandBuffer[6] & PDAPAGEREADY){

       if(Palm.PDAPageReady == 0){
          Palm.PDAPageReady  = 1;
          RefreshIPalm();
       }
    } else {
       if(Palm.PDAPageReady){
          Palm.PDAPageReady  = 0;
          RefreshIPalm();

#if USE_PLAYBACK
          if(InPlayBackMode){
             AddPageInPlayTable();
             if((PlayTillNextPage)
             ){
                PlayTillNextPage  =
                PlayNextStep      = FALSE;
             }
          }
#endif
       }
    }
    if (CommandBuffer[6] & PADSETPOS) {

       XLSB = CommandBuffer[2];
       XMSB = CommandBuffer[3];

       YLSB = CommandBuffer[4];
       YMSB = CommandBuffer[5];

       VirtualX = XLSB + (XMSB * 256);
       VirtualY = YLSB + (YMSB * 256);

       if(UseSimul && Palm.ShowSimulBox ){
          Palm.SimulLeft = VirtualX;
          Palm.SimulTop  = VirtualY;
       }
       SetScreenPos (VirtualX, VirtualY);
       PostABeacon  ();
       RefreshIPalm ();
       // Call Function in Com for Fire_Event
       return TRUE;
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL HandleKeyboardCommand (BYTE CommandBuffer[8])
{
long Which, Status;

    Which  = CommandBuffer[5];
    Status = CommandBuffer[6];

    ShowKeyboard(Which);
    EchoTask(CommandBuffer);
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL ProcessACommand(BYTE   CommandBuffer[8])
{
BOOL bRet = TRUE;

	switch(CommandBuffer[1]){
	case 'I':
         PushStatusState(STATUSREADING);
         bRet =  HandleInitCommand    (CommandBuffer);
         PullStatusState(STATUSREADING);
         break;

	case 'R':
         PushStatusState(STATUSREADING);
         bRet =  HandleResetConfig    (CommandBuffer);
         PullStatusState(STATUSREADING);
         break;

	case 'L':
         PushStatusState(STATUSREADING);
         bRet =  HandleScreenCommand    (CommandBuffer);
         PullStatusState(STATUSREADING);
         break;

	case 'S':
         PushStatusState(STATUSREADING);
         bRet =  HandleScrollCommand    (CommandBuffer);
         PullStatusState(STATUSREADING);
         break;

	case 'A':
         PushStatusState(STATUSREADING);
         bRet =  HandleStringCommand    (CommandBuffer);
         PullStatusState(STATUSREADING);
         break;

	case 'K':
         PushStatusState(STATUSREADING);
 		 bRet =  HandleKeyboardCommand  (CommandBuffer);
         PullStatusState(STATUSREADING);
         break;

	case 'B':
         PushStatusState(STATUSREADING);
 		 bRet =  HandleBeaconCommand    (CommandBuffer);
         PullStatusState(STATUSREADING);
         break;

	case 'C':
         PushStatusState(STATUSREADING);
 		 bRet =  HandlePaletteCommand    (CommandBuffer);
         PullStatusState(STATUSREADING);
         break;

	case 'G':
         PushStatusState(STATUSREADING);
 		 bRet =  HandleColorImageCommand (CommandBuffer);
         PullStatusState(STATUSREADING);
         break;

	case 'f':
         PushStatusState(STATUSREADING);
 		 bRet =  HandleFocusRectCommand (CommandBuffer);
         PullStatusState(STATUSREADING);
         break;

	case 'J':
         PushStatusState(STATUSREADING);
 		 bRet =  HandleMultiPackColorImageCommand (CommandBuffer);
         PullStatusState(STATUSREADING);
         break;

	case 'M':
         PushStatusState(STATUSREADING);
 		 bRet =  HandleCacheMemoryCommand (CommandBuffer);
         PullStatusState(STATUSREADING);
         break;

	case 'O':
         PushStatusState(STATUSREADING);
 		 bRet =  HandleOrderedTaskListCommand (CommandBuffer);
         PullStatusState(STATUSREADING);
         break;
    case 'r':
         PushStatusState(STATUSREADING);
 		 bRet =  HandleReRouteCommand (CommandBuffer);
         PullStatusState(STATUSREADING);
         break;

	default:
         EchoTask(CommandBuffer);
         break;
    }
    if((InPlayBackMode)
    && (Not PlayTillNextPage)
    ){
       PlayNextStep = FALSE;
    }
	return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL ProcessDeviceDataForStdPort ()
{
BYTE    CommandBuffer[8];
BOOL    bRet = TRUE;

	if(( RecvData(CommandBuffer, 1)) != FALSE){

       FrameError   = 0;
       RcvError     = 0;
       ImageError   = 0;

	   if(CommandBuffer[0] == CommandCode){

		   if(Not RecvData( &CommandBuffer[1], 7)){
			   RcvError++;
               EchoError (_T("Error in reading a command"));
			   return TRUE;
		   }
		   if(CommandBuffer[7] != 0x1a){
               EchoCommandError(CommandBuffer);
			   return TRUE;
		   }
           // COMMAND IS RECOGNIZED...
           if(PadSettings.HostStatus == 0){
              EchoText(_T("Host waking up, recovering..."));
           }
           PadSettings.HostTimeOut = 0;
           PadSettings.HostStatus++;
           bRet = ProcessACommand(CommandBuffer);

	   } else {
          EchoByte(CommandBuffer[0]);
	   }
    }
    return bRet;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL ProcessOutgoingDataForStdPort()
{
BYTE       AckType;
BYTE       SeqID;
BYTE       FrameID;
BYTE       CurrentPhase;
BYTE       CurrentState;

    while( PopAckQueue (AckType, SeqID, FrameID, CurrentPhase, CurrentState) ){

       SendAck (AckType, SeqID, FrameID, CurrentPhase, CurrentState);
	}
/*
BOOL       IsScrolled = FALSE;
BYTE       ScrollID;
    while( PopScrollAckQueue (ScrollID) ){
 	   SendScrollAck (ScrollID);
       IsScrolled = TRUE;
       Sleep(100);
	}
*/
#if USE_AUTOPLAY
    if(AutoTestMode){
       if(TestTimer.Delay){
          if(TestTimer.StillInDelay() == FALSE){

             SendAFunctionString(PDA_GOKEY, ToggleString);
             if (ToggleString == AltAdressString) {
                ToggleString   = FirstAdressString;
             } else {
                ToggleString   = AltAdressString;
             }
             TestTimer.EndDelay();
          }
       } else {
          TestTimer.BeginDelay(TestModeInterval);
       }
    }
#endif
	return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
// EXPORTED FUNCTION
///////////////////////////////////////////////////////////////////////////////////////////////////
#if 0
BOOL __stdcall SendAck(BYTE FrameID)
{DLL_THREAD_MANAGEMENT();

BYTE     Ack[2] = {0xd0, 0 };
CString  Info;

    switch(FrameID){
    case FRAMEKEYBD-1:   Palm.KeyboardTable = Palm.KeyboardTable | 0x1;
         break;
    case FRAMEKEYBD-2:   Palm.KeyboardTable = Palm.KeyboardTable | 0x2;
         break;
    case FRAMEKEYBD-3:   Palm.KeyboardTable = Palm.KeyboardTable | 0x4;
         break;
    case FRAMEKEYBD-4:   Palm.KeyboardTable = Palm.KeyboardTable | 0x8;
         break;
    case FRAMEKEYBD-5:   Palm.KeyboardTable = Palm.KeyboardTable | 0x10;
         break;
    case FRAMEKEYBD+1:   Palm.KeyboardDownloaded = Palm.KeyboardDownloaded | 0x1;
         break;
    case FRAMEKEYBD+2:   Palm.KeyboardDownloaded = Palm.KeyboardDownloaded | 0x2;
         break;
    case FRAMEKEYBD+3:   Palm.KeyboardDownloaded = Palm.KeyboardDownloaded | 0x4;
         break;
    case FRAMEKEYBD+4:   Palm.KeyboardDownloaded = Palm.KeyboardDownloaded | 0x8;
         break;
    case 255:   Palm.MenuDownloaded     = Palm.MenuDownloaded | 0x1;
         break;
    }
/*
    Info.Format("Acking Frame: %d", (int)FrameID);
    EchoText(Info);
*/
    Ack[0]  = 0xd0;
    Ack[1]  = FrameID;
    if(SendData(Ack, 2)){
	   return TRUE;
    }
    EchoSendError("Ack Frame! failled to send");
    return FALSE;
}
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall SendAck(BYTE AckType, BYTE SeqID, BYTE FrameID, BYTE  CurrentPhase, BYTE CurrentState)
{DLL_THREAD_MANAGEMENT();

    if(AckType == 0xA0){
       return SendScrollAck(SeqID);
    } else {
       return SendFrameAck(SeqID, FrameID, CurrentPhase, CurrentState);
    }
    return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall SendFrameAck(BYTE SeqID, BYTE FrameID, BYTE  CurrentPhase, BYTE CurrentState)
{DLL_THREAD_MANAGEMENT();

BYTE     Ack[2]       = {0xd0, 0 };
CString  Info;

    switch(FrameID){
    case FRAMEUNKNW:
    case FRAMECLEAR:
         break;
    case FRAMERESYNC:
         Info.Format(_T("Ack/NAck Re-Sync: %d"), (int)FrameID);
         EchoText(Info);
         break;
    case FRAMEKEYBD-1:   Palm.KeyboardTable         = Palm.KeyboardTable | 0x1;
         break;
    case FRAMEKEYBD-2:   Palm.KeyboardTable         = Palm.KeyboardTable | 0x2;
         break;
    case FRAMEKEYBD-3:   Palm.KeyboardTable         = Palm.KeyboardTable | 0x4;
         break;
    case FRAMEKEYBD-4:   Palm.KeyboardTable         = Palm.KeyboardTable | 0x8;
         break;
    case FRAMEKEYBD-5:   Palm.KeyboardTable         = Palm.KeyboardTable | 0x10;
         break;
    case FRAMEKEYBD+1:   Palm.KeyboardDownloaded    = Palm.KeyboardDownloaded | 0x1;
         // MOVE KEYBOARD IN DEFAULT POSITION...
         SetupKeyboard(1);
         break;
    case FRAMEKEYBD+2:   Palm.KeyboardDownloaded    = Palm.KeyboardDownloaded | 0x2;
         break;
    case FRAMEKEYBD+3:   Palm.KeyboardDownloaded    = Palm.KeyboardDownloaded | 0x4;
         break;
    case FRAMEKEYBD+4:   Palm.KeyboardDownloaded    = Palm.KeyboardDownloaded | 0x8;
         break;
    case FRAMEMENU:      Palm.MenuDownloaded        = Palm.MenuDownloaded     | 0x1;
         if(((Palm.KeyboardTable          & 0xFF)     == 0x1F)
         && ((Palm.KeyboardDownloaded     & 0x0F)     == 0x03) ){ // DOES NOT SEND EXTENDED YET
            Palm.KeyboardFullyFunctionnal = TRUE;
            // Palm.InitSequenceComplete     = TRUE;
         }
         break;
    default:
         Palm.InitSequenceComplete        = TRUE;
         WaitForConnect = FALSE;
         break;
    }
/*
    Info.Format("Acking Frame: %d", (int)FrameID);
    EchoText(Info);
*/
    if(CurrentState == ACK_FRAME_SUCCESSFULL){
       Ack[0]        = ACK_FRAME_SUCCESSFULL + CurrentPhase;
       EchoAck (SeqID, FrameID, CurrentPhase);
    } else {
       Ack[0]        = CurrentState;
       EchoNAck(SeqID, FrameID, CurrentPhase);
    }
    Ack[1]  = SeqID;

    if(SendData(Ack, 2)){
	   return TRUE;
    }
    EchoSendError(_T("Ack Frame! failled to send"));
    return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall SendScrollAck(BYTE ScrollID)
{DLL_THREAD_MANAGEMENT();

BYTE     Ack[2] = {0xA0, 0 };
CString  Info;

    Ack[0]  = 0xA0;
    Ack[1]  = ScrollID;
    if(SendData(Ack, 2)){

       Info.Format(_T("Acking ScrollID: %d"), (int)ScrollID);
       EchoText(Info);

	   return TRUE;
    }
    EchoSendError(_T("Ack Scroll! failled to send"));
    return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall SendAMouseEvent(long MouseState, long VirtualX, long VirtualY)
{DLL_THREAD_MANAGEMENT();

BYTE XLSB, XMSB, YLSB, YMSB;
BYTE theStream[8];
BOOL Ret;

    if (Not IsLocalPortOpen()) {
       //'MsgBox ("Port IO should be open prior to send command...")
       return FALSE;
    }
    if (PadSettings.ProcessChannel == FALSE) {
       return TRUE;
    }
    XLSB = (BYTE) ((WORD)VirtualX % 256);
    XMSB = (BYTE) ((WORD)VirtualX / 256);

    YLSB = (BYTE) ((WORD)VirtualY % 256);
    YMSB = (BYTE) ((WORD)VirtualY / 256);

    theStream[0] = CommandCode;
    theStream[1] = 'P';
    theStream[2] = (XLSB);
    theStream[3] = (XMSB);
    theStream[4] = (YLSB);
    theStream[5] = (YMSB);
    theStream[6] = (MouseState);
    theStream[7] = (0x1A);
    Ret = WriteChannelBuffer((LPCSTR)theStream, 8);
	if(Not Ret){
       EchoSendError(_T("Mouse Event! failled to send"));
	   return FALSE;
	}
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall SendRawData (LPBYTE ByteToSend, long DataLen)
{DLL_THREAD_MANAGEMENT();

BOOL        Ret;

    if (Not IsLocalPortOpen()) {
       //'MsgBox ("Port IO should be open prior to send command...")
       return FALSE;
    }
    Ret = SendData(ByteToSend, DataLen);
	if(Not Ret){
       EchoSendError(_T("Raw Data failled to send"));
	   return FALSE;
	}
	return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall SendAString(LPCTSTR StringToSend)
{DLL_THREAD_MANAGEMENT();

BYTE        XLSB, XMSB, YLSB, YMSB;
long        VirtualX, VirtualY;
BYTE        ThisStrLen;
BYTE        theStream[512];
CHAR        theCharString [512];
CString     theString;
BOOL        Ret;
DWORD       StrLenInTChar = 0;

    if (Not IsLocalPortOpen()) {
       //'MsgBox ("Port IO should be open prior to send command...")
       return FALSE;
    }
    if (PadSettings.ProcessChannel == FALSE) {
       return TRUE;
    }
    VirtualX = 0;
    VirtualY = 0;

    XLSB = (BYTE) ((WORD)VirtualX % 256);
    XMSB = (BYTE) ((WORD)VirtualX / 256);

    YLSB = (BYTE) ((WORD)VirtualY % 256);
    YMSB = (BYTE) ((WORD)VirtualY / 256);

    theString  = StringToSend;
    StrLenInTChar = ((sizeof(theStream) - 8 - sizeof(TCHAR)) / sizeof(TCHAR));

    if ((theString.GetLength()) >= StrLenInTChar) {
       theString  = theString.Mid(0, StrLenInTChar);
    }
    ThisStrLen     = theString.GetLength() + 1; // WILL INCLUDE NULL TERMINATOR

    if((sizeof(TCHAR) == 2) && (UnicodeSupport)){

       ThisStrLen      *= sizeof(TCHAR);
       CopyMemory(theCharString, theString, ThisStrLen);
    } else {
       ThisStrLen = ConvertToAsciiChar(theCharString, sizeof(theCharString), theString, ThisStrLen);
    }

    theStream[0] = CommandCode;
    theStream[1] = 'A';
    theStream[2] = (XLSB);
    theStream[3] = (XMSB);
    theStream[4] = (YLSB);
    theStream[5] = (YMSB);
    theStream[6] = (ThisStrLen);
    theStream[7] = (0x1A);
    CopyMemory(&theStream[8], theCharString, ThisStrLen);

    Ret = WriteChannelBuffer((LPCSTR)theStream, 8 + ThisStrLen);
	if(Not Ret){
       EchoSendError(_T("String Command! failled to send"));
	   return FALSE;
	}
	return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall SendAFunctionKeyString(WORD FunctionKey, WORD ExtraState, LPCTSTR StringToSend)
{DLL_THREAD_MANAGEMENT();

BYTE        KEY_LSB, KEY_MSB;
BYTE        LEN_LSB, LEN_MSB;
WORD        ThisStrLen = 0;
BYTE        theStream     [4096];
CHAR        theCharString [4096];
CString     theString;
BOOL        Ret;
DWORD       StrLenInTChar = 0;


    // : TO TEST NEW GPS BEACON, WHEN SHIFT + F8 RECEIVED, JUST READ THE STRING  AS NEW GPS POSITION STRING
    if((FunctionKey  == 0x008F)
    && (ExtraState)
    ){
       theString         = StringToSend;

       if(Not theString.IsEmpty()){
          CSingleLock AccessSingleLock     (&CriticalGpsAccess);
          if(AccessSingleLock.Lock         ())
          {
             PDAGpsPosition = theString;
             AccessSingleLock.Unlock       ();
          }
       }
       return TRUE;
    }
    ZeroMemory(theCharString, sizeof(theCharString));

    if (Not IsLocalPortOpen()) {
       //'MsgBox ("Port IO should be open prior to send command...")
       if(UseCacheMemory){
          switch(FunctionKey){
          case PDA_BACKWARDKEY:
          case PDA_FORWARDKEY:
               BrowseOffLine(FunctionKey);
               break;
          }
       }
       return FALSE;
    }
    if (PadSettings.ProcessChannel == FALSE) {
       return TRUE;
    }
    KEY_LSB       = (BYTE) (FunctionKey % 256);
    KEY_MSB       = (BYTE) (FunctionKey / 256);
/*
    if(FunctionKey  == 0x0085){
       theString     = StringToSend;
*/
    switch(FunctionKey){
    case 0x0085:
    case 0x0088: //NEW IMPLEMENTATION FOR F1 KEY TO INSERT STRING
    case 0x0089: //NEW IMPLEMENTATION FOR F2 KEY TO INSERT STRING
         theString  = StringToSend;

         StrLenInTChar = ((sizeof(theStream) - 8 - sizeof(TCHAR)) / sizeof(TCHAR));

         if ((theString.GetLength()) >= StrLenInTChar) {
            theString  = theString.Mid(0, StrLenInTChar);
         }
         ThisStrLen     = theString.GetLength() + 1; // WILL INCLUDE NULL TERMINATOR

         if((sizeof(TCHAR) == 2) && (UnicodeSupport)){

            ThisStrLen      *= sizeof(TCHAR);
            CopyMemory(theCharString, theString, ThisStrLen);
         } else {
            ThisStrLen = ConvertToAsciiChar(theCharString, sizeof(theCharString), theString, ThisStrLen);
         }
         break;
    }
    LEN_LSB      = (BYTE) (ThisStrLen % 256);
    LEN_MSB      = (BYTE) (ThisStrLen / 256);

    theStream[0] = CommandCode;
    theStream[1] = 'F';
    theStream[2] = (KEY_LSB);
    theStream[3] = (KEY_MSB);
    theStream[4] = (ExtraState); // KeyboardShiftStatus KeyboardCapStatus  KeyboardCtrlStatus  KeyboardIntlStatus
    theStream[5] = (LEN_LSB);
    theStream[6] = (LEN_MSB);
    theStream[7] = (0x1A);
    CopyMemory(&theStream[8], theCharString, ThisStrLen);


    Ret = WriteChannelBuffer((LPCSTR)theStream, 8 + ThisStrLen);
	if(Not Ret){
       EchoSendError(_T("String Command! failled to send"));
	   return FALSE;
	}
	return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall SendATextString(LPCTSTR StringToSend)
{DLL_THREAD_MANAGEMENT();

   return SendAFunctionKeyString(0x0088, 0, StringToSend);
}


///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall SendAFunctionString(WORD FunctionKey, LPCTSTR StringToSend)
{DLL_THREAD_MANAGEMENT();

   return SendAFunctionKeyString(FunctionKey,  KeyboardShiftStatus, StringToSend);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall PostABeacon()
{DLL_THREAD_MANAGEMENT();

BYTE XLSB = 0, XMSB = 0, YLSB = 0, YMSB = 0;
BYTE theStream[8];
BYTE Status;
BOOL Ret;

    if(UseGpsBeacon){
       return PostAGpsBeacon();
    }
    if(Not IsLocalPortOpen()) {
       //'MsgBox ("Port IO should be open prior to send command...")
       return FALSE;
    }
    if(PadSettings.ProcessChannel   == FALSE) {
       return TRUE;
    }
    if(PadSettings.EnableSendBeacon == FALSE) {
       return TRUE;
    }
    Status  = Palm.KeybdOnSatus; //'(KeybdOnScreen <> 0) And 1
    Status |= (Palm.AddressStatus ? 8 : 0);

    if(PadSettings.EnableScreenPos){

       if(UseSimul && Palm.ShowSimulBox ){
          XLSB = (BYTE) ((WORD)Palm.SimulLeft   % 256);
          XMSB = (BYTE) ((WORD)Palm.SimulLeft   / 256);

          YLSB = (BYTE) ((WORD)Palm.SimulTop    % 256);
          YMSB = (BYTE) ((WORD)Palm.SimulTop    / 256);
       } else {
          XLSB = (BYTE) ((WORD)Palm.HScrollValue % 256);
          XMSB = (BYTE) ((WORD)Palm.HScrollValue / 256);

          YLSB = (BYTE) ((WORD)Palm.VScrollValue % 256);
          YMSB = (BYTE) ((WORD)Palm.VScrollValue / 256);
       }
    }
    theStream[0] = CommandCode;
    theStream[1] = 'B';
    theStream[2] = (XLSB);
    theStream[3] = (XMSB);
    theStream[4] = (YLSB);
    theStream[5] = (YMSB);
    theStream[6] = (Status);
    theStream[7] = (0x1A);
    Ret = WriteChannelBuffer((LPCSTR)theStream, 8);

    TriggerEventStatus ();

    if(Not Ret){
       EchoSendError(_T("Beacon! failled to send"));
	   return FALSE;
	}
	return TRUE;

}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall SendABeacon()
{DLL_THREAD_MANAGEMENT();

BYTE XLSB = 0, XMSB = 0, YLSB = 0, YMSB = 0;
BYTE theStream[8];
BYTE Status;
BOOL Ret;

    if(UseGpsBeacon){
       return SendAGpsBeacon();
    }
    if(Not IsLocalPortOpen()) {
       //'MsgBox ("Port IO should be open prior to send command...")
       return FALSE;
    }
    if(PadSettings.ProcessChannel   == FALSE) {
       return TRUE;
    }
    if(PadSettings.EnableSendBeacon == FALSE) {
       return TRUE;
    }
    Status  = Palm.KeybdOnSatus; //'(KeybdOnScreen <> 0) And 1
    Status |= (Palm.AddressStatus ? 8 : 0);

    if(PadSettings.EnableScreenPos){

       if(UseSimul && Palm.ShowSimulBox ){
          XLSB = (BYTE) ((WORD)Palm.SimulLeft   % 256);
          XMSB = (BYTE) ((WORD)Palm.SimulLeft   / 256);

          YLSB = (BYTE) ((WORD)Palm.SimulTop    % 256);
          YMSB = (BYTE) ((WORD)Palm.SimulTop    / 256);
       } else {
          XLSB = (BYTE) ((WORD)Palm.HScrollValue % 256);
          XMSB = (BYTE) ((WORD)Palm.HScrollValue / 256);

          YLSB = (BYTE) ((WORD)Palm.VScrollValue % 256);
          YMSB = (BYTE) ((WORD)Palm.VScrollValue / 256);
       }
    }
    theStream[0] = CommandCode;
    theStream[1] = 'B';
    theStream[2] = (XLSB);
    theStream[3] = (XMSB);
    theStream[4] = (YLSB);
    theStream[5] = (YMSB);
    theStream[6] = (Status);
    theStream[7] = (0x1A);
    Ret = SendData  ((LPBYTE)theStream, 8);
    TriggerEventStatus ();

    if(Not Ret){
       EchoSendError(_T("Beacon! failled to send"));
	   return FALSE;
	}
	return TRUE;

}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall PostAGpsBeacon()
{DLL_THREAD_MANAGEMENT();

BYTE XLSB = 0, XMSB = 0, YLSB = 0, YMSB = 0;
BYTE theStream     [512];
CHAR theCharString [128];
BYTE Status;
BOOL Ret;
BYTE ThisStrLen = 0;
CString GpsStr = _T("");

    if(Not IsLocalPortOpen()) {
       //'MsgBox ("Port IO should be open prior to send command...")
       return FALSE;
    }
    if(PadSettings.ProcessChannel   == FALSE) {
       return TRUE;
    }
    if(PadSettings.EnableSendBeacon == FALSE) {
       return TRUE;
    }
    ZeroMemory (theStream,     sizeof(theStream));
    ZeroMemory (theCharString, sizeof(theCharString));

    Status  = Palm.KeybdOnSatus; //'(KeybdOnScreen <> 0) And 1
    Status |= (Palm.AddressStatus ? 8 : 0);

    if(PadSettings.EnableScreenPos){

       if(UseSimul && Palm.ShowSimulBox ){
          XLSB = (BYTE) ((WORD)Palm.SimulLeft   % 256);
          XMSB = (BYTE) ((WORD)Palm.SimulLeft   / 256);

          YLSB = (BYTE) ((WORD)Palm.SimulTop    % 256);
          YMSB = (BYTE) ((WORD)Palm.SimulTop    / 256);
       } else {
          XLSB = (BYTE) ((WORD)Palm.HScrollValue % 256);
          XMSB = (BYTE) ((WORD)Palm.HScrollValue / 256);

          YLSB = (BYTE) ((WORD)Palm.VScrollValue % 256);
          YMSB = (BYTE) ((WORD)Palm.VScrollValue / 256);
       }
    }
    theStream[0] = CommandCode;
    theStream[1] = 'X';
    theStream[2] = (XLSB);
    theStream[3] = (XMSB);
    theStream[4] = (YLSB);
    theStream[5] = (YMSB);
    theStream[6] = (Status);
    theStream[7] = (0x1A);

    CSingleLock AccessSingleLock     (&CriticalGpsAccess);
    if(AccessSingleLock.Lock         ())
    {
       GpsStr = PDAGpsPosition;
       AccessSingleLock.Unlock       ();
    }
    if(Not GpsStr.IsEmpty()){

       ThisStrLen         = GpsStr.GetLength() + 1; // WILL INCLUDE NULL TERMINATOR
       ThisStrLen         = ConvertToAsciiChar(theCharString, sizeof(theCharString), GpsStr, ThisStrLen);

       CopyMemory          (&theStream[9], theCharString, ThisStrLen);
    }
    theStream[8]         = ThisStrLen;
    Ret                  = WriteChannelBuffer((LPCSTR)theStream, (ThisStrLen + 1 + 8));

    TriggerEventStatus ();

    if(Not Ret){
       EchoSendError(_T("Beacon! failled to send"));
	   return FALSE;
	}
	return TRUE;

}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall SendAGpsBeacon()
{DLL_THREAD_MANAGEMENT();

BYTE XLSB = 0, XMSB = 0, YLSB = 0, YMSB = 0;
BYTE theStream     [512];
CHAR theCharString [128];
BYTE Status;
BOOL Ret;
BYTE ThisStrLen = 0;
CString GpsStr = _T("");

    if(Not IsLocalPortOpen()) {
       //'MsgBox ("Port IO should be open prior to send command...")
       return FALSE;
    }
    if(PadSettings.ProcessChannel   == FALSE) {
       return TRUE;
    }
    if(PadSettings.EnableSendBeacon == FALSE) {
       return TRUE;
    }
    ZeroMemory (theStream, sizeof(theStream));
    ZeroMemory (theCharString, sizeof(theCharString));

    Status  = Palm.KeybdOnSatus; //'(KeybdOnScreen <> 0) And 1
    Status |= (Palm.AddressStatus ? 8 : 0);

    if(PadSettings.EnableScreenPos){
       XLSB = (BYTE) ((WORD)Palm.HScrollValue % 256);
       XMSB = (BYTE) ((WORD)Palm.HScrollValue / 256);

       YLSB = (BYTE) ((WORD)Palm.VScrollValue % 256);
       YMSB = (BYTE) ((WORD)Palm.VScrollValue / 256);
    }

    theStream[0] = CommandCode;
    theStream[1] = 'X';
    theStream[2] = (XLSB);
    theStream[3] = (XMSB);
    theStream[4] = (YLSB);
    theStream[5] = (YMSB);
    theStream[6] = (Status);
    theStream[7] = (0x1A);

    CSingleLock AccessSingleLock     (&CriticalGpsAccess);
    if(AccessSingleLock.Lock         ())
    {
       GpsStr = PDAGpsPosition;
       AccessSingleLock.Unlock       ();
    }
    if(Not GpsStr.IsEmpty()){

       ThisStrLen         = GpsStr.GetLength() + 1; // WILL INCLUDE NULL TERMINATOR
       ThisStrLen         = ConvertToAsciiChar(theCharString, sizeof(theCharString), GpsStr, ThisStrLen);

       CopyMemory          (&theStream[9], theCharString, ThisStrLen);
    }
    theStream[8]         = ThisStrLen;

    Ret                  = SendData  ((LPBYTE)theStream,  (ThisStrLen + 1 + 8));
    TriggerEventStatus ();

    if(Not Ret){
       EchoSendError(_T("Beacon! failled to send"));
	   return FALSE;
	}
	return TRUE;

}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall SendAScrollCommand(short X, short Y, BYTE Status)
{DLL_THREAD_MANAGEMENT();

BYTE XLSB = 0, XMSB = 0, YLSB = 0, YMSB = 0;
BYTE theStream[8];
BOOL Ret;

//    if(PadSettings.EnableScreenPos){
       XLSB = (BYTE) ((WORD)X % 256);
       XMSB = (BYTE) ((WORD)X / 256);

       YLSB = (BYTE) ((WORD)Y % 256);
       YMSB = (BYTE) ((WORD)Y / 256);
//    }

    theStream[0] = CommandCode;
    theStream[1] = 'S';
    theStream[2] = (XLSB);
    theStream[3] = (XMSB);
    theStream[4] = (YLSB);
    theStream[5] = (YMSB);
    theStream[6] = (Status);
    theStream[7] = (0x1A);

    if (Not IsLocalPortOpen()) {
       //'MsgBox ("Port IO should be open prior to send command...")
       return FALSE;
    }

    Ret = WriteChannelBuffer((LPCSTR)theStream, 8);

    if(Not Ret){
       EchoSendError(_T("SCROLL! failled to send"));
	   return FALSE;
	}
	return TRUE;
}
//////////////////////////////////////////////////////////////////////
int BuildStringPacket (LPSTR ThisPacket, CString & ParmString, WORD PacketSize)
{
BYTE    XorParity = 0;
BYTE    SizeofThisPacket = PacketSize;
char    ASCIIBuffer [256];
int     CharToAdd = 0;

    ZeroMemory(ASCIIBuffer, sizeof(ASCIIBuffer));

#ifdef _UNICODE
    CharToAdd = ConvertToAsciiChar (ASCIIBuffer, sizeof(ASCIIBuffer), ParmString, ParmString.GetLength());
#else
    CharToAdd = ParmString.GetLength();
    if(CharToAdd > sizeof(ASCIIBuffer)){
       CharToAdd = sizeof(ASCIIBuffer);
    }
    CopyMemory (ASCIIBuffer, ParmString, CharToAdd);
#endif

   if(TRUE){ // IN THIS RELEASE...

      ThisPacket[SizeofThisPacket]     = ' ';
      SizeofThisPacket                ++;

      CopyMemory (&ThisPacket[SizeofThisPacket], ASCIIBuffer, CharToAdd);
      XorParity                        = GetXorParity (&ThisPacket[SizeofThisPacket], ParmString.GetLength());

      SizeofThisPacket                += (CharToAdd + 1);
      if(SizeofThisPacket > 255){
         SizeofThisPacket = 255;
         EchoSendError(_T("Output packet truncated in Build String Packet()!"));
      }
      ThisPacket[1]                    = SizeofThisPacket;
      ThisPacket[2]                    = XorParity;

   } else {
      CopyMemory (&ThisPacket[SizeofThisPacket], ASCIIBuffer, CharToAdd);
      SizeofThisPacket                += (CharToAdd + 1);
      if(SizeofThisPacket > 255){
         SizeofThisPacket = 255;
         EchoSendError(_T("Output packet truncated in Build String Packet()!"));
      }
      ThisPacket[1]                    = SizeofThisPacket;
   }
   ThisPacket[(SizeofThisPacket - 1)] = 0; // TERMINATE STRING
   return SizeofThisPacket;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall SendAModeSwitch()
{DLL_THREAD_MANAGEMENT();

static int ModeCount = 1;

    if (Not IsLocalPortOpen()) {
       //'MsgBox ("Port IO should be open prior to send command...")
       return FALSE;
    }
    PDASerialNo.Format(_T("TempSession-%4d"),  ModeCount++);

    return SendAnInit('M');
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall SendAnInit(CHAR ActionMode)
{DLL_THREAD_MANAGEMENT();

BOOL           Ret;
BYTE           theStream[8192];
LPBYTE         LoadStream = theStream;
INITINFO       InitInfo;
CACHEINFO      CacheInfo;
LANGIDINFO     PadLangIdInfo;
PADCAPSINFO    PadCapsInfo;
PADFEATUREINFO PadFeaturesInfo;
PAGEIDINFO     PageIdInfo;

BYTE           SizeofUserID     = 0,  SizeofPassword  = 0, SizeofSerialNo   = 0;
BYTE           SizeofBrandName  = 0,  SizeofModelName = 0;
BYTE           SizeofEncryptKey = 0;

BYTE           SizeofIMEIKey    = 0,  SizeofIMSIKey   = 0, SizeofCCIDKey    = 0, SizeofSimTelKey  = 0;
BYTE           SizeofSIMKeys    = 0;

char           SerialNo      [32];
char           BrandName     [32];
char           ModelName     [32];
char           EncryptKey    [32];
char           UserID        [32];
char           Password      [32];

char           IMEIKey       [48];
char           IMSIKey       [48];
char           CCIDKey       [48];
char           SimTelKey     [48];

#define        MaxPDAString 16
#define        MaxSIMString 32

    if (Not IsLocalPortOpen()) {
       //'MsgBox ("Port IO should be open prior to send command...")
       return FALSE;
    }
    ZeroMemory(SerialNo,                  sizeof(SerialNo));
    ZeroMemory(BrandName,                 sizeof(BrandName));
    ZeroMemory(ModelName,                 sizeof(ModelName));
    ZeroMemory(EncryptKey,                sizeof(EncryptKey));
    ZeroMemory(UserID,                    sizeof(UserID));
    ZeroMemory(Password,                  sizeof(Password));

    ZeroMemory(&InitInfo,                 sizeof(InitInfo));
    ZeroMemory(&CacheInfo,                sizeof(CacheInfo));
    ZeroMemory(&PadCapsInfo,              sizeof(PadCapsInfo));
    ZeroMemory(&PadLangIdInfo,            sizeof(PadLangIdInfo));
    ZeroMemory(&PadFeaturesInfo,          sizeof(PadFeaturesInfo));
    ZeroMemory(&PageIdInfo,               sizeof(PageIdInfo));


    if(PDAUserID       . GetLength()  > MaxPDAString){
       PDAUserID       = PDAUserID    . Left(MaxPDAString);
    }
    UserID[0]          = 'U';
    UserID[1]          = ' ';
    SizeofUserID       = BuildStringPacket (UserID, PDAUserID, 2);

    if(PDAUserPsw      . GetLength()  > MaxPDAString){
       PDAUserPsw      = PDAUserPsw   . Left(MaxPDAString);
    }
    Password[0]        = 'P';
    Password[1]        = ' ';
    SizeofPassword     = BuildStringPacket (Password, PDAUserPsw, 2);

    if(PDASerialNo     . GetLength()   > MaxPDAString){
       PDASerialNo     = PDASerialNo   . Left(MaxPDAString);
    }
    SerialNo[0]        = 'S';
    SerialNo[1]        = ' ';
    SizeofSerialNo     = BuildStringPacket (SerialNo, PDASerialNo, 2);

    if(PDABrandName    . GetLength()   > MaxPDAString){
       PDABrandName    = PDABrandName  . Left(MaxPDAString);
    }
    BrandName[0]       = 'B';
    BrandName[1]       = ' ';
    SizeofBrandName    = BuildStringPacket (BrandName, PDABrandName, 2);

    if(PDAModelName    . GetLength()   > MaxPDAString){
       PDAModelName    = PDAModelName  . Left(MaxPDAString);
    }
    ModelName[0]       = 'M';
    ModelName[1]       = ' ';
    SizeofModelName    = BuildStringPacket (ModelName, PDAModelName, 2);

    if(PDAEncryptKey   . GetLength()   > MaxPDAString){
       PDAEncryptKey   = PDAEncryptKey . Left(MaxPDAString);
    }
    EncryptKey[0]      = 'K';
    EncryptKey[1]      = ' ';
    SizeofEncryptKey   = BuildStringPacket (EncryptKey, PDAEncryptKey, 2);


    // NEW KEY FROM SIM...
    if(PDAIMEIKey      . GetLength()  > MaxSIMString){
       PDAIMEIKey      = PDAIMEIKey   . Left(MaxSIMString);
    }
    IMEIKey[0]         = 'N';
    IMEIKey[1]         = ' ';
    SizeofIMEIKey      = BuildStringPacket (IMEIKey, PDAIMEIKey, 2);

    if(PDAIMSIKey      . GetLength()  > MaxSIMString){
       PDAIMSIKey      = PDAIMSIKey   . Left(MaxSIMString);
    }
    IMSIKey[0]         = 'n';
    IMSIKey[1]         = ' ';
    SizeofIMSIKey      = BuildStringPacket (IMSIKey, PDAIMSIKey, 2);

    if(PDACCIDKey      . GetLength()  > MaxSIMString){
       PDACCIDKey      = PDACCIDKey   . Left(MaxSIMString);
    }
    CCIDKey[0]         = 'c';
    CCIDKey[1]         = ' ';
    SizeofCCIDKey      = BuildStringPacket (CCIDKey, PDACCIDKey, 2);

    if(PDASimTelKey    . GetLength()  > MaxSIMString){
       PDASimTelKey    = PDASimTelKey . Left(MaxSIMString);
    }
    SimTelKey[0]       = 'T';
    SimTelKey[1]       = ' ';
    SizeofSimTelKey    = BuildStringPacket (SimTelKey, PDASimTelKey, 2);

    SizeofSIMKeys      = (SizeofIMEIKey + SizeofIMSIKey + SizeofCCIDKey + SizeofSimTelKey);


    InitInfo.Command                    = CommandCode;
    InitInfo.SubCommand                 = 'I';
    InitInfo.MajorLSB                   = HIBYTE(FirmwareVersion);
    InitInfo.MinorMSB                   = LOBYTE(FirmwareVersion);
    InitInfo.Action                     = ActionMode; // TYPES ARE 'S' = SYSTEM INIT, 'U' = UPDATE INIT, 'H' = HIDDEN MODE;
    InitInfo.Len                        =  sizeof(PadCapsInfo)
                                        +  sizeof(PadFeaturesInfo)
                                        +  SizeofUserID
                                        +  SizeofPassword
                                        +  SizeofSerialNo
                                        +  SizeofBrandName
                                        +  SizeofModelName
                                        +  SizeofEncryptKey
                                        +  SizeofSIMKeys;
    if(UseCacheMemory){
       InitInfo.Len                    +=  sizeof(CacheInfo);
       CacheInfo.Command                = 'D';
       CacheInfo.Len                    =  sizeof(CacheInfo);
       CacheInfo.CacheSize              =  CacheMemorySize;
       CacheInfo.ChunkSize              =  MemChunkSize;
       CacheInfo.MaxPageSize            =  LinksInfo.MaxPageSize;
       CacheInfo.CacheID                =  LinksInfo.CacheID;
       CacheInfo.Terminator             =  0;

    }
    if(UnicodeSupport){
       InitInfo.Len                    +=  sizeof(PadLangIdInfo);
       PadLangIdInfo.BlockType          =  'L';
       PadLangIdInfo.BlockLen           =  sizeof(PadLangIdInfo);
       PadLangIdInfo.LangID             =  PadSettings.LangID;
       PadLangIdInfo.ConversionType     =  0; // NO SPECIAL CONVERSION
       PadLangIdInfo.Terminator         =  0;
    }
    // : NEW TO SUPPORT DIRECT EMAIL MODE... ////////////
    if(ActionMode                      == 'D'){

       InitInfo.Len                    +=  sizeof(PageIdInfo);
       PageIdInfo.BlockID               = 'I';
       PageIdInfo.BlockLen              = sizeof(PageIdInfo);

       if(DirectAccessUID. GetLength()  > UID_INFO_CHAR_LEN){
          DirectAccessUID               = DirectAccessUID.Left(UID_INFO_CHAR_LEN);
       }
       ConvertToAsciiChar                 ((LPSTR)PageIdInfo.UID, UID_INFO_CHAR_LEN, DirectAccessUID, DirectAccessUID.GetLength());
       PageIdInfo.Terminator            = 0;
    }
    ///////////////////////////////////////////////////////

    InitInfo.Terminator                 = (0x1A);

    PadCapsInfo.Command                 =  'C';
    PadCapsInfo.Len                     =  sizeof(PadCapsInfo);
/*
    if(PadSettings.ImageCapsRequested & PDA_MULTIPHASE ){
       PadCapsInfo.ColorBitDeep         =  PDA_MONO | PDA_MULTIPHASE;
    } else {
       PadCapsInfo.ColorBitDeep         =  PDA_MONO;
    }

    if(PadSettings.ImageCapsRequested & PDA_MULTIPHASE ){
       //PadCapsInfo.ColorBitDeep         =  PDA_3BITCOLOR | PDA_MULTIPHASE;
       //PadSettings.ImageCapsRequested  ^=  PDA_MULTIPHASE;
       //PadCapsInfo.ColorBitDeep         =  PadSettings.ImageCapsRequested;
       PadCapsInfo.ColorBitDeep         =  PadSettings.ImageCapsRequested;
    } else {
*/
    PadCapsInfo.ColorBitDeep            =  PadSettings.ImageCapsRequested;

    if(UseSimul && Palm.ShowSimulBox ){
       PadCapsInfo.ScreenWidth          =  ((Palm.SimulWidth)                     / 16);
       PadCapsInfo.ScreenHeight         =  ((Palm.SimulHeight - Palm.MenuHeight)  / 16);
    } else {

       PadCapsInfo.ScreenWidth          =  ((Palm.ScreenWidth)                    / 16);
       PadCapsInfo.ScreenHeight         =  ((Palm.ScreenHeight - Palm.MenuHeight) / 16);
    }
    PadCapsInfo.VScreenWidth            =  ((Palm.VirtualScreenWidth)             / 16);
    PadCapsInfo.VScreenHeight           =  ((Palm.VirtualScreenHeight)            / 16);

    PadCapsInfo.IntegrationLevel        =  PDAIntegrationLevel;

    PadCapsInfo.CompressMethodSupported =  RequireCompressMethod;
    PadCapsInfo.LineSpeedSupported      =  LineSpeed;
    PadCapsInfo.Terminator              =  0;


    PadFeaturesInfo.Command             =  'F';
    PadFeaturesInfo.Len                 =  sizeof(PadFeaturesInfo);
    CopyMemory(PadFeaturesInfo.Features, PadSettings.Features, sizeof(PadSettings.Features));

    // BITFIELD 1....................................................
    PadFeaturesInfo.Features [0]       |=  ((TRUE                           ) != 0);        // SCROLL
    PadFeaturesInfo.Features [0]       |=  ((PadSettings.EnablePenUp        ) != 0) << 1;
    PadFeaturesInfo.Features [0]       |=  ((PadSettings.EnablePenMove      ) != 0) << 2;
    PadFeaturesInfo.Features [0]       |=  ((PadSettings.EnablePenClicks    ) != 0) << 3;
    PadFeaturesInfo.Features [0]       |=  ((TRUE                           ) != 0) << 4;   // NEW X SCROLL

    // BITFIELD 2....................................................
    PadFeaturesInfo.Features [1]       |=  ((PadSettings.ImageCapsRequested & PDA_CAPDYNATABLE) != 0);
    PadFeaturesInfo.Features [1]       |=  ((PadSettings.ImageCapsRequested & PDA_CAPDYNAPALETTE) != 0) << 1;

    PadFeaturesInfo.Features [1]       |=  (PadSettings.EnableTransparency) << 4;  // SUPORT TRANSPARENCY

    // BITFIELD 3....................................................
    PadFeaturesInfo.Features [2]       |=  ((PadSettings.ImageCapsRequested & PDA_CAPMULTIPHASE) != 0);

    // REMOVE ALL MENUS AND KEYBOARDS....
    // PadFeaturesInfo.Features [2]       |=  ( 2 | 4 | 8 | 16 | 32 | 64 | 128);

    // BITFIELD 4....................................................
    PadFeaturesInfo.Features [3]       |=  1;   // XOR FEATURE MANDATORY IN EMU
    PadFeaturesInfo.Features [3]       |=  2;   // XOR FEATURE FOR TEXT CONFIG MANDATORY IN EMU
    PadFeaturesInfo.Features [3]       |=  (UnicodeSupport ? 4 : 0); // UNICODE SUPPORT
    PadFeaturesInfo.Features [3]       |=  128; // EnhanceStatus Transmitted In Beacon

    // BITFIELD 6....................................................
    // PadFeaturesInfo.Features [5]       |=  1;   // TIME  SYNC
    PadFeaturesInfo.Features [5]       |=  2;   // FOCUS RECT
    PadFeaturesInfo.Features [5]       |=  4;   // EXTENDED FOCUS RECT SUPPORT

    // BITFIELD 7....................................................
    PadFeaturesInfo.Features [6]       |=  (SupportFlexiblePageSize ? 8  : 0);   // : NEW
    PadFeaturesInfo.Features [6]       |=  (SupportShowPage         ? 16 : 0);   // : NEW
    PadFeaturesInfo.Features [6]       |=  (UseCacheMemory          ? 32 : 0);

    //PadFeaturesInfo.Features [6]       |=  (UseBiosTransfer  ? 64  : 0);
    //PadFeaturesInfo.Features [6]       |=  (UseFilesTransfer ? 128 : 0);

    // BITFIELD 8....................................................
    PadFeaturesInfo.Features [7]       |=  32; // PDA_SUPPORT_SUPPORTJPEG
    PadFeaturesInfo.Features [7]       |=  (EnabledRequireCompressMethod ? 64 : 0);
    PadFeaturesInfo.Features [7]       |=  128; // Use Enhance SequenceID MANDATORY IN EMU

    PadFeaturesInfo.Terminator          =  0;

    CopyMemory(LoadStream, &InitInfo,            sizeof(InitInfo));        LoadStream += sizeof(InitInfo);
    CopyMemory(LoadStream, &PadCapsInfo,         sizeof(PadCapsInfo));     LoadStream += sizeof(PadCapsInfo);
    CopyMemory(LoadStream, &PadFeaturesInfo,     sizeof(PadFeaturesInfo)); LoadStream += sizeof(PadFeaturesInfo);

    if(SizeofUserID){
       CopyMemory(LoadStream, UserID,            SizeofUserID);            LoadStream += SizeofUserID;
    }
    if(SizeofPassword){
       CopyMemory(LoadStream, Password,          SizeofPassword);          LoadStream += SizeofPassword;
    }
    if(SizeofSerialNo){
       CopyMemory(LoadStream, SerialNo,          SizeofSerialNo);          LoadStream += SizeofSerialNo;
    }
    if(SizeofBrandName){
       CopyMemory(LoadStream, BrandName,         SizeofBrandName);         LoadStream += SizeofBrandName;
    }
    if(SizeofModelName){
       CopyMemory(LoadStream, ModelName,         SizeofModelName);         LoadStream += SizeofModelName;
    }
    if(SizeofEncryptKey){
       CopyMemory(LoadStream, EncryptKey,        SizeofEncryptKey);        LoadStream += SizeofEncryptKey;
    }
    // NEW SIM SUPPORT...
    if(SizeofIMEIKey){
       CopyMemory(LoadStream, IMEIKey,           SizeofIMEIKey);           LoadStream += SizeofIMEIKey;
    }
    if(SizeofIMSIKey){
       CopyMemory(LoadStream, IMSIKey,           SizeofIMSIKey);           LoadStream += SizeofIMSIKey;
    }
    if(SizeofCCIDKey){
       CopyMemory(LoadStream, CCIDKey,           SizeofCCIDKey);           LoadStream += SizeofCCIDKey;
    }
    if(SizeofSimTelKey){
       CopyMemory(LoadStream, SimTelKey,         SizeofSimTelKey);         LoadStream += SizeofSimTelKey;
    }

    if(UseCacheMemory){
       CopyMemory(LoadStream, &CacheInfo,        sizeof(CacheInfo));       LoadStream += sizeof(CacheInfo);
    }
    if(UnicodeSupport){
       CopyMemory(LoadStream, &PadLangIdInfo,    sizeof(PadLangIdInfo));   LoadStream += sizeof(PadLangIdInfo);
    }
    if(ActionMode == 'D'){
       CopyMemory(LoadStream, &PageIdInfo,       sizeof(PageIdInfo));      LoadStream += sizeof(PageIdInfo);
    }

    Ret = WriteChannelBuffer((LPCSTR)theStream, (InitInfo.Len + sizeof(InitInfo)));
	if(Not Ret){
       EchoSendError(_T("Init Command! failled to send"));
	   return FALSE;
	}
    Palm.InitSequenceComplete = FALSE;
	return Ret;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall SendAConfig()
{DLL_THREAD_MANAGEMENT();

BOOL           Ret;
BYTE           theStream[4096];
LPBYTE         LoadStream = theStream;
BYTE           SizeofDialNumber = 0, SizeofInitModemString = 0, SizeOfSetStack = 0;
char           InitModemString    [196];
char           DialNumber         [64];
CString        TempDialNumber     (_T(""));
CString        ProcessingString   (_T(""));
BYTE           SettingsStack      [32];
INITINFO       ConfigInfo;
CString        Info;

    if (Not IsLocalPortOpen()) {
       //'MsgBox ("Port IO should be open prior to send command...")
       return FALSE;
    }
    short    BaudSpeed                   = 96;
    BOOL     AutoRedial                  = TRUE;
    short    RedialDelay                 = 5;
    short    TimeoutConnect              = 30;

    ZeroMemory(&InitModemString,           sizeof(InitModemString));
    ZeroMemory(&DialNumber,                sizeof(DialNumber));


    ZeroMemory(&SettingsStack,             sizeof(SettingsStack));
    SettingsStack [0]                    = 'S';
    SettingsStack [1]                    = 11; // SIZE OF THIS STACK
    SettingsStack [2]                    = LOBYTE(BaudSpeed);
    SettingsStack [3]                    = HIBYTE(BaudSpeed);
    SettingsStack [4]                    = (AutoRedial != 0) & 1;
    SettingsStack [5]                    = 0;
    SettingsStack [6]                    = LOBYTE(TimeoutConnect);
    SettingsStack [7]                    = HIBYTE(TimeoutConnect);
    SettingsStack [8]                    = LOBYTE(RedialDelay);
    SettingsStack [9]                    = LOBYTE(RedialDelay);
    SettingsStack [10]                   = 0;
    SizeOfSetStack                       = SettingsStack [1] + 1;

    if(m_PortName.Left(3).CompareNoCase(_T("Com")) == 0){
       TempDialNumber                   = ModemDialString;
    } else {
       TempDialNumber.Format( _T("%s:%s"), m_PortName, m_PortSettings);
    }
    //if((TempDialNumber != "")){

       ProcessingString                  = (TempDialNumber);

       DialNumber[0]                     = 'D';
       DialNumber[1]                     = ' ';
       SizeofDialNumber                  = BuildStringPacket (DialNumber, ProcessingString, 2);
    //}
    //if( (ModemInitString != "")){
       ProcessingString                  = (ModemInitString);

       InitModemString[0]                = 'I';
       InitModemString[1]                = ' ';
       SizeofInitModemString             = BuildStringPacket (InitModemString, ProcessingString, 2);
    //}
    ///////////////////////////////////////////////////////////////////////////////////////////////

    ZeroMemory(&ConfigInfo,               sizeof(ConfigInfo));

    ConfigInfo.Command                   = CommandCode;
    ConfigInfo.SubCommand                = 'R';
    ConfigInfo.MajorLSB                  =  2;
    ConfigInfo.MinorMSB                  =  0;
    ConfigInfo.Action                    = 'S';
    ConfigInfo.Len                       =  SizeofDialNumber
                                         +  SizeOfSetStack
                                         +  SizeofInitModemString;

    ConfigInfo.Terminator                = (0x1A);

    ///////////////////////////////////////////////////////////////////////////////////////////////
    CopyMemory(LoadStream, &ConfigInfo,          sizeof(ConfigInfo));      LoadStream += sizeof(ConfigInfo);

    if(SizeOfSetStack){
       CopyMemory(LoadStream, SettingsStack,     SizeOfSetStack);          LoadStream += SizeOfSetStack;
    }
    if(SizeofDialNumber){
       CopyMemory(LoadStream, DialNumber,  SizeofDialNumber);        LoadStream += SizeofDialNumber;
    }
    if(SizeofInitModemString){
       CopyMemory(LoadStream, InitModemString,   SizeofInitModemString);   LoadStream += SizeofInitModemString;
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////
    Ret = WriteChannelBuffer((LPCSTR)theStream, (ConfigInfo.Len + sizeof(ConfigInfo)));
	if(Not Ret){
       EchoSendError(_T("Init Command! failled to send"));
	   return FALSE;
	}
	return Ret;
}
///////////////////////////////////////////////////////////////////////////////////////////////////

} // extern "C"
