// Echo.cpp
///////////////////////////////////////////////////////////////////////////////////////////////////
#include "StdAfx.h"

///////////////////////////////////////////////////////////////////////////////////////////////////
PDASettings  PadSettings;
CString      TextEcho, RawEcho, StatusEcho (_T("Ready"));
DWORD        CurrentStatusCode, CurrentStatusError;

#define MAXTEXT 32 * KB
#if USE_ECHO
///////////////////////////////////////////////////////////////////////////////////////////////////
CCriticalSection      CriticalEchoAccess;
DCTimeout             EventTimeLock;
///////////////////////////////////////////////////////////////////////////////////////////////////
// HERE WE NEED A CRITCAL ACCESS BECAUSE ECHO COME FROM EITHER READ WRITE AND REPORT
///////////////////////////////////////////////////////////////////////////////////////////////////
extern "C" {

void (__stdcall* OnPadStatus)   (DWORD CurrentStatus);
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall TriggerEventStatus            ()
{DLL_THREAD_MANAGEMENT();

MSG  Msg;
BOOL bRet;

    bRet      = PeekMessage(&Msg, PadWndHandle, WM_NULL, WM_NULL, PM_NOREMOVE | PM_NOYIELD);
    if((bRet == 0)){
       PostMessage(PadWndHandle, WM_NULL, NOTIFY_ON_DEVICE_STATUS, CurrentStatusCode);
    }

/*
    // NO MORE THAN 16 PER SECOND
    if((EventTimeLock.Delay == 0) || (Not  EventTimeLock.StillInDelay()) ){

       EventTimeLock   . BeginDelay(32);

       if( ::IsWindow(PadWndHandle)) {
          PostMessage(PadWndHandle, WM_NULL, 0, CurrentStatusCode);
       }
       if(IsValidCodePointer((FARPROC) OnPadStatus) == FALSE){
          return;
       }
       (*OnPadStatus) (CurrentStatusCode);
    }
*/
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall RegisterPadStatus   (PADSTATUSPROC PadHandler)
{DLL_THREAD_MANAGEMENT();

    if(IsValidCodePointer((FARPROC) PadHandler) == FALSE){
       OnPadStatus = NULL;
       return FALSE;
    }
    OnPadStatus = PadHandler;
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void PushStatusState               (DWORD  StatusFlags)
{
    CurrentStatusCode  |= StatusFlags;
    TriggerEventStatus ();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void PullStatusState               (DWORD  StatusFlags)
{
    CurrentStatusCode  &= ~StatusFlags;
    TriggerEventStatus ();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void ResetStatusState               ()
{
    CurrentStatusCode  = STATUSNOTHING;
    CurrentStatusError = STATUSNOTHING;
    TriggerEventStatus ();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
void EchoStatus(LPCTSTR Why)
{
CString TempText;

#ifdef _DEBUG
    TempText.Format(_T("\r\nStatus: %s "), Why);
    OutputDebugString(TempText);
#endif

    if (PadSettings.All  == ECHONONE){
       return;
    }
    if ((PadSettings.All == ECHOONFILTER) || PadSettings.Status) {

       CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
       if(UpdateSingleLock.IsLocked()){

          if ((StatusEcho.GetLength()) > (MAXTEXT)) {
              StatusEcho = StatusEcho.Right((MAXTEXT / 2));
          }
          TempText.Format(_T("%s "), Why);
          StatusEcho = TempText;

          UpdateSingleLock.Unlock();
          TriggerEventStatus ();
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void EchoText(LPCTSTR Why)
{
CString TempText;

#ifdef _DEBUG
    TempText.Format(_T("\r\n%s "), Why);
    OutputDebugString(TempText);
#endif

    if (PadSettings.All  == ECHONONE){
       return;
    }
    if ((PadSettings.All == ECHOONFILTER) || PadSettings.Text) {

       CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
       if(UpdateSingleLock.IsLocked()){

          if ((TextEcho.GetLength()) > (MAXTEXT)) {
              TextEcho = TextEcho.Right((MAXTEXT / 2));
          }
          TempText.Format(_T("\r\n%s "), Why);
          TextEcho += TempText;

          UpdateSingleLock.Unlock();
          TriggerEventStatus ();
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void EchoError(LPCTSTR Why)
{
CString TempText;

#ifdef _DEBUG
    TempText.Format(_T("\r\nError: %s "), Why);
    OutputDebugString(TempText);
#endif

    if (PadSettings.All  == ECHONONE){
       return;
    }
    if ((PadSettings.All == ECHOONFILTER) || PadSettings.Errors) {

       CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
       if(UpdateSingleLock.IsLocked()){

          if ((TextEcho.GetLength()) > (MAXTEXT)) {
              TextEcho = TextEcho.Right((MAXTEXT / 2));
          }
          TempText.Format(_T("\r\nError: %s "), Why);
          TextEcho += TempText;

          UpdateSingleLock.Unlock();
          TriggerEventStatus ();
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void EchoSendError(LPCTSTR Why)
{
CString TempText;

#ifdef _DEBUG
    TempText.Format(_T("\r\nSend Error: %s "), Why);
    OutputDebugString(TempText);
#endif

    if (PadSettings.All  == ECHONONE){
       return;
    }
    if ((PadSettings.All == ECHOONFILTER) || PadSettings.Errors) {

       CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
       if(UpdateSingleLock.IsLocked()){

          if ((TextEcho.GetLength()) > (MAXTEXT)) {
              TextEcho = TextEcho.Right((MAXTEXT / 2));
          }
          TempText.Format(_T("\r\nSend Error: %s "), Why);
          TextEcho += TempText;

          UpdateSingleLock.Unlock();
          TriggerEventStatus ();
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void EchoCommandError(BYTE CommandBuffer[8])
{
CString TempText;
int     theLoop = 0;

#ifdef _DEBUG
    TempText.Format(_T("\r\nCommand Error: 0x%X 0x%X 0x%X 0x%X 0x%X 0x%X 0x%X 0x%X "),
                    (int)CommandBuffer[0], (int)CommandBuffer[1],
                    (int)CommandBuffer[2], (int)CommandBuffer[3],
                    (int)CommandBuffer[4], (int)CommandBuffer[5],
                    (int)CommandBuffer[6], (int)CommandBuffer[7]);
    OutputDebugString(TempText);
#endif

    if (PadSettings.All  == ECHONONE){
       return;
    }
    if ((PadSettings.All == ECHOONFILTER) || PadSettings.Errors) {

       CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
       if(UpdateSingleLock.IsLocked()){

          if ((TextEcho.GetLength()) > (MAXTEXT)) {
              TextEcho = TextEcho.Right((MAXTEXT / 2));
          }
          TempText.Format(_T("\r\nCommand Error: 0x%X 0x%X 0x%X 0x%X 0x%X 0x%X 0x%X 0x%X "),
                          (int)CommandBuffer[0], (int)CommandBuffer[1],
                          (int)CommandBuffer[2], (int)CommandBuffer[3],
                          (int)CommandBuffer[4], (int)CommandBuffer[5],
                          (int)CommandBuffer[6], (int)CommandBuffer[7]);

          TextEcho += TempText;

          UpdateSingleLock.Unlock();
          TriggerEventStatus ();
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void EchoRcvError(long ErrCode, long ErrCount)
{
CString TempText;

#ifdef _DEBUG
    TempText.Format(_T("\r\nRcv Error: Code:%d ErrCount: %d "), ErrCode, ErrCount);
    OutputDebugString(TempText);
#endif

    if (PadSettings.All  == ECHONONE){
       return;
    }
    if ((PadSettings.All == ECHOONFILTER) || PadSettings.Errors) {

       CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
       if(UpdateSingleLock.IsLocked()){

          if ((TextEcho.GetLength()) > (MAXTEXT)) {
              TextEcho = TextEcho.Right((MAXTEXT / 2));
          }
          TempText.Format(_T("\r\nRcv Error: Code:%d ErrCount: %d "), ErrCode, ErrCount);
          TextEcho += TempText;

          UpdateSingleLock.Unlock();
          TriggerEventStatus ();
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void EchoImageError(long RcvData, long SumData)
{
CString TempText;

#ifdef _DEBUG
    TempText.Format(_T("\r\nImage Error: RcvData:%d SumData: %d "), RcvData, SumData);
    OutputDebugString(TempText);
#endif

    if (PadSettings.All  == ECHONONE){
       return;
    }
    if ((PadSettings.All == ECHOONFILTER) || PadSettings.Errors) {

       CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
       if(UpdateSingleLock.IsLocked()){

          if ((TextEcho.GetLength()) > (MAXTEXT)) {
              TextEcho = TextEcho.Right((MAXTEXT / 2));
          }
          TempText.Format(_T("\r\nImage Error: RcvData:%d SumData: %d "), RcvData, SumData);
          TextEcho += TempText;

          UpdateSingleLock.Unlock();
          TriggerEventStatus ();
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void EchoFrameError(long SeqID, long FrameID, long DstX, long DstY, long DstW, long DstH, long SumData)
{
CString TempText;

#ifdef _DEBUG
    TempText.Format(_T("\r\nFrame Err: SID: %3d FID: %3d X: %4d Y: %4d W: %4d H: %4d Sum: %d"),
                    SeqID, FrameID, DstX, DstY, DstW, DstH, SumData);
    OutputDebugString(TempText);
#endif

    if (PadSettings.All  == ECHONONE){
       return;
    }
    if ((PadSettings.All == ECHOONFILTER) || PadSettings.Errors) {

       CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
       if(UpdateSingleLock.IsLocked()){

          if ((TextEcho.GetLength()) > (MAXTEXT)) {
              TextEcho = TextEcho.Right((MAXTEXT / 2));
          }
          TempText.Format(_T("\r\nFrame Err: SID:%3d FID: %3d X: %4d Y: %4d W: %4d H: %4d Sum: %d"),
                          SeqID, FrameID, DstX, DstY, DstW, DstH, SumData);
          TextEcho += TempText;

          UpdateSingleLock.Unlock();
          TriggerEventStatus ();
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void EchoG3Error(LPCSTR TheColor, long ThePos, long PacketLen)
{
CString TempText;

#ifdef _DEBUG
    TempText.Format(_T("\r\nG3 Error Type: %s, At: %d, From: %d "), TheColor, ThePos, PacketLen);
    OutputDebugString(TempText);
#endif

    if (PadSettings.All  == ECHONONE){
       return;
    }
    if ((PadSettings.All == ECHOONFILTER) || PadSettings.Errors) {

       CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
       if(UpdateSingleLock.IsLocked()){

          if ((TextEcho.GetLength()) > (MAXTEXT)) {
              TextEcho = TextEcho.Right((MAXTEXT / 2));
          }
          TempText.Format(_T("\r\nG3 Error Type: %s, At: %d, From: %d "), TheColor, ThePos, PacketLen);
          TextEcho += TempText;

          UpdateSingleLock.Unlock();
          TriggerEventStatus ();
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
// INFO...
///////////////////////////////////////////////////////////////////////////////////////////////////
void EchoTimeDuration(long TimeStart, long TimeEnd)
{
CString TempText;

    if (PadSettings.All  == ECHONONE){
       return;
    }
    if ((PadSettings.All == ECHOONFILTER) || PadSettings.TimeStamp) {

       CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
       if(UpdateSingleLock.IsLocked()){

          if ((TextEcho.GetLength()) > (MAXTEXT)) {
             TextEcho = TextEcho.Right((MAXTEXT / 2));
          }
          TempText.Format(_T("\r\nTimeDuration: %d "), abs(TimeEnd - TimeStart));
          TextEcho += TempText;

          UpdateSingleLock.Unlock();
          TriggerEventStatus ();
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void EchoTimeStamp()
{
CString   TempText;
TCHAR     TimeString [256];
struct tm PadTm;
time_t    PadTime;

    if (PadSettings.All  == ECHONONE){
       return;
    }
    if ((PadSettings.All == ECHOONFILTER) || PadSettings.TimeStamp) {

       CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
       if(UpdateSingleLock.IsLocked()){

          if ((TextEcho.GetLength()) > (MAXTEXT)) {
             TextEcho = TextEcho.Right((MAXTEXT / 2));
          }
//          if(PadSettings.TimeStamp) {
             time( &PadTime );
             PadTm   = *localtime( &PadTime );
             _tcsftime( TimeString, 256, _T("Pad time: %a %b %d %I:%M:%S %p %Y %Z"), &PadTm );

             TempText.Format(_T("\r\nRet Command: %s "), TimeString);
             TextEcho += TempText;
//          }

          UpdateSingleLock.Unlock();
          TriggerEventStatus ();
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void EchoBeacon(BYTE CommandBuffer[8])
{
CString   TempText;
TCHAR      TimeString [256];
struct tm PadTm;
time_t    PadTime;
BYTE      XLSB, XMSB, YLSB, YMSB;
long      VirtualX, VirtualY;

    if (PadSettings.All  == ECHONONE){
       return;
    }
    if ((PadSettings.All == ECHOONFILTER) || PadSettings.Beacon) {

       CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
       if(UpdateSingleLock.IsLocked()){

          if ((TextEcho.GetLength()) > (MAXTEXT)) {
             TextEcho = TextEcho.Right((MAXTEXT / 2));
          }
//          if(PadSettings.TimeStamp) {
             time( &PadTime );
             PadTm   = *localtime( &PadTime );
             _tcsftime( TimeString, 256, _T("Pad time: %a %b %d %I:%M:%S %p %Y %Z"), &PadTm );

             TempText.Format(_T("\r\nRet Beacon: %s "), TimeString);

             OutputDebugString(TempText);
             TextEcho += TempText;

             // PADREFRESH = 0,PADSETPOS = 1, PADADRESSDOWN = 2, WEBINTRANSITION = 4, PDAPAGEREADY = 0X10
             if (CommandBuffer[6] & PADADRESSDOWN) {
                TempText.Format(_T("\r\nAdBar Status: %d"), 1);
             } else {
                TempText.Format(_T("\r\nAdBar Status: %d"), 0);
             }
             if(CommandBuffer[6] & WEBINTRANSITION){

                TempText += _T(", WebPage Status: in transition");
             }
             if(CommandBuffer[6] & PDAPAGEREADY){
                TempText += _T(", Transfer Status: Complete");
             }
             if (CommandBuffer[6] & PADSETPOS)
             {
             CString PosString;

                XLSB = CommandBuffer[2];
                XMSB = CommandBuffer[3];

                YLSB = CommandBuffer[4];
                YMSB = CommandBuffer[5];

                VirtualX  = XLSB + (XMSB * 256);
                VirtualY  = YLSB + (YMSB * 256);
                PosString.Format(_T(", SetPos: %d, %d "), VirtualX, VirtualY );
                TempText += PosString;
             }
             OutputDebugString(TempText);
             TextEcho += TempText;

//          }
          UpdateSingleLock.Unlock();
          TriggerEventStatus ();
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void EchoScroll(long ScrollID, long DstX, long DstY, long SrcX, long SrcY, long SrcW, long SrcH)
{
CString   TempText;
TCHAR     TimeString [256];
struct tm PadTm;
time_t    PadTime;

#ifdef _DEBUG
    TempText.Format(_T("\r\nScrollID: %3d DstX: %4d DstY: %4d SrcX: %4d SrcY: %4d SrcW: %4d SrcH: %4d "),
                    ScrollID, DstX, DstY, SrcX, SrcY, SrcW, SrcH);
    OutputDebugString(TempText);
#endif

    if (PadSettings.All  == ECHONONE){
       return;
    }
    if ((PadSettings.All == ECHOONFILTER) || PadSettings.Scroll) {

       CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
       if(UpdateSingleLock.IsLocked()){

          if ((TextEcho.GetLength()) > (MAXTEXT)) {
             TextEcho = TextEcho.Right((MAXTEXT / 2));
          }
          if(PadSettings.TimeStamp) {
             time( &PadTime );
             PadTm   = *localtime( &PadTime );
             _tcsftime( TimeString, 256, _T("Pad time: %a %b %d %I:%M:%S %p %Y %Z"), &PadTm );

             TempText.Format(_T("\r\nRcv Command: %s "), TimeString);
             TextEcho += TempText;
          }

          TempText.Format(_T("\r\nScrollID: %3d DstX: %4d DstY: %4d SrcX: %4d SrcY: %4d SrcW: %4d SrcH: %4d "),
                          ScrollID, DstX, DstY, SrcX, SrcY, SrcW, SrcH);
          TextEcho += TempText;

          UpdateSingleLock.Unlock();
          TriggerEventStatus ();
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void EchoFrame(long SeqID, long FrameID, long DstX, long DstY, long DstW, long DstH, long SumData)
{
CString   TempText;
TCHAR     TimeString [256];
struct tm PadTm;
time_t    PadTime;

#ifdef _DEBUG
    TempText.Format(_T("\r\nFrame SID: %3d FID: %3d DstX: %4d DstY: %4d DstW: %4d DstH: %4d Sum: %d "),
                    SeqID, FrameID, DstX, DstY, DstW, DstH, SumData);
    OutputDebugString(TempText);
#endif

    if (PadSettings.All  == ECHONONE){
       return;
    }
    if ((PadSettings.All == ECHOONFILTER) || PadSettings.Frame) {

       CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
       if(UpdateSingleLock.IsLocked()){

          if ((TextEcho.GetLength()) > (MAXTEXT)) {
             TextEcho = TextEcho.Right((MAXTEXT / 2));
          }
          if(PadSettings.TimeStamp) {
             time( &PadTime );
             PadTm   = *localtime( &PadTime );
             _tcsftime( TimeString, 256, _T("Pad time: %a %b %d %I:%M:%S %p %Y %Z"), &PadTm );

             TempText.Format(_T("\r\nRcv Command: %s "), TimeString);
             TextEcho += TempText;
          }

          TempText.Format(_T("\r\nFrame SID: %3d FID: %3d DstX: %4d DstY: %4d DstW: %4d DstH: %4d Sum: %d "),
                          SeqID, FrameID, DstX, DstY, DstW, DstH, SumData);
          TextEcho += TempText;

          UpdateSingleLock.Unlock();
          TriggerEventStatus ();
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void EchoPalette(long SeqID, long FrameID, BYTE Action)
{
CString   TempText;
CString   ActionStr;
TCHAR     TimeString [256];
struct tm PadTm;
time_t    PadTime;

    if(Action        == 'R'){
       ActionStr      = (_T("Requesting current palette"));
    } else if(Action == 'S'){
       ActionStr      = (_T("Receiving a new palette"));
    } else {
       ActionStr      = (_T("Unknown Palette action!"));
    }
#ifdef _DEBUG
    TempText.Format(_T("\r\nPalette SID: %3d FID: %3d %s "),
                    SeqID, FrameID, ActionStr);
    OutputDebugString(TempText);
#endif

    if (PadSettings.All  == ECHONONE){
       return;
    }
    if ((PadSettings.All == ECHOONFILTER) || PadSettings.Frame) {

       CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
       if(UpdateSingleLock.IsLocked()){

          if ((TextEcho.GetLength()) > (MAXTEXT)) {
             TextEcho = TextEcho.Right((MAXTEXT / 2));
          }
          if(PadSettings.TimeStamp) {
             time( &PadTime );
             PadTm   = *localtime( &PadTime );
             _tcsftime( TimeString, 256, _T("Pad time: %a %b %d %I:%M:%S %p %Y %Z"), &PadTm );

             TempText.Format(_T("\r\nRcv Palette Cmd: %s "), TimeString);
             TextEcho += TempText;
          }
          TempText.Format(_T("\r\nPal...SID: %3d FID: %3d %s"), SeqID, FrameID, ActionStr);
          TextEcho += TempText;

          UpdateSingleLock.Unlock();
          TriggerEventStatus ();
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void  EchoCacheCommand (long SeqID, long FrameID, BYTE Action)
{
CString   TempText;
CString   ActionStr;
TCHAR     TimeString [256];
struct tm PadTm;
time_t    PadTime;

    if(Action        == 'D'){
       ActionStr      = (_T("Show Cached Page"));
    } else if(Action == 'C'){
       ActionStr      = (_T("Clear Cached Page"));
    } else if(Action == 'I'){
       ActionStr      = (_T("Init Cache command!"));
    } else {
       ActionStr      = (_T("Update Cache Data Info!"));
    }
    if (PadSettings.All  == ECHONONE){
       return;
    }
    if ((PadSettings.All == ECHOONFILTER) || PadSettings.Frame) {

       CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
       if(UpdateSingleLock.IsLocked()){

          if ((TextEcho.GetLength()) > (MAXTEXT)) {
             TextEcho = TextEcho.Right((MAXTEXT / 2));
          }
          if(PadSettings.TimeStamp) {
             time( &PadTime );
             PadTm   = *localtime( &PadTime );
             _tcsftime( TimeString, 256, _T("Pad time: %a %b %d %I:%M:%S %p %Y %Z"), &PadTm );

             TempText.Format(_T("\r\nRcv Cache Cmd: %s "), TimeString);
             TextEcho += TempText;
          }
          TempText.Format(_T("\r\nCache SID: %3d FID: %3d %s"), SeqID, FrameID, ActionStr);
          TextEcho += TempText;

          UpdateSingleLock.Unlock();
          TriggerEventStatus ();
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void EchoAck(long SeqID, long FrameID, BYTE CurrentPhase)
{
#if 1
CString   TempText;
TCHAR     TimeString [256];
struct tm PadTm;
time_t    PadTime;

#ifdef _DEBUG
    TempText.Format(_T("\r\n>>Ack SID: %3d FID: %3d Phase: %3d"), SeqID, FrameID, CurrentPhase);
    OutputDebugString(TempText);
#endif

    if (PadSettings.All  == ECHONONE){
       return;
    }
    if ((PadSettings.All == ECHOONFILTER) || PadSettings.Frame) {

       CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
       if(UpdateSingleLock.IsLocked()){

          if ((TextEcho.GetLength()) > (MAXTEXT)) {
             TextEcho = TextEcho.Right((MAXTEXT / 2));
          }
          if(PadSettings.TimeStamp) {
             time( &PadTime );
             PadTm   = *localtime( &PadTime );
             _tcsftime( TimeString, 256, _T("Pad time: %a %b %d %I:%M:%S %p %Y %Z"), &PadTm );

             TempText.Format(_T("\r\nRcv Command: %s "), TimeString);
             TextEcho += TempText;
          }

          TempText.Format(_T("\r\n>>Ack SID: %3d FID: %3d Phase: %3d"), SeqID, FrameID, CurrentPhase);

          TextEcho += TempText;

          UpdateSingleLock.Unlock();
          TriggerEventStatus ();
       }
    }
#endif
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void EchoNAck(long SeqID, long FrameID, BYTE CurrentPhase)
{
CString   TempText;
TCHAR     TimeString [256];
struct tm PadTm;
time_t    PadTime;

#ifdef _DEBUG
    TempText.Format(_T("\r\n>NAck SID: %3d FID: %3d Phase: %3d"), SeqID, FrameID, CurrentPhase);
    OutputDebugString(TempText);
#endif

    if (PadSettings.All  == ECHONONE){
       return;
    }
    if ((PadSettings.All == ECHOONFILTER) || PadSettings.Frame) {

       CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
       if(UpdateSingleLock.IsLocked()){

          if ((TextEcho.GetLength()) > (MAXTEXT)) {
             TextEcho = TextEcho.Right((MAXTEXT / 2));
          }
          if(PadSettings.TimeStamp) {
             time( &PadTime );
             PadTm   = *localtime( &PadTime );
             _tcsftime( TimeString, 256, _T("Pad time: %a %b %d %I:%M:%S %p %Y %Z"), &PadTm );

             TempText.Format(_T("\r\nRcv Command: %s "), TimeString);
             TextEcho += TempText;
          }

          TempText.Format(_T("\r\n>NAck SID: %3d FID: %3d Phase: %3d"), SeqID, FrameID, CurrentPhase);

          TextEcho += TempText;

          UpdateSingleLock.Unlock();
          TriggerEventStatus ();
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void EchoFill(long SeqID, long FrameID, long DstX, long DstY, long DstW, long DstH, long WordMask)
{
CString   TempText;
TCHAR     TimeString [256];
struct tm PadTm;
time_t    PadTime;

#ifdef _DEBUG
    TempText.Format(_T("\r\nFill SID: %3d FID: %3d DstX =%4d DstY =%4d DstW =%4d DstH =%4d WordMask = 0x%X "),
                   SeqID, FrameID, DstX, DstY, DstW, DstH, WordMask);
    OutputDebugString(TempText);
#endif

    if (PadSettings.All  == ECHONONE){
       return;
    }
    if ((PadSettings.All == ECHOONFILTER) || PadSettings.Fill) {

       CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
       if(UpdateSingleLock.IsLocked()){

          if ((TextEcho.GetLength()) > (MAXTEXT)) {
             TextEcho = TextEcho.Right((MAXTEXT / 2));
          }
          if(PadSettings.TimeStamp) {
             time( &PadTime );
             PadTm   = *localtime( &PadTime );
             _tcsftime( TimeString, 256, _T("Pad time: %a %b %d %I:%M:%S %p %Y %Z"), &PadTm );

             TempText.Format(_T("\r\nFill Command: %s "), TimeString);
             TextEcho += TempText;
          }

          TempText.Format(_T("\r\nFill SID: %3d FID: %3d DstX =%4d DstY =%4d DstW =%4d DstH =%4d WordMask = 0x%X "),
                         SeqID, FrameID, DstX, DstY, DstW, DstH, WordMask);
          TextEcho += TempText;

          UpdateSingleLock.Unlock();
          TriggerEventStatus ();
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void EchoSync(long SeqID, long FrameID)
{
CString   TempText;
TCHAR     TimeString [256];
struct tm PadTm;
time_t    PadTime;

#ifdef _DEBUG
    TempText.Format(_T("\r\nSync SID: %3d FID: %3d "),
                   SeqID, FrameID);
    OutputDebugString(TempText);
#endif

    if (PadSettings.All  == ECHONONE){
       return;
    }
    if ((PadSettings.All == ECHOONFILTER) || PadSettings.Fill) {

       CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
       if(UpdateSingleLock.IsLocked()){

          if ((TextEcho.GetLength()) > (MAXTEXT)) {
             TextEcho = TextEcho.Right((MAXTEXT / 2));
          }
          if(PadSettings.TimeStamp) {
             time( &PadTime );
             PadTm   = *localtime( &PadTime );
             _tcsftime( TimeString, 256, _T("Pad time: %a %b %d %I:%M:%S %p %Y %Z"), &PadTm );

             TempText.Format(_T("\r\nSync Command: %s "), TimeString);
             TextEcho += TempText;
          }

          TempText.Format(_T("\r\nSync SID: %3d FID: %3d "), SeqID, FrameID);
          TextEcho += TempText;

          UpdateSingleLock.Unlock();
          TriggerEventStatus ();
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void EchoTask(BYTE CommandBuffer[8])
{
CString TempText;
int     theLoop = 0;

#if 0
    TempText.Format("\r\nTask Command: 0x%X 0x%X 0x%X 0x%X 0x%X 0x%X 0x%X 0x%X ",
                    (int)CommandBuffer[0], (int)CommandBuffer[1],
                    (int)CommandBuffer[2], (int)CommandBuffer[3],
                    (int)CommandBuffer[4], (int)CommandBuffer[5],
                    (int)CommandBuffer[6], (int)CommandBuffer[7]);
    OutputDebugString(TempText);
#endif

    if (PadSettings.All  == ECHONONE){
       return;
    }
    if ((PadSettings.All == ECHOONFILTER) || PadSettings.Task) {

       CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
       if(UpdateSingleLock.IsLocked()){

          if ((TextEcho.GetLength()) > (MAXTEXT)) {
             TextEcho = TextEcho.Right((MAXTEXT / 2));
          }
          TempText.Format(_T("\r\nTask Command: 0x%X 0x%X 0x%X 0x%X 0x%X 0x%X 0x%X 0x%X "),
                          (int)CommandBuffer[0], (int)CommandBuffer[1],
                          (int)CommandBuffer[2], (int)CommandBuffer[3],
                          (int)CommandBuffer[4], (int)CommandBuffer[5],
                          (int)CommandBuffer[6], (int)CommandBuffer[7]);
          TextEcho += TempText;

          UpdateSingleLock.Unlock();
          TriggerEventStatus ();
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void EchoByte(BYTE theByte)
{
CString TempText;

#ifdef _DEBUG
    TempText.Format(_T("%c"),theByte);
    OutputDebugString(TempText);
#endif

    if (PadSettings.All  == ECHONONE){
       return;
    }
    if ((PadSettings.All == ECHOONFILTER) || PadSettings.Raw  || PadSettings.Text) {

       CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
       if(UpdateSingleLock.IsLocked()){

          if ((TextEcho.GetLength()) > (MAXTEXT)) {
             TextEcho = TextEcho.Right((MAXTEXT / 2));
          }
          if ((RawEcho.GetLength()) > (MAXTEXT)) {
              RawEcho = RawEcho.Right((MAXTEXT / 2));
          }
          if ((PadSettings.All == ECHOONFILTER) || PadSettings.Text) {
             TempText.Format(_T("%c"),theByte);
             TextEcho += TempText;
          }
          if ((PadSettings.All == ECHOONFILTER) || PadSettings.Raw) {
             TempText.Format(_T(" 0x%X"), (int)theByte);
             RawEcho += TempText;
          }

          UpdateSingleLock.Unlock();
          TriggerEventStatus ();
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
// EXPORTED ACCESS ON ANOTHER THREAD MOST LIKELY...
///////////////////////////////////////////////////////////////////////////////////////////////////
DWORD __stdcall GetEchoFlags()
{DLL_THREAD_MANAGEMENT();

    return PadSettings.All              |
           PadSettings.Raw              |
           PadSettings.Text             |
           PadSettings.Frame            |
           PadSettings.Fill             |
           PadSettings.Scroll           |
           PadSettings.Beacon           |
           PadSettings.Task             |
           PadSettings.TimeStamp        |
           PadSettings.Status           |
           PadSettings.Errors           ;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall SetEchoFlags(DWORD EchoFlags)
{DLL_THREAD_MANAGEMENT();

    PadSettings.All              = EchoFlags & ECHOALLMASK;
    PadSettings.Raw              = EchoFlags & ECHORAW;
    PadSettings.Text             = EchoFlags & ECHOTEXT;
    PadSettings.Frame            = EchoFlags & ECHOFRAME;
    PadSettings.Fill             = ((EchoFlags & ECHOBEACON) ? TRUE : (EchoFlags & ECHOFILL));
    PadSettings.Scroll           = EchoFlags & ECHOSCROLL    || 1;
    PadSettings.Beacon           = EchoFlags & ECHOBEACON;
    PadSettings.Task             = EchoFlags & ECHOTASK;
    PadSettings.TimeStamp        = EchoFlags & ECHOTIME;
    PadSettings.Status           = EchoFlags & ECHOSTATUS;
    PadSettings.Errors           = EchoFlags & ECHOERRORS;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall GetEnableSendInitOnStart ()
{DLL_THREAD_MANAGEMENT();

    return PadSettings.SendInitOnStart;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall SetEnableSendInitOnStart (BOOL Toggle)
{DLL_THREAD_MANAGEMENT();

    PadSettings.SendInitOnStart = Toggle;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall GetEnableClearScreenOnStart ()
{DLL_THREAD_MANAGEMENT();

    return PadSettings.ClearScreenOnStart;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall SetEnableClearScreenOnStart (BOOL Toggle)
{DLL_THREAD_MANAGEMENT();

    PadSettings.ClearScreenOnStart = Toggle;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall GetEnableBeacon()
{DLL_THREAD_MANAGEMENT();

    return PadSettings.EnableSendBeacon;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall SetEnableBeacon(BOOL Toggle)
{DLL_THREAD_MANAGEMENT();

    PadSettings.EnableSendBeacon = Toggle;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall GetEnableProcess()
{DLL_THREAD_MANAGEMENT();

    return PadSettings.ProcessChannel;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall SetEnableProcess(BOOL Toggle)
{DLL_THREAD_MANAGEMENT();

    PadSettings.ProcessChannel   = Toggle;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall SetProcessFlags(DWORD ProcessFlags)
{DLL_THREAD_MANAGEMENT();

    PadSettings.ProcessChannel   = ProcessFlags & PROCESSCHANNEL;
    PadSettings.EnableSendBeacon = ProcessFlags & PROCESSSENDBEACON;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
DWORD __stdcall GetProcessFlags()
{DLL_THREAD_MANAGEMENT();

DWORD ProcessFlags;

    ProcessFlags  = (PadSettings.ProcessChannel   ? PROCESSCHANNEL    : 0);
    ProcessFlags |= (PadSettings.EnableSendBeacon ? PROCESSSENDBEACON : 0);
    return ProcessFlags;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall ClearStatus()
{DLL_THREAD_MANAGEMENT();

    CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
    if(UpdateSingleLock.IsLocked()){

       CurrentStatusError = STATUSNOTHING;

       UpdateSingleLock.Unlock();
       return TRUE;
    }
    return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall ClearEcho()
{DLL_THREAD_MANAGEMENT();

    CSingleLock UpdateSingleLock(&CriticalEchoAccess);  UpdateSingleLock.Lock();
    if(UpdateSingleLock.IsLocked()){

       TextEcho          = "";
       RawEcho           = "";

       UpdateSingleLock.Unlock();
       return TRUE;
    }
    return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
long __stdcall GetStatus()
{DLL_THREAD_MANAGEMENT();

    return CurrentStatusCode;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
long __stdcall GetStatusString (LPTSTR StringBuffer, long BufferSize)
{DLL_THREAD_MANAGEMENT();

    if(StringBuffer == NULL){
       return 0;
    }
    return StringCopy(StringBuffer, StatusEcho, BufferSize);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
long __stdcall GetTextEchoString (LPTSTR StringBuffer, long BufferSize)
{DLL_THREAD_MANAGEMENT();

    if(StringBuffer == NULL){
       return 0;
    }
    return StringCopy(StringBuffer, TextEcho, BufferSize);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
long __stdcall GetRawEchoString (LPTSTR StringBuffer, long BufferSize)
{DLL_THREAD_MANAGEMENT();

    if(StringBuffer == NULL){
       return 0;
    }
    return StringCopy(StringBuffer, RawEcho, BufferSize);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
} // extern "C"
///////////////////////////////////////////////////////////////////////////////////////////////////
#endif // USE_ECHO
///////////////////////////////////////////////////////////////////////////////////////////////////
