// Echo.h
///////////////////////////////////////////////////////////////////////////////////////////////////
extern "C" { // EXPORTABLE
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
#if USE_ECHO
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef  EchoWarnString
#define  OutputMessageString(A)  OutputDebugString (A)
#define  OutputFrameString(A)    OutputDebugString (A)
#define  OutputStateString(A)    OutputDebugString (A)

#define  EchoInfoString(A)
#define  EchoDebugString(A)      OutputDebugString (A)
#define  EchoWarnString(A)       OutputDebugString (A)
#define  EchoErrorString(A)      OutputDebugString (A)
#endif

void  EchoError                     (LPCTSTR Why); 
void  EchoSendError                 (LPCTSTR Why);
void  EchoCommandError              (BYTE CommandBuffer[8]);
void  EchoRcvError                  (long ErrCode, long ErrCount);
void  EchoImageError                (long RcvData, long SumData);
void  EchoFrameError                (long SeqID, long FrameID, long DstX, long DstY, long DstW, long DstH, long SumData);
void  EchoG3Error                   (LPCSTR TheColor, long ThePos, long PacketLen);

void  EchoTimeDuration              (long TimeStart, long TimeEnd);
void  EchoTimeStamp                 ();
void  EchoBeacon                    (BYTE CommandBuffer[8]);
void  EchoScroll                    (long ScrollID, long DstX, long DstY, long SrcX, long SrcY, long SrcW, long SrcH);

void  EchoAck                       (long SeqID, long FrameID, BYTE CurrentPhase);
void  EchoNAck                      (long SeqID, long FrameID, BYTE CurrentPhase);
void  EchoFrame                     (long SeqID, long FrameID, long DstX, long DstY, long DstW, long DstH, long SumData);
void  EchoPalette                   (long SeqID, long FrameID, BYTE Action);
void  EchoCacheCommand              (long SeqID, long FrameID, BYTE Action);
void  EchoFill                      (long SeqID, long FrameID, long DstX, long DstY, long DstW, long DstH, long WordMask);
void  EchoSync                      (long SeqID, long FrameID);
void  EchoTask                      (BYTE CommandBuffer[8]);
void  EchoByte                      (BYTE theByte);
void  EchoText                      (LPCTSTR theText);

void  EchoStatus                    (LPCTSTR Why);

void  PushStatusState               (DWORD  StatusFlags);
void  PullStatusState               (DWORD  StatusFlags);
void  ResetStatusState              ();

///////////////////////////////////////////////////////////////////////////////////////////////////
#else 
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef  EchoWarnString
///////////////////////////////////////////////////////////////////////////////////////////////////
#define  OutputMessageString(A)  
#define  OutputFrameString(A)    
#define  OutputStateString(A)    

#define  EchoInfoString(A)
#define  EchoDebugString(A)      
#define  EchoWarnString(A)       
#define  EchoErrorString(A)      
///////////////////////////////////////////////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////

#define  EchoError(W)
#define  EchoSendError(Why) 
#define  EchoSendError(Why)
#define  EchoCommandError(CommandBuffer)
#define  EchoRcvError(ErrCode, ErrCount)
#define  EchoImageError(RcvData, SumData)
#define  EchoFrameError(SeqID, FrameID, DstX, DstY, DstW, DstH, SumData)
#define  EchoG3Error(TheColor,  ThePos,  PacketLen)

#define  EchoTimeDuration(TimeStart, TimeEnd)
#define  EchoTimeStamp()
#define  EchoBeacon(CommandBuffer)
#define  EchoScroll(ScrollID, DstX, DstY, SrcX, SrcY, SrcW, SrcH)

#define  EchoAck(SeqID, FrameID, CurrentPhase)
#define  EchoNAck(SeqID, FrameID,  CurrentPhase)
#define  EchoFrame(SeqID, FrameID, DstX, DstY, DstW, DstH, SumData)
#define  EchoPalette( SeqID, FrameID, Action)
#define  EchoCacheCommand( SeqID, FrameID, Action)
#define  EchoFill( SeqID, FrameID, DstX, DstY, DstW, DstH, WordMask)
#define  EchoSync( SeqID, FrameID);
#define  EchoTask(CommandBuffer)
#define  EchoByte(theByte)
#define  EchoText(theText)

#define  EchoStatus(Why)

#define  PushStatusState(StatusFlags)
#define  PullStatusState(StatusFlags)
#define  ResetStatusState()

///////////////////////////////////////////////////////////////////////////////////////////////////
#endif //  USE_ECHO
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
} // extern "C"
///////////////////////////////////////////////////////////////////////////////////////////////////
