// JUncompress.cpp
///////////////////////////////////////////////////////////////////////////////////////////////////
#include "StdAfx.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////
extern "C" {
///////////////////////////////////////////////////////////////////////////////////////////////////
#define JPEG_BUFFER_SIZE     (1 * MB)
///////////////////////////////////////////////////////////////////////////////////////////////////
Int JUncompress(PByte DataDst, LPRGBQUAD Palette, ULong DataCount, PByte RcvSrc, UInt RcvCount)
{
struct  jpeg_decompress_struct cinfo;
struct  jpeg_error_mgr         jerr;
PBYTE                          ImgPtr             = DataDst;
long                           ReadLen            = 0;
    
    ZeroMemory(&cinfo, sizeof(cinfo));
    ZeroMemory(&jerr,  sizeof(jerr));
    // Step 1: allocate and initialize JPEG decompression object 
    // We set up the normal JPEG error routines, then override error_exit. 
    cinfo.err           = jpeg_std_error(&jerr); // Now we can initialize the JPEG compression object. 

    // Now we can initialize the JPEG decompression object.
    jpeg_create_decompress(&cinfo);

    jpeg_memio_src(&cinfo, RcvSrc, RcvCount, &ReadLen);

    jpeg_read_header(&cinfo, TRUE);

    // Step 2: set parameters for decompression
    if(cinfo.jpeg_color_space        != JCS_GRAYSCALE) {
	  cinfo.quantize_colors           = TRUE;
	  cinfo.desired_number_of_colors  = 256;
    }
    // cinfo.desired_number_of_colors    = (16777216);
    cinfo.desired_number_of_colors    = 256;

    // Step 3: Start decompressor 
    jpeg_start_decompress(&cinfo);

    // Step 4: Build palette... USING OUR DEVICE PALETTE...
    int EachColor;
    for(EachColor = 0;        EachColor   < cinfo.actual_number_of_colors; EachColor++){
/*
        Palette[EachColor].rgbRed         = cinfo.colormap[0][EachColor];
        Palette[EachColor].rgbGreen       = cinfo.colormap[1][EachColor];
        Palette[EachColor].rgbBlue        = cinfo.colormap[2][EachColor];
*/
        cinfo.colormap[0][EachColor]      = Palette[EachColor].rgbRed;
        cinfo.colormap[1][EachColor]      = Palette[EachColor].rgbGreen;
        cinfo.colormap[2][EachColor]      = Palette[EachColor].rgbBlue;
    }
    // Step 5: while (scan lines remain to be written) 
    // Here we use the library's state variable cinfo.next_scanline as the
    // loop counter, so that we don't have to keep track ourselves.
    // To keep things simple, we pass one scanline per call; you can pass more if you wish, though.
    int               row_stride;	// physical row width in image buffer 
    row_stride      = cinfo.image_width   * cinfo.output_components;	// JSAMPLEs per row in image_buffer 
    JSAMPARRAY        ThisScanline        = (*cinfo.mem->alloc_sarray) ((j_common_ptr) &cinfo, JPOOL_IMAGE, row_stride, 1);
    DWORD             WidthInByte         = cinfo.output_width * cinfo.output_components;
    
    while(cinfo.output_scanline           < cinfo.output_height) 
    {
       jpeg_read_scanlines(&cinfo,          ThisScanline, 1);
       CopyMemory(ImgPtr, ThisScanline[0],  WidthInByte);
       ImgPtr                            += WidthInByte;
    }

#if 0
    // We may need to do some setup of our own at this point before reading
	// the data.  After jpeg_start_decompress() we have the correct scaled
	// output image dimensions available, as well as the output colormap
	// if we asked for color quantization.
	  
    Create(cinfo.image_width, cinfo.image_height, 8 * cinfo.output_components);

    if(cinfo.jpeg_color_space    == JCS_GRAYSCALE)
	   CreateGrayColourMap(256);
    else
	   SetPalette(cinfo.actual_number_of_colors, cinfo.colormap[0], cinfo.colormap[1], cinfo.colormap[2]);

    // JSAMPLEs per row in output buffer 
    row_stride = cinfo.output_width * cinfo.output_components;

    // Make a one-row-high sample array that will go away when done with image 
    buffer = (*cinfo.mem->alloc_sarray)  ((j_common_ptr) &cinfo, JPOOL_IMAGE, row_stride, 1);

    // Step 6: while (scan lines remain to be read) 
    // Here we use the library's state variable cinfo.output_scanline as the
	// loop counter, so that we don't have to keep track ourselves.
	  
    iter.Upset();
    while (cinfo.output_scanline < cinfo.output_height) {
	   (void) jpeg_read_scanlines(&cinfo, buffer, 1);
	   // Assume put_scanline_someplace wants a pointer and sample count. 
	   iter.SetRow(buffer[0], row_stride);
	   iter.PrevRow();
    }
#endif

    // Step 5: Finish decompression
    jpeg_finish_decompress(&cinfo);
    // We can ignore the return value since suspension is not possible with the stdio data source.

    // Step 6: Release JPEG decompression object 
    // This is an important step since it will release a good deal of memory. 
    jpeg_destroy_decompress(&cinfo);

    // At this point you may want to check to see whether any corrupt-data
	// warnings occurred (test whether jerr.pub.num_warnings is nonzero).

    return 1;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
// EXPERIMENTAL ZONE 
// UNFINISHED MATCHING COLOR...
// A VERY SIMPLIFY VERSION OF A REAL FIND COLOR...
///////////////////////////////////////////////////////////////////////////////////////////////////
#if 0
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
RGBQUAD     SortedGRB               [256];
///////////////////////////////////////////////////////////////////////////////////////////////////
int __cdecl SortColors                  (PCVOID ElemFrom, PCVOID ElemTo)
{
LPRGBQUAD PaletteFrom                 = (LPRGBQUAD)ElemFrom,    PaletteTo = (LPRGBQUAD)ElemTo;
long      ColorFrom, ColorTo;
int       Result;

    ColorFrom                         = (PaletteFrom->rgbGreen << 16) | (PaletteFrom->rgbRed << 8) | (PaletteFrom->rgbBlue); 
    ColorTo                           = (PaletteTo->rgbGreen   << 16) | (PaletteTo->rgbRed   << 8) | (PaletteTo->rgbBlue); 

    return (ColorFrom                 - ColorTo);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
int __cdecl MatchColors                 (PCVOID ElemFrom, PCVOID ElemTo)
{
LPRGBQUAD PaletteFrom                 = (LPRGBQUAD)ElemFrom,    PaletteTo = (LPRGBQUAD)ElemTo;
long      ColorFrom, ColorTo;
int       Result;

    ColorFrom                         = (PaletteFrom->rgbGreen << 16) | (PaletteFrom->rgbRed << 8) | (PaletteFrom->rgbBlue); 
    ColorTo                           = (PaletteTo->rgbGreen   << 16) | (PaletteTo->rgbRed   << 8) | (PaletteTo->rgbBlue); 
    // DETERMINE HOW CLOSE IT IS...
    if((ColorFrom - ColorTo)         != 0){
       ;
    }
    return 0; // EXACT MATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////
VOID BuildCrossColorTable(LPRGBQUAD Palette)
{
int      EachColor; 
    
    CopyMemory(&SortedGRB, Palette, sizeof(SortedGRB));
    for(EachColor             = 0;    EachColor     < 256; EachColor++){
       SortedGRB[EachColor].rgbReserved = EachColor;
    }
    qsort(SortedGRB, 256, sizeof(RGBQUAD), SortColors);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BYTE FindNearestColor(LPRGBQUAD Palette)
{
int       ThisColor              = 0;
int       FoundColor             = 255;
BYTE      Direction              = 255; 
int       Pivot                  = 0; 
int       MinRec                 = 0, 
          MaxRec                 = 255;

    while(Direction){
       Pivot                     = MatchColors (&SortedGRB[FoundColor], Palette);
       if(Pivot                 == 0){
          break;
       } else 
       if(Pivot                  < 0){
          FoundColor            += Direction;
       } else {
          FoundColor            -= Direction;
       }
       if((FoundColor            < MinRec)){
           FoundColor            = MinRec; break;
       } else 
       if((FoundColor            > MaxRec)){
           FoundColor            = MaxRec; break;
       }
       Direction               >>= 1;
    }
    // STEP BY STEP...
    while(Pivot                  < 0){                    
       FoundColor               ++;
       if((FoundColor            > MaxRec)){
           FoundColor            = MaxRec; break;
       }
       Pivot                     = MatchColors (&SortedGRB[FoundColor], Palette);
    }
    while(Pivot                  > 0){
       FoundColor               --;
       if(FoundColor            <= MinRec){
          FoundColor             = MinRec; break;
       }
       Pivot                     = MatchColors (&SortedGRB[FoundColor], Palette);
    }
    // CLOSE ENOUGH
    ThisColor                    = SortedGRB[FoundColor].rgbReserved;
    return ThisColor;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL JUncompressFrame (UInt X, UInt Y, UInt W, UInt H, Byte BitPerPix, UInt SumData, 
                       Byte StepLine, Byte InitialPhase, PByte ScreenPtr, PByte RcvPtr)
{
HLSINFO     SurfaceHLS                  [256];
RGBQUAD     Palette                     [256];    ZeroMemory(&Palette, sizeof(Palette));
BYTE        TransPalette                [256];
HPALETTE    ms_palette                = NULL;
PBYTE       TempBuffer                = NULL; 
PBYTE       TempPtr                   = NULL; 
PBYTE       ImgPtr                    = ScreenPtr;
long        CompressedSize            = SumData;
long        UnCompressedSize          = (W * H);
long        WidthInPixel              = W;
long        WidthInByte               = W * 1;
long        DevWidthInByte            = Palm.MemoryScreenWidth;
PLOGPALETTE WinPalette                = (PLOGPALETTE)GlobalAlloc(LMEM_FIXED, sizeof(LOGPALETTE) + (256  * sizeof(PALETTEENTRY)));
int         EachPixel;
int         EachColor;
int         ThisPixel;
int         Looper;

    if(BitPerPix                     != 8){
       return FALSE;
    }
    if(WinPalette                    == NULL){
       return FALSE;
    }
    BuildCrossColorTable                (ImageBmp.bmiColors);
    BuildHLSFromRGB                     (SurfaceHLS,        ImageBmp.bmiColors, 256);
    CopyMemory                          (Palette, ImageBmp.bmiColors, sizeof(Palette));

    WinPalette->palVersion            = 0x300;
    WinPalette->palNumEntries         = 256;

    for(EachColor = 0; EachColor < 256; EachColor ++)
    {
       WinPalette->palPalEntry[EachColor].peRed   = ImageBmp.bmiColors[EachColor].rgbRed;
       WinPalette->palPalEntry[EachColor].peGreen = ImageBmp.bmiColors[EachColor].rgbGreen;
       WinPalette->palPalEntry[EachColor].peBlue  = ImageBmp.bmiColors[EachColor].rgbBlue;
       WinPalette->palPalEntry[EachColor].peFlags = 0;
    }
    ms_palette                        = ::CreatePalette((LPLOGPALETTE)WinPalette);

    BITMAPINFO256     BmpHead;          ZeroMemory(&BmpHead, sizeof(BmpHead));
    static int        count;
    CString           Filename;         Filename.Format(_T("D:\\JPtest%d.bmp"), count++);  
    BmpHead.bmiHeader.biSize          = 40;
    BmpHead.bmiHeader.biPlanes        = 1;
    BmpHead.bmiHeader.biBitCount      = 8;
    BmpHead.bmiHeader.biWidth         = WidthInPixel;
    BmpHead.bmiHeader.biHeight        = H;
    BmpHead.bmiHeader.biSizeImage     = H * WidthInByte;

    PBYTE                               ThisScanByte;
    ImgPtr                            = ScreenPtr + X + (Y * DevWidthInByte);
    TempPtr = TempBuffer              = (PBYTE)GlobalAlloc(GMEM_FIXED, (JPEG_BUFFER_SIZE));
    if(TempBuffer                    != NULL)
    {
       if(JUncompress(TempBuffer,       Palette, JPEG_BUFFER_SIZE, RcvPtr, CompressedSize))
       {

          CopyMemory                   (BmpHead.bmiColors, Palette, (256 * sizeof(RGBQUAD)));
          SaveBitmap                   (Filename, TempBuffer, (PBITMAPINFOHEADER)&BmpHead);

          // BUILD TRANSLATOR PALETTE
          for(EachColor = 0;            EachColor     < 256; EachColor++){
             TransPalette[EachColor]  =  EachColor;
             // TransPalette[EachColor]  = ::GetNearestPaletteIndex(ms_palette,  RGB(Palette[EachColor].rgbRed, Palette[EachColor].rgbGreen, Palette[EachColor].rgbBlue));
             // TransPalette[EachColor]  = FindClosestColor (Palette[EachColor], SurfaceHLS, 256, 0);
             // TransPalette[EachColor]  = FindNearestColor(&Palette[EachColor]);
          }
          for(Looper = 0; Looper      < H; Looper++){
             for(EachPixel = 0;            EachPixel     < WidthInPixel; EachPixel++){
                ImgPtr[EachPixel]     =    TransPalette    [TempPtr[EachPixel]];  
             }
             ImgPtr                  += DevWidthInByte;
             TempPtr                 += WidthInByte;
          }
       }
       GlobalFree(TempBuffer);
    }
    if(ms_palette)::DeleteObject(ms_palette); 
    GlobalFree((HANDLE)WinPalette);
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
#endif // #if 0 EXPERIEMENT...
///////////////////////////////////////////////////////////////////////////////////////////////////
// 
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL JUncompressFrame (UInt X, UInt Y, UInt W, UInt H, Byte BitPerPix, UInt SumData, 
                       Byte StepLine, Byte InitialPhase, PByte ScreenPtr, PByte RcvPtr)
{
#if USE_JCOMPRESS
PBYTE       TempBuffer                = NULL; 
PBYTE       TempPtr                   = NULL; 
PBYTE       ImgPtr                    = ScreenPtr;
long        CompressedSize            = SumData;
long        UnCompressedSize          = (W * H);
long        WidthInPixel              = W;
long        WidthInByte               = W * 1;
long        DevWidthInByte            = Palm.MemoryScreenWidth;
int         EachPixel;
int         Looper;

    if(BitPerPix                     != 8){
       return FALSE;
    }
    PBYTE                               ThisScanByte;
    ImgPtr                            = ScreenPtr + X + (Y * DevWidthInByte);
    TempPtr = TempBuffer              = (PBYTE)GlobalAlloc(GMEM_FIXED, (JPEG_BUFFER_SIZE));
    if(TempBuffer                    != NULL)
    {
       if(JUncompress(TempBuffer,       ImageBmp.bmiColors, JPEG_BUFFER_SIZE, RcvPtr, CompressedSize))
       {
          for(Looper = 0; Looper      < H; Looper++){
             for(EachPixel = 0;            EachPixel     < WidthInPixel; EachPixel++){
                ImgPtr[EachPixel]     =    TempPtr[EachPixel];  
             }
             ImgPtr                  += DevWidthInByte;
             TempPtr                 += WidthInByte;
          }
       }
       GlobalFree(TempBuffer);
    }
    return TRUE;
#endif
    return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
// 
///////////////////////////////////////////////////////////////////////////////////////////////////
class CJPegUncompress 
{
public:
                CJPegUncompress        ();
    virtual     ~CJPegUncompress       ();

    BOOL        JStartUncompress       (UInt X, UInt Y,  UInt W, UInt H,  Byte  BitPerPix, 
                                        PByte ScreenPtr, PByte RcvSrc,    UInt  RcvCount);
    BOOL        JEndUncompress         ();
    BOOL        JUncompress            ();
    BOOL        JFillIO                (PByte RcvSrc, UInt  RcvCount);

    struct      jpeg_decompress_struct m_cinfo;
    struct      jpeg_error_mgr         m_jerr;

    JSAMPARRAY  m_CurScanLine;         // TEMPRORARY SCANLINE IN JPEG INTERPRETTATION FORMAT.
    PBYTE       m_DevLinePtr;          // CURRENT DEVICE IMAGE LINE BUFFER

    int         m_CurRowStride;        // PHYSICAL ROW WIDTH IN IMAGE BUFFER 
    long        m_ReadLen;             // HOW MUCH SOURCE BUFFER CONSUMED

    DWORD       m_SrcWidthInPixel;     // SOURCE BUFFER WIDTH IN PIXEL
    DWORD       m_SrcWidthInByte;      // SOURCE BUFFER WIDTH IN BYTE
    DWORD       m_DevWidthInByte;      // DEVICE WIDTH IN BYTE

    PBYTE       m_DualBuffer;
    // FOR COLOR HANDLING...
    BYTE        m_TransPalette         [256];

};
///////////////////////////////////////////////////////////////////////////////////////////////////
CJPegUncompress  JPegEnngine;
///////////////////////////////////////////////////////////////////////////////////////////////////
CJPegUncompress::CJPegUncompress ()
{
    ZeroMemory(m_TransPalette,         sizeof(m_TransPalette));
    
    ZeroMemory(&m_cinfo,               sizeof(m_cinfo));
    ZeroMemory(&m_jerr,                sizeof(m_jerr));

    m_DualBuffer                     = NULL;
    m_CurScanLine                    = NULL;
    m_DevLinePtr                     = NULL;

    m_CurRowStride                   = 0;
    m_ReadLen                        = 0;

    m_SrcWidthInPixel                = 0;
    m_SrcWidthInByte                 = 0;
    m_DevWidthInByte                 = 0;

}
///////////////////////////////////////////////////////////////////////////////////////////////////
CJPegUncompress::~CJPegUncompress ()
{
    JEndUncompress ();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CJPegUncompress::JStartUncompress (UInt X, UInt Y,  UInt W, UInt H, Byte  BitPerPix, 
                                        PByte ScreenPtr, PByte RcvSrc,   UInt  RcvCount)
{
RGBQUAD     Palette                       [256];    ZeroMemory(&Palette,       sizeof(Palette));
HLSINFO     SurfaceHLS                    [256];    ZeroMemory(&SurfaceHLS,    sizeof(SurfaceHLS));
PLOGPALETTE WinPalette                  = NULL;
HPALETTE    MSPalette                   = NULL;
int         EachColor;
BOOL        bRet                        = FALSE;

    ///////////////////////////////////////////////////////////////////////////////////////////////
    // ARE WE ALREARY STARTED THEN RELEASE
    ///////////////////////////////////////////////////////////////////////////////////////////////
    if(m_DualBuffer){ 
       JEndUncompress();
    }
    if(BitPerPix                       != 8){
       goto ExitJStartUncompress;
    }
    ///////////////////////////////////////////////////////////////////////////////////////////////
    // PREPARING COLOR TRANSLATION
    ///////////////////////////////////////////////////////////////////////////////////////////////
    m_DualBuffer                        = (PBYTE)GlobalAlloc(LMEM_FIXED, (2 * RcvCount) );
    if(m_DualBuffer                    == NULL){
       goto ExitJStartUncompress;
    }
    CopyMemory(m_DualBuffer, RcvSrc, RcvCount);
    ///////////////////////////////////////////////////////////////////////////////////////////////
    WinPalette                          = (PLOGPALETTE)GlobalAlloc(LMEM_FIXED, sizeof(LOGPALETTE) + (256  * sizeof(PALETTEENTRY)));
    if(WinPalette                      == NULL){
       goto ExitJStartUncompress;
    }
    // BuildHLSFromRGB (SurfaceHLS,        ImageBmp.bmiColors, 256);

    WinPalette->palVersion              = 0x300;
    WinPalette->palNumEntries           = 256;

    for(EachColor = 0;  EachColor       < 256; EachColor ++)
    {
       WinPalette->palPalEntry[EachColor].peRed   = ImageBmp.bmiColors[EachColor].rgbRed;
       WinPalette->palPalEntry[EachColor].peGreen = ImageBmp.bmiColors[EachColor].rgbGreen;
       WinPalette->palPalEntry[EachColor].peBlue  = ImageBmp.bmiColors[EachColor].rgbBlue;
       WinPalette->palPalEntry[EachColor].peFlags = 0;
    }
    MSPalette                           = ::CreatePalette((LPLOGPALETTE)WinPalette);
    if(MSPalette                       == NULL){
       goto ExitJStartUncompress;
    }
    ///////////////////////////////////////////////////////////////////////////////////////////////
    // PREPARING JPEG DECOMPRESSOR
    ///////////////////////////////////////////////////////////////////////////////////////////////
    // Step 1: allocate and initialize JPEG decompression object We set up the normal JPEG error routines, then override error_exit. 
    m_cinfo.err                         = jpeg_std_error(&m_jerr); // Now we can initialize the JPEG compression object. 
    
    jpeg_create_decompress(&m_cinfo);// Now we can initialize the JPEG decompression object.
    jpeg_memio_src(&m_cinfo, m_DualBuffer, RcvCount, &m_ReadLen);
    jpeg_read_header(&m_cinfo, TRUE);

    // Step 2: set parameters for decompression
    if(m_cinfo.jpeg_color_space        != JCS_GRAYSCALE) {
	  m_cinfo.quantize_colors           = TRUE;
	  m_cinfo.desired_number_of_colors  = 256;
    }
    // Step 3: Start decompressor 
    jpeg_start_decompress(&m_cinfo);

    // Step 4: Build palette...
    for(EachColor = 0; EachColor        < m_cinfo.actual_number_of_colors; EachColor++){
        Palette[EachColor].rgbRed       = m_cinfo.colormap[0][EachColor];
        Palette[EachColor].rgbGreen     = m_cinfo.colormap[1][EachColor];
        Palette[EachColor].rgbBlue      = m_cinfo.colormap[2][EachColor];
    }
    // Step 5: while (scan lines remain to be written) 
    // Here we use the library's state variable m_cinfo.next_scanline as the loop counter, so that we don't have to keep track ourselves.
    // To keep things simple, we pass one scanline per call; you can pass more if you wish, though.
    m_CurRowStride                      = m_cinfo.image_width  * m_cinfo.output_components; // JSAMPLEs per row in image_buffer 
    m_CurScanLine                       = (*m_cinfo.mem->alloc_sarray) ((j_common_ptr) &m_cinfo, JPOOL_IMAGE, m_CurRowStride, 1);
    m_SrcWidthInByte                    = m_cinfo.output_width * m_cinfo.output_components;
    m_SrcWidthInPixel                   = W;
    m_DevWidthInByte                    = Palm.MemoryScreenWidth;
    m_DevLinePtr                        = ScreenPtr + X + (Y * m_DevWidthInByte);
    ///////////////////////////////////////////////////////////////////////////////////////////////
    // VALIDATE THE LATER INFO
    ///////////////////////////////////////////////////////////////////////////////////////////////
    if((m_CurRowStride                 == 0) || (m_CurScanLine                  == 0)
    || (m_SrcWidthInByte               == 0) || (m_SrcWidthInPixel              == 0)
    || (m_DevWidthInByte               == 0) || (m_DevLinePtr                   == 0)
    ){
       goto ExitJStartUncompress;
    }
    ///////////////////////////////////////////////////////////////////////////////////////////////
    // BUILD TRANSLATOR PALETTE
    ///////////////////////////////////////////////////////////////////////////////////////////////
    for(EachColor = 0;    EachColor     < 256; EachColor++){
       m_TransPalette   [EachColor]     = ::GetNearestPaletteIndex(MSPalette,  RGB(Palette[EachColor].rgbRed, Palette[EachColor].rgbGreen, Palette[EachColor].rgbBlue));
       // FindClosestColor (Palette[EachColor], SurfaceHLS, 256, 0);
       // FindNearestColor (&Palette[EachColor]);
    }
    ///////////////////////////////////////////////////////////////////////////////////////////////
    bRet                                = TRUE;
    ///////////////////////////////////////////////////////////////////////////////////////////////
    // WE ARE DONE WITH MS PALETTE NOW THAT WE HAVE OUR TRANSLATOR.
    ///////////////////////////////////////////////////////////////////////////////////////////////
ExitJStartUncompress:    

    if(WinPalette) GlobalFree     ((HANDLE)WinPalette);
    if(MSPalette)  ::DeleteObject (MSPalette); 
    if((Not bRet) 
    || (0)
    ){
       JEndUncompress();
    }
    ///////////////////////////////////////////////////////////////////////////////////////////////
    return bRet;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CJPegUncompress::JFillIO (PByte RcvSrc, UInt  RcvCount)
{
    if((m_CurRowStride                 == 0) || (m_CurScanLine                  == 0)
    || (m_SrcWidthInByte               == 0) || (m_SrcWidthInPixel              == 0)
    || (m_DevWidthInByte               == 0) || (m_DevLinePtr                   == 0)
    || (m_DualBuffer                   == 0)
    ){
       return FALSE;
    }
    // GET CURRENT SIZE AND POINT IN THE BUFFER
    // CHECK IF ENOUGH ROOM TO MAKE THE MOVE AND COPY
    // POINT TO THE LAST AND MOVE TO THE BEGENNING
    // COPY THE NEW DATA AT THE END OF IT...
    // jpeg_memio_Rst (&m_cinfo, RcvSrc, RcvCount, &m_ReadLen);

    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CJPegUncompress::JEndUncompress ()
{
    if(m_DualBuffer) GlobalFree ((HANDLE)m_DualBuffer); m_DualBuffer = NULL;

    ZeroMemory(&m_cinfo,               sizeof(m_cinfo));
    ZeroMemory(&m_jerr,                sizeof(m_jerr));

    m_CurScanLine                    = NULL;
    m_DevLinePtr                     = NULL;

    m_CurRowStride                   = 0;
    m_ReadLen                        = 0;

    m_SrcWidthInPixel                = 0;
    m_SrcWidthInByte                 = 0;
    m_DevWidthInByte                 = 0;

    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CJPegUncompress::JUncompress ()
{
PBYTE ImgPtr                            = NULL;
PBYTE TempPtr                           = NULL;

    if((m_CurRowStride                 == 0) || (m_CurScanLine                  == 0)
    || (m_SrcWidthInByte               == 0) || (m_SrcWidthInPixel              == 0)
    || (m_DevWidthInByte               == 0) || (m_DevLinePtr                   == 0)
    || (m_DualBuffer                   == 0)
    ){
       return FALSE;
    }
    TempPtr                             = m_CurScanLine[0];

    while(m_cinfo.output_scanline       < m_cinfo.output_height) 
    {
       ImgPtr                           = m_DevLinePtr;
       jpeg_read_scanlines(&m_cinfo,      m_CurScanLine, 1);
       // CONVERT JPEG COLOR  TO DEVICE   IMAGE LOCATION AND COLOR
       for(int EachPixel = 0; EachPixel < m_SrcWidthInPixel; EachPixel++){
          ImgPtr[EachPixel]             = m_TransPalette    [ TempPtr [EachPixel] ];  
       }
       m_DevLinePtr                    += m_DevWidthInByte;
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL JUncompressPacket (UInt X, UInt Y, UInt W, UInt H,   Byte  BitPerPix, UInt  RcvCount, 
                       Byte ImageIndX,  Byte PacketField, PByte ScreenPtr, PByte RcvSrc)
{
BYTE           PacketID                 = (PacketField & 0x7F);
BOOL           IsLastPacket             = (PacketField & 0x80) != 0;
BOOL           bRet                     = TRUE;

    // if(PacketID                        == 0){
    //   JPegEnngine.JEndUncompress         ();
    //   return TRUE;
    // } else 
    // if(PacketID                == 1){ 
       bRet      = JPegEnngine.JStartUncompress (X, Y, W, H, BitPerPix, ScreenPtr, RcvSrc, RcvCount);
    // } else {
    //    bRet      = JPegEnngine.JFillIO    (RcvSrc, RcvCount); 
    // }
    if(bRet){
       bRet      = JPegEnngine.JUncompress();
    }
    if(IsLastPacket){
       JPegEnngine.JEndUncompress         ();
    }
    return bRet;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
} // extern "C"
///////////////////////////////////////////////////////////////////////////////////////////////////

