// Keyboard.cpp
///////////////////////////////////////////////////////////////////////////////////////////////////
#include "StdAfx.h"
///////////////////////////////////////////////////////////////////////////////////////////////////
extern "C" {
///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
typedef struct _KeyboardLocator {
    long Pos;
    BYTE LoCase, UpCase;
} KeyboardLocator, * PKeyboardLocator;
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL KeyboardShiftStatus = FALSE;
BOOL KeyboardCapStatus   = FALSE;
BOOL KeyboardCtrlStatus  = FALSE;
BOOL KeyboardIntlStatus  = FALSE;

BOOL KeyboardBackStatus  = FALSE;

BOOL EnableDirectKey     = FALSE;


#if USE_KEYBOARD
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall SetKeyBoardStatus      (BOOL   ShiftStatus, BOOL   CapStatus, BOOL   CtrlStatus, BOOL   IntlStatus)
{DLL_THREAD_MANAGEMENT();

    KeyboardShiftStatus = ShiftStatus;
    KeyboardCapStatus   = CapStatus;
    KeyboardCtrlStatus  = CtrlStatus;
    KeyboardIntlStatus  = IntlStatus;
    RefreshIKeyboardPalm   ();
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall GetKeyBoardStatus (LPBOOL ShiftStatus, LPBOOL CapStatus, LPBOOL CtrlStatus, LPBOOL IntlStatus)
{DLL_THREAD_MANAGEMENT();

    *ShiftStatus   = KeyboardShiftStatus;
    *CapStatus     = KeyboardCapStatus;
    *CtrlStatus    = KeyboardCtrlStatus;
    *IntlStatus    = KeyboardIntlStatus;
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall ResetShiftStatus ()
{DLL_THREAD_MANAGEMENT();

    if(KeyboardShiftStatus) {
       KeyboardShiftStatus = FALSE;
       SelectKeyboard();
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall GetStringQueue (LPTSTR theString, short BufferSize)
{DLL_THREAD_MANAGEMENT();

    StringCopy(theString, KeyboardString, BufferSize);
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall SetStringQueue (LPCTSTR theString)
{DLL_THREAD_MANAGEMENT();

    KeyboardString        = theString;
    KeyboardBackStatus    = FALSE;
    // ResetShiftStatus ();
    RefreshIKeyboardPalm();
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall AddStringQueue (LPCTSTR theString)
{DLL_THREAD_MANAGEMENT();

    KeyboardString        = KeyboardString + theString;
    KeyboardBackStatus    = FALSE;
    ResetShiftStatus ();
    RefreshIKeyboardPalm   ();
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall AddCharQueue (TCHAR theChar)
{DLL_THREAD_MANAGEMENT();

    switch(Palm.MenuMode){
    case PDAMENUMODE_ONLINE:
         if(Not AddCtrlQueue (theChar)){
            KeyboardString        = KeyboardString + theChar;
            KeyboardBackStatus    = FALSE;
         }
         if(EnableDirectKey){
            ProcessKeyboardIdle ();
         }
         RefreshIKeyboardPalm();
         break;

    case PDAMENUMODE_DESKTOP:
         ProcessPdaKeyboard(theChar);
         break;
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall AddCtrlQueue (char theChar)
{DLL_THREAD_MANAGEMENT();

long            theLen;

    switch (theChar){
    case PADKEY_ESC:          // 27
         KeyboardString        = KeyboardString +  ( (char)(PADKEY_ESC) );
         KeyboardBackStatus    = FALSE;
         SendKeyboardString      ();
         break;

    case PADKEY_BACKSPACE:    //  8
         if((KeyboardString.GetLength()) && (KeyboardBackStatus == FALSE) ) {
            theLen             = (KeyboardString.GetLength());
            KeyboardString     = KeyboardString.Left(theLen - 1);

         } else {
            KeyboardBackStatus = TRUE;
            KeyboardString     = KeyboardString + (char)(8);
         }
         break;
    
    case PADKEY_DELETE:       // 14 // USUALLY NOT USE 
         KeyboardString        = KeyboardString + ( (char)(PADKEY_DELETE) );
         KeyboardBackStatus    = FALSE;
         break;
    
    case PADKEY_SHIFTTAB:     //15 // USUALLY NOT USE 
         KeyboardString        = KeyboardString +  ( (char)(PADKEY_SHIFTTAB) );
         KeyboardBackStatus    = FALSE;
         SendKeyboardString      ();
         break;

    case PADKEY_TAB:          // 9
         KeyboardString        = KeyboardString +  ( (char)(PADKEY_TAB) );
         KeyboardBackStatus    = FALSE;
         SendKeyboardString      ();
         break;

    case PADKEY_RETURN:       //13
         KeyboardString        = KeyboardString +  ( (char)(PADKEY_RETURN) );
         KeyboardBackStatus    = FALSE;
         SendKeyboardString      ();
         break;
    
    case PADKEY_RIGHTARROW:   //28
    case PADKEY_LEFTARROW:    //29
    case PADKEY_UPARROW:      //30
    case PADKEY_DOWNARROW:    //31
         theChar               = (theChar);
         KeyboardString        = KeyboardString +  theChar;
         break;
        
    case PADKEY_CTRL:         //17 // USUALLY NOT USE 
         theChar               = (theChar);
         KeyboardString        = KeyboardString +  theChar;
         break;

    case PADKEY_ACCENT:       //18 // USUALLY NOT USE 
         break;

    case PADKEY_CAPSLOCK:     //15 // USUALLY NOT USE 
         KeyboardCapStatus     = Not KeyboardCapStatus;
         SelectKeyboard();
         break;
    
    case PADKEY_SHIFT:        //16 // USUALLY NOT USE 
         KeyboardShiftStatus   = Not KeyboardShiftStatus;
         SelectKeyboard();
         break;
    default:
         return FALSE;
    }
    RefreshIKeyboardPalm();
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall ProcessKeyboardEntry(long x, long y)
{DLL_THREAD_MANAGEMENT();
long             RowPos, ThePos, CapState = 0;
CString          theChar;
BYTE             theByte;
KeyboardLocator  thisKey; 

    if(IsBadWritePtr(Palm.ScreenPointer, Palm.VScreenBufferSize)){
       return FALSE;
    }
    if(Palm.KeyboardFullyFunctionnal == FALSE){
       return FALSE;
    }
    y = y - Palm.MenuHeight;
    if(Palm.KeyboardWidth == 384){
       RowPos = (y / 24);
    } else {
       RowPos = (y / 18);
    }
    switch (RowPos){
    case 0:
         //if (KeyboardTable & 0x1) {
            RowPos = Palm.KeyboardTableTop;     // 1598;
         //}
         break;
    
    case 1:
         //if (KeyboardTable & 0x2) {
            RowPos = Palm.KeyboardTableTop + 1; // 1599;
         //}
         break;
    
    case 2:
         //if (KeyboardTable & 0x4) {
            RowPos = Palm.KeyboardTableTop + 2; // 1600;
         //}
         break;
    
    case 3:
         //if (KeyboardTable & 0x8) {
            RowPos = Palm.KeyboardTableTop + 3; // 1601;
         //}
         break;
    
    case 4:
         //if (KeyboardTable & 0x10) {
            RowPos = Palm.KeyboardTableTop + 4; // 1602;
         //}
         break;
    default:
         return FALSE;
    }
    if (KeyboardCapStatus) {
       CapState = 1;
    }
    if (KeyboardShiftStatus) {
       if (CapState) {
          CapState = 0;
       } else {
          CapState = 1;
       }
    }
    
    if (RowPos >= Palm.KeyboardTableTop) {
       theChar  = _T("");
       theByte  = 0;
       ThePos   = 0;
       do {
          thisKey.Pos    = Palm.ScreenPointer[((RowPos * Palm.VScreenWidthInByte) + ThePos)];       ThePos = ThePos + 1;
          thisKey.Pos   += Palm.ScreenPointer[((RowPos * Palm.VScreenWidthInByte) + ThePos)] * 256; ThePos = ThePos + 1;
          thisKey.LoCase = Palm.ScreenPointer[((RowPos * Palm.VScreenWidthInByte) + ThePos)];       ThePos = ThePos + 1;
          thisKey.UpCase = Palm.ScreenPointer[((RowPos * Palm.VScreenWidthInByte) + ThePos)];       ThePos = ThePos + 1;
          
          if (thisKey.Pos > x) {
             if (CapState) {
                theByte = thisKey.UpCase;
             } else {
                theByte = thisKey.LoCase;
             }
             break;
          }
       } while (thisKey.Pos != 0);
    } 
    if (theByte >= 32) {
       theChar   = (TCHAR)(theByte);
    } else {
       
       AddCtrlQueue (theByte);
    }
    if (theChar != _T("")) {
       
       AddStringQueue((LPCTSTR)theChar);
       
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall OpenKeyboard()
{DLL_THREAD_MANAGEMENT();

    if(Palm.KeybdOnSatus == FALSE) {
       ClearKeyboard();
       ShowKeyboard(1);
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall ToggleKeyboard()
{DLL_THREAD_MANAGEMENT();

    if (Palm.KeybdOnSatus) {
       if ((KeyboardString.GetLength())) {
          SendKeyboardString();
       }
       ClearKeyboard();
    } else {
       ShowKeyboard(1);
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall SelectKeyboard()
{DLL_THREAD_MANAGEMENT();

long Which;
long CapState = 0;

    if (KeyboardCapStatus) {
       CapState = 1;
    }
    if (KeyboardShiftStatus) {
       if (CapState) {
          CapState = 0;
       } else {
          CapState = 1;
       }
    }
    if (CapState == 1) {
       Which = 2;
    } else {
       Which = 1;
    }
    SetupKeyboard(Which);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall ShowKeyboard(long Which)
{DLL_THREAD_MANAGEMENT();
static BOOL SafeToCopy = TRUE;

    if(Palm.MenuMode != PDAMENUMODE_ONLINE){
       return;
    }
    if (Which != 0) {
        
       Palm.KeybdOnScreen     = Palm.KeyboardHeight;
       Palm.KeybdOnSatus      = Which;
       if(Palm.KeyboardWidth == 384){
          if(SafeToCopy){
             SafeToCopy = FALSE;
             // COPY MENU TO BUFFER AREA...
             MemRectCopyMono(0, (Palm.KeyboardTableTop + 6), 
                             0, Palm.VirtualScreenHeight, Palm.VirtualScreenWidth, Palm.MenuHeight);
             // CLEAR THE BUTTON AREA FOR TEXT
             ClearRectData(0, Palm.VirtualScreenHeight, 640, (Palm.MenuHeight - 1), 1);
             // COPY SEND BUTTON TO MENU AREA...
             MemRectCopyMono(512, Palm.VirtualScreenHeight, 
                             640, Palm.VirtualScreenHeight, 128, Palm.MenuHeight); // other button + 32 = 160
          }
       }
    } else {
       Palm.KeybdOnScreen       = 0;
       Palm.KeybdOnSatus        = 0;
       if(Palm.KeyboardWidth == 384){
          // COPY MENU FROM BUFFER AREA...
          if(SafeToCopy ==  FALSE){
             SafeToCopy  = TRUE;
             MemRectCopyMono(0, Palm.VirtualScreenHeight, 
                             0, (Palm.KeyboardTableTop + 6), Palm.VirtualScreenWidth, Palm.MenuHeight);
          }
       }
    }
    SetupKeyboard(Which);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall SetupKeyboard(long Which)
{DLL_THREAD_MANAGEMENT();
long  x, y, W, H;
long  NewX, NewY;

    if (Which != 0) {
        
        NewX               = Palm.CurrentKeyboardX;
        NewY               = Palm.VirtualScreenHeight + Palm.MenuHeight;
        W                  = Palm.KeyboardWidth;
        H                  = Palm.KeyboardHeight;
        switch ( Which ){
        case 1:
             x = 0;
             y = Palm.KeyboardTop;
             break;
        case 2:
             x = Palm.KeyboardWidth;
             y = Palm.KeyboardTop;
             break;
        case 3:
             x = 0;
             y = Palm.KeyboardTop + Palm.KeyboardHeight;
             break;
        case 4:
             x = Palm.KeyboardWidth;
             y = Palm.KeyboardTop + Palm.KeyboardHeight;
             break;
        }
        MemRectCopyMono(NewX, NewY, x, y, W, H);
    }
    RefreshIPalm();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall SendKeyboardString()
{DLL_THREAD_MANAGEMENT();

    if((KeyboardString.GetLength())) {
       // SendAString(KeyboardString);
       SendATextString(KeyboardString);
       ClearKeyboard();
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall ClearKeyboard()
{DLL_THREAD_MANAGEMENT();

    KeyboardShiftStatus = FALSE;
    KeyboardCapStatus   = FALSE;
    KeyboardCtrlStatus  = FALSE;
    KeyboardIntlStatus  = FALSE;

    SetStringQueue ( _T("") );

    ShowKeyboard(0);
}
DCTimeout      KeyTimeout;
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall ProcessKeyboardIdle()
{DLL_THREAD_MANAGEMENT();

    // DC HERE WE PROCESS KEYBOARD IN A PERIODIC MANER...
    if((KeyTimeout.Delay) ){
       if(Not KeyTimeout.StillInDelay()){
          KeyTimeout.EndDelay();
          // SL THIS IS TO SUPPORT CHAR BY CHAR MODE TO SERVER...
          // DC NEED TO CHECK WITH PREVIOUS VERSION ???
          // ProcessUIKeybdAction (theChar);
          SendKeyboardString();
       }
     } else {
        KeyTimeout.BeginDelay(1000);
     }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
#endif

} // extern "C"
