// NCompress.cpp
/////////////////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"

#include "G_Compress.h"
#include "NCompress.h"
/////////////////////////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////////////////////////
static DWORD BytesTransmitted, BytesTranslated;
static DWORD CalcZeroBits;
static DWORD CalcOneBits;
static DWORD ZeroBitsRunlenght[128];
static DWORD OneBitsRunlenght[128];

static DWORD FramesCalcZeroBits;
static DWORD FramesCalcOneBits;
static DWORD FramesZeroBitsRunlenght[128];
static DWORD FramesOneBitsRunlenght[128];
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
static PBYTE    EncodedDataBufCurrentPtr    = NULL;               
static BYTE     N3EncodingByte              = 0; 
static BYTE     N3EncodingBit               = 8;                    
static DWORD    N3EncodedDataSize           = 0;      
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
const WORD CodeMask    []  = {0x8000,0x4000,0x2000,0x1000,0x800,0x400,0x200,0x100,0x80,0x40,0X20,0X10,0X08,0X04,0X02,0X01};

const WORD MaskCode    []  = {0,0X0001, 0X0003, 0X0007, 0X000F, 0X001F, 0X003F, 0X007F, 0X00FF,
                                0X01FF, 0X03FF, 0X07FF, 0X0FFF, 0X1FFF, 0X3FFF, 0X7FFF, 0XFFFF};

const WORD InvCode     []  = {0,0X8000, 0XC000, 0XE000, 0XF000, 0XF800, 0XFC00, 0XFE00, 0XFF00,
                                0XFF80, 0XFFC0, 0XFFE0, 0XFFF0, 0XFFF8, 0XFFFC, 0XFFFE, 0XFFFF};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
short NextZeroCodes [128];
short NextOneCodes  [128];
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
static void InitNextCode ()
{
int Looper;

    __asm{
    LEA EDX,             NextZeroCodes
    MOV WORD PTR [EDX],  000111101b            __asm ADD EDX, 2    
    MOV WORD PTR [EDX],  101b                  __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  11b                   __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  100b                  __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0111b                 __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0101b                 __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  001111b               __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  001110b               __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  001101b               __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  001011b               __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  001100b               __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  001000b               __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000000b             __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000001b             __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0100b                 __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  001001b               __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000111111b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000111100b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000111010b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000111110b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000111000b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000110001b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000101100b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000110110b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000111011b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000111001b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000110010b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000101111b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000110101b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000101010b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000101001b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000110111b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000101101b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000100110b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000100100b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000011110b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000100010b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000011000b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000100011b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000010010b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000100000b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000011011b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000100001b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000010111b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000010110b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000101110b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000011100b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000011001b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000011111b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000100101b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000010000b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000001001b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000110100b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000101011b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000010101b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000001101b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000101000b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000001111b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000100111b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000001110b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000010001b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000001010b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000011010b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000001011b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0110b                 __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000110011b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000010100b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000001000b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000110000b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000011101b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000010011b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000001100b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000000111b            __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  001010b               __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0                     // 0 END OF CODE TABLE
    }
    __asm{
    LEA EDX,             NextOneCodes
    MOV WORD PTR [EDX],  00000100111b          __asm ADD EDX, 2      
    MOV WORD PTR [EDX],  1b                    __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  01b                   __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  001b                  __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000111b               __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000110b               __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000101b               __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  000100b               __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000111110b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000111101b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000111011b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000111001b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000111000b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000110110b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000111010b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000110111b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000111100b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000110011b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000101110b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000110010b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000110001b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000101101b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000101011b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000101100b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000100101b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000101010b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000101111b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000100110b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000100111b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000100100b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000101000b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000110101b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000101001b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000100011b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000111010b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000100000b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000110111b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000111000b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000111111b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000101110b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000110100b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000101011b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000101101b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000111011b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000101000b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000100110b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000100100b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000110110b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000111101b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000110100b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000101111b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000110010b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000100001b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000101010b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000111110b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000111001b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000110001b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000110000b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000101001b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000100101b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000110101b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000101100b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000110000b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000100010b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000111111b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0000100010b           __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000110011b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000100001b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000100011b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000011101b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000100000b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000011110b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000011111b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  00000111100b          __asm ADD EDX, 2   
    MOV WORD PTR [EDX],  0                     // 0 END OF CODE TABLE
    }

    for(Looper = 0; Looper < 74 ; Looper++){
/*
       WORD  TheCode       = NextZeroCodes  [Looper];
       WORD  TheNewCode    = ~TheCode; 
       WORD  ThePlacedCode = TheNewCode >> (16 - N3FaxZeroCodes[Looper].length); 
*/

       NextZeroCodes  [Looper]  = ~NextZeroCodes  [Looper];
       NextZeroCodes  [Looper] &= MaskCode[N3FaxZeroCodes [Looper].length];

       NextOneCodes   [Looper]  = ~NextOneCodes   [Looper];
       NextOneCodes   [Looper] &= MaskCode[N3FaxOneCodes  [Looper].length];
/*
       N3FaxZeroCodes [Looper].code =  NextZeroCodes [Looper];
       N3FaxOneCodes  [Looper].code =  NextOneCodes  [Looper];
*/
    }
};
/////////////////////////////////////////////////////////////////////////////////////////
// NEW OPTIMIZED FAX INTERPRETTATION...
/////////////////////////////////////////////////////////////////////////////////////////
static TableEntry OptFaxOneCodes  [(sizeof(N3FaxOneCodes)  / sizeof(TableEntry))];
static TableEntry OptFaxZeroCodes [(sizeof(N3FaxZeroCodes) / sizeof(TableEntry))];

static BYTE       RelocOne  [256];
static BYTE       RelocZero [256];
/////////////////////////////////////////////////////////////////////////////////////////
BOOL     InitN3(DWORD BufLen)
{
     //InitNextCode();
     EncodedDataBufCurrentPtr    = (PBYTE) malloc ((2 * BufLen) + 32);
     N3EncodingByte              = 0; 
     N3EncodingBit               = 8;                    
     N3EncodedDataSize           = 0;  
     return (EncodedDataBufCurrentPtr != NULL);
}
/////////////////////////////////////////////////////////////////////////////////////////
VOID     ReleaseN3  ()
{
     if(EncodedDataBufCurrentPtr){
        free( EncodedDataBufCurrentPtr );
        EncodedDataBufCurrentPtr = NULL;
     } 
     N3EncodingByte              = 0; 
     N3EncodingBit               = 8;                    
     N3EncodedDataSize           = 0;  
}
/////////////////////////////////////////////////////////////////////////////////////////
static _inline int  CalcOneRuns (PBYTE ImgLine, int   StartPixel, 
                                         DWORD PixelsInLine){
int     Pixel         = PixelsInLine - StartPixel;
DWORD   RunLenght     = 0;
BYTE    StartBitInByte, BitInByte, Mask, Span;  

    if(Pixel > 0){ 

       // CHECK PARTIAL BYTE ON LHS.
       StartBitInByte = (StartPixel & 7);
       if( StartBitInByte ){

           BitInByte = 8 - StartBitInByte;

           Mask = PixelToBit[ BitInByte ];
           Span = OneRuns
                  [((*ImgLine << StartBitInByte) & Mask)];

           if(Span < BitInByte){ // DOESN'T EXTEND TO EDGE OF BYTE
              return (RunLenght + Span);
           }
           RunLenght += Span;
           Pixel     -= BitInByte;
           ImgLine++;
       } 
       // SCAN FULL BYTES FOR ALL ONE'S.
       while (Pixel > 0) {
           if (*ImgLine != 0XFF){// END OF RUN
               return (RunLenght + OneRuns[*ImgLine]);
           }
           RunLenght += 8;
           Pixel     -= 8;
           ImgLine++; 
       }
       return (RunLenght);
    } else {
       return PixelsInLine;
    }
}
/////////////////////////////////////////////////////////////////////////////////////////
static _inline int  CalcZeroRuns (PBYTE ImgLine, int   StartPixel, 
                                          DWORD PixelsInLine){
int    Pixel     = PixelsInLine - StartPixel;
DWORD  RunLenght = 0;
BYTE   StartBitInByte, BitInByte, Mask, Span;  

    if(Pixel > 0){ 

       StartBitInByte = (StartPixel & 7);
 
       if (StartBitInByte) {
           BitInByte = 8 - StartBitInByte;

           Mask = PixelToBit[ BitInByte ];
           Span = ZeroRuns
                  [((*ImgLine << StartBitInByte) & Mask)];
        
           if(Span < BitInByte){ // DOESN'T EXTEND TO EDGE OF BYTE
              return (RunLenght + Span);
           } else {
              Span = BitInByte;
           }
           RunLenght += Span;
           Pixel     -= BitInByte;
           ImgLine++;
       } 
       // SCAN FULL BYTES FOR ALL 0'S.
       while (Pixel > 0) {
           if (*ImgLine != 0X00){// END OF RUN 
               return (RunLenght + ZeroRuns[*ImgLine]);
           }
           RunLenght  += 8; 
           Pixel      -= 8;
           ImgLine++;
       }
       return (RunLenght);
    } else {
       return PixelsInLine;
    }
}
/////////////////////////////////////////////////////////////////////////////////////////
static _inline void FlushBits() // IN C
{                   
// write N3EncodingByte to buffer after all Pixel in N3EncodingByte has been encoded.

    EncodedDataBufCurrentPtr[N3EncodedDataSize] = N3EncodingByte;               
    N3EncodingByte              = 0; 
    N3EncodingBit               = 8;                    
    N3EncodedDataSize++;          
}
/////////////////////////////////////////////////////////////////////////////////////////
static _inline void  PutCode(const TableEntry* CodeMode)
//          Write a variable-length code (bit value) to the output stream.
//          The value is assumed to be at most 16 bit.
{
BYTE Code       = CodeMode->code;
BYTE CodeLength = CodeMode->length;

    while (CodeLength > N3EncodingBit) {                  
        N3EncodingByte |= Code >> (CodeLength -= N3EncodingBit);         
        FlushBits();                
    }
    N3EncodingByte |= (Code & MaskLeft[CodeLength]) << (N3EncodingBit - CodeLength);    
    N3EncodingBit  -= CodeLength;                      
    if (N3EncodingBit == 0){
        FlushBits();    
    }
}
/////////////////////////////////////////////////////////////////////////////////////////
static void  StoreOneRun(DWORD Runlength)
{
// For horizontal mode, write the sequence of codes that describes the 
// specified runlength of zero's or one's. The appropriate table that holds 
// the make-up and terminating codes is supplied.

    // THE PALM DOES NOT SUPPORT MORE THAN 640
    while (Runlength >= 640) {
        const TableEntry* te = &N3FaxOneCodes[73];
        PutCode(te);
        Runlength -= te->runlen;
    }
    if (Runlength >= 64) {
        const TableEntry* te = &N3FaxOneCodes[63 + (Runlength >> 6)];
        PutCode(te);
        Runlength -= te->runlen;
    }
    PutCode(&N3FaxOneCodes[Runlength]);
}
/////////////////////////////////////////////////////////////////////////////////////////
static void  StoreZeroRun(DWORD Runlength)
{
// For horizontal mode, write the sequence of codes that describes the 
// specified runlength of zero's or one's. The appropriate table that holds 
// the make-up and terminating codes is supplied.

    // THE PALM DOES NOT SUPPORT MORE THAN 640
    while (Runlength >= 640) {
        const TableEntry* te = &N3FaxZeroCodes[73];
        PutCode(te);
        Runlength -= te->runlen;
    }
    while(Runlength >= 64) {
        const TableEntry* te = &N3FaxZeroCodes[63 + (Runlength >> 6)];
        PutCode(te);
        Runlength -= te->runlen;
    }
    PutCode(&N3FaxZeroCodes[Runlength]);
}
/////////////////////////////////////////////////////////////////////////////////////////
extern "C" {
/////////////////////////////////////////////////////////////////////////////////////////
int  __stdcall  N3Compress (PBYTE Buffer,  DWORD BufLen)
{
DLL_THREAD_MANAGEMENT();

int    WhiteRunPix,      BlackRunPix;
int    PixelsInLine    = BufLen * 8, StorePixelInLine;
int    CurrentPixel    = 0,          StoreCurrentPix;
int    StartPixel      = 0,          StoreStartPix;
PBYTE  ImgLine         = Buffer,     StoreImgLine;
DWORD  CodeLen         = BufLen; 

    if( Not InitN3(BufLen)){
       AfxMessageBox(_T("Could not allocate Compression buffer"));
       return 0;
    }
    while((PixelsInLine > 0)&&(N3EncodedDataSize < BufLen)){
/*
#ifdef _DEBUG
       StoreImgLine     = ImgLine;
       StoreStartPix    = StartPixel;
       StoreCurrentPix  = CurrentPixel;
       StorePixelInLine = PixelsInLine;
// RESET:
       ImgLine          = StoreImgLine;
       StartPixel       = StoreStartPix;
       CurrentPixel     = StoreCurrentPix;
       PixelsInLine     = StorePixelInLine;
#endif
*/
       //////////////////////////////////////////////////////////////////////
       WhiteRunPix        = CalcZeroRuns (ImgLine, StartPixel, PixelsInLine);

       PixelsInLine      -= WhiteRunPix;
       CurrentPixel      += WhiteRunPix;
       StartPixel         = CurrentPixel % 8;

       ImgLine            = &Buffer[((CurrentPixel) / 8)];

       // THE PALM DOES NOT SUPPORT MORE THAN 640
       StoreZeroRun         (WhiteRunPix);

       //////////////////////////////////////////////////////////////////////
       BlackRunPix        = CalcOneRuns  (ImgLine, StartPixel, PixelsInLine);
       if(BlackRunPix    == 0){
          if(PixelsInLine > 0){
             AfxMessageBox(_T("Error in Compression buffer"));
          }
          break;
       }
       PixelsInLine      -= BlackRunPix;
       CurrentPixel      += BlackRunPix;
       StartPixel         = CurrentPixel % 8; 

       ImgLine            = &Buffer[((CurrentPixel) / 8)];

       // THE PALM DOES NOT SUPPORT MORE THAN 640
       StoreOneRun          (BlackRunPix);
    }
    if (N3EncodingBit    != 0){
        FlushBits();
    }
    BytesTranslated += N3EncodedDataSize;
    CodeLen          = N3EncodedDataSize;
    if(CodeLen      >= BufLen){
       EchoWarnString(_T("Warning: Compression insufisant using uncompressed buffer"));
       CodeLen = 0;
    } else {
       CString Outform;
       Outform.Format( _T("Compression Percentage at: %f%% \r\nPacket Original Size:%d \r\nPacket Reduced Size:%d"), 
                       (float)(((float)CodeLen/(float)BufLen)*100.0), BufLen, CodeLen );
       EchoDebugString( Outform);
       CopyMemory(Buffer, EncodedDataBufCurrentPtr,  CodeLen);
    }
    ReleaseN3();
    return CodeLen;
}
/////////////////////////////////////////////////////////////////////////////////////////
} // extern "C"
/////////////////////////////////////////////////////////////////////////////////////////
static _inline void SimFlushBits() // IN C
{                   
// write N3EncodingByte to buffer after all Pixel in N3EncodingByte has been encoded.

    //EncodedDataBufCurrentPtr[N3EncodedDataSize] = N3EncodingByte;               
    N3EncodingByte              = 0; 
    N3EncodingBit               = 8;                    
    N3EncodedDataSize++;          
}
/////////////////////////////////////////////////////////////////////////////////////////
static _inline void  SimPutCode(const TableEntry* CodeMode)
//          Write a variable-length code (bit value) to the output stream.
//          The value is assumed to be at most 16 bit.
{
BYTE Code       = CodeMode->code;
BYTE CodeLength = CodeMode->length;

    while (CodeLength > N3EncodingBit) {                  
        N3EncodingByte |= Code >> (CodeLength -= N3EncodingBit);         
        SimFlushBits();                
    }
    N3EncodingByte |= (Code & MaskLeft[CodeLength]) << (N3EncodingBit - CodeLength);    
    N3EncodingBit  -= CodeLength;                      
    if (N3EncodingBit == 0){
        SimFlushBits();    
    }
}
/////////////////////////////////////////////////////////////////////////////////////////
static void  ReportOneRun(DWORD Runlength)
{
// For horizontal mode, write the sequence of codes that describes the 
// specified runlength of zero's or one's. The appropriate table that holds 
// the make-up and terminating codes is supplied.

    // THE PALM DOES NOT SUPPORT MORE THAN 640
    while (Runlength >= 640) {
        const TableEntry* te = &OptFaxOneCodes[RelocOne[73]];
        SimPutCode(te);

        OneBitsRunlenght[RelocOne[73]] += 1;
        CalcOneBits += te->length;
        Runlength   -= te->runlen;
    }
    if (Runlength >= 64) {
        const TableEntry* te = &OptFaxOneCodes[RelocOne[63 + (Runlength >> 6)]];
        SimPutCode(te);

        OneBitsRunlenght[RelocOne[63 + (Runlength >> 6)]] += 1;
        CalcOneBits += te->length;
        Runlength   -= te->runlen;
    }
    SimPutCode(&OptFaxOneCodes[RelocOne[Runlength]]);
    CalcOneBits += OptFaxOneCodes[RelocOne[Runlength]].length;
    OneBitsRunlenght[RelocOne[Runlength]] += 1;
}
/////////////////////////////////////////////////////////////////////////////////////////
static void  ReportZeroRun(DWORD Runlength)
{
// For horizontal mode, write the sequence of codes that describes the 
// specified runlength of zero's or one's. The appropriate table that holds 
// the make-up and terminating codes is supplied.
CString Outform;

    // THE PALM DOES NOT SUPPORT MORE THAN 640
    while (Runlength >= 640) {
        const TableEntry* te = &OptFaxZeroCodes[RelocZero[73]];
        SimPutCode(te);

        ZeroBitsRunlenght[RelocZero[73]] += 1;
        CalcZeroBits += te->length;
        Runlength    -= te->runlen;
    }
    while(Runlength >= 64) {
        const TableEntry* te = &OptFaxZeroCodes[RelocZero[63 + (Runlength >> 6)]];
        SimPutCode(te);

        ZeroBitsRunlenght[RelocZero[63 + (Runlength >> 6)]] += 1;
        CalcZeroBits += te->length;
        Runlength    -= te->runlen;
    }
    SimPutCode(&OptFaxZeroCodes[RelocOne[Runlength]]);
    CalcZeroBits += OptFaxZeroCodes[RelocZero[Runlength]].length;
    ZeroBitsRunlenght[RelocZero[Runlength]] += 1;
}
/////////////////////////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////////////////////////
static void InitRLReport ()
{
int     Looper;

    N3EncodingByte      = 0; 
    N3EncodingBit       = 8;                    
    N3EncodedDataSize   = 0;  

    CalcZeroBits        = 0;
    CalcOneBits         = 0;

    ZeroMemory(ZeroBitsRunlenght, sizeof(ZeroBitsRunlenght));
    ZeroMemory(OneBitsRunlenght,  sizeof(OneBitsRunlenght));

    CopyMemory(OptFaxOneCodes,  N3FaxOneCodes,  sizeof(OptFaxOneCodes));
    CopyMemory(OptFaxZeroCodes, N3FaxZeroCodes, sizeof(OptFaxZeroCodes));

    for(Looper = 0; Looper < 128; Looper++){
       RelocOne  [Looper] = Looper;
       RelocZero [Looper] = Looper;
    }
}
/////////////////////////////////////////////////////////////////////////////////////////
static void AddFramesStats ()
{
CString Outform;
int     Looper;

    if (N3EncodingBit    != 0){
       SimFlushBits();
    }

    BytesTransmitted   += N3EncodedDataSize;
    FramesCalcZeroBits += CalcZeroBits;
    FramesCalcOneBits  += CalcOneBits;

    for(Looper = 0; Looper < 74; Looper++){
       FramesZeroBitsRunlenght[Looper] += ZeroBitsRunlenght[Looper];
    }
    for(Looper = 0; Looper < 74; Looper++){
       FramesOneBitsRunlenght[Looper]  += OneBitsRunlenght[Looper];
    }
}
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
void   N3ClearRLReport          () // RESET VALUE TO ZERO 
{
    FramesCalcZeroBits        = 0;
    FramesCalcOneBits         = 0;
    BytesTransmitted          = 0;
    BytesTranslated           = 0;

    ZeroMemory(FramesZeroBitsRunlenght, sizeof(FramesZeroBitsRunlenght));
    ZeroMemory(FramesOneBitsRunlenght,  sizeof(FramesOneBitsRunlenght));
}
/////////////////////////////////////////////////////////////////////////////////////////
void N3ReportRunLen (PBYTE Buffer,  DWORD BufLen)
{
int     WhiteRunPix,      BlackRunPix;
int     PixelsInLine    = BufLen * 8;
int     CurrentPixel    = 0;
int     StartPixel      = 0;
PBYTE   ImgLine         = Buffer;
DWORD   CodeLen         = BufLen; 

    InitRLReport ();

    while((PixelsInLine > 0)){
       //////////////////////////////////////////////////////////////////////
       WhiteRunPix        = CalcZeroRuns (ImgLine, StartPixel, PixelsInLine);

       PixelsInLine      -= WhiteRunPix;
       CurrentPixel      += WhiteRunPix;
       StartPixel         = CurrentPixel % 8;

       ImgLine            = &Buffer[((CurrentPixel) / 8)];

       // REPORT WHITE RUNS
       ReportZeroRun        (WhiteRunPix);

       //////////////////////////////////////////////////////////////////////
       BlackRunPix        = CalcOneRuns  (ImgLine, StartPixel, PixelsInLine);
       if(BlackRunPix    == 0){
          if(PixelsInLine > 0){
             AfxMessageBox(_T("Error in Compression buffer"));
          }
          break;
       }
       PixelsInLine      -= BlackRunPix;
       CurrentPixel      += BlackRunPix;
       StartPixel         = CurrentPixel % 8; 

       ImgLine            = &Buffer[((CurrentPixel) / 8)];

       // REPORT BLACK RUNS
       ReportOneRun         (BlackRunPix);
    }
    AddFramesStats ();
    return ;
}
/////////////////////////////////////////////////////////////////////////////////////////
void N3ReportPageStats ()
{
CString Outform;
int     Looper;

    // BytesTranslated;
    Outform.Format( _T("Total Bytes Count: \t%d\n"), BytesTransmitted);
    OutputDebugString( Outform);
    Outform.Format( _T("Zero Bits Count: \t%d\tPerFrames: \t%d\n"), CalcZeroBits, FramesCalcZeroBits);
    OutputDebugString( Outform);
    Outform.Format( _T("One Bits Count: \t%d\tPerFrames: \t%d\n"),  CalcOneBits,  FramesCalcOneBits);
    OutputDebugString( Outform);

    for(Looper = 0; Looper < 74; Looper++){
       Outform.Format    (_T("ZeroBits Runlenght \t%d \tCount: \t%d\tPerFrames: \t%d\n"), 
                          Looper, 
                          ZeroBitsRunlenght[Looper],
                          FramesZeroBitsRunlenght[Looper]);
       OutputDebugString (Outform);
    }
    for(Looper = 0; Looper < 74; Looper++){
       Outform.Format    (_T("OneBits Runlenght \t%d \tCount: \t%d\tPerFrames: \t%d\n"), 
                          Looper, 
                          OneBitsRunlenght[Looper],
                          FramesOneBitsRunlenght[Looper]);
       OutputDebugString (Outform);
    }
}
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
void N3ReportPageRunLen (PBYTE Buffer,  DWORD BufLen)
{
int     WhiteRunPix,      BlackRunPix;
int     PixelsInLine    = BufLen * 8;
int     CurrentPixel    = 0;
int     StartPixel      = 0;
PBYTE   ImgLine         = Buffer;
DWORD   CodeLen         = BufLen; 

    InitRLReport ();

    while((PixelsInLine > 0)){
       //////////////////////////////////////////////////////////////////////
       WhiteRunPix        = CalcZeroRuns (ImgLine, StartPixel, PixelsInLine);

       PixelsInLine      -= WhiteRunPix;
       CurrentPixel      += WhiteRunPix;
       StartPixel         = CurrentPixel % 8;

       ImgLine            = &Buffer[((CurrentPixel) / 8)];

       // REPORT WHITE RUNS
       ReportZeroRun        (WhiteRunPix);

       //////////////////////////////////////////////////////////////////////
       BlackRunPix        = CalcOneRuns  (ImgLine, StartPixel, PixelsInLine);
       if(BlackRunPix    == 0){
          if(PixelsInLine > 0){
             AfxMessageBox(_T("Error in Compression buffer"));
          }
          break;
       }
       PixelsInLine      -= BlackRunPix;
       CurrentPixel      += BlackRunPix;
       StartPixel         = CurrentPixel % 8; 

       ImgLine            = &Buffer[((CurrentPixel) / 8)];

       // REPORT BLACK RUNS
       ReportOneRun         (BlackRunPix);
    }
    N3ReportPageStats ();
    return;
}
