//PadCacheMngr.cpp
///////////////////////////////////////////////////////////////////////////////////////////////////
#include "StdAfx.h"
///////////////////////////////////////////////////////////////////////////////////////////////////
#define MAKE_WORD_ALIGNED  if (FrameSize & 1) FrameSize += 1;  
///////////////////////////////////////////////////////////////////////////////////////////////////
BYTE    PDACache                   [2 * MB];  //CacheMemorySize * 512 KB
WORD    CacheMemorySize          = 4; //12; // * 512 KB
WORD    MaxPageSize              = 128;     //DEFAULT *   1 KB    
WORD    MaxNumOfPages            = (CacheMemorySize * 512) / MaxPageSize; // : DEFAULT
BOOL    UseCacheMemory           = 1,
        SupportShowPage          = 1,      // : NEW... 
        SupportFlexiblePageSize  = 1,      // : NEW... 
        CacheReady;
BYTE    MemChunkSize             = 4;      // * 1 KB

int     CurrentLink              = 0, PageIndex    = 0, MemIndex     = 0, TotalPageNum = 0;
CString CurrentSerialNo;
BOOL    FirstTimeOffLine         = TRUE;
BYTE    CurrentPdaMode           = MODE_NORMAL; // MODE_QUICKLOAD;  // MODE_NORMAL; // MODE_EMAIL_OFFLINE; // 
CString DirectAccessUID          = _T("");
BYTE    TaskListBuffer            [32 * KB];  
///////////////////////////////////////////////////////////////////////////////////////////////////
PDALINKSINFO   LinksInfo;
///////////////////////////////////////////////////////////////////////////////////////////////////
#if USE_CACHEMNGR
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  GetPdaCacheMemory ()
{
HANDLE  CacheFileHandle   = INVALID_HANDLE_VALUE;
CString CacheFileName     = "\\PDA";
DWORD   BytesRead         = 0;

   if((UseCacheMemory) && (CurrentSerialNo != PDASerialNo)){
      
      SavePdaCacheMemory ();
      CacheReady          = FALSE;
      CurrentSerialNo     = PDASerialNo;
      ZeroMemory           (&LinksInfo,     sizeof(LinksInfo));
      ZeroMemory           (PDACache,       sizeof(PDACache));
      ZeroMemory           (TaskListBuffer, sizeof(TaskListBuffer));

      CacheFileName       = CacheFileName + CurrentSerialNo + "Cache.txt";
      CacheFileHandle     = CreateFile(CacheFileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

      if(GetLastError()  == ERROR_ALREADY_EXISTS){ 
         BytesRead        = ReadBinaryFile(CacheFileHandle, &PDACache[0], sizeof(PDACache));
         if(BytesRead    == sizeof(PDACache)){
            CopyMemory     (&LinksInfo, &PDACache[(sizeof(PDACache) - sizeof(LinksInfo))], sizeof(LinksInfo));
         }
         BytesRead        = ReadBinaryFile(CacheFileHandle, (PBYTE)ImageBmp.bmiColors, (256 * sizeof(RGBQUAD)));
      }
      CacheReady    = TRUE;
      if(CacheFileHandle != INVALID_HANDLE_VALUE){
         CloseHandle       (CacheFileHandle);
         return TRUE;
      }
   }
   return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  SavePdaCacheMemory ()
{
HANDLE  CacheFileHandle   = INVALID_HANDLE_VALUE; 
CString CacheFileName     = "\\PDA";

   if((UseCacheMemory) && (CurrentSerialNo != ""))
   {
      CacheFileName       = CacheFileName + CurrentSerialNo + "Cache.txt";
      CacheFileHandle     = CreateFile(CacheFileName, GENERIC_WRITE, FILE_SHARE_READ, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

      if(CacheFileHandle != INVALID_HANDLE_VALUE){

         // STORE LINKS INFO
         CopyMemory        (&PDACache[(sizeof(PDACache) - sizeof(LinksInfo))], &LinksInfo, sizeof(LinksInfo));

         WriteBinaryFile   (CacheFileHandle, &PDACache[0], sizeof(PDACache));
         WriteBinaryFile   (CacheFileHandle, (PBYTE)ImageBmp.bmiColors, (256 * sizeof(RGBQUAD)));

         CloseHandle       (CacheFileHandle);
         return TRUE;
      }
   }
   return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL HandleCacheMemoryCommand (BYTE CommandBuffer[8]) 
{
CACHEINFO         CacheInfo;
CACHEFRAMEINFO    CacheFrameInfo;
UPDATECACHEINFO   UpdateCacheInfo;
BYTE              CacheBuffer [8 * KB];
WORD              Looper = 0, BlockSize = 0;
BYTE              SeqID, FrameID;
BOOL              bRet = FALSE;      
WORD              MemIndex = 0;

   CacheFrameInfo                   = *(CACHEFRAMEINFO*) CommandBuffer;
   ZeroMemory                         (CacheBuffer, sizeof(CacheBuffer));
   SeqID                            = CacheFrameInfo.SequenceID;
   FrameID                          = CacheFrameInfo.FrameID; 

   EchoCacheCommand                   (SeqID, FrameID, CacheFrameInfo.Action);

   if(CacheFrameInfo.Action        == 'D'){   // : NEW TO SUPPORT DISPLAY PAGE.....
      MemIndex                      = (WORD)CacheFrameInfo.ExtraLen;
      bRet                          = DisplayCachedPage(MemIndex);

   } else if(CacheFrameInfo.Action == 'C'){   // : NEW TO SUPPORT CLEAR PAGE .....
      MemIndex                      = (WORD)CacheFrameInfo.ExtraLen;
      bRet                          = ClearCachedPage(MemIndex);

   } else if(CacheFrameInfo.Action == 'I'){   // : NEW TO SUPPORT INIT CACHE (USED TO BE IN HANDLE INIT CMD)

      if(Not RecvData                 ((PBYTE)&CacheInfo, CacheFrameInfo.ExtraLen)){
         RcvError++;
         EchoRcvError                 (-2, RcvError);
         PushFrameNackQueue           (SeqID, FrameID, 1, NACK_ERROR_RECEIVE);
         return FALSE;
      }      
      switch(CacheInfo.Action){
      case 'R': // RESET
           ZeroMemory                 (PDACache, (CacheMemorySize * 512 * KB));
           ZeroMemory                 (&LinksInfo, (sizeof(LinksInfo)));
           EchoText                   (_T("Resetting Cache!"));
           break;
      case 'U':
           EchoText                   (_T("Updating Cache!"));
           break;

      default:
          PushFrameNackQueue          (SeqID, FrameID, 1, NACK_ERROR_CACHECOMMAND);
          return FALSE;
      }
      MaxPageSize                   = CacheInfo.MaxPageSize;
      MemChunkSize                  = CacheInfo.ChunkSize;
      MaxNumOfPages                 = ((CacheMemorySize * 512) / MaxPageSize); 

      LinksInfo.MaxPageSize         = MaxPageSize;
      LinksInfo.CacheID             = CacheInfo.CacheID;  
      EchoText                        (_T("Updating Cache ID!"));
      bRet                          = TRUE;  

   } else if((CacheFrameInfo.ExtraLen) && (CacheFrameInfo.ExtraLen <= sizeof(CacheBuffer))){

      if(Not RecvData                 ((PBYTE)CacheBuffer, CacheFrameInfo.ExtraLen)){
         RcvError++;
         EchoRcvError                 (-2, RcvError);
         PushFrameNackQueue           (SeqID, FrameID, 1, NACK_ERROR_RECEIVE);
         return FALSE;
      }      
      while( Looper                 < CacheFrameInfo.ExtraLen){
    
         switch(CacheBuffer[Looper]){
         case 'U':
              EchoText                (_T("Received UpdateCacheData Block!"));
              CopyMemory              (&UpdateCacheInfo, &CacheBuffer[Looper], sizeof(UpdateCacheInfo));
              BlockSize             = UpdateCacheInfo.Len;
              bRet                  = UpdateCacheData (&CacheBuffer[Looper]); 
              Looper               += BlockSize;
              break;
         default:
              bRet                  = FALSE;
              break;
         }
         if(bRet                   == FALSE){
            break;
         }
      }
   }
   if(bRet){ 
      PushFrameAckQueue  (SeqID, FrameID, 1);
   } else { 
      PushFrameNackQueue (SeqID, FrameID, 1, NACK_ERROR_CACHECOMMAND);
   }
   return bRet;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL HandleOrderedTaskListCommand (BYTE CommandBuffer[8]) 
{
PTASKLISTINFO TaskInfo;
char          TaskBuffer[8192];
BYTE          FrameID, SeqID, Compression, ExtraLen, PageOrder;
DWORD         CacheMemDest, PacketSize;
CString       Info;

    ZeroMemory                 (TaskBuffer, sizeof(TaskBuffer));
    TaskInfo                 = (PTASKLISTINFO)&TaskBuffer [0];
 
    EchoTask                   (CommandBuffer);

    CopyMemory                 (&TaskInfo->Command[0], &CommandBuffer[0], 8);  

    SeqID                    = (TaskInfo->Command[2]);
    FrameID                  = (TaskInfo->Command[3]);
    PageOrder                = (TaskInfo->Command[4]);
	Compression              = (TaskInfo->Command[5]);
	ExtraLen                 = (TaskInfo->Command[6]);

    if(FrameID              != FRAMETASKLIST){
       EchoError               (_T("Wrong frame ID in Ordered TaskLis Command"));
       PushFrameNackQueue      (SeqID, FrameID, 1, NACK_ERROR_FRAME);
       return FALSE;
    }
    if(Not RecvData            ((PBYTE)&TaskInfo->Reserved[0], ExtraLen)){
       RcvError++;
       EchoError               (_T("Failed to read extra info bytes in Ordered TaskLis Command"));
       PushFrameNackQueue      (SeqID, FrameID, 1, NACK_ERROR_FRAME);
       return FALSE;
    }
    PacketSize               = sizeof(TASKLISTINFO);

    if((TaskInfo->ByteCount == 0) 
    || (TaskInfo->ByteCount >= sizeof(TaskBuffer))){
          RcvError++;
          EchoRcvError         (-2, RcvError);
          PushFrameNackQueue   (SeqID, FrameID, 1, NACK_ERROR_BUFFER);
          return FALSE;
    }
    if(Not RecvData            ((PBYTE)&TaskBuffer[PacketSize], TaskInfo->ByteCount)){
       RcvError++;
       EchoRcvError            (-3, RcvError);
       PushFrameNackQueue      (SeqID, FrameID, 1, NACK_ERROR_RECEIVE);
       return FALSE;
    }
    PacketSize              += TaskInfo->ByteCount;
    ////////////////////////////////////////////////////////////////////////////////////
    if((UseCacheMemory)     && (TaskInfo->Features & 1)){
     
       CacheMemDest          = TaskInfo->MemAddress;
       if(TaskInfo->MemAddress >= (sizeof(PDACache) - PacketSize)){
          EchoRcvError         (-4, RcvError);
          PushFrameNackQueue   (SeqID, FrameID, 1, NACK_ERROR_CACHEFAILED);
          EchoError            (_T("Invalid cache mem destination in Ordered TaskLis Command"));
          return FALSE;
       }
       CopyMemory              (&PDACache[CacheMemDest],   &TaskInfo->Command[0], PacketSize);

       Info.Format             (_T("Stored to Cache: FrameID = %d"), FrameID);
       EchoText(Info);
    }
    PushFrameAckQueue (SeqID, FrameID, 1);
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  GetEmailPageIndexByUid    (LPCTSTR ThisUid, PWORD MemIndex)
{
DWORD           ReadFrom = 0, ImageSize = 0, FrameSize, PageLooper;
PCOLORFRAMEINFO CachedFrameInfo;
PTASKLISTINFO   TaskListInfo;
CString         PageUid;

    for(PageLooper = 0; PageLooper < MaxNumOfPages; PageLooper ++){

       ReadFrom    = (PageLooper * MaxPageSize * KB); 
       while(1){

          CachedFrameInfo                  = (PCOLORFRAMEINFO)&PDACache[ReadFrom];
          if((CachedFrameInfo->Command[0] != 0xE0) || (CachedFrameInfo->Command[7] != 0x1A)){ 
             break;// NOT A FRAME INFO, CONTINUE WITH NEXT CACHED PAGE
          }
          if(CachedFrameInfo->Command[3]  == FRAMETASKLIST){
             
             TaskListInfo                  = (PTASKLISTINFO)&PDACache[ReadFrom];
             
             if(ReadThisPageUid              (TaskListInfo, &PageUid)){
                if(PageUid.CompareNoCase     (ThisUid) == 0){
                   *MemIndex               = PageLooper;
                   return TRUE;
                }
             }
             ImageSize                     = TaskListInfo->ByteCount;
             FrameSize                     = ImageSize + sizeof(TASKLISTINFO);
          } else {
             ImageSize                     = CachedFrameInfo->SumData;
             FrameSize                     = ImageSize + sizeof(COLORFRAMEINFO);
          }

          MAKE_WORD_ALIGNED
          ReadFrom                        += FrameSize;
       }
    }
    return FALSE;    
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  ReadThisPageUid            (PTASKLISTINFO TaskInfo, CString *PageUid)
{
DWORD          TaskLooper   = 0;
PBYTE          TaskBuffer;
PPAGEIDINFO    PageIdInfo;
PLINKINFO      LinkInfo;
TCHAR          UidBuffer      [UID_INFO_CHAR_LEN + 1];

    ZeroMemory                (UidBuffer, sizeof(UidBuffer));

    TaskBuffer              = (PBYTE)TaskInfo + sizeof(TASKLISTINFO);

    while(TaskLooper        < TaskInfo->ByteCount){

       switch(TaskBuffer      [TaskLooper]){
       case 'I':              // ID BLOCK
            PageIdInfo      = (PPAGEIDINFO)&TaskBuffer[TaskLooper];
            //StringCopy        (UidBuffer, (LPCTSTR)&PageIdInfo->UID, SizeFromTCharLen(UID_INFO_CHAR_LEN));
            //*PageUid        =  (LPCTSTR)UidBuffer;
            *PageUid        = PageIdInfo->UID;
            return TRUE;
       case 'L':              // LINK INFO BLOCK, NOT INTERESTED
            LinkInfo        = (PLINKINFO)&TaskBuffer[TaskLooper];
            TaskLooper     += LinkInfo->BlockLen;
            break;
       default:
            EchoError         (_T("Unknown block in Read ThisPageUid"));
            return FALSE;
       }
    }
    return FALSE;
///////////////////////////////////////////////////////////////////////////////////////////////////
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  DisplayEmailPageByUid        (LPCTSTR ThisUid)
{
WORD MemIndex = 0;

    if(GetEmailPageIndexByUid    (ThisUid, &MemIndex)){
       if(DisplayCachedPage(MemIndex)){
          return TRUE;
       }
    }
    return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  UpdateCacheData (PBYTE Buf)
{
PMEMBLOCKINFO          MemBlockInfo;
PUPDATECACHEINFO       UpdateCacheInfo;
PUPDATECACHEINFOLEGACY UpdateCacheInfoOld;
WORD                   ReadFrom  = 0, Looper, BlockCount, Len, PageToDelete;
LONG                   PageStart = 0;
BOOL                   bRet      = FALSE;
CString                Info;

   if(SupportShowPage){     // NEW CACHE PROTOCOL
      UpdateCacheInfo     = (PUPDATECACHEINFO)Buf;

      BlockCount          = UpdateCacheInfo->MemBlockCount;
      Len                 = UpdateCacheInfo->Len;

      if((BlockCount      > MAX_MEM_BLOCK) || (UpdateCacheInfo->Terminator != 0x00)){
         EchoText           (_T("???? Num of Move memory Blocks is out of limit in New Protocol!"));
         goto EXIT;   
      }
   } else {                 // OLD CACHE PROTOCOL
      UpdateCacheInfoOld  = (PUPDATECACHEINFOLEGACY)Buf;

      BlockCount          = UpdateCacheInfoOld->MemBlockCount;
      Len                 = UpdateCacheInfoOld->Len;
      PageToDelete        = UpdateCacheInfoOld->PageToDelete;

      if((BlockCount      > MAX_MEM_BLOCK_LEGACY) || (UpdateCacheInfoOld->Terminator != 0x00)){
         EchoText           (_T("???? Num of Move memory Blocks is out of limit in Old Protocol!"));
         goto EXIT;   
      }
   }
   // PROCESS MOVEMEMORY BLOCKS (IF ANY)
   Buf                   += sizeof(UPDATECACHEINFO); // SAME SIZE IN OLD PROTOCOL
   if(Len                != (BlockCount * sizeof(MEMBLOCKINFO)) + sizeof(UPDATECACHEINFO)){
      EchoText              (_T("???? Wrong length in UPDATECACHEINFO while processing Mem Blocks!"));
      goto EXIT;   
   }
   if(BlockCount){
      Info.Format           (_T("Start Processing %d Move Memory Blocks"), BlockCount);
      EchoText              (Info);
   }
   for(Looper = 0; Looper < BlockCount; Looper ++){

      MemBlockInfo        = (PMEMBLOCKINFO) Buf;

      if((MemBlockInfo   -> SrcSize > (MaxPageSize * KB)) 
      || (MemBlockInfo   -> Dest    > sizeof(PDACache)) 
      || (MemBlockInfo   -> Source  > sizeof(PDACache))){
         EchoText           (_T("???? Error while processing Move memory Block!"));
         goto EXIT;   
      }
      CopyMemory            (&PDACache[MemBlockInfo->Dest], &PDACache[MemBlockInfo->Source], MemBlockInfo->SrcSize);
      Buf                += sizeof(MEMBLOCKINFO);

      Info.Format           (_T("Cache Block Move Src: %d, Dst: %d, Siz: %d"), 
                             MemBlockInfo->Source, MemBlockInfo->Dest, MemBlockInfo->SrcSize);
      EchoText              (Info);
   }
   if(BlockCount){
      Info.Format           (_T("Finished Processing %d Move Memory Blocks"), (Looper));
      EchoText              (Info);
   }
   bRet                   = TRUE;

EXIT:
   // MUST BE DONE AFTER MOVING MEM BLOCKS...
   if(Not SupportShowPage){ // OLD CACHE PROTOCOL
      if(ClearCachedPage    (PageToDelete) == FALSE){
         EchoText           (_T("???? Failed to delete page in Old Protocol!"));
         bRet             = FALSE;
      }
   }
   return bRet;
} 
///////////////////////////////////////////////////////////////////////////////////////////////////
void  BrowseOffLine(BYTE FunctionKey)
{
   if((CacheReady          == FALSE)
   ){
      AfxMessageBox(_T("No Cache available!"));
      return;
   }
   if(CurrentPdaMode       == MODE_EMAIL_OFFLINE){  // START WITH MAIN EMAIL PAGE
      if(FALSE             == DisplayEmailPageByUid (_T("UID:EMAILLIST"))){

         AfxMessageBox        (_T("Failed to find cached main email page! Connecting to server!"));
         CurrentPdaMode     = MODE_EMAIL_DIRECT;
         DirectAccessUID    = _T("UID:EMAILLIST");
         StartDevice          ();
      }
      return;
   }

   if(FirstTimeOffLine){ 
      FirstTimeOffLine      = FALSE;
      CurrentLink           = 0;
   }
   switch(FunctionKey){
   case 134: // BACKWARD KEY
        CurrentLink    --;
        if(CurrentLink  < 0){
           CurrentLink  = (MaxNumOfPages - 1);
        }
        break;
   case 135: // FORWARD KEY
        CurrentLink    ++;
        if(CurrentLink >= MaxNumOfPages){
           CurrentLink  = 0;
        }
        break;
   }
GetData:
   PageIndex = CurrentLink;

   if(IsValidPageIndex (PageIndex) == FALSE){
      AfxMessageBox(_T("Invalid Page Index!"));
      return;
   }
   MemIndex  = PageIndex;
   DisplayCachedPage(MemIndex);
   EmptyAckQueue     ();
   return;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL DisplayCachedPage (int MemIndex)
{
BOOL            Done = FALSE;
BOOL            bRet = TRUE; 
DWORD           ReadFrom = 0;
PTASKLISTINFO   TaskFrameInfo;
PCOLORFRAMEINFO CachedFrameInfo;
BYTE            HeaderSize  = (sizeof(COLORFRAMEINFO)); // LESS ONE BYTE OF IMAGE
WORD            FrameSize   = 0, ImageSize = 0;
int             Compression, StepLine, InitialPhase;
BOOL            IsTransparent;
PBYTE           CacheImage;  
CString         Info;

   if(IsValidMemIndex (MemIndex)      == FALSE){
      EchoError                          (_T("???? Invalid Mem index in Display Cached Page!"));
   }
   ClearPadScreen                        ();
   ZeroMemory                            (TaskListBuffer,        sizeof(TaskListBuffer));
   DirectAccessUID                     = _T("");

   ReadFrom                            = (MemIndex * MaxPageSize * KB); 
   while(1){

      CachedFrameInfo                  = (PCOLORFRAMEINFO)&PDACache[ReadFrom];
      if((CachedFrameInfo->Command[0] != 0xE0) || (CachedFrameInfo->Command[7] != 0x1A)){ 
         break;// NOT A FRAME INFO
      }
      // IF IT IS FRAMETASKLIST, RECORD IT INTO TaskListBuffer  AND CONTINUE...
      if(CachedFrameInfo->Command[3]  == FRAMETASKLIST){

         ZeroMemory                      (TaskListBuffer,        sizeof(TaskListBuffer));
         DirectAccessUID               = _T("");

         TaskFrameInfo                 = (PTASKLISTINFO)CachedFrameInfo;
         FrameSize                     = (8 + TaskFrameInfo->Command[6] + TaskFrameInfo->ByteCount);
         if(FrameSize                  > sizeof(TaskListBuffer)){
            EchoError                    (_T("Insufficient TaskList Buffer in Display CachedPage!"));
            return FALSE;
         }
         CopyMemory                      (TaskListBuffer, &PDACache[ReadFrom], FrameSize);
         MAKE_WORD_ALIGNED
         ReadFrom                     += FrameSize;
         continue;
      }

      StepLine       = ((CachedFrameInfo->Command[4] & 0x70) / 16) + 1;
      InitialPhase   = ((CachedFrameInfo->Command[4] & 0x80) != 0);
      Compression    = ((CachedFrameInfo->Command[5] & 0x7F));
      IsTransparent  = ((CachedFrameInfo->Command[5] & 0x80) != 0);
      ImageSize      = CachedFrameInfo->SumData;
      CacheImage     = (((PBYTE)CachedFrameInfo) + HeaderSize); 

      if(CachedFrameInfo->Command[1]  == 'J'){ // JPEG MULTI PACKET PROCESSING
         
         if(CachedFrameInfo->SumData   < TempBufferSize){
            CopyMemory                   (&TempBuffer[0], CacheImage, CachedFrameInfo->SumData);

            if(Not ProcessMultiPackImage (CachedFrameInfo, 0, FALSE)){
               bRet                    = FALSE;
               EchoError                 (_T("???? Failed to Process MultiPackImage while reading from cache!"));
            }
         } else {
            EchoError                    (_T("Insufficient temporary buffer size in Display CachedPage!"));
            break;
         }
      } else {    // REGULAR COLOR FRAME

	     switch(Compression){
         case PD_COMPRESS_ZIP:
              InitUnZipFrame             (CachedFrameInfo->X, CachedFrameInfo->Y, CachedFrameInfo->W, CachedFrameInfo->H,
                                          CachedFrameInfo->BitPerPixel, IsTransparent, ImageSize, StepLine, InitialPhase,
                                          Palm.ScreenPointer, CacheImage); 
              if(UnzipImageFrame ()   == Z_OK){
                 Info.Format             (_T("Read from cache: FID = %3d  ZIP"), (int)CachedFrameInfo->Command[3]);
                 EchoText                (Info);
                 RefreshIPalm            ();
              } else {
                 EchoError               (_T("???? Failed to Unzip Cached Frame!"));
                 bRet                  = FALSE; 
              }
              break;
         case PD_COMPRESS_JPEG: 
              if(JUncompressFrame        (CachedFrameInfo->X, CachedFrameInfo->Y, CachedFrameInfo->W, CachedFrameInfo->H, CachedFrameInfo->BitPerPixel, 
                                          ImageSize, StepLine, InitialPhase, Palm.ScreenPointer, CacheImage)
              ){
                 Info.Format             (_T("Read from cache: FID = %3d  JPEG"), (int)CachedFrameInfo->Command[3]);
                 EchoText                (Info);
                 RefreshIPalm            ();
              } else {
                 EchoError               (_T("???? Failed to J Uncompress Cached Frame!"));
                 bRet                  = FALSE; 
              }
              break;
         case PD_COMPRESS_NONE:
              InitUnZipFrame             (CachedFrameInfo->X, CachedFrameInfo->Y, CachedFrameInfo->W, CachedFrameInfo->H,
                                          CachedFrameInfo->BitPerPixel, IsTransparent, ImageSize, StepLine, InitialPhase,
                                          Palm.ScreenPointer, CacheImage); 
              if(PaintUnCompresedFrame   () == Z_OK){
                 Info.Format             (_T("Read from cache: FID = %3d  NOT COMPRESSED"), (int)CachedFrameInfo->Command[3]);
                 EchoText                (Info);
                 RefreshIPalm();
              } else {
                 EchoError               (_T("???? Failed to Paint uncompressed Cached Frame!"));
                 bRet = FALSE;           
              }
              break;
         default:
              EchoError                  (_T("???? Unknown compression in Display Cached Page!"));
              break;
         }
      }
      FrameSize                        = ImageSize + HeaderSize;
      MAKE_WORD_ALIGNED
      ReadFrom                        += FrameSize;
   }
   return bRet;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL ClearCachedPage (int MemIndex)
{
LONG PageStart;

    
    if(IsValidMemIndex             (MemIndex) == TRUE){
       PageStart                 = (MemIndex * MaxPageSize * KB);
       ZeroMemory                  (&PDACache[PageStart], (MaxPageSize * KB));
       return TRUE;
    }
    if(Not SupportShowPage){       // OLD PROTOCOL
       return TRUE; 
    }
    EchoError                      (_T("???? Failed to Clear Cached Page!"));
    return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  IsValidPageIndex    (int IndexToVerify)  
{
CString Info;

    if((IndexToVerify < 0)      || (IndexToVerify >= MaxNumOfPages)){
       Info.Format                 (_T("???? Page index %d is out of boundary!"), IndexToVerify);
       EchoError                   (Info);
       return FALSE;
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  IsValidMemIndex      (int IndexToVerify) // 
{
CString Info;

    if((IndexToVerify < 0)      || (IndexToVerify > MaxNumOfPages)){
       if(SupportShowPage){        // NEW PROTOCOL
          Info.Format              (_T("???? Mem index %d is out of boundary!"), IndexToVerify);
          EchoError                (Info);
       }
       return FALSE;
    } 
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  ProcessCacheEmailClick (long X, long Y)
{
DWORD          TaskLooper   = 0;
PTASKLISTINFO  TaskFrameInfo;
PPAGEIDINFO    PageIdInfo;
PLINKINFO      LinkInfo;

    if(IsMemDirty (TaskListBuffer, sizeof(TaskListBuffer))){

       TaskFrameInfo                    = (PTASKLISTINFO)&TaskListBuffer[0];
       if((TaskFrameInfo->Command[0] != 0xE0) 
       || (TaskFrameInfo->Command[7] != 0x1A)
       || (TaskFrameInfo->Command[3] != FRAMETASKLIST)
       ){ 
          EchoError                (_T("Failoed to fing Task List Info in Process CacheEmail Click!"));
          return FALSE;            // NOT A TASK LIST INFO
       }
       TaskLooper                = sizeof(TASKLISTINFO);

       while(TaskLooper          < (sizeof(TASKLISTINFO) + TaskFrameInfo->ByteCount)){

          switch(TaskListBuffer    [TaskLooper]){
          case 'I':                // ID BLOCK
               PageIdInfo        = (PPAGEIDINFO)&TaskListBuffer[TaskLooper];
               TaskLooper       += PageIdInfo->BlockLen;
               continue;

          case 'L':                // LINK INFO BLOCK, NOT INTERESTED
               LinkInfo          = (PLINKINFO)&TaskListBuffer[TaskLooper];

               if((Y            >= LinkInfo->RectTop)
               && (Y            <= LinkInfo->RectBottom)
               ){
                  if((X         >= LinkInfo->RectLeft)
                  && (X         <= LinkInfo->RectRight)
                  ){
                     return  ProcessEmailLinkClick (LinkInfo);
                  }
               }
               TaskLooper       += LinkInfo->BlockLen;
               continue;
          default:
               if(TaskListBuffer   [TaskLooper] != 0){
                  EchoError        (_T("Unknown block in Process CacheEmail Click!"));
                  return FALSE;
               }
               return TRUE;
          }
       }
    }
    return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  ProcessEmailLinkClick        (PLINKINFO  LinkInfo)
{
CString LinkDestUid = _T(""), Info;
DWORD   LinkAction  = 0;
BOOL    bRet        = FALSE;

    LinkDestUid                  = LinkInfo->UID;
    LinkAction                   = LinkInfo->Action;

    if(LinkDestUid.IsEmpty()){
      EchoError                    (_T("Empty destination UID in Process EmailLink Click!"));
      return FALSE;
    }
    switch(LinkAction){
    case 'SHOW': 
         bRet                    = DisplayEmailPageByUid (LinkDestUid);
         if(bRet                == FALSE){
            Info.Format            (_T("Failed to find cached email! Connecting to server to get EMAIL by UID: %s"), LinkDestUid);  
            AfxMessageBox          (Info);
            CurrentPdaMode       = MODE_EMAIL_DIRECT;
            DirectAccessUID      = LinkDestUid;
            StartDevice            ();
         }
         break;
    case 'GOTO': 
         Info.Format               (_T("Connecting to server to get EMAIL by UID: %s"), LinkDestUid);  
         AfxMessageBox             (Info);
         CurrentPdaMode          = MODE_EMAIL_DIRECT;
         DirectAccessUID         = LinkDestUid;
         StartDevice               ();
         break;
    default:
         EchoError                 (_T("Unknown action in Process EmailLink Click!"));
    }
    return bRet;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
#endif // USE_CACHEMNGR
///////////////////////////////////////////////////////////////////////////////////////////////////

