//PadCacheMngr.h
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef __PDACACHEMNGR_H_
#define __PDACACHEMNGR_H_

//#define PAGE_PER_CACHE    10
#define MAX_MEM_BLOCK              512
#define MAX_MEM_BLOCK_LEGACY        24 // OLD PDA COMPATABILITY
///////////////////////////////////////////////////////////////////////////////////////////////////

// USED FOR CURRENT SESSION MODE   // TO DISCUSS WITH DENIS
#define MODE_NORMAL          0
#define MODE_EMAIL_SYNC      1   // RUN HIDDEN EMAIL SYNC
#define MODE_EMAIL_DIRECT    2   // UPON CONNECTION GO TO THE REQUESTED EMAIL
#define MODE_EMAIL_OFFLINE   4   // BROWSE CACHED EMAILS OFFLINE
#define MODE_QUICKLOAD       5


#define MAX_EMAIL_PER_PAGE  16

#define UIDINFO_HEADER_LEN   8   // 'MAIL' + 4 TCHAR EMAIL COUNT
#define UID_INFO_CHAR_LEN   24
#define EMAIL_INFO_CHAR_LEN 42   // UID INFO, PLUS 2 FOR 'SEEN' STATUS, PLUS 16 FOR RECT INFO
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
#pragma pack(push, 1)
///////////////////////////////////////////////////////////////////////////////////////////////////
typedef struct {

BYTE     Command;
BYTE     Len;

BYTE     Action; // 'U' - UPDATE OR 'R' - RESET
union {
   WORD  CacheSize;
   struct {
   BYTE  CacheSizeLSB;
   BYTE  CacheSizeMSB;
   };
};
union {
   WORD  MaxPageSize;
   struct {
   BYTE  MaxPageSizeLSB;
   BYTE  MaxPageSizeMSB;
   };
};


BYTE     ChunkSize;
FILETIME CacheID;
BYTE     Terminator;

} CACHEINFO, * PCACHEINFO;
///////////////////////////////////////////////////////////////////////////////////////////////////
typedef struct {

union {
   LONG Dest;

   struct{
   WORD  DestLSW;
   WORD  DestMSW;
   };

   struct{
   BYTE  DestLSB0;
   BYTE  DestMSB0;
   BYTE  DestLSB1;
   BYTE  DestMSB1;
   };
};

union {
   LONG Source;

   struct{
   WORD  SourceLSW;
   WORD  SourceMSW;
   };

   struct{
   BYTE  SourceLSB0;
   BYTE  SourceMSB0;
   BYTE  SourceLSB1;
   BYTE  SourceMSB1;
   };
};
union {
   WORD  SrcSize;
   struct {
   BYTE  SrcSizeLSB;
   BYTE  SrcSizeMSB;
   };
};

} MEMBLOCKINFO, * PMEMBLOCKINFO;
///////////////////////////////////////////////////////////////////////////////////////////////////
typedef struct {

BYTE     Command;
union {
   WORD  Len;
   struct {
   BYTE  LenLSB;
   BYTE  LenMSB;
   };
};
BYTE     Reserved1;
BYTE     Reserved2;
BYTE     Reserved3;
BYTE     Reserved4;
union {
   WORD  MemBlockCount;
   struct {
   BYTE  MemBlockCountLSB;
   BYTE  MemBlockCountMSB;
   };
};
BYTE     Terminator;

} UPDATECACHEINFO, * PUPDATECACHEINFO;
/////////////////////////////////////////////////////////////////////////////////////////
typedef struct {

BYTE     Command;
BYTE     Len;

BYTE     PageToDelete;
BYTE     PageIndex;
BYTE     MemIndex;
BYTE     FirstLink;
BYTE     LastLink;
BYTE     MemBlockCount;
BYTE     Reserved;

BYTE     Terminator;

} UPDATECACHEINFOLEGACY, * PUPDATECACHEINFOLEGACY;
///////////////////////////////////////////////////////////////////////////////////////////////////
typedef struct {

BYTE  Command;
BYTE  SubCommand;
BYTE  SequenceID;
BYTE  FrameID;
BYTE  Action;
union {
   WORD ExtraLen;
   struct {
      BYTE  LenLSB;
      BYTE  LenMSB;
   };
};
BYTE  Terminator;

} CACHEFRAMEINFO, * PCACHEFRAMEINFO;
///////////////////////////////////////////////////////////////////////////////////////////////////
typedef struct {
     BYTE        First;
     BYTE        Last;
     BYTE        LinkTbl  [256];
     BYTE        MemIndex [256]; //  NEW FIXED
     WORD        PagesPerCache;
     WORD        MaxPageSize;
     FILETIME    CacheID;

} PDALINKSINFO, * PPDALINKSINFO;
/////////////////////////////////////////////////////////////////////////////////////////
typedef struct {

    BYTE    Command[8];

    BYTE    Reserved[8];

    BYTE    Reserved2;
    BYTE    Features;

    union {
       WORD ByteCount;
       struct {
       BYTE  ByteCountLSB;
       BYTE  ByteCountMSB;
       };
    };

    BYTE    CacheAction;
    BYTE    XorCheck;

    union {
       long MemAddress;

       struct{
       short  MemAddressLSW;
       short  MemAddressMSW;
       };

       struct{
       BYTE  MemAddressLSB0;
       BYTE  MemAddressMSB0;
       BYTE  MemAddressLSB1;
       BYTE  MemAddressMSB1;
       };
    };

} TASKLISTINFO, * PTASKLISTINFO;
///////////////////////////////////////////////////////////////////////////////////////////////////
typedef struct {

    BYTE BlockID;

    union {
       WORD BlockLen;
       struct {
          BYTE  BlockLenLSB;
          BYTE  BlockLenMSB;
       };
    };

    DWORD Action;
    union {
       WORD RectLeft;
       struct {
          BYTE  RectLeftLSB;
          BYTE  RectLeftMSB;
       };
    };
    union {
       WORD RectTop;
       struct {
          BYTE  RectTopLSB;
          BYTE  RectTopMSB;
       };
    };
    union {
       WORD RectRight;
       struct {
          BYTE  RectRightLSB;
          BYTE  RectRightMSB;
       };
    };
    union {
       WORD RectBottom;
       struct {
          BYTE  RectBottomLSB;
          BYTE  RectBottomMSB;
       };
    };

    BYTE  UID [UID_INFO_CHAR_LEN];

    BYTE  Terminator;

} LINKINFO, * PLINKINFO;
///////////////////////////////////////////////////////////////////////////////////////////////////
typedef struct {

    BYTE BlockID;

    BYTE BlockLen;

    BYTE  UID [UID_INFO_CHAR_LEN + 1];

    BYTE  Terminator;

} PAGEIDINFO, * PPAGEIDINFO;

///////////////////////////////////////////////////////////////////////////////////////////////////
#pragma pack(pop)
///////////////////////////////////////////////////////////////////////////////////////////////////
extern BOOL  CacheReady;

///////////////////////////////////////////////////////////////////////////////////////////////////
#if USE_CACHEMNGR
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  GetPdaCacheMemory            ();
BOOL  SavePdaCacheMemory           ();

BOOL  HandleCacheMemoryCommand     (BYTE  CommandBuffer[8]);
BOOL  HandleOrderedTaskListCommand (BYTE  CommandBuffer[8]);

BOOL  GetEmailPageIndexByUid       (LPCTSTR ThisUid);
BOOL  ReadThisPageUid              (PTASKLISTINFO TaskInfo, CString *PageUid);

BOOL  DisplayEmailPageByUid        (LPCTSTR ThisUid);

BOOL  UpdateCacheData              (PBYTE Buf);

void  BrowseOffLine                (BYTE  FunctionKey);
BOOL  DisplayCachedPage            (int   MemIndex);
BOOL  ClearCachedPage              (int   MemIndex);

BOOL  IsValidPageIndex             (int   IndexToVerify);
BOOL  IsValidMemIndex              (int   IndexToVerify);
BOOL  ProcessCacheEmailClick       (long  X, long Y);
BOOL  ProcessEmailLinkClick        (PLINKINFO  LinkInfo);
///////////////////////////////////////////////////////////////////////////////////////////////////
#else
///////////////////////////////////////////////////////////////////////////////////////////////////
#define  GetPdaCacheMemory() TRUE
#define  SavePdaCacheMemory() TRUE

#define  HandleCacheMemoryCommand(CommandBuffer) TRUE
#define  HandleOrderedTaskListCommand(CommandBuffer) TRUE

#define  GetEmailPageIndexByUid(ThisUid) TRUE
#define  ReadThisPageUid(TaskInfo, PageUid) TRUE

#define  DisplayEmailPageByUid(ThisUid) TRUE

#define  UpdateCacheData(Buf) TRUE

#define  BrowseOffLine(FunctionKey)
#define  DisplayCachedPage(MemIndex) TRUE
#define  ClearCachedPage(MemIndex) TRUE

#define  IsValidPageIndex(IndexToVerify) TRUE
#define  IsValidMemIndex(IndexToVerify) TRUE
#define  ProcessCacheEmailClick(X,Y) TRUE
#define  ProcessEmailLinkClick(LinkInfo) TRUE

///////////////////////////////////////////////////////////////////////////////////////////////////
#endif //USE_CACHEMNGR
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
extern LONG           RcvError;
extern BYTE           PDACache     [];  //CacheMemorySize * 512 KB
extern WORD           CacheMemorySize;      // * 512 KB
extern WORD           MaxPageSize;          // *   1 KB
extern WORD           MaxNumOfPages;
extern CString        PDASerialNo;
extern BOOL           UseCacheMemory, CacheReady, SupportShowPage, SupportFlexiblePageSize;
extern BYTE           MemChunkSize;
extern PDALINKSINFO   LinksInfo;
extern BYTE           CurrentPdaMode;
extern BYTE           TaskListBuffer   [];
extern CString        DirectAccessUID;
///////////////////////////////////////////////////////////////////////////////////////////////////
#endif
