// PadCore.h : main header file for the PADCORE DLL
///////////////////////////////////////////////////////////////////////////////////////////////////
#if !defined(AFX_PADCORE_H__C0511461_3D0E_4F4E_A8D3_2B91E28702F3__INCLUDED_)
#define AFX_PADCORE_H__C0511461_3D0E_4F4E_A8D3_2B91E28702F3__INCLUDED_
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
// QH THIS IS FOR THE STATISTIC EXPERIMENT
// QH THIS IS VARIABLE FOR BUFFERED SENDING MEASUREMENT FROM EMULATOR
static const  DWORD     InternalBufferSize           =  (4 * KB);
extern int              SavedPackets;
extern int              TotalPackets;
extern BOOL             AccumulatePacket; // ENABLE BUFFERED SENT
extern BOOL             EnableAckPacket;

extern BYTE             AccumulatePacketBuffer[InternalBufferSize];
extern unsigned int     AccumulatePacketBufferLength;
extern DCTimeout        AccumulatePacketSendingTimer;
extern unsigned int     AccumulatePacketSendingDelay; // 2000

///////////////////////////////////////////////////////////////////////////////////////////////////
extern DOUBLE           ProfileDataIn,    ProfileDataOut;
extern DOUBLE           ProfileDataInHi,  ProfileDataOutHi;
extern DOUBLE           ProfileDataInAvg, ProfileDataOutAvg;
///////////////////////////////////////////////////////////////////////////////////////////////////
 
extern HANDLE           ShutDownEvent;
extern CString          m_PortName;
extern CString          m_PortSettings;
extern BOOL             ScheduledInit;

extern BOOL             DeviceOnHold;

extern BYTE             CommandCode;
extern BOOL             UseParity;
extern BOOL             EnableUnpackAndDraw;
extern BOOL             EnableStatusBar;

extern DWORD            TempBufferSize;
extern BYTE             TempBuffer            [IMAGETEMP_BUFFERSIZE + 4];
extern BYTE             UncompressTempBuffer  [IMAGETEMP_BUFFERSIZE + 4];
extern BYTE             TempImageBuffer       [IMAGETEMP_BUFFERSIZE + 4];
extern BYTE             TempPaletteBuffer     [2 * KB];

extern CRect            CurFocusRect;
extern ULONG            CurFocusWindId;
extern ULONG            CurFocusObjectId;
extern ULONG            CurFocusChildId;
extern ULONG            CurFocusLimit;
extern CString          CurFocusText;

///////////////////////////////////////////////////////////////////////////////////////////////////

extern volatile BOOL     WaitForConnect;
extern BOOL              AutoTestMode;
extern BOOL              UnicodeSupport;
extern CString           ToggleString;
extern CString           FirstAdressString;
extern CString           AltAdressString;

extern CString           PDAUserID     ; // ("DenisCo");     // THE SPACE IS THERE INTENTIONNALLY FOR THE LEN
extern CString           PDAUserPsw    ; // ("Terminator");  // THE SPACE IS THERE INTENTIONNALLY FOR THE LEN

extern CString           PDASerialNo   ; // ("PD12345678");  // THE SPACE IS THERE INTENTIONNALLY FOR THE LEN
extern CString           PDABrandName  ; // ("INetPad");     // THE SPACE IS THERE INTENTIONNALLY FOR THE LEN
extern CString           PDAModelName  ; // ("Emulator");    // THE SPACE IS THERE INTENTIONNALLY FOR THE LEN
extern CString           PDAEncryptKey ; // ("");            // THE SPACE IS THERE INTENTIONNALLY FOR THE LEN

extern CString           PDAIMEIKey    ; // ("");            // THE SPACE IS THERE INTENTIONNALLY FOR THE LEN
extern CString           PDAIMSIKey    ; // ("");            // THE SPACE IS THERE INTENTIONNALLY FOR THE LEN
extern CString           PDACCIDKey    ; // ("");            // THE SPACE IS THERE INTENTIONNALLY FOR THE LEN
extern CString           PDASimTelKey  ; // ("");            // THE SPACE IS THERE INTENTIONNALLY FOR THE LEN

extern WORD              FirmwareVersion;

extern DWORD             SpeedControl;
extern DWORD             LineSpeed;
extern BYTE              PDAIntegrationLevel;

extern BOOL              UseGpsBeacon;

extern DWORD             RequireCompressMethod;
extern DWORD             RequireColorMode;
extern BOOL              EnabledRequireCompressMethod;
extern BOOL              EnabledRequireColorMode;
extern DWORD             TestModeInterval;



extern DWORD             PlayTable           [256];
extern BOOL              InPlayBackMode;
extern BOOL              PlayNextStep;
extern BOOL              PlayTillNextPage;

extern BOOL              ShowGrid;
extern BOOL              UseSimul;
extern DWORD             TilesHorz;
extern DWORD             TilesVert;
extern DWORD             TilesWidth;
extern DWORD             TilesHeight;

extern CString           PDAGpsPosition;

///////////////////////////////////////////////////////////////////////////////////////////////////
extern CString ModemInitString; // AT&F1E0L1Q0S0=1S7=20&K0&U6V1&W0\r
extern CString ModemDialString;

///////////////////////////////////////////////////////////////////////////////////////////////////
extern "C" { // EXPORTABLE
///////////////////////////////////////////////////////////////////////////////////////////////////
extern BOOL              KeyboardShiftStatus;
extern BOOL              KeyboardCapStatus;
extern BOOL              KeyboardCtrlStatus;
extern BOOL              KeyboardIntlStatus;

extern BOOL              KeyboardBackStatus;
extern BOOL              EnableDirectKey;
///////////////////////////////////////////////////////////////////////////////////////////////////
void EmptyAckQueue         (); // IN SEND THREAD ONLY NOT MADE FOR READ THREAD
BOOL PushAckQueue          (BYTE AckType,  BYTE SeqID,  BYTE FrameID,  BYTE CurrentPhase);  // IN READ THREAD
BOOL PushNackQueue         (BYTE AckType,  BYTE SeqID,  BYTE FrameID,  BYTE CurrentPhase,  BYTE Reason);  // IN READ THREAD
BOOL PopAckQueue           (BYTE &AckType, BYTE &SeqID, BYTE &FrameID, BYTE &CurrentPhase, BYTE &CurrentState); // IN SEND THREAD
///////////////////////////////////////////////////////////////////////////////////////////////////

BOOL PushFrameAckQueue     (BYTE SeqID,    BYTE FrameID,  BYTE CurrentPhase);  // IN READ THREAD
BOOL PushFrameNackQueue    (BYTE SeqID,    BYTE FrameID,  BYTE CurrentPhase,  BYTE Reason);  // IN READ THREAD
///////////////////////////////////////////////////////////////////////////////////////////////////
void EmptyScrollAckQueue   (); // IN SEND THREAD ONLY NOT MADE FOR READ THREAD
BOOL PushScrollAckQueue    (BYTE ScrollID);  // IN READ THREAD
BOOL PopScrollAckQueue     (BYTE &ScrollID); // IN SEND THREAD


///////////////////////////////////////////////////////////////////////////////////////////////////
// PRIVATE ACCESS
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL           IsLocalPortOpen         ();
BOOL __stdcall SendABeacon             ();
BOOL __stdcall SendAGpsBeacon          ();

#if USE_MODEM
BOOL     ProcessDeviceDataForModem     ();
BOOL     ProcessOutgoingDataForStdModem();
#else
#define  ProcessDeviceDataForModem()
#define  ProcessOutgoingDataForStdModem()
#endif

BOOL     ProcessDeviceDataForStdPort   ();
BOOL     ProcessOutgoingDataForStdPort ();

BOOL     LeaveStatus                   ();
DWORD    ConvertFontImageToColor       (PBYTE DestBuffer, PBYTE SourceBuffer, DWORD PacketSize);
DWORD    ConvertMonoImageToColor       (PBYTE DestBuffer, PBYTE SourceBuffer, DWORD PacketSize);
DWORD    ConvertImageTo3BitColor       (PBYTE DestBuffer, PBYTE SourceBuffer, DWORD PacketSize);
DWORD    ConvertImageTo4BitColor       (PBYTE DestBuffer, PBYTE SourceBuffer, DWORD PacketSize);

BOOL     UpdateRGBQuad                 (PBYTE RGBInfoBuffer, WORD NumOfColors);
///////////////////////////////////////////////////////////////////////////////////////////////////
} // extern "C"
///////////////////////////////////////////////////////////////////////////////////////////////////






///////////////////////////////////////////////////////////////////////////////////////////////////
extern "C" { // EXPORTABLE
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  ProcessMultiPackImage    (PCOLORFRAMEINFO ColorFrameInfo, BYTE SeqID, BOOL NeedAck);
///////////////////////////////////////////////////////////////////////////////////////////////////
} // extern "C"
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.




#endif // !defined(AFX_PADCORE_H__C0511461_3D0E_4F4E_A8D3_2B91E28702F3__INCLUDED_)
