// PaintDraw.cpp: implementation of the PaintDraw class.
///////////////////////////////////////////////////////////////////////////////////////////////////
#include "StdAfx.h"
///////////////////////////////////////////////////////////////////////////////////////////////////

#if USE_PAINTDRAW
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////
PaintDraw::PaintDraw()
{
}
PaintDraw::~PaintDraw()
{
}
///////////////////////////////////////////////////////////////////////////////////////////////////
// DRAWFUNCTIONS SUPPORT...
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static int DecideQuadrant (PPdaRect TheRect)
{
int Quadrant = 0;

    if((TheRect->left  < TheRect->right) && (TheRect->top  < TheRect->bottom) ){
       Quadrant = BOTTOM_RIGHT_QUADRANT;
    } else 
    if((TheRect->left >= TheRect->right) && (TheRect->top  < TheRect->bottom) ){
       Quadrant = BOTTOM_LEFT_QUADRANT;
    } else 
    if((TheRect->left  < TheRect->right) && (TheRect->top  >= TheRect->bottom) ){
       Quadrant = TOP_RIGHT_QUADRANT;
    } else 
    if((TheRect->left >= TheRect->right) && (TheRect->top  >= TheRect->bottom) ){
       Quadrant = TOP_LEFT_QUADRANT;
    }
    return Quadrant;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall DrawArc (PPdaRect PreviousRect, PPdaRect NewRect)
{DLL_THREAD_MANAGEMENT();
BOOL           RetStatus = FALSE;
static int     Quadrant  = 0;
PPixColor      OldBrush;

    SaveCurrentPdaContext();
	if(IsEmptyPdaRect(PreviousRect) == FALSE){
       SetPenColor(ThePdaGDI.CurrentPaintBackColor);
       OldBrush = SetBrushColor(WhiteBrushBlck);
       PaintArc(PreviousRect, Quadrant); 
       SetBrushColor(OldBrush);
    }
    Quadrant = DecideQuadrant (NewRect);
    NormalizePdaRect(NewRect);

    SetPenColor(ThePdaGDI.CurrentPaintForeColor);
    PaintArc(NewRect, Quadrant);

    *PreviousRect   = *NewRect;
    RetStatus       = TRUE;
    RestoreCurrentPdaContext();
    return (RetStatus);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall DrawPie (PPdaRect PreviousRect, PPdaRect NewRect)
{DLL_THREAD_MANAGEMENT();
BOOL           RetStatus = FALSE;
static int     Quadrant  = 0;
PPixColor      OldBrush;

    SaveCurrentPdaContext();
	if(IsEmptyPdaRect(PreviousRect) == FALSE){
       SetPenColor(ThePdaGDI.CurrentPaintBackColor);
       OldBrush = SetBrushColor(WhiteBrushBlck);
       PaintPie(PreviousRect, Quadrant); 
       SetBrushColor(OldBrush);
    }
    Quadrant = DecideQuadrant (NewRect);
    NormalizePdaRect(NewRect);

    SetPenColor(ThePdaGDI.CurrentPaintForeColor);
    PaintPie(NewRect, Quadrant);

    *PreviousRect   = *NewRect;
    RetStatus       = TRUE;
    RestoreCurrentPdaContext();
    return (RetStatus);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall DrawEllipse (PPdaRect PreviousRect, PPdaRect NewRect)
{DLL_THREAD_MANAGEMENT();
BOOL           RetStatus = FALSE;
PPixColor      OldBrush;

    SaveCurrentPdaContext();
	if(IsEmptyPdaRect(PreviousRect) == FALSE){
       SetPenColor(ThePdaGDI.CurrentPaintBackColor);
       OldBrush = SetBrushColor(WhiteBrushBlck);
       PaintEllipse(PreviousRect); 
       SetBrushColor(OldBrush);
    }
    NormalizePdaRect(NewRect);

    SetPenColor(ThePdaGDI.CurrentPaintForeColor);
    PaintEllipse(NewRect);

    *PreviousRect   = *NewRect;
    RetStatus       = TRUE;
    RestoreCurrentPdaContext();
    return (RetStatus);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall DrawRect (PPdaRect PreviousRect, PPdaRect NewRect)
{DLL_THREAD_MANAGEMENT();
BOOL           RetStatus = FALSE;
PPixColor      OldBrush;

    SaveCurrentPdaContext();
	if(IsEmptyPdaRect(PreviousRect) == FALSE){
       SetPenColor(ThePdaGDI.CurrentPaintBackColor);
       OldBrush = SetBrushColor(WhiteBrushBlck);
       PaintRectangle(PreviousRect); 
       SetBrushColor(OldBrush);
    }
    NormalizePdaRect(NewRect);

    SetPenColor(ThePdaGDI.CurrentPaintForeColor);
    PaintRectangle(NewRect);

    *PreviousRect   = *NewRect;
    RetStatus       = TRUE;
    RestoreCurrentPdaContext();
    return (RetStatus);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall DrawRoundRect (PPdaRect PreviousRect, PPdaRect NewRect)
{DLL_THREAD_MANAGEMENT();
BOOL           RetStatus = FALSE;
PPixColor      OldBrush;

    SaveCurrentPdaContext();
	if(IsEmptyPdaRect(PreviousRect) == FALSE){
       SetPenColor(ThePdaGDI.CurrentPaintBackColor);
       OldBrush = SetBrushColor(WhiteBrushBlck);
       PaintRoundRectangle(PreviousRect); 
       SetBrushColor(OldBrush);
    }
    NormalizePdaRect(NewRect);

    SetPenColor(ThePdaGDI.CurrentPaintForeColor);
    PaintRoundRectangle(NewRect);

    *PreviousRect   = *NewRect;
    RetStatus       = TRUE;
    RestoreCurrentPdaContext();
    return (RetStatus);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall DrawLine (PPdaRect PreviousRect, PPdaRect NewRect)
{DLL_THREAD_MANAGEMENT();
BOOL           RetStatus = FALSE;

    SaveCurrentPdaContext();
    SetPenColor(ThePdaGDI.CurrentPaintBackColor);
    PaintLine(PreviousRect->left, PreviousRect->top, PreviousRect->right, PreviousRect->bottom); 

    SetPenColor(ThePdaGDI.CurrentPaintForeColor);
    PaintLine(NewRect->left, NewRect->top, NewRect->right, NewRect->bottom);

    *PreviousRect   = *NewRect;
    RetStatus       = TRUE;
    RestoreCurrentPdaContext();
    return (RetStatus);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall DrawFreeHand (PPdaRect PreviousRect, PPdaRect NewRect)
{DLL_THREAD_MANAGEMENT();
BOOL           RetStatus = FALSE;

    SaveCurrentPdaContext();

    if(IsNullPdaRect(PreviousRect) == FALSE){
       SetPenColor(ThePdaGDI.CurrentPaintForeColor);
       PaintLine(PreviousRect->right, PreviousRect->bottom, NewRect->right, NewRect->bottom);
    }
    *PreviousRect   = *NewRect;
    RetStatus       = TRUE;
    RestoreCurrentPdaContext();
    return (RetStatus);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall DemoFont(PPdaRect PreviousRect, PPdaRect NewRect)
{DLL_THREAD_MANAGEMENT();
PdaSize           TheNewFontSize = {32, 32};
BOOL           RetStatus = FALSE;

    SaveCurrentPdaContext();

    //if(IsEmptyRect(PreviousRect) == FALSE){
       //ColorFillRect(&ThePdaGDI.ClipRectangle, ThePdaGDI.CurrentPaintBackColor);
       BrushFillRect(&ThePdaGDI.ClipRectangle);
    //}
    //SetMaskMode(ROP_MASKSRC);
    //SetMaskMode(ROP_MASKDST);

    // NormalizeRect(NewRect);
    *PreviousRect   = *NewRect;
    RetStatus       = TRUE;

    //SetMaskColor(ThePdaGDI.LightYellowPoint);
    SetFontForeColor(DarkRedPoint);
    SetFontBackColor(LightYellowPoint);
    SetFontBackMode(PDAFONT_TRANSPARENT);
    SetFontSize(&TheNewFontSize);
    PaintStringLine(NewRect->right,NewRect->bottom,"The Quick Brown ", 15 );

    //SetMaskColor(DarkBluePoint);
    SetFontForeColor(LightYellowPoint);
    SetFontBackColor(DarkBluePoint);
    SetFontBackMode(PDAFONT_OPAQUE);
    TheNewFontSize.cx = 32;    TheNewFontSize.cy = 64;
    SetFontSize(&TheNewFontSize);

    PaintStringLine(NewRect->right+7,NewRect->bottom+33,"Fox Jumps Overefpokpfo", 14);

    //SetMaskColor(TheOldBackColor);
    SetFontForeColor(DarkGreenPoint);
    //SetFontBackColor(LightYellowPoint);
    SetFontBackMode(PDAFONT_TRANSPARENT);
    TheNewFontSize.cx = 88;    TheNewFontSize.cy = 30;
    SetFontSize(&TheNewFontSize);
    PaintStringLine(NewRect->right+7,NewRect->bottom+117,"A Lazy", 6);

    SetFontForeColor(DarkPurplePoint);
    TheNewFontSize.cx = 6;    TheNewFontSize.cy = 8;
    SetFontSize(&TheNewFontSize);
    PaintStringLine(NewRect->right+13,NewRect->bottom+159,"Dog!", 4);

    TheNewFontSize.cx = 8;    TheNewFontSize.cy = 16;
    SetFontSize(&TheNewFontSize);
    PaintStringLine(NewRect->right,NewRect->bottom+167,"abcdefghijklmnopqrstuvwxyz{}~<>@=ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890*1234567890", 80);

    RestoreCurrentPdaContext();
    return (RetStatus);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall DrawItalicText (PPdaRect PreviousRect, PPdaRect NewRect)
{DLL_THREAD_MANAGEMENT();
BOOL           RetStatus = FALSE;
int            DemoSlant;     

    SaveCurrentPdaContext();
    DemoSlant = ((NewRect->right) - (NewRect->left)) / 4;    
    SetItalicSlant(DemoSlant);

    PaintStringLine(NewRect->left, NewRect->top, "We are the World!because we are alone", 17); 

    *PreviousRect   = *NewRect;
    RetStatus       = TRUE;
    RestoreCurrentPdaContext();
    return (RetStatus);

}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall DrawTextFuncEx (PPdaRect PreviousRect, PPdaRect NewRect)
{DLL_THREAD_MANAGEMENT();
BOOL           RetStatus = FALSE;
int            TheOldForeColor;
    
    SaveCurrentPdaContext();
    if(IsNullPdaRect(PreviousRect) == FALSE){

       TheOldForeColor = GetFontForeColor();
       SetFontForeColor(GetFontBackColor());

       PdaDrawText("We are testing!so and so it begin to get on my nerve and so on, bla bla bla bla bla bla bla", 
                    80, PreviousRect, 
                    ThePdaGDI.CurrentStyleOption);

       SetFontForeColor(TheOldForeColor);

       PdaDrawText("We are testing!so and so it begin to get on my nerve and so on, bla bla bla bla bla bla bla", 
                    80, NewRect, 
                    ThePdaGDI.CurrentStyleOption);
    }
    *PreviousRect   = *NewRect;
    RetStatus       = TRUE;
    RestoreCurrentPdaContext();
    return (RetStatus);
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// PEN TOOL SUPPORT...
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall PenDraw ()
{DLL_THREAD_MANAGEMENT();
MSG         Msg;
PdaRect     WindowRect,  ClientRect;
POINT       StartPoint,  CurrentPoint, NewPoint;
PdaRect     NormalRect,  PreviousRect = {0,0,0,0};

    if( ::IsWindow(PadWndHandle) == FALSE) {
       return ;
    } 
    if(IsBadWritePtr(ThePdaGDI.SurfacePtr, ThePdaGDI.SurfaceMemLen)){
       return ;
    }
    if(IsBadCodePtr((FARPROC)ThePdaGDI.DrawFunction)){
       return ;
    }
    GetCursorPos(&StartPoint); ScreenToClient(PadWndHandle, (LPPOINT)&StartPoint);
    NewPoint           = StartPoint;
    
    GetClientRect(PadWndHandle, (LPRECT)&ClientRect);
    WindowRect         = ClientRect;

    ClientToScreen(PadWndHandle, (LPPOINT)&WindowRect.left);
    ClientToScreen(PadWndHandle, (LPPOINT)&WindowRect.right);

    InitStillDown( PadWndHandle ); 
    while(StillDown(&Msg, PadWndHandle)){

       switch( Msg.message ){
       case WM_MOUSEMOVE:

            GetCursorPos(&CurrentPoint);  ScreenToClient(PadWndHandle, (LPPOINT)&CurrentPoint);

            if((CurrentPoint.x != NewPoint.x) || (CurrentPoint.y != NewPoint.y))
            { 
               NormalRect.left   = StartPoint.x;
               NormalRect.top    = StartPoint.y;
               NormalRect.right  = CurrentPoint.x;
               NormalRect.bottom = CurrentPoint.y;

               TranslateMousePoint(((LPPOINT)&NormalRect.left));
               TranslateMousePoint(((LPPOINT)&NormalRect.right));

               if((IsPointInsideVirtualScreen(((LPPOINT)&NormalRect.left)) ) 
               && (IsPointInsideVirtualScreen(((LPPOINT)&NormalRect.right))) )
               {
                  CSingleLock AccessSingleLock(&CriticalScreenAccess);  AccessSingleLock.Lock();
                  if(AccessSingleLock.IsLocked()){

                     if(Not IsBadWritePtr(ThePdaGDI.SurfacePtr, ThePdaGDI.SurfaceMemLen)){

                        ThePdaGDI.DrawFunction(&PreviousRect, &NormalRect);
                        RepaintIPalm();
                     }
                     AccessSingleLock.Unlock();
                  }
               }
               NewPoint          = CurrentPoint;
           }
            break;
       }
    }
    ReleaseStillDown();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall PenDrawPie ()
{DLL_THREAD_MANAGEMENT();

    ThePdaGDI.DrawFunction             = DrawPie;
    PenDraw ();

//PdaRect TestRect (100, 100, 200, 200);
//    PaintPie(TestRect, TOP_RIGHT_QUADRANT); 
//    RepaintIPalm();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall PenDrawArc ()
{DLL_THREAD_MANAGEMENT();

    ThePdaGDI.DrawFunction             = DrawArc; 
    PenDraw ();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall PenDrawEllipse ()
{DLL_THREAD_MANAGEMENT();

    ThePdaGDI.DrawFunction             = DrawEllipse; 
    PenDraw ();

//PdaRect TestRect (100, 60, 200, 140);
//    PaintEllipse(TestRect); 
//    RepaintIPalm();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall PenDrawRect ()
{DLL_THREAD_MANAGEMENT();

    ThePdaGDI.DrawFunction             = DrawRect; 
    PenDraw ();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall PenDrawRoundRect ()
{DLL_THREAD_MANAGEMENT();

    ThePdaGDI.DrawFunction             = DrawRoundRect; 
    PenDraw ();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall PenDrawLine ()
{DLL_THREAD_MANAGEMENT();

    ThePdaGDI.DrawFunction             = DrawLine; 
    PenDraw ();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall PenDrawFreeHand ()
{DLL_THREAD_MANAGEMENT();

    ThePdaGDI.DrawFunction             = DrawFreeHand; 
    PenDraw ();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall PenDrawFont ()
{DLL_THREAD_MANAGEMENT();

    ThePdaGDI.DrawFunction             = DemoFont; 
    PenDraw ();

#if 0
    ResetClipRect();
    PdaLoadMenu (CurrentMenuTemplate, IDR_DESKMENU);
    ShowMenu (0, Palm.MenuTop, CurrentMenuTemplate, NULL);
    PrepareDeskMenu ();
#else
    // RESTORE MENU...
    ResetClipRect();
    PdaLoadBitmap    (0, Palm.ToolTop, (LPBYTE)BITMAP_PAINTMENU);
    PreparePaintMenu ();
#endif
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall PenDrawText ()
{DLL_THREAD_MANAGEMENT();

    ThePdaGDI.DrawFunction             = DrawTextFuncEx; 
    PenDraw ();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall PenDrawItalicText ()
{DLL_THREAD_MANAGEMENT();

    ThePdaGDI.DrawFunction             = DrawItalicText; 
    PenDraw ();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall PreparePaintMenu ()
{
PdaRect   ItemRect     = {0,Palm.MenuTop,0,(Palm.MenuTop + Palm.MenuHeight - 2)};
int       Position     = 0;

    ZeroMemory(&CurrentMenuManger, sizeof(CurrentMenuManger));
    CurrentMenuManger.PdaMenuFunction = PdaPaintMenuMouse;
    CurrentMenuManger.Count = 11;

    CurrentMenuManger.PdaMenuFunction = PdaPaintMenuMouse;
    ItemRect.left    = PDAMENU640_PAINTDESKTOP;
    ItemRect.right   = PDAMENU640_PAINTSAVE;
    CurrentMenuManger.MenuItem[Position].ItemRect = ItemRect;
    CurrentMenuManger.MenuItem[Position].Command  = PDAPAINTMENU_DESKTOP;
    CurrentMenuManger.MenuItem[Position].Position = Position++;

    ItemRect.left    = PDAMENU640_PAINTSAVE;
    ItemRect.right   = PDAMENU640_PAINTARROW;
    CurrentMenuManger.MenuItem[Position].ItemRect = ItemRect;
    CurrentMenuManger.MenuItem[Position].Command  = PDAPAINTMENU_SAVE;
    CurrentMenuManger.MenuItem[Position].Position = Position++;

    ItemRect.left    = PDAMENU640_PAINTARROW;
    ItemRect.right   = PDAMENU640_PAINTPEN;
    CurrentMenuManger.MenuItem[Position].ItemRect = ItemRect;
    CurrentMenuManger.MenuItem[Position].Command  = PDAPAINTMENU_ARROW;
    CurrentMenuManger.MenuItem[Position].Position = Position++;

    ItemRect.left    = PDAMENU640_PAINTPEN;
    ItemRect.right   = PDAMENU640_PAINTERASER;
    CurrentMenuManger.MenuItem[Position].ItemRect = ItemRect;
    CurrentMenuManger.MenuItem[Position].Command  = PDAPAINTMENU_PEN;
    CurrentMenuManger.MenuItem[Position].Position = Position++;

    ItemRect.left    = PDAMENU640_PAINTERASER;
    ItemRect.right   = PDAMENU640_PAINTLINE;
    CurrentMenuManger.MenuItem[Position].ItemRect = ItemRect;
    CurrentMenuManger.MenuItem[Position].Command  = PDAPAINTMENU_ERASER;
    CurrentMenuManger.MenuItem[Position].Position = Position++;

    ItemRect.left    = PDAMENU640_PAINTLINE;
    ItemRect.right   = PDAMENU640_PAINTRECT;
    CurrentMenuManger.MenuItem[Position].ItemRect = ItemRect;
    CurrentMenuManger.MenuItem[Position].Command  = PDAPAINTMENU_LINE;
    CurrentMenuManger.MenuItem[Position].Position = Position++;

    ItemRect.left    = PDAMENU640_PAINTRECT;
    ItemRect.right   = PDAMENU640_PAINTELLIPSE;
    CurrentMenuManger.MenuItem[Position].ItemRect = ItemRect;
    CurrentMenuManger.MenuItem[Position].Command  = PDAPAINTMENU_RECT;
    CurrentMenuManger.MenuItem[Position].Position = Position++;

    ItemRect.left    = PDAMENU640_PAINTELLIPSE;
    ItemRect.right   = PDAMENU640_PAINTTEXT;
    CurrentMenuManger.MenuItem[Position].ItemRect = ItemRect;
    CurrentMenuManger.MenuItem[Position].Command  = PDAPAINTMENU_ELLIPSE;
    CurrentMenuManger.MenuItem[Position].Position = Position++;

    ItemRect.left    = PDAMENU640_PAINTTEXT;
    ItemRect.right   = PDAMENU640_PAINTSETTING;
    CurrentMenuManger.MenuItem[Position].ItemRect = ItemRect;
    CurrentMenuManger.MenuItem[Position].Command  = PDAPAINTMENU_TEXT;
    CurrentMenuManger.MenuItem[Position].Position = Position++;

    ItemRect.left    = PDAMENU640_PAINTSETTING;
    ItemRect.right   = PDAMENU640_SELECT;
    CurrentMenuManger.MenuItem[Position].ItemRect = ItemRect;
    CurrentMenuManger.MenuItem[Position].Command  = PDAPAINTMENU_SETTINGS;
    CurrentMenuManger.MenuItem[Position].Position = Position++;

    ItemRect.left    = PDAMENU640_SELECT;
    ItemRect.right   = PDAMENU640_PAINTLAST;
    CurrentMenuManger.MenuItem[Position].ItemRect = ItemRect;
    CurrentMenuManger.MenuItem[Position].Command  = PDAPAINTMENU_SELECT;
    CurrentMenuManger.MenuItem[Position].Position = Position++;

}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL PdaDeskMenuMouse (UShort ThisPosition, UShort ThisCommand, Byte Button, Byte Shift, UShort X, UShort Y)
{
PdaSize Size0x0     = { 0,  0};
PdaSize Size1x1     = { 1,  1};
PdaSize Size1x4     = { 1,  4};
PdaSize Size4x1     = { 4,  1};
PdaSize Size4x4     = { 4,  4};
PdaSize Size4x8     = { 4,  8};
PdaSize Size7x12    = { 7, 12};
PdaSize Size8x16    = { 8, 16};
PdaSize Size10x20   = {10, 20};
PdaSize Size16x16   = {16, 16};
PdaSize Size64x128  = {64,128};


    switch(ThisCommand){
    case ID_DESK_PAINT:
         Palm.MenuMode   = PDAMENUMODE_PAINT;
         ResetClipRect     ();
         PdaLoadBitmap     (0, Palm.ToolTop, (LPBYTE)BITMAP_PAINTMENU);
         PreparePaintMenu  ();
         break;

    case ID_TEXT_FORMAT_UNDERLINE        :
         ThePdaGDI.CurrentUnderLineMode = Not ThePdaGDI.CurrentUnderLineMode;
         break;
    case ID_TEXT_FORMAT_STRIKETHROUGH    :
         ThePdaGDI.CurrentStrikeThroughMode = Not ThePdaGDI.CurrentStrikeThroughMode;
         break;
    case ID_TEXT_FORMAT_ITALIC           :
         ThePdaGDI.ItalicSlant = (ThePdaGDI.ItalicSlant ? 0 : 16);
         break;
    case ID_TEXT_FORMAT_REVERSEITALIC    :
         ThePdaGDI.ItalicSlant = (ThePdaGDI.ItalicSlant ? 0 : -16);
         break;

    case ID_TEXT_FORMAT_FONT8X16         :
         SetFontSize(&Size8x16);
         goto SetFontMenuCheked;
    case ID_TEXT_FORMAT_FONT4X8          :
         SetFontSize(&Size4x8);
         goto SetFontMenuCheked;
    case ID_TEXT_FORMAT_FONT7X12         :
         SetFontSize(&Size7x12);
         goto SetFontMenuCheked;
    case ID_TEXT_FORMAT_FONT10X20        :
         SetFontSize(&Size10x20);
         goto SetFontMenuCheked;
    case ID_TEXT_FORMAT_FONT16X16        :
         SetFontSize(&Size16x16);
         goto SetFontMenuCheked;
    case ID_TEXT_FORMAT_FONT64X128       :
         SetFontSize(&Size64x128);
    SetFontMenuCheked:
         CheckPdaMenuItem (CurrentMenuTemplate, ID_TEXT_FORMAT_FONT8X16,   MF_UNCHECKED);
         CheckPdaMenuItem (CurrentMenuTemplate, ID_TEXT_FORMAT_FONT4X8,    MF_UNCHECKED);
         CheckPdaMenuItem (CurrentMenuTemplate, ID_TEXT_FORMAT_FONT7X12,   MF_UNCHECKED);
         CheckPdaMenuItem (CurrentMenuTemplate, ID_TEXT_FORMAT_FONT10X20,  MF_UNCHECKED);
         CheckPdaMenuItem (CurrentMenuTemplate, ID_TEXT_FORMAT_FONT16X16,  MF_UNCHECKED);
         CheckPdaMenuItem (CurrentMenuTemplate, ID_TEXT_FORMAT_FONT64X128, MF_UNCHECKED);

         CheckPdaMenuItem (CurrentMenuTemplate, ThisCommand,  MF_CHECKED);
         break;

    case ID_TEXT_FORMAT_TRANSPARENT      :
         ThePdaGDI.CurrentFontBackMode   = PDAFONT_TRANSPARENT;
         break;
    case ID_TEXT_FORMAT_OPAQUE           :
         ThePdaGDI.CurrentFontBackMode   = PDAFONT_OPAQUE;
         break;
    case ID_TEXT_PARAGRAPH_LEFT          :
         UnsetStyleOption((PDA_DT_LEFT | PDA_DT_CENTER | PDA_DT_RIGHT));
         ThePdaGDI.CurrentStyleOption   |= PDA_DT_LEFT; 
         break;
    case ID_TEXT_PARAGRAPH_CENTER        :
         UnsetStyleOption((PDA_DT_LEFT | PDA_DT_CENTER | PDA_DT_RIGHT));
         ThePdaGDI.CurrentStyleOption   |= PDA_DT_CENTER; 
         break;
    case ID_TEXT_PARAGRAPH_RIGHT         :
         UnsetStyleOption((PDA_DT_LEFT | PDA_DT_CENTER | PDA_DT_RIGHT));
         ThePdaGDI.CurrentStyleOption   |= PDA_DT_RIGHT; 
         break;

    case ID_TEXT_PARAGRAPH_TOP           :
         UnsetStyleOption((PDA_DT_TOP | PDA_DT_VCENTER | PDA_DT_BOTTOM));
         ThePdaGDI.CurrentStyleOption   |= PDA_DT_TOP; 
         break;
    case ID_TEXT_PARAGRAPH_MIDDLE        :
         UnsetStyleOption((PDA_DT_TOP | PDA_DT_VCENTER | PDA_DT_BOTTOM));
         ThePdaGDI.CurrentStyleOption   |= PDA_DT_VCENTER; 
         break;
    case ID_TEXT_PARAGRAPH_BOTTOM        :
         UnsetStyleOption((PDA_DT_TOP | PDA_DT_VCENTER | PDA_DT_BOTTOM));
         ThePdaGDI.CurrentStyleOption   |= PDA_DT_BOTTOM; 
         break;

    case ID_TEXT_PARAGRAPH_WORDBREAK     :
         SetStyleOption((DT_WORDBREAK));
         break;
    case ID_TEXT_PARAGRAPH_NOWORDBREAK   :
         UnsetStyleOption((DT_WORDBREAK));
         break;

    case ID_TEXT_COLORFOREGROUND_WHITE   :
         ThePdaGDI.CurrentFontForeColor  = WhitePoint;
         break;
    case ID_TEXT_COLORFOREGROUND_BLACK   :
         ThePdaGDI.CurrentFontForeColor  = BlackPoint;
         break;
    case ID_TEXT_COLORFOREGROUND_DARKBLUE :
         ThePdaGDI.CurrentFontForeColor  = DarkBluePoint;
         break;
    case ID_TEXT_COLORFOREGROUND_LIGHTBLUE :
         ThePdaGDI.CurrentFontForeColor  = LightBluePoint;
         break;
    case ID_TEXT_COLORFOREGROUND_DARKGREEN :
         ThePdaGDI.CurrentFontForeColor  = DarkGreenPoint;
         break;
    case ID_TEXT_COLORFOREGROUND_LIGHTGREEN :
         ThePdaGDI.CurrentFontForeColor  = LightGreenPoint;
         break;
    case ID_TEXT_COLORFOREGROUND_DARKRED :
         ThePdaGDI.CurrentFontForeColor  = DarkRedPoint;
         break;
    case ID_TEXT_COLORFOREGROUND_LIGHTRED :
         ThePdaGDI.CurrentFontForeColor  = LightRedPoint;
         break;
    case ID_TEXT_COLORFOREGROUND_DARKYELLOW :
         ThePdaGDI.CurrentFontForeColor  = DarkYellowPoint;
         break;
    case ID_TEXT_COLORFOREGROUND_LIGHTYELLOW :
         ThePdaGDI.CurrentFontForeColor  = LightYellowPoint;
         break;
    case ID_TEXT_COLORFOREGROUND_DARKGRAY :
         ThePdaGDI.CurrentFontForeColor  = DarkGreyPoint;
         break;
    case ID_TEXT_COLORFOREGROUND_LIGHTGRAY :
         ThePdaGDI.CurrentFontForeColor  = LightGreyPoint;
         break;
    case ID_TEXT_COLORFOREGROUND_DARKCYAN :
         ThePdaGDI.CurrentFontForeColor  = DarkCyanPoint;
         break;
    case ID_TEXT_COLORFOREGROUND_LIGHTCYAN :
         ThePdaGDI.CurrentFontForeColor  = LightCyanPoint;
         break;
    case ID_TEXT_COLORFOREGROUND_DARKPURPLE :
         ThePdaGDI.CurrentFontForeColor  = DarkPurplePoint;
         break;
    case ID_TEXT_COLORFOREGROUND_LIGHTPURPLE :
         ThePdaGDI.CurrentFontForeColor  = LightPurplePoint;
         break;

    case ID_TEXT_COLORBACKGROUND_WHITE   :
         ThePdaGDI.CurrentFontBackColor  = WhitePoint;
         break;
    case ID_TEXT_COLORBACKGROUND_BLACK   :
         ThePdaGDI.CurrentFontBackColor  = BlackPoint;
         break;
    case ID_TEXT_COLORBACKGROUND_DARKBLUE :
         ThePdaGDI.CurrentFontBackColor  = DarkBluePoint;
         break;
    case ID_TEXT_COLORBACKGROUND_LIGHTBLUE :
         ThePdaGDI.CurrentFontBackColor  = LightBluePoint;
         break;
    case ID_TEXT_COLORBACKGROUND_DARKGREEN :
         ThePdaGDI.CurrentFontBackColor  = DarkGreenPoint;
         break;
    case ID_TEXT_COLORBACKGROUND_LIGHTGREEN :
         ThePdaGDI.CurrentFontBackColor  = LightGreenPoint;
         break;
    case ID_TEXT_COLORBACKGROUND_DARKRED :
         ThePdaGDI.CurrentFontBackColor  = DarkRedPoint;
         break;
    case ID_TEXT_COLORBACKGROUND_LIGHTRED :
         ThePdaGDI.CurrentFontBackColor  = LightRedPoint;
         break;
    case ID_TEXT_COLORBACKGROUND_DARKGRAY :
         ThePdaGDI.CurrentFontBackColor  = DarkGreyPoint;
         break;
    case ID_TEXT_COLORBACKGROUND_LIGHTGRAY :
         ThePdaGDI.CurrentFontBackColor  = LightGreyPoint;
         break;

    case ID_TEXT_COLORBACKGROUND_DARKYELLOW :
         ThePdaGDI.CurrentFontBackColor  = DarkYellowPoint;
         break;
    case ID_TEXT_COLORBACKGROUND_LIGHTYELLOW :
         ThePdaGDI.CurrentFontBackColor  = LightYellowPoint;
         break;
    case ID_TEXT_COLORBACKGROUND_DARKCYAN :
         ThePdaGDI.CurrentFontBackColor  = DarkCyanPoint;
         break;
    case ID_TEXT_COLORBACKGROUND_LIGHTCYAN :
         ThePdaGDI.CurrentFontBackColor  = LightCyanPoint;
         break;
    case ID_TEXT_COLORBACKGROUND_DARKPURPLE :
         ThePdaGDI.CurrentFontBackColor  = DarkPurplePoint;
         break;
    case ID_TEXT_COLORBACKGROUND_LIGHTPURPLE :
         ThePdaGDI.CurrentFontBackColor  = LightPurplePoint;
         break;

    case ID_TEXT_FORMAT_UNDERANDSTRIKECOLOR_WHITE :
         ThePdaGDI.UnderLineColor  = WhitePoint;
         break;
    case ID_TEXT_FORMAT_UNDERANDSTRIKECOLOR_BLACK :
         ThePdaGDI.UnderLineColor  = BlackPoint;
         break;
    case ID_TEXT_FORMAT_UNDERANDSTRIKECOLOR_RED :
         ThePdaGDI.UnderLineColor  = (ThePdaGDI.UnderLineColor == DarkRedPoint ? LightRedPoint : DarkRedPoint);
         break;
    case ID_TEXT_FORMAT_UNDERANDSTRIKECOLOR_GREEN :
         ThePdaGDI.UnderLineColor  = (ThePdaGDI.UnderLineColor == DarkGreenPoint ? LightGreenPoint : DarkGreenPoint);
         break;
    case ID_TEXT_FORMAT_UNDERANDSTRIKECOLOR_BLUE :
         ThePdaGDI.UnderLineColor  = (ThePdaGDI.UnderLineColor == DarkBluePoint ? LightBluePoint : DarkBluePoint);
         break;

    case ID_PEN_SIZE_PEN0X0              :
         SetPenSize(&Size0x0);
         break;
    case ID_PEN_SIZE_PEN1X1              :
         SetPenSize(&Size1x1);
         break;
    case ID_PEN_SIZE_PEN1X4              :
         SetPenSize(&Size1x4);
         break;
    case ID_PEN_SIZE_PEN4X1              :
         SetPenSize(&Size4x1);
         break;
    case ID_PEN_SIZE_PEN4X4              :
         SetPenSize(&Size4x4);
         break;

    case ID_PEN_COLOR_WHITE              :
         ThePdaGDI.CurrentPenColor       = WhitePoint;
         break;
    case ID_PEN_COLOR_BLACK              :
         ThePdaGDI.CurrentPenColor       = BlackPoint;
         break;
    case ID_PEN_COLOR_RED                :
         ThePdaGDI.CurrentPenColor       = (ThePdaGDI.CurrentPenColor == DarkRedPoint ? LightRedPoint : DarkRedPoint);
         break;
    case ID_PEN_COLOR_GREEN              :
         ThePdaGDI.CurrentPenColor       = (ThePdaGDI.CurrentPenColor == DarkGreenPoint ? LightGreenPoint : DarkGreenPoint);
         break;
    case ID_PEN_COLOR_BLUE               :
         ThePdaGDI.CurrentPenColor       = (ThePdaGDI.CurrentPenColor == DarkBluePoint ? LightBluePoint : DarkBluePoint);
         break;

    case ID_FILL_MODE_ON                 : 
         ThePdaGDI.CurrentFillMode       =  TRUE;
         EnablePdaMenuItem (CurrentMenuTemplate, ID_FILL_MODE_OFF,  MF_ENABLED);
         EnablePdaMenuItem (CurrentMenuTemplate, ThisCommand,  MF_GRAYED);
         break;
    case ID_FILL_MODE_OFF                :
         ThePdaGDI.CurrentFillMode       =  FALSE;
         EnablePdaMenuItem (CurrentMenuTemplate, ID_FILL_MODE_ON,  MF_ENABLED);
         EnablePdaMenuItem (CurrentMenuTemplate, ThisCommand,  MF_GRAYED);
         break;
    case ID_FILL_SIZE_FILL0X0            :
         break;
    case ID_FILL_SIZE_FILL4X4            :
         break;
    case ID_FILL_SIZE_FILL2X2            :
         break;
    case ID_FILL_SIZE_FILL2X8            :
         break;

    case ID_FILL_COLOR_WHITE             :
         break;
    case ID_FILL_COLOR_BLACK             :
         break;
    case ID_FILL_COLOR_LIGHTGRAY         :
         break;
    case ID_MENU5_DEMO:
/*       CHANGED BY VZ IN PDA OS
          if(CurrentDlgTemplate = (TOBJECT)PdaLoadDlg(IDD_DIALOG)){
             ShowDlg       (CurrentDlgTemplate, TRUE);
          }
*/
         break;
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _PdaOS_H
void __stdcall PrepareDeskMenu ()
{
    // THE MENU IS ALREADY ADDED JUST POINT TO THE RIGHT HANDLER
    CurrentMenuManger.PdaMenuFunction = PdaDeskMenuMouse;
}
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL PdaPaintMenuMouse (UShort ThisPosition, UShort ThisCommand, Byte Button, Byte Shift, UShort X, UShort Y)
// (WORD ThisPosition, WORD ThisCommand, BYTE Button, BYTE Shift, WORD X, WORD Y)
{
    switch(ThisCommand){
    case PDAPAINTMENU_DESKTOP:             
#ifdef _PdaOS_H
         InitPdaDesktop    (IDR_PDAMENU, 0, 0, Palm.MenuTop);
         ResetClipRect     ();
         ClearPadScreen    ();
         Palm.MenuMode   = PDAMENUMODE_DESKTOP;
#else 
         PdaLoadMenu (CurrentMenuTemplate, IDR_DESKMENU);
         ShowMenu (0, Palm.MenuTop, CurrentMenuTemplate, NULL);
         PrepareDeskMenu ();
#endif
         break;
    case PDAPAINTMENU_ARROW:               ThePdaGDI.PenMode = PDAPENMODE_ARROW;    break;
    case PDAPAINTMENU_PEN:                 ThePdaGDI.PenMode = PDAPENMODE_PEN;      break;
    case PDAPAINTMENU_ERASER:              ThePdaGDI.PenMode = PDAPENMODE_ERASER;   break;
    case PDAPAINTMENU_LINE:                ThePdaGDI.PenMode = PDAPENMODE_LINE;     break;
    case PDAPAINTMENU_RECT:                ThePdaGDI.PenMode = PDAPENMODE_RECT;     break;
    case PDAPAINTMENU_ELLIPSE:             ThePdaGDI.PenMode = PDAPENMODE_ELLIPSE;  break;
    case PDAPAINTMENU_TEXT:                ThePdaGDI.PenMode = PDAPENMODE_TEXT;     break;
    case PDAPAINTMENU_PIE:                 break;
    case PDAPAINTMENU_ARC:                 break;
    case PDAPAINTMENU_ZOOM:                break;
    case PDAPAINTMENU_COLORPICKER:         break;
    case PDAPAINTMENU_HAND:                break;
    case PDAPAINTMENU_FILL:                break;
    case PDAPAINTMENU_SAVE:                break;
    case PDAPAINTMENU_SETTINGS:            ThePdaGDI.PenMode = PDAPENMODE_FILL;     break;
    case PDAPAINTMENU_SELECT:              ThePdaGDI.PenMode = PDAPENMODE_SELECT;
         break;

    }
    return TRUE;
}  
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall PdaPaintMouseDown (long Button, long Shift, long X, long Y)
{
long        VirtualX = X, VirtualY = Y;

/* TEST
    PdaRect TempClipRect = {7,5,633,201};
    SetClipRect(&TempClipRect);

    //ColorFillRect(&TempClipRect, ThePdaGDI.CurrentMaskColor);
    //SetMaskMode(ROP_ANDSRC);
*/
    TranslateMousePos (&VirtualX, &VirtualY);
    if(Y <= Palm.MenuHeight) { //  + Palm.KeybdOnScreen 
       PdaProcessMenuMouse (Button, Shift, X, Y);
    } else {
       if(PdaProcessPopMenuMouse (Button, Shift, VirtualX, VirtualY)){
          return TRUE;
       }
       switch(ThePdaGDI.PenMode){
       case PDAPENMODE_ARROW:       ;   break;
       case PDAPENMODE_PEN:         PenDrawFreeHand();    break;
       case PDAPENMODE_ERASER:      ;   break;
       case PDAPENMODE_LINE:        PenDrawLine();        break;
       case PDAPENMODE_RECT:        PenDrawRoundRect();   break;
       case PDAPENMODE_ELLIPSE:     PenDrawEllipse();     break;
       case PDAPENMODE_TEXT:        PenDrawFont();        break;
       case PDAPENMODE_PIE:         PenDrawPie();         break;
       case PDAPENMODE_ARC:         PenDrawArc();         break;
       case PDAPENMODE_ZOOM:        ;   break;
       case PDAPENMODE_COLORPICKER: ;   break;
       case PDAPENMODE_HAND:        ;   break;
       case PDAPENMODE_FILL:        PenDrawItalicText();   break;
       case PDAPENMODE_SELECT:      PenDrawText();         break;
       }
       //PenDrawRect();
    }
    return TRUE;
}  
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
// BITMAP
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static void PaintOneMonoPoint  (int X, int Y)
{
/*  TO BE IMPLEMENTED...
	PBYTE ScreenPtr  = &ThePdaGDI.SurfacePtr[((Y * ThePdaGDI.SurfaceWidthInByte) + X)];
	*ScreenPtr       = ThePdaGDI.CurrentPenColor;
*/
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static void PaintOneColorPoint(int X, int Y)
{
long AddrX, AddrY;
	
    AddrX            = X; 
    AddrY            = (Y * ThePdaGDI.SurfaceWidthInByte);
    SetPenPixel        (AddrX, AddrY);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static void PaintOnePoint      (int X, int Y)
{
    PaintOneColorPoint(X, Y);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static PixColor GetPointColor      (int X, int Y)
{
	PBYTE ScreenPtr  = &ThePdaGDI.SurfacePtr[((Y * ThePdaGDI.SurfaceWidthInByte) + X)];
	return *ScreenPtr;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static void SetQuadrantPixels(LPPOINT CenterPoint, LPPOINT CurrentPoint)
{
    if(CurrentPoint->x != 0)
    {
       // PAINT BOTTOM-LEFT QUADRANT
       PaintOnePoint(CenterPoint->x - CurrentPoint->x, CenterPoint->y + CurrentPoint->y);
       // PAINT BOTTOM-RIGHT QUADRANT
       PaintOnePoint(CenterPoint->x + CurrentPoint->x, CenterPoint->y + CurrentPoint->y);

       if(CurrentPoint->y != 0)
       {
          // PAINT TOP-RIGHT QUADRANT
          PaintOnePoint(CenterPoint->x + CurrentPoint->x, CenterPoint->y - CurrentPoint->y);
          // PAINT TOP-LEFT QUADRANT
          PaintOnePoint(CenterPoint->x - CurrentPoint->x, CenterPoint->y - CurrentPoint->y);
       }
    } else {
       // PAINT Y BOTTOM AXIS QUADRANT
       PaintOnePoint(CenterPoint->x, CenterPoint->y + CurrentPoint->y);
       if( CurrentPoint->y != 0){
          // PAINT Y TOP AXIS QUADRANT
          PaintOnePoint(CenterPoint->x, CenterPoint->y - CurrentPoint->y);
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static void SetArcPixels(LPPOINT CenterPoint, LPPOINT CurrentPoint, int Quadrant)
{
    if(CurrentPoint->x != 0)
    {
       if(Quadrant     == BOTTOM_LEFT_QUADRANT){
          // PAINT BOTTOM-LEFT QUADRANT
          PaintOnePoint(CenterPoint->x - CurrentPoint->x, CenterPoint->y + CurrentPoint->y);
       } else 
       if(Quadrant     == BOTTOM_RIGHT_QUADRANT){
          // PAINT BOTTOM-RIGHT QUADRANT
          PaintOnePoint(CenterPoint->x + CurrentPoint->x, CenterPoint->y + CurrentPoint->y);
       } else
       if(CurrentPoint->y != 0)
       {
          if(Quadrant     == TOP_RIGHT_QUADRANT){
             // PAINT TOP-RIGHT QUADRANT
             PaintOnePoint(CenterPoint->x + CurrentPoint->x, CenterPoint->y - CurrentPoint->y);
          } else 
          if(Quadrant     == TOP_LEFT_QUADRANT){
             // PAINT TOP-LEFT QUADRANT
             PaintOnePoint(CenterPoint->x - CurrentPoint->x, CenterPoint->y - CurrentPoint->y);
          }
       }
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static void FillArcPixels (LPPOINT CenterPoint, LPPOINT CurrentPoint, int Quadrant)
{

    if(CurrentPoint->x != 0)
    {
       if(Quadrant     == BOTTOM_LEFT_QUADRANT){
          BrushFill   (CenterPoint->x - CurrentPoint->x,                
                       CenterPoint->y, 
                       CenterPoint->x,                                 
                       CenterPoint->y + CurrentPoint->y);
       } else 
       if(Quadrant     == BOTTOM_RIGHT_QUADRANT){
          BrushFill   (CenterPoint->x,    
                       CenterPoint->y,  
                       CenterPoint->x + CurrentPoint->x,   
                       CenterPoint->y + CurrentPoint->y);
       } else
       if(CurrentPoint->y != 0)
       {
          if(Quadrant     == TOP_RIGHT_QUADRANT){
             BrushFill   (CenterPoint->x, 
                          CenterPoint->y - CurrentPoint->y + ThePdaGDI.CurrentPenSize.cy, 
                          CenterPoint->x + CurrentPoint->x, 
                          CenterPoint->y                  );
          } else 
          if(Quadrant     == TOP_LEFT_QUADRANT){
             BrushFill   (CenterPoint->x - CurrentPoint->x,             
                          CenterPoint->y - CurrentPoint->y + ThePdaGDI.CurrentPenSize.cy, 
                          CenterPoint->x                  ,                               
                          CenterPoint->y                  );
          }
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static void SetPieLines(LPPOINT CenterPoint, LPPOINT CurrentPoint, int Quadrant)
{
    if(Quadrant     == BOTTOM_LEFT_QUADRANT){
       PaintLine (CenterPoint->x, CenterPoint->y, CenterPoint->x - CurrentPoint->x,  CenterPoint->y + CurrentPoint->y);
    } else 
    if(Quadrant     == BOTTOM_RIGHT_QUADRANT){
       PaintLine (CenterPoint->x, CenterPoint->y, CenterPoint->x + CurrentPoint->x,  CenterPoint->y + CurrentPoint->y);
    } else
    if(Quadrant     == TOP_RIGHT_QUADRANT){
       PaintLine (CenterPoint->x, CenterPoint->y, CenterPoint->x + CurrentPoint->x,  CenterPoint->y - CurrentPoint->y);
    } else 
    if(Quadrant     == TOP_LEFT_QUADRANT){
       PaintLine (CenterPoint->x, CenterPoint->y, CenterPoint->x - CurrentPoint->x,  CenterPoint->y - CurrentPoint->y);
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef _PdaOS_H
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
// BITMAP
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL   __stdcall PdaLoadBitmap  (long X, long Y, LPROMBYTE ImageData)
{
PPdaBitmapRes ThisImageFormat = (PPdaBitmapRes)ImageData;
UINT          WidthInByte, UncompressedSize, InputSize = ThisImageFormat->BlockSize;
PBYTE         SrcBuffer   = (PBYTE)&ImageData[sizeof(PdaBitmapRes)];

    switch(ThisImageFormat->BitPerPixel){
    case 1:  WidthInByte  = ((ThisImageFormat->Width + 15) & ~15) / 8; break;
    case 4:  WidthInByte  = ((ThisImageFormat->Width +  3) & ~ 3) / 2; break;
    case 8:  WidthInByte  = ((ThisImageFormat->Width +  1) & ~ 1);     break;
    default: WidthInByte  = 0; // UNSUPPORTED
             break;
    }
    if(WidthInByte       == 0){
       return FALSE;
    }
    UncompressedSize      = WidthInByte * ThisImageFormat->Height;

    InitUnZipFrame(X, Y, ThisImageFormat->Width, ThisImageFormat->Height, ThisImageFormat->BitPerPixel, InputSize, 
                   1, 0, ThePdaGDI.SurfacePtr, SrcBuffer); 

    switch(ThisImageFormat->Compression){
    case PD_COMPRESS_ZIP:
         if(UnzipImageFrame () != Z_OK){
            return FALSE;
	     }
         break;
    case PD_COMPRESS_NONE:
         if((UncompressedSize > InputSize) || (PaintUnCompresedFrame () != Z_OK)){            
            return FALSE;
         }
         break;
    default:
         return FALSE;
    }
    RepaintIPalm();
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
#if 0 // KEEP FOR ARCHIVE REASON
__forceinline static void SetPenPixel          (long CurrX, long CurrY)
{
int      LoopOnPenHeight;
WORD     BrushX, BrushY;
long     StartX, StartY, DeltaX, DeltaY;
PBYTE    ScreenPtr;

    if(ThePdaGDI.CurrentMaskMode){
       SetMaskedPenPixel (CurrX, CurrY);
       return;
    }
    StartX = CurrX; DeltaX = CurrX  + ThePdaGDI.CurrentPenSize.cx;
    StartY = CurrY; DeltaY = StartY;
  
    for(LoopOnPenHeight = 0; LoopOnPenHeight  < ThePdaGDI.CurrentPenSize.cy; LoopOnPenHeight++){
       DeltaY  += ThePdaGDI.SurfaceWidthInByte;
    }

    if(ClipRectangle(&StartX, &StartY, &DeltaX, &DeltaY, &ThePdaGDI.ClipAddrRectangle) == FALSE){
       return ;
    }
    for( CurrY           = StartY; CurrY < DeltaY; CurrY += ThePdaGDI.SurfaceWidthInByte)
    {
       ScreenPtr         = &ThePdaGDI.SurfacePtr[CurrY + StartX]; 

       for( CurrX        = StartX; CurrX < DeltaX; CurrX ++)
       {
           *ScreenPtr++  = ThePdaGDI.CurrentPenColor; 
       }
    }
}
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall PaintRoundRectangle (PPdaRect TheRect)
{
int     MaxThickness     = min((GetPRectWidth(TheRect) >> 1), (GetPRectHeight(TheRect) >> 1));
PdaRect LocalRect        = *TheRect;
PdaRect CornerRect       = *TheRect;
int     Roundness        = ThePdaGDI.CurrentBorderRoundness;

    if((ThePdaGDI.CurrentPenSize.cx > MaxThickness)
    || (ThePdaGDI.CurrentPenSize.cy > MaxThickness)){
       return FALSE;
    }
    if(Roundness > MaxThickness){
       return FALSE;
    } else 
    if((Roundness < 2) && (Roundness > -2) ){
       Roundness = 0;
    }
    if(Roundness){

       if(ThePdaGDI.CurrentFillMode){

          BrushFill (TheRect->left   + Roundness, // FILL THE CENTER
                     TheRect->top    + Roundness, 
                     TheRect->right  - Roundness, 
                     TheRect->bottom - Roundness);
          
          BrushFill (TheRect->left             ,  // FILL THE LEFT SIDE
                     TheRect->top    + Roundness, 
                     TheRect->left   + Roundness, 
                     TheRect->bottom - Roundness);
          
          BrushFill (TheRect->right  - Roundness, // FILL THE RIGHT SIDE 
                     TheRect->top    + Roundness, 
                     TheRect->right,             
                     TheRect->bottom - Roundness);

          BrushFill (TheRect->left   + Roundness, // FILL THE TOP SIDE
                     TheRect->top               , 
                     TheRect->right  - Roundness,  
                     TheRect->top    + Roundness);

          BrushFill (TheRect->left   + Roundness, // FILL THEBOTTOM SIDE
                     TheRect->bottom - Roundness, 
                     TheRect->right  - Roundness, 
                     TheRect->bottom);
       }
       LocalRect           = *TheRect;
       // PAINT LEFT TOP CORNER 
       CornerRect.left   = LocalRect.left; 
       CornerRect.top    = LocalRect.top     + (Roundness << 1); 
       CornerRect.right  = LocalRect.left    + (Roundness << 1); 
       CornerRect.bottom = LocalRect.top;
       NormalizePdaRect    (&CornerRect);
       PaintArc            (&CornerRect, TOP_LEFT_QUADRANT);

       // PAINT TOP LINE 
	   PaintLine (LocalRect.left + (Roundness), LocalRect.top, LocalRect.right  - (Roundness), LocalRect.top);

       // PAINT TOP RIGHT CORNER 
       CornerRect.left   = LocalRect.right   - (Roundness << 1); 
       CornerRect.top    = LocalRect.top; 
       CornerRect.right  = LocalRect.right; 
       CornerRect.bottom = LocalRect.top     + (Roundness << 1);
       NormalizePdaRect    (&CornerRect);
       PaintArc            (&CornerRect, TOP_RIGHT_QUADRANT);

       // PAINT RIGHT LINE 
	   PaintLine (LocalRect.right, LocalRect.top + (Roundness), LocalRect.right, LocalRect.bottom - (Roundness));

       // PAINT BOTTOM RIGHT CORNER 
       CornerRect.left   = LocalRect.right; 
       CornerRect.top    = LocalRect.bottom  - (Roundness << 1); 
       CornerRect.right  = LocalRect.right   - (Roundness << 1); 
       CornerRect.bottom = LocalRect.bottom;
       NormalizePdaRect    (&CornerRect);
       PaintArc            (&CornerRect, BOTTOM_RIGHT_QUADRANT);

       // PAINT BOTTOM LINE 
	   PaintLine (LocalRect.right - Roundness,   LocalRect.bottom, LocalRect.left + Roundness, LocalRect.bottom);

       // PAINT BOTTOM LEFT CORNER
       CornerRect.left   = LocalRect.left    + (Roundness << 1); 
       CornerRect.top    = LocalRect.bottom; 
       CornerRect.right  = LocalRect.left; 
       CornerRect.bottom = LocalRect.bottom  - (Roundness << 1);
       NormalizePdaRect    (&CornerRect);
       PaintArc            (&CornerRect, BOTTOM_LEFT_QUADRANT);

       // PAINT LEFT LINE 
	   PaintLine (LocalRect.left, LocalRect.bottom - Roundness, LocalRect.left, LocalRect.top + Roundness);
    } else {
       if(ThePdaGDI.CurrentFillMode){
          BrushFillRect(TheRect);
       }
       LocalRect           = *TheRect;
	   PaintLine (LocalRect.left,   LocalRect.top,    LocalRect.right,    LocalRect.top);     // PAINT TOP LINE 
	   PaintLine (LocalRect.right,  LocalRect.top,    LocalRect.right,    LocalRect.bottom);  // PAINT RIGHT LINE 
	   PaintLine (LocalRect.right,  LocalRect.bottom, LocalRect.left,     LocalRect.bottom);  // PAINT BOTTOM LINE 
	   PaintLine (LocalRect.left,   LocalRect.bottom, LocalRect.left,     LocalRect.top);     // PAINT LEFT LINE 
    }
	return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall PaintEllipse(PPdaRect TheRect)
{
POINT     CenterPoint;
POINT     CurrentPoint;
int       HalfWidth    = (GetPRectWidth(TheRect)  >> 1);
int       HalfHeight   = (GetPRectHeight(TheRect) >> 1);
long      SquareOfA    = HalfWidth * HalfWidth;
long      TwoSquareOfA = 2 * SquareOfA;
long      SquareOfB    = HalfHeight * HalfHeight;
long      TwoSquareOfB = 2 * SquareOfB;
long      Direction,     DeltaX, DeltaY;

    CenterPoint.x      = TheRect->left     + HalfWidth;
    CenterPoint.y      = TheRect->top      + HalfHeight;
    CurrentPoint.x     = 0;
    CurrentPoint.y     = HalfHeight;

    if((HalfWidth == 0 ) || (HalfHeight == 0)){
       return FALSE;
    }
    //INITIALIZE DECISION VARIABLE AND INCREMENTS
    Direction  = SquareOfB - SquareOfA * HalfHeight + SquareOfA / 4;
    DeltaX     = 0;
    DeltaY     = TwoSquareOfA * HalfHeight;
    
    while(DeltaX < DeltaY ) // DO WHILE SLOPE > -1
    {
       SetQuadrantPixels(&CenterPoint, &CurrentPoint);
       if (Direction     > 0){
          if(ThePdaGDI.CurrentFillMode){
             BrushFill (CenterPoint.x - CurrentPoint.x,     CenterPoint.y - CurrentPoint.y + ThePdaGDI.CurrentPenSize.cy, 
                        CenterPoint.x + CurrentPoint.x,     CenterPoint.y + CurrentPoint.y - 1);
          }
          CurrentPoint.y--;
          DeltaY        -= TwoSquareOfA;
          Direction     -= DeltaY;

       }
       CurrentPoint.x++;
       DeltaX           += TwoSquareOfB;
       Direction        += SquareOfB + DeltaX;
    }
    // SLOPE <= -1
    Direction +=(3 * (SquareOfA - SquareOfB) / 2 - (DeltaX + DeltaY)) / 2;
    
    while(CurrentPoint.y >= 0) // DO UNTIL X_AXIS IS REACHED
    {
       SetQuadrantPixels(&CenterPoint, &CurrentPoint);
       
       if(Direction      < 0){
          CurrentPoint.x++;
          DeltaX        += TwoSquareOfB;
          Direction     += DeltaX;
       }
       if(ThePdaGDI.CurrentFillMode){
          BrushFill (CenterPoint.x - CurrentPoint.x, CenterPoint.y - CurrentPoint.y + ThePdaGDI.CurrentPenSize.cy, 
                     CenterPoint.x + CurrentPoint.x, CenterPoint.y + CurrentPoint.y - 1);
       }
       CurrentPoint.y--;
       DeltaY           -= TwoSquareOfA;
       Direction        += SquareOfA -DeltaY;
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall PaintArc(PPdaRect TheRect, int Quadrant)
{
POINT     CenterPoint;
POINT     CurrentPoint;
int       HalfWidth    = (GetPRectWidth(TheRect)  >> 1);
int       HalfHeight   = (GetPRectHeight(TheRect) >> 1);
long      SquareOfA    = HalfWidth * HalfWidth;
long      TwoSquareOfA = 2 * SquareOfA;
long      SquareOfB    = HalfHeight * HalfHeight;
long      TwoSquareOfB = 2 * SquareOfB;
long      Direction,     DeltaX, DeltaY;

    CenterPoint.x      = TheRect->left     + HalfWidth;
    CenterPoint.y      = TheRect->top      + HalfHeight;
    CurrentPoint.x     = 0;
    CurrentPoint.y     = HalfHeight;

    if((HalfWidth == 0 )|| (HalfHeight == 0)){
       return FALSE;
    }
    //INITIALIZE DECISION VARIABLE AND INCREMENTS
    Direction  = SquareOfB - SquareOfA * HalfHeight + SquareOfA / 4;
    DeltaX     = 0;
    DeltaY     = TwoSquareOfA * HalfHeight;
    
    while(DeltaX < DeltaY ) // DO WHILE SLOPE > -1
    {
       SetArcPixels(&CenterPoint, &CurrentPoint, Quadrant);
       if (Direction     > 0){
          if(ThePdaGDI.CurrentFillMode){
             FillArcPixels (&CenterPoint, &CurrentPoint, Quadrant);
          }
          CurrentPoint.y--;
          DeltaY        -= TwoSquareOfA;
          Direction     -= DeltaY;
       }
       CurrentPoint.x++;
       DeltaX           += TwoSquareOfB;
       Direction        += SquareOfB + DeltaX;
    }
    // SLOPE <= -1
    Direction +=(3 * (SquareOfA - SquareOfB) / 2 - (DeltaX + DeltaY)) / 2;
    
    while(CurrentPoint.y >= 0) // DO UNTIL X_AXIS IS REACHED
    {
       if(ThePdaGDI.CurrentFillMode){
          FillArcPixels (&CenterPoint, &CurrentPoint, Quadrant);
       }
       SetArcPixels(&CenterPoint, &CurrentPoint, Quadrant);
       
       if(Direction      < 0){
          CurrentPoint.x++;
          DeltaX        += TwoSquareOfB;
          Direction     += DeltaX;
       }
       CurrentPoint.y--;
       DeltaY           -= TwoSquareOfA;
       Direction        += SquareOfA -DeltaY;
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall PaintPie(PPdaRect TheRect, int Quadrant)
{
POINT     CenterPoint,    CurrentPoint,   StartPoint;
int       HalfWidth    = (GetPRectWidth(TheRect)  >> 1);
int       HalfHeight   = (GetPRectHeight(TheRect) >> 1);
long      SquareOfA    = HalfWidth * HalfWidth;
long      TwoSquareOfA = 2 * SquareOfA;
long      SquareOfB    = HalfHeight * HalfHeight;
long      TwoSquareOfB = 2 * SquareOfB;
long      Direction,     DeltaX, DeltaY;

    CenterPoint.x      = TheRect->left     + HalfWidth;
    CenterPoint.y      = TheRect->top      + HalfHeight;
    CurrentPoint.x     = 0;
    CurrentPoint.y     = HalfHeight;

    if((HalfWidth == 0 )|| (HalfHeight == 0)){
       return FALSE;
    }
    //INITIALIZE DECISION VARIABLE AND INCREMENTS
    Direction  = SquareOfB - SquareOfA * HalfHeight + SquareOfA / 4;
    DeltaX     = 0;
    DeltaY     = TwoSquareOfA * HalfHeight;
    
    StartPoint = CurrentPoint;

    while(DeltaX < DeltaY ) // DO WHILE SLOPE > -1
    {
       SetArcPixels(&CenterPoint, &CurrentPoint, Quadrant);
       if (Direction     > 0){
          if(ThePdaGDI.CurrentFillMode){
             FillArcPixels (&CenterPoint, &CurrentPoint, Quadrant);
          }
          CurrentPoint.y--;
          DeltaY        -= TwoSquareOfA;
          Direction     -= DeltaY;
       }
       CurrentPoint.x++;
       DeltaX           += TwoSquareOfB;
       Direction        += SquareOfB + DeltaX;
    }
    // SLOPE <= -1
    Direction +=(3 * (SquareOfA - SquareOfB) / 2 - (DeltaX + DeltaY)) / 2;

    while(CurrentPoint.y > 0) // DO UNTIL X_AXIS IS REACHED
    {
       if(ThePdaGDI.CurrentFillMode){
          FillArcPixels (&CenterPoint, &CurrentPoint, Quadrant);
       }
       SetArcPixels(&CenterPoint, &CurrentPoint, Quadrant);
       
       if(Direction      < 0){
          CurrentPoint.x++;
          DeltaX        += TwoSquareOfB;
          Direction     += DeltaX;
       }
       CurrentPoint.y--;
       DeltaY           -= TwoSquareOfA;
       Direction        += SquareOfA -DeltaY;
    }
    SetArcPixels(&CenterPoint, &CurrentPoint, Quadrant);
    SetPieLines (&CenterPoint, &StartPoint, Quadrant);
    SetPieLines (&CenterPoint, &CurrentPoint, Quadrant);
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
#endif // _PdaOS_H
///////////////////////////////////////////////////////////////////////////////////////////////////
#endif // USE_PAINTDRAW
///////////////////////////////////////////////////////////////////////////////////////////////////
