// PaintDraw.h: interface for the PaintDraw class.
///////////////////////////////////////////////////////////////////////////////////////////////////
#if !defined(AFX_PAINTDRAW_H__1084A3A5_BD38_4034_8AEC_F026BD8EECD4__INCLUDED_)
#define AFX_PAINTDRAW_H__1084A3A5_BD38_4034_8AEC_F026BD8EECD4__INCLUDED_
///////////////////////////////////////////////////////////////////////////////////////////////////
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
///////////////////////////////////////////////////////////////////////////////////////////////////
#pragma pack(push, 1)
///////////////////////////////////////////////////////////////////////////////////////////////////
typedef enum _PdaMouseMode {

    PDAPENMODE_ARROW       = 0,

    PDAPENMODE_PEN         = 1,
    PDAPENMODE_ERASER      = 2,

    PDAPENMODE_LINE        = 11,
    PDAPENMODE_RECT        = 12,

    PDAPENMODE_ELLIPSE     = 21,
    PDAPENMODE_TEXT        = 22,

    PDAPENMODE_PIE         = 31,
    PDAPENMODE_ARC         = 32,

    PDAPENMODE_ZOOM        = 41,
    PDAPENMODE_COLORPICKER = 42,

    PDAPENMODE_HAND        = 51,
    PDAPENMODE_FILL        = 52,

    PDAPENMODE_SELECT      = 61 

} PdaMouseMode; 
///////////////////////////////////////////////////////////////////////////////////////////////////
typedef enum _PdaPaintMenuSelect {

    PDAPAINTMENU_DESKTOP     = (WORD)-1,

    PDAPAINTMENU_ARROW       = 0,

    PDAPAINTMENU_PEN         = 1,
    PDAPAINTMENU_ERASER      = 2,

    PDAPAINTMENU_LINE        = 11,
    PDAPAINTMENU_RECT        = 12,

    PDAPAINTMENU_ELLIPSE     = 21,
    PDAPAINTMENU_TEXT        = 22,

    PDAPAINTMENU_PIE         = 31,
    PDAPAINTMENU_ARC         = 32,

    PDAPAINTMENU_ZOOM        = 41,
    PDAPAINTMENU_COLORPICKER = 42,

    PDAPAINTMENU_HAND        = 51,
    PDAPAINTMENU_FILL        = 52,

    PDAPAINTMENU_SELECT      = 61,
    
    PDAPAINTMENU_SAVE        = 98,
    PDAPAINTMENU_SETTINGS    = 99

} PdaPaintMenuSelect; 
///////////////////////////////////////////////////////////////////////////////////////////////////
// USER DRAW SUPPORT
///////////////////////////////////////////////////////////////////////////////////////////////////
#if USE_PAINTDRAW
///////////////////////////////////////////////////////////////////////////////////////////////////
void         __stdcall PenDrawFreeHand                        ();
void         __stdcall PenDrawLine                            ();
void         __stdcall PenDrawRoundRect                       ();
void         __stdcall PenDrawRect                            ();
void         __stdcall PenDrawEllipse                         ();
void         __stdcall PenDrawArc                             ();
void         __stdcall PenDrawPie                             ();

void         __stdcall PenDraw                                ();

void         __stdcall PenDrawFont                            ();

BOOL         __stdcall DemoFont                               (PPdaRect PreviousRect, PPdaRect NewRect);

///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL         __stdcall PdaLoadBitmap                          (long X, long Y, LPROMBYTE ImageData);

int                    PdaPaintMenuMouse                      (UShort ThisPosition, UShort ThisCommand, Byte Button, Byte Shift, UShort X, UShort Y);
BOOL         __stdcall PdaPaintMouseDown                      (long Button, long Shift, long X, long Y);  
void         __stdcall PreparePaintMenu                       ();
///////////////////////////////////////////////////////////////////////////////////////////////////
class PaintDraw  
{
public:
	PaintDraw();
	virtual ~PaintDraw();

};
///////////////////////////////////////////////////////////////////////////////////////////////////
#endif // USE_PAINTDRAW
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
#pragma pack(pop)
///////////////////////////////////////////////////////////////////////////////////////////////////
#endif // !defined(AFX_PAINTDRAW_H__1084A3A5_BD38_4034_8AEC_F026BD8EECD4__INCLUDED_)
