// PaintScreen.cpp
///////////////////////////////////////////////////////////////////////////////////////////////////
#include "StdAfx.h"
///////////////////////////////////////////////////////////////////////////////////////////////////
CCriticalSection               CriticalScreenAccess;
int                            PDA_VIR_SCREEN_WIDTH = PAL_SCREEN_VIR_WIDTH; //
int                            CurrentPenX, CurrentPenY;
///////////////////////////////////////////////////////////////////////////////////////////////////
PalmScreenLayout::PalmScreenLayout ()
{
	m_ColorBuffer              = NULL;
    ZeroMemory                   (&m_ColorInfo,      sizeof(m_ColorInfo));

    DebugMode                  = TRUE;
    ScreenWidth                = PAL_SCREEN_WIDTH;
    ScreenHeight               = PAL_SCREEN_HEIGHT;

    SimulLeft                  = 0;
    SimulTop                   = 0;
    SimulWidth                 = PAL_SCREEN_WIDTH;
    SimulHeight                = PAL_SCREEN_HEIGHT;
    ThumbNailRectSize          = 24;
    ThumbNailPenWidth          = 4;
    SimulBeginMove             = FALSE;
    ShowSimulBox               = FALSE;

    VirtualScreenWidth         = PAL_SCREEN_VIR_WIDTH;
    VirtualScreenHeight        = PAL_SCREEN_VIR_HEIGHT;
    PDA_VIR_SCREEN_WIDTH       = VirtualScreenWidth;

    ToolHeight                 = PAL_TOOL_SIZE;
    MenuHeight                 = PAL_MENU_HEIGHT;
    KeyboardWidth              = PAL_KEBD_WIDTH;
    KeyboardHeight             = PAL_KEBD_HEIGHT;

    ToolTop                    = VirtualScreenHeight;
    MenuTop                    = ToolTop;
    KeyboardTop                = (VirtualScreenHeight + MenuHeight + KeyboardHeight);
    KeyboardTableTop           = 1598; // KeyboardTop + KeyboardHeight;

    CurrentKeyboardX           = (KeyboardWidth);
    CurrentKeyboardY           = (ToolHeight  - (MenuHeight + KeyboardHeight));

    TransitPos                 = 194;
    PageReadyPos               = 206;
    Palm.MarqueLen             = 20;

    // SCREEN BUFFER POINTER PASSED FROM VB
    ScreenPointer              = NULL;

    MemoryScreenWidth          = VirtualScreenWidth;
    MemoryScreenHeight         = VirtualScreenHeight + ToolHeight;
    VScreenWidthInByte         = VirtualScreenWidth;
    VScreenBufferSize          = (MemoryScreenHeight * VScreenWidthInByte);

    VScrollValue               = 0; //TheMain.VScroll1.Value Current Screen location
    HScrollValue               = 0; //TheMain.HScroll1.Value Current Screen location

    VScrollMax                 = 0;
    HScrollMax                 = 0;

    VScrollMin                 = 0;
    HScrollMin                 = 0;

    VScrollSmallChange         = 0;
    HScrollSmallChange         = 0;

    CurrentColorIndex          = 0;

    // TEMPORARY VAR HOLDER FOR MODIFIED SCREEN
    KeybdOnScreen              = 0;
    AddressStatus              = 0;
    TransitStatus              = 0;
    KeybdOnSatus               = 0;
    MenuDownloaded             = 0;
    KeyboardTable              = 0;
    KeyboardDownloaded         = 0;
    KeyboardFullyFunctionnal   = FALSE;

    InitSequenceComplete       = FALSE;

    WhitePoint                 = 1;
    BlackPoint                 = 0;

    MenuMode                   = PDAMENUMODE_PAINT;

    ZeroMemory(&ImageBmp.bmiColors[0], 256 * sizeof(RGBQUAD));

#ifndef __LINUX__
    GetHalftoneSytemPaletteColors ((LPPALETTEENTRY) &ImageBmp.bmiColors[0], 256);
#endif
    // 16 colors
    // Black point
    ImageBmp.bmiColors[0].rgbRed    = 0;
    ImageBmp.bmiColors[0].rgbGreen  = 0;
    ImageBmp.bmiColors[0].rgbBlue   = 0;

    // White Point
    ImageBmp.bmiColors[1].rgbRed    = 255;
    ImageBmp.bmiColors[1].rgbGreen  = 255;
    ImageBmp.bmiColors[1].rgbBlue   = 255;

    ImageBmp.bmiColors[2].rgbRed    = 51;
    ImageBmp.bmiColors[2].rgbGreen  = 51;
    ImageBmp.bmiColors[2].rgbBlue   = 153;

    ImageBmp.bmiColors[3].rgbRed    = 204;
    ImageBmp.bmiColors[3].rgbGreen  = 102;
    ImageBmp.bmiColors[3].rgbBlue   = 204;

    ImageBmp.bmiColors[4].rgbRed    = 102;
    ImageBmp.bmiColors[4].rgbGreen  = 204;
    ImageBmp.bmiColors[4].rgbBlue   = 204;

    ImageBmp.bmiColors[5].rgbRed    = 153;
    ImageBmp.bmiColors[5].rgbGreen  = 204;
    ImageBmp.bmiColors[5].rgbBlue   = 0;

    ImageBmp.bmiColors[6].rgbRed    = 255;
    ImageBmp.bmiColors[6].rgbGreen  = 153;
    ImageBmp.bmiColors[6].rgbBlue   = 102;

    ImageBmp.bmiColors[7].rgbRed    = 225;
    ImageBmp.bmiColors[7].rgbGreen  = 204;
    ImageBmp.bmiColors[7].rgbBlue   = 51;

    ImageBmp.bmiColors[8].rgbRed    = 153;
    ImageBmp.bmiColors[8].rgbGreen  = 102;
    ImageBmp.bmiColors[8].rgbBlue   = 204;

    ImageBmp.bmiColors[9].rgbRed    = 204;
    ImageBmp.bmiColors[9].rgbGreen  = 0;
    ImageBmp.bmiColors[9].rgbBlue   = 102;

    ImageBmp.bmiColors[10].rgbRed   = 0;
    ImageBmp.bmiColors[10].rgbGreen = 153;
    ImageBmp.bmiColors[10].rgbBlue  = 153;

    ImageBmp.bmiColors[11].rgbRed   = 102;
    ImageBmp.bmiColors[11].rgbGreen = 153;
    ImageBmp.bmiColors[11].rgbBlue  = 0;

    ImageBmp.bmiColors[12].rgbRed   = 204;
    ImageBmp.bmiColors[12].rgbGreen = 51;
    ImageBmp.bmiColors[12].rgbBlue  = 0;

    ImageBmp.bmiColors[13].rgbRed   = 204;
    ImageBmp.bmiColors[13].rgbGreen = 102;
    ImageBmp.bmiColors[13].rgbBlue  = 0;

    ImageBmp.bmiColors[14].rgbRed   = 203;
    ImageBmp.bmiColors[14].rgbGreen = 203;
    ImageBmp.bmiColors[14].rgbBlue  = 203;

    ImageBmp.bmiColors[15].rgbRed   = 150;
    ImageBmp.bmiColors[15].rgbGreen = 150;
    ImageBmp.bmiColors[15].rgbBlue  = 150;
}
PalmScreenLayout::~PalmScreenLayout()
{
}
///////////////////////////////////////////////////////////////////////////////////////////////////
PalmScreenLayout Palm;
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
// PRIVATE ONLY
///////////////////////////////////////////////////////////////////////////////////////////////////
CString KeyboardString;
///////////////////////////////////////////////////////////////////////////////////////////////////
BITMAPINFO256      ImageBmp;
HWND               PadWndHandle;
HWND               KeyboardWndHandle;

typedef struct _Frame {
int    X, Y;
DWORD  W, H;
} Frame, *PFrame;

Frame  Pad;

UINT   ScanStart;
LONG   NumScans;
int    MemSrcX, MemSrcY;
///////////////////////////////////////////////////////////////////////////////////////////////////
extern "C" {
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
void SetupColorBitmapInfo()
{
    ImageBmp.bmiHeader.biSize          = 40;
    ImageBmp.bmiHeader.biCompression   = 0;
    ImageBmp.bmiHeader.biPlanes        = 1;
    ImageBmp.bmiHeader.biBitCount      = 8;

    ImageBmp.bmiHeader.biHeight        = -(NumScans);
    ImageBmp.bmiHeader.biWidth         = Palm.VirtualScreenWidth;
    ImageBmp.bmiHeader.biSizeImage     = NumScans * ImageBmp.bmiHeader.biWidth;

    ImageBmp.bmiHeader.biXPelsPerMeter = 40;
    ImageBmp.bmiHeader.biYPelsPerMeter = 40;
    ImageBmp.bmiHeader.biClrImportant  = 0;
    ImageBmp.bmiHeader.biClrUsed       = 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  UpdateRGBQuad  (PBYTE RGBInfoBuffer, WORD NumOfColors)
{
DWORD PaletteLength = 0;

    // GetHalftoneSytemPaletteColors ((LPPALETTEENTRY) &ImageBmp.bmiColors[0], 256);

    PaletteLength = NumOfColors * sizeof (RGBQUAD);
    CopyMemory (ImageBmp.bmiColors, RGBInfoBuffer, PaletteLength);

    RepaintIPalm();
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
#if USE_PDA_SYSFONT
///////////////////////////////////////////////////////////////////////////////////////////////////
HFONT    hTekCtrlFx = NULL;
CString  TekFontName (_T("TekSymbol")); // TekSymbol // TekOEM // TekCtrl // TekSymbol

///////////////////////////////////////////////////////////////////////////////////////////////////
int CALLBACK FontLookup (CONST  LOGFONT    *Log,     // logical-font data
                         CONST  TEXTMETRIC *Metric,  // physical-font data
                         DWORD  Type,                // font type
                         LPARAM Data)                // application-defined data
{
CString FontName;

   FontName = Log->lfFaceName;

   if( FontName.CompareNoCase(TekFontName) == 0 ){
       hTekCtrlFx =  CreateFontIndirect(Log);
       return FALSE; // STOP PARSING...
   }
   return( TRUE );
}
#endif // USE_PDA_SYSFONT
///////////////////////////////////////////////////////////////////////////////////////////////////
#if USE_PDA_SYSFONT //moved 2 lines up by AY
HFONT ReleasePDAFont (HDC hDC, HFONT TheOldFont)
{

    if(hTekCtrlFx){
       if(TheOldFont){
          SelectObject (hDC, TheOldFont);
       } else {
          SelectObject (hDC , GetStockObject(ANSI_VAR_FONT));
       }
       DeleteObject(hTekCtrlFx); hTekCtrlFx = NULL;
    }

    return NULL;
}
#endif // USE_PDA_SYSFONT moved 3 lines down by ay
///////////////////////////////////////////////////////////////////////////////////////////////////
#if USE_PDA_SYSFONT //moved 2 lines up by AY
HFONT GetPDAFont (HDC hDC)
{

    EnumFonts (hDC,  TekFontName, FontLookup, NULL );
    if(hTekCtrlFx){
       return (HFONT) SelectObject (hDC, hTekCtrlFx);
    }

    return NULL;
}
#endif // USE_PDA_SYSFONT  moved 3 lines down by ay
///////////////////////////////////////////////////////////////////////////////////////////////////
void InitPaint()
{
	Pad.X                     = 0;
	Pad.Y                     = 0;
	Pad.W                     = Palm.ScreenWidth;
	Pad.H                     = Palm.ScreenHeight;

	MemSrcX                   = 0;
	                          // THE REST FROM FULLHEIGHT - HEIGHT OF A SCREEN WIDTHOUT THE MENU
    MemSrcY                   = Palm.MemoryScreenHeight  - (Palm.ScreenHeight);

	ScanStart                 = 0;
	NumScans                  = Palm.MemoryScreenHeight;

	Palm.KeybdOnScreen        = 0;    // assume keybd is not on screen

	Palm.VScrollValue         = 0;
	Palm.HScrollValue         = 0;

    Palm.VScrollMin           = 0;
    Palm.HScrollMin           = 0;

	                          // THE SCROLLMAX MUST BE CALULATED WITH THE ENTIRE VIRTUALSCREEN HEIGHT
    Palm.VScrollMax           = (Palm.DebugMode ? ((Palm.MemoryScreenHeight - Palm.ScreenHeight)) : ((Palm.VirtualScreenHeight - Palm.ScreenHeight + Palm.MenuHeight)) );
    Palm.HScrollMax           = (Palm.VirtualScreenWidth  - Palm.ScreenWidth);

    Palm.VScrollSmallChange   = 16;
    Palm.HScrollSmallChange   = 16;

	SetupColorBitmapInfo();
    if(PadSettings.ImageCapsRequested == PDA_CAPMONO) {
	   ChangeScreenColor(Palm.CurrentColorIndex);
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
long CalcScreen (long ScreenWidth, long ScreenHeight, long VirWidth, long VirHeight)
{
long MemNeeded = VirWidth * (VirHeight + Palm.ToolHeight);

    ScreenWidth  &= ~15;
    VirWidth     &= ~15;

    if((ScreenWidth              > VirWidth)){
       ScreenWidth               = VirWidth;
    }
    if((ScreenHeight             > VirHeight + Palm.MenuHeight) ){
       ScreenHeight              = VirHeight + Palm.MenuHeight;
    }
    Palm.SimulWidth              = 640;
    Palm.SimulHeight             = PAL_SCREEN_HEIGHT;
    if(Palm.SimulWidth           < ScreenWidth){
       Palm.ShowSimulBox         = TRUE;
    } else {
       Palm.ShowSimulBox         = FALSE;
       UseSimul                  = FALSE;
    }
    if((Palm.VirtualScreenWidth == VirWidth) && (Palm.VirtualScreenHeight == VirHeight) ){
       Palm.ScreenWidth          = ScreenWidth;
       Palm.ScreenHeight         = ScreenHeight;
       if(Palm.ScreenPointer){
          return 0;
       }
    }
    if(Palm.VirtualScreenHeight < (PAL_TOOL_SIZE)){
       return 0;
    }
    if((MemNeeded > 0) ){
       Palm.ScreenWidth          = ScreenWidth;
       Palm.ScreenHeight         = ScreenHeight;

       Palm.VirtualScreenWidth   = VirWidth;
       Palm.VirtualScreenHeight  = VirHeight;
       PDA_VIR_SCREEN_WIDTH      = Palm.VirtualScreenWidth;

       if(Palm.VirtualScreenWidth >= 800){

          Palm.ToolHeight           = PAL_TOOL_SIZE;  // 352;// MUST BE AT LEAST (2 * MenuHeight) + (2 * KeyboardHeight) + 16
          Palm.MenuHeight           = 32;  // PAL_MENU_HEIGHT;
          Palm.KeyboardWidth        = 384; // PAL_KEBD_WIDTH
          Palm.KeyboardHeight       = 120; // PAL_KEBD_HEIGHT;

          Palm.ToolTop              = Palm.VirtualScreenHeight;
          Palm.MenuTop              = Palm.ToolTop;
          Palm.KeyboardTop          = (Palm.VirtualScreenHeight + Palm.MenuHeight + Palm.KeyboardHeight);
          Palm.KeyboardTableTop     = Palm.KeyboardTop + Palm.KeyboardHeight; // 1598; //

          Palm.CurrentKeyboardX     = (Palm.ScreenWidth - Palm.KeyboardWidth);
          Palm.CurrentKeyboardY     = (Palm.ToolHeight  - (Palm.MenuHeight + Palm.KeyboardHeight));

          Palm.TransitPos           = 448;
          Palm.PageReadyPos         = 460;
          Palm.MarqueLen            = 30;

       } else if(Palm.VirtualScreenWidth == 640){ // FOR OLD 320 DEVICE

          Palm.ToolHeight           = PAL_TOOL_SIZE;
          Palm.MenuHeight           = PAL_MENU_HEIGHT;
          Palm.KeyboardWidth        = PAL_KEBD_WIDTH;
          Palm.KeyboardHeight       = PAL_KEBD_HEIGHT;

          Palm.ToolTop              = Palm.VirtualScreenHeight;
          Palm.MenuTop              = Palm.ToolTop;
          Palm.KeyboardTop          = (Palm.VirtualScreenHeight + Palm.MenuHeight + Palm.KeyboardHeight);
          Palm.KeyboardTableTop     = 1598; // KeyboardTop + KeyboardHeight;

          Palm.CurrentKeyboardX     = (Palm.KeyboardWidth);
          Palm.CurrentKeyboardY     = (Palm.ToolHeight  - (Palm.MenuHeight + Palm.KeyboardHeight));

          Palm.TransitPos           = 194;
          Palm.PageReadyPos         = 206;
          Palm.MarqueLen            = 20;

       }
       Palm.VScreenWidthInByte      = Palm.VirtualScreenWidth;
       Palm.MemoryScreenWidth       = Palm.VirtualScreenWidth;
       Palm.MemoryScreenHeight      = Palm.VirtualScreenHeight + Palm.ToolHeight;
       Palm.VScreenBufferSize       = Palm.MemoryScreenHeight  * Palm.VScreenWidthInByte;
       MemNeeded                    = Palm.VirtualScreenWidth  * (Palm.MemoryScreenHeight);
    }
    return MemNeeded;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
void  RefreshIPalm()
{DLL_THREAD_MANAGEMENT();

#ifndef __LINUX__
    if(PadWndHandle == 0){
	    return ;
    }
    if( ::IsWindow(PadWndHandle)) {
       InvalidateRect(PadWndHandle, NULL, FALSE);
    }
    if( ::IsWindow(KeyboardWndHandle)) {
       InvalidateRect(KeyboardWndHandle, NULL, FALSE);
    }
#endif
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void  ClearPadScreen()
{DLL_THREAD_MANAGEMENT();

    CurFocusWindId              = NULL;
    CurFocusObjectId            = 0;
    CurFocusChildId             = 0;
    CurFocusLimit               = 0;
    CurFocusRect.SetRectEmpty();
    CurFocusText                = _T("");

    ClearRectData(0, 0, Palm.VirtualScreenWidth, Palm.VirtualScreenHeight, 1);
    RefreshIPalm();
}
//const BYTE   StartByteMask [8]  = { 0xFF, 0x7F, 0x3F, 0x1F, 0x0F, 0x07, 0x03, 0x01 };
//const BYTE   EndByteMask   [8]  = { 0x00, 0x80, 0xC0, 0xE0, 0xF0, 0xF8, 0xFC, 0xFE };
//const BYTE   DecodeMask    [8]  = { 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01 };
///////////////////////////////////////////////////////////////////////////////////////////////////
// TAKE NOTE : This scroll routine only support when the refresh edge is rounded to a byte
//             So the originate of the copy line must align the opposite edge
//             ex.: When (XDst < XSrc) then the width must be in boudary of byte
//                  When (XDst > XSrc) then (XDst and XSrc) must be in boudary of byte
//                  But not necessary the width.
//                  When (XDst == XSrc) it should be all in boundary.
//
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall RefreshIKeyboardPalm()
{DLL_THREAD_MANAGEMENT();
#if USE_KEYBOARDIMAGE
    if(PadWndHandle      == 0){
	    return ;
    }
    if(KeyboardWndHandle == 0){
       return ;
    }
    if( ::IsWindow(KeyboardWndHandle)) {
       InvalidateRect(KeyboardWndHandle, NULL, FALSE);
    }
    if(Palm.KeybdOnScreen){
       if( ::IsWindow(PadWndHandle)) {
          InvalidateRect(PadWndHandle, NULL, FALSE);
       }
    }
#endif
}

///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall RepaintIPalm()
{DLL_THREAD_MANAGEMENT();

#ifndef __LINUX__
HDC  PadHdcHandle;

    if(PadWndHandle == 0){
	    return FALSE;
    }
    if(IsBadWritePtr(Palm.ScreenPointer, Palm.VScreenBufferSize)){
       return FALSE;
    }
    if( ::IsWindow(PadWndHandle)) {

       //InvalidateRect( PadWndHandle, NULL, FALSE);
       PadHdcHandle = GetDC(PadWndHandle);
       if(PadHdcHandle){
          PaintPalmScreen(PadHdcHandle);
          ReleaseDC(PadWndHandle, PadHdcHandle);
          return TRUE;
       }
    }
#endif
    return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall CopyPalmToClipboard()
{DLL_THREAD_MANAGEMENT();

#ifndef __LINUX__
    return CopyBitmapToClipboard((BITMAPINFO*)&ImageBmp, Palm.ScreenPointer);
#endif
    return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall PaintPalmScreen(HDC  PadHdcHandle)
{DLL_THREAD_MANAGEMENT();
#ifndef __LINUX__
LONG        Lineret;
//std::string StringOut;
CString     StringOut;
LONG        ThisStrLen;
HFONT       TheOldFont;

    if( ::IsWindow(PadWndHandle) == FALSE) {
       return FALSE;
    }
    if(IsBadWritePtr(Palm.ScreenPointer, Palm.VScreenBufferSize)){
       return FALSE;
    }
    CSingleLock AccessSingleLock(&CriticalScreenAccess);  AccessSingleLock.Lock();
    if(AccessSingleLock.IsLocked()){

       SetDIBColorTable(PadHdcHandle, 0, 256, ImageBmp.bmiColors);

       if(Palm.KeybdOnScreen){
            if(Palm.ScreenWidth == 480){
               Rectangle (PadHdcHandle, (Pad.X + Palm.KeyboardWidth),
                                        (Pad.Y + Palm.MenuHeight),
                                        Pad.W,
                                        (Pad.Y + Palm.MenuHeight));//  + Palm.KeyboardHeight
            }
            // FIRST PAINT THE MENU AND KEYBOARD UNDERNEATH
            Lineret = SetDIBitsToDevice(PadHdcHandle,
                                        Pad.X, Pad.Y,
                                        Pad.W, (Palm.MenuHeight),                     //  + Palm.KeybdOnScreen
                                        (Palm.ScreenWidth == 640 ? 0 : 320),
                                        (Palm.ToolHeight  - (Palm.MenuHeight)),//  + Palm.KeybdOnScreen

                                        ScanStart, NumScans,
                                        Palm.ScreenPointer, (CONST BITMAPINFO*)&ImageBmp, DIB_RGB_COLORS);
       } else {
            // FIRST PAINT MENU
            Lineret = SetDIBitsToDevice(PadHdcHandle,
                                        Pad.X, Pad.Y,
                                        Pad.W, Palm.MenuHeight,
                                        0,     (Palm.ToolHeight - Palm.MenuHeight),
                                        ScanStart, NumScans,
                                        Palm.ScreenPointer, (CONST BITMAPINFO*)&ImageBmp, DIB_RGB_COLORS);
       }
       if(Palm.VScrollValue   < Palm.VScrollMin) {
          Palm.VScrollValue   = Palm.VScrollMin;
       }
       if(Palm.VScrollValue   > Palm.VScrollMax) { //  + Palm.KeybdOnScreen
          Palm.VScrollValue   = Palm.VScrollMax;   //  + Palm.KeybdOnScreen
       }
       long  SrcX  = (MemSrcX + Palm.HScrollValue),
             SrcY  = (MemSrcY - Palm.VScrollValue);//  + Palm.KeybdOnScreen
       // NOW PAINT IMAGE
       Lineret = SetDIBitsToDevice(PadHdcHandle,
                                   Pad.X, (Pad.Y + Palm.MenuHeight),  // + Palm.KeybdOnScreen
                                   Pad.W, (Pad.H ),  // + Palm.KeybdOnScreen
                                   SrcX,  SrcY,
                                   ScanStart, NumScans,
                                   Palm.ScreenPointer, (CONST BITMAPINFO*)&ImageBmp, DIB_RGB_COLORS);

       //SelectObject (PadHdcHandle , GetStockObject(ANSI_VAR_FONT));
       //SelectObject (PadHdcHandle , GetStockObject(BLACK_PEN));
       //SetBkMode    (PadHdcHandle,  OPAQUE);
       SetBkMode    (PadHdcHandle, TRANSPARENT);

       TheOldFont   = GetPDAFont (PadHdcHandle);

       if((Palm.KeybdOnScreen) && (KeyboardString != _T(""))) {
          StringOut      = KeyboardString;
          ThisStrLen     = StringOut.GetLength();
          if(ThisStrLen > Palm.MarqueLen) {
             StringOut   = KeyboardString.Mid(((ThisStrLen - Palm.MarqueLen) + 1));
             ThisStrLen  = StringOut.GetLength();
          }
          TextOut        (PadHdcHandle, 4, 4, StringOut, ThisStrLen);
       }
       if((Palm.TransitStatus)){
          static       CurrentForm;
          TCHAR        TheChar = 22;
          CurrentForm++; CurrentForm &= 3; TheChar += CurrentForm;

          StringOut    = TheChar;   //StringOut    = "\x16";
          TextOut        (PadHdcHandle, Palm.TransitPos, 4, StringOut, 1); // 448, 6, StringOut.c_str(), 1);
       }
       if((Palm.PDAPageReady)){
          StringOut    = _T("\x9D");
          TextOut        (PadHdcHandle, Palm.PageReadyPos, 4, StringOut, 1); // 464, 6, StringOut.c_str(), 1);
       }

       if(EnableStatusBar){
          CString    Info;
/*
          Info.Format    ("Profile Rate: Hi In: %8d B/s  Current: %8d B/s,  Out Hi: %8d B/s  Current: %8d B/s ",
                          ProfileDataInHi, ProfileDataIn, ProfileDataOutHi, ProfileDataOut);
*/
          Info.Format    (_T("Profile Rate: Hi In: %8.3f Kb/s  Current: %8.3f Kb/s,  Avg: %8.3f Kb/s"),
                          ProfileDataInHi, ProfileDataIn, ProfileDataInAvg);

          Rectangle      (PadHdcHandle, 0, 220, Palm.ScreenWidth, 240);
          TextOut        (PadHdcHandle, 4, 222, Info, Info.GetLength());
       }
#if USE_FOCUSRECT // def _DEBUG

       PaintGrid(PadHdcHandle);

       if((CurFocusWindId) || (CurFocusObjectId) || (CurFocusChildId)
       && (Not CurFocusRect.IsRectEmpty())
       ){
          CRect     ThisRect    = CurFocusRect;
          CRect     ScreenRect;
          CRect     ScrollRect;

          ScreenRect.left       = Pad.X;
          ScreenRect.top        = Pad.Y              + Palm.MenuHeight;
          ScreenRect.right      = Pad.W;
          ScreenRect.bottom     = Pad.H              + ScreenRect.top;

          ScrollRect.left       = Palm.HScrollValue;
          ScrollRect.top        = Palm.VScrollValue  + Pad.Y;
          ScrollRect.right      = Palm.HScrollValue  + Pad.W;
          ScrollRect.bottom     = Palm.VScrollValue  + Pad.H   - Pad.Y;

          ThisRect.left        -= ScrollRect.left;
          ThisRect.top         -= ScrollRect.top;      ThisRect.top         += Palm.MenuHeight;
          ThisRect.right       -= ScrollRect.left;
          ThisRect.bottom      -= ScrollRect.top;      ThisRect.bottom      += Palm.MenuHeight;
          if(ClipRect(&ThisRect, &ScreenRect)){

             HPEN hpen, hpenOld;

             if(CurFocusLimit){
                hpen    = CreatePen(PS_SOLID, 2, RGB(255, 0, 0));
             } else {
                hpen    = CreatePen(PS_SOLID, 2, RGB(0, 128, 0));
             }
             if(Not CurFocusLimit){ // COMMENT THIS IF YOU WANT TO SEE THE RED LINE FOR LIMITTED FOCUS RECT...
                hpenOld = (HPEN)SelectObject(PadHdcHandle, hpen);
                MoveToEx (PadHdcHandle, ThisRect.left,    ThisRect.top,                      NULL);
                LineTo   (PadHdcHandle, ThisRect.right,   ThisRect.top);
                LineTo   (PadHdcHandle, ThisRect.right,   ThisRect.bottom);
                LineTo   (PadHdcHandle, ThisRect.left,    ThisRect.bottom);
                LineTo   (PadHdcHandle, ThisRect.left,    ThisRect.top);

                MoveToEx (PadHdcHandle, ThisRect.left   + 1,  ThisRect.top     + 1,          NULL);
                LineTo   (PadHdcHandle, ThisRect.right  - 1,  ThisRect.top     + 1);
                LineTo   (PadHdcHandle, ThisRect.right  - 1,  ThisRect.bottom  - 1);
                LineTo   (PadHdcHandle, ThisRect.left   + 1,  ThisRect.bottom  - 1);
                LineTo   (PadHdcHandle, ThisRect.left   + 1,  ThisRect.top     + 1);

                SelectObject(PadHdcHandle, hpenOld);
             }
             DeleteObject(hpen);
          }
       }
#endif // USE_FOCUSRECT // def _DEBUG
       ReleasePDAFont (PadHdcHandle, TheOldFont);
       AccessSingleLock.Unlock();
    }
#endif // __LINUX__
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall PaintPalmKeyboardScreen(HWND WinHandle, HDC  PadHdcHandle)
{DLL_THREAD_MANAGEMENT();
#if USE_KEYBOARDIMAGE

LONG        Lineret;
CRect       ClientRect;

    if( ::IsWindow(PadWndHandle) == FALSE) {
       return FALSE;
    }
    if( ::IsWindow(WinHandle) == FALSE) {
       return FALSE;
    }
    if(KeyboardWndHandle != WinHandle){
       KeyboardWndHandle  = WinHandle;
    }
    if(IsBadWritePtr(Palm.ScreenPointer, Palm.VScreenBufferSize)){
       return FALSE;
    }
    if(GetClientRect(WinHandle, &ClientRect) == FALSE){
       return FALSE;
    }
    CSingleLock AccessSingleLock(&CriticalScreenAccess);  AccessSingleLock.Lock();
    if(AccessSingleLock.IsLocked()){
       SetDIBColorTable(PadHdcHandle, 0, 256, ImageBmp.bmiColors);

	   Lineret = SetDIBitsToDevice(PadHdcHandle,
                                   0,
                                   0,
                                   Palm.KeyboardWidth,
                                   Palm.KeyboardHeight,

                                   (Palm.CurrentKeyboardX), // X SOURCE
                                   (Palm.CurrentKeyboardY), // Y SOURCE

                                   ScanStart, NumScans,
                                   Palm.ScreenPointer, (CONST BITMAPINFO*)&ImageBmp, DIB_RGB_COLORS);
       AccessSingleLock.Unlock();
    }
#endif
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
/*
void DrawSingleCharOnMono (long DstX, long DstY, BYTE CharOut) // CURRENT FONT 8 X 16
{
int   Looper;
long  ThisCharArray = CharOut * 16;
PBYTE MonoPtr       = Palm.ScreenPointer + ((DstY * Palm.VScreenWidthInByte) + DstX / 8);

    for(Looper        = 0; Looper < 16; Looper ++){
       *MonoPtr       = PDAFONT [ ThisCharArray ];
       MonoPtr       += Palm.VScreenWidthInByte;
       ThisCharArray += 1;
    }
}
*/
///////////////////////////////////////////////////////////////////////////////////////////////////
void DrawSingleCharOnMono (long DstX, long DstY, BYTE CharOut) // CURRENT FONT 8 X 16
{
int   Looper;
long  ThisCharArray   = CharOut * 16;
PBYTE MonoPtr         = Palm.ScreenPointer + ((DstY * Palm.VScreenWidthInByte) + DstX);

    for(Looper        = 0; Looper < 16; Looper ++){
      *MonoPtr        = ThePdaGDI.CurrentFont [ ThisCharArray ];
       MonoPtr       += Palm.VScreenWidthInByte;
       ThisCharArray += 1;
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void DrawSingleCharOnColor (long DstX, long DstY, BYTE CharOut) // CURRENT FONT 8 X 16
{
int   Looper, SumData;
long  ThisCharArray    = CharOut * 16;
PBYTE MonoPtr          = &UncompressTempBuffer[0];
int   PacketSize = 16  * (8 / 8 );

    for(Looper         = 0; Looper < 16; Looper ++){
       *MonoPtr        = ThePdaGDI.CurrentFont [ ThisCharArray ];

       MonoPtr        += 1;
       ThisCharArray  += 1;
    }
    SumData = ConvertFontImageToColor  ( TempImageBuffer, UncompressTempBuffer, PacketSize);
    PaintRectData (DstX, DstY, 8, 16, TempImageBuffer, 1, 1);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall DisplayString(long DstX, long DstY, LPCSTR StringOut, long ThisStrLen)
{DLL_THREAD_MANAGEMENT();
int   Looper;
BYTE  CharOut;
long  ThisX = DstX, ThisY = (DstY >= Palm.MemoryScreenHeight ? DstY - Palm.MemoryScreenHeight : DstY );
/*
    while (DstX >= 320){
       DstX = DstX - 320;
    }
    while (DstY >= 240){
       DstY = DstY - 240;
    }
    Call TextOut(TheMain.ZPad.hdc, DstX, DstY, StringOut, Stringlen)
    SetStringQueue ( StringOut );
*/
    for(Looper = 0; Looper < ThisStrLen; Looper++){
       CharOut = StringOut[Looper];
       //DrawSingleCharOnMono (ThisX, ThisY, CharOut);
       DrawSingleCharOnColor (ThisX, ThisY, CharOut);
       ThisX  += 8;
    }
    RefreshIPalm();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
int __stdcall GetScreenColor()
{DLL_THREAD_MANAGEMENT();

    return Palm.CurrentColorIndex;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall ChangeScreenColor(long Index)
{DLL_THREAD_MANAGEMENT();

    switch(Index){
    case 0:                   //NORMAL
         ImageBmp.bmiColors[Palm.WhitePoint].rgbRed   = 127 ;
         ImageBmp.bmiColors[Palm.WhitePoint].rgbGreen = 143 ;
         ImageBmp.bmiColors[Palm.WhitePoint].rgbBlue  = 111 ;

         //BACKLITE
         //ImageBmp.bmiColors[Palm.BlackPoint].rgbRed    = 0     '80   '0    '0    '
         //ImageBmp.bmiColors[Palm.BlackPoint].rgbGreen  = 192 '128  '127  '199  '
         //ImageBmp.bmiColors[Palm.BlackPoint].rgbBlue   = 192  '144  '127  '192  '

         ImageBmp.bmiColors[Palm.BlackPoint].rgbRed    = 0;
         ImageBmp.bmiColors[Palm.BlackPoint].rgbGreen  = 40;
         ImageBmp.bmiColors[Palm.BlackPoint].rgbBlue   = 0;
		 break;

    case 1:   // BLUE BACKLITE
         ImageBmp.bmiColors[Palm.WhitePoint].rgbRed    = 112;
         ImageBmp.bmiColors[Palm.WhitePoint].rgbGreen  = 224;
         ImageBmp.bmiColors[Palm.WhitePoint].rgbBlue   = 239;

         ImageBmp.bmiColors[Palm.BlackPoint].rgbRed    = 0;
         ImageBmp.bmiColors[Palm.BlackPoint].rgbGreen  = 60;
         ImageBmp.bmiColors[Palm.BlackPoint].rgbBlue   = 40;
         break;

    case 2:   // GREEN LITE
         ImageBmp.bmiColors[Palm.WhitePoint].rgbRed    = 94;
         ImageBmp.bmiColors[Palm.WhitePoint].rgbGreen  = 190;
         ImageBmp.bmiColors[Palm.WhitePoint].rgbBlue   = 94;

         ImageBmp.bmiColors[Palm.BlackPoint].rgbRed    = 0;
         ImageBmp.bmiColors[Palm.BlackPoint].rgbGreen  = 80;
         ImageBmp.bmiColors[Palm.BlackPoint].rgbBlue   = 0;
         break;

    case 3:   //  SANDED
         ImageBmp.bmiColors[Palm.WhitePoint].rgbRed    = 187;
         ImageBmp.bmiColors[Palm.WhitePoint].rgbGreen  = 168;
         ImageBmp.bmiColors[Palm.WhitePoint].rgbBlue   = 111;

         ImageBmp.bmiColors[Palm.BlackPoint].rgbRed    = 110;
         ImageBmp.bmiColors[Palm.BlackPoint].rgbGreen  = 0;
         ImageBmp.bmiColors[Palm.BlackPoint].rgbBlue   = 0;
         break;

    case 4:   // DESERT
         ImageBmp.bmiColors[Palm.WhitePoint].rgbRed    = 208;
         ImageBmp.bmiColors[Palm.WhitePoint].rgbGreen  = 199;
         ImageBmp.bmiColors[Palm.WhitePoint].rgbBlue   = 176;

         ImageBmp.bmiColors[Palm.BlackPoint].rgbRed    = 0;
         ImageBmp.bmiColors[Palm.BlackPoint].rgbGreen  = 60;
         ImageBmp.bmiColors[Palm.BlackPoint].rgbBlue   = 0;
         break;

    case 5:   // GREY SANDED
         ImageBmp.bmiColors[Palm.WhitePoint].rgbRed    = 180;
         ImageBmp.bmiColors[Palm.WhitePoint].rgbGreen  = 190;
         ImageBmp.bmiColors[Palm.WhitePoint].rgbBlue   = 180;

         ImageBmp.bmiColors[Palm.BlackPoint].rgbRed    = 65;
         ImageBmp.bmiColors[Palm.BlackPoint].rgbGreen  = 65;
         ImageBmp.bmiColors[Palm.BlackPoint].rgbBlue   = 44;
         break;

    case 6:   // GREY METALIC
         ImageBmp.bmiColors[Palm.WhitePoint].rgbRed    = 213;
         ImageBmp.bmiColors[Palm.WhitePoint].rgbGreen  = 218;
         ImageBmp.bmiColors[Palm.WhitePoint].rgbBlue   = 227;

         ImageBmp.bmiColors[Palm.BlackPoint].rgbRed    = 65;
         ImageBmp.bmiColors[Palm.BlackPoint].rgbGreen  = 65;
         ImageBmp.bmiColors[Palm.BlackPoint].rgbBlue   = 44;
         break;

    case 7:    // PINKY
         ImageBmp.bmiColors[Palm.WhitePoint].rgbRed    = 255;// '254
         ImageBmp.bmiColors[Palm.WhitePoint].rgbGreen  = 128 ; // 1
         ImageBmp.bmiColors[Palm.WhitePoint].rgbBlue   = 230;  //'166

         ImageBmp.bmiColors[Palm.BlackPoint].rgbRed    = 0;
         ImageBmp.bmiColors[Palm.BlackPoint].rgbGreen  = 64;
         ImageBmp.bmiColors[Palm.BlackPoint].rgbBlue   = 92;
         break;

    case 8:    // OCEAN
         ImageBmp.bmiColors[Palm.WhitePoint].rgbRed    = 0;
         ImageBmp.bmiColors[Palm.WhitePoint].rgbGreen  = 192;
         ImageBmp.bmiColors[Palm.WhitePoint].rgbBlue   = 192;

         ImageBmp.bmiColors[Palm.BlackPoint].rgbRed    = 0;
         ImageBmp.bmiColors[Palm.BlackPoint].rgbGreen  = 64;
         ImageBmp.bmiColors[Palm.BlackPoint].rgbBlue   = 64;
         break;

    case 9:    // WHITE PAPER
         ImageBmp.bmiColors[Palm.WhitePoint].rgbRed    = 255;
         ImageBmp.bmiColors[Palm.WhitePoint].rgbGreen  = 255;
         ImageBmp.bmiColors[Palm.WhitePoint].rgbBlue   = 255;

         ImageBmp.bmiColors[Palm.BlackPoint].rgbRed    = 0;
         ImageBmp.bmiColors[Palm.BlackPoint].rgbGreen  = 0;
         ImageBmp.bmiColors[Palm.BlackPoint].rgbBlue   = 0;
         break;
    }
    Palm.CurrentColorIndex = Index;
    RefreshIPalm();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall ClearPadMem()
{DLL_THREAD_MANAGEMENT();

    ClearRectData(0, Palm.VirtualScreenHeight, Palm.VirtualScreenWidth, (Palm.ToolHeight), 1);
    Palm.MenuDownloaded            = 0;
    Palm.KeyboardTable             = 0;
    Palm.KeyboardDownloaded        = 0;
    Palm.KeyboardFullyFunctionnal  = FALSE;
    Palm.InitSequenceComplete      = 0;

    RefreshIPalm();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
#if USE_KEYBOARDIMAGE
void CopyRoughLine (PBYTE ScreenPtrSrc, PBYTE ScreenPtrDst, short XSrc, short XDst, short WidthInPixel)
{
const BYTE   MaskLeft      [8]  = { 0x00, 0x80, 0xC0, 0xE0, 0xF0, 0xF8, 0xFC, 0xFE };
const BYTE   MaskRight     [8]  = { 0xFF, 0x7F, 0x3F, 0x1F, 0x0F, 0x07, 0x03, 0x01 };
WORD         CombineBytes;
short        ShiftSrc,  ShiftDst, ShiftEnd, CombineShift;
short        ColLooper, WidthInByte = WidthInPixel;
BYTE         DstEdge, SrcEdge, ThePixel;

    ShiftDst    = XDst         & 7;
    ShiftSrc    = XSrc         & 7;
    ShiftEnd    = WidthInPixel & 7;

    if(XDst    <= XSrc){

       CombineShift      = ShiftSrc  // (>  0) = THE SRC >> DIRECTION + USE REMAINDER
                         - ShiftDst; // (<  0) = THE SRC << DIRECTION
                                     // (== 0) = VOIDING EACH OTHER JUST USE MASK
       if(CombineShift      > 0){

          ColLooper         = 0;
          DstEdge           = MaskLeft     [ShiftDst];
          SrcEdge           = MaskRight    [ShiftDst];

          CombineBytes      = *(WORD*)& ScreenPtrSrc [ColLooper++];
          __asm {
             ROR  CombineBytes, 8
          }
          CombineBytes    <<= CombineShift;

          *ScreenPtrDst    &= DstEdge;
          ThePixel          = HIBYTE(CombineBytes);
          *ScreenPtrDst    |= (ThePixel & SrcEdge);

          ScreenPtrSrc++;
          ScreenPtrDst++;

          for(; ColLooper < WidthInByte; ColLooper ++){

              CombineBytes      = *(WORD*)&ScreenPtrSrc[0];
              __asm {
                 ROR  CombineBytes, 8
              }
              CombineBytes    <<= CombineShift;
              *ScreenPtrDst     = HIBYTE(CombineBytes);

              ScreenPtrSrc++;
              ScreenPtrDst++;
          }
          return;

       } else if(CombineShift < 0){ //  NEED A REMAINDER USE PREBYTE LOADING

          CombineShift      = abs(CombineShift);

          DstEdge           = MaskLeft     [ShiftDst];
          SrcEdge           = MaskRight    [ShiftDst];

          ScreenPtrSrc--;
          CombineBytes      = *(WORD*)&ScreenPtrSrc[0];
          __asm {
             ROR  CombineBytes, 8
          }
          CombineBytes    >>= CombineShift;

          ThePixel          = LOBYTE(CombineBytes);

          *ScreenPtrDst    &= DstEdge;
          *ScreenPtrDst    |= (ThePixel & SrcEdge);

          ScreenPtrDst++;
          ScreenPtrSrc++;

          for(ColLooper         = 1; ColLooper < WidthInByte; ColLooper ++){

              CombineBytes      = *(WORD*)&ScreenPtrSrc[0];
              __asm {
                 ROR  CombineBytes, 8
              }
              CombineBytes    >>= CombineShift;

              *ScreenPtrDst     = LOBYTE(CombineBytes);

              ScreenPtrDst++;
              ScreenPtrSrc++;
          }
          return;

       } else {
          ColLooper = 0;
          if(ShiftDst){
             DstEdge           = MaskLeft     [ShiftDst];
             SrcEdge           = MaskRight    [ShiftDst];

             CombineBytes      = *(WORD*)& ScreenPtrSrc [ColLooper++];
             __asm {
                ROR  CombineBytes, 8
             }
             *ScreenPtrDst    &= DstEdge;
             ThePixel          = HIBYTE(CombineBytes);
             *ScreenPtrDst    |= (ThePixel & SrcEdge);

             ScreenPtrSrc++;
             ScreenPtrDst++;
          }
          for(; ColLooper < WidthInByte; ColLooper ++){
              *ScreenPtrDst++ = *ScreenPtrSrc++;
          }
          return;
       }
    } else { // if(XDst     > XSrc){

       CombineShift      = ShiftSrc  // (>  0) = THE SRC << DIRECTION
                         - ShiftDst; // (<  0) = THE SRC >> DIRECTION + USE REMAINDER
                                     // (== 0) = VOIDING EACH OTHER JUST USE MASK
       if(CombineShift      > 0){
          ColLooper         = 0;

          DstEdge           = MaskRight    [ShiftDst];
          SrcEdge           = MaskLeft     [ShiftDst];

          CombineBytes      = *(WORD*)& ScreenPtrSrc [ColLooper++];
          __asm {
             ROR  CombineBytes, 8
          }
          CombineBytes    <<= CombineShift;

          *ScreenPtrDst    &= DstEdge;
          ThePixel          = HIBYTE(CombineBytes);
          *ScreenPtrDst    |= (ThePixel & SrcEdge);

          ScreenPtrSrc--;
          ScreenPtrDst--;

          for(; ColLooper < WidthInByte; ColLooper ++){

              CombineBytes      = *(WORD*)ScreenPtrSrc;
              __asm {
                 ROR  CombineBytes, 8
              }
              CombineBytes    <<= CombineShift;
              *ScreenPtrDst     = HIBYTE(CombineBytes);

              ScreenPtrSrc--;
              ScreenPtrDst--;
          }
          return;

       } if(CombineShift      < 0){

          CombineShift      = abs(CombineShift);

          ColLooper         = 0;

          DstEdge           = MaskRight    [ShiftDst];
          SrcEdge           = MaskLeft     [ShiftDst];

          ScreenPtrSrc--;

          CombineBytes      = *(WORD*)& ScreenPtrSrc [ColLooper++];
          __asm {
             ROR  CombineBytes, 8
          }
          CombineBytes    >>= CombineShift;

          *ScreenPtrDst    &= DstEdge;
          ThePixel          = LOBYTE(CombineBytes);
          *ScreenPtrDst    |= (ThePixel & SrcEdge);

          ScreenPtrDst--;

          // WARNING : THERE IS A CRASH POTENTIEL HERE IF IT GOES UP TO THE BEGENNING OF MEM.
          // IF LINE(Y) IS 0 THEN IT SHOULD NOT COMME HERE.
          for(; ColLooper < WidthInByte; ColLooper ++){

              ScreenPtrSrc--;

              CombineBytes      = *(WORD*)ScreenPtrSrc;
              __asm {
                 ROR  CombineBytes, 8
              }
              CombineBytes    >>= CombineShift;
              *ScreenPtrDst     = LOBYTE(CombineBytes);

              ScreenPtrDst--;
          }
          return;

       } else {

          ColLooper         = 0;

          DstEdge           = MaskRight    [ShiftDst];
          SrcEdge           = MaskLeft     [ShiftDst];

          *ScreenPtrDst    &= DstEdge;
          ThePixel          = *ScreenPtrSrc;
          *ScreenPtrDst    |= (ThePixel & SrcEdge);

          ScreenPtrSrc--;
          ScreenPtrDst--;

          for(; ColLooper < WidthInByte; ColLooper ++){
              *ScreenPtrDst   = *ScreenPtrSrc;
              ScreenPtrDst--;
              ScreenPtrSrc--;
          }
          return;
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall MemRectCopyMono(long NewX, long NewY, long X, long Y, long W, long H)
{DLL_THREAD_MANAGEMENT();

short XSrc,  XDst;
LONG  RowLooper;
LONG  DeltaX, DeltaY, DestX, DestY, WidthInPixel, WidthInByte;
LONG  SumData, LineToDo;
PBYTE ScreenPtrSrc, ScreenPtrDst;

    NewX          &= ~7;
    X             &= ~7;
    W             &= ~7;

    XDst           = NewX;
    XSrc           = X;

    WidthInPixel   = W;
    WidthInByte    = W; // STEP 8

    if(WidthInByte < 2){
       return;
    }
    DestX          = NewX;
    DestY          = NewY;
    DeltaX         = (X + WidthInByte) - 1;
	DeltaY         = (Y + H) - 1;
    LineToDo       = H;
    SumData        = WidthInByte * H;

    if(SumData > Palm.VScreenBufferSize) {
       return;
    }
    if((X    + W) > Palm.VirtualScreenWidth){
       return;
    }
    if((NewX + W) > Palm.VirtualScreenWidth){
       return;
    }
    if((Y    + H) > Palm.MemoryScreenHeight){
       return;
    }
    if((NewY + H) > Palm.MemoryScreenHeight){
       return;
    }
    if(IsBadWritePtr(Palm.ScreenPointer, Palm.VScreenBufferSize)){
       return;
    }
    CSingleLock AccessSingleLock(&CriticalScreenAccess);  AccessSingleLock.Lock();
    if(AccessSingleLock.IsLocked()){

       if((XDst      <= XSrc) ){
          if((DestY   > Y) ){ // DIRECTION UP
             DestY   += (H - 1);
             for( RowLooper = DeltaY; RowLooper >= Y; RowLooper--, DestY--){
                 ScreenPtrSrc = &Palm.ScreenPointer[((RowLooper * Palm.VScreenWidthInByte) + X)];
                 ScreenPtrDst = &Palm.ScreenPointer[((DestY * Palm.VScreenWidthInByte) + DestX)];

                 CopyRoughLine (ScreenPtrSrc, ScreenPtrDst, XSrc, XDst, WidthInPixel);
                 /*
                 for( ColLooper = X; ColLooper <= DeltaX; ColLooper ++){
                     *ScreenPtrDst++ = *ScreenPtrSrc++;
		         }
                 */
	         }
          } else { // DIRECTION DOWN
             for( RowLooper = Y; RowLooper <= DeltaY; RowLooper++, DestY++){
                 ScreenPtrSrc = &Palm.ScreenPointer[((RowLooper * Palm.VScreenWidthInByte) + X)];
                 ScreenPtrDst = &Palm.ScreenPointer[((DestY * Palm.VScreenWidthInByte) + DestX)];

                 CopyRoughLine (ScreenPtrSrc, ScreenPtrDst, XSrc, XDst, WidthInPixel);
                 /*
                 for( ColLooper = X; ColLooper <= DeltaX; ColLooper ++){
                     *ScreenPtrDst++ = *ScreenPtrSrc++;
		         }
                 */
	         }
          }
       } else {
          if((DestY  > Y) ){  // DIRECTION UP
             DestY  += (H - 1);
             for( RowLooper = DeltaY; RowLooper >= Y; RowLooper--, DestY--){
                 ScreenPtrSrc = &Palm.ScreenPointer[((RowLooper * Palm.VScreenWidthInByte) + X + WidthInByte)];
                 ScreenPtrDst = &Palm.ScreenPointer[((DestY * Palm.VScreenWidthInByte) + DestX + WidthInByte)];

                 CopyRoughLine (ScreenPtrSrc, ScreenPtrDst, XSrc, XDst, WidthInPixel);
                 /*
                 for( ColLooper = DeltaX; ColLooper >= X; ColLooper --){
                     ScreenPtrDst--;
                     ScreenPtrSrc--;
                     *ScreenPtrDst   = *ScreenPtrSrc;
		         }
                 */

	         }
          } else { // DIRECTION DOWN
             for( RowLooper = Y; RowLooper <= DeltaY; RowLooper++, DestY++){
                 ScreenPtrSrc = &Palm.ScreenPointer[((RowLooper * Palm.VScreenWidthInByte) + X + WidthInByte)];
                 ScreenPtrDst = &Palm.ScreenPointer[((DestY * Palm.VScreenWidthInByte) + DestX + WidthInByte)];


                 CopyRoughLine (ScreenPtrSrc, ScreenPtrDst, XSrc, XDst, WidthInPixel);
                 /*
                 for( ColLooper = DeltaX; ColLooper >= X; ColLooper --){
                     ScreenPtrDst--;
                     ScreenPtrSrc--;
                     *ScreenPtrDst   = *ScreenPtrSrc;
		         }
                 */
	         }
          }
       }
       AccessSingleLock.Unlock();
    }
}
#endif // #if USE_KEYBOARDIMAGE
///////////////////////////////////////////////////////////////////////////////////////////////////
// USE FOR SCROLL
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall MemRectCopyData(long NewX, long NewY, long X, long Y, long W, long H)
{DLL_THREAD_MANAGEMENT();

short XSrc,      XDst;
LONG  RowLooper, ColLooper;
LONG  DeltaX, DeltaY, DestX, DestY, WidthInPixel, WidthInByte;
LONG  SumData, LineToDo;
PBYTE ScreenPtrSrc, ScreenPtrDst;

    XDst           = NewX;
    XSrc           = X;

    WidthInPixel   = W;
    WidthInByte    = W;

    if(WidthInByte < 2){
       return;
    }
    DestX          = NewX;
    DestY          = NewY;
    DeltaX         = (X + WidthInByte) - 1;
	DeltaY         = (Y + H) - 1;
    LineToDo       = H;
    SumData        = WidthInByte * H;

    if(SumData > Palm.VScreenBufferSize) {
       return;
    }
    if((X    + W) > Palm.VirtualScreenWidth){
       return;
    }
    if((NewX + W) > Palm.VirtualScreenWidth){
       return;
    }
    if((Y    + H) > Palm.MemoryScreenHeight){
       return;
    }
    if((NewY + H) > Palm.MemoryScreenHeight){
       return;
    }
    if(IsBadWritePtr(Palm.ScreenPointer, Palm.VScreenBufferSize)){
       return;
    }
    CSingleLock AccessSingleLock(&CriticalScreenAccess);  AccessSingleLock.Lock();
    if(AccessSingleLock.IsLocked()){

       if((XDst      <= XSrc) ){
          if((DestY   > Y) ){ // DIRECTION UP
             DestY   += (H - 1);
             for( RowLooper = DeltaY; RowLooper >= Y; RowLooper--, DestY--){
                 ScreenPtrSrc = &Palm.ScreenPointer[((RowLooper * Palm.VScreenWidthInByte) + X)];
                 ScreenPtrDst = &Palm.ScreenPointer[((DestY * Palm.VScreenWidthInByte) + DestX)];

                 for( ColLooper = X; ColLooper <= DeltaX; ColLooper ++){
                     *ScreenPtrDst++ = *ScreenPtrSrc++;
		         }
	         }
          } else { // DIRECTION DOWN
             for( RowLooper = Y; RowLooper <= DeltaY; RowLooper++, DestY++){
                 ScreenPtrSrc = &Palm.ScreenPointer[((RowLooper * Palm.VScreenWidthInByte) + X)];
                 ScreenPtrDst = &Palm.ScreenPointer[((DestY * Palm.VScreenWidthInByte) + DestX)];

                 for( ColLooper = X; ColLooper <= DeltaX; ColLooper ++){
                     *ScreenPtrDst++ = *ScreenPtrSrc++;
		         }
	         }
          }
       } else {
          if((DestY  > Y) ){  // DIRECTION UP
             DestY  += (H - 1);
             for( RowLooper = DeltaY; RowLooper >= Y; RowLooper--, DestY--){
                 ScreenPtrSrc = &Palm.ScreenPointer[((RowLooper * Palm.VScreenWidthInByte) + X + WidthInByte)];
                 ScreenPtrDst = &Palm.ScreenPointer[((DestY * Palm.VScreenWidthInByte) + DestX + WidthInByte)];

                 for( ColLooper = DeltaX; ColLooper >= X; ColLooper --){
                     ScreenPtrDst--;
                     ScreenPtrSrc--;
                     *ScreenPtrDst   = *ScreenPtrSrc;
		         }
	         }
          } else { // DIRECTION DOWN
             for( RowLooper = Y; RowLooper <= DeltaY; RowLooper++, DestY++){
                 ScreenPtrSrc = &Palm.ScreenPointer[((RowLooper * Palm.VScreenWidthInByte) + X + WidthInByte)];
                 ScreenPtrDst = &Palm.ScreenPointer[((DestY * Palm.VScreenWidthInByte) + DestX + WidthInByte)];

                 for( ColLooper = DeltaX; ColLooper >= X; ColLooper --){
                     ScreenPtrDst--;
                     ScreenPtrSrc--;
                     *ScreenPtrDst   = *ScreenPtrSrc;
		         }
	         }
          }
       }
       AccessSingleLock.Unlock();
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall FillRectData(long X, long Y, long W, long H, BYTE FillLow, BYTE FillHigh)
{DLL_THREAD_MANAGEMENT();
LONG RowLooper, ColLooper;
LONG DeltaX, DeltaY;

/* MONO IMPLEMENTATION MUST BE REDESIGN FOR COLOR
    X      = (X) / 8;
    W      = (W + 7) / 8;
*/

    DeltaX = (X + W) - 1;
	DeltaY = (Y + H) - 1;

    if(IsBadWritePtr(Palm.ScreenPointer, Palm.VScreenBufferSize)){
       return;
    }
    CSingleLock AccessSingleLock(&CriticalScreenAccess);  AccessSingleLock.Lock();
    if(AccessSingleLock.IsLocked()){

       for( RowLooper = Y; RowLooper <= DeltaY; RowLooper++){
           PBYTE ScreenPtr = &Palm.ScreenPointer[((RowLooper * Palm.VScreenWidthInByte) + X)];

           for( ColLooper = X; ColLooper <= DeltaX; ColLooper += 2){
               *ScreenPtr++ = FillHigh;
			   if(ColLooper < Palm.VScreenWidthInByte-1){
                  *ScreenPtr++ = FillLow;
			   }
		   }
	   }
       AccessSingleLock.Unlock();
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall ClearRectData(long X, long Y, long W, long H, long StepLine)
{DLL_THREAD_MANAGEMENT();
long DeltaX, DeltaY;
long RowLooper, ColLooper;

    DeltaX  = (X + W) - 1;
    DeltaY  = (Y + H) - 1;

    if(IsBadWritePtr(Palm.ScreenPointer, Palm.VScreenBufferSize)){
       return;
    }
    CSingleLock AccessSingleLock(&CriticalScreenAccess);  AccessSingleLock.Lock();
    if(AccessSingleLock.IsLocked()){

       for( RowLooper = Y; RowLooper <= DeltaY; RowLooper += StepLine){

          PBYTE ScreenPtr = &Palm.ScreenPointer[((RowLooper * Palm.VScreenWidthInByte) + X)];
          for( ColLooper  = X; ColLooper <= DeltaX; ColLooper ++){

            *ScreenPtr++  = Palm.WhitePoint;
          }
       }
       AccessSingleLock.Unlock();
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void PaintRectColorData(long X, long Y, long W, long H, PBYTE TheData, long StepLine, BYTE InitialPhase)
{
LONG  DeltaX,         DeltaY;
LONG  RowLooper,      ColLooper;
LONG  DataLooper = 0;

    DeltaX  = (X + W) - 1;
    DeltaY  = (Y + H) - 1;

    if(IsBadWritePtr(Palm.ScreenPointer, Palm.VScreenBufferSize)){
       return;
    }
    // CopyRawMemoryToClipboard  (TheData, 800, 32, 8);                                     //VZ

    CSingleLock AccessSingleLock(&CriticalScreenAccess);  AccessSingleLock.Lock();
    if(AccessSingleLock.IsLocked()){

       for( RowLooper = Y; RowLooper <= DeltaY; RowLooper += StepLine){
           PBYTE ScreenPtr  = &Palm.ScreenPointer[((RowLooper * Palm.VScreenWidthInByte) + X)];
           PBYTE ScreenPtr2 = &Palm.ScreenPointer[(((RowLooper + 1) * Palm.VScreenWidthInByte) + X)];

           for( ColLooper  = X; ColLooper <= DeltaX; ColLooper++){

              *ScreenPtr++ = TheData[DataLooper];
              if((InitialPhase)){
                 *ScreenPtr2++ = TheData[DataLooper];
              }
              DataLooper   = DataLooper + 1;
           }
       }
       AccessSingleLock.Unlock();
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void PaintRectMonoData(long X, long Y, long W, long H, PBYTE TheData, long StepLine, BYTE InitialPhase)
{DLL_THREAD_MANAGEMENT();
LONG DeltaX,         DeltaY;
LONG RowLooper,      ColLooper;
LONG DataLooper = 0, SumData;

    X       = X / 8;
    W       = (W + 7) / 8;

    DeltaX  = (X + W) - 1;
    DeltaY  = (Y + H) - 1;

    SumData = W  * H;

    if(IsBadWritePtr(Palm.ScreenPointer, Palm.VScreenBufferSize)){
       return;
    }
    CSingleLock AccessSingleLock(&CriticalScreenAccess);  AccessSingleLock.Lock();
    if(AccessSingleLock.IsLocked()){

       for( RowLooper = Y; RowLooper <= DeltaY; RowLooper += StepLine){
           PBYTE ScreenPtr  = &Palm.ScreenPointer[((RowLooper * Palm.VScreenWidthInByte) + X)];
           PBYTE ScreenPtr2 = &Palm.ScreenPointer[(((RowLooper + 1) * Palm.VScreenWidthInByte) + X)];

           for( ColLooper  = X; ColLooper <= DeltaX; ColLooper++){

              *ScreenPtr++ = TheData[DataLooper];
              if((InitialPhase)){
                 *ScreenPtr2++ = TheData[DataLooper];
              }
              DataLooper   = DataLooper + 1;
           }
       }
       AccessSingleLock.Unlock();
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall PaintRectData(long X, long Y, long W, long H, PBYTE TheData, long StepLine, BYTE InitialPhase)
{DLL_THREAD_MANAGEMENT();

    PaintRectColorData(X, Y, W, H, TheData, StepLine, InitialPhase);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
HWND __stdcall GetScreenWindow()
{DLL_THREAD_MANAGEMENT();

    return PadWndHandle;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall SetScreenWindow(HWND PadDeviceHandle)
{DLL_THREAD_MANAGEMENT();

    PadWndHandle           = PadDeviceHandle;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
HWND __stdcall GetKeyboardWindow()
{DLL_THREAD_MANAGEMENT();

    return KeyboardWndHandle;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall SetKeyboardWindow (HWND KeyboardDeviceHandle)
{DLL_THREAD_MANAGEMENT();

    KeyboardWndHandle      = KeyboardDeviceHandle;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL PadScrollMouse(long Button, long Shift, long X, long Y)
{
long        Direction = 0;
MSG         Msg;

    if((X < PMENUKEYBOARD)) {
       ToggleKeyboard();
    } else if((X < PMENUDOWN)) {
       Direction  = PMENUDOWN;
    } else if((X < PMENUUP)) {
       Direction  = PMENUUP;
    } else if((X < PMENULEFT)) {
       Direction  = PMENULEFT;
    } else if((X < PMENURIGHT)) {
       Direction  = PMENURIGHT;
    }
    if(Direction) {
       InitStillDown(PadWndHandle);

       do {

          switch (Direction){
          case PMENUDOWN:
               if(Palm.VScrollValue >= Palm.VScrollMax) {// + Palm.KeybdOnScreen
                  goto ExitDo;
               } else {
                  Palm.VScrollValue = Palm.VScrollValue + Palm.VScrollSmallChange;
               }
               break;

          case PMENUUP:
               if(Palm.VScrollValue <= Palm.VScrollMin) {
                  goto ExitDo;
               } else {
                  Palm.VScrollValue = Palm.VScrollValue - Palm.VScrollSmallChange;
               }
               break;

          case PMENULEFT:
               if(Palm.HScrollValue <= Palm.HScrollMin) {
                  goto ExitDo;
               } else {
                  Palm.HScrollValue = Palm.HScrollValue - Palm.HScrollSmallChange;
               }
               break;

          case PMENURIGHT:
               if(Palm.HScrollValue >= Palm.HScrollMax) {
                  goto ExitDo;
               } else {
                  Palm.HScrollValue = Palm.HScrollValue + Palm.HScrollSmallChange;
               }
               break;
          }
          //ENTER DELAY BETWEEN MOVEMENT
          Sleep(50);
          RefreshIPalm ();

       } while (StillDown(&Msg, PadWndHandle));
ExitDo:
       ReleaseStillDown ();
       PostABeacon      ();
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL PadButtonMouse (long Button, long Shift, long X, long Y)
{
CString     NewString;

    if(Palm.KeybdOnSatus == 0){

       if((X > PMENUOPENKEYBD) && (X < (Palm.ScreenWidth))){
          ToggleKeyboard();
       }
    } else {
       if((X > PMENUSENDTEXT) && (X < (PMENUCANCELTEXT))){

          ToggleKeyboard();

       } else if((X > PMENUCANCELTEXT) && (X < (Palm.ScreenWidth))){
          if(Palm.AddressStatus){
             NewString = _T("27");
             SetStringQueue ( NewString );
             ToggleKeyboard();
          } else {
             ClearKeyboard();
          }
       }
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL PadMenuMouse (long Button, long Shift, long X, long Y)
{
long        VirtualX = X, VirtualY = Y;
BYTE        InMenuFlag = 0x80;

    TranslateMousePos (&VirtualX, &VirtualY);

    //IS IT IN THE MENU SCROLL TOOL AREA FOR 320 DEVICES...
    if((X > PALM_KEY) && (Palm.KeyboardWidth == 320)) {

       return PadScrollMouse(Button, Shift, X, Y);

    } else { // if((X <= PALM_KEY) || (Palm.KeyboardWidth != 320))

       if(X > PMENUSENDTEXT){ // SEND OR CANCEL BUTTON

          return PadButtonMouse(Button, Shift, X, Y);
/*
       } else { //

          if((Palm.KeybdOnSatus != 0) ){
             return TRUE;
          }
          if(Palm.AddressStatus == 0){
             if(Palm.KeyboardWidth == 320){
                if((X > PALM_ADRESSBUTTON) && (X < (PALM_GOBUTTON))){
                   ToggleKeyboard();
                }
             } else {
                if((X > WPALM_ADRESSBUTTON) && (X < (WPALM_GOBUTTON))){
                   ToggleKeyboard();
                }
             }
          }
*/
       }
    }
    return SendAMouseEvent((1  | ((Shift & 3) << 4) | InMenuFlag), VirtualX, VirtualY);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  TestAndSetSimulBox(long X, long Y)
{
long        VirtualSimX = X - Palm.ThumbnailMousePos.x;
long        VirtualSimY = Y - Palm.ThumbnailMousePos.y;
long        PreviousX   = X,  PreviousY = Y;

    if(VirtualSimY <= Palm.MenuHeight){
       TranslateMousePos (&VirtualSimX, &VirtualSimY);
       VirtualSimY = 0;
    } else {
       TranslateMousePos (&VirtualSimX, &VirtualSimY);
    }

    if(UseSimul && Palm.ShowSimulBox && Palm.SimulBeginMove ) {

       PreviousX       = Palm.SimulLeft ;  // : to keep respect relative pos with thumbnail
       PreviousY       = Palm.SimulTop  ;  //
       if((Y          <= Palm.MenuHeight)
       ){
          VirtualSimY  = 0;
       }
       Palm.SimulLeft  = MakeInRange(VirtualSimX, 0, Palm.ScreenWidth  - Palm.SimulWidth)  ;
       Palm.SimulTop   = MakeInRange(VirtualSimY, 0, Palm.ScreenHeight - Palm.SimulHeight) ;
       if((PreviousX  != Palm.SimulLeft )  // : thumbnail vs mouse
       || (PreviousY  != Palm.SimulTop  )
       ){
          RefreshIPalm();
       }
       return TRUE;
    }
    return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall PadMouseMove (long Button, long Shift, long X, long Y)
{DLL_THREAD_MANAGEMENT();
GBOOL Reentrant;
static DCTimeout MovePeriod;
long        VirtualX  = X, VirtualY  = Y;
long        PreviousX = X, PreviousY = Y;
BOOL        bRet = FALSE;

    TranslateMousePos (&VirtualX, &VirtualY);

    if(TestAndSetSimulBox(X, Y)){
       return Button;
    }
/*
    if(UseSimul && Palm.ShowSimulBox && Palm.SimulBeginMove ) {

       PreviousX       = Palm.SimulLeft;
       PreviousY       = Palm.SimulTop;
       if((Y           < Palm.MenuHeight)
       ){
          VirtualY     = 0;
       }
       Palm.SimulLeft  = MakeInRange(VirtualX, 0, Palm.ScreenWidth  - Palm.SimulWidth);
       Palm.SimulTop   = MakeInRange(VirtualY, 0, Palm.ScreenHeight - Palm.SimulHeight);
       if((PreviousX  != Palm.SimulLeft)
       || (PreviousY  != Palm.SimulTop)
       ){
          RefreshIPalm();
       }
       return Button;
    }
*/
    if((PadSettings.EnablePenMove == FALSE)
    || (Reentrant)){
       return FALSE;
    }
    Reentrant = TRUE;

    if((MovePeriod.Delay == 0) || (MovePeriod.StillInDelay() ==  FALSE)){

       bRet =  SendAMouseEvent((64  | ((Shift & 3) << 4)), VirtualX, VirtualY); // 64BIT 6 MEAN MOVE INDEPENDANTLY OF STATE
       CurrentPenX      = VirtualX;
       CurrentPenY      = VirtualY;
       MovePeriod.BeginDelay(5000);
    } else {
       CurrentPenX      = VirtualX;
       CurrentPenY      = VirtualY;
    }
    Reentrant = FALSE;
    return bRet;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall PadMouseUp (long Button, long Shift, long X, long Y)
{DLL_THREAD_MANAGEMENT();
GBOOL       Reentrant;
long        VirtualX  = X, VirtualY  = Y;
long        PreviousX = X, PreviousY = Y;

    TranslateMousePos (&VirtualX, &VirtualY);
#if USE_SIMULBOX
    if(TestAndSetSimulBox(X, Y)){
        Palm.SimulBeginMove  = FALSE;
        ReleaseCapture       ();
        PostABeacon          ();
        return Button;
    }
#endif
/*
    if(UseSimul && Palm.ShowSimulBox  && Palm.SimulBeginMove &&  Button == 1) {

        PreviousX          = Palm.SimulLeft;
        PreviousY          = Palm.SimulTop;
        if((Y             <= Palm.MenuHeight)
        ){
           VirtualY        = 0;
        }
        Palm.SimulLeft     = MakeInRange(VirtualX, 0, Palm.ScreenWidth  - Palm.SimulWidth);
        Palm.SimulTop      = MakeInRange(VirtualY, 0, Palm.ScreenHeight - Palm.SimulHeight);

        if((PreviousX     != Palm.SimulLeft)
        || (PreviousY     != Palm.SimulTop)
        ){
           RefreshIPalm      ();
        }
        Palm.SimulBeginMove  = FALSE;
        ReleaseCapture       ();
        PostABeacon          ();
        return Button;
    }
*/
    if((PadSettings.EnablePenUp == FALSE)
    || (Reentrant)) {
       return FALSE;
    }
    Reentrant = TRUE;


    Reentrant = FALSE;
    return SendAMouseEvent((0  | ((Shift & 3) << 4)), VirtualX, VirtualY);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall PadMouseDown(long Button, long Shift, long X, long Y)
{DLL_THREAD_MANAGEMENT();
GBOOL       Reentrant;
long        VirtualX  = X, VirtualY  = Y;
long        PreviousX = X, PreviousY = Y;

    if(PadWndHandle == 0){
	    return FALSE;
    }

    if((UseCacheMemory)
    && (CacheReady)
    && (CurrentPdaMode == MODE_EMAIL_OFFLINE)
    ){
       TranslateMousePos (&VirtualX, &VirtualY);
       return ProcessCacheEmailClick (VirtualX, VirtualY);
    }
#if USE_SIMULBOX
    if(UseSimul  &&  Palm.ShowSimulBox)  {
       if(Not Palm.SimulBeginMove) {
          if(Button == 1  && Palm.HitThumbNailRect(X , Y)) {
             SetCapture(PadWndHandle);
             Palm.SimulBeginMove  =  TRUE;
             return Button;
          }
       }
    }
#endif
    switch(Palm.MenuMode){
    case PDAMENUMODE_ONLINE:
         if(Reentrant) {
            return FALSE;
         }
         Reentrant = TRUE;
         TranslateMousePos (&VirtualX, &VirtualY);

         if(Y <= Palm.MenuHeight ) { // + Palm.KeybdOnScreen
            VirtualX = X;
            VirtualY = Y + (Palm.VirtualScreenHeight);

            if((Y < Palm.MenuHeight)) //IS IT IN MENU AREA
            {
               Reentrant = FALSE;
               return PadMenuMouse(Button, Shift, X, Y);

            // IS IT IN KEYBOARD AREA
            } else if(Y < Palm.MenuHeight ) { // + Palm.KeybdOnScreen
               if((Palm.ScreenWidth == 640) && (X > (Palm.ScreenWidth - Palm.KeyboardWidth))){
                  X -= (Palm.ScreenWidth - Palm.KeyboardWidth);
               }
               if( ProcessKeyboardEntry(X, Y)){
                  RefreshIPalm();
               }
               Reentrant = FALSE;
               return TRUE;
            }
         }
         break;

#ifdef  _PdaOS_H
    case PDAMENUMODE_DESKTOP:
         ProcessPdaMouse       (Button, Shift, X, Y);
         break;
#endif
    case PDAMENUMODE_DESKPIM:
         break;

#if USE_PAINTDRAW
    case PDAMENUMODE_PAINT:
         PdaPaintMouseDown     (Button, Shift, X, Y);
         break;
#endif
    }
    Reentrant = FALSE;
    return SendAMouseEvent     ((1 | ((Shift & 3) << 4)), VirtualX, VirtualY);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall KeyboardMouseUp(long Button, long Shift, long X, long Y)
{DLL_THREAD_MANAGEMENT();

static BOOL Reentrant;
long        VirtualX = X, VirtualY = Y;
BOOL        bRet = FALSE;

    if(PadWndHandle == 0){
	    return FALSE;
    }
    if(Reentrant) {
       return FALSE;
    }
    Reentrant = TRUE;

    VirtualX  = X;
    VirtualY  = Y + (Palm.MenuHeight);

    bRet      = ProcessKeyboardEntry(VirtualX, VirtualY);
    Reentrant = FALSE;
    return bRet;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
void  TranslateMousePos (long *MouseX, long *MouseY)
{DLL_THREAD_MANAGEMENT();

long VirtualX = 0, VirtualY = 0;

    if(*MouseY  <= Palm.MenuHeight) {// + Palm.KeybdOnScreen
       VirtualX  = *MouseX;
       VirtualY  = *MouseY + (Palm.VirtualScreenHeight);
    } else {
       VirtualX  = Palm.HScrollValue + *MouseX;
       VirtualY  = Palm.VScrollValue + (*MouseY - (Palm.MenuHeight));// + Palm.KeybdOnScreen
    }
    if(VirtualX  < 0){
       VirtualX  = 0;
    }
    if(VirtualY  < 0){
       VirtualY  = 0;
    }
    if(VirtualX >= Palm.MemoryScreenWidth){
       VirtualX  = Palm.MemoryScreenWidth - 1;
    }
    if(VirtualY >= Palm.MemoryScreenHeight){
       VirtualY  = Palm.MemoryScreenHeight - 1;
    }
    *MouseX      = VirtualX;
    *MouseY      = VirtualY;

}
///////////////////////////////////////////////////////////////////////////////////////////////////
long __stdcall GetCurrentColorIndex  (long MouseX, long MouseY)
{DLL_THREAD_MANAGEMENT();
    if((IsBadWritePtr(Palm.ScreenPointer, Palm.VScreenBufferSize) == FALSE)
    && ((DWORD)MouseX   < (DWORD)Palm.MemoryScreenWidth)
    && ((DWORD)MouseY   < (DWORD)Palm.MemoryScreenHeight)
    ){
       long CurrentPos  = MouseY; // (Palm.MemoryScreenHeight - MouseY);
       CurrentPos       = ((CurrentPos * Palm.MemoryScreenWidth) + MouseX);

       return Palm.ScreenPointer[CurrentPos];
    } else {
       return 0;
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall TranslateMousePoint (LPPOINT MousePoint)
{DLL_THREAD_MANAGEMENT();
     TranslateMousePos (&MousePoint->x, &MousePoint->y);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall GetPadScrollLimitt (long * HPadScrollMin, long * VPadScrollMin, long * HPadScrollMax, long * VPadScrollMax)
{DLL_THREAD_MANAGEMENT();

    if(HPadScrollMin) *HPadScrollMin = Palm.HScrollMin;
	if(VPadScrollMin) *VPadScrollMin = Palm.VScrollMin;

    if(HPadScrollMax) *HPadScrollMax = Palm.HScrollMax;
	if(VPadScrollMax) *VPadScrollMax = Palm.VScrollMax ;// + Palm.KeybdOnScreen
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall SetScreenPos (long HScrollPos, long VScrollPos)
{DLL_THREAD_MANAGEMENT();

long HPadScrollMin, VPadScrollMin, HPadScrollMax, VPadScrollMax;

    GetPadScrollLimitt  (&HPadScrollMin, &VPadScrollMin, &HPadScrollMax, &VPadScrollMax);
    HScrollPos        = MakeInRange(HScrollPos, HPadScrollMin, HPadScrollMax);
    VScrollPos        = MakeInRange(VScrollPos, VPadScrollMin, VPadScrollMax);

    // if(Palm.KeybdOnScreen)
    Palm.HScrollValue = HScrollPos;
	Palm.VScrollValue = VScrollPos;
	RefreshIPalm();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall GetScreenPos (long *HScrollPos, long *VScrollPos)
{DLL_THREAD_MANAGEMENT();

    // if(Palm.KeybdOnScreen){
    if(HScrollPos)*HScrollPos = Palm.HScrollValue;
	if(VScrollPos)*VScrollPos = Palm.VScrollValue;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
//
int       LastScrollDirection = 0;
DCTimeout LastScrollTimestamp;

///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall  IsRemoteScrollPermit(int Direction, BOOL Wait)
{DLL_THREAD_MANAGEMENT();
BOOL IsRemoteScrollPermitted                   = FALSE;

    if(LastScrollDirection                    == Direction){

       if((LastScrollTimestamp.StillInDelay() == FALSE)){
          IsRemoteScrollPermitted              = TRUE;
          LastScrollTimestamp.BeginDelay(250);
       } else
       if(Wait){
          LastScrollTimestamp.SleepTillEndDelay();
          IsRemoteScrollPermitted              = TRUE;
       }
    } else {
       IsRemoteScrollPermitted                 = TRUE;
       LastScrollDirection                     = Direction;
       LastScrollTimestamp.BeginDelay(250);
    }
    return IsRemoteScrollPermitted;
}
VOID __stdcall  ResetScrollDirection()
{DLL_THREAD_MANAGEMENT();
    LastScrollDirection            = 0;
    LastScrollTimestamp.EndDelay();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
VOID __stdcall ScreenScroll(int ParmDirection)
{DLL_THREAD_MANAGEMENT();
#ifndef __LINUX__ //TO DO
    switch(ParmDirection){
    case VK_PRIOR:
    case VK_NEXT:
    case VK_UP:
    case VK_DOWN:    VertiScreenScroll(ParmDirection);            break;

    case VK_LEFT:
    case VK_RIGHT:
    case VK_HOME:
    case VK_END:     HorziScreenScroll(ParmDirection);            break;
    }
#endif
}
///////////////////////////////////////////////////////////////////////////////////////////////////
VOID __stdcall VertiScreenScroll(int ParmDirection)
{DLL_THREAD_MANAGEMENT();
long HPadScrollPos, VPadScrollPos;
long HPadScrollMin, VPadScrollMin, HPadScrollMax, VPadScrollMax;

    GetScreenPos      (&HPadScrollPos, &VPadScrollPos);
    GetPadScrollLimitt(&HPadScrollMin, &VPadScrollMin, &HPadScrollMax, &VPadScrollMax);

    // WHEN VALUE IS BASED ON A SCROLLBAR:
    // VPadScrollPos               = VScroll1.Value;
    // WORKING BY DIRECTION:
#ifndef __LINUX__ //TO DO
    switch(ParmDirection){
    case VK_UP:     VPadScrollPos -= 8;   break;
    case VK_PRIOR:  VPadScrollPos -= 128; break;

    case VK_DOWN:   VPadScrollPos += 8;   break;
    case VK_NEXT:   VPadScrollPos += 128; break;
    default:        return;
    }
    if(VPadScrollPos            < VPadScrollMin){
       if(IsRemoteScrollPermit    (VK_UP, FALSE)){
          SendAScrollCommand      (0, -1, 0);
       }
       SetScreenPos               (HPadScrollPos, VPadScrollPos);
    } else if(VPadScrollPos     > VPadScrollMax){
       if(IsRemoteScrollPermit    (VK_DOWN, FALSE)){
          SendAScrollCommand      (0, 1, 0);
       }
       SetScreenPos               (HPadScrollPos, VPadScrollPos);
    } else {

       ResetScrollDirection();
       SetScreenPos               (HPadScrollPos, VPadScrollPos);
    }
#endif
}
///////////////////////////////////////////////////////////////////////////////////////////////////
VOID __stdcall HorziScreenScroll(int ParmDirection)
{DLL_THREAD_MANAGEMENT();
long HPadScrollPos, VPadScrollPos;
long HPadScrollMin, VPadScrollMin, HPadScrollMax, VPadScrollMax;

    GetScreenPos      (&HPadScrollPos, &VPadScrollPos);
    GetPadScrollLimitt(&HPadScrollMin, &VPadScrollMin, &HPadScrollMax, &VPadScrollMax);

    // WHEN VALUE IS BASED ON A SCROLLBAR:
    // VPadScrollPos               = HScroll1.Value;
    // WORKING BY DIRECTION:
#ifndef __LINUX__ //TO DO
    switch(ParmDirection){
    case VK_LEFT:   HPadScrollPos -= 32;   break;
    case VK_HOME:   HPadScrollPos -= 128;  break;

    case VK_RIGHT:  HPadScrollPos += 32;   break;
    case VK_END:    HPadScrollPos += 128;  break;
    default:        return;
    }
    if(HPadScrollPos            < HPadScrollMin){

       if(IsRemoteScrollPermit    (VK_LEFT, FALSE)){
          SendAScrollCommand      (-1, 0, 0);
       }
       SetScreenPos               (HPadScrollPos, VPadScrollPos);
    } else if(HPadScrollPos     > HPadScrollMax){

       if(IsRemoteScrollPermit    (VK_RIGHT, FALSE)){
          SendAScrollCommand      (1, 0, 0);
       }
       SetScreenPos               (HPadScrollPos, VPadScrollPos);
    } else {

       ResetScrollDirection();
       SetScreenPos               (HPadScrollPos, VPadScrollPos);
    }
#endif
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall ResetDisplaySize (long ScreenWidth, long ScreenHeight)
{DLL_THREAD_MANAGEMENT();

    if((ScreenWidth       > Palm.VirtualScreenWidth)){
       ScreenWidth        = Palm.VirtualScreenWidth;
    }
    if((ScreenHeight      > Palm.VirtualScreenHeight + Palm.MenuHeight) ){
       ScreenHeight       = Palm.VirtualScreenHeight + Palm.MenuHeight;
    }
    Palm.SimulWidth       = 640;
    Palm.SimulHeight      = PAL_SCREEN_HEIGHT;

    Palm.ScreenWidth      = ScreenWidth;
    Palm.ScreenHeight     = ScreenHeight;
	Pad.W                 = Palm.ScreenWidth;
	Pad.H                 = Palm.ScreenHeight;

	MemSrcX               = 0;
	                      // THE REST FROM FULLHEIGHT - HEIGHT OF A SCREEN WIDTHOUT THE MENU
    MemSrcY               = Palm.MemoryScreenHeight   - (Palm.ScreenHeight); // - Palm.MenuHeight

                          // THE SCROLLMAX MUST BE CALULATED WITH THE ENTIRE VIRTUALSCREEN HEIGHT
    Palm.VScrollMax       = (Palm.DebugMode ? ((Palm.MemoryScreenHeight - Palm.ScreenHeight)) : ((Palm.VirtualScreenHeight - Palm.ScreenHeight + Palm.MenuHeight ))); //

    Palm.HScrollMax       = (Palm.VirtualScreenWidth  - Palm.ScreenWidth);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
long __stdcall GetScreenWidth ()
{DLL_THREAD_MANAGEMENT();

    return Palm.ScreenWidth;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
long __stdcall GetScreenHeight ()
{DLL_THREAD_MANAGEMENT();

    return Palm.ScreenHeight;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
long __stdcall GetVirtualScreenWidth ()
{DLL_THREAD_MANAGEMENT();

    return Palm.VirtualScreenWidth;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
long __stdcall GetVirtualScreenHeight ()
{DLL_THREAD_MANAGEMENT();

    return Palm.VirtualScreenHeight;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall SetScreenWidth (long  ScreenWidth)
{DLL_THREAD_MANAGEMENT();

    Palm.ScreenWidth         = (ScreenWidth  &= ~15);
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall SetScreenHeight (long  ScreenHeight)
{DLL_THREAD_MANAGEMENT();

    Palm.ScreenHeight         = (ScreenHeight); //  &= ~15
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall SetVirtualScreenWidth (long  VirWidth)
{DLL_THREAD_MANAGEMENT();

    if(IsPortOpen()) {
       return FALSE;
    }
    Palm.VirtualScreenWidth         = (VirWidth  &= ~15);
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall SetVirtualScreenHeight (long  VirHeight)
{DLL_THREAD_MANAGEMENT();

    if(IsPortOpen()) {
       return FALSE;
    }
    Palm.VirtualScreenHeight         = (VirHeight); //  &= ~15
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall GetInitializedScreenMemory (long* ScreenWidth, long* ScreenHeight, long* VirWidth, long* VirHeight)
{DLL_THREAD_MANAGEMENT();

    if(ScreenWidth) { * ScreenWidth         = Palm.ScreenWidth;         }
    if(ScreenHeight){ * ScreenHeight        = Palm.ScreenHeight;        }
	if(VirWidth)    { * VirWidth            = Palm.VirtualScreenWidth;  }
	if(VirHeight)   { * VirHeight           = Palm.VirtualScreenHeight; }

    return IsPortOpen(); // Wheter it is changeable or not...
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall InitializeScreenMemory     (long  ScreenWidth, long  ScreenHeight, long  VirWidth, long  VirHeight)
{DLL_THREAD_MANAGEMENT();
long    MemNeeded;
CDC     ThisDC;
HDC     hDC;
HBITMAP hBmp;

    if(IsPortOpen()) {
       return ;
    }
    ReleaseScreenMemory ();

    MemNeeded = CalcScreen(ScreenWidth, ScreenHeight, VirWidth, VirHeight);

    if((MemNeeded <= 0) || (MemNeeded > (4 * MB))){
       return ;
    }
    CSingleLock AccessSingleLock(&CriticalScreenAccess);  AccessSingleLock.Lock();
    if(AccessSingleLock.IsLocked()){

#ifndef __LINUX__
       ReleaseScreenMemory ();
       if(MemNeeded > 0){
          // Palm.ScreenPointer = (PBYTE)GlobalAlloc(GMEM_FIXED, MemNeeded);

          InitBitmapHeader     ((LPBITMAPINFOHEADER)&Palm.m_ColorInfo, VirWidth, (VirHeight + Palm.ToolHeight), 100, 100, 8);
          Palm.m_ColorInfo.bmiHeader.biHeight = -(long)(Palm.m_ColorInfo.bmiHeader.biHeight);
	      ThisDC.CreateCompatibleDC(NULL);
	      hDC  = ThisDC.GetSafeHdc();
	      hBmp = CreateDIBSection(hDC, (PBITMAPINFO)&Palm.m_ColorInfo, DIB_RGB_COLORS, (PVOID*)(&Palm.m_ColorBuffer), NULL, 0);
	      if(hBmp){
		     Palm.m_ColorBmp.Attach(hBmp);
             Palm.ScreenPointer = Palm.m_ColorBuffer;
             InitPaint();
	      }
	      ThisDC.DeleteDC();
       }
#endif
       AccessSingleLock.Unlock();
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall ReleaseScreenMemory ()
{DLL_THREAD_MANAGEMENT();
    CSingleLock AccessSingleLock(&CriticalScreenAccess);  AccessSingleLock.Lock();
    if(AccessSingleLock.IsLocked()){
       if(Palm.ScreenPointer){

          Palm.KeyboardTable            =
          Palm.KeyboardDownloaded       =
          Palm.MenuDownloaded           = 0;
          Palm.InitSequenceComplete     = 0;
          Palm.KeyboardFullyFunctionnal = FALSE;
#ifndef __LINUX__ //TO DO
          if((HBITMAP)Palm.m_ColorBmp){
		      Palm.m_ColorBmp.DeleteObject();
		      Palm.m_ColorBuffer        = NULL;
	      }
 #endif
         // GlobalFree(Palm.ScreenPointer);
          Palm.ScreenPointer            = NULL;
       }
       AccessSingleLock.Unlock();
    }

}
///////////////////////////////////////////////////////////////////////////////////////////////////
BYTE __stdcall ConvertFrameCoordinateToFrameID (int   XFrame, int   YFrame){
BYTE  FrameID;

    FrameID      = (YFrame * TilesHorz) + XFrame + 1;

    return FrameID;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BYTE __stdcall ConvertPointToFrame (long PointX, long PointY){
int  XFrame,         YFrame;
BYTE FrameID       = 0;

    if((PointX    >= 0)
    && (PointY    >= 0)
    ){
       XFrame      = (PointX / TilesWidth);
       YFrame      = (PointY / TilesHeight);

       FrameID     = ConvertFrameCoordinateToFrameID (XFrame, YFrame);
    }
    return FrameID;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall PaintGrid (HDC OriginalHDC)
{
#if USE_PAINTGRID
    ///////////////////////////////////////////////////////////////////////////////////////////////
    if(ShowGrid){
       CDC         SrcDC;	SrcDC.Attach(OriginalHDC);
       {
          SrcDC.SetBkMode         (TRANSPARENT);
          {
             int     ThisFrame = 0;
             int     ColLooper, ColPos;  // X
             int     RowLooper, RowPos;  // Y
             CString OffLinText;
             // ===================================================================================
			 int  XStart      = -Palm.HScrollValue,
				  YStart      = -Palm.VScrollValue + Palm.MenuHeight;

             long SrcX        = (MemSrcX + Palm.HScrollValue),
                  SrcY        = (MemSrcY - Palm.VScrollValue);//  + Palm.KeybdOnScreen

             for(ColLooper    = 0; ColLooper  < TilesHorz;         ColLooper++){

                ColPos        = ColLooper     * TilesWidth;
                SrcDC.MoveTo   (ColPos,         Palm.MenuHeight);
                SrcDC.LineTo   (ColPos,         (Palm.VirtualScreenHeight) );

                for(RowLooper = 0; RowLooper  < TilesVert;         RowLooper++){

                   RowPos     =  RowLooper    * TilesHeight;
				   if(IsInRange(RowPos, Palm.VScrollValue, Palm.VScrollValue + Palm.ScreenHeight)){
				      ThisFrame  = ConvertPointToFrame (ColPos + 2, RowPos + 2);

				      SrcDC.MoveTo(0,                       RowPos + YStart);
				      SrcDC.LineTo(Palm.VirtualScreenWidth, RowPos + YStart);
                      OffLinText.Format(_T("%d"),  ThisFrame);
				      SrcDC.TextOut(ColPos + 2, RowPos + YStart + 2, OffLinText);

                      if(1) {
                         SrcDC.SetTextColor(RGB(255, 0, 0));
                         OffLinText.Format(_T("%d"),  Palm.RecvedFrameCounter[ThisFrame]);
				         SrcDC.TextOut(MakeInRange(ColPos + 2 + TilesWidth - 22, 0, Palm.ScreenWidth - 24),
                                       RowPos + YStart + 2 + TilesHeight - 22 ,
                                       OffLinText);
                         SrcDC.SetTextColor(0x00);
                      }
				   }
                }
             }
          }
          if(UseSimul && Palm.ShowSimulBox ) {
		     Palm.DrawSimulBox(SrcDC);
          }
          ////////////////////////////
          SrcDC.Detach(); // WE DETACH ANYWAY
       }
    }
#endif
}
#if 0 // PREVIOUS IMPLEMENT DC
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall PaintGrid ()
{
#if USE_PAINTGRID
    ///////////////////////////////////////////////////////////////////////////////////////////////
    if(ShowGrid){
       CDC         SrcDC;
       CBitmap*    DispBmp;
       HFONT       TheOldFont;

       SrcDC.CreateCompatibleDC  (NULL);

       DispBmp            = &Palm.m_ColorBmp;
	   CBitmap* SrcOldBmp = SrcDC   .SelectObject(DispBmp);
       SetDIBColorTable(SrcDC.m_hDC, 0, 256, ImageBmp.bmiColors);
       // SetDIBColorTable(SrcDC.m_hDC, 0, 256, Palm.m_ColorInfo.bmiColors);

       if(SrcOldBmp){
          TheOldFont             = GetPDAFont (SrcDC.GetSafeHdc());
          // SrcDC.SetTextColor   (0x00000000);
          // SrcDC.SetBkColor     (0xFFFFFFFF);
          SrcDC.SetBkMode         (TRANSPARENT);
          if(TheOldFont){
             int     ThisFrame = 0;
             // FOR  EACH FRAME COLUMNS
             int     ColLooper, ColPos;  // X
             // FOR  EACH FRAME ROWS
             int     RowLooper, RowPos;  // Y
             CString OffLinText;
             // ===================================================================================
             for(ColLooper    = 0; ColLooper  < TilesHorz;         ColLooper++){

                ColPos        = ColLooper     * TilesWidth;
                SrcDC.MoveTo   (ColPos,         0);
                SrcDC.LineTo   (ColPos,         (Palm.VirtualScreenHeight) );

                for(RowLooper = 0; RowLooper  < TilesVert;         RowLooper++){
                   RowPos     = (RowLooper    * TilesHeight);
                   ThisFrame  = ConvertPointToFrame (ColPos + 2, RowPos + 2);

                   SrcDC.MoveTo(0,                       RowPos);
                   SrcDC.LineTo(Palm.VirtualScreenWidth, RowPos);

                   OffLinText.Format(_T("%d"),  ThisFrame);
                   SrcDC.TextOut(ColPos + 2, RowPos + 2, OffLinText);
                }
             }
             ReleasePDAFont (SrcDC.GetSafeHdc(), TheOldFont);
          }
          SrcDC   .SelectObject(SrcOldBmp);
       }
    }
#endif
}
#endif // if 0 PREVIOUS IMPLEMENT...
///////////////////////////////////////////////////////////////////////////////////////////////////
DWORD ConvertImageTo3BitColor (PBYTE pDestBuffer, PBYTE pSourceBuffer, DWORD PacketSize)
{
DWORD  Looper,         ImageSize  = 0;
WORD   TempBuffer = 0, BitsOfData = 0;

	for ( Looper = 0; Looper < PacketSize; Looper++){

            TempBuffer   <<= BitsOfData;
            TempBuffer    += *pSourceBuffer;
            BitsOfData    += 8;
            pSourceBuffer ++;

        while (BitsOfData >= 3) {

            if(BitsOfData == 9) {
                TempBuffer <<= 2;
            }else if(BitsOfData == 10) {
                TempBuffer <<= 1;
            } else {
                TempBuffer <<= 3;
            }
            *pDestBuffer = HIBYTE (TempBuffer);
            TempBuffer &= 0xFF;
            BitsOfData -= 3;
            ImageSize   ++;
            pDestBuffer ++;
        }
	}
    return ImageSize;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
DWORD ConvertImageTo4BitColor (PBYTE pDestBuffer, PBYTE pSourceBuffer, DWORD PacketSize)
{
DWORD  Looper,         ImageSize  = 0;
WORD   TempBuffer = 0;

	for ( Looper = 0; Looper < PacketSize; Looper++){

        TempBuffer    += *pSourceBuffer;
        pSourceBuffer ++;

        TempBuffer <<= 4;
        *pDestBuffer = HIBYTE (TempBuffer);
        pDestBuffer ++;

        TempBuffer  &= 0xFF;

        TempBuffer <<= 4;
        *pDestBuffer = HIBYTE (TempBuffer);
        pDestBuffer ++;

        TempBuffer  &= 0xFF;
		ImageSize   += 2;
	}
    return ImageSize;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
DWORD  ConvertFontImageToColor (PBYTE pDestBuffer, PBYTE pSourceBuffer, DWORD PacketSize)
{
DWORD  Looper,         ImageSize  = 0;
WORD   TempBuffer = 0, BitsOfData = 0;

	for ( Looper = 0; Looper < PacketSize; Looper++){

            TempBuffer    += *pSourceBuffer;
            BitsOfData    += 8;
            pSourceBuffer ++;

        while (BitsOfData >= 1) {

            TempBuffer <<= 1;
            if(HIBYTE (TempBuffer) == 1 ) {
                *pDestBuffer = Palm.BlackPoint;
            } else {
                *pDestBuffer = Palm.WhitePoint;
            }
            TempBuffer &= 0xFF;
            BitsOfData -= 1;
            ImageSize   ++;
            pDestBuffer ++;
        }
	}
    return ImageSize;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
DWORD  ConvertMonoImageToColor (PBYTE pDestBuffer, PBYTE pSourceBuffer, DWORD PacketSize)
{
DWORD  Looper,         ImageSize  = 0;
WORD   TempBuffer = 0, BitsOfData = 0;

	for ( Looper = 0; Looper < PacketSize; Looper++){

            TempBuffer    += *pSourceBuffer;
            BitsOfData    += 8;
            pSourceBuffer ++;

        while (BitsOfData >= 1) {

            TempBuffer <<= 1;
            if(HIBYTE (TempBuffer) == 1 ) {
                *pDestBuffer = Palm.BlackPoint;
            } else {
                *pDestBuffer = Palm.WhitePoint;
            }
            TempBuffer &= 0xFF;
            BitsOfData -= 1;
            ImageSize   ++;
            pDestBuffer ++;
        }
	}
    return ImageSize;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL PalmScreenLayout::HitThumbNailRect(long X, long Y)
{
    if((X >= SimulLeft)
    && (X <= SimulLeft + ThumbNailRectSize)
    && (Y >= SimulTop  + MenuHeight)
    && (Y <= SimulTop  + MenuHeight + ThumbNailRectSize))
    {
        // RECORD RELATIVE POS
        ThumbnailMousePos.x = X - SimulLeft;
        ThumbnailMousePos.y = Y - SimulTop - MenuHeight;
        return TRUE;
    } else {
        return FALSE;
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void PalmScreenLayout::ResetReceivedFrameCounter()
{
    ZeroMemory(RecvedFrameCounter, sizeof(RecvedFrameCounter));
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void PalmScreenLayout::DrawSimulBox(CDC& SrcDC)
{
#if USE_SIMULBOX
HPEN   HMyPen, HOldPen;
int    RelativeTop    = SimulTop + MenuHeight;

    HMyPen  = CreatePen(PS_DASHDOT, ThumbNailPenWidth,  RGB(0, 0, 255));
    HOldPen = (HPEN) SelectObject(SrcDC, HMyPen);

    SrcDC.MoveTo   (SimulLeft,  RelativeTop);
    SrcDC.LineTo   (SimulLeft + SimulWidth, RelativeTop);
    SrcDC.LineTo   (SimulLeft + SimulWidth, RelativeTop + SimulHeight);
    SrcDC.LineTo   (SimulLeft,  RelativeTop + SimulHeight);
    SrcDC.LineTo   (SimulLeft,  RelativeTop);

    SrcDC.MoveTo   (SimulLeft + ThumbNailRectSize, RelativeTop);
    SrcDC.LineTo   (SimulLeft + ThumbNailRectSize, RelativeTop + ThumbNailRectSize);
    SrcDC.LineTo   (SimulLeft,  RelativeTop + ThumbNailRectSize);

    SelectObject(SrcDC, HOldPen);
    DeleteObject(HMyPen);
#endif
}
///////////////////////////////////////////////////////////////////////////////////////////////////

} // extern "C"
