// Header PaintScreen.h 
#ifndef __PAINTSCREEN_H_
#define __PAINTSCREEN_H_
///////////////////////////////////////////////////////////////////////////////////////////////////
// SCREEN LAYOUT
///////////////////////////////////////////////////////////////////////////////////////////////////
// LineNo
//0= 1648    ________________________________________________________________________________
//           | TOP OF THE VIRTUAL SCREEN                                                    |
//           |                                                                              |
//           |                                                                              |
//           |                                                                              |
//     =1432 | FIRST SCREEN SIZE = SCREEN HEIGHT - MENU HEIGHT                              |
//           |______________________________________________________________________________|
//           |                                                                              |
//           |                                                                              |
//           |                                                                              |
//           |                                                                              |
//           |                                                                              |
//           |                                                                              |
//           |                                                                              |
//           |                                                                              |
//           | BOTTOM OF THE VIRTUAL SCREEN                                                 |
//1296=      |_________________________________TOOL HEIGHT__________________________________|
//           | VIRTUAL MENU                                                                 |
//           |______________________________________________________________________________|
//           | TEMP KEYBOARD AREA                   |                                       |
//           |                                      |                                       |
//           |                                      |                                       |
//           |______________________________________|_______________________________________|
//           | KEYBOARD STD LO CASE                 | KEYBOARD STD UP CASE                  |
//           |                                      |                                       |
//           |                                      |                                       |
//           |______________________________________|_______________________________________|
//           | KEYBOARD LANG LO CASE                | KEYBOARD LANG UP CASE                 |
//           |                                      |                                       |
//           |                                      |                                       |
//           |______________________________________|_______________________________________|
//           | KEYBOARD DEF TABLE                                                           |
//           |______________________________________________________________________________|
//MEM HEIGHT | MEM FREE AREA                                                                |
//1648=    0 |______________________________________________________________________________|
//
//           In Windows DIB format everything must be handle upside down.   
//           Gosh! I hate the moreon who got that idea.
///////////////////////////////////////////////////////////////////////////////////////////////////
// LineNo    The real physical layout look like this:
//           ________________________________________________________________________________
//           | MEM FREE AREA                                                                |
//           |______________________________________________________________________________|
//           | KEYBOARD DEF TABLE                                                           |
//58         |______________________________________________________________________________|
//           |                                      |                                       |
//           |                                      |                                       |
//           | KEYBOARD LANG LO CASE                | KEYBOARD LANG UP CASE                 |
//148        |______________________________________|_______________________________________|
//           |                                      |                                       |
//           |                                      |                                       |
//           | KEYBOARD STD LO CASE                 | KEYBOARD STD UP CASE                  |
//238        |______________________________________|_______________________________________|
//           |                                      |                                       |
//           |                                      |                                       |
//           | TEMP KEYBOARD AREA                   |                                       |
//328        |______________________________________|_______________________________________|
//           | VIRTUAL MENU                                                                 |
//352        |_________________________________TOOL HEIGHT__________________________________|
//           | BOTTOM OF THE VIRTUAL SCREEN                                                 |
//           |                                                                              |
//           |                                                                              |
//           |                                                                              |
//           |                                                                              |
//           |                                                                              |
//           |                                                                              |
//           |                                                                              |
//1432       |______________________________________________________________________________|
//           | FIRST SCREEN SIZE = SCREEN HEIGHT - MENU HEIGHT                              |
//           |                                                                              |
//           |                                                                              |
//           |                                                                              |
//           | TOP OF THE VIRTUAL SCREEN                                                    |
//1648       |______________________________________________________________________________|
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
// DEFAULT VALUES
///////////////////////////////////////////////////////////////////////////////////////////////////
typedef enum  { FRAMEUNKNW       = 0,
                FRAMECLEAR       = 200, FRAMEMENU       = 255, FRAMEKEYBD    = 220, 
                FRAMEINIT        = 201, FRAMEPROCESSING = 202, FRAMEPALETTE  = 203,
                FRAMECACHE       = 204, FRAMEIMGOVERLAY = 205, FRAMETRANSFER = 199,
                FRAMEQUICKUPD    = 206, FRAMETASKLIST   = 207, FRAMETIMESYNC = 208,
                FRAMEIMAGEPACK   = 209, FRAMERESYNC     = 210

              } PalmFrameTool;

#define PALM_ADRESSBUTTON 144
#define PALM_GOBUTTON     168

#define WPALM_ADRESSBUTTON 200
#define WPALM_GOBUTTON     (WPALM_ADRESSBUTTON + 28)

#define PALM_KEY      220
#define PMENUKEYBOARD 244
#define PMENUDOWN     264
#define PMENUUP       282
#define PMENULEFT     300
#define PMENURIGHT    320

#define PMENUSENDTEXT     512
#define PMENUCANCELTEXT   576
#define PMENUOPENKEYBD    576


#define PAL_SCREEN_WIDTH  320
#define PAL_SCREEN_HEIGHT 240 // 208

#define PAL_MENU_HEIGHT   24
#define PAL_KEBD_HEIGHT   90
#define PAL_KEBD_WIDTH    320
#define PAL_TOOL_SIZE     398  // before 344  // MUST BE AT LEAST (2 * MenuHeight) + (2 * KeyboardHeight) + 16
                                              // BETTER (3 * MenuHeight) + (3 * KeyboardHeight) + 16

#define PAL_SCREEN_VIR_WIDTH  (PAL_SCREEN_WIDTH * 2)    // whole buffer width in bits
// whole buffer height including the keyboard, menu and all the other things
#define PAL_SCREEN_VIR_HEIGHT  976 // (((PAL_SCREEN_HEIGHT - PAL_MENU_HEIGHT) * 6) + PAL_TOOL_SIZE)
// the whole buffer size in bits
//define PAL_VIR_IMAGESIZE  ((PAL_SCREEN_VIR_WIDTH) / 8) * (PAL_SCREEN_VIR_HEIGHT + PAL_TOOL_SIZE)             
#define PAL_VIR_IMAGESIZE  PAL_SCREEN_VIR_WIDTH * (PAL_SCREEN_VIR_HEIGHT + PAL_TOOL_SIZE)

///////////////////////////////////////////////////////////////////////////////////////////////////
// Const PAL_MENU_HEIGHT       = 24
// Const PAL_KEBD_HEIGHT       = 90
//
// Const PAL_TOOL_SIZE         = 344 ' HEIGHT OF (KEYBOARD * 3) + MENUHEIGHT + 48 LINES\
//
// Const PAL_SCREEN_WIDTH      = 320
// Const PAL_SCREEN_HEIGHT     = 240
//
// Const PAL_SCREEN_VIR_WIDTH  = (PAL_SCREEN_WIDTH * 2)
// Const PAL_SCREEN_VIR_HEIGHT = (((PAL_SCREEN_HEIGHT - PAL_MENU_HEIGHT) * 6) + PAL_TOOL_SIZE)
//
// Const PAL_VIR_IMAGESIZE     = ((PAL_SCREEN_VIR_WIDTH) / 8) * PAL_SCREEN_VIR_HEIGHT
// the last line of the screen
// Const SCREEN_BASELINE       = (PAL_SCREEN_VIR_HEIGHT - (PAL_SCREEN_HEIGHT - PAL_MENU_HEIGHT))
//
// Const MEM_KEYBOARD = (PAL_SCREEN_VIR_HEIGHT - (PAL_TOOL_SIZE - PAL_MENU_HEIGHT - PAL_KEBD_HEIGHT))
//
// ImageMem(0 To ((PAL_SCREEN_VIR_WIDTH) / 8) - 1, _
//          0 To ((PAL_SCREEN_VIR_HEIGHT)) - 1) As Byte
///////////////////////////////////////////////////////////////////////////////////////////////////
class  PalmScreenLayout 
{
public:

    PalmScreenLayout         ();
    virtual ~PalmScreenLayout();

    CBitmap		  m_ColorBmp;	        
    BITMAPINFO256 m_ColorInfo;
    PBYTE         m_ColorBuffer;

    BOOL          DebugMode; 
    long          ScreenWidth;
    long          ScreenHeight;

    long          VirtualScreenWidth;
    long          VirtualScreenHeight;
    long          MemoryScreenWidth;
    long          MemoryScreenHeight;

    long          ToolHeight;
    long          MenuHeight;
    long          MenuMode;

    long          CurrentKeyboardX;
    long          CurrentKeyboardY;

    long          KeyboardHeight;
    long          KeyboardWidth;

    long          ToolTop;
    long          MenuTop;
    long          KeyboardTop;
    long          KeyboardTableTop;

    // SCREEN BUFFER POINTER PASSED FROM VB
    long          VScreenWidthInByte;
    long          VScreenBufferSize;

    PBYTE         ScreenPointer;
    int           VScrollValue, //TheMain.VScroll1.Value Current Screen location
                  HScrollValue; //TheMain.HScroll1.Value Current Screen location

    int           VScrollMax, 
                  HScrollMax; 

    int           VScrollMin, 
                  HScrollMin; 

    int           VScrollSmallChange, 
                  HScrollSmallChange; 

    long          CurrentColorIndex; // FOR MONO SCREEN MODE

    int           TransitPos;
    int           PageReadyPos;

    int           MarqueLen;

    // VAR HOLDER FOR MODIFIED SCREEN
    long          KeybdOnScreen;
    BOOL          AddressStatus;
    BOOL          TransitStatus;
    BOOL          PDAPageReady;
    long          KeybdOnSatus;
    long          MenuDownloaded;
    long          KeyboardTable;
    long          KeyboardDownloaded;
    BOOL          KeyboardFullyFunctionnal;

    BOOL          InitSequenceComplete;

    PixColor      WhitePoint;
    PixColor      BlackPoint;

    long          SimulLeft;
    long          SimulTop;
    long          SimulWidth;
    long          SimulHeight;

    long          ThumbNailRectSize;
    long          ThumbNailPenWidth;
    POINT         ThumbnailMousePos;
    
    BOOL          SimulBeginMove;
    BOOL          ShowSimulBox;

    #define       PALMFRAMEARRAYSIZE        (256)
    long          SavedFrameCounter         [PALMFRAMEARRAYSIZE];
    long          RecvedFrameCounter        [PALMFRAMEARRAYSIZE];

    BOOL          HitThumbNailRect          (long X, long Y);
    void          ResetReceivedFrameCounter ();
    void          DrawSimulBox              (CDC&    SrcDC);

};
extern PalmScreenLayout Palm;
extern HWND             PadWndHandle;
extern CString          KeyboardString;
extern BITMAPINFO256    ImageBmp;
extern int              CurrentPenX, CurrentPenY;

///////////////////////////////////////////////////////////////////////////////////////////////////
extern "C" {

///////////////////////////////////////////////////////////////////////////////////////////////////
// PROPERTYS
///////////////////////////////////////////////////////////////////////////////////////////////////
int  __stdcall GetScreenColor         ();
void __stdcall ChangeScreenColor      (long Index);

void __stdcall SetScreenPos           (long HScrollPos,  long VScrollPos);
void __stdcall GetScreenPos           (long *HScrollPos, long *VScrollPos);

///////////////////////////////////////////////////////////////////////////////////////////////////
long __stdcall GetScreenWidth             ();
long __stdcall GetScreenHeight            ();
long __stdcall GetVirtualScreenWidth      ();
long __stdcall GetVirtualScreenHeight     ();
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall SetScreenWidth             (long  ScreenWidth);
BOOL __stdcall SetScreenHeight            (long  ScreenHeight);
BOOL __stdcall SetVirtualScreenWidth      (long  VirWidth);
BOOL __stdcall SetVirtualScreenHeight     (long  VirHeight);
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall  IsRemoteScrollPermit      (int Direction, BOOL Wait);
VOID __stdcall  ResetScrollDirection      ();

VOID __stdcall ScreenScroll               (int ParmDirection);
VOID __stdcall VertiScreenScroll          (int ParmDirection);
VOID __stdcall HorziScreenScroll          (int ParmDirection);

///////////////////////////////////////////////////////////////////////////////////////////////////
// METHOD
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall GetInitializedScreenMemory (long* ScreenWidth, long* ScreenHeight, long* VirWidth, long* VirHeight);
void __stdcall InitializeScreenMemory     (long  ScreenWidth, long  ScreenHeight, long  VirWidth, long  VirHeight);
void __stdcall ReleaseScreenMemory        ();
void __stdcall PaintGrid                  (HDC OriginalHDC);

void __stdcall ResetDisplaySize       (long ScreenWidth, long ScreenHeight);

HWND __stdcall GetScreenWindow        ();
void __stdcall SetScreenWindow        (HWND  PadDeviceHandle);
void __stdcall GetPadScrollLimitt     (long * HPadScrollMin, long * VPadScrollMin, long * HPadScrollMax, long * VPadScrollMax);

BYTE __stdcall ConvertFrameCoordinateToFrameID (int  XFrame, int  YFrame);
BYTE __stdcall ConvertPointToFrame             (long PointX, long PointY);

///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall PadMouseDown           (long Button, long Shift, long X, long Y);
BOOL __stdcall PadMouseUp             (long Button, long Shift, long X, long Y);
BOOL __stdcall PadMouseMove           (long Button, long Shift, long X, long Y);
void           TranslateMousePos      (long *MouseX, long *MouseY);
void __stdcall TranslateMousePoint    (LPPOINT MousePoint);
long __stdcall GetCurrentColorIndex   (long MouseX, long MouseY);
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall MemRectCopyData        (long NewX, long NewY, long X, long Y, long W, long H);
void __stdcall MemRectCopyMono        (long NewX, long NewY, long X, long Y, long W, long H);
void __stdcall ClearRectData          (long X, long Y, long W, long H, long StepLine);
void __stdcall FillRectData           (long X, long Y, long W, long H, BYTE FillLow, BYTE FillHigh);
void __stdcall PaintRectData          (long X, long Y, long W, long H, PBYTE TheData, long StepLine, BYTE InitialPhase);
void __stdcall DisplayString          (long DstX, long DstY, LPCSTR StringOut, long ThisStrLen);

///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall ClearPadMem            ();
void           ClearPadScreen         ();
void           RefreshIPalm           ();
BOOL __stdcall RepaintIPalm           ();
BOOL __stdcall PaintPalmScreen        (HDC  PadHdcHandle);

BOOL __stdcall CopyPalmToClipboard    ();

void __stdcall RefreshIKeyboardPalm   ();
HWND __stdcall GetKeyboardWindow      ();
void __stdcall SetKeyboardWindow      (HWND KeyboardDeviceHandle);
BOOL __stdcall PaintPalmKeyboardScreen(HWND WinHandle, HDC  PadHdcHandle);
BOOL __stdcall KeyboardMouseUp        (long Button, long Shift, long X, long Y);

#if USE_KEYBOARD
BOOL __stdcall GetStringQueue         (LPTSTR  theString, short ThisStrLen);
BOOL __stdcall SetStringQueue         (LPCTSTR theString);
BOOL __stdcall AddStringQueue         (LPCTSTR theString);
BOOL __stdcall AddCharQueue           (TCHAR   theChar);
BOOL __stdcall AddCtrlQueue           (char theChar);

BOOL __stdcall GetKeyBoardStatus      (LPBOOL ShiftStatus, LPBOOL CapStatus, LPBOOL CtrlStatus, LPBOOL IntlStatus);
BOOL __stdcall SetKeyBoardStatus      (BOOL   ShiftStatus, BOOL   CapStatus, BOOL   CtrlStatus, BOOL   IntlStatus);
BOOL __stdcall ProcessKeyboardEntry   (long x, long y);
void __stdcall ToggleKeyboard         ();
void __stdcall OpenKeyboard           ();
void __stdcall ProcessKeyboardIdle    ();

void __stdcall SendKeyboardString     ();
void __stdcall SelectKeyboard         ();
void __stdcall ShowKeyboard           (long Which);
void __stdcall SetupKeyboard          (long Which);

void __stdcall ClearKeyboard          ();

#else 

#define GetStringQueue(S, L)          FALSE
#define SetStringQueue(S)             FALSE
#define AddStringQueue(S)             FALSE
#define AddCharQueue(C)               FALSE
#define AddCtrlQueue(C)               FALSE

#define GetKeyBoardStatus(S,C,CTR,INTL) FALSE
#define SetKeyBoardStatus(S,C,CTR,INTL) FALSE
#define ProcessKeyboardEntry(X, Y)    FALSE

#define ToggleKeyboard()
#define OpenKeyboard()
#define ProcessKeyboardIdle()

#define SendKeyboardString()
#define SelectKeyboard()
#define ShowKeyboard(W)
#define SetupKeyboard(W)
#define ClearKeyboard()

#endif

///////////////////////////////////////////////////////////////////////////////////////////////////
#define PADKEY_ESC              27 // VK_ESCAPE
#define PADKEY_CANCEL           03 // VK_CANCEL
#define PADKEY_BACKSPACE         8 // VK_BACK
#define PADKEY_TAB               9 // VK_TAB
#define PADKEY_RETURN           13 // VK_RETURN

#define PADKEY_DELETE           14 // USUALLY NOT USE 
#define PADKEY_SHIFTTAB         15 // USUALLY NOT USE 

#define PADKEY_RIGHTARROW       28 // VK_CONVERT
#define PADKEY_LEFTARROW        29 // VK_NONCONVERT
#define PADKEY_UPARROW          30 // VK_ACCEPT
#define PADKEY_DOWNARROW        31 // VK_MODECHANGE

#define PADKEY_SHIFT            16 // VK_SHIFT
#define PADKEY_CTRL             17 // VK_CONTROL
#define PADKEY_ACCENT           18 // VK_MENU
#define PADKEY_PAUSE            19 // VK_PAUSE
#define PADKEY_CAPSLOCK         20 // VK_CAPITAL

///////////////////////////////////////////////////////////////////////////////////////////////////
// INTERNALS AND FRIENDS


typedef enum  {PDAMENU640_PAINTDESKTOP = 0,
               PDAMENU640_PAINTSAVE    = 32,   PDAMENU640_PAINTARROW   = 60,  PDAMENU640_PAINTPEN     = 88,      
               PDAMENU640_PAINTERASER  = 116,  PDAMENU640_PAINTLINE    = 144, PDAMENU640_PAINTRECT    = 172, 
               PDAMENU640_PAINTELLIPSE = 200,  PDAMENU640_PAINTTEXT    = 228, PDAMENU640_PAINTSETTING = 256,  
               PDAMENU640_SELECT       = 284,  PDAMENU640_PAINTLAST    = 312 
              } PdaMenu640Button;

typedef enum {PDAMENUMODE_ONLINE       = 0,
              PDAMENUMODE_DESKTOP      = 1,
              PDAMENUMODE_DESKPIM      = 2,
              PDAMENUMODE_PAINT        = 4,
              PDAMENUMODE_CUSTOMAPP    = -1
              } PdaMenuMode; 

} // extern "C"    
///////////////////////////////////////////////////////////////////////////////////////////////////
#endif //__PAINTSCREEN_H_
