// PdaGDI.h: interface for the PdaGDI class.
///////////////////////////////////////////////////////////////////////////////////////////////////
#if !defined(AFX_PDAGDI_H__6192CF3D_F7FC_4134_BECB_F0B7A5811E85__INCLUDED_)
#define AFX_PDAGDI_H__6192CF3D_F7FC_4134_BECB_F0B7A5811E85__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
///////////////////////////////////////////////////////////////////////////////////////////////////
#define IMAGETEMP_BUFFERSIZE (1 * MB)
///////////////////////////////////////////////////////////////////////////////////////////////////
// PDA DESKTOP SUPPORT
///////////////////////////////////////////////////////////////////////////////////////////////////
#define MAXDLGTEMPLATE       (16 * KB)
#define MAXMENUTEMPLATE       (4 * KB)
#define POPMENUBUFFERSIZE     1024

extern ROMBYTE                 PDAFONT          [];
extern ROMBYTE                 PDASYMBOL        [];
extern ROMBYTE                 IDD_DIALOG       [];
extern ROMBYTE                 IDR_DESKMENU     [];
extern ROMBYTE                 BITMAP_PAINTMENU [];
extern ROMBYTE                 IDR_PDAMENU      [];
extern ROMBYTE                 IDD_APPDLG       [];
extern ROMBYTE                 IDD_CALC         [];

///////////////////////////////////////////////////////////////////////////////////////////////////
#pragma pack(push, 1)
///////////////////////////////////////////////////////////////////////////////////////////////////
typedef struct {
    BYTE MajorVersion;
    BYTE ResType;
    BYTE Unused;
    BYTE Compression;
    WORD SizeOfBlock;
    WORD SizeUncompress;
} PdaMemRes, *PPdaMemRes;
///////////////////////////////////////////////////////////////////////////////////////////////////

#define DEFDLGCAPTIONHEIGHT   20

///////////////////////////////////////////////////////////////////////////////////////////////////
#define PDASTYLE_POPED      0x01
#define PDASTYLE_PRESSED    0x02
#define PDASTYLE_SELECTED   0x04
#define PDASTYLE_BORDER     0x08
///////////////////////////////////////////////////////////////////////////////////////////////////

// ************************************************************************************
typedef struct _PdaSize {
    short      cx;
    short      cy;
} PdaSize, * PPdaSize;
typedef struct _PdaBox {
    short      x;
    short      y;
    short      W;
    short      h;
} PdaBox, * PPdaBox;
typedef struct _PdaRect {
    long      left;
    long      top;
    long      right;
    long      bottom;
} PdaRect, * PPdaRect;
///////////////////////////////////////////////////////////////////////////////////////////////////
typedef BYTE  PixColor, * PPixColor;  // FORMAT TO HOLD A SINGLE PIXSEL COLOR...
///////////////////////////////////////////////////////////////////////////////////////////////////
extern PixColor    BlackBrushBlck             [( 8 *  8)];
extern PixColor    WhiteBrushBlck             [( 8 *  8)];
extern PixColor    GreyBrushBlck              [( 8 *  8)];
extern PixColor    LightGreyBrushBlck         [( 8 *  8)];

#define MINFONTCHAR            0
#define MAXFONTCHAR          255

///////////////////////////////////////////////////////////////////////////////////////////////////
typedef enum _DefFontSize {
    DefFontWidth        = 8,
    DefFontHeight       = 16,
    DefaultBaseLine     = 13
} _DefFontSize;
typedef enum _PDAFONTMODE {
    PDAFONT_OPAQUE      = 0,
    PDAFONT_TRANSPARENT = 1,

} PDAFONTMODE;
///////////////////////////////////////////////////////////////////////////////////////////////////
typedef enum _PDA_ROP_Mode {

    ROP_COPY            = 0,

    ROP_MASKSRC         = 1,
    ROP_MASKDST         = 2,

    ROP_XORSRC          = 11,
    ROP_XORDST          = 12,

    ROP_ORSRC           = 21,
    ROP_ORDST           = 22,

    ROP_ANDSRC          = 31,
    ROP_ANDDST          = 32,

    ROP_EXCSRC          = 41,
    ROP_EXCDST          = 42

} PDA_ROP_Mode; 
enum {
    WhitePoint                 =  1,
    BlackPoint                 =  0,

    DarkRedPoint               = 12,
    LightRedPoint              =  6,
    DarkBluePoint              =  2,
    LightBluePoint             =  8,
    DarkGreenPoint             = 11,
    LightGreenPoint            =  5,

    DarkYellowPoint            = 13,
    LightYellowPoint           =  7,
    DarkCyanPoint              = 10,
    LightCyanPoint             =  4,
    DarkPurplePoint            =  9,
    LightPurplePoint           =  3,

    LightGreyPoint             = 14,
    DarkGreyPoint              = 15 
};
///////////////////////////////////////////////////////////////////////////////////////////////////
#define BOTTOM_RIGHT_QUADRANT 0
#define BOTTOM_LEFT_QUADRANT  1
#define TOP_RIGHT_QUADRANT    2
#define TOP_LEFT_QUADRANT     3
///////////////////////////////////////////////////////////////////////////////////////////////////
// BITMAP SUPPORT STRUCT
///////////////////////////////////////////////////////////////////////////////////////////////////
typedef struct _PdaBitmapRes {
    WORD       Width, Height;
    BYTE       BitPerPixel;
    BYTE       Compression;
    WORD       BlockSize;

} PdaBitmapRes, *PPdaBitmapRes;

///////////////////////////////////////////////////////////////////////////////////////////////////
#define IsPointInsideVirtualMemScreen(ThePoint) ((((WORD)(ThePoint->x) >= Palm.MemoryScreenWidth)  || ((WORD)(ThePoint->y) >= Palm.MemoryScreenHeight) )  ? FALSE : TRUE)
#define IsPointInsideVirtualScreen(ThePoint)    ((((WORD)(ThePoint->x) >= Palm.VirtualScreenWidth) || ((WORD)(ThePoint->y) >= Palm.VirtualScreenHeight) ) ? FALSE : TRUE)

#define ScreenToVirtual(X,Y)           (Y           >= Palm.MenuHeight ? (Y           -= Palm.MenuHeight) : Y           +=  Palm.VirtualScreenHeight)
#define ScreenPointToVirtual(ThePoint) (ThePoint->y >= Palm.MenuHeight ? (ThePoint->y -= Palm.MenuHeight) : ThePoint->y +=  Palm.VirtualScreenHeight)


///////////////////////////////////////////////////////////////////////////////////////////////////
// LOW LEVEL
///////////////////////////////////////////////////////////////////////////////////////////////////
void         __stdcall InvertPdaMonoRect                      (PPdaRect TheRect);

///////////////////////////////////////////////////////////////////////////////////////////////////
// MODAL PROPERTYS
///////////////////////////////////////////////////////////////////////////////////////////////////
PixColor     __stdcall GetFontBackColor                       ();
PixColor     __stdcall SetFontBackColor                       (PixColor NewColor);

int          __stdcall GetFontBackMode                        ();
int          __stdcall SetFontBackMode                        (int NewValue);

PixColor     __stdcall GetFontForeColor                       ();
PixColor     __stdcall SetFontForeColor                       (PixColor NewColor);

void         __stdcall GetFontSize                            (PPdaSize TheSize);
BOOL         __stdcall SetFontSize                            (PPdaSize TheSize);
int          __stdcall GetFontBaseLine                        ();
int          __stdcall SetFontBaseLine                        (int NewValue);


PixColor     __stdcall GetPaintBackColor                      ();
PixColor     __stdcall SetPaintBackColor                      (PixColor NewColor);
PixColor     __stdcall GetPaintForeColor                      ();
PixColor     __stdcall SetPaintForeColor                      (PixColor NewColor);

int          __stdcall GetMaskMode                            ();
int          __stdcall SetMaskMode                            (int  NewMode);
PixColor     __stdcall GetMaskColor                           ();
PixColor     __stdcall SetMaskColor                           (PixColor NewColor);

void         __stdcall GetPenSize                             (PPdaSize TheSize);
BOOL         __stdcall SetPenSize                             (PPdaSize TheSize);
PixColor     __stdcall GetPenColor                            ();
PixColor     __stdcall SetPenColor                            (PixColor NewColor);

BOOL         __stdcall GetFillMode                            ();
BOOL         __stdcall SetFillMode                            (BOOL NewMode);
void         __stdcall GetBrushSize                           (LPSIZE TheSize);
BOOL         __stdcall SetBrushSize                           (LPSIZE TheSize);
PPixColor    __stdcall GetBrushColor                          ();
PPixColor    __stdcall SetBrushColor                          (PPixColor NewColor);

///////////////////////////////////////////////////////////////////////////////////////////////////
int          __stdcall GetItalicSlant                         ();
int          __stdcall SetItalicSlant                         (int NewValue);

int          __stdcall GetStyleOption                         ();
int          __stdcall UnsetStyleOption                       (int NewMode);
int          __stdcall SetStyleOption                         (int NewMode);

int          __stdcall GetStrikeThroughMode                   (int NewMode);
int          __stdcall SetStrikeThroughMode                   (int NewMode);

int          __stdcall GetUnderLineMode                       ();
int          __stdcall SetUnderLineMode                       (int NewMode);
PixColor     __stdcall GetUnderLineColor                      ();
PixColor     __stdcall SetUnderLineColor                      (PixColor NewColor);
int          __stdcall GetUnderLineDotInterval                (int NewValue);

int          __stdcall SetTabStep                             (int NewValue);

///////////////////////////////////////////////////////////////////////////////////////////////////
int          __stdcall GetBorderRoundness                     ();
int          __stdcall SetBorderRoundness                     (int NewValue);

void         __stdcall ResetClipRect                          ();
void         __stdcall GetClipRect                            (PPdaRect TheRect);
BOOL         __stdcall SetClipRect                            (PPdaRect TheRect);
BOOL         __stdcall AddClipRect                            (PPdaRect TheRect);

///////////////////////////////////////////////////////////////////////////////////////////////////
// METHOD
///////////////////////////////////////////////////////////////////////////////////////////////////
void         __stdcall ColorFillRect                          (PPdaRect TheRect, PixColor ThisColor);
void         __stdcall BrushFill                              (int StartX, int StartY, int DeltaX, int DeltaY);
void         __stdcall BrushFillRect                          (PPdaRect TheRect);

void         __stdcall PaintLine                              (int X1, int Y1, int X2, int Y2);
void         __stdcall PaintThickLine                         (int X1, int Y1, int X2, int Y2);
BOOL         __stdcall PaintRoundRectangle                    (PPdaRect TheRect);
BOOL         __stdcall PaintRectangle                         (PPdaRect TheRect);
BOOL         __stdcall Paint3DRectangle                       (PPdaRect TheRect, BYTE Style);
void         __stdcall PaintCircle                            (PPdaRect TheRect);
BOOL         __stdcall PaintEllipse                           (PPdaRect TheRect);
BOOL         __stdcall PaintArc                               (PPdaRect TheRect, int Quadrant);
BOOL         __stdcall PaintPie                               (PPdaRect TheRect, int Quadrant);

BOOL         __stdcall PaintStringLine                        (long X, long Y, LPCSTR TheTextLine, int ThisStrLen);
void         __stdcall SetPenPixel                            (long CurrX, long CurrY);

///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL         __stdcall PdaDrawText                            (LPCSTR TheString, int StrLen, PPdaRect TheRect, int Options);
BOOL         __stdcall PdaLoadBitmap                          (long X, long Y, LPROMBYTE ImageData);
BOOL         __stdcall PaintPdaSymbol                         (PPdaRect  TheRect, BYTE ThisSymbol, BYTE SymbolLen, BYTE Style);

///////////////////////////////////////////////////////////////////////////////////////////////////
// PDA RECT SUPPORT
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL         __stdcall ClipPdaRectangle                       (int *StartX, int *StartY, int *DeltaX, int *DeltaY, PPdaRect ThisClipRect);
BOOL         __stdcall IsIntersectPdaRect                     (PPdaRect ThisRect, PPdaRect ThatRect);
void         __stdcall NormalizePdaRect                       (PPdaRect ThisRect);
BOOL         __stdcall ClipPdaRect                            (PPdaRect ThisRect, PPdaRect ThisClipRect);
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static BOOL IsEmptyPdaRect (PPdaRect ThisRect)
{
    if((ThisRect->left  == ThisRect->right)
    || (ThisRect->top   == ThisRect->bottom)){
       return TRUE;
    }
    return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static BOOL IsAbNormalPdaRect (PPdaRect ThisRect)
{
    if((ThisRect->right  <= ThisRect->left)
    || (ThisRect->bottom <= ThisRect->top)){
       return TRUE;
    }
    return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static BOOL IsNormalPdaRect (PPdaRect ThisRect)
{
    if((ThisRect->left  >= ThisRect->right)
    || (ThisRect->top   >= ThisRect->bottom)){
       return FALSE;
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static void MovePdaRect (PPdaRect ThisRect, int X, int Y)
{
    ThisRect->left       += X;
    ThisRect->right      += X;
	ThisRect->top        += Y;
	ThisRect->bottom     += Y;
} 
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static BOOL IsNullPdaRect(PPdaRect ThisRect)
{
    if((ThisRect->left  == ThisRect->right)
    && (ThisRect->top   == ThisRect->bottom)){
       return TRUE;
    }
    return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
class PdaGDI  
{
public:
	void Init ()
    {
    PdaRect  EmptyRect       = {0,0,0,0};
    // DC PdaRect  ScreenClipRect  = {0,0,Palm.VirtualScreenWidth - 1, Palm.MemoryScreenHeight - 1};
       
       CBLen                          = sizeof(PdaGDI);

       Copy                           = 0;
       PenMode                        = 0; 

       ResetContext ();

        // SURFACE...
        SurfacePtr                    = 0; // Palm.ScreenPointer;
        SurfaceWidth                  = 0; // Palm.VirtualScreenWidth;
        SurfaceHeight                 = 0; // Palm.MemoryScreenHeight;
        SurfaceWidthInByte            = 0; // Palm.VScreenWidthInByte;
        SurfaceMemLen                 = 0; // Palm.VScreenBufferSize;

        ClipRectangle                 = EmptyRect;
        ClipAddrRectangle             = EmptyRect;
        // SetClipRect                     (&ScreenClipRect);

        FillMemory (BlackBrushBlck,     sizeof(BlackBrushBlck),     BlackPoint);
        FillMemory (WhiteBrushBlck,     sizeof(WhiteBrushBlck),     WhitePoint);
        FillMemory (GreyBrushBlck,      sizeof(GreyBrushBlck),      DarkGreyPoint);
        FillMemory (LightGreyBrushBlck, sizeof(LightGreyBrushBlck), LightGreyPoint);
    }
	void ResetContext ()
    {
    PdaRect  EmptyRect       = {0,0,0,0};
    PdaSize  EmptySize       = {0,0};
    PdaSize  Sqare0          = {0,0};
    PdaSize  Sqare1          = {1,1};
    PdaSize  Sqare2          = {2,2};
    PdaSize  Sqare3          = {3,3};
    PdaSize  Sqare4          = {4,4};
    PdaSize  Sqare8          = {8,8};
    PdaSize  Sqare16         = {16,16};
    PdaSize  Sqare32         = {32,32};
    PdaSize  DefaultFontSize = { DefFontWidth, DefFontHeight};

        ScreenBackColor            = WhitePoint;

        MenuFontBackColor          = WhitePoint;
        MenuFontForeColor          = BlackPoint;

        ItalicSlant                = 0; //DEFAULT 16 WHEN APPLYED
        CurrTabStep                = 4;
        CurrentStyleOption         = (DT_RIGHT | DT_BOTTOM | DT_WORDBREAK);
        CurrentUnderLineMode       = 
        CurrentStrikeThroughMode   = FALSE;
        UnderLineColor             = DarkRedPoint;
        UnderLineDotInterval       = 1;
        CurrentFontForeColor       = BlackPoint;
        CurrentFontBackColor       = WhitePoint;
        CurrentFontBackMode        = PDAFONT_OPAQUE;

        CurrentPaintForeColor      = BlackPoint;
        CurrentPaintBackColor      = WhitePoint;
        CurrentFontSize            = DefaultFontSize;
        CurrentFontBaseLine        = DefaultBaseLine;

        CurrentFillMode            = TRUE;
        CurrentBrushColor          = GreyBrushBlck;
        CurrentBrushSize           = Sqare8; // DEFAULT: Square8 
        CurrentBrushfactor         = 3;      // DEFAULT: 3

        CurrentPenColor            = CurrentPaintForeColor;
        CurrentPenSize             = Sqare1; // DEFAULT: Square1
        CurrentPenfactor           = 0;      // DEFAULT: 0
        CurrentBorderRoundness     = 12;     // DEFAULT: 12

        CurrentMaskMode            = ROP_COPY;
        CurrentMaskColor           = LightPurplePoint;

        StdCaptionHeight           = DEFDLGCAPTIONHEIGHT;
        StdCaptionBrushColor       = GreyBrushBlck;
        StdDlgBackBrushColor       = LightGreyBrushBlck;
        StdCaptionFontColor        = BlackPoint;

        CurrentFont                = PDAFONT;
        Current3DMode              = TRUE;
        // TO DO: ADD EXCLUDERECTLIST
    }
    PdaGDI()
    {
       Init();
    }
	virtual ~PdaGDI()
    {
    }
    int         CBLen;
    int         Copy;

    int         PenMode;

    // SURFACE...
    PBYTE       SurfacePtr;
    long        SurfaceWidth;
    long        SurfaceHeight;
    long        SurfaceWidthInByte;
    long        SurfaceMemLen;

    PixColor    ScreenBackColor;

    PixColor    MenuFontForeColor;
    PixColor    MenuFontBackColor;

    int         StdCaptionHeight;
    PPixColor   StdCaptionBrushColor;
    PPixColor   StdDlgBackBrushColor;
    PixColor    StdCaptionFontColor;

    PixColor    CurrentFontForeColor;
    PixColor    CurrentFontBackColor;
    int         CurrentFontBackMode;
    PdaSize     CurrentFontSize;
    int         CurrentFontBaseLine;
    int         CurrTabStep;
    int         ItalicSlant;
    int         CurrentStyleOption;
    PixColor    UnderLineColor;
    int         UnderLineDotInterval;
    int         CurrentUnderLineMode,
                CurrentStrikeThroughMode;

    PixColor    CurrentPaintForeColor;
    PixColor    CurrentPaintBackColor;
    
    PixColor    CurrentPenColor;
    PdaSize     CurrentPenSize;
    int         CurrentPenfactor;
    int         CurrentBorderRoundness;
    
    BOOL        CurrentFillMode;
    PPixColor   CurrentBrushColor;
    PdaSize     CurrentBrushSize;
    int         CurrentBrushfactor;

    BOOL        CurrentMaskMode;
    PixColor    CurrentMaskColor;

    PdaRect     ClipRectangle;
    PdaRect     ClipAddrRectangle;

    LPROMBYTE   CurrentFont;
    BOOL        Current3DMode;

    BOOL (__stdcall *DrawFunction) (PPdaRect, PPdaRect);
};
Byte      InitPdaScreen            (PByte ScreenPtr,       UShort ScreenWidth,     UShort ScreenHeight, 
                                    UShort  VirScreenWidth , UShort VirScreenHeight, Byte MenuHeight);

///////////////////////////////////////////////////////////////////////////////////////////////////
extern PdaGDI                    ThePdaGDISnapShot;
extern PdaGDI                    ThePdaGDI;
///////////////////////////////////////////////////////////////////////////////////////////////////
// NOTE ADD DEVICE CONTEXT ASAP...
/*
LPPDACONTEXT __stdcall CreatePdaContext                       ();
void         __stdcall DestroyPdaContext                      (LPPDACONTEXT PdaContext);

LPPDACONTEXT __stdcall GetCurrentPdaContext                   ();
BOOL         __stdcall SetCurrentPdaContext                   (LPPDACONTEXT PdaContext);

// AND SO IT BEGINS...
*/
// FLIPFLOP SUPPORT
void         __stdcall SaveCurrentPdaContext                  ();
void         __stdcall RestoreCurrentPdaContext               ();

void         __stdcall SaveLocalCurrentPdaContext             (PdaGDI * ThisPdaGDISnapShot);
void         __stdcall RestoreLocalCurrentPdaContext          (PdaGDI * ThisPdaGDISnapShot);

///////////////////////////////////////////////////////////////////////////////////////////////////
#pragma pack(pop)


///////////////////////////////////////////////////////////////////////////////////////////////////
#endif // !defined(AFX_PDAGDI_H__6192CF3D_F7FC_4134_BECB_F0B7A5811E85__INCLUDED_)


