//PdaUnzip.cpp
///////////////////////////////////////////////////////////////////////////////////////////////////
#include "DevUnzip.h"

#ifdef _DEBUG
#undef THIS_FILE
static Char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef __cplusplus
extern "C" {
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////
Int             PaintPDAScreen           (PByte Buffer, UInt BufLen);
Int             ProcessUnzipData         (PByte Buffer, UInt BufLen);
///////////////////////////////////////////////////////////////////////////////////////////////////
Int             CheckMemorys             (void);
///////////////////////////////////////////////////////////////////////////////////////////////////
Byte   volatile SramCounter;
UShort volatile TotalDataLen;

Byte            XorCheck;

Byte            Z_Current_Error_Num;
Byte            Z_Current_RetCode;
Byte            Z_Current_FastCode;

PByte           InQueuePtr;
PByte           InQueueStart;
PByte           InQueueEnd;

PByte           StoragePtr;  // 

UShort          InQueueSize;
UShort          BytesToRead;

Byte            Step_Line;
Byte            Initial_Phase;
Byte            CommandType;
Byte            UseTransparency;

Byte            PixDone;
Byte            BitPerPixel;
Byte            BitsOfDataLeft;  
UShort          TempPixBuffer;
UShort          Temp3BitBuffer;

UShort          FrameLineHeight;
UShort          FrameWidthInPix;
UShort          FrameWidthInWord;
UShort          MemWidthInWords;

UShort          XPos;
UShort          YPos;
ULong           CurMemPosX;
ULong           CurMemPosY;

Byte InputBuffer   [MAX_MEM_BUF],
     OutputBuffer  [MAX_MEM_BUF],
     DisplayBuffer [MAX_MEM_BUF]; 

///////////////////////////////////////////////////////////////////////////////////////////////////
#if (ATMEL_PLATFORM == 1)
#include <ProgMem.h>

   Byte 		   LUT[256] = { };
   ULong           PdaFrameMemory;
   ULong           PdaScreenMemory;
   ULong           DestAddr;
   UShort          DataVal;
   Byte            DataLen; 
   UShort          SrcAddr;

   //register unsigned Char  SRAMCounter   asm("r10");
   
   void _WriteVideoMem (void);
   void _WriteVideoLine (void);
   
   Int ProgMemCompare (PByte SRam, PByte RomMem, UInt len)
   {
       UInt j;

       if(len == 0){
          return 0;
       }
       for(j = 0; j < len; j++) {
           Byte RomByte;
           RomByte     = PRG_RDB(&RomMem[j]);
           if(RomByte != SRam[j]){
             return 2 * (RomByte > SRam[j])-1;
           }
       }
       return 0;
   }
   void CopyProgMemToSRam (PByte Dest, PByte Source, UInt ByteLen)
   {
       UInt ByteCount = ByteLen;

       while (ByteCount--)
       {
          *Dest++ = PRG_RDB(Source++);
       }
   }
   ///////////////////////////////////////////////////////////////////////////////////////////////
   void PullInputData ()
   {
   Byte  ByteIn;
   	
       while ((BytesToRead < MAX_MEM_BUF) && (TotalDataLen > 0)){

          if(PDA_ONLINE){  // 
             if(SramCounter > 0){
	            ByteIn                         = *InQueuePtr++;
	            XorCheck                      ^= ByteIn; 
	            InputBuffer[BytesToRead++]     = ByteIn;  
	            if(InQueuePtr >= InQueueEnd){
	                InQueuePtr                  = InQueueStart;
	            }                              
	            asm volatile ("CLI;");
	            SramCounter                   --;
	            TotalDataLen                  --;
	            asm volatile ("SEI;");
             }
             if(SramCounter < 10 ) {
                asm volatile ("cbi  0x12,4;"); // RTS=on
             }
          } else { // PDA IS OFFLINE
             ; // CALL GIRISH ROUTINE TO READ DATA FROM FLASH MEMORY
               // DEST = InputBuffer[BytesToRead];
               // SIZE = ((MAX_MEM_BUF - BytesToRead) > TotalDataLen) ? TotalDataLen : (MAX_MEM_BUF - BytesToRead)
          }
       }
       if((TotalDataLen  <= 0) && (PDA_ONLINE)){
          if(XorCheck   != 0){
             ReportErrorStr("incorrect XOR check", Z_BAD_XORCHECK);
          }
       }
   }
   ///////////////////////////////////////////////////////////////////////////////////////////////
   Int PutLineInVMem (PByte DataBuffer, Byte BufLen)
   {
   Byte     ZRet = Z_OK;
   UShort   BufLooper, LineLenght = 0;
   ULong    LineStart = 0;

      LineStart     = CurMemPosX;

      for(BufLooper = 0; BufLooper < BufLen; BufLooper += 2){

         CurMemPosX        ++;
         LineLenght        += 2;

         if(CurMemPosX     >= FrameWidthInWord){

            // FOR DEVICE VIDEO........................................
            DestAddr        = (PdaFrameMemory + LineStart);
            SrcAddr         = (UShort)DataBuffer;
            DataLen         = LineLenght;
            _WriteVideoLine   ();
            //.........................................................
            DataBuffer     += LineLenght;
            CurMemPosY     ++;
            CurMemPosX      = 0;
            LineStart       = CurMemPosX;
            LineLenght      = 0;

            if(CurMemPosY  >= FrameLineHeight){
               return ZRet;
            }
            // THEN RESTART FOR NEXT LINE.
            PdaFrameMemory += MemWidthInWords;
         }
      }
      if(LineLenght){
         // FOR DEVICE VIDEO........................................
         DestAddr           = (PdaFrameMemory + LineStart);
         SrcAddr            = (UShort)DataBuffer;
         DataLen            = LineLenght;
         _WriteVideoLine      ();
         //.........................................................
      }
      return ZRet;
   }
   ///////////////////////////////////////////////////////////////////////////////////////////////
   /*
      void PutValInVMem(ULong ThisCurMemPosX, UInt PixBuffer)
      {
          // FOR DEVICE VIDEO........................................
          DestAddr = (PdaFrameMemory + ThisCurMemPosX);
          DataVal  = PixBuffer;
       
          _WriteVideoMem ();
      }
   */
   ///////////////////////////////////////////////////////////////////////////////////////////////
   void InitImageFrame (void)
   {

       XorCheck            = 0;
       Z_Current_RetCode   = 0;
       Z_Current_Error_Num = 0;
       Z_Current_FastCode  = 0;

       CurMemPosX          = 0;         CurMemPosY        = 0;
       BitsOfDataLeft      = 0;         TempPixBuffer     = 0;         Temp3BitBuffer    = 0;         PixDone           = 0;
       
       InQueueEnd          = InQueueStart     + InQueueSize;
       BytesToRead         = 0;

       CurMemPosX          = XPos;
       CurMemPosY          = YPos;

       FrameWidthInWord    = FrameWidthInPix   / PIX_PER_WORD;
       MemWidthInWords     = PDA_VIR_MEM_WIDTH * Step_Line;

       PdaScreenMemory     = 0x00;      
       PdaFrameMemory      = PdaScreenMemory + (((CurMemPosY + Initial_Phase) * PDA_VIR_MEM_WIDTH)
                           + (CurMemPosX / PIX_PER_WORD));

       CurMemPosX          = 0;         CurMemPosY        = 0;
   }
   ///////////////////////////////////////////////////////////////////////////////////////////////

#else // IF NOT ON ATMEL_PLATFORM 

   ///////////////////////////////////////////////////////////////////////////////////////////////
   UShort FAR *    PdaFrameMemory;
   UShort FAR *    PdaScreenMemory;
   
   #define ProgMemCompare    ZMemCompare
   #define CopyProgMemToSRam ZMemCopy

   void PullInputData ()
   {
        while((TotalDataLen > 0) && (BytesToRead < MAX_MEM_BUF)){

            InputBuffer[BytesToRead++]  = *InQueuePtr;
            
            InQueuePtr                ++;
            TotalDataLen              --;
        }
   }
   ////////////////////////////////////////////////////////////////////////////////////////////////
   void _WriteVideoMem(PByte dest, PByte source, UInt len)
   {
       if(len == 0){
          return;
       }
       if((UseTransparency)){
          do{
             if(*source  != 0xFF){
                *dest     = *source; /* ??? to be unrolled */
             } 
             dest        ++;
             source      ++;
          } while (--len != 0);
       } else {
          do{
             *dest++      = *source++; /* ??? to be unrolled */
          } while (--len != 0);
       }
   }
   ///////////////////////////////////////////////////////////////////////////////////////////////
   Int PutLineInVMem (PByte DataBuffer, Byte BufLen)
   {
   Byte     ZRet = Z_OK;
   UShort   BufLooper, LineLength = 0;
   ULong    LineStart;

      LineStart     = CurMemPosX;

      for(BufLooper = 0; BufLooper < BufLen; BufLooper += 2){

         CurMemPosX        ++;
         LineLength        += 2;

         if(CurMemPosX     >= FrameWidthInWord){

            _WriteVideoMem    ((PByte)&PdaFrameMemory [(LineStart)], DataBuffer, LineLength);
            DataBuffer     += LineLength;
            CurMemPosY     ++;
            CurMemPosX      = 0;
            LineStart       = CurMemPosX;
            LineLength      = 0;

            if(CurMemPosY  >= FrameLineHeight){
               return ZRet;
            }
            // THEN RESTART FOR NEXT LINE.
            PdaFrameMemory += MemWidthInWords;
         }
      }
      if(LineLength){
         _WriteVideoMem       ((PByte)&PdaFrameMemory [(LineStart)], DataBuffer, LineLength);
      }
      return ZRet;
   }
   ///////////////////////////////////////////////////////////////////////////////////////////////
   /*
      void PutValInVMem(ULong ThisCurMemPosX, UInt PixBuffer)
      {
          PdaFrameMemory [(ThisCurMemPosX) ] = PixBuffer;
      }
   */
   ///////////////////////////////////////////////////////////////////////////////////////////////
   void InitUnZipFrame (UInt X, UInt Y, UInt W, UInt H, Byte BitPerPix, Byte  IsTransparent, 
                        UInt SumData, Byte StepLine, Byte InitialPhase, PByte ScreenPtr, PByte ParmInQueuePtr)
   {
       InQueueStart        = InQueuePtr       = ParmInQueuePtr;
       InQueueSize         = SumData;
       InQueueEnd          = InQueueStart     + InQueueSize;

       BytesToRead         = 0;

       XorCheck            = 0;
       Z_Current_RetCode   = 0;
       Z_Current_Error_Num = 0;
       Z_Current_FastCode  = 0;

       CurMemPosX          = 0;           CurMemPosY        = 0;         BitsOfDataLeft    = 0;
       TempPixBuffer       = 0;           Temp3BitBuffer    = 0;         PixDone           = 0;

       UseTransparency     = IsTransparent;
       Step_Line           = StepLine;
       Initial_Phase       = InitialPhase;
       CommandType         = 'G';         // CHECK FOR FUTURE SUPPORT OF DOWNLOADS..

       XPos                = X;         
       YPos                = Y;
       FrameLineHeight     = H;         
       FrameWidthInPix     = W;
       BitPerPixel         = BitPerPix;
       TotalDataLen        = SumData;
       FrameWidthInWord    = FrameWidthInPix   / PIX_PER_WORD;
       MemWidthInWords     = PDA_VIR_MEM_WIDTH * Step_Line;

       CurMemPosX          = XPos;
       CurMemPosY          = YPos;

       PdaScreenMemory     = (PUShort)ScreenPtr;
       PdaFrameMemory      = &PdaScreenMemory [ (((CurMemPosY + Initial_Phase) * PDA_VIR_MEM_WIDTH)
                           + ((CurMemPosX / PIX_PER_WORD)) ) ];

       CurMemPosX          = 0;         CurMemPosY        = 0;
   }
   ///////////////////////////////////////////////////////////////////////////////////////////////
   void InitUnZipInfo (PByte DataDst, PByte Source, UInt SourceSize){ // 

       InQueueStart        = InQueuePtr       = Source;
       InQueueSize         = SourceSize;
       InQueueEnd          = InQueueStart     + SourceSize;

       StoragePtr          = DataDst;
       CommandType         = 'D';         // DATA
       TotalDataLen        = SourceSize;

       BytesToRead         = 0;           XorCheck           = 0;        Z_Current_RetCode = 0;
       Z_Current_Error_Num = 0;           Z_Current_FastCode = 0;
       CurMemPosX          = 0;           CurMemPosY         = 0;        BitsOfDataLeft    = 0;
       TempPixBuffer       = 0;           Temp3BitBuffer     = 0;        PixDone           = 0;
       Step_Line           = 0;           Initial_Phase      = 0;        XPos              = 0;         
       YPos                = 0;           FrameLineHeight    = 0;        FrameWidthInPix   = 0;
       BitPerPixel         = 0;           FrameWidthInWord   = 0;        MemWidthInWords   = 0;
       CurMemPosX          = 0;           CurMemPosY         = 0;        PdaScreenMemory   = 0;
       PdaFrameMemory      = 0;           CurMemPosX         = 0;        CurMemPosY        = 0;
   }
   ///////////////////////////////////////////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////
Int CheckMemorys   (void)
{
    if(ProgMemCompare ((PByte)CopyLens,       (PByte)_CopyLens,       SIZEOF_COPYLENS))
    {
       return 1;
    }
    if(ProgMemCompare ((PByte)CopyLiteral,    (PByte)_CopyLiteral,    SIZEOF_COPYLITERAL))
    {
       return 2;
    }
    if(ProgMemCompare ((PByte)CopyDist,       (PByte)_CopyDist,       SIZEOF_COPYDIST))
    {
       return 3;
    }
    if(ProgMemCompare ((PByte)CopyExtraBits,  (PByte)_CopyExtraBits,  SIZEOF_COPYEXTRABITS))
    {
       return 4;
    }

    if(ProgMemCompare ((PByte)Inflate_Mask,   (PByte)_Inflate_Mask,   SIZEOF_INFLATEMASK))
    {
       return 5;
    }
    if(ProgMemCompare ((PByte)DefBorder,      (PByte)_DefBorder,      SIZEOF_DEFBORDER))
    {
       return 6;
    }

    if(ProgMemCompare ((PByte)Fixed_LitTree,  (PByte)_Fixed_LitTree,  SIZEOF_FIXEDLITTREE))
    {
       return 7;
    }
    if(ProgMemCompare ((PByte)Fixed_DistTree, (PByte)_Fixed_DistTree, SIZEOF_FIXEDDISTTREE))
    {
       return 8;
    }
    return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
Int PrepareMemorys (void)
{
    CopyLens        = (PUInt)                  (((PByte)MemoryWindow));
    CopyLiteral     = (PUInt)                  (((PByte)CopyLens)        + SIZEOF_COPYLENS);
    CopyDist        = (PUInt)                  (((PByte)CopyLiteral)     + SIZEOF_COPYLITERAL);
    CopyExtraBits   = (PUInt)                  (((PByte)CopyDist)        + SIZEOF_COPYDIST);

    Inflate_Mask    = (PUInt)                  (((PByte)CopyExtraBits)   + SIZEOF_COPYEXTRABITS);
    DefBorder       = (PUInt)                  (((PByte)Inflate_Mask)    + SIZEOF_INFLATEMASK);

    Fixed_LitTree   = (TInflate_Huft *)        (((PByte)DefBorder)       + SIZEOF_DEFBORDER);
    Fixed_DistTree  = (TInflate_Huft *)        (((PByte)Fixed_LitTree)   + SIZEOF_FIXEDLITTREE);

    LZ77Window      = (PByte)                  (((PByte)Fixed_DistTree)  + SIZEOF_FIXEDDISTTREE);

    Zee             = (PZ_Stream)              (((PByte)LZ77Window)      + SIZEOF_LZ77WINDOW);

    ICState         = (TInflate_Codes_State  *)(((PByte)Zee)             + SIZEOF_ZSTREAM);
    IBState         = (TInflate_Blocks_State *)(((PByte)ICState)         + SIZEOF_CODESTATE);

    HuftmanTable    = (TInflate_Huft *)        (((PByte)IBState)         + SIZEOF_BLOCKSTATE);

    TreesBitsBuf    = (PUInt)                  (((PByte)HuftmanTable)    + SIZEOF_HUFTMANTABLE);
    TreesDynBuf     = (PUInt)                  (((PByte)TreesBitsBuf)    + SIZEOF_TREEBITSBUFFER);

    TreesBuffer     = (PByte)                  (((PByte)TreesDynBuf)     + SIZEOF_TREEDYNBUFFER);

    CopyProgMemToSRam ((PByte)CopyLens,       (PByte)_CopyLens,       SIZEOF_COPYLENS);
    CopyProgMemToSRam ((PByte)CopyLiteral,    (PByte)_CopyLiteral,    SIZEOF_COPYLITERAL);
    CopyProgMemToSRam ((PByte)CopyDist,       (PByte)_CopyDist,       SIZEOF_COPYDIST);
    CopyProgMemToSRam ((PByte)CopyExtraBits,  (PByte)_CopyExtraBits,  SIZEOF_COPYEXTRABITS);

    CopyProgMemToSRam ((PByte)Inflate_Mask,   (PByte)_Inflate_Mask,   SIZEOF_INFLATEMASK);
    CopyProgMemToSRam ((PByte)DefBorder,      (PByte)_DefBorder,      SIZEOF_DEFBORDER);

    CopyProgMemToSRam ((PByte)Fixed_LitTree,  (PByte)_Fixed_LitTree,  SIZEOF_FIXEDLITTREE);
    CopyProgMemToSRam ((PByte)Fixed_DistTree, (PByte)_Fixed_DistTree, SIZEOF_FIXEDDISTTREE);

    return CheckMemorys();
}
///////////////////////////////////////////////////////////////////////////////////////////////////
Int  UnzipImageFrame (void)
{
ULong     BytesOut    = 0;
Int       ZRet = Z_OK;

    ZRet       = InflateInit();

    if(ZRet != Z_OK){
       return (Z_Current_RetCode = Z_INIT_ERROR);
    }
    // FILL TEMP INPUT BUFFER FOR THE FIRST TIME

    PullInputData ();

    if(Z_Current_Error_Num != 0){
       return (Z_Current_RetCode = Z_DATA_ERROR);
    }
    // UPDATE Z_STREAM STRUCTURE
    Zee->NextInByte   = &InputBuffer [0];
    Zee->NextOutByte  = &OutputBuffer[0];
    Zee->Avail_in     = BytesToRead;
    Zee->Avail_out    = MAX_MEM_BUF;
    ///////////////////////////////////////////////////////////////////////////////////////////////
    // DECOMPRESS UNTIL END OR ERROR OCCURED
    while(ZRet != Z_STREAM_END){
    
       ZRet = Inflate(Z_NO_FLUSH);

       switch (ZRet){
       case Z_STREAM_END:
            switch(CommandType){
            case 'L': case 'G':
                 ZRet = PaintPDAScreen   (&OutputBuffer[0], (Zee->Total_out - BytesOut));
                 break;
            default:
                 ZRet = ProcessUnzipData (&OutputBuffer[0], (Zee->Total_out - BytesOut));
                 break;
            }
            if(ZRet != Z_OK){
               InflateEnd();
               return (Z_Current_RetCode = Z_DISPLAY_ERROR);
            }
            goto End;
       case Z_OK:
            break;
       default:
            InflateEnd();
            return (Z_Current_RetCode = ZRet);
       }
       if(Zee->Avail_out == 0){ // NEED TO FLUSH THE TEMP MEMORY BUFFER

          switch(CommandType){
          case 'L': case 'G':
               ZRet = PaintPDAScreen   (&OutputBuffer[0], MAX_MEM_BUF);
               break;
          default:
               ZRet = ProcessUnzipData (&OutputBuffer[0], MAX_MEM_BUF);
               break;
          }
          if(ZRet != Z_OK){
             InflateEnd();
             return (Z_Current_RetCode = Z_DISPLAY_ERROR);
          }
          BytesOut             = Zee->Total_out;
          Zee->Avail_out       = MAX_MEM_BUF;              // UPDATE Z_STREAM STRUCTURE
          Zee->NextOutByte     = &OutputBuffer[0];
       }
       if((Zee->Avail_in      == 0) 
       && (TotalDataLen       != 0)){ // NEED TO GET DATA

          BytesToRead          = Zee->Avail_in; // MUST BE SYNCHRONIZE WITH BytesToRead...
          PullInputData ();

          if(Z_Current_Error_Num != 0){
             (ZRet = Z_DATA_ERROR);
             goto End;
          }
          // UPDATE Z_STREAM STRUCTURE
          Zee->Avail_in     = BytesToRead;
          Zee->NextInByte   = &InputBuffer[0];
       }
    }  // while(ZRet != Z_STREAM_END)
    ////////////////////////////////////////////////////////////////////////////////////////////////
End:
    ZRet = InflateEnd();

    if(ZRet != Z_OK){
       return (Z_Current_RetCode = ZRet);
    }
    return (Z_Current_RetCode = Z_OK);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
Int  ProcessUnzipData (PByte Buffer, UInt BufLen)
{
Int  ZRet = Z_OK;

    ZMemCopy      (StoragePtr, Buffer, BufLen); //  
    StoragePtr += BufLen;
   
    return ZRet;
}
#if (ATMEL_PLATFORM == 0)
///////////////////////////////////////////////////////////////////////////////////////////////////
/*
   Decompresses the source buffer into the destination buffer.  sourceLen is the byte length of 
   the source buffer. Upon entry, destLen is the total size of the destination buffer, which must be 
   large enough to hold the entire uncompressed data. (The size of the uncompressed data must have
   been saved previously by the compressor and transmitted to the decompressor by some mechanism 
   outside the scope of this compression library.)
   Upon exit, destLen is the actual size of the compressed buffer.
  
   This function can be used to decompress a whole file at once if the
   input file is mmap'ed.

     uncompress returns 
     Z_OK if success, 
     Z_MEM_ERROR  if there was not enough memory, 
     Z_BUF_ERROR  if there was not enough room in the output buffer, 
     Z_DATA_ERROR if the input data was corrupted.
*/
///////////////////////////////////////////////////////////////////////////////////////////////////
Int  Z_Uncompress (PByte dest, PULong destLen, PByte source, UInt sourceLen)
{
Int  ZRet;

    ZRet     = InflateInit();
    if(ZRet != Z_OK){
       return ZRet;
    }
    Zee->NextInByte  = (PByte)source;
    Zee->Avail_in    = (UInt)sourceLen;
    /* Check for source > 64K on 16-bit machine: */
    if((ULong)Zee->Avail_in  != sourceLen){
       return Z_BUF_ERROR;
    }
    Zee->NextOutByte          = dest;
    Zee->Avail_out            = *destLen;
    if((ULong)Zee->Avail_out != *destLen){
       return Z_BUF_ERROR;
    }

    ZRet     = Inflate(Z_FINISH);
    if(ZRet != Z_STREAM_END) {
       InflateEnd();
       return ZRet;
    }
    *destLen = Zee->Total_out;

    ZRet = InflateEnd();
    return ZRet;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
Int  ZUncompress (PByte DataDst, ULong DataCount, PByte RcvSrc, UInt RcvCount)
{
Int     ZRet;
ULong   UncompressedSize = DataCount;

    ZRet = Z_Uncompress (DataDst, &UncompressedSize, RcvSrc, RcvCount);
    if((ZRet != Z_OK)){

       // EchoWarnString(_T("Warning: ZLib fail to uncompress"));
       return 0;
    }
    return 1;
}
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
Int _DirectPDAScreen (PByte Buffer, UInt BufLen)  
{
Byte ZRet = Z_OK;
Byte Looper;

    for(Looper = 0; Looper < BufLen; Looper ++){
        DisplayBuffer[Looper]             = CorrectPixLUT(Buffer[Looper]);
    }
    ZRet =  PutLineInVMem (&DisplayBuffer[0], (Byte)BufLen);

    return ZRet;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
Int _PaintMonoOnPDA (PByte Buffer, UInt BufLen) 
{
UShort   BufLooper, BitsOfData = 0, TempBuffer = 0;
Byte     BitLooper, ByteBuffer = 0, ZRet       = Z_OK, DispBufLen  = 0;

    for(BufLooper = 0; BufLooper < BufLen; BufLooper ++){

       TempBuffer           = Buffer[BufLooper];
#if ATMEL_PLATFORM
       TempBuffer          ^= 255; // MONO INVERSE SUPPORT... ONLY FOR ATMEL
#endif
       Buffer[BufLooper]    = 0;

       for(BitLooper        = 0; BitLooper < 8; BitLooper ++)
       {
          TempBuffer      <<= 1;
          ByteBuffer       += (TempBuffer >> 8);
          TempBuffer       &= 0xFF;
          
          BitsOfData       += PDA_MODE;

          if(BitsOfData    >= 8) 
          {
             DisplayBuffer[DispBufLen] = CorrectPixLUT(ByteBuffer);
             DispBufLen    ++;

             if(DispBufLen >= MAX_MEM_BUF)
             {
                ZRet        =  PutLineInVMem (&DisplayBuffer[0], DispBufLen);
                DispBufLen  = 0;
             }
             ByteBuffer     = 0;
             BitsOfData     = 0;
          }
          if(BitsOfData){
             ByteBuffer   <<= PDA_MODE; 
          }
       }
    }
    if(DispBufLen){
       ZRet =  PutLineInVMem (&DisplayBuffer[0], DispBufLen);
    }
    return ZRet;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
// THIS FUNCTION USED FOR PDA_MODE = 8, FOR PDA_MODE = 4 _DirectPDAScreen() IS CALLED
///////////////////////////////////////////////////////////////////////////////////////////////////
Int _Paint4BitOnPDA (PByte Buffer, UInt BufLen) 
{
UShort   BufLooper;
Byte     ZRet = Z_OK, DispBufLen = 0;

    if(PDA_MODE != 8){
       return ZRet = Z_ERRNO;
    } 
    for(BufLooper = 0; BufLooper < BufLen; BufLooper ++){

       DisplayBuffer[DispBufLen] = CorrectPixLUT((Buffer[BufLooper] >> 4));
       DispBufLen ++;
       DisplayBuffer[DispBufLen] = CorrectPixLUT((Buffer[BufLooper] & 0xF));
       DispBufLen ++;

       Buffer[BufLooper] = 0;

       if(DispBufLen >= MAX_MEM_BUF)
       {
          ZRet        =  PutLineInVMem (&DisplayBuffer[0], MAX_MEM_BUF);
          DispBufLen  = 0;
       }
    }
    if(DispBufLen){
       ZRet =  PutLineInVMem (&DisplayBuffer[0], DispBufLen);
    }
    return ZRet;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
Int  _Paint3BitOnPDA (PByte Buffer, UInt BufLen)
{
Byte     ZRet = Z_OK, IsDataLeft = 0, DispBufLen = 0, ByteBuffer;
UShort   ByteLooper;

    if(BitsOfDataLeft > 2){
       IsDataLeft = 1;
    } else {
       IsDataLeft = 0;
    }
    for(ByteLooper = 0; ByteLooper < BufLen; ByteLooper ++){

       if(IsDataLeft           == 0){
       GetNewData:
          TempPixBuffer       <<= BitsOfDataLeft; 
          TempPixBuffer        |= Buffer[ByteLooper];
          BitsOfDataLeft       += 8;
       }
       while (BitsOfDataLeft   >= 3) {

          if      (BitsOfDataLeft == 9) { TempPixBuffer <<= 2;} 
          else if (BitsOfDataLeft == 10){ TempPixBuffer <<= 1;}
          else                          { TempPixBuffer <<= 3;}

          Temp3BitBuffer       |= (TempPixBuffer >> 8) & 0X07;

          PixDone ++;
          if(PixDone           >= PIX_PER_WORD) 
          {
             ByteBuffer         = (Temp3BitBuffer >> 8);
             DisplayBuffer[DispBufLen] = CorrectPixLUT(ByteBuffer);
             DispBufLen        ++;

             ByteBuffer         = (Byte)Temp3BitBuffer;
             DisplayBuffer[DispBufLen] = CorrectPixLUT(ByteBuffer);
             DispBufLen        ++;

             Temp3BitBuffer     = 0;

             if(DispBufLen     >= MAX_MEM_BUF)
             {
                ZRet            =  PutLineInVMem (&DisplayBuffer[0], DispBufLen);
                DispBufLen      = 0;
             }
             PixDone            = 0;
             TempPixBuffer     &= 0xFF;
             BitsOfDataLeft    -= 3;
             if(ByteLooper     == (BufLen - 1)){ 
                if(DispBufLen){
                   ZRet         =  PutLineInVMem (&DisplayBuffer[0], DispBufLen);
                }
                return ZRet;
             }
          }
          if(PixDone){
             Temp3BitBuffer   <<= PDA_MODE;
             TempPixBuffer     &= 0xFF;
             BitsOfDataLeft    -= 3;
          }
       }
       if(IsDataLeft){
          IsDataLeft = 0;
          goto GetNewData;
       }
    }
    return ZRet;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
Int  PaintPDAScreen (PByte Buffer, UInt BufLen)
{
Int   ZRet = Z_OK;

    if(BitPerPixel  == PDA_MODE){

       ZRet = _DirectPDAScreen(Buffer, BufLen);

    } else {
       switch (BitPerPixel){ // ASSUME 8 BIT PLATFORM
       case 1:
            ZRet = _PaintMonoOnPDA (Buffer, BufLen);
            break;
       case 4:
            ZRet = _Paint4BitOnPDA (Buffer, BufLen);
            break;
       case 3:
            ZRet = _Paint3BitOnPDA (Buffer, BufLen);
            break;
       case 8:
       default:
            ZRet = Z_ERRNO;
       }
    }
    return ZRet;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
Int	PaintUnCompresedFrame (void){
Int       ZRet = Z_OK;

	while( TotalDataLen > 0 ){

       PullInputData ();
	   ZRet          = PaintPDAScreen  (InputBuffer, BytesToRead);
       BytesToRead   = 0;
	}
	return ZRet;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef __cplusplus
}
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////
