// zutil.c -- target dependent utility functions for the compression library
///////////////////////////////////////////////////////////////////////////////////////////////////
#include "DevUnzip.h"
///////////////////////////////////////////////////////////////////////////////////////////////////
//  FOR SPECIAL IMPLEMENTATION JUST REPLACE BY A PTR 
//  MAKE SURE IT PREALLOCATED.
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
#if (ATMEL_PLATFORM   == 0)
const Char * UnZip_ErrMsg[10] = {
             "need dictionary",     // Z_NEED_DICT       2  
             "stream end",          // Z_STREAM_END      1  
             "",                    // Z_OK              0  
             "file error",          // Z_ERRNO         (-1) 
             "stream error",        // Z_STREAM_ERROR  (-2) 
             "data error",          // Z_DATA_ERROR    (-3) 
             "insufficient memory", // Z_MEM_ERROR     (-4) 
             "buffer error",        // Z_BUF_ERROR     (-5) 
             "incompatible version",// Z_VERSION_ERROR (-6) 
             ""
};
///////////////////////////////////////////////////////////////////////////////////////////////////
CPChar UnZipError(UInt ErrNo)
{
    if(ErrNo < 10){
       return UnZip_ErrMsg[ErrNo];
    }
    return "illegal error";
}
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////
void UnZipMemCopy(PByte dest, PByte source, UInt len)
{
    if(len == 0){
       return;
    }
    do{
       *dest++ = *source++; /* ??? to be unrolled */
    } while (--len != 0);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
Int UnZipMemCompare (PByte s1, PByte s2, UInt len)
{
UInt j;

    if(len == 0){
       return 0;
    }
    for (j = 0; j < len; j++) {
       if (s1[j] != s2[j]) return 2*(s1[j] > s2[j])-1;
    }
    return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void UnZipMemClear (PByte dest, UInt len)
{
   if(len == 0){
      return;
   }
   do{
      *dest++ = 0;  
   } while (--len != 0);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void UnZipMemFill (PByte dest, UInt len, Byte Fill)
{
    if(len == 0){
       return;
    }
    do{
       *dest++ = Fill;  
    } while (--len != 0);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
ULong       MemUsed      = MAX_MEM;     
ULong       MemMissing   = 0;     
ULong       MemLeft      = 0;     // MEM FOR STORAGE = MAX_MEM;
///////////////////////////////////////////////////////////////////////////////////////////////////
#if 0
PVoid UnZipCalloc (unsigned ItemCount, unsigned ItemSize)
{
ULong  RequestedSize;

    RequestedSize = (ULong)(ItemCount * (ULong)ItemSize);

    if(RequestedSize < 65536){
       if(RequestedSize < MemLeft){
          if(Next_Buf < MAX_PTR){

             BufTable [Next_Buf].Start  = &ZipBuffer[MAX_MEM - MemLeft];
             BufTable [Next_Buf].Len    = RequestedSize;
             MemLeft                   -= RequestedSize;
             Next_Buf ++;

             return (PVoid)BufTable [Next_Buf - 1].Start;
          }
       }
    }
    return Z_NULL;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void  UnZipFree ( PVoid ptr)
{
Int Looper;

    for (Looper = 0; Looper < Next_Buf; Looper++) {

        if(ptr != BufTable [Looper].Start){ 
           continue; 
        }
        BufTable [Looper].Start = Z_NULL;

        while (++Looper < Next_Buf) {
            BufTable [Looper-1] = BufTable [Looper];
        }
        Next_Buf--;
        if(Next_Buf == 0){
           MemLeft = MAX_MEM;
        }
        return;
    }
}
#else 
PVoid UnZipCalloc (unsigned ItemCount, unsigned ItemSize)
{
ULong  RequestedSize;    RequestedSize = (ULong)(ItemCount * (ULong)ItemSize);

    // ALIGN THE REQUESTED SIZE
    RequestedSize        = (((RequestedSize + 7) / 8) * 8);
    if(RequestedSize     < MAX_MEM){
       if(Access_Buf    == 0){
          UnZipMemClear    ((PByte)TreesBuffer,  SIZEOF_TREESBUFFER);
          MemLeft       -= RequestedSize;
          MemUsed       += RequestedSize;
          return (PVoid)TreesBuffer;
       }
    } else {
       // NOT ENOUGH MEMORY
       MemMissing    += (RequestedSize - MemLeft);
    }
    return Z_NULL;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void  UnZipFree ( PVoid ptr)
{
    Access_Buf      = 0;
    MemLeft         = MAX_MEM;
    MemUsed         = 0;
    MemMissing      = 0;
}
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////
