// windef.h -- Basic Windows Type Definitions
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _WINDEF_
#define _WINDEF_
///////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef STRICT
#define STRICT 0
#endif

///////////////////////////////////////////////////////////////////////////////////////////////////
#define _UNICODE
#define UNICODE _UNICODE

///////////////////////////////////////////////////////////////////////////////////////////////////
#define FAR
#define far
#define NEAR
#define near
#ifndef CONST
#define CONST               const
#endif

#define __cdecl
#define cdecl
#define CDECL
#define __stdcall
#define pascal
#define __forceinline	inline
#define _fastcall
#define __fastcall
#define ASSERT(x)
#define IMPLEMENT_DYNAMIC
#define _inline __inline

#define AFXAPI
#define AFX_CDECL
#define FASTCALL
#define WINAPI
#define WINAPIV
#define APIENTRY
#define APIPRIVATE
#define PASCAL
#define CALLBACK

typedef wchar_t WCHAR;
typedef char CHAR;

#ifndef SHORT
typedef short SHORT;
#endif
#ifndef LONG
typedef long LONG;
#endif
typedef unsigned long ULONG;
typedef ULONG *PULONG;
typedef unsigned short USHORT;
typedef USHORT *PUSHORT;
typedef unsigned char UCHAR;
typedef UCHAR *PUCHAR;
typedef char *PSZ;

typedef const short * LPCWSTR;
typedef const char * LPCSTR;
typedef WCHAR * LPWSTR;
typedef LPCSTR PCSTR;
typedef LPCWSTR PCWSTR;
typedef char *LPSTR;
typedef WCHAR WBYTE;
typedef WCHAR *BSTR;

#ifdef _UNICODE
typedef WBYTE TBYTE;
typedef WCHAR TCHAR;
typedef WCHAR *LPTSTR;
typedef const WCHAR *PCTSTR;
#define _T(x) L##x
#define __T(x) L##x
typedef LPWSTR PTSTR;
typedef const WCHAR *LPCTSTR;
#else
typedef BYTE TBYTE;
typedef char TCHAR, *PTCHAR;
typedef char *PTBYTE;
typedef CHAR *LPTSTR;
typedef const CHAR *PCTSTR;
#define _T(x) x
#define __T(x) x
typedef LPSTR PTSTR;
typedef const char * LPCTSTR;
#endif

typedef LPWSTR PWSTR;



///////////////////////////////////////////////////////////////////////////////////////////////////
#define MAX_PATH          260

#ifndef NULL
#ifdef __cplusplus
#define NULL    0
#else
#define NULL    ((void *)0)
#endif
#endif

#ifndef FALSE
#define FALSE               0
#endif

#ifndef TRUE
#define TRUE                1
#endif

#ifndef IN
#define IN
#endif

#ifndef OUT
#define OUT
#endif

typedef unsigned long       DWORD;
typedef int                 BOOL;
typedef unsigned char       BYTE;
typedef unsigned short      WORD;
typedef float               FLOAT;
typedef double				DOUBLE;
typedef DOUBLE				*PDOUBLE;
typedef FLOAT               *PFLOAT;
typedef BOOL near           *PBOOL;
typedef BOOL far            *LPBOOL;
typedef BYTE near           *PBYTE;
typedef BYTE far            *LPBYTE;
typedef int near            *PINT;
typedef int far             *LPINT;
typedef WORD near           *PWORD;
typedef WORD far            *LPWORD;
typedef long far            *LPLONG;
typedef DWORD near          *PDWORD;
typedef DWORD far           *LPDWORD;
typedef void	VOID;
typedef VOID *PVOID, *LPVOID;
typedef CONST void far      *LPCVOID;
typedef int                 INT;
typedef unsigned int        UINT;
typedef unsigned long DWORD_PTR;
typedef unsigned int        *PUINT;

///////////////////////////////////////////////////////////////////////////////////////////////////
#if STRICT
typedef void *HANDLE;
#define DECLARE_HANDLE(name) struct name##__ { int unused; }; typedef struct name##__ *name
#else
typedef PVOID HANDLE;
#define DECLARE_HANDLE(name) typedef HANDLE name
#endif
typedef HANDLE *PHANDLE;

/* Types use for passing & returning polymorphic values */
typedef PUINT            WPARAM;
typedef LPLONG            LPARAM;
typedef LPLONG            LRESULT;

#ifndef NOMINMAX
#ifndef max
#define max(a,b)            (((a) > (b)) ? (a) : (b))
#endif

#ifndef min
#define min(a,b)            (((a) < (b)) ? (a) : (b))
#endif
#endif  /* NOMINMAX */

#ifndef WIN_INTERNAL
DECLARE_HANDLE            (HWND);
DECLARE_HANDLE            (HHOOK);
#ifdef WINABLE
DECLARE_HANDLE            (HEVENT);
#endif
#endif

typedef WORD                ATOM;

typedef HANDLE NEAR         *SPHANDLE;
typedef HANDLE FAR          *LPHANDLE;
typedef HANDLE              HGLOBAL;
typedef HANDLE              HLOCAL;
typedef HANDLE              GLOBALHANDLE;
typedef HANDLE              LOCALHANDLE;

typedef int (CALLBACK *FARPROC)();
typedef int (CALLBACK *NEARPROC)();
typedef int (CALLBACK *PROC)();

#define MINCHAR     0x80
#define MAXCHAR     0x7f
#define MINSHORT    0x8000
#define MAXSHORT    0x7fff
#define MINLONG     0x80000000
#define MAXLONG     0x7fffffff
#define MAXBYTE     0xff
#define MAXWORD     0xffff
#define MAXDWORD    0xffffffff

#define MAKEWORD(a, b)      ((WORD)(((BYTE)((DWORD_PTR)(a) & 0xff)) | ((WORD)((BYTE)((DWORD_PTR)(b) & 0xff))) << 8))
#define MAKELONG(a, b)      ((LONG)(((WORD)((DWORD_PTR)(a) & 0xffff)) | ((DWORD)((WORD)((DWORD_PTR)(b) & 0xffff))) << 16))
#define LOWORD(l)           ((WORD)((DWORD_PTR)(l) & 0xffff))
#define HIWORD(l)           ((WORD)((DWORD_PTR)(l) >> 16))
#define LOBYTE(w)           ((BYTE)((DWORD_PTR)(w) & 0xff))
#define HIBYTE(w)           ((BYTE)((DWORD_PTR)(w) >> 8))

DECLARE_HANDLE(HBITMAP);
typedef int HFILE;
#define HFILE_ERROR ((HFILE)-1)

#define RtlCopyMemory(DESC,SRC,LEN)	memcpy((DESC),(SRC),(LEN))
#define RtlZeroMemory(DESC,LEN)	memset((DESC),0,LEN)
#define CopyMemory	RtlCopyMemory
#define ZeroMemory	RtlZeroMemory
#define FillMemory(DESC,LEN,VALUE)	memset((DESC),(LEN),(VALUE))

typedef struct _FILETIME {
    DWORD dwLowDateTime;
    DWORD dwHighDateTime;
} FILETIME, *PFILETIME, *LPFILETIME;

typedef struct _SYSTEMTIME {
    WORD wYear;
    WORD wMonth;
    WORD wDayOfWeek;
    WORD wDay;
    WORD wHour;
    WORD wMinute;
    WORD wSecond;
    WORD wMilliseconds;
} SYSTEMTIME, *PSYSTEMTIME, *LPSYSTEMTIME;

#define INVALID_HANDLE_VALUE (-1)
///////////////////////////////////////////////////////////////////////////////////////////////////


#define wsprintf	swprintf
typedef struct {
	pthread_mutex_t mutex;     //Controls access to sharedint
    pthread_cond_t condition;  //Indicates a change to sharedint
    int sharedint;
}critical_data, *pt_critical_data;
///////////////////////////////////////////////////////////////////////////////////////////////////
#endif /* _WINDEF_ */
///////////////////////////////////////////////////////////////////////////////////////////////////
