// File name: G3G4.h
// Header file for g3g4 encoding
// The algorithm is based on ITU-T Recommendation T.4 and T.6
#ifndef _G3G4_
#define _G3G4_

#define G4MODE_V0		  0
#define G4MODE_VR1		  1
#define G4MODE_VR2		  2
#define G4MODE_VR3		  3

#define G4_VL_OFFSET	  8
#define G4MODE_VL1		  9
#define G4MODE_VL2		  10
#define G4MODE_VL3		  11

#define G4MODE_PASS       13
#define G4MODE_HORIZ      14

#define G4MODE_UNCOMPRESS 15

//STRUCT TableEntry PRESENTS RUNLENGTH CODE
typedef struct TableEntry {
    BYTE    length;        // BIT LENGTH G4 CODE 
    BYTE    code;          // G4 CODE 
    short   runlen;        // RUN LENGTH IN BITS 
} TableEntry;

// status values returned instead of a run length 
#define G4CODE_EOL      -1  // ACT_EOL 
#define G4CODE_INVALID  -2  // ACT_INVALID
#define G4CODE_EOF      -3  // END OF INPUT DATA 
#define G4CODE_INCOMP   -4  // INCOMPLETE RUN CODE 

#define G4WHITE          0
#define G4BLACK          1

#define G4ODDROW         0
#define G4EVENROW        1

#endif // _G3G4_
