
#ifndef __G3G4DECODE_H__
#define __G3G4DECODE_H__



const BYTE StartByteMask[8]	= { 0xff, 0x7f, 0x3f, 0x1f, 0x0f, 0x07, 0x03, 0x01 };
const BYTE EndByteMask[8]	= { 0x00, 0x80, 0xc0, 0xe0, 0xf0, 0xf8, 0xfc, 0xfe };
const BYTE DecodeMask [8]	= { 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01 };

class CG3Decode{
public:
	CG3Decode();
	~CG3Decode();

    bool Reset();
	bool Initialize(DWORD DestImgWidthInBytes);
	bool UncompressG3ToBinary(PBYTE	SrcG3Buffer,
						  DWORD	SrcG3BufSize,
						  PBYTE DestBinBuffer,
						  DWORD DestBinBufSize,
						  PDWORD LinesUncompressed,
						  PBOOL  CompressedBufferDone);
protected:
	CG3Tree		m_G3Tree;
	PTREENODE	m_WhiteRoot;
	PTREENODE	m_BlackRoot;
	PTREENODE	m_CurrentTreePointer;
	bool		m_IsWhite;
    bool        m_FirstEOL;
	DWORD		m_G4byteToStart;
	BYTE		m_G4bitToStart;
	DWORD		m_LineOffset;
	PBYTE		m_CurrentBinLine;
	DWORD		m_DestImgWidthInBytes;
};



class CG4Decode{
public:
	CG4Decode();
	~CG4Decode();

    bool Reset();
	bool Initialize(DWORD DestImgWidthInBytes);
	bool UncompressG4ToBinary(PBYTE	SrcG4Buffer,
						  DWORD	SrcG4BufSize,
						  PBYTE DestBinBuffer,
						  DWORD DestBinBufSize,
						  PDWORD LinesUncompressed,
						  PBOOL  CompressedBufferDone);
protected:
	CG4Tree		m_G4Tree;
	PTREENODE	m_WhiteRoot;
	PTREENODE	m_BlackRoot;
	PTREENODE	m_CurrentTreePointer;
	bool		m_IsWhite;
	DWORD		m_G4byteToStart;
	BYTE		m_G4bitToStart;
	DWORD		m_LineOffset;
	PBYTE		m_CurrentBinLine;
	DWORD		m_DestImgWidthInBytes;
	PTREENODE	m_ModeCodeRoot;
	int*		m_ReferenceRuns;
	int*		m_CodingRuns;
	int			m_CodingIndex;
	int			m_ReferenceIndex;
	bool		m_LookForCode;
	bool		m_IsFirstRun;

	_inline void FillCurrentBinLine(DWORD Begin, DWORD End);
};

/*
#define FillMacro(Begin, End, Buffer, N)	\
		__asm push eax						\
		__asm push ebx						\
		__asm push ecx						\
		__asm push edx						\
		__asm push edi						\
		__asm push esi						\
		__asm mov ecx, End					\
		__asm cmp ecx, 0					\
		__asm jge BEGINFILL##N				\
		__asm jmp ENDFILLMACRO##N			\
__asm BEGINFILL##N:							\
		__asm mov esi, ecx					\
		__asm mov ebx, Begin				\
		__asm mov edx, ebx					\
		__asm shr ecx, 3					\
		__asm shr ebx, 3					\
		__asm sub ecx, ebx					\
		__asm sub ecx, 1					\
		__asm jl FILLONE##N					\
		__asm mov edi, Buffer				\
		__asm add edi, ebx					\
		__asm add edi, 1					\
		__asm mov al, 0FFh					\
		__asm rep stosb						\
		__asm lea eax, StartByteMask		\
		__asm and edx, 7					\
		__asm mov cl, byte ptr [eax+edx]	\
		__asm add ebx, Buffer				\
		__asm or  byte ptr [ebx], cl		\
		__asm lea eax, EndByteMask			\
		__asm mov ebx, esi					\
		__asm shr ebx, 3					\
		__asm and esi, 7					\
		__asm mov cl, byte ptr [eax+esi]	\
		__asm add ebx, Buffer				\
		__asm or  byte ptr [ebx], cl		\
		__asm jmp ENDFILLMACRO##N			\
__asm FILLONE##N:							\
		__asm lea eax, StartByteMask		\
		__asm and edx, 7					\
		__asm mov cl, byte ptr [eax+edx]	\
		__asm lea eax, EndByteMask			\
		__asm and esi, 7					\
		__asm and cl, byte ptr [eax+esi]	\
		__asm add ebx, Buffer				\
		__asm or  byte ptr [ebx], cl		\
__asm ENDFILLMACRO##N:						\
		__asm pop  esi						\
		__asm pop  edi						\
		__asm pop  edx						\
		__asm pop  ecx						\
		__asm pop  ebx						\
		__asm pop  eax
*/


#endif
