#include "stdafx.h"

#include "G_Compress.h"


CG3Tree::CG3Tree(){
	m_WhiteTree = NULL;
	m_BlackTree = NULL;
}
CG3Tree::~CG3Tree(){
	if (m_WhiteTree != NULL)
		DeleteTree(m_WhiteTree);
	m_WhiteTree = NULL;
	if (m_BlackTree != NULL)
		DeleteTree(m_BlackTree);
	m_BlackTree = NULL;
}
bool CG3Tree::Initialize(){

	if ((m_WhiteTree == NULL)&&
		((m_WhiteTree = BuildWhiteTree()) == NULL))
		return FALSE;
	if ((m_BlackTree == NULL)&&
		((m_BlackTree = BuildBlackTree())== NULL))
		return FALSE;
	return TRUE;
}
PTREENODE	CG3Tree::GetWhiteTree(){
	return m_WhiteTree;
}
PTREENODE	CG3Tree::GetBlackTree(){
	return m_BlackTree;
}
PTREENODE CG3Tree::InitTreeNode(void){
PTREENODE pTreeRoot;
	pTreeRoot = new TREENODE;
	if (pTreeRoot){
		pTreeRoot->RunLength = G4CODE_INVALID;
		pTreeRoot->One	= NULL;
		pTreeRoot->Zero = NULL;
	}
	return pTreeRoot;
}
bool CG3Tree::DeleteTree(PTREENODE pStartNode){
	if (pStartNode == NULL)
		return false;
	if (pStartNode->One)
		DeleteTree(pStartNode->One);
	if (pStartNode->Zero)
		DeleteTree(pStartNode->Zero);
	delete pStartNode;
	return true;
}
PTREENODE CG3Tree::BuildWhiteTree(void){
PTREENODE pWhiteTreeRoot;
	if ((pWhiteTreeRoot = InitTreeNode())==NULL)
		return NULL;
	for (int i=0; i<NO_OF_WHITE_CODES; i++){
		if (!AddTreeCode(pWhiteTreeRoot, StrWhiteCodes[i].G4Code, StrWhiteCodes[i].RunLength)){
			DeleteTree(pWhiteTreeRoot);
			return NULL;
		}
	}
	return pWhiteTreeRoot;
}
PTREENODE CG3Tree::BuildBlackTree(void){
PTREENODE pBlackTreeRoot;
	if ((pBlackTreeRoot = InitTreeNode())==NULL)
		return NULL;
	for (int i=0; i<NO_OF_BLACK_CODES; i++){
		if (!AddTreeCode(pBlackTreeRoot, StrBlackCodes[i].G4Code, StrBlackCodes[i].RunLength)){
			DeleteTree(pBlackTreeRoot);
			return NULL;
		}
	}
	return pBlackTreeRoot;
}
bool CG3Tree::AddTreeCode (PTREENODE pTreeRoot, const char* G4Code, short RunLength){
PTREENODE pCurrentNode = pTreeRoot;
	for (int i=0; i<strlen(G4Code); i++){
		if (G4Code[i] == '0'){
			if (pCurrentNode->Zero == NULL)
				pCurrentNode->Zero = InitTreeNode();
			pCurrentNode = pCurrentNode->Zero;
		}else if (G4Code[i] == '1'){
			if (pCurrentNode->One == NULL)
				pCurrentNode->One = InitTreeNode();
			pCurrentNode = pCurrentNode->One;
		}
		if (pCurrentNode == NULL)
			return FALSE;
	}
	pCurrentNode->RunLength = RunLength;
	return true;
}






CG4Tree::CG4Tree():CG3Tree(){
	m_ModeCodeTree = NULL;
}
bool CG4Tree::Initialize(){
	
	if(CG3Tree::Initialize() == FALSE)
		 return FALSE;
	return (((m_ModeCodeTree != NULL)
		||((m_ModeCodeTree = CG4Tree::BuildModeCodeTree()) != NULL)));
}
PTREENODE	CG4Tree::GetModeCodeTree(){
	return m_ModeCodeTree;
}
CG4Tree::~CG4Tree(){

	if (m_ModeCodeTree != NULL)
		DeleteTree(m_ModeCodeTree);
	m_ModeCodeTree = NULL;
}
PTREENODE CG4Tree::BuildModeCodeTree(void){
PTREENODE pModeCodeTreeRoot;
	if ((pModeCodeTreeRoot = InitTreeNode())==NULL)
		return NULL;
	for (int i=0; i<NO_OF_MODE_CODES; i++){
		if (!AddTreeCode(pModeCodeTreeRoot, StrModeCodes[i].G4Code, StrModeCodes[i].RunLength)){
			DeleteTree(pModeCodeTreeRoot);
			return NULL;
		}
	}
	return pModeCodeTreeRoot;
}