// NUncompress.cpp
#include "stdafx.h"


///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
static BYTE  Decode_Mask [16];
static BOOL  IsInvalidCodeFound;
static int   N3ErrorStatus;
static BOOL  ContinueDecoding;

static BYTE  BitNumber, CodeByte;
static int   Code_Pos,   Pix_Pos;

static PBYTE N3Src;
static PBYTE N3Dst;

static int   PixCount;
static int   ImgDataCount;
static int   PackRcvCount;

// N4 ADD ON
static int   a0,a1,a2,b0,b1,b2;
static int   CurrentRow;
static int   G4CurrentColor   = G4WHITE;
static WORD  EvenRuns [1024],   OddRuns  [1024]; // SPECIAL IMPLEMENTATION UNDER 1 K =4K buffer total.
static WORD  EvenIndex,         OddIndex;

// INFORMATIONNAL VARIABLES...
static int   ImgLineCount   = 0;
static int   ImgWidthInByte,  ImgWidthInPixel;
static int   ImgHeightInLines;
///////////////////////////////////////////////////////////////////////////////////////////////////
#if _DEBUG
static 	CString CurrentCode;   // Private CurrentCode As String
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL N3Initialize(PBYTE DataDst, int  DataCount, PBYTE RcvSrc, int  RcvCount)
{
    N3Src              = RcvSrc;
    N3Dst              = DataDst;
    ImgDataCount       = DataCount;
    PackRcvCount       = RcvCount;

    PixCount           = DataCount * 8;

    BitNumber          = 0;
    Code_Pos           = 0;
    CodeByte           = N3Src [Code_Pos];

    ContinueDecoding   = TRUE;
    IsInvalidCodeFound = FALSE;
    N3ErrorStatus      = 0;

    Decode_Mask[0]     = 0x80;
    Decode_Mask[1]     = 0x40;
    Decode_Mask[2]     = 0x20;
    Decode_Mask[3]     = 0x10;
    Decode_Mask[4]     = 0x8;
    Decode_Mask[5]     = 0x4;
    Decode_Mask[6]     = 0x2;
    Decode_Mask[7]     = 0x1;

    Pix_Pos            = 0;

    // FILL WITH ZERO'S THEN WE ONLY HAVE TO SKIP
    ZeroMemory(DataDst, DataCount);

    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL N4Initialize(PBYTE DataDst, int  DataCount, PBYTE RcvSrc, int  RcvCount, int   ImgWidth, int  ImgHeight) // IN PIXEL
{
    ImgWidthInByte   = ImgWidth / 8;
    ImgWidthInPixel  = ImgWidth;
    ImgHeightInLines = ImgHeight;
    ImgLineCount     = 0;

    G4CurrentColor   = G4WHITE;
    CurrentRow       = G4ODDROW;

    EvenRuns [0]     = 0;
    EvenRuns [1]     = ImgWidthInPixel; // INITIAL b1
    EvenRuns [2]     = ImgWidthInPixel; // INITIAL b2
    OddRuns  [0]     = 0;

    a0               = 0;

    EvenIndex        = 1;
    OddIndex         = 0;

    b1               = -1;

    return N3Initialize( DataDst,  DataCount,  RcvSrc, RcvCount);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
static void __inline N4OnNewLine()
{
    G4CurrentColor = G4WHITE;

    if (CurrentRow != G4EVENROW){
      CurrentRow             = G4EVENROW;
      OddRuns [++OddIndex]   = a0;
      OddRuns [++OddIndex]   = a0;
      OddIndex               = 1;
      EvenIndex              = 0;

    } else {

      CurrentRow             = G4ODDROW;
      EvenRuns [++EvenIndex] = a0;
      EvenRuns [++EvenIndex] = a0;
      OddIndex               = 0;
      EvenIndex              = 1;
    }
    a0 =  0;
    b1 = -1;

    ImgLineCount++;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
static void FillOnePixel(int  RunLen)
{
BYTE  Bit_Pos;
int   Byte_Pos;

    if((RunLen <= 0)){
       return;
    }
    Byte_Pos   = Pix_Pos  / 8;
    Bit_Pos    = Pix_Pos  & 7;
    Pix_Pos   += RunLen;

    if (Pix_Pos >= PixCount) {
       ContinueDecoding = FALSE;
       return;
    }
    if (Bit_Pos >= 8){
       Byte_Pos  = Byte_Pos + 1;
       Bit_Pos   = 0;
    }
    while (RunLen > 8){
		if (Bit_Pos != 0){
			while (Bit_Pos < 8){
                N3Dst[Byte_Pos] = N3Dst [Byte_Pos] | Decode_Mask [Bit_Pos];
                Bit_Pos = Bit_Pos + 1;
                RunLen  = RunLen  - 1;
			}
            Byte_Pos = Byte_Pos + 1;
            Bit_Pos  = 0;
		} else {
            N3Dst [Byte_Pos]  = 0xFF;
            RunLen            = RunLen   - 8;
            Byte_Pos          = Byte_Pos + 1;
		}
    }
    while (RunLen > 0){
		if (Bit_Pos >= 8){
            Byte_Pos = Byte_Pos + 1;
            Bit_Pos  = 0;
		}
        N3Dst [Byte_Pos] = N3Dst [Byte_Pos] | Decode_Mask [Bit_Pos];
        Bit_Pos          = Bit_Pos + 1;
        RunLen           = RunLen  - 1;
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
static void SkipZeroPixel(int  RunLen)
{
    if((RunLen <= 0)){
       return;
    }
	Pix_Pos   += RunLen;

    if (Pix_Pos >= PixCount) {
       ContinueDecoding = FALSE;
       return;
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
static BOOL __inline Next_Bit()
{
BOOL BitValue;

    if (BitNumber   >= 8) {
       if (Code_Pos >= PackRcvCount - 1) {
          //N3ErrorStatus++;
          ContinueDecoding = FALSE;
          return FALSE;
       }
       Code_Pos   = Code_Pos + 1;
       CodeByte   = N3Src [Code_Pos];
       BitNumber  = 0;
    }
    if (CodeByte  & Decode_Mask [BitNumber]) {
       BitValue   = TRUE;   //CurrentCode = CurrentCode + "1"
    } else {
       BitValue   = FALSE;  //CurrentCode = CurrentCode + "0"
    }
    BitNumber     = BitNumber + 1;
    return (BitValue);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
//#include "DecodeWord.c"
#include "DecodeN4Code.c"
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
static int DecodeZeroRun()
{
int  Cumulative = 0, CodeValue;
int  SnapPos;
BYTE SnapBit;

    SnapPos = Code_Pos;
    SnapBit = BitNumber;
    do{
      CodeValue = DecodeZeroWord();
      if (CodeValue  < 0) {
        if (Code_Pos < PackRcvCount) {
           N3ErrorStatus++;
           OutputDebugString(_T("Bad (zero) N3 CODE Image Error!!!\n "));
           return (-1);
        }
        return (CodeValue) ;
      }
      Cumulative = Cumulative + CodeValue;
      if (CodeValue < 64) { // OTHERWISE ACCUMULATE CODE VALUE
        return (Cumulative);
      }
    } while (ContinueDecoding);
    return Cumulative;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
static int  DecodeOneRun()
{
int  Cumulative = 0, CodeValue;
int  SnapPos;
BYTE SnapBit;

    SnapPos = Code_Pos;
    SnapBit = BitNumber;
    do{
      CodeValue = DecodeOneWord();
      if (CodeValue  < 0) {
        if (Code_Pos < PackRcvCount) {
           N3ErrorStatus++;
           OutputDebugString(_T("Bad (one) N3 CODE Image Error!!!\n "));
           return (-1);
        }
        return (CodeValue);
      }
      Cumulative = Cumulative + CodeValue;
      if (CodeValue < 64) { // OTHERWISE ACCUMULATE CODE VALUE
        return (Cumulative);
      }
    } while (ContinueDecoding);
    return Cumulative;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
static int __inline PassMode(int  G4Code) //  RETURN RUNLENGTH FILLMODE
{
int  RunLength  = (b2 - a0);

    // SKIP (PASS) TWO G4CURRENTCOLOR CHANGES ON THE PREVIOUS ROW
	if (G4CurrentColor == G4WHITE){
      SkipZeroPixel (RunLength);
	} else {
      FillOnePixel (RunLength);
	}
    a0 = b2;
	if (CurrentRow != G4ODDROW){
	  OddIndex     += 2;
	  b1 = OddRuns [OddIndex];
	} else {
	  EvenIndex    += 2;
	  b1 = EvenRuns [EvenIndex];
	}
    return RunLength;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
static int __inline VerticalRightMode(int  G4Code)
{
int  RunLength;
int  VerticalOffset;

    VerticalOffset = G4Code - G4MODE_V0;
    RunLength      = (b1 - a0 + VerticalOffset);

    // THE NEXT G4CURRENTCOLOR CHANGE BEGINS THREE PIXELS TO THE RIGHT OF ITS LOCATION ON THE PREVIOUS ROW
	if (G4CurrentColor == G4WHITE){
	  SkipZeroPixel  (RunLength);
	  G4CurrentColor = G4BLACK;
	} else {
	  FillOnePixel   (RunLength);
	  G4CurrentColor = G4WHITE;
	}
	a0 = b1 + VerticalOffset;
	if (CurrentRow != G4ODDROW){
	  EvenRuns [++EvenIndex] = a0;
	  OddIndex++;
	} else {
	  OddRuns  [++OddIndex]  = a0;
	  EvenIndex++;
	}
    return RunLength;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
static int __inline VeticalLeftMode(int  G4Code)
{
int  RunLength;
int  VerticalOffset;

    VerticalOffset = G4Code - G4_VL_OFFSET;
    RunLength      = (b1 - a0 - VerticalOffset);

    // THE NEXT G4CURRENTCOLOR CHANGE BEGINS TWO PIXELS TO THE LEFT OF ITS LOCATION ON THE PREVIOUS ROW
	if (G4CurrentColor == G4WHITE) {
	  SkipZeroPixel (RunLength);
	  G4CurrentColor = G4BLACK;
	} else {
	  FillOnePixel  (RunLength);
	  G4CurrentColor = G4WHITE;
	}
	a0 = b1 - VerticalOffset;
	if (CurrentRow != G4ODDROW){

      EvenRuns [++EvenIndex] = a0;

      if (a0 < b0){
        OddIndex--;
	  } else {
        OddIndex++;
      }
	} else {
	  OddRuns [++OddIndex] = a0;
	  if (a0 < b0){
        EvenIndex--;
	  } else {
        EvenIndex++;
      }
	}
    return RunLength;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
static int __inline HorizontalMode(int  G4Code)
{
int  WhiteRunlength, BlackRunlength;

    // REVERT TO 1-DIMENSIONAL MODIFIED HUFFMAN ENCODING FOR A PAIR OF RUNS
	if (G4CurrentColor == G4WHITE){

      WhiteRunlength = DecodeZeroRun ();
	  SkipZeroPixel (WhiteRunlength);
	  a1 = (a0 += WhiteRunlength);

      BlackRunlength = DecodeOneRun ();
	  FillOnePixel (BlackRunlength);
	  a2 = (a0 += BlackRunlength);

	} else {

      BlackRunlength = DecodeOneRun ();
	  FillOnePixel (BlackRunlength);
	  a1 = (a0 += BlackRunlength);

      WhiteRunlength = DecodeZeroRun ();
	  SkipZeroPixel (WhiteRunlength);
	  a2 = (a0 += WhiteRunlength);
	}
	if (CurrentRow != G4ODDROW){

	  EvenRuns [++EvenIndex] = a1;
	  EvenRuns [++EvenIndex] = a2;
	  while (a0 > OddRuns [OddIndex]){
         OddIndex += 2;
	  }
      b1 = OddRuns [OddIndex];

	} else {

	  OddRuns [++OddIndex] = a1;
	  OddRuns [++OddIndex] = a2;
	  while (a0 > EvenRuns [EvenIndex]){
         EvenIndex += 2;
	  }
      b1 = EvenRuns [EvenIndex];
	}
    return (WhiteRunlength + BlackRunlength);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
static int  DecodeG4()
{
//  CurrentCode = ""

  if (Next_Bit ()){                              // 1
    return (G4MODE_V0);
  } else {                                       // 0...
    if (Next_Bit ()){                            // 01...
      if (Next_Bit ()){                          // 011
        return (G4MODE_VR1);
      } else {                                   // 010
        return (G4MODE_VL1);
      }
    } else {                                     // 00...
      if (Next_Bit ()){                          // 001
        return (G4MODE_HORIZ);
      } else {                                   // 000...
	    if (Next_Bit ()){                        // 0001
          return (G4MODE_PASS);
	    } else {                                 // 0000...
	      if (Next_Bit ()){                      // 0000 1...
	        if (Next_Bit ()){                    // 0000 11
              return (G4MODE_VR2);
	        } else {                             // 0000 10
              return (G4MODE_VL2);
            }
	      } else {                               // 0000 0...
	        if (Next_Bit ()){                    // 0000 01...
	          if (Next_Bit ()) {                 // 0000 011
                return (G4MODE_VR3);
	          } else {                           // 0000 010
                return (G4MODE_VL3);
              }
	        } else {                             // 0000 00...
	          if (Next_Bit ()){                  // 0000 001...
		        if (Next_Bit ()){                // 0000 0011...
		          if (Next_Bit ()){              // 0000 0011 1...
		            if (Next_Bit ()){            // 0000 0011 11
                      return (G4MODE_UNCOMPRESS);
                    } else {                     // 0000 0011 10
                      return (G4CODE_INVALID);
                    }
		          } else {                       // 0000 0011 0
                    return (G4CODE_INVALID);
                  }
		        } else {                         // 0000 0010
                  return (G4CODE_INVALID);
                }
	          } else {                           // 0000 000
                return (G4CODE_EOF);
		        // under the assumption that there are no errors in the file,
			    // then this bit string can only be the beginning of an
			    // EOFB (end-of-facsimile-block) code
              }
	        }
	      }
	    }
      }
    }
  }
  return (G4CODE_EOL);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
extern "C" {
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall N4_Uncompress()
{
DLL_THREAD_MANAGEMENT();

int  ThisRun, G4Code;

    do{
       G4Code  = DecodeG4();

       if (CurrentRow != G4ODDROW){

         b0 = b1;
         b1 = OddRuns [OddIndex];
         if ((b1 <= a0) && a0){
	       OddIndex += 2;
	       b0 = OddRuns [OddIndex - 1];
	       b1 = OddRuns [OddIndex];
         }
         b2 = OddRuns [OddIndex + 1];

       } else {

         b0 = b1;
         b1 = EvenRuns [EvenIndex];
         if ((b1 <= a0) && a0){
	       EvenIndex += 2;
	       b0 = EvenRuns [EvenIndex - 1];
	       b1 = EvenRuns [EvenIndex];
         }
         b2 = EvenRuns [EvenIndex + 1];
       }
       #ifdef _DEBUG_FULLG4
	      if (CurrentRow != G4ODDROW){
	        TRACE ("\n ref_index=%hd b1=%hd b2=%hd a0=%hd curr[%hd]=%hd G4CurrentColor=%hd ",
	                OddIndex, b1, b2, a0, EvenIndex, EvenRuns [EvenIndex],G4CurrentColor);
	      } else {
	        TRACE ("\n ref_index=%hd b1=%hd b2=%hd a0=%hd curr[%hd]=%hd G4CurrentColor=%hd ",
	                EvenIndex, b1, b2, a0, OddIndex, OddRuns [OddIndex],G4CurrentColor);
	      }
       #endif


       switch(G4Code){
       case G4MODE_V0:
       case G4MODE_VR1:
       case G4MODE_VR2:
       case G4MODE_VR3:
            // THE NEXT G4CURRENTCOLOR CHANGE BEGINS THREE PIXELS TO THE RIGHT OF ITS LOCATION ON THE PREVIOUS ROW
            ThisRun = VerticalRightMode(G4Code);
            break;
       case G4MODE_VL1:
       case G4MODE_VL2:
       case G4MODE_VL3:
            // THE NEXT G4CURRENTCOLOR CHANGE BEGINS TWO PIXELS TO THE LEFT OF ITS LOCATION ON THE PREVIOUS ROW
            ThisRun = VeticalLeftMode(G4Code);
            break;

       case G4MODE_PASS:
            // SKIP (PASS) TWO G4CURRENTCOLOR CHANGES ON THE PREVIOUS ROW
            ThisRun = PassMode(G4Code);
            break;
       case G4MODE_HORIZ:
            // REVERT TO 1-DIMENSIONAL MODIFIED HUFFMAN ENCODING FOR A PAIR OF RUNS
            ThisRun = HorizontalMode(G4Code);
            break;

       case G4MODE_UNCOMPRESS:
            // ENTER EXTENSION TYPE 7 ("111"), AN UNCOMPRESSED ENCODING SCHEME
            OutputDebugString(_T("Bad G4 CODE unsupported Extension!!!\n "));
            break;

       case G4CODE_INVALID:
            // THE BIT PATTERN FOUND CORRESPONDS TO AN UNKNOWN OR INVALID CODEWORD.
            // THIS MAY BE ONE OF THE SEVEN POSSIBLE EXTENSIONS NOT DEFINED BY THE SPECIFICATION.
            N3ErrorStatus++;
            OutputDebugString(_T("Bad G4 CODE Image Error!!!\n "));
            break;
       case G4CODE_EOL:
            break;
       case G4CODE_EOF:
            // ASSUMED IN THIS IMPLEMENTATION TO BE EQUIVALENT TO EOFB (END-OF-FACSIMILE-BLOCK)
       default:
            // WE SHOULD NEVER GET HERE; IF WE DO, THE TABLES ARE BAD
            return TRUE;
       }
       if(a0 >= ImgWidthInPixel){
          N4OnNewLine();
          if(ImgLineCount >= ImgHeightInLines){
             return TRUE;
          }
       }

	} while (ContinueDecoding);

    return TRUE;
}
#if 1
//////////////////////////////////////////////////////////////////////////////////////////////
// REQUIREMENT IN THIS VERSION
// - ImgWidth MUST BE IN PIXEL AND IN BOUDARIES OF 8 BIT (TOLERANCE BYTE)
// - Imgwidth MUST BE <= 1024
// -
//////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall N4Uncompress (PBYTE DataDst,  int  DataCount,
                             int   ImgWidth, int  ImgHeight, // IN PIXEL
                             PBYTE RcvSrc,   int  RcvCount)
{
DLL_THREAD_MANAGEMENT();

    N4Initialize(DataDst, DataCount, RcvSrc, RcvCount, ImgWidth, ImgHeight);

    return N4_Uncompress();
}
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall N3Uncompress(PBYTE DataDst, int  DataCount, PBYTE RcvSrc, int  RcvCount)
{
DLL_THREAD_MANAGEMENT();

int  ZeroRun, OneRun;

    N3Initialize(DataDst, DataCount, RcvSrc, RcvCount);
    do{
       ZeroRun = DecodeZeroRun();
       OneRun  = DecodeOneRun();
       if((ZeroRun < 0) && (OneRun < 0)){
          return FALSE;
       }
       SkipZeroPixel (ZeroRun);
       FillOnePixel  (OneRun);
	} while (ContinueDecoding);

    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
} // extern "C"
///////////////////////////////////////////////////////////////////////////////////////////////////
