/*
 * ringbuffer.h
 *
 *  Created on: Dec 11, 2008
 *      Author: root
 */

#ifndef RINGBUFFER_H_
#define RINGB
#define RECV_BUFFER_SIZE	(1024*50)
#define RB_WRITE	(1)
#define RB_READ	(2)

typedef struct {
	unsigned char *container;
	unsigned char *header;
	unsigned char *wp;
	unsigned char *rp;
	unsigned char *tail;
	int available_to_write;
	int available_to_read;
	bool ready_to_write;
	bool ready_to_read;
}RB,*P_RB;
bool rb_create(P_RB rb);
void rb_init(P_RB rb);
void rb_destroy(P_RB rb);

size_t rb_write(P_RB rb,LPCSTR data, size_t len);
#endif /* RINGBUFFER_H_ */
