// threadMngr.c
#include "StdAfx.h"

pthread_t threads[BRWS_NUMBER_THREADS];
pthread_mutex_t mutex_send = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t mutex_recv = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t cond_send = PTHREAD_COND_INITIALIZER;\
extern int SendSocket;
extern int RecvSocket;
extern P_RB rb_send;
extern P_RB rb_recv;
extern BYTE WriteBufferQueue[8192];
extern int    WriteBufferStart ;
extern int    WriteBufferEnd ;
sem_t sem;
extern CCriticalSection  CriticalWriteBufferAccess;
void *hdl_thread_send(void * p){
	g_debug("In send thread\n");
	int len;
	CSingleLock AccessSingleLock(&CriticalWriteBufferAccess);


    	for(;;){

		while (WriteBufferStart!=WriteBufferEnd){
			//pthread_mutex_lock(&mutex_send);
			AccessSingleLock.Lock();
			if(AccessSingleLock.IsLocked()){
				len = WriteBufferEnd-WriteBufferStart;
				rb_write(rb_send,(const char*)WriteBufferQueue, len);

				EmptyWriteBufferQueue();
				socket_write(SendSocket,rb_send->rp,len);
				AccessSingleLock.Unlock();
			}
		}	//pthread_mutex_unlock(&mutex_send);

	}

}
#if 0
size_t send_data(LPCSTR data, size_t len){
	size_t available_to_write;
	LPSTR p_data;
	p_data= (LPSTR)data;

	while (len >0)
	{
		available_to_write = rb_send->available_to_write;
		if (available_to_write>0){	// HAVE SAPCE TO FIT
		sem_wait(&sem);
		len -=available_to_write;
		rb_write(rb_send,p_data, len);
		p_data = p_data + len;
		sem_post(&sem);
		}
	}
	//RETURN;
}
#endif

void *hdl_thread_recv(void * p){
	int socket_fd;
	void* buf;
	ssize_t len;

	printf("In send thread\n");

	socket_fd = RecvSocket;
	CSingleLock AccessSingleLock(&CriticalWriteBufferAccess);

	for(;;){
		AccessSingleLock.Lock();
		if(AccessSingleLock.IsLocked()){
		while(socket_read(socket_fd,rb_recv,len)){  //condition: have enough bytes to send
			//socket_write(socket_descriptor,rb_send->rp,len);
		}
		}
	}

}

BOOL create_thread(int action){
	bool ret;
	int  rc,t;
	switch (action){
	case 0 : //main thread
		ret = FALSE;
		break;
	case 1 : //send thread
		rc = pthread_create(&threads[BRWS_THREAD_SEND],NULL,hdl_thread_send,(void *)t);
		ret = TRUE;
		break;
	case 2 : //receiving thread
		rc = pthread_create(&threads[BRWS_THREAD_RECEIVE],NULL,hdl_thread_send,(void *)t);
		ret = TRUE;
		break;
	case 3 : //protocol parsing thread
		rc = pthread_create(&threads[BRWS_THREAD_PROT_PARSER],NULL,hdl_thread_send,(void *)t);
		ret = TRUE;
		break;
	default:
		ret = FALSE;
		break;
	}
	return ret;
}


#if 0
class CSyncObject //: public CObject
{
#if 0 //AY
	DECLARE_DYNAMIC(CSyncObject)
#endif
public:
    CSyncObject(LPCTSTR pstrName);

public:
    operator HANDLE() const;
    HANDLE  m_hObject;

    virtual BOOL Lock(DWORD dwTimeout = INFINITE);
    virtual BOOL Unlock() = 0;
    virtual BOOL Unlock(LONG /* lCount */, LPLONG /* lpPrevCount=NULL */)
        { return TRUE; }

public:
    virtual ~CSyncObject();

    friend class CSingleLock;
    friend class CMultiLock;
};
#endif

CCriticalSection::CCriticalSection(){
	sem_init(&m_pObject, 0, 1);
}
CCriticalSection::~CCriticalSection(){
	sem_destroy(&m_pObject);
}
BOOL CCriticalSection::Lock(){
	sem_wait(&m_pObject);
	return TRUE;
}
BOOL CCriticalSection::Unlock()
{
	sem_post(&m_pObject);
	return TRUE;
}
BOOL CCriticalSection::Unlock(LONG lCount, LPLONG lPrevCount ){
	return TRUE;
}
BOOL  CCriticalSection::IsLocked(){
	int sval;
	sem_getvalue(&m_pObject, &sval);
	return (sval>0);
}

//Implementation of CSingLock
CSingleLock::CSingleLock(CCriticalSection* p){
	m_pObject = p;
	//sem_init(&m_pObject, 0, 1);
}
CSingleLock::~CSingleLock(){
	//sem_destroy(&m_pObject);
}
BOOL CSingleLock::Lock(){
	return m_pObject->Lock();
	//sem_wait(&m_pObject);

}
BOOL CSingleLock::Unlock(){
	return m_pObject->Unlock();
}
BOOL CSingleLock::Unlock(LONG lCount, LPLONG lPrevCount){
	return TRUE;
}
BOOL  CSingleLock::IsLocked(){

	return (m_pObject->IsLocked());
}
