/*
 * threadMngr.h
 *
 *  Created on: Dec 2, 2008
 *      Author: Andy Yang
 */

#ifndef THREADMNGR_H_
#define THREADMNGR_H_
#include <semaphore.h>

//typedef pthread_mutex_t CCriticalSection;
#define BRWS_NUMBER_THREADS	(4)
#define BRWS_THREAD_MAIN	(0)
#define BRWS_THREAD_SEND	(1)
#define BRWS_THREAD_RECEIVE (2)
#define BRWS_THREAD_PROT_PARSER (3)


BOOL create_thread(int action);

class CCriticalSection
{
// Constructors
public:
	CCriticalSection();
    ~CCriticalSection();

// Operations
public:
    //BOOL Lock(DWORD dwTimeOut = INFINITE);
    BOOL Lock();
    BOOL Unlock();
    BOOL Unlock(LONG lCount, LPLONG lPrevCount = NULL);
    BOOL IsLocked();

protected:
	sem_t  m_pObject;
   // HANDLE  m_hObject;
    BOOL    m_bAcquired;
};
//typedef CCriticalSection


class CSingleLock
{
// Constructors
public:
    CSingleLock(CCriticalSection *);
    ~CSingleLock();

// Operations
public:
    //BOOL Lock(DWORD dwTimeOut = INFINITE);
    BOOL Lock();
    BOOL Unlock();
    BOOL Unlock(LONG lCount, LPLONG lPrevCount = NULL);
    BOOL IsLocked();

protected:
	CCriticalSection *  m_pObject;
   // HANDLE  m_hObject;
    BOOL    m_bAcquired;
};
//typedef CCriticalSection
#endif /* THREADMNGR_H_ */
