////////////////////////////////////////////////////////////
//     Filename g4bin1.cpp
//
//     This file contains two parts which orignal from 
//     g4bin1m.asm and g4bin1s.asm
//     g4bin1m.asm convert tif mono file and g4bin1s.asm
//     convert tif strip file to Binary data.
//     Functions  g4bin1m() and g4bin1s() do the job now
//     g4bin1s() modified the asembly code at three places.
//	   Original developer   K.K
//     Lastest modifier     Ming Lu   
//     Date 05-27-1998
///////////////////////////////////////////////////////////	 
#include "stdafx.h"

#include "G_Compress.h"
//////////////////////////////////////////////////////////////////////////////////////////
extern "C" {
//////////////////////////////////////////////////////////////////////////////////////////
// THESE MOREON ROUTINES ARE NOT SAFE TO USE
//////////////////////////////////////////////////////////////////////////////////////////

int __stdcall g4bin1m(BYTE  *g4buffer, 
                      WORD  *binbuffer, 
                      DWORD g4memsize,
                      DWORD binmemsize, 
                      DWORD *_g4bufcnt,  
                      DWORD *_binbufcnt, 
                      WORD  _image_width,  // IN PIXEL
                      WORD  _linesperstrip, 
			          BYTE  _moretocome);

int __stdcall g4bin1s(BYTE  *g4buffer, 
                      WORD  *binbuffer, 
                      DWORD linesperstrip, 
                      DWORD *_binbufcnt, 
                      WORD  _image_width); // IN PIXEL

int __stdcall g4bin2m(BYTE  *g4buffer, 
                      WORD  *binbuffer, 
                      DWORD g4memsize,
                      DWORD binmemsize, 
                      DWORD *_g4bufcnt,  
                      DWORD *_binbufcnt, 
                      WORD _image_width,   // IN PIXEL
                      WORD _linesperstrip, 
			          BYTE _moretocome);

int __stdcall g4bin2s(BYTE  *g4buffer, 
                      WORD  *binbuffer, 
                      DWORD linesperstrip, 
                      DWORD *_binbufcnt, 
                      WORD _image_width);  // IN PIXEL
//////////////////////////////////////////////////////////////////////////////////////////////
//
//////////////////////////////////////////////////////////////////////////////////////////////
int __stdcall G4UncompressMono (BYTE  *g4buffer, 
                                WORD  *binbuffer,   
                                DWORD g4memsize,
                                DWORD binmemsize,        
                                DWORD *_g4bufcnt,   
                                DWORD *_binbufcnt, 
                                WORD  _image_width,   // IN PIXEL    
                                WORD  _linesperstrip, 
			                    BYTE  _moretocome,        
                                WORD  FillOrder)
{
DLL_THREAD_MANAGEMENT();

    switch (FillOrder) {
    case 1: //  default: pixels are arranged within a byte such that pixels with lower column values are stored in the higher-order bits of the byte.
        return g4bin1m(g4buffer, binbuffer, g4memsize, binmemsize, _g4bufcnt, _binbufcnt, 
                      _image_width,  _linesperstrip,  _moretocome);
    case 2: // pixels are arranged within a byte such that pixels with lower column values are stored in the lower-order bits of the byte.
        return g4bin2m(g4buffer, binbuffer, g4memsize, binmemsize, _g4bufcnt, _binbufcnt, 
                      _image_width,  _linesperstrip,  _moretocome);
    default:
        MessageBox(NULL, "Fill order  must be 1 or 2", "G4 Reader", MB_OK);
        return FALSE;
    }
}
//////////////////////////////////////////////////////////////////////////////////////////////
int __stdcall G4UncompressStrip (BYTE  *g4buffer, 
                                 WORD  *binbuffer, 
                                 DWORD linesperstrip, 
                                 DWORD *_binbufcnt, 
                                 WORD _image_width,    // IN PIXEL 
                                 WORD FillOrder) 
{
DLL_THREAD_MANAGEMENT();

    switch (FillOrder) {
    case 1: //  default: pixels are arranged within a byte such that pixels with lower column values are stored in the higher-order bits of the byte.
        return g4bin1s(g4buffer, binbuffer, linesperstrip, _binbufcnt,  _image_width);
    case 2: // pixels are arranged within a byte such that pixels with lower column values are stored in the lower-order bits of the byte.
        return g4bin2s(g4buffer, binbuffer, linesperstrip, _binbufcnt,  _image_width);
    default:
        MessageBox(NULL, "Fill order  must be 1 or 2", "G4 Reader", MB_OK);
        return FALSE;
    }
}
#if 0 // LOOK IN G3G4DECODE.CPP FOR A TEMP IMPLEMENTATION (SLOW)
//////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall G4Uncompress (PBYTE DataDst,  LONG DataCount, 
                             LONG  ImgWidth, LONG ImgHeight, // IN PIXEL
                             PBYTE RcvSrc,   LONG RcvCount)
{
DLL_THREAD_MANAGEMENT();

WORD   FillOrder     = 1;//  default: pixels are arranged within a byte such that pixels with lower column values are stored in the higher-order bits of the byte.
BYTE   MoreToCome    = FALSE;
WORD   LinesPerStrip = ImgHeight;
DWORD  RetG4Count, RetSrcCount;
int    G4Ret;
    
    G4Ret =
    G4UncompressMono ( RcvSrc,       // = BYTE  *g4buffer, 
               (PWORD) DataDst,      // = WORD  *binbuffer, 
                      
                       RcvCount,     // = DWORD g4memsize,
                       DataCount,    // = DWORD binmemsize, 
                      
                       &RetG4Count,  // = DWORD *_g4bufcnt,  
                       &RetSrcCount, // = DWORD *_binbufcnt, 

                       (ImgWidth), // = WORD _image_width
                       LinesPerStrip, 
			           MoreToCome,  
                       FillOrder);

    if(G4Ret == 0 ){
       return TRUE;
    }
    return FALSE;
}
#endif
//////////////////////////////////////////////////////////////////////////////////////////////
//
//////////////////////////////////////////////////////////////////////////////////////////////
WORD   ref_line[7200], cod_line[7200];
DWORD  g4bufcnt, g4mem;
WORD   image_width;

unsigned int  binbufcnt;
WORD   linecnt, passvalue, flag;
signed short a0, a1, b1=-1, b2;
DWORD  i=0, j=0;
WORD   bitcnt;
BYTE   cnt;
DWORD  bin_bitcnt, binbufcntp, binsize, g4bufcntp;

WORD black[]={0x100, 0x300,  0x700,  0xf00,
			  0x1f00,0x3f00, 0x7f00, 0xff00,
			  0xff01,0xff03, 0xff07, 0xff0f,
			  0xff1f,0xff3f, 0xff7f};	

WORD white[]={0xfeff, 0xfcff, 0xf8ff, 0xf0ff,
			  0xe0ff, 0xc0ff, 0x80ff, 0x00ff,
			  0x00fe, 0x00fc, 0x00f8, 0x00f0,
			  0x00e0, 0x00c0, 0x0080};

WORD *pwhite, *pblack;
DWORD valebp, valesi, valedi;
WORD  *pref_line, *pcod_line;	
int retval;	
	
#define prepare_g4bit(a) __asm		\
{		\
	 __asm	dec	bx		\
	 __asm	jns	g4same##a		\
	 __asm	mov	bx,7	\
	 __asm	inc	esi		\
	__asm g4same##a:	 __asm	bt	[eax][esi],bx	\
}

//////////////////////////////////////////////////////////////////////////
// Function int g4bin1m()
//          conversion g4bin for monolithic and fill_order=1
//	        Converts a full no of lines.
//  	    By the end of each line, it checks if still enough space to
//  	    read a full g4 line (45k taken as covering quantity) and to
//	        write a full binary line (image_width/8).
//          Ref_line and g4bitcnt values are transfered between buffers,
//	        as static variables.
// Returns  0   Success
//          1   not finished
//         -1   error   
///////////////////////////////////////////////////////////////////////////

int __stdcall g4bin1m(BYTE  *g4buffer, 
                      WORD  *binbuffer, 
                      DWORD g4memsize,
                      DWORD binmemsize, 
                      DWORD *_g4bufcnt,  
                      DWORD *_binbufcnt, 
                      WORD  _image_width, // IN PIXEL
                      WORD  _linesperstrip, 
			          BYTE  _moretocome)

{
DLL_THREAD_MANAGEMENT();

	pref_line = ref_line;
	pcod_line=cod_line;
	pblack=black;
	pwhite= white;
    __asm
    {  
		mov DWORD PTR valebp,ebp
		mov DWORD PTR valesi,esi
		mov DWORD PTR valedi,edi
	
		mov  eax,g4buffer 
		mov  edx,binbuffer 
		mov  ebx,g4memsize 
		mov  ecx,binmemsize 

		mov	 di, _image_width // >> 3  _image_width IS IN PIXEL 
		mov	image_width,di        
		shr	di,3		
		bt	di,0
		jnc     isshort
		inc	di

isshort:        movzx	edi,di
		sub	ecx,edi
		mov	binsize,ecx		;save binmemsize minus safety
		mov	cl,_moretocome  ;read moretocome
		cmp	cl,0
		je	lastbuf
		sub	ebx,45000
lastbuf:	mov	g4mem,ebx		;save g4memsize minus safety
		mov	edi,_g4bufcnt 		;read add for g4bufcnt
		mov	g4bufcntp,edi
		mov	edi,_binbufcnt  	;read add for binbufcnt
		mov	binbufcntp,edi
		mov	g4bufcnt,0
		mov	binbufcnt,0
		mov	passvalue,0
		mov	bin_bitcnt,15
		mov	cx,b1         ;see if first buf: b1=-1 if first file
		cmp	cx,0	      ;or linecnt=0 (from previous conversion)
		js	firstbuf      ;for next files
		mov	cx,linecnt
		cmp	cx,0
		jne 	length_loop
firstbuf:	mov	bx,_linesperstrip  
		mov	linecnt,bx     ;Initializes linecnt with linesperstrip
		mov	ecx, pref_line
		mov	bx,image_width
		mov	[ecx],bx                ;Initializes ref_line and b1
		mov	b1,bx                   ;for first line in strip
		mov	bitcnt,8
length_loop:	mov	a0,-1
		mov	i,0
		mov	j,0
		mov	ecx, pref_line
width_loop:	mov	bx,b1
		cmp     bx,image_width
		jne	calc_b2                 ;if b1 at end of line
		mov	b2,bx			;b2=b1=image_width
		jmp	g4_tree
calc_b2:	mov	ebp,i
		inc	ebp
		add	bx,[ecx][ebp*2]
		mov	b2,bx			;b2=b1+ref_line[i+1]
	;Uses EAX(g4buf),ESI(g4bufcnt),BX(bitcnt)
	;EAX is preserved through the functions called, BX and ESI are not
	;Passes left and right position through CX(-3 to +3)
	;returns error or correct op from horizontal in CX
	;return towards the end of width_loop at end_g4_code
g4_tree:        mov	bx,bitcnt
		mov	esi,g4bufcnt
		prepare_g4bit(1)
		jnc	g4a0
		mov	g4bufcnt,esi
		mov	bitcnt,bx			;1=>V(0)
		mov    	cx,0
		jmp	vert_left
g4a0:	    	prepare_g4bit(2)  				;0
		jnc	g4a00
		prepare_g4bit(3)				;01
		mov	g4bufcnt,esi
		mov	bitcnt,bx
		jnc	g4a010
		mov	cx,1                            ;011=>VR(1)
		jmp	vert_right
g4a010:		mov	cx,-1				;010=>VL(1)
		jmp	vert_left
g4a00:		prepare_g4bit(4)				;00
		jnc	g4a000
		mov	g4bufcnt,esi
		mov	bitcnt,bx
		jmp	horizont                	;001=>H
g4a000:		prepare_g4bit(5)				;000
		jnc	g4a0000
		mov	g4bufcnt,esi
		mov	bitcnt,bx
		mov	cx,b2       			;0001=>P
		sub	cx,a0
		add	passvalue,cx
		mov	cx,b2
		mov	a0,cx
		inc	i
		inc	i
		mov	ebx, pref_line
		mov	ebp,i
		add	cx,[ebx][ebp*2]
		mov	b1,cx
		mov	ecx,0
		jmp	end_g4_code
g4a0000:	prepare_g4bit(6)				;0000
		jnc	g4a00000
		prepare_g4bit(7)				;00001
		mov	bitcnt,bx
		mov	g4bufcnt,esi
		jnc	g4a000010
		mov	cx,2				;000011=>VR(2)
		jmp	vert_right
g4a000010:	mov	cx,-2				;000010=>VL(2)
		jmp	vert_left
g4a00000:	prepare_g4bit(8)				;00000
		jnc	g4a000000
		prepare_g4bit(9)				;000001
		mov	bitcnt,bx
		mov	g4bufcnt,esi
		jnc	g4a0000010
		mov	cx,3				;0000011=>VR(3)
		jmp	vert_right
g4a0000010:	mov	cx,-3				;0000010=>VL(3)
		jmp	vert_left
g4a000000:      
		mov	edi,binbufcnt
		mov	eax,binbufcntp
		mov	[eax],edi
;		mov	eax,-1                          ;return error
		jmp	finish_g4rl

end_g4_code:	cmp	ecx,-1
		je	    g4a000000
		mov	ecx, pref_line
		mov	bx,a0
		cmp	bx,image_width
		jne	width_loop
		mov	edi,binbufcnt
;
		mov	ebx,bin_bitcnt
		cmp	bx,15
		je	nopadding
		mov	si,[edx][edi]
		mov	ebp, pwhite
		and	si,[ebp][ebx*2]
		mov	[edx][edi],si
		inc	edi
		inc	edi
nopadding:	mov	bin_bitcnt,15
		mov	binbufcnt,edi
		mov	di,linecnt
		dec	di
		mov	linecnt,di
		jnz	update_ref
		mov	esi,g4bufcnt
		mov	eax,g4bufcntp
		mov	[eax],esi
		mov	edi,binbufcnt
		mov	eax,binbufcntp			;return binbufcnt   
		mov	[eax],edi
		mov	eax,0
		jmp finish_g4rl

update_ref:	mov     ecx,j           		;prepare ref line
		mov     esi, pcod_line
		mov	edi, pref_line
		rep	movsw
		mov	cx,b1				;prepare first b1
		mov	edi, pref_line
		mov	cx,[edi]
		mov	b1,cx
;
		mov	esi,g4bufcnt                    ;check g4buffer ended
		mov	edi,binbufcnt			;check binbuffer ended
		mov	ecx,g4mem
		cmp	esi,ecx
		jg      full_buf
		mov	ecx,binsize
		cmp	edi,ecx
		jbe	length_loop
full_buf:       mov	eax,g4bufcntp
		mov	[eax],esi
		mov	eax,binbufcntp			;return binbufcnt
		mov	[eax],edi
		mov	eax,1
		jmp	finish_g4rl
;
;	VERT_LEFT function solves the vertical left and zero codes
;				Registers used:
;					Input	EAX -g4buffer
;						EDX -rlbuffer
;						ECX -position (0 to -3)
;                               	Output	ECX -correct (if 0)
;					Uses all the other regs except ESI
;
;
vert_left:	mov	edi,binbufcnt
		mov	ebp,j
		cmp	ebp,0
		jnz	save_vl
		mov	bx,passvalue
		dec	bx
		mov	passvalue,bx
save_vl:	add	cx,b1
		mov	a1,cx
		sub	cx,a0                  ;b1-pos-a0
		add	cx,passvalue	       ;b1-pos-a0+passvalue
		mov	ebx, pcod_line
		mov	[ebx][ebp*2],cx
;
		mov	ebx,bin_bitcnt
		mov	si,[edx][edi]
		bt	ebp,0
		jc	vlb_makebin
vlw_makebin:    cmp	cx,0
		jz      vl_endbin              ;If 0 don't write anything
		cmp	bx,15
		jne	vlw_bin1
		cmp	cx,32
		js 	vlw_bin3
		mov	si,cx
		and	si,001fh
		shr	cx,5
vlw_bin2:	mov	dword ptr [edx][edi],0
		add	edi,4
		dec	cx
		jnz	vlw_bin2
		cmp	si,0
		je	vl_endbin
		mov	cx,si
vlw_bin3:	mov	word ptr [edx][edi],0
		cmp	cx,16
		js	vlw_bin4
		add	edi,2
		mov	word ptr [edx][edi],0
		sub	cx,16
vlw_bin4:       sub	bx,cx
		jmp	vl_endbin
vlw_bin1:       mov	ebp, pwhite
		inc	bx
		cmp	cx,bx
		js	vlw_bin6
		sub	cx,bx
		dec	bx
		and	si,[ebp][ebx*2]
		mov     [edx][edi],si
		add	edi,2
		mov	bx,15
		jmp	vlw_makebin
vlw_bin6:	dec	bx
		and	si,[ebp][ebx*2]
		sub	bx,cx
		mov	[edx][edi],si
		jmp	vl_endbin
vlb_makebin:    cmp	cx,0
		jz      vl_endbin              ;If 0 don't write anything
		cmp	bx,15
		jne	vlb_bin1
		cmp	cx,32
		js 	vlb_bin3
		mov	si,cx
		and	si,001fh
		shr	cx,5
vlb_bin2:	mov	dword ptr [edx][edi],0ffffffffh
		add	edi,4
		dec	cx
		jnz	vlb_bin2
		cmp	si,0
		je	vl_endbin
		mov	cx,si
vlb_bin3:	mov	word ptr [edx][edi],0ffffh
		cmp	cx,16
		js	vlb_bin4
		add	edi,2
		mov	word ptr [edx][edi],0ffffh
		sub	cx,16
vlb_bin4:       sub	bx,cx
		jmp	vl_endbin
vlb_bin1:       mov	ebp, pblack
		inc	bx
		cmp	cx,bx
		js	vlb_bin6
		sub	cx,bx
		dec	bx
		or	si,[ebp][ebx*2]
		mov     [edx][edi],si
		add	edi,2
		mov	bx,15
		jmp	vlb_makebin
vlb_bin6:	dec	bx
		or	si,[ebp][ebx*2]
		sub	bx,cx
		mov	[edx][edi],si
vl_endbin:	mov	bin_bitcnt,ebx
;
		mov	ebp,j
		mov	cx,a1
		cmp	cx,image_width
		jbe	inside_vl
		sub	cx,image_width
		sub	[ebx][ebp*2],cx
		mov	cx,image_width
inside_vl:	inc	ebp
		mov	j,ebp
		mov	binbufcnt,edi
		mov	a0,cx
		mov	ebp,i
		mov	ebx, pref_line
		mov	di,b1
		sub	di,[ebx][ebp*2]
		cmp	di,a0
		jbe	left_b1
		dec	ebp
		jmp	fin_vl
left_b1:	mov	di,b1
		cmp	di,image_width
		jae	fin_vl
		inc	ebp
		add	di,[ebx][ebp*2]
fin_vl:		mov	i,ebp
		mov	b1,di
		mov	passvalue,0
		mov	ecx,0
		jmp	end_g4_code
;
;	VERT_RIGHT function solves the vertical right codes
;				Registers used:
;					Input	EAX -g4buffer
;						EDX -rlbuffer
;						ECX -position (1 to 3)
;                               	Output	ECX -correct (if 0)
;					Uses all the other regs except ESI
;
vert_right:	mov	edi,binbufcnt
		mov	ebp,j
		cmp	ebp,0
		jnz	save_vr
		mov	bx,passvalue
		dec 	bx
		mov	passvalue,bx
save_vr:	add	cx,b1			;pos+b1
		mov	a1,cx			;a1=b1+pos
		sub	cx,a0			;pos+b1-a0
		add	cx,passvalue
		mov	ebx, pcod_line
		mov	[ebx][ebp*2],cx
;
		mov	ebx,bin_bitcnt
		mov	si,[edx][edi]
		bt	ebp,0
		jc	vrb_makebin
vrw_makebin:    cmp	cx,0
		jz      vr_endbin              ;If 0 don't write anything
		cmp	bx,15
		jne	vrw_bin1
		cmp	cx,32
		js 	vrw_bin3
		mov	si,cx
		and	si,001fh
		shr	cx,5
vrw_bin2:	mov	dword ptr [edx][edi],0
		add	edi,4
		dec	cx
		jnz	vrw_bin2
		cmp	si,0
		je	vr_endbin
		mov	cx,si
vrw_bin3:	mov	word ptr [edx][edi],0
		cmp	cx,16
		js	vrw_bin4
		add	edi,2
		mov	word ptr [edx][edi],0
		sub	cx,16
vrw_bin4:       sub	bx,cx
		jmp	vr_endbin
vrw_bin1:       mov	ebp, pwhite
		inc	bx
		cmp	cx,bx
		js	vrw_bin6
		sub	cx,bx
		dec	bx
		and	si,[ebp][ebx*2]
		mov     [edx][edi],si
		add	edi,2
		mov	bx,15
		jmp	vrw_makebin
vrw_bin6:	dec	bx
		and	si,[ebp][ebx*2]
		sub	bx,cx
		mov	[edx][edi],si
		jmp	vr_endbin
vrb_makebin:    cmp	cx,0
		jz      vr_endbin              ;If 0 don't write anything
		cmp	bx,15
		jne	vrb_bin1
		cmp	cx,32
		js 	vrb_bin3
		mov	si,cx
		and	si,001fh
		shr	cx,5
vrb_bin2:	mov	dword ptr [edx][edi],0ffffffffh
		add	edi,4
		dec	cx
		jnz	vrb_bin2
		cmp	si,0
		je	vr_endbin
		mov	cx,si
vrb_bin3:	mov	word ptr [edx][edi],0ffffh
		cmp	cx,16
		js	vrb_bin4
		add	edi,2
		mov	word ptr [edx][edi],0ffffh
		sub	cx,16
vrb_bin4:       sub	bx,cx
		jmp	vr_endbin
vrb_bin1:       mov	ebp, pblack
		inc	bx
		cmp	cx,bx
		js	vrb_bin6
		sub	cx,bx
		dec	bx
		or	si,[ebp][ebx*2]
		mov     [edx][edi],si
		add	edi,2
		mov	bx,15
		jmp	vrb_makebin
vrb_bin6:	dec	bx
		or	si,[ebp][ebx*2]
		sub	bx,cx
		mov	[edx][edi],si
vr_endbin: 	mov	bin_bitcnt,ebx
;
		mov	ebp,j
		mov	cx,a1
		cmp	cx,image_width
		jbe	inside_vr
		sub	cx,image_width
		sub	[ebx][ebp*2],cx
		mov	cx,image_width
inside_vr:	inc	ebp
		mov	j,ebp
		mov	binbufcnt,edi
		mov	a0,cx			;a0=a1
		mov	ebp,i
		mov	ebx, pref_line
		mov	di,b1
		inc	ebp
		add	di,[ebx][ebp*2]
make_ivr:       cmp	cx,di
		jb	fin_vr
		cmp	di,image_width
		jae	fin_vr
		inc	ebp
		add	di,[ebx][ebp*2]
		cmp	di,image_width
		jae	fin_vr
		inc	ebp
		add	di,[ebx][ebp*2]
		jmp	make_ivr
fin_vr:		mov	i,ebp
		mov	b1,di
		mov	passvalue,0
		mov	ecx,0
		jmp	end_g4_code
;
;	HORIZONT function solves the horizontal codes
;				Registers used:
;					Input	EAX -g4buffer
;						EDX -rlbuffer
;                               	Output	ECX -correct (if 0)
;						    -error code(if -1)
;					Uses all the other regs
horizont:	mov	cnt,2
		mov	edi,binbufcnt
		mov	ebp,j
;	dec passvalue if the first ellement in line
		mov	flag,0
		cmp	ebp,0
		jnz	read_g3
		mov	cx,passvalue
		cmp	cx,0
		jz	nopass
		mov	flag,1
		jmp	read_g3
;	read g3 info in cx register
nopass:		mov	a0,0
read_g3:	mov	cx,0
		mov	bx,bitcnt
		mov	esi,g4bufcnt
		bt	ebp,0			;see if j even or odd
		jnc	wg3			;white g3
		jmp	bg3			;black g3
;	save g3 info from cx in rl buffer
save_g3:        mov	bitcnt,bx 		;save new bitcnt
		mov	g4bufcnt,esi
		cmp	cx,0                    ;if -1 error code return
		js	error_code
		add	a0,cx
		add	cx,passvalue
		sub	cx,flag
		mov	ebx, pcod_line
		mov	[ebx][ebp*2],cx		;save rl in the coding line
;
		mov	ebx,bin_bitcnt
		mov	si,[edx][edi]
		bt	ebp,0
		jc	hb_makebin
hw_makebin:    	cmp	cx,0
		jz      h_endbin              ;If 0 don't write anything
		cmp	bx,15
		jne	hw_bin1
		cmp	cx,32
		js 	hw_bin3
		mov	si,cx
		and	si,001fh
		shr	cx,5
hw_bin2:	mov	dword ptr [edx][edi],0
		add	edi,4
		dec	cx
		jnz	hw_bin2
		cmp	si,0
		je	h_endbin
		mov	cx,si
hw_bin3:	mov	word ptr [edx][edi],0
		cmp	cx,16
		js	hw_bin4
		add	edi,2
		mov	word ptr [edx][edi],0
		sub	cx,16
hw_bin4:        sub	bx,cx
		jmp	h_endbin
hw_bin1:        mov	ebp, pwhite
		inc	bx
		cmp	cx,bx
		js	hw_bin6
		sub	cx,bx
		dec	bx
		and	si,[ebp][ebx*2]
		mov     [edx][edi],si
		add	edi,2
		mov	bx,15
		jmp	hw_makebin
hw_bin6:	dec	bx
		and	si,[ebp][ebx*2]
		sub	bx,cx
		mov	[edx][edi],si
		jmp	h_endbin
hb_makebin:	cmp	cx,0
		jz      h_endbin              ;If 0 don't write anything
		cmp	bx,15
		jne	hb_bin1
		cmp	cx,32
		js 	hb_bin3
		mov	si,cx
		and	si,001fh
		shr	cx,5
hb_bin2:	mov	dword ptr [edx][edi],0ffffffffh
		add	edi,4
		dec	cx
		jnz	hb_bin2
		cmp	si,0
		je	h_endbin
		mov	cx,si
hb_bin3:	mov	word ptr [edx][edi],0ffffh
		cmp	cx,16
		js	hb_bin4
		add	edi,2
		mov	word ptr [edx][edi],0ffffh
		sub	cx,16
hb_bin4:        sub	bx,cx
		jmp	h_endbin
hb_bin1:        mov	ebp, pblack
		inc	bx
		cmp	cx,bx
		js	hb_bin6
		sub	cx,bx
		dec	bx
		or	si,[ebp][ebx*2]
		mov     [edx][edi],si
		add	edi,2
		mov	bx,15
		jmp	hb_makebin
hb_bin6:	dec	bx
		or	si,[ebp][ebx*2]
		sub	bx,cx
		mov	[edx][edi],si
h_endbin: 	mov	bin_bitcnt,ebx
;
		mov	ebp,j
		mov	cx,a0
		cmp	cx,image_width
		jbe	inside_line             ;If exceeding image_width,
		sub	cx,image_width		;adjust at image_width
		sub	[ebx][ebp*2],cx         ;both cod_line[j] and pixcnt
		mov	cx,image_width
inside_line:	mov	passvalue,0
		mov	a0,cx
		inc	ebp
		dec	cnt
		mov	flag,0
		mov	j,ebp
		jnz	read_g3
		mov	binbufcnt,edi           ;save new binbufcnt
		mov	ebx, pref_line
		mov	ebp,i
		mov	di,b1
make_i:		cmp	cx,di
		jb	fin_horiz
		cmp	di,image_width
		jae	fin_horiz
		inc	ebp
		add	di,[ebx][ebp*2]
		cmp	di,image_width
		jae	fin_horiz
		inc	ebp
		add	di,[ebx][ebp*2]
		jmp	make_i
fin_horiz:	mov	i,ebp
		mov	b1,di
		mov	ecx,0
		jmp	end_g4_code
error_code:	mov	ecx,-1
		jmp     end_g4_code
;
;	WhiteG3 function decodes g3 info in horizontal encoding
;				Registers used:
;					Input	EAX -g4buffer
;						ESI -g4bufcnt
;						 BX -bitcnt
;                               	Output	 CX -runlength (if>=0)
;						    -error code(if -1)
;					Doesn't use other regs
wg3:       	prepare_g4bit(10)
		jnc	wa0
		prepare_g4bit(11)			;1
		jnc	wa10
		prepare_g4bit(12)			;11
		jnc	wa110
		prepare_g4bit(13)			;111
		jnc	wa1110
		add	cx,7			;1111=>7
		jmp	save_g3
wa1110:         add	cx,6			;1110=>6
		jmp	save_g3
wa110:          prepare_g4bit(14)			;110
		jnc	wa1100
		prepare_g4bit(15)			;1101
		jnc	wa11010
		add	cx,64			;11011=>64
		jmp	wg3
wa11010:        prepare_g4bit(16)			;11010
		jnc	wa110100
		add	cx,15			;110101=>15
		jmp	save_g3
wa110100:       add	cx,14			;110100=>14
		jmp	save_g3
wa1100:		add	cx,5			;1100=>5
		jmp	save_g3
wa10:           prepare_g4bit(17)			;10
		jnc	wa100
		prepare_g4bit(18)			;101
		jnc	wa1010
		add	cx,4			;1011=>4
		jmp	save_g3
wa1010:         prepare_g4bit(19)			;1010
		jnc	wa10100
		prepare_g4bit(20)			;10101
		jnc	wa101010
		add	cx,17			;101011=>17
		jmp	save_g3
wa101010:       add	cx,16			;101010=>16
		jmp	save_g3
wa10100:        add	cx,9			;10100=>9
		jmp	save_g3
wa100:          prepare_g4bit(21)			;100
		jnc	wa1000
		prepare_g4bit(22)			;1001
		jnc	wa10010
		add	cx,8			;10011=>8
		jmp	save_g3
wa10010:        add	cx,128			;10010=>128
		jmp	wg3
wa1000:         add	cx,3			;1000=>3
		jmp	save_g3
wa0:            prepare_g4bit(23)			;0
		jnc	wa00
		prepare_g4bit(24)			;01
		jnc	wa010
		prepare_g4bit(25)			;011
		jnc	wa0110
		add	cx,2			;0111=>2
		jmp	save_g3
wa0110:         prepare_g4bit(26)			;0110
		jnc	wa01100
		prepare_g4bit(27)			;01101
		jnc	wa011010
		prepare_g4bit(28)			;011011
		jnc	wa0110110
		add	cx,256			;0110111=>256
		jmp	wg3
wa0110110:      prepare_g4bit(29)			;0110110
		jnc	wa01101100
		prepare_g4bit(30)			;01101101
		jnc	wa011011010
		add	cx,1408			;011011011=>1408
		jmp	wg3
wa011011010:    add	cx,1344			;011011010=>1344
		jmp	wg3
wa01101100:     prepare_g4bit(31)			;01101100
		jnc	wa011011000
		add	cx,1280			;011011001=>1280
		jmp	wg3
wa011011000:    add	cx,1216			;011011000=>1216
		jmp	wg3
wa011010:       prepare_g4bit(32)			;011010
		jnc	wa0110100
		prepare_g4bit(33)                   ;0110101
		jnc	wa01101010
		prepare_g4bit(34)			;01101011
		jnc	wa011010110
		add	cx,1152			;011010111=>1152
		jmp	wg3
wa011010110:    add	cx,1088			;011010110=>1088
		jmp	wg3
wa01101010:     prepare_g4bit(35)			;01101010
		jnc	wa011010100
		add	cx,1024			;011010101=>1024
		jmp	wg3
wa011010100:    add	cx,960			;011010100=>960
		jmp	wg3
wa0110100:      prepare_g4bit(36)			;0110100
		jnc	wa01101000
		prepare_g4bit(37)			;01101001
		jnc	wa011010010
		add	cx,896			;011010011=>896
		jmp	wg3
wa011010010:    add	cx,832			;011010010=>832
		jmp	wg3
wa01101000:     add	cx,576			;01101000=>576
		jmp	wg3
wa01100:        prepare_g4bit(38)			;01100
		jnc	wa011000
		prepare_g4bit(39)			;011001
		jnc	wa0110010
		prepare_g4bit(40)			;0110011
		jnc	wa01100110
		add	cx,640			;01100111=>640
		jmp	wg3
wa01100110:     prepare_g4bit(41)			;01100110
		jnc	wa011001100
		add	cx,768			;011001101=>768
		jmp	wg3
wa011001100:    add	cx,704			;011001100=>704
		jmp	wg3
wa0110010:      prepare_g4bit(42)			;0110010
		jnc	wa01100100
		add	cx,512			;01100101=>512
		jmp	wg3
wa01100100:     add	cx,448			;01100100=>448
		jmp	wg3
wa011000:       add	cx,1664			;011000=>1664
		jmp	wg3
wa010:          prepare_g4bit(43)			;010
		jnc	wa0100
		prepare_g4bit(44)			;0101
		jnc	wa01010
		prepare_g4bit(45)			;01011
		jnc	wa010110
		add	cx,192			;010111=>192
		jmp	wg3
wa010110:       prepare_g4bit(46)			;010110
		jnc	wa0101100
		prepare_g4bit(47)			;0101101
		jnc	wa01011010
		add	cx,58			;01011011=>58
		jmp	save_g3
wa01011010:     add	cx,57			;01011010=>57
		jmp	save_g3
wa0101100:      prepare_g4bit(48)			;0101100
		jnc	wa01011000
		add	cx,56			;01011001=>56
		jmp	save_g3
wa01011000:     add	cx,55			;01011000=>55
		jmp	save_g3
wa01010:        prepare_g4bit(49)			;01010
		jnc	wa010100
		prepare_g4bit(50)			;010101
		jnc	wa0101010
		add	cx,25			;0101011=>25
		jmp	save_g3
wa0101010:      prepare_g4bit(51)			;0101010
		jnc	wa01010100
		add	cx,52			;01010101=>52
		jmp	save_g3
wa01010100:     add	cx,51			;01010100=>51
		jmp	save_g3
wa010100:       prepare_g4bit(52)			;010100
		jnc	wa0101000
		prepare_g4bit(53)			;0101001
		jnc	wa01010010
		add	cx,50			;01010011=>50
		jmp	save_g3
wa01010010:     add	cx,49			;01010010=>49
		jmp	save_g3
wa0101000:      add	cx,24			;0101000=>24
		jmp	save_g3
wa0100:         prepare_g4bit(54)			;0100
		jnc	wa01000
		prepare_g4bit(55)			;01001
		jnc	wa010010
		prepare_g4bit(56)			;010011
		jnc	wa0100110
		add	cx,18			;0100111=>18
		jmp	save_g3
wa0100110:	prepare_g4bit(57)			;0100110
		jnc	wa01001100
		prepare_g4bit(58)			;01001101
		jnc	wa010011010
		add	cx,1728			;010011011=>1728
		jmp	wg3
wa010011010:    add	cx,1600			;010011010=>1600
		jmp	wg3
wa01001100:     prepare_g4bit(59)			;01001100
		jnc	wa010011000
		add	cx,1536			;010011001=>1536
		jmp	wg3
wa010011000:    add	cx,1472			;010011000=>1472
		jmp	wg3
wa010010:       prepare_g4bit(60)			;010010
		jnc	wa0100100
		prepare_g4bit(61)			;0100101
		jnc	wa01001010
		add	cx,60			;01001011=>60
		jmp	save_g3
wa01001010:     add	cx,59			;01001010=>59
		jmp	save_g3
wa0100100:      add	cx,27			;0100100=>27
		jmp	save_g3
wa01000:        add	cx,11			;01000=>11
		jmp	save_g3
wa00:           prepare_g4bit(62)			;00
		jnc	wa000
		prepare_g4bit(63)			;001
		jnc	wa0010
		prepare_g4bit(64)			;0011
		jnc	wa00110
		add	cx,10			;00111=>10
		jmp	save_g3
wa00110:        prepare_g4bit(65)			;00110
		jnc	wa001100
		prepare_g4bit(66)			;001101
		jnc	wa0011010
		prepare_g4bit(67)			;0011011
		jnc	wa00110110
		add	cx,384			;00110111=>384
		jmp	wg3
wa00110110:     add	cx,320			;00110110=>320
		jmp	wg3
wa0011010:      prepare_g4bit(68)			;0011010
		jnc	wa00110100
		add	cx,0			;00110101=>0
		jmp	save_g3
wa00110100:     add	cx,63			;00110100=>63
		jmp	save_g3
wa001100:       prepare_g4bit(69)			;001100
		jnc	wa0011000
		prepare_g4bit(70)			;0011001
		jnc	wa00110010
		add	cx,62			;00110011=>62
		jmp	save_g3
wa00110010:     add	cx,61			;00110010=>61
		jmp	save_g3
wa0011000:      add	cx,28			;0011000=>28
		jmp	save_g3
wa0010:         prepare_g4bit(71)			;0010
		jnc	wa00100
		prepare_g4bit(72)			;00101
		jnc	wa001010
		prepare_g4bit(73)			;001011
		jnc	wa0010110
		add	cx,21			;0010111=>21
		jmp	save_g3
wa0010110:      prepare_g4bit(74)			;0010110
		jnc	wa00101100
		add	cx,44			;00101101=>44
		jmp	save_g3
wa00101100:     add	cx,43			;00101100=>43
		jmp	save_g3
wa001010:       prepare_g4bit(75)			;001010
		jnc	wa0010100
		prepare_g4bit(76)			;0010101
		jnc	wa00101010
		add	cx,42			;00101011=>42
		jmp	save_g3
wa00101010:     add	cx,41			;00101010=>41
		jmp	save_g3
wa0010100:      prepare_g4bit(77)			;0010100
		jnc	wa00101000
		add	cx,40			;00101001=>40
		jmp	save_g3
wa00101000:     add	cx,39			;00101000=>39
		jmp	save_g3
wa00100:        prepare_g4bit(78)			;00100
		jnc	wa001000
		prepare_g4bit(79)			;001001
		jnc	wa0010010
		add	cx,26			;0010011=>26
		jmp	save_g3
wa0010010:      prepare_g4bit(80)			;0010010
		jnc	wa00100100
		add	cx,54			;00100101=>54
		jmp	save_g3
wa00100100:     add	cx,53			;00100100=>53
		jmp	save_g3
wa001000:       add	cx,12			;001000=>12
		jmp	save_g3
wa000:          prepare_g4bit(81)			;000
		jnc	wa0000
		prepare_g4bit(82)			;0001
		jnc	wa00010
		prepare_g4bit(83)			;00011
		jnc	wa000110
		add	cx,1			;000111=>1
		jmp	save_g3
wa000110:       prepare_g4bit(84)			;000110
		jnc	wa0001100
		prepare_g4bit(85)			;0001101
		jnc	wa00011010
		add	cx,32			;00011011=>32
		jmp	save_g3
wa00011010:	add	cx,31			;00011010=>31
		jmp	save_g3
wa0001100:      add	cx,19			;0001100=>19
		jmp	save_g3
wa00010:        prepare_g4bit(86)			;00010
		jnc	wa000100
		prepare_g4bit(87)			;000101
		jnc	wa0001010
		prepare_g4bit(88)			;0001011
		jnc	wa00010110
		add	cx,38			;00010111=>38
		jmp	save_g3
wa00010110:     add	cx,37			;00010110=>37
		jmp	save_g3
wa0001010:      prepare_g4bit(89)			;0001010
		jnc	wa00010100
		add	cx,36			;00010101=>36
		jmp	save_g3
wa00010100:     add	cx,35			;00010100=>35
		jmp	save_g3
wa000100:       prepare_g4bit(90)			;000100
		jnc	wa0001000
		prepare_g4bit(91)			;0001001
		jnc	wa00010010
		add	cx,34			;00010011=>34
		jmp	save_g3
wa00010010:     add	cx,33			;00010010=>33
		jmp	save_g3
wa0001000:      add	cx,20			;0001000=>20
		jmp	save_g3
wa0000:         prepare_g4bit(92)			;0000
		jnc	wa00000
		prepare_g4bit(93)			;00001
		jnc	wa000010
		add	cx,13			;000011=>13
		jmp	save_g3
wa000010:       prepare_g4bit(94)			;000010
		jnc	wa0000100
		prepare_g4bit(95)			;0000101
		jnc	wa00001010
		add	cx,48			;00001011=>48
		jmp	save_g3
wa00001010:     add	cx,47			;00001010=>47
		jmp	save_g3
wa0000100:      add	cx,23			;0000100=>23
		jmp	save_g3
wa00000:        prepare_g4bit(96)			;00000
		jnc	wa000000
		prepare_g4bit(97)			;000001
		jnc	wa0000010
		add	cx,22			;0000011=>22
		jmp	save_g3
wa0000010:      prepare_g4bit(98)			;0000010
		jnc	wa00000100
		add	cx,46			;00000101=>46
		jmp	save_g3
wa00000100:     add	cx,45			;00000100=>45
		jmp	save_g3
wa000000:       prepare_g4bit(99)			;000000
		jnc	wa0000000
		prepare_g4bit(100)			;0000001
		jnc	wa00000010
		add	cx,30			;00000011=>30
		jmp	save_g3
wa00000010:     add	cx,29			;00000010=>29
		jmp	save_g3
wa0000000:      prepare_g4bit(101)			;0000000
		jnc	wa00000000
		prepare_g4bit(102)			;00000001
		jnc	wa000000010
		prepare_g4bit(103)			;000000011
		jnc	wa0000000110
		prepare_g4bit(104)			;0000000111
		jnc	wa00000001110
		prepare_g4bit(105)			;00000001111
		jnc	wa000000011110
		add	cx,2560			;000000011111=>2560
		jmp	wg3
wa000000011110: add	cx,2496			;000000011110=>2496
		jmp	wg3
wa00000001110:  prepare_g4bit(106)			;00000001110
		jnc	wa000000011100
		add	cx,2432			;000000011101=>2432
		jmp	wg3
wa000000011100: add	cx,2368			;000000011100=>2368
		jmp	wg3
wa0000000110:   prepare_g4bit(107)			;0000000110
		jnc	wa00000001100
		add	cx,1920			;00000001101=>1920
		jmp	wg3
wa00000001100:  add	cx,1856			;00000001100=>1856
		jmp	wg3
wa000000010:    prepare_g4bit(108)			;000000010
		jnc	wa0000000100
		prepare_g4bit(109)			;0000000101
		jnc	wa00000001010
		prepare_g4bit(110)			;00000001011
		jnc	wa000000010110
		add	cx,2304			;000000010111=>2304
		jmp	wg3
wa000000010110: add	cx,2240			;000000010110=>2240
		jmp	wg3
wa00000001010:  prepare_g4bit(111)			;00000001010
		jnc	wa000000010100
		add	cx,2176			;000000010101=>2176
		jmp	wg3
wa000000010100: add	cx,2112			;000000010100=>2112
		jmp	wg3
wa0000000100:	prepare_g4bit(112)			;0000000100
		jnc	wa00000001000
		prepare_g4bit(113)			;00000001001
		jnc	wa000000010010
		add	cx,2048			;000000010011=>2048
		jmp	wg3
wa000000010010: add	cx,1984			;000000010010=>1984
		jmp	wg3
wa00000001000:  add	cx,1792			;00000001000=>1792
		jmp	wg3
wa00000000:     mov	cx,-1			;error
		jmp	save_g3
;
;	BlackG3 function decodes g3 info in horizontal encoding
;				Registers used:
;					Input	EAX -g4buffer
;						ESI -g4bufcnt
;						 BX -bitcnt
;                               	Output	 CX -runlength (if>=0)
;						    -error code(if -1)
;					Doesn't use other regs
bg3:		prepare_g4bit(114)
		jnc	ba0
		prepare_g4bit(115)			;1
		jnc	ba10
		add	cx,2			;11=>2
		jmp	save_g3
ba10:		add	cx,3			;10=>3
		jmp	save_g3
ba0:		prepare_g4bit(116)			;0
		jnc	ba00
		prepare_g4bit(117)			;01
		jnc	ba010
		add	cx,4			;011=>4
		jmp	save_g3
ba010:          add	cx,1			;010=>1
		jmp	save_g3
ba00:           prepare_g4bit(118)			;00
		jnc	ba000
		prepare_g4bit(119)			;001
		jnc	ba0010
		add	cx,5			;0011=>5
		jmp	save_g3
ba0010:		add	cx,6			;0010=>6
		jmp	save_g3
ba000:		prepare_g4bit(120)			;000
		jnc	ba0000
		prepare_g4bit(121)			;0001
		jnc	ba00010
		add	cx,7			;00011=>7
		jmp	save_g3
ba00010:        prepare_g4bit(122)			;00010
		jnc	ba000100
		add	cx,8			;000101=>8
		jmp	save_g3
ba000100:       add	cx,9			;000100=>9
		jmp	save_g3
ba0000:         prepare_g4bit(123)			;0000
		jnc	ba00000
		prepare_g4bit(124)			;00001
		jnc	ba000010
		prepare_g4bit(125)			;000011
		jnc	ba0000110
		add	cx,12			;0000111=>12
		jmp	save_g3
ba0000110:	prepare_g4bit(126)			;0000110
		jnc	ba00001100
		prepare_g4bit(127)			;00001101
		jnc	ba000011010
		prepare_g4bit(128)			;000011011
		jnc	ba0000110110
		jmp	save_g3			;0000110111=>0
ba0000110110:   prepare_g4bit(129)			;0000110110
		jnc	ba00001101100
		prepare_g4bit(130)			;00001101101
		jnc	ba000011011010
		add	cx,43			;000011011011=>43
		jmp	save_g3
ba000011011010: add	cx,42			;000011011010=>42
		jmp	save_g3
ba00001101100:	add	cx,21			;00001101100=>21
		jmp	save_g3
ba000011010:	prepare_g4bit(131)			;000011010
		jnc	ba0000110100
		prepare_g4bit(132)			;0000110101
		jnc	ba00001101010
		prepare_g4bit(133)			;00001101011
		jnc	ba000011010110
		add	cx,39			;000011010111=>39
		jmp	save_g3
ba000011010110:	add	cx,38			;000011010110=>38
		jmp	save_g3
ba00001101010:	prepare_g4bit(134)			;00001101010
		jnc	ba000011010100
		add	cx,37			;000011010101=>37
		jmp	save_g3
ba000011010100: add	cx,36			;000011010100=>36
		jmp	save_g3
ba0000110100:   prepare_g4bit(135)			;0000110100
		jnc	ba00001101000
		prepare_g4bit(136)			;00001101001
		jnc	ba000011010010
		add	cx,35			;000011010011=>35
		jmp	save_g3
ba000011010010:	add	cx,34			;000011010010=>34
		jmp	save_g3
ba00001101000:	add	cx,20			;00001101000=>20
		jmp	save_g3
ba00001100:	prepare_g4bit(137)			;00001100
		jnc	ba000011000
		prepare_g4bit(138)			;000011001
		jnc	ba0000110010
		prepare_g4bit(139)			;0000110011
		jnc	ba00001100110
		add	cx,19			;00001100111=>19
		jmp	save_g3
ba00001100110:	prepare_g4bit(140)			;00001100110
		jnc	ba000011001100
		add	cx,29			;000011001101=>29
		jmp	save_g3
ba000011001100:	add	cx,28			;000011001100=>28
		jmp	save_g3
ba0000110010:	prepare_g4bit(141)		;0000110010
		jnc	ba00001100100
		prepare_g4bit(142)			;00001100101
		jnc	ba000011001010
		add	cx,27			;000011001011=>27
		jmp	save_g3
ba000011001010:	add	cx,26			;000011001010=>26
		jmp	save_g3
ba00001100100:	prepare_g4bit(143)			;00001100100
		jnc	ba000011001000
		add	cx,192			;000011001001=>192
		jmp	bg3
ba000011001000:	add	cx,128			;000011001000=>128
		jmp	bg3
ba000011000:	add	cx,15			;000011000=>15
		jmp	save_g3
ba000010:	prepare_g4bit(144)			;000010
		jnc	ba0000100
		add	cx,11			;0000101=>11
		jmp	save_g3
ba0000100:	add	cx,10			;0000100=>10
		jmp	save_g3
ba00000:        prepare_g4bit(145)			;00000
		jnc	ba000000
		prepare_g4bit(146)			;000001
		jnc	ba0000010
		prepare_g4bit(147)			;0000011
		jnc	ba00000110
		add	cx,14			;00000111=>14
		jmp	save_g3
ba00000110:	prepare_g4bit(148)			;00000110
		jnc	ba000001100
		prepare_g4bit(149)			;000001101
		jnc	ba0000011010
		prepare_g4bit(151)			;0000011011
		jnc	ba00000110110
		add	cx,22			;00000110111=>22
		jmp	save_g3
ba00000110110:	prepare_g4bit(251)			;00000110110
		jnc	ba000001101100
		add	cx,41			;000001101101=>41
		jmp	save_g3
ba000001101100:	add	cx,40			;000001101100=>40
		jmp	save_g3
ba0000011010:	prepare_g4bit(152)			;0000011010
		jnc	ba00000110100
		prepare_g4bit(153)			;00000110101
		jnc	ba000001101010
		add	cx,33			;000001101011=>33
		jmp	save_g3
ba000001101010:	add	cx,32			;000001101010=>32
		jmp	save_g3
ba00000110100:	prepare_g4bit(154)			;00000110100
		jnc	ba000001101000
		add	cx,31			;000001101001=>31
		jmp	save_g3
ba000001101000:	add	cx,30			;000001101000=>30
		jmp	save_g3
ba000001100:	prepare_g4bit(155)			;000001100
		jnc	ba0000011000
		prepare_g4bit(156)			;0000011001
		jnc	ba00000110010
		prepare_g4bit(157)			;00000110011
		jnc	ba000001100110
		add	cx,63			;000001100111=>63
		jmp	save_g3
ba000001100110:	add	cx,62			;000001100110=>62
		jmp	save_g3
ba00000110010:	prepare_g4bit(158)			;00000110010
		jnc	ba000001100100
		add	cx,49			;000001100101=>49
		jmp	save_g3
ba000001100100:	add	cx,48			;000001100100=>48
		jmp	save_g3
ba0000011000:	add	cx,17			;0000011000=>17
		jmp	save_g3
ba0000010:	prepare_g4bit(159)			;0000010
		jnc	ba00000100
		prepare_g4bit(160)			;00000101
		jnc	ba000001010
		prepare_g4bit(161)			;000001011
		jnc	ba0000010110
		add	cx,16			;0000010111=>16
		jmp	save_g3
ba0000010110:	prepare_g4bit(162)			;0000010110
		jnc	ba00000101100
		prepare_g4bit(163)			;00000101101
		jnc	ba000001011010
		add	cx,256			;000001011011=>256
		jmp	bg3
ba000001011010:	add	cx,61			;000001011010=>61
		jmp	save_g3
ba00000101100:  prepare_g4bit(164)			;00000101100
		jnc	ba000001011000
		add	cx,58			;000001011001=>58
		jmp	save_g3
ba000001011000:	add	cx,57			;000001011000=>57
		jmp	save_g3
ba000001010:   	prepare_g4bit(165)			;000001010
		jnc	ba0000010100
		prepare_g4bit(166)			;0000010101
		jnc	ba00000101010
		prepare_g4bit(167)			;00000101011
		jnc	ba000001010110
		add	cx,47			;000001010111=>47
		jmp	save_g3
ba000001010110:	add	cx,46			;000001010110=>46
		jmp	save_g3
ba00000101010:	prepare_g4bit(168)			;00000101010
		jnc	ba000001010100
		add	cx,45			;000001010101=>45
		jmp	save_g3
ba000001010100:	add	cx,44			;000001010100=>44
		jmp	save_g3
ba0000010100:	prepare_g4bit(169)			;0000010100
		jnc	ba00000101000
		prepare_g4bit(170)			;00000101001
		jnc	ba000001010010
		add	cx,51			;000001010011=>51
		jmp	save_g3
ba000001010010:	add	cx,50			;000001010010=>50
		jmp	save_g3
ba00000101000:	add	cx,23			;00000101000=>23
		jmp	save_g3
ba00000100:	add	cx,13			;00000100=>13
		jmp	save_g3
ba000000:	prepare_g4bit(171)			;000000
		jnc	ba0000000
		prepare_g4bit(172)			;0000001
		jnc	ba00000010
		prepare_g4bit(173)			;00000011
		jnc	ba000000110
		prepare_g4bit(174)			;000000111
		jnc	ba0000001110
		add	cx,64			;0000001111=>64
		jmp	bg3
ba0000001110:	prepare_g4bit(175)			;0000001110
		jnc	ba00000011100
		prepare_g4bit(176)			;00000011101
		jnc	ba000000111010
		prepare_g4bit(177)			;000000111011
		jnc	ba0000001110110
		add	cx,1216			;0000001110111=>1216
		jmp	bg3
ba0000001110110:add	cx,1152			;0000001110110=>1152
		jmp	bg3
ba000000111010:	prepare_g4bit(178)			;000000111010
		jnc	ba0000001110100
		add	cx,1088			;0000001110101=>1088
		jmp	bg3
ba0000001110100:add	cx,1024			;0000001110100=>1024
		jmp	bg3
ba00000011100:  prepare_g4bit(179)			;00000011100
		jnc	ba000000111000
		prepare_g4bit(180)			;000000111001
		jnc	ba0000001110010
		add	cx,960			;0000001110011=>960
		jmp	bg3
ba0000001110010:add	cx,896			;0000001110010=>896
		jmp	bg3
ba000000111000:	add	cx,54			;000000111000=>54
		jmp	save_g3
ba000000110:	prepare_g4bit(181)			;000000110
		jnc	ba0000001100
		prepare_g4bit(182)			;0000001101
		jnc	ba00000011010
		prepare_g4bit(183)			;00000011011
		jnc	ba000000110110
		add	cx,53			;000000110111=>53
		jmp	save_g3
ba000000110110:	prepare_g4bit(184)			;000000110110
		jnc	ba0000001101100
		add	cx,576			;0000001101101=>576
		jmp	bg3
ba0000001101100:add	cx,512			;0000001101100=>512
		jmp	bg3
ba00000011010:	prepare_g4bit(185)			;00000011010
		jnc	ba000000110100
		add	cx,448			;000000110101=>448
		jmp	bg3
ba000000110100:	add	cx,384			;000000110100=>384
		jmp	bg3
ba0000001100:	prepare_g4bit(186)			;0000001100
		jnc	ba00000011000
		prepare_g4bit(187)			;00000011001
		jnc	ba000000110010
		add	cx,320			;000000110011=>320
		jmp	bg3
ba000000110010:	prepare_g4bit(188)			;000000110010
		jnc	ba0000001100100
		add	cx,1728			;0000001100101=>1728
		jmp	bg3
ba0000001100100:add	cx,1664			;0000001100100=>1664
		jmp	bg3
ba00000011000:	add	cx,25			;00000011000=>25
		jmp	save_g3
ba00000010:	prepare_g4bit(189)			;00000010
		jnc	ba000000100
		prepare_g4bit(190)			;000000101
		jnc	ba0000001010
		prepare_g4bit(191)			;0000001011
		jnc	ba00000010110
		add	cx,24			;00000010111=>24
		jmp	save_g3
ba00000010110:	prepare_g4bit(192)			;00000010110
		jnc	ba000000101100
		prepare_g4bit(193)			;000000101101
		jnc	ba0000001011010
		add	cx,1600			;0000001011011=>1600
		jmp	bg3
ba0000001011010:add	cx,1536			;0000001011010=>1536
		jmp	bg3
ba000000101100:	add	cx,60			;000000101100=>60
		jmp	save_g3
ba0000001010:   prepare_g4bit(194)			;0000001010
		jnc	ba00000010100
		prepare_g4bit(195)			;00000010101
		jnc	ba000000101010
		add	cx,59			;000000101011=>59
		jmp	save_g3
ba000000101010:	prepare_g4bit(196)			;000000101010
		jnc	ba0000001010100
		add	cx,1472			;0000001010101=>1472
		jmp	bg3
ba0000001010100:add	cx,1408			;0000001010100=>1408
		jmp	bg3
ba00000010100:	prepare_g4bit(197)			;00000010100
		jnc	ba000000101000
		prepare_g4bit(198)			;000000101001
		jnc	ba0000001010010
		add	cx,1344			;0000001010011=>1344
		jmp	bg3
ba0000001010010:add	cx,1280			;0000001010010=>1280
		jmp	bg3
ba000000101000:	add	cx,56			;000000101000=>56
		jmp	save_g3
ba000000100:	prepare_g4bit(199)			;000000100
		jnc	ba0000001000
		prepare_g4bit(200)			;0000001001
		jnc	ba00000010010
		prepare_g4bit(201)			;00000010011
		jnc	ba000000100110
		add	cx,55			;000000100111=>55
		jmp	save_g3
ba000000100110:	prepare_g4bit(202)			;000000100110
		jnc	ba0000001001100
		add	cx,832			;0000001001101=>832
		jmp	bg3
ba0000001001100:add	cx,768			;0000001001100=>768
		jmp	bg3
ba00000010010:	prepare_g4bit(203)			;00000010010
		jnc	ba000000100100
		prepare_g4bit(204)			;000000100101
		jnc	ba0000001001010
		add	cx,704			;0000001001011=>704
		jmp	bg3
ba0000001001010:add	cx,640			;0000001001010=>640
		jmp	bg3
ba000000100100:	add	cx,52			;000000100100=>52
		jmp	save_g3
ba0000001000:	add	cx,18			;0000001000=>18
		jmp	save_g3
ba0000000:	prepare_g4bit(205)			;0000000
		jnc	ba00000000
		prepare_g4bit(206)			;00000001
		jnc	ba000000010
		prepare_g4bit(207)			;000000011
		jnc	ba0000000110
		prepare_g4bit(208)			;0000000111
		jnc	ba00000001110
		prepare_g4bit(209)			;00000001111
		jnc	ba000000011110
		add	cx,2560			;000000011111=>2560
		jmp	bg3
ba000000011110:	add	cx,2496			;000000011110=>2496
		jmp	bg3
ba00000001110:	prepare_g4bit(210)			;00000001110
		jnc	ba000000011100
		add     cx,2432			;000000011101=>2432
		jmp	bg3
ba000000011100:	add	cx,2368			;000000011100=>2368
		jmp	bg3
ba0000000110:	prepare_g4bit(211)			;0000000110
		jnc	ba00000001100
		add	cx,1920			;00000001101=>1920
		jmp	bg3
ba00000001100:	add	cx,1856			;00000001100=>1856
		jmp	bg3
ba000000010:	prepare_g4bit(212)			;000000010
		jnc	ba0000000100
		prepare_g4bit(213)			;0000000101
		jnc	ba00000001010
		prepare_g4bit(214)			;00000001011
		jnc	ba000000010110
		add	cx,2304			;000000010111=>2304
		jmp	bg3
ba000000010110:	add	cx,2240			;000000010110=>2240
		jmp	bg3
ba00000001010:	prepare_g4bit(215)			;00000001010
		jnc	ba000000010100
		add	cx,2176			;000000010101=>2176
		jmp	bg3
ba000000010100:	add	cx,2112			;000000010100=>2112
		jmp	bg3
ba0000000100:   prepare_g4bit(216)			;0000000100
		jnc	ba00000001000
		prepare_g4bit(217)			;00000001001
		jnc	ba000000010010
		add	cx,2048			;000000010011=>2048
		jmp	bg3
ba000000010010:	add	cx,1984			;000000010010=>1984
		jmp	bg3
ba00000001000:	add	cx,1792			;00000001000=>1792
		jmp	bg3
ba00000000:	mov	cx,-1			;error
		jmp	save_g3

finish_g4rl:    cld
                mov ebp ,valebp
                mov  esi, valesi
                mov  edi, valedi
				mov  retval, eax
	}
    return retval;
}
	

int __stdcall g4bin1s(BYTE  *g4buffer, 
                      WORD  *binbuffer, 
                      DWORD linesperstrip, 
                      DWORD *_binbufcnt, 
                      WORD _image_width) //  IN PIXEL
{   
DLL_THREAD_MANAGEMENT();

    pref_line = ref_line;
	pcod_line=cod_line;
	pblack=black;
	pwhite= white; 
    __asm
    {  
    	mov DWORD PTR valebp, ebp
	    mov DWORD PTR valesi, esi
	    mov DWORD PTR valedi, edi
	    mov eax,  g4buffer
		mov edx,  binbuffer
		mov ebx,  linesperstrip		;length
        mov ecx,  _binbufcnt	    ;binbufcnt
		
		mov	di,_image_width  ;[ebp+16]
		mov	image_width,di
		mov	g4bufcnt,0
		mov	binbufcnt,0
		mov	passvalue,0
		mov	bitcnt,8
		mov	bin_bitcnt,15
		mov	binbufcntp,ecx
		mov	linecnt,bx     ;Initializes linecnt with linesperstrip

length_loop:    mov     a0,-1
                mov     i,0
                mov     j,0
                mov     bx,image_width
                mov     ecx, pref_line
                cmp     binbufcnt,0
                jne     width_loop
                mov     [ecx],bx                ;Initializes ref_line and b1
                mov     b1,bx                   ;for first line in strip
width_loop:     mov     bx,b1
                cmp     bx,image_width
                jne     calc_b2                 ;if b1 at end of line
                mov     b2,bx                   ;b2=b1=image_width
                jmp     g4_tree
calc_b2:        mov     ebp,i
                inc     ebp
                add     bx,[ecx][ebp*2]
                mov     b2,bx                   ;b2=b1+ref_line[i+1]
        ;Uses EAX(g4buf),ESI(g4bufcnt),BX(bitcnt)
        ;EAX is preserved through the functions called, BX and ESI are not
        ;Passes left and right position through CX(-3 to +3)
        ;returns error or correct op from horizontal in CX
        ;return towards the end of width_loop at end_g4_code
g4_tree:        mov     bx,bitcnt
                mov     esi,g4bufcnt
                prepare_g4bit(4)
                jnc     g4a0
                mov     g4bufcnt,esi
                mov     bitcnt,bx                       ;1=>V(0)
                mov     cx,0
                jmp     vert_left
g4a0:           prepare_g4bit(5)                           ;0
                jnc     g4a00
                prepare_g4bit(6)                           ;01
                mov     g4bufcnt,esi
                mov     bitcnt,bx
                jnc     g4a010
                mov     cx,1                            ;011=>VR(1)
                jmp     vert_right
g4a010:         mov     cx,-1                           ;010=>VL(1)
                jmp     vert_left
g4a00:          prepare_g4bit(7)                           ;00
                jnc     g4a000
                mov     g4bufcnt,esi
                mov     bitcnt,bx
                jmp     horizont                        ;001=>H
g4a000:         prepare_g4bit(8)                           ;000
                jnc     g4a0000
                mov     g4bufcnt,esi
                mov     bitcnt,bx
                mov     cx,b2                           ;0001=>P
                sub     cx,a0
                add     passvalue,cx
                mov     cx,b2
                mov     a0,cx
                inc     i
                inc     i
                mov     ebx,pref_line
                mov     ebp,i
                add     cx,[ebx][ebp*2]
                mov     b1,cx
                mov     ecx,0
                jmp     end_g4_code
g4a0000:        prepare_g4bit(9)                           ;0000
                jnc     g4a00000
                prepare_g4bit(10)                           ;00001
                mov     bitcnt,bx
                mov     g4bufcnt,esi
                jnc     g4a000010
                mov     cx,2                            ;000011=>VR(2)
                jmp     vert_right
g4a000010:      mov     cx,-2                           ;000010=>VL(2)
                jmp     vert_left
g4a00000:       prepare_g4bit(11)                           ;00000
                jnc     g4a000000
                prepare_g4bit(12)                           ;000001
                mov     bitcnt,bx
                mov     g4bufcnt,esi
                jnc     g4a0000010
                mov     cx,3                            ;0000011=>VR(3)
                jmp     vert_right
g4a0000010:     mov     cx,-3                           ;0000010=>VL(3)
                jmp     vert_left
g4a000000:      mov     edi,binbufcnt
                mov     eax,binbufcntp
                mov     [eax],edi
                mov     eax,-1                          ;return error
                jmp     finish_g4rl
;
end_g4_code:    cmp     ecx,-1
                je      g4a000000
                mov     ecx,pref_line
                mov     bx,a0
                cmp     bx,image_width
                jne     width_loop
                mov     edi,binbufcnt
;
                mov     ebx,bin_bitcnt
                cmp     bx,15
                je      nopadding
                mov     si,[edx][edi]
                mov     ebp,pwhite
                and     si,[ebp][ebx*2]
                mov     [edx][edi],si
                inc     edi
                inc     edi
nopadding:      mov     bin_bitcnt,15
                mov     binbufcnt,edi
                mov     di,linecnt
                dec     di
                mov     linecnt,di
                jnz     update_ref
                mov     edi,binbufcnt
                mov     eax,binbufcntp                  ;return binbufcnt
                mov     [eax],edi
                mov     eax,0
                jmp     finish_g4rl

update_ref:     mov     ecx,j                           ;prepare ref line
                mov     esi,pcod_line
                mov     edi,pref_line
                rep     movsw
                mov     cx,b1                           ;prepare first b1
                mov     edi,pref_line
                mov     cx,[edi]
                mov     b1,cx
                jmp     length_loop
;
;       VERT_LEFT function solves the vertical left and zero codes
;                               Registers used:
;                                       Input   EAX -g4buffer
;                                               EDX -rlbuffer
;                                               ECX -position (0 to -3)
;                                       Output  ECX -correct (if 0)
;                                       Uses all the other regs except ESI
;
;
vert_left:      mov     edi,binbufcnt
                mov     ebp,j
                cmp     ebp,0
                jnz     save_vl
                mov     bx,passvalue
                dec     bx
                mov     passvalue,bx
save_vl:        add     cx,b1
                mov     a1,cx
                sub     cx,a0                  ;b1-pos-a0
                add     cx,passvalue           ;b1-pos-a0+passvalue
                mov     ebx,pcod_line
                mov     [ebx][ebp*2],cx
;
                mov     ebx,bin_bitcnt
                mov     si,[edx][edi]
                bt      ebp,0
                jc      vlb_makebin
vlw_makebin:    cmp     cx,0
                jz      vl_endbin              ;If 0 don't write anything
                cmp     bx,15
                jne     vlw_bin1
                cmp     cx,32
                js      vlw_bin3
                mov     si,cx
                and     si,001fh
                shr     cx,5
vlw_bin2:       mov     dword ptr [edx][edi],0
                add     edi,4
                dec     cx
                jnz     vlw_bin2
                cmp     si,0
                je      vl_endbin
                mov     cx,si
vlw_bin3:       mov     word ptr [edx][edi],0
                cmp     cx,16
                js      vlw_bin4
                add     edi,2
                mov     word ptr [edx][edi],0
                sub     cx,16
vlw_bin4:       sub     bx,cx
                jmp     vl_endbin
vlw_bin1:       mov     ebp,pwhite
                inc     bx
                cmp     cx,bx
                js      vlw_bin6
                sub     cx,bx
                dec     bx
                and     si,[ebp][ebx*2]
                mov     [edx][edi],si
                add     edi,2
                mov     bx,15
                jmp     vlw_makebin
vlw_bin6:       dec     bx
                and     si,[ebp][ebx*2]
                sub     bx,cx
                mov     [edx][edi],si
                jmp     vl_endbin
vlb_makebin:    cmp     cx,0
                jz      vl_endbin              ;If 0 don't write anything
                cmp     bx,15
                jne     vlb_bin1
                cmp     cx,32
                js      vlb_bin3
                mov     si,cx
                and     si,001fh
                shr     cx,5
vlb_bin2:       mov     dword ptr [edx][edi],0ffffffffh
                add     edi,4
                dec     cx
                jnz     vlb_bin2
                cmp     si,0
                je      vl_endbin
                mov     cx,si
vlb_bin3:       mov     word ptr [edx][edi],0ffffh
                cmp     cx,16
                js      vlb_bin4
                add     edi,2
                mov     word ptr [edx][edi],0ffffh
                sub     cx,16
vlb_bin4:       sub     bx,cx
                jmp     vl_endbin
vlb_bin1:       mov     ebp,pblack
                inc     bx
                cmp     cx,bx
                js      vlb_bin6
                sub     cx,bx
                dec     bx
                or      si,[ebp][ebx*2]
                mov     [edx][edi],si
                add     edi,2
                mov     bx,15
                jmp     vlb_makebin
vlb_bin6:       dec     bx
                or      si,[ebp][ebx*2]
                sub     bx,cx
                mov     [edx][edi],si
vl_endbin:      mov     bin_bitcnt,ebx
                mov     ebx,pcod_line
                mov     ebp,j
                mov     cx,a1
                cmp     cx,image_width
                jbe     inside_vl
                sub     cx,image_width
                sub     [ebx][ebp*2],cx
                mov     cx,image_width
inside_vl:      inc     ebp
                mov     j,ebp
                mov     binbufcnt,edi
                mov     a0,cx
                mov     ebp,i
                mov     ebx,pref_line
                mov     di,b1
                sub     di,[ebx][ebp*2]
                cmp     di,a0
                jbe     left_b1
                dec     ebp
                jmp     fin_vl
left_b1:        mov     di,b1
                cmp     di,image_width
                jae     fin_vl
                inc     ebp
                add     di,[ebx][ebp*2]
fin_vl:         mov     i,ebp
                mov     b1,di
                mov     passvalue,0
                mov     ecx,0
                jmp     end_g4_code
;
;       VERT_RIGHT function solves the vertical right codes
;                               Registers used:
;                                       Input   EAX -g4buffer
;                                               EDX -rlbuffer
;                                               ECX -position (1 to 3)
;                                       Output  ECX -correct (if 0)
;                                       Uses all the other regs except ESI
;
vert_right:     mov     edi,binbufcnt
                mov     ebp,j
                cmp     ebp,0
                jnz     save_vr
                mov     bx,passvalue
                dec     bx
                mov     passvalue,bx
save_vr:        add     cx,b1                   ;pos+b1
                mov     a1,cx                   ;a1=b1+pos
                sub     cx,a0                   ;pos+b1-a0
                add     cx,passvalue
                mov     ebx,pcod_line
                mov     [ebx][ebp*2],cx
;
                mov     ebx,bin_bitcnt
                mov     si,[edx][edi]
                bt      ebp,0
                jc      vrb_makebin
vrw_makebin:    cmp     cx,0
                jz      vr_endbin              ;If 0 don't write anything
                cmp     bx,15
                jne     vrw_bin1
                cmp     cx,32
                js      vrw_bin3
                mov     si,cx
                and     si,001fh
                shr     cx,5
vrw_bin2:       mov     dword ptr [edx][edi],0
                add     edi,4
                dec     cx
                jnz     vrw_bin2
                cmp     si,0
                je      vr_endbin
                mov     cx,si
vrw_bin3:       mov     word ptr [edx][edi],0
                cmp     cx,16
                js      vrw_bin4
                add     edi,2
                mov     word ptr [edx][edi],0
                sub     cx,16
vrw_bin4:       sub     bx,cx
                jmp     vr_endbin
vrw_bin1:       mov     ebp,pwhite
                inc     bx
                cmp     cx,bx
                js      vrw_bin6
                sub     cx,bx
                dec     bx
                and     si,[ebp][ebx*2]
                mov     [edx][edi],si
                add     edi,2
                mov     bx,15
                jmp     vrw_makebin
vrw_bin6:       dec     bx
                and     si,[ebp][ebx*2]
                sub     bx,cx
                mov     [edx][edi],si
                jmp     vr_endbin
vrb_makebin:    cmp     cx,0
                jz      vr_endbin              ;If 0 don't write anything
                cmp     bx,15
                jne     vrb_bin1
                cmp     cx,32
                js      vrb_bin3
                mov     si,cx
                and     si,001fh
                shr     cx,5
vrb_bin2:       mov     dword ptr [edx][edi],0ffffffffh
                add     edi,4
                dec     cx
                jnz     vrb_bin2
                cmp     si,0
                je      vr_endbin
                mov     cx,si
vrb_bin3:       mov     word ptr [edx][edi],0ffffh
                cmp     cx,16
                js      vrb_bin4
                add     edi,2
                mov     word ptr [edx][edi],0ffffh
                sub     cx,16
vrb_bin4:       sub     bx,cx
                jmp     vr_endbin
vrb_bin1:       mov     ebp,pblack
                inc     bx
                cmp     cx,bx
                js      vrb_bin6
                sub     cx,bx
                dec     bx
                or      si,[ebp][ebx*2]
                mov     [edx][edi],si
                add     edi,2
                mov     bx,15
                jmp     vrb_makebin
vrb_bin6:       dec     bx
                or      si,[ebp][ebx*2]
                sub     bx,cx
                mov     [edx][edi],si
vr_endbin:      mov     bin_bitcnt,ebx
                mov     ebx,pcod_line
                mov     ebp,j
                mov     cx,a1
                cmp     cx,image_width
                jbe     inside_vr
                sub     cx,image_width
                sub     [ebx][ebp*2],cx
                mov     cx,image_width
inside_vr:      inc     ebp
                mov     j,ebp
                mov     binbufcnt,edi
                mov     a0,cx                   ;a0=a1
                mov     ebp,i
                mov     ebx,pref_line
                mov     di,b1
                inc     ebp
                add     di,[ebx][ebp*2]
make_ivr:       cmp     cx,di
                jb      fin_vr
                cmp     di,image_width
                jae     fin_vr
                inc     ebp
                add     di,[ebx][ebp*2]
                cmp     di,image_width
                jae     fin_vr
                inc     ebp
                add     di,[ebx][ebp*2]
                jmp     make_ivr
fin_vr:         mov     i,ebp
                mov     b1,di
                mov     passvalue,0
                mov     ecx,0
                jmp     end_g4_code
;
;       HORIZONT function solves the horizontal codes
;                               Registers used:
;                                       Input   EAX -g4buffer
;                                               EDX -rlbuffer
;                                       Output  ECX -correct (if 0)
;                                                   -error code(if -1)
;                                       Uses all the other regs
horizont:       mov     cnt,2
                mov     edi,binbufcnt
                mov     ebp,j
;       dec passvalue if the first ellement in line
                mov     flag,0
                cmp     ebp,0
                jnz     read_g3
                mov     cx,passvalue
                cmp     cx,0
                jz      nopass
                mov     flag,1
                jmp     read_g3
;       read g3 info in cx register
nopass:         mov     a0,0
read_g3:        mov     cx,0
                mov     bx,bitcnt
                mov     esi,g4bufcnt
                bt      ebp,0                   ;see if j even or odd
                jnc     wg3                     ;white g3
                jmp     bg3                     ;black g3
;       save g3 info from cx in rl buffer
save_g3:        mov     bitcnt,bx               ;save new bitcnt
                mov     g4bufcnt,esi
                cmp     cx,0                    ;if -1 error code return
                js      error_code
                add     a0,cx
                add     cx,passvalue
                sub     cx,flag
                mov     ebx,pcod_line
                mov     [ebx][ebp*2],cx         ;save rl in the coding line
;
                mov     ebx,bin_bitcnt
                mov     si,[edx][edi]
                bt      ebp,0
                jc      hb_makebin
hw_makebin:     cmp     cx,0
                jz      h_endbin              ;If 0 don't write anything
                cmp     bx,15
                jne     hw_bin1
                cmp     cx,32
                js      hw_bin3
                mov     si,cx
                and     si,001fh
                shr     cx,5
hw_bin2:        mov     dword ptr [edx][edi],0
                add     edi,4
                dec     cx
                jnz     hw_bin2
                cmp     si,0
                je      h_endbin
                mov     cx,si
hw_bin3:        mov     word ptr [edx][edi],0
                cmp     cx,16
                js      hw_bin4
                add     edi,2
                mov     word ptr [edx][edi],0
                sub     cx,16
hw_bin4:        sub     bx,cx
                jmp     h_endbin
hw_bin1:        mov     ebp,pwhite
                inc     bx
                cmp     cx,bx
                js      hw_bin6
                sub     cx,bx
                dec     bx
                and     si,[ebp][ebx*2]
                mov     [edx][edi],si
                add     edi,2
                mov     bx,15
                jmp     hw_makebin
hw_bin6:        dec     bx
                and     si,[ebp][ebx*2]
                sub     bx,cx
                mov     [edx][edi],si
                jmp     h_endbin
hb_makebin:     cmp     cx,0
                jz      h_endbin              ;If 0 don't write anything
                cmp     bx,15
                jne     hb_bin1
                cmp     cx,32
                js      hb_bin3
                mov     si,cx
                and     si,001fh
                shr     cx,5
hb_bin2:        mov     dword ptr [edx][edi],0ffffffffh
                add     edi,4
                dec     cx
                jnz     hb_bin2
                cmp     si,0
                je      h_endbin
                mov     cx,si
hb_bin3:        mov     word ptr [edx][edi],0ffffh
                cmp     cx,16
                js      hb_bin4
                add     edi,2
                mov     word ptr [edx][edi],0ffffh
                sub     cx,16
hb_bin4:        sub     bx,cx
                jmp     h_endbin
hb_bin1:        mov     ebp,pblack
                inc     bx
                cmp     cx,bx
                js      hb_bin6
                sub     cx,bx
                dec     bx
                or      si,[ebp][ebx*2]
                mov     [edx][edi],si
                add     edi,2
                mov     bx,15
                jmp     hb_makebin
hb_bin6:        dec     bx
                or      si,[ebp][ebx*2]
                sub     bx,cx
                mov     [edx][edi],si
h_endbin:       mov     bin_bitcnt,ebx
                mov     ebx,pcod_line
                mov     ebp,j
                mov     cx,a0
                cmp     cx,image_width
                jb      inside_line             ;If exceeding image_width,
                sub     cx,image_width          ;adjust at image_width
                sub     [ebx][ebp*2],cx         ;both cod_line[j] and pixcnt
                mov     cx,image_width
             
inside_line:    mov     passvalue,0
                mov     a0,cx
                inc     ebp
                dec     cnt
                mov     flag,0
                mov     j,ebp
                jnz     read_g3
                mov     binbufcnt,edi           ;save new binbufcnt
                mov     ebx,pref_line
                mov     ebp,i
                mov     di,b1
make_i:         cmp     cx,di
                jb      fin_horiz
                cmp     di,image_width
                jae     fin_horiz
                inc     ebp
                add     di,[ebx][ebp*2]
                cmp     di,image_width
                jae     fin_horiz
                inc     ebp
                add     di,[ebx][ebp*2]
                jmp     make_i
fin_horiz:      mov     i,ebp
                mov     b1,di
                mov     ecx,0
                jmp     end_g4_code
error_code:     mov     ecx,-1
                jmp     end_g4_code
;
;       WhiteG3 function decodes g3 info in horizontal encoding
;                               Registers used:
;                                       Input   EAX -g4buffer
;                                               ESI -g4bufcnt
;                                                BX -bitcnt
;                                       Output   CX -runlength (if>=0)
;                                                   -error code(if -1)
;                                       Doesn't use other regs
wg3:            prepare_g4bit(13)
                jnc     wa0
                prepare_g4bit(14)                   ;1
                jnc     wa10
                prepare_g4bit(15)                   ;11
                jnc     wa110
                prepare_g4bit(16)                   ;111
                jnc     wa1110
                add     cx,7                    ;1111=>7
                jmp     save_g3
wa1110:         add     cx,6                    ;1110=>6
                jmp     save_g3
wa110:          prepare_g4bit(17)                   ;110
                jnc     wa1100
                prepare_g4bit(18)                   ;1101
                jnc     wa11010
                add     cx,64                   ;11011=>64
                jmp     wg3
wa11010:        prepare_g4bit(19)                   ;11010
                jnc     wa110100
                add     cx,15                   ;110101=>15
                jmp     save_g3
wa110100:       add     cx,14                   ;110100=>14
                jmp     save_g3
wa1100:         add     cx,5                    ;1100=>5
                jmp     save_g3
wa10:           prepare_g4bit(20)                   ;10
                jnc     wa100
                prepare_g4bit(21)                   ;101
                jnc     wa1010
                add     cx,4                    ;1011=>4
                jmp     save_g3
wa1010:         prepare_g4bit(22)                   ;1010
                jnc     wa10100
                prepare_g4bit(23)                   ;10101
                jnc     wa101010
                add     cx,17                   ;101011=>17
                jmp     save_g3
wa101010:       add     cx,16                   ;101010=>16
                jmp     save_g3
wa10100:        add     cx,9                    ;10100=>9
                jmp     save_g3
wa100:          prepare_g4bit(24)                   ;100
                jnc     wa1000
                prepare_g4bit(25)                   ;1001
                jnc     wa10010
                add     cx,8                    ;10011=>8
                jmp     save_g3
wa10010:        add     cx,128                  ;10010=>128
                jmp     wg3
wa1000:         add     cx,3                    ;1000=>3
                jmp     save_g3
wa0:            prepare_g4bit(26)                   ;0
                jnc     wa00
                prepare_g4bit(27)                   ;01
                jnc     wa010
                prepare_g4bit(28)                   ;011
                jnc     wa0110
                add     cx,2                    ;0111=>2
                jmp     save_g3
wa0110:         prepare_g4bit(29)                   ;0110
                jnc     wa01100
                prepare_g4bit(30)                   ;01101
                jnc     wa011010
                prepare_g4bit(31)                   ;011011
                jnc     wa0110110
                add     cx,256                  ;0110111=>256
                jmp     wg3
wa0110110:      prepare_g4bit(32)                   ;0110110
                jnc     wa01101100
                prepare_g4bit(33)                   ;01101101
                jnc     wa011011010
                add     cx,1408                 ;011011011=>1408
                jmp     wg3
wa011011010:    add     cx,1344                 ;011011010=>1344
                jmp     wg3
wa01101100:     prepare_g4bit(34)                   ;01101100
                jnc     wa011011000
                add     cx,1280                 ;011011001=>1280
                jmp     wg3
wa011011000:    add     cx,1216                 ;011011000=>1216
                jmp     wg3
wa011010:       prepare_g4bit(35)                   ;011010
                jnc     wa0110100
                prepare_g4bit(36)                   ;0110101
                jnc     wa01101010
                prepare_g4bit(37)                   ;01101011
                jnc     wa011010110
                add     cx,1152                 ;011010111=>1152
                jmp     wg3
wa011010110:    add     cx,1088                 ;011010110=>1088
                jmp     wg3
wa01101010:     prepare_g4bit(38)                   ;01101010
                jnc     wa011010100
                add     cx,1024                 ;011010101=>1024
                jmp     wg3
wa011010100:    add     cx,960                  ;011010100=>960
                jmp     wg3
wa0110100:      prepare_g4bit(39)                   ;0110100
                jnc     wa01101000
                prepare_g4bit(40)                   ;01101001
                jnc     wa011010010
                add     cx,896                  ;011010011=>896
                jmp     wg3
wa011010010:    add     cx,832                  ;011010010=>832
                jmp     wg3
wa01101000:     add     cx,576                  ;01101000=>576
                jmp     wg3
wa01100:        prepare_g4bit(41)                   ;01100
                jnc     wa011000
                prepare_g4bit(42)                   ;011001
                jnc     wa0110010
                prepare_g4bit(43)                   ;0110011
                jnc     wa01100110
                add     cx,640                  ;01100111=>640
                jmp     wg3
wa01100110:     prepare_g4bit(44)                   ;01100110
                jnc     wa011001100
                add     cx,768                  ;011001101=>768
                jmp     wg3
wa011001100:    add     cx,704                  ;011001100=>704
                jmp     wg3
wa0110010:      prepare_g4bit(45)                   ;0110010
                jnc     wa01100100
                add     cx,512                  ;01100101=>512
                jmp     wg3
wa01100100:     add     cx,448                  ;01100100=>448
                jmp     wg3
wa011000:       add     cx,1664                 ;011000=>1664
                jmp     wg3
wa010:          prepare_g4bit(46)                   ;010
                jnc     wa0100
                prepare_g4bit(47)                   ;0101
                jnc     wa01010
                prepare_g4bit(48)                   ;01011
                jnc     wa010110
                add     cx,192                  ;010111=>192
                jmp     wg3
wa010110:       prepare_g4bit(49)                   ;010110
                jnc     wa0101100
                prepare_g4bit(50)                   ;0101101
                jnc     wa01011010
                add     cx,58                   ;01011011=>58
                jmp     save_g3
wa01011010:     add     cx,57                   ;01011010=>57
                jmp     save_g3
wa0101100:      prepare_g4bit(51)                   ;0101100
                jnc     wa01011000
                add     cx,56                   ;01011001=>56
                jmp     save_g3
wa01011000:     add     cx,55                   ;01011000=>55
                jmp     save_g3
wa01010:        prepare_g4bit(52)                   ;01010
                jnc     wa010100
                prepare_g4bit(53)                   ;010101
                jnc     wa0101010
                add     cx,25                   ;0101011=>25
                jmp     save_g3
wa0101010:      prepare_g4bit(54)                   ;0101010
                jnc     wa01010100
                add     cx,52                   ;01010101=>52
                jmp     save_g3
wa01010100:     add     cx,51                   ;01010100=>51
                jmp     save_g3
wa010100:       prepare_g4bit(55)                   ;010100
                jnc     wa0101000
                prepare_g4bit(56)                   ;0101001
                jnc     wa01010010
                add     cx,50                   ;01010011=>50
                jmp     save_g3
wa01010010:     add     cx,49                   ;01010010=>49
                jmp     save_g3
wa0101000:      add     cx,24                   ;0101000=>24
                jmp     save_g3
wa0100:         prepare_g4bit(57)                   ;0100
                jnc     wa01000
                prepare_g4bit(58)                   ;01001
                jnc     wa010010
                prepare_g4bit(59)                   ;010011
                jnc     wa0100110
                add     cx,18                   ;0100111=>18
                jmp     save_g3
wa0100110:      prepare_g4bit(60)                   ;0100110
                jnc     wa01001100
                prepare_g4bit(61)                   ;01001101
                jnc     wa010011010
                add     cx,1728                 ;010011011=>1728
                jmp     wg3
wa010011010:    add     cx,1600                 ;010011010=>1600
                jmp     wg3
wa01001100:     prepare_g4bit(62)                   ;01001100
                jnc     wa010011000
                add     cx,1536                 ;010011001=>1536
                jmp     wg3
wa010011000:    add     cx,1472                 ;010011000=>1472
                jmp     wg3
wa010010:       prepare_g4bit(63)                   ;010010
                jnc     wa0100100
                prepare_g4bit(64)                   ;0100101
                jnc     wa01001010
                add     cx,60                   ;01001011=>60
                jmp     save_g3
wa01001010:     add     cx,59                   ;01001010=>59
                jmp     save_g3
wa0100100:      add     cx,27                   ;0100100=>27
                jmp     save_g3
wa01000:        add     cx,11                   ;01000=>11
                jmp     save_g3
wa00:           prepare_g4bit(65)                   ;00
                jnc     wa000
                prepare_g4bit(66)                   ;001
                jnc     wa0010
                prepare_g4bit(67)                   ;0011
                jnc     wa00110
                add     cx,10                   ;00111=>10
                jmp     save_g3
wa00110:        prepare_g4bit(68)                   ;00110
                jnc     wa001100
                prepare_g4bit(69)                   ;001101
                jnc     wa0011010
                prepare_g4bit(70)                   ;0011011
                jnc     wa00110110
                add     cx,384                  ;00110111=>384
                jmp     wg3
wa00110110:     add     cx,320                  ;00110110=>320
                jmp     wg3
wa0011010:      prepare_g4bit(71)                   ;0011010
                jnc     wa00110100
                add     cx,0                    ;00110101=>0
                jmp     save_g3
wa00110100:     add     cx,63                   ;00110100=>63
                jmp     save_g3
wa001100:       prepare_g4bit(72)                   ;001100
                jnc     wa0011000
                prepare_g4bit(73)                   ;0011001
                jnc     wa00110010
                add     cx,62                   ;00110011=>62
                jmp     save_g3
wa00110010:     add     cx,61                   ;00110010=>61
                jmp     save_g3
wa0011000:      add     cx,28                   ;0011000=>28
                jmp     save_g3
wa0010:         prepare_g4bit(74)                   ;0010
                jnc     wa00100
                prepare_g4bit(75)                   ;00101
                jnc     wa001010
                prepare_g4bit(76)                   ;001011
                jnc     wa0010110
                add     cx,21                   ;0010111=>21
                jmp     save_g3
wa0010110:      prepare_g4bit(77)                   ;0010110
                jnc     wa00101100
                add     cx,44                   ;00101101=>44
                jmp     save_g3
wa00101100:     add     cx,43                   ;00101100=>43
                jmp     save_g3
wa001010:       prepare_g4bit(78)                   ;001010
                jnc     wa0010100
                prepare_g4bit(79)                   ;0010101
                jnc     wa00101010
                add     cx,42                   ;00101011=>42
                jmp     save_g3
wa00101010:     add     cx,41                   ;00101010=>41
                jmp     save_g3
wa0010100:      prepare_g4bit(80)                   ;0010100
                jnc     wa00101000
                add     cx,40                   ;00101001=>40
                jmp     save_g3
wa00101000:     add     cx,39                   ;00101000=>39
                jmp     save_g3
wa00100:        prepare_g4bit(81)                   ;00100
                jnc     wa001000
                prepare_g4bit(82)                   ;001001
                jnc     wa0010010
                add     cx,26                   ;0010011=>26
                jmp     save_g3
wa0010010:      prepare_g4bit(83)                   ;0010010
                jnc     wa00100100
                add     cx,54                   ;00100101=>54
                jmp     save_g3
wa00100100:     add     cx,53                   ;00100100=>53
                jmp     save_g3
wa001000:       add     cx,12                   ;001000=>12
                jmp     save_g3
wa000:          prepare_g4bit(84)                   ;000
                jnc     wa0000
                prepare_g4bit(85)                   ;0001
                jnc     wa00010
                prepare_g4bit(86)                   ;00011
                jnc     wa000110
                add     cx,1                    ;000111=>1
                jmp     save_g3
wa000110:       prepare_g4bit(87)                   ;000110
                jnc     wa0001100
                prepare_g4bit(88)                   ;0001101
                jnc     wa00011010
                add     cx,32                   ;00011011=>32
                jmp     save_g3
wa00011010:     add     cx,31                   ;00011010=>31
                jmp     save_g3
wa0001100:      add     cx,19                   ;0001100=>19
                jmp     save_g3
wa00010:        prepare_g4bit(89)                   ;00010
                jnc     wa000100
                prepare_g4bit(90)                   ;000101
                jnc     wa0001010
                prepare_g4bit(91)                   ;0001011
                jnc     wa00010110
                add     cx,38                   ;00010111=>38
                jmp     save_g3
wa00010110:     add     cx,37                   ;00010110=>37
                jmp     save_g3
wa0001010:      prepare_g4bit(92)                   ;0001010
                jnc     wa00010100
                add     cx,36                   ;00010101=>36
                jmp     save_g3
wa00010100:     add     cx,35                   ;00010100=>35
                jmp     save_g3
wa000100:       prepare_g4bit(93)                   ;000100
                jnc     wa0001000
                prepare_g4bit(94)                   ;0001001
                jnc     wa00010010
                add     cx,34                   ;00010011=>34
                jmp     save_g3
wa00010010:     add     cx,33                   ;00010010=>33
                jmp     save_g3
wa0001000:      add     cx,20                   ;0001000=>20
                jmp     save_g3
wa0000:         prepare_g4bit(95)                   ;0000
                jnc     wa00000
                prepare_g4bit(96)                   ;00001
                jnc     wa000010
                add     cx,13                   ;000011=>13
                jmp     save_g3
wa000010:       prepare_g4bit(97)                   ;000010
                jnc     wa0000100
                prepare_g4bit(98)                   ;0000101
                jnc     wa00001010
                add     cx,48                   ;00001011=>48
                jmp     save_g3
wa00001010:     add     cx,47                   ;00001010=>47
                jmp     save_g3
wa0000100:      add     cx,23                   ;0000100=>23
                jmp     save_g3
wa00000:        prepare_g4bit(99)                   ;00000
                jnc     wa000000
                prepare_g4bit(100)                   ;000001
                jnc     wa0000010
                add     cx,22                   ;0000011=>22
                jmp     save_g3
wa0000010:      prepare_g4bit(101)                   ;0000010
                jnc     wa00000100
                add     cx,46                   ;00000101=>46
                jmp     save_g3
wa00000100:     add     cx,45                   ;00000100=>45
                jmp     save_g3
wa000000:       prepare_g4bit(102)                   ;000000
                jnc     wa0000000
                prepare_g4bit(103)                   ;0000001
                jnc     wa00000010
                add     cx,30                   ;00000011=>30
                jmp     save_g3
wa00000010:     add     cx,29                   ;00000010=>29
                jmp     save_g3
wa0000000:      prepare_g4bit(104)                   ;0000000
                jnc     wa00000000
                prepare_g4bit(105)                   ;00000001
                jnc     wa000000010
                prepare_g4bit(106)                   ;000000011
                jnc     wa0000000110
                prepare_g4bit(107)                   ;0000000111
                jnc     wa00000001110
                prepare_g4bit(108)                   ;00000001111
                jnc     wa000000011110
                add     cx,2560                 ;000000011111=>2560
                jmp     wg3
wa000000011110: add     cx,2496                 ;000000011110=>2496
                jmp     wg3
wa00000001110:  prepare_g4bit(109)                   ;00000001110
                jnc     wa000000011100
                add     cx,2432                 ;000000011101=>2432
                jmp     wg3
wa000000011100: add     cx,2368                 ;000000011100=>2368
                jmp     wg3
wa0000000110:   prepare_g4bit(110)                   ;0000000110
                jnc     wa00000001100
                add     cx,1920                 ;00000001101=>1920
                jmp     wg3
wa00000001100:  add     cx,1856                 ;00000001100=>1856
                jmp     wg3
wa000000010:    prepare_g4bit(111)                   ;000000010
                jnc     wa0000000100
                prepare_g4bit(112)                   ;0000000101
                jnc     wa00000001010
                prepare_g4bit(113)                   ;00000001011
                jnc     wa000000010110
                add     cx,2304                 ;000000010111=>2304
                jmp     wg3
wa000000010110: add     cx,2240                 ;000000010110=>2240
                jmp     wg3
wa00000001010:  prepare_g4bit(114)                   ;00000001010
                jnc     wa000000010100
                add     cx,2176                 ;000000010101=>2176
                jmp     wg3
wa000000010100: add     cx,2112                 ;000000010100=>2112
                jmp     wg3
wa0000000100:   prepare_g4bit(115)                   ;0000000100
                jnc     wa00000001000
                prepare_g4bit(116)                   ;00000001001
                jnc     wa000000010010
                add     cx,2048                 ;000000010011=>2048
                jmp     wg3
wa000000010010: add     cx,1984                 ;000000010010=>1984
                jmp     wg3
wa00000001000:  add     cx,1792                 ;00000001000=>1792
                jmp     wg3
wa00000000:     mov     cx,-1                   ;error
                jmp     save_g3
;
;       BlackG3 function decodes g3 info in horizontal encoding
;                               Registers used:
;                                       Input   EAX -g4buffer
;                                               ESI -g4bufcnt
;                                                BX -bitcnt
;                                       Output   CX -runlength (if>=0)
;                                                   -error code(if -1)
;                                       Doesn't use other regs
bg3:            prepare_g4bit(117)
                jnc     ba0
                prepare_g4bit(118)                   ;1
                jnc     ba10
                add     cx,2                    ;11=>2
                jmp     save_g3
ba10:           add     cx,3                    ;10=>3
                jmp     save_g3
ba0:            prepare_g4bit(119)                   ;0
                jnc     ba00
                prepare_g4bit(120)                   ;01
                jnc     ba010
                add     cx,4                    ;011=>4
                jmp     save_g3
ba010:          add     cx,1                    ;010=>1
                jmp     save_g3
ba00:           prepare_g4bit(121)                   ;00
                jnc     ba000
                prepare_g4bit(122)                   ;001
                jnc     ba0010
                add     cx,5                    ;0011=>5
                jmp     save_g3
ba0010:         add     cx,6                    ;0010=>6
                jmp     save_g3
ba000:          prepare_g4bit(123)                   ;000
                jnc     ba0000
                prepare_g4bit(124)                   ;0001
                jnc     ba00010
                add     cx,7                    ;00011=>7
                jmp     save_g3
ba00010:        prepare_g4bit(125)                   ;00010
                jnc     ba000100
                add     cx,8                    ;000101=>8
                jmp     save_g3
ba000100:       add     cx,9                    ;000100=>9
                jmp     save_g3
ba0000:         prepare_g4bit(126)                   ;0000
                jnc     ba00000
                prepare_g4bit(127)                   ;00001
                jnc     ba000010
                prepare_g4bit(128)                   ;000011
                jnc     ba0000110
                add     cx,12                   ;0000111=>12
                jmp     save_g3
ba0000110:      prepare_g4bit(129)                   ;0000110
                jnc     ba00001100
                prepare_g4bit(130)                   ;00001101
                jnc     ba000011010
                prepare_g4bit(131)                   ;000011011
                jnc     ba0000110110
                jmp     save_g3                 ;0000110111=>0
ba0000110110:   prepare_g4bit(132)                   ;0000110110
                jnc     ba00001101100
                prepare_g4bit(133)                   ;00001101101
                jnc     ba000011011010
                add     cx,43                   ;000011011011=>43
                jmp     save_g3
ba000011011010: add     cx,42                   ;000011011010=>42
                jmp     save_g3
ba00001101100:  add     cx,21                   ;00001101100=>21
                jmp     save_g3
ba000011010:    prepare_g4bit(134)                   ;000011010
                jnc     ba0000110100
                prepare_g4bit(135)                   ;0000110101
                jnc     ba00001101010
                prepare_g4bit(136)                   ;00001101011
                jnc     ba000011010110
                add     cx,39                   ;000011010111=>39
                jmp     save_g3
ba000011010110: add     cx,38                   ;000011010110=>38
                jmp     save_g3
ba00001101010:  prepare_g4bit(137)                   ;00001101010
                jnc     ba000011010100
                add     cx,37                   ;000011010101=>37
                jmp     save_g3
ba000011010100: add     cx,36                   ;000011010100=>36
                jmp     save_g3
ba0000110100:   prepare_g4bit(138)                   ;0000110100
                jnc     ba00001101000
                prepare_g4bit(139)                   ;00001101001
                jnc     ba000011010010
                add     cx,35                   ;000011010011=>35
                jmp     save_g3
ba000011010010: add     cx,34                   ;000011010010=>34
                jmp     save_g3
ba00001101000:  add     cx,20                   ;00001101000=>20
                jmp     save_g3
ba00001100:     prepare_g4bit(140)                   ;00001100
                jnc     ba000011000
                prepare_g4bit(141)                   ;000011001
                jnc     ba0000110010
                prepare_g4bit(142)                   ;0000110011
                jnc     ba00001100110
                add     cx,19                   ;00001100111=>19
                jmp     save_g3
ba00001100110:  prepare_g4bit(143)                   ;00001100110
                jnc     ba000011001100
                add     cx,29                   ;000011001101=>29
                jmp     save_g3
ba000011001100: add     cx,28                   ;000011001100=>28
                jmp     save_g3
ba0000110010:   prepare_g4bit(144)                   ;0000110010
                jnc     ba00001100100
                prepare_g4bit(145)                   ;00001100101
                jnc     ba000011001010
                add     cx,27                   ;000011001011=>27
                jmp     save_g3
ba000011001010: add     cx,26                   ;000011001010=>26
                jmp     save_g3
ba00001100100:  prepare_g4bit(146)                   ;00001100100
                jnc     ba000011001000
                add     cx,192                  ;000011001001=>192
                jmp     bg3
ba000011001000: add     cx,128                  ;000011001000=>128
                jmp     bg3
ba000011000:    add     cx,15                   ;000011000=>15
                jmp     save_g3
ba000010:       prepare_g4bit(147)                   ;000010
                jnc     ba0000100
                add     cx,11                   ;0000101=>11
                jmp     save_g3
ba0000100:      add     cx,10                   ;0000100=>10
                jmp     save_g3
ba00000:        prepare_g4bit(148)                   ;00000
                jnc     ba000000
                prepare_g4bit(149)                   ;000001
                jnc     ba0000010
                prepare_g4bit(150)                   ;0000011
                jnc     ba00000110
                add     cx,14                   ;00000111=>14
                jmp     save_g3
ba00000110:     prepare_g4bit(151)                   ;00000110
                jnc     ba000001100
                prepare_g4bit(152)                   ;000001101
                jnc     ba0000011010
                prepare_g4bit(153)                   ;0000011011
                jnc     ba00000110110
                add     cx,22                   ;00000110111=>22
                jmp     save_g3
ba00000110110:  prepare_g4bit(154)                   ;00000110110
                jnc     ba000001101100
                add     cx,41                   ;000001101101=>41
                jmp     save_g3
ba000001101100: add     cx,40                   ;000001101100=>40
                jmp     save_g3
ba0000011010:   prepare_g4bit(155)                   ;0000011010
                jnc     ba00000110100
                prepare_g4bit(156)                   ;00000110101
                jnc     ba000001101010
                add     cx,33                   ;000001101011=>33
                jmp     save_g3
ba000001101010: add     cx,32                   ;000001101010=>32
                jmp     save_g3
ba00000110100:  prepare_g4bit(157)                   ;00000110100
                jnc     ba000001101000
                add     cx,31                   ;000001101001=>31
                jmp     save_g3
ba000001101000: add     cx,30                   ;000001101000=>30
                jmp     save_g3
ba000001100:    prepare_g4bit(158)                   ;000001100
                jnc     ba0000011000
                prepare_g4bit(159)                   ;0000011001
                jnc     ba00000110010
                prepare_g4bit(160)                   ;00000110011
                jnc     ba000001100110
                add     cx,63                   ;000001100111=>63
                jmp     save_g3
ba000001100110: add     cx,62                   ;000001100110=>62
                jmp     save_g3
ba00000110010:  prepare_g4bit(161)                   ;00000110010
                jnc     ba000001100100
                add     cx,49                   ;000001100101=>49
                jmp     save_g3
ba000001100100: add     cx,48                   ;000001100100=>48
                jmp     save_g3
ba0000011000:   add     cx,17                   ;0000011000=>17
                jmp     save_g3
ba0000010:      prepare_g4bit(162)                   ;0000010
                jnc     ba00000100
                prepare_g4bit(163)                   ;00000101
                jnc     ba000001010
                prepare_g4bit(164)                   ;000001011
                jnc     ba0000010110
                add     cx,16                   ;0000010111=>16
                jmp     save_g3
ba0000010110:   prepare_g4bit(165)                   ;0000010110
                jnc     ba00000101100
                prepare_g4bit(166)                   ;00000101101
                jnc     ba000001011010
                add     cx,256                  ;000001011011=>256
                jmp     bg3
ba000001011010: add     cx,61                   ;000001011010=>61
                jmp     save_g3
ba00000101100:  prepare_g4bit(167)                   ;00000101100
                jnc     ba000001011000
                add     cx,58                   ;000001011001=>58
                jmp     save_g3
ba000001011000: add     cx,57                   ;000001011000=>57
                jmp     save_g3
ba000001010:    prepare_g4bit(168)                   ;000001010
                jnc     ba0000010100
                prepare_g4bit(169)                   ;0000010101
                jnc     ba00000101010
                prepare_g4bit(170)                   ;00000101011
                jnc     ba000001010110
                add     cx,47                   ;000001010111=>47
                jmp     save_g3
ba000001010110: add     cx,46                   ;000001010110=>46
                jmp     save_g3
ba00000101010:  prepare_g4bit(171)                   ;00000101010
                jnc     ba000001010100
                add     cx,45                   ;000001010101=>45
                jmp     save_g3
ba000001010100: add     cx,44                   ;000001010100=>44
                jmp     save_g3
ba0000010100:   prepare_g4bit(172)                   ;0000010100
                jnc     ba00000101000
                prepare_g4bit(173)                   ;00000101001
                jnc     ba000001010010
                add     cx,51                   ;000001010011=>51
                jmp     save_g3
ba000001010010: add     cx,50                   ;000001010010=>50
                jmp     save_g3
ba00000101000:  add     cx,23                   ;00000101000=>23
                jmp     save_g3
ba00000100:     add     cx,13                   ;00000100=>13
                jmp     save_g3
ba000000:       prepare_g4bit(174)                   ;000000
                jnc     ba0000000
                prepare_g4bit(175)                   ;0000001
                jnc     ba00000010
                prepare_g4bit(176)                   ;00000011
                jnc     ba000000110
                prepare_g4bit(177)                   ;000000111
                jnc     ba0000001110
                add     cx,64                   ;0000001111=>64
                jmp     bg3
ba0000001110:   prepare_g4bit(178)                   ;0000001110
                jnc     ba00000011100
                prepare_g4bit(179)                   ;00000011101
                jnc     ba000000111010
                prepare_g4bit(180)                   ;000000111011
                jnc     ba0000001110110
                add     cx,1216                 ;0000001110111=>1216
                jmp     bg3
ba0000001110110:add     cx,1152                 ;0000001110110=>1152
                jmp     bg3
ba000000111010: prepare_g4bit(181)                   ;000000111010
                jnc     ba0000001110100
                add     cx,1088                 ;0000001110101=>1088
                jmp     bg3
ba0000001110100:add     cx,1024                 ;0000001110100=>1024
                jmp     bg3
ba00000011100:  prepare_g4bit(182)                   ;00000011100
                jnc     ba000000111000
                prepare_g4bit(183)                   ;000000111001
                jnc     ba0000001110010
                add     cx,960                  ;0000001110011=>960
                jmp     bg3
ba0000001110010:add     cx,896                  ;0000001110010=>896
                jmp     bg3
ba000000111000: add     cx,54                   ;000000111000=>54
                jmp     save_g3
ba000000110:    prepare_g4bit(184)                   ;000000110
                jnc     ba0000001100
                prepare_g4bit(185)                   ;0000001101
                jnc     ba00000011010
                prepare_g4bit(186)                   ;00000011011
                jnc     ba000000110110
                add     cx,53                   ;000000110111=>53
                jmp     save_g3
ba000000110110: prepare_g4bit(187)                   ;000000110110
                jnc     ba0000001101100
                add     cx,576                  ;0000001101101=>576
                jmp     bg3
ba0000001101100:add     cx,512                  ;0000001101100=>512
                jmp     bg3
ba00000011010:  prepare_g4bit(188)                   ;00000011010
                jnc     ba000000110100
                add     cx,448                  ;000000110101=>448
                jmp     bg3
ba000000110100: add     cx,384                  ;000000110100=>384
                jmp     bg3
ba0000001100:   prepare_g4bit(189)                   ;0000001100
                jnc     ba00000011000
                prepare_g4bit(190)                   ;00000011001
                jnc     ba000000110010
                add     cx,320                  ;000000110011=>320
                jmp     bg3
ba000000110010: prepare_g4bit(191)                   ;000000110010
                jnc     ba0000001100100
                add     cx,1728                 ;0000001100101=>1728
                jmp     bg3
ba0000001100100:add     cx,1664                 ;0000001100100=>1664
                jmp     bg3
ba00000011000:  add     cx,25                   ;00000011000=>25
                jmp     save_g3
ba00000010:     prepare_g4bit(192)                   ;00000010
                jnc     ba000000100
                prepare_g4bit(193)                   ;000000101
                jnc     ba0000001010
                prepare_g4bit(194)                   ;0000001011
                jnc     ba00000010110
                add     cx,24                   ;00000010111=>24
                jmp     save_g3
ba00000010110:  prepare_g4bit(195)                   ;00000010110
                jnc     ba000000101100
                prepare_g4bit(196)                   ;000000101101
                jnc     ba0000001011010
                add     cx,1600                 ;0000001011011=>1600
                jmp     bg3
ba0000001011010:add     cx,1536                 ;0000001011010=>1536
                jmp     bg3
ba000000101100: add     cx,60                   ;000000101100=>60
                jmp     save_g3
ba0000001010:   prepare_g4bit(197)                   ;0000001010
                jnc     ba00000010100
                prepare_g4bit(198)                   ;00000010101
                jnc     ba000000101010
                add     cx,59                   ;000000101011=>59
                jmp     save_g3
ba000000101010: prepare_g4bit(199)                   ;000000101010
                jnc     ba0000001010100
                add     cx,1472                 ;0000001010101=>1472
                jmp     bg3
ba0000001010100:add     cx,1408                 ;0000001010100=>1408
                jmp     bg3
ba00000010100:  prepare_g4bit(200)                   ;00000010100
                jnc     ba000000101000
                prepare_g4bit(201)                   ;000000101001
                jnc     ba0000001010010
                add     cx,1344                 ;0000001010011=>1344
                jmp     bg3
ba0000001010010:add     cx,1280                 ;0000001010010=>1280
                jmp     bg3
ba000000101000: add     cx,56                   ;000000101000=>56
                jmp     save_g3
ba000000100:    prepare_g4bit(202)                   ;000000100
                jnc     ba0000001000
                prepare_g4bit(203)                   ;0000001001
                jnc     ba00000010010
                prepare_g4bit(204)                   ;00000010011
                jnc     ba000000100110
                add     cx,55                   ;000000100111=>55
                jmp     save_g3
ba000000100110: prepare_g4bit(205)                   ;000000100110
                jnc     ba0000001001100
                add     cx,832                  ;0000001001101=>832
                jmp     bg3
ba0000001001100:add     cx,768                  ;0000001001100=>768
                jmp     bg3
ba00000010010:  prepare_g4bit(206)                   ;00000010010
                jnc     ba000000100100
                prepare_g4bit(207)                   ;000000100101
                jnc     ba0000001001010
                add     cx,704                  ;0000001001011=>704
                jmp     bg3
ba0000001001010:add     cx,640                  ;0000001001010=>640
                jmp     bg3
ba000000100100: add     cx,52                   ;000000100100=>52
                jmp     save_g3
ba0000001000:   add     cx,18                   ;0000001000=>18
                jmp     save_g3
ba0000000:      prepare_g4bit(208)                   ;0000000
                jnc     ba00000000
                prepare_g4bit(209)                   ;00000001
                jnc     ba000000010
                prepare_g4bit(210)                   ;000000011
                jnc     ba0000000110
                prepare_g4bit(211)                   ;0000000111
                jnc     ba00000001110
                prepare_g4bit(212)                   ;00000001111
                jnc     ba000000011110
                add     cx,2560                 ;000000011111=>2560
                jmp     bg3
ba000000011110: add     cx,2496                 ;000000011110=>2496
                jmp     bg3
ba00000001110:  prepare_g4bit(213)                   ;00000001110
                jnc     ba000000011100
                add     cx,2432                 ;000000011101=>2432
                jmp     bg3
ba000000011100: add     cx,2368                 ;000000011100=>2368
                jmp     bg3
ba0000000110:   prepare_g4bit(214)                   ;0000000110
                jnc     ba00000001100
                add     cx,1920                 ;00000001101=>1920
                jmp     bg3
ba00000001100:  add     cx,1856                 ;00000001100=>1856
                jmp     bg3
ba000000010:    prepare_g4bit(215)                   ;000000010
                jnc     ba0000000100
                prepare_g4bit(216)                   ;0000000101
                jnc     ba00000001010
                prepare_g4bit(217)                   ;00000001011
                jnc     ba000000010110
                add     cx,2304                 ;000000010111=>2304
                jmp     bg3
ba000000010110: add     cx,2240                 ;000000010110=>2240
                jmp     bg3
ba00000001010:  prepare_g4bit(218)                   ;00000001010
                jnc     ba000000010100
                add     cx,2176                 ;000000010101=>2176
                jmp     bg3
ba000000010100: add     cx,2112                 ;000000010100=>2112
                jmp     bg3
ba0000000100:   prepare_g4bit(219)                   ;0000000100
                jnc     ba00000001000
                prepare_g4bit(220)                   ;00000001001
                jnc     ba000000010010
                add     cx,2048                 ;000000010011=>2048
                jmp     bg3
ba000000010010: add     cx,1984                 ;000000010010=>1984
                jmp     bg3
ba00000001000:  add     cx,1792                 ;00000001000=>1792
                jmp     bg3
ba00000000:     mov     cx,-1                   ;error
                jmp     save_g3


finish_g4rl:    
                cld
                mov ebp ,valebp
                mov  esi, valesi
                mov  edi, valedi
				mov  retval, EAX 
	}
    return retval;
}



int __stdcall g4bin2m(BYTE  *g4buffer, 
                      WORD  *binbuffer, 
                      DWORD g4memsize,
                      DWORD binmemsize, 
                      DWORD *_g4bufcnt,  
                      DWORD *_binbufcnt, 
                      WORD  _image_width,  //  IN PIXEL
                      WORD  _linesperstrip, 
			          BYTE  _moretocome)

{
DLL_THREAD_MANAGEMENT();

	pref_line = ref_line;
	pcod_line=cod_line;
	pblack=black;
	pwhite= white;
    __asm
    {  
		mov DWORD PTR valebp,ebp
		mov DWORD PTR valesi,esi
		mov DWORD PTR valedi,edi
	
		mov  eax,g4buffer 
		mov  edx,binbuffer 
		mov  ebx,g4memsize 
		mov  ecx,binmemsize 

		mov	 di, _image_width 
		mov	image_width,di        
		shr	di,3		
		bt	di,0
		jnc     isshort
		inc	di

isshort:        movzx	edi,di
		sub	ecx,edi
		mov	binsize,ecx		;save binmemsize minus safety
		mov	cl,[ebp+32]		;read moretocome
		cmp	cl,0
		je	lastbuf
		sub	ebx,45000
lastbuf:	mov	g4mem,ebx		;save g4memsize minus safety
		mov	edi,[ebp+16]		;read add for g4bufcnt
		mov	g4bufcntp,edi
		mov	edi,[ebp+20]		;read add for binbufcnt
		mov	binbufcntp,edi
		mov	g4bufcnt,0
		mov	binbufcnt,0
		mov	passvalue,0
		mov	bin_bitcnt,15
		mov	cx,b1         ;see if first buf: b1=-1 if first file
		cmp	cx,0	      ;or linecnt=0 (from previous conversion)
		js	firstbuf      ;for next files
		mov	cx,linecnt
		cmp	cx,0
		jne 	length_loop
firstbuf:	mov	bx,[ebp+28]
		mov	linecnt,bx     ;Initializes linecnt with linesperstrip
		mov	ecx,pref_line
		mov	bx,image_width
		mov	[ecx],bx                ;Initializes ref_line and b1
		mov	b1,bx                   ;for first line in strip
		mov	bitcnt,8
length_loop:	mov	a0,-1
		mov	i,0
		mov	j,0
		mov	ecx,pref_line
width_loop:	mov	bx,b1
		cmp     bx,image_width
		jne	calc_b2                 ;if b1 at end of line
		mov	b2,bx			;b2=b1=image_width
		jmp	g4_tree
calc_b2:	mov	ebp,i
		inc	ebp
		add	bx,[ecx][ebp*2]
		mov	b2,bx			;b2=b1+ref_line[i+1]
	;Uses EAX(g4buf),ESI(g4bufcnt),BX(bitcnt)
	;EAX is preserved through the functions called, BX and ESI are not
	;Passes left and right position through CX(-3 to +3)
	;returns error or correct op from horizontal in CX
	;return towards the end of width_loop at end_g4_code
g4_tree:        mov	bx,bitcnt
		mov	esi,g4bufcnt
		prepare_g4bit(1)
		jnc	g4a0
		mov	g4bufcnt,esi
		mov	bitcnt,bx			;1=>V(0)
		mov    	cx,0
		jmp	vert_left
g4a0:	    	prepare_g4bit(2)  				;0
		jnc	g4a00
		prepare_g4bit(3)				;01
		mov	g4bufcnt,esi
		mov	bitcnt,bx
		jnc	g4a010
		mov	cx,1                            ;011=>VR(1)
		jmp	vert_right
g4a010:		mov	cx,-1				;010=>VL(1)
		jmp	vert_left
g4a00:		prepare_g4bit(4)				;00
		jnc	g4a000
		mov	g4bufcnt,esi
		mov	bitcnt,bx
		jmp	horizont                	;001=>H
g4a000:		prepare_g4bit(5)				;000
		jnc	g4a0000
		mov	g4bufcnt,esi
		mov	bitcnt,bx
		mov	cx,b2       			;0001=>P
		sub	cx,a0
		add	passvalue,cx
		mov	cx,b2
		mov	a0,cx
		inc	i
		inc	i
		mov	ebx,pref_line
		mov	ebp,i
		add	cx,[ebx][ebp*2]
		mov	b1,cx
		mov	ecx,0
		jmp	end_g4_code
g4a0000:	prepare_g4bit(6)				;0000
		jnc	g4a00000
		prepare_g4bit(7)				;00001
		mov	bitcnt,bx
		mov	g4bufcnt,esi
		jnc	g4a000010
		mov	cx,2				;000011=>VR(2)
		jmp	vert_right
g4a000010:	mov	cx,-2				;000010=>VL(2)
		jmp	vert_left
g4a00000:	prepare_g4bit(8)				;00000
		jnc	g4a000000
		prepare_g4bit(9)				;000001
		mov	bitcnt,bx
		mov	g4bufcnt,esi
		jnc	g4a0000010
		mov	cx,3				;0000011=>VR(3)
		jmp	vert_right
g4a0000010:	mov	cx,-3				;0000010=>VL(3)
		jmp	vert_left
g4a000000:      mov	edi,binbufcnt
		mov	eax,binbufcntp
		mov	[eax],edi
		mov	eax,-1                          ;return error
		jmp	finish_g4rl
;
end_g4_code:	cmp	ecx,-1
		je	g4a000000
		mov	ecx,pref_line
		mov	bx,a0
		cmp	bx,image_width
		jne	width_loop
		mov	edi,binbufcnt
;
		mov	ebx,bin_bitcnt
		cmp	bx,15
		je	nopadding
		mov	si,[edx][edi]
		mov	ebp,pwhite
		and	si,[ebp][ebx*2]
		mov	[edx][edi],si
		inc	edi
		inc	edi
nopadding:	mov	bin_bitcnt,15
		mov	binbufcnt,edi
		mov	di,linecnt
		dec	di
		mov	linecnt,di
		jnz	update_ref
		mov	esi,g4bufcnt
		mov	eax,g4bufcntp
		mov	[eax],esi
		mov	edi,binbufcnt
		mov	eax,binbufcntp			;return binbufcnt
		mov	[eax],edi
		mov	eax,0
		jmp finish_g4rl

update_ref:	mov     ecx,j           		;prepare ref line
		mov     esi,pcod_line
		mov	edi,pref_line
		rep	movsw
		mov	cx,b1				;prepare first b1
		mov	edi,pref_line
		mov	cx,[edi]
		mov	b1,cx
;
		mov	esi,g4bufcnt                    ;check g4buffer ended
		mov	edi,binbufcnt			;check binbuffer ended
		mov	ecx,g4mem
		cmp	esi,ecx
		jg      full_buf
		mov	ecx,binsize
		cmp	edi,ecx
		jbe	length_loop
full_buf:       mov	eax,g4bufcntp
		mov	[eax],esi
		mov	eax,binbufcntp			;return binbufcnt
		mov	[eax],edi
		mov	eax,1
		jmp	finish_g4rl
;
;	VERT_LEFT function solves the vertical left and zero codes
;				Registers used:
;					Input	EAX -g4buffer
;						EDX -rlbuffer
;						ECX -position (0 to -3)
;                               	Output	ECX -correct (if 0)
;					Uses all the other regs except ESI
;
;
vert_left:	mov	edi,binbufcnt
		mov	ebp,j
		cmp	ebp,0
		jnz	save_vl
		mov	bx,passvalue
		dec	bx
		mov	passvalue,bx
save_vl:	add	cx,b1
		mov	a1,cx
		sub	cx,a0                  ;b1-pos-a0
		add	cx,passvalue	       ;b1-pos-a0+passvalue
		mov	ebx,pcod_line
		mov	[ebx][ebp*2],cx
;
		mov	ebx,bin_bitcnt
		mov	si,[edx][edi]
		bt	ebp,0
		jc	vlb_makebin
vlw_makebin:    cmp	cx,0
		jz      vl_endbin              ;If 0 don't write anything
		cmp	bx,15
		jne	vlw_bin1
		cmp	cx,32
		js 	vlw_bin3
		mov	si,cx
		and	si,001fh
		shr	cx,5
vlw_bin2:	mov	dword ptr [edx][edi],0
		add	edi,4
		dec	cx
		jnz	vlw_bin2
		cmp	si,0
		je	vl_endbin
		mov	cx,si
vlw_bin3:	mov	word ptr [edx][edi],0
		cmp	cx,16
		js	vlw_bin4
		add	edi,2
		mov	word ptr [edx][edi],0
		sub	cx,16
vlw_bin4:       sub	bx,cx
		jmp	vl_endbin
vlw_bin1:       mov	ebp,pwhite
		inc	bx
		cmp	cx,bx
		js	vlw_bin6
		sub	cx,bx
		dec	bx
		and	si,[ebp][ebx*2]
		mov     [edx][edi],si
		add	edi,2
		mov	bx,15
		jmp	vlw_makebin
vlw_bin6:	dec	bx
		and	si,[ebp][ebx*2]
		sub	bx,cx
		mov	[edx][edi],si
		jmp	vl_endbin
vlb_makebin:    cmp	cx,0
		jz      vl_endbin              ;If 0 don't write anything
		cmp	bx,15
		jne	vlb_bin1
		cmp	cx,32
		js 	vlb_bin3
		mov	si,cx
		and	si,001fh
		shr	cx,5
vlb_bin2:	mov	dword ptr [edx][edi],0ffffffffh
		add	edi,4
		dec	cx
		jnz	vlb_bin2
		cmp	si,0
		je	vl_endbin
		mov	cx,si
vlb_bin3:	mov	word ptr [edx][edi],0ffffh
		cmp	cx,16
		js	vlb_bin4
		add	edi,2
		mov	word ptr [edx][edi],0ffffh
		sub	cx,16
vlb_bin4:       sub	bx,cx
		jmp	vl_endbin
vlb_bin1:       mov	ebp,pblack
		inc	bx
		cmp	cx,bx
		js	vlb_bin6
		sub	cx,bx
		dec	bx
		or	si,[ebp][ebx*2]
		mov     [edx][edi],si
		add	edi,2
		mov	bx,15
		jmp	vlb_makebin
vlb_bin6:	dec	bx
		or	si,[ebp][ebx*2]
		sub	bx,cx
		mov	[edx][edi],si
vl_endbin:	mov	bin_bitcnt,ebx
;
		mov	ebp,j
		mov	cx,a1
		cmp	cx,image_width
		jbe	inside_vl
		sub	cx,image_width
		sub	[ebx][ebp*2],cx
		mov	cx,image_width
inside_vl:	inc	ebp
		mov	j,ebp
		mov	binbufcnt,edi
		mov	a0,cx
		mov	ebp,i
		mov	ebx,pref_line
		mov	di,b1
		sub	di,[ebx][ebp*2]
		cmp	di,a0
		jbe	left_b1
		dec	ebp
		jmp	fin_vl
left_b1:	mov	di,b1
		cmp	di,image_width
		jae	fin_vl
		inc	ebp
		add	di,[ebx][ebp*2]
fin_vl:		mov	i,ebp
		mov	b1,di
		mov	passvalue,0
		mov	ecx,0
		jmp	end_g4_code
;
;	VERT_RIGHT function solves the vertical right codes
;				Registers used:
;					Input	EAX -g4buffer
;						EDX -rlbuffer
;						ECX -position (1 to 3)
;                               	Output	ECX -correct (if 0)
;					Uses all the other regs except ESI
;
vert_right:	mov	edi,binbufcnt
		mov	ebp,j
		cmp	ebp,0
		jnz	save_vr
		mov	bx,passvalue
		dec 	bx
		mov	passvalue,bx
save_vr:	add	cx,b1			;pos+b1
		mov	a1,cx			;a1=b1+pos
		sub	cx,a0			;pos+b1-a0
		add	cx,passvalue
		mov	ebx,pcod_line
		mov	[ebx][ebp*2],cx
;
		mov	ebx,bin_bitcnt
		mov	si,[edx][edi]
		bt	ebp,0
		jc	vrb_makebin
vrw_makebin:    cmp	cx,0
		jz      vr_endbin              ;If 0 don't write anything
		cmp	bx,15
		jne	vrw_bin1
		cmp	cx,32
		js 	vrw_bin3
		mov	si,cx
		and	si,001fh
		shr	cx,5
vrw_bin2:	mov	dword ptr [edx][edi],0
		add	edi,4
		dec	cx
		jnz	vrw_bin2
		cmp	si,0
		je	vr_endbin
		mov	cx,si
vrw_bin3:	mov	word ptr [edx][edi],0
		cmp	cx,16
		js	vrw_bin4
		add	edi,2
		mov	word ptr [edx][edi],0
		sub	cx,16
vrw_bin4:       sub	bx,cx
		jmp	vr_endbin
vrw_bin1:       mov	ebp,pwhite
		inc	bx
		cmp	cx,bx
		js	vrw_bin6
		sub	cx,bx
		dec	bx
		and	si,[ebp][ebx*2]
		mov     [edx][edi],si
		add	edi,2
		mov	bx,15
		jmp	vrw_makebin
vrw_bin6:	dec	bx
		and	si,[ebp][ebx*2]
		sub	bx,cx
		mov	[edx][edi],si
		jmp	vr_endbin
vrb_makebin:    cmp	cx,0
		jz      vr_endbin              ;If 0 don't write anything
		cmp	bx,15
		jne	vrb_bin1
		cmp	cx,32
		js 	vrb_bin3
		mov	si,cx
		and	si,001fh
		shr	cx,5
vrb_bin2:	mov	dword ptr [edx][edi],0ffffffffh
		add	edi,4
		dec	cx
		jnz	vrb_bin2
		cmp	si,0
		je	vr_endbin
		mov	cx,si
vrb_bin3:	mov	word ptr [edx][edi],0ffffh
		cmp	cx,16
		js	vrb_bin4
		add	edi,2
		mov	word ptr [edx][edi],0ffffh
		sub	cx,16
vrb_bin4:       sub	bx,cx
		jmp	vr_endbin
vrb_bin1:       mov	ebp,pblack
		inc	bx
		cmp	cx,bx
		js	vrb_bin6
		sub	cx,bx
		dec	bx
		or	si,[ebp][ebx*2]
		mov     [edx][edi],si
		add	edi,2
		mov	bx,15
		jmp	vrb_makebin
vrb_bin6:	dec	bx
		or	si,[ebp][ebx*2]
		sub	bx,cx
		mov	[edx][edi],si
vr_endbin: 	mov	bin_bitcnt,ebx
;
		mov	ebp,j
		mov	cx,a1
		cmp	cx,image_width
		jbe	inside_vr
		sub	cx,image_width
		sub	[ebx][ebp*2],cx
		mov	cx,image_width
inside_vr:	inc	ebp
		mov	j,ebp
		mov	binbufcnt,edi
		mov	a0,cx			;a0=a1
		mov	ebp,i
		mov	ebx,pref_line
		mov	di,b1
		inc	ebp
		add	di,[ebx][ebp*2]
make_ivr:       cmp	cx,di
		jb	fin_vr
		cmp	di,image_width
		jae	fin_vr
		inc	ebp
		add	di,[ebx][ebp*2]
		cmp	di,image_width
		jae	fin_vr
		inc	ebp
		add	di,[ebx][ebp*2]
		jmp	make_ivr
fin_vr:		mov	i,ebp
		mov	b1,di
		mov	passvalue,0
		mov	ecx,0
		jmp	end_g4_code
;
;	HORIZONT function solves the horizontal codes
;				Registers used:
;					Input	EAX -g4buffer
;						EDX -rlbuffer
;                               	Output	ECX -correct (if 0)
;						    -error code(if -1)
;					Uses all the other regs
horizont:	mov	cnt,2
		mov	edi,binbufcnt
		mov	ebp,j
;	dec passvalue if the first ellement in line
		mov	flag,0
		cmp	ebp,0
		jnz	read_g3
		mov	cx,passvalue
		cmp	cx,0
		jz	nopass
		mov	flag,1
		jmp	read_g3
;	read g3 info in cx register
nopass:		mov	a0,0
read_g3:	mov	cx,0
		mov	bx,bitcnt
		mov	esi,g4bufcnt
		bt	ebp,0			;see if j even or odd
		jnc	wg3			;white g3
		jmp	bg3			;black g3
;	save g3 info from cx in rl buffer
save_g3:        mov	bitcnt,bx 		;save new bitcnt
		mov	g4bufcnt,esi
		cmp	cx,0                    ;if -1 error code return
		js	error_code
		add	a0,cx
		add	cx,passvalue
		sub	cx,flag
		mov	ebx,pcod_line
		mov	[ebx][ebp*2],cx		;save rl in the coding line
;
		mov	ebx,bin_bitcnt
		mov	si,[edx][edi]
		bt	ebp,0
		jc	hb_makebin
hw_makebin:    	cmp	cx,0
		jz      h_endbin              ;If 0 don't write anything
		cmp	bx,15
		jne	hw_bin1
		cmp	cx,32
		js 	hw_bin3
		mov	si,cx
		and	si,001fh
		shr	cx,5
hw_bin2:	mov	dword ptr [edx][edi],0
		add	edi,4
		dec	cx
		jnz	hw_bin2
		cmp	si,0
		je	h_endbin
		mov	cx,si
hw_bin3:	mov	word ptr [edx][edi],0
		cmp	cx,16
		js	hw_bin4
		add	edi,2
		mov	word ptr [edx][edi],0
		sub	cx,16
hw_bin4:        sub	bx,cx
		jmp	h_endbin
hw_bin1:        mov	ebp,pwhite
		inc	bx
		cmp	cx,bx
		js	hw_bin6
		sub	cx,bx
		dec	bx
		and	si,[ebp][ebx*2]
		mov     [edx][edi],si
		add	edi,2
		mov	bx,15
		jmp	hw_makebin
hw_bin6:	dec	bx
		and	si,[ebp][ebx*2]
		sub	bx,cx
		mov	[edx][edi],si
		jmp	h_endbin
hb_makebin:	cmp	cx,0
		jz      h_endbin              ;If 0 don't write anything
		cmp	bx,15
		jne	hb_bin1
		cmp	cx,32
		js 	hb_bin3
		mov	si,cx
		and	si,001fh
		shr	cx,5
hb_bin2:	mov	dword ptr [edx][edi],0ffffffffh
		add	edi,4
		dec	cx
		jnz	hb_bin2
		cmp	si,0
		je	h_endbin
		mov	cx,si
hb_bin3:	mov	word ptr [edx][edi],0ffffh
		cmp	cx,16
		js	hb_bin4
		add	edi,2
		mov	word ptr [edx][edi],0ffffh
		sub	cx,16
hb_bin4:        sub	bx,cx
		jmp	h_endbin
hb_bin1:        mov	ebp,pblack
		inc	bx
		cmp	cx,bx
		js	hb_bin6
		sub	cx,bx
		dec	bx
		or	si,[ebp][ebx*2]
		mov     [edx][edi],si
		add	edi,2
		mov	bx,15
		jmp	hb_makebin
hb_bin6:	dec	bx
		or	si,[ebp][ebx*2]
		sub	bx,cx
		mov	[edx][edi],si
h_endbin: 	mov	bin_bitcnt,ebx
;
		mov	ebp,j
		mov	cx,a0
		cmp	cx,image_width
		jbe	inside_line             ;If exceeding image_width,
		sub	cx,image_width		;adjust at image_width
		sub	[ebx][ebp*2],cx         ;both cod_line[j] and pixcnt
		mov	cx,image_width
inside_line:	mov	passvalue,0
		mov	a0,cx
		inc	ebp
		dec	cnt
		mov	flag,0
		mov	j,ebp
		jnz	read_g3
		mov	binbufcnt,edi           ;save new binbufcnt
		mov	ebx,pref_line
		mov	ebp,i
		mov	di,b1
make_i:		cmp	cx,di
		jb	fin_horiz
		cmp	di,image_width
		jae	fin_horiz
		inc	ebp
		add	di,[ebx][ebp*2]
		cmp	di,image_width
		jae	fin_horiz
		inc	ebp
		add	di,[ebx][ebp*2]
		jmp	make_i
fin_horiz:	mov	i,ebp
		mov	b1,di
		mov	ecx,0
		jmp	end_g4_code
error_code:	mov	ecx,-1
		jmp     end_g4_code
;
;	WhiteG3 function decodes g3 info in horizontal encoding
;				Registers used:
;					Input	EAX -g4buffer
;						ESI -g4bufcnt
;						 BX -bitcnt
;                               	Output	 CX -runlength (if>=0)
;						    -error code(if -1)
;					Doesn't use other regs
wg3:       	prepare_g4bit(10)
		jnc	wa0
		prepare_g4bit(11)			;1
		jnc	wa10
		prepare_g4bit(12)			;11
		jnc	wa110
		prepare_g4bit(13)			;111
		jnc	wa1110
		add	cx,7			;1111=>7
		jmp	save_g3
wa1110:         add	cx,6			;1110=>6
		jmp	save_g3
wa110:          prepare_g4bit(14)			;110
		jnc	wa1100
		prepare_g4bit(15)			;1101
		jnc	wa11010
		add	cx,64			;11011=>64
		jmp	wg3
wa11010:        prepare_g4bit(16)			;11010
		jnc	wa110100
		add	cx,15			;110101=>15
		jmp	save_g3
wa110100:       add	cx,14			;110100=>14
		jmp	save_g3
wa1100:		add	cx,5			;1100=>5
		jmp	save_g3
wa10:           prepare_g4bit(17)			;10
		jnc	wa100
		prepare_g4bit(18)			;101
		jnc	wa1010
		add	cx,4			;1011=>4
		jmp	save_g3
wa1010:         prepare_g4bit(19)			;1010
		jnc	wa10100
		prepare_g4bit(20)			;10101
		jnc	wa101010
		add	cx,17			;101011=>17
		jmp	save_g3
wa101010:       add	cx,16			;101010=>16
		jmp	save_g3
wa10100:        add	cx,9			;10100=>9
		jmp	save_g3
wa100:          prepare_g4bit(21)			;100
		jnc	wa1000
		prepare_g4bit(22)			;1001
		jnc	wa10010
		add	cx,8			;10011=>8
		jmp	save_g3
wa10010:        add	cx,128			;10010=>128
		jmp	wg3
wa1000:         add	cx,3			;1000=>3
		jmp	save_g3
wa0:            prepare_g4bit(23)			;0
		jnc	wa00
		prepare_g4bit(24)			;01
		jnc	wa010
		prepare_g4bit(25)			;011
		jnc	wa0110
		add	cx,2			;0111=>2
		jmp	save_g3
wa0110:         prepare_g4bit(26)			;0110
		jnc	wa01100
		prepare_g4bit(27)			;01101
		jnc	wa011010
		prepare_g4bit(28)			;011011
		jnc	wa0110110
		add	cx,256			;0110111=>256
		jmp	wg3
wa0110110:      prepare_g4bit(29)			;0110110
		jnc	wa01101100
		prepare_g4bit(30)			;01101101
		jnc	wa011011010
		add	cx,1408			;011011011=>1408
		jmp	wg3
wa011011010:    add	cx,1344			;011011010=>1344
		jmp	wg3
wa01101100:     prepare_g4bit(31)			;01101100
		jnc	wa011011000
		add	cx,1280			;011011001=>1280
		jmp	wg3
wa011011000:    add	cx,1216			;011011000=>1216
		jmp	wg3
wa011010:       prepare_g4bit(32)			;011010
		jnc	wa0110100
		prepare_g4bit(33)                   ;0110101
		jnc	wa01101010
		prepare_g4bit(34)			;01101011
		jnc	wa011010110
		add	cx,1152			;011010111=>1152
		jmp	wg3
wa011010110:    add	cx,1088			;011010110=>1088
		jmp	wg3
wa01101010:     prepare_g4bit(35)			;01101010
		jnc	wa011010100
		add	cx,1024			;011010101=>1024
		jmp	wg3
wa011010100:    add	cx,960			;011010100=>960
		jmp	wg3
wa0110100:      prepare_g4bit(36)			;0110100
		jnc	wa01101000
		prepare_g4bit(37)			;01101001
		jnc	wa011010010
		add	cx,896			;011010011=>896
		jmp	wg3
wa011010010:    add	cx,832			;011010010=>832
		jmp	wg3
wa01101000:     add	cx,576			;01101000=>576
		jmp	wg3
wa01100:        prepare_g4bit(38)			;01100
		jnc	wa011000
		prepare_g4bit(39)			;011001
		jnc	wa0110010
		prepare_g4bit(40)			;0110011
		jnc	wa01100110
		add	cx,640			;01100111=>640
		jmp	wg3
wa01100110:     prepare_g4bit(41)			;01100110
		jnc	wa011001100
		add	cx,768			;011001101=>768
		jmp	wg3
wa011001100:    add	cx,704			;011001100=>704
		jmp	wg3
wa0110010:      prepare_g4bit(42)			;0110010
		jnc	wa01100100
		add	cx,512			;01100101=>512
		jmp	wg3
wa01100100:     add	cx,448			;01100100=>448
		jmp	wg3
wa011000:       add	cx,1664			;011000=>1664
		jmp	wg3
wa010:          prepare_g4bit(43)			;010
		jnc	wa0100
		prepare_g4bit(44)			;0101
		jnc	wa01010
		prepare_g4bit(45)			;01011
		jnc	wa010110
		add	cx,192			;010111=>192
		jmp	wg3
wa010110:       prepare_g4bit(46)			;010110
		jnc	wa0101100
		prepare_g4bit(47)			;0101101
		jnc	wa01011010
		add	cx,58			;01011011=>58
		jmp	save_g3
wa01011010:     add	cx,57			;01011010=>57
		jmp	save_g3
wa0101100:      prepare_g4bit(48)			;0101100
		jnc	wa01011000
		add	cx,56			;01011001=>56
		jmp	save_g3
wa01011000:     add	cx,55			;01011000=>55
		jmp	save_g3
wa01010:        prepare_g4bit(49)			;01010
		jnc	wa010100
		prepare_g4bit(50)			;010101
		jnc	wa0101010
		add	cx,25			;0101011=>25
		jmp	save_g3
wa0101010:      prepare_g4bit(51)			;0101010
		jnc	wa01010100
		add	cx,52			;01010101=>52
		jmp	save_g3
wa01010100:     add	cx,51			;01010100=>51
		jmp	save_g3
wa010100:       prepare_g4bit(52)			;010100
		jnc	wa0101000
		prepare_g4bit(53)			;0101001
		jnc	wa01010010
		add	cx,50			;01010011=>50
		jmp	save_g3
wa01010010:     add	cx,49			;01010010=>49
		jmp	save_g3
wa0101000:      add	cx,24			;0101000=>24
		jmp	save_g3
wa0100:         prepare_g4bit(54)			;0100
		jnc	wa01000
		prepare_g4bit(55)			;01001
		jnc	wa010010
		prepare_g4bit(56)			;010011
		jnc	wa0100110
		add	cx,18			;0100111=>18
		jmp	save_g3
wa0100110:	prepare_g4bit(57)			;0100110
		jnc	wa01001100
		prepare_g4bit(58)			;01001101
		jnc	wa010011010
		add	cx,1728			;010011011=>1728
		jmp	wg3
wa010011010:    add	cx,1600			;010011010=>1600
		jmp	wg3
wa01001100:     prepare_g4bit(59)			;01001100
		jnc	wa010011000
		add	cx,1536			;010011001=>1536
		jmp	wg3
wa010011000:    add	cx,1472			;010011000=>1472
		jmp	wg3
wa010010:       prepare_g4bit(60)			;010010
		jnc	wa0100100
		prepare_g4bit(61)			;0100101
		jnc	wa01001010
		add	cx,60			;01001011=>60
		jmp	save_g3
wa01001010:     add	cx,59			;01001010=>59
		jmp	save_g3
wa0100100:      add	cx,27			;0100100=>27
		jmp	save_g3
wa01000:        add	cx,11			;01000=>11
		jmp	save_g3
wa00:           prepare_g4bit(62)			;00
		jnc	wa000
		prepare_g4bit(63)			;001
		jnc	wa0010
		prepare_g4bit(64)			;0011
		jnc	wa00110
		add	cx,10			;00111=>10
		jmp	save_g3
wa00110:        prepare_g4bit(65)			;00110
		jnc	wa001100
		prepare_g4bit(66)			;001101
		jnc	wa0011010
		prepare_g4bit(67)			;0011011
		jnc	wa00110110
		add	cx,384			;00110111=>384
		jmp	wg3
wa00110110:     add	cx,320			;00110110=>320
		jmp	wg3
wa0011010:      prepare_g4bit(68)			;0011010
		jnc	wa00110100
		add	cx,0			;00110101=>0
		jmp	save_g3
wa00110100:     add	cx,63			;00110100=>63
		jmp	save_g3
wa001100:       prepare_g4bit(69)			;001100
		jnc	wa0011000
		prepare_g4bit(70)			;0011001
		jnc	wa00110010
		add	cx,62			;00110011=>62
		jmp	save_g3
wa00110010:     add	cx,61			;00110010=>61
		jmp	save_g3
wa0011000:      add	cx,28			;0011000=>28
		jmp	save_g3
wa0010:         prepare_g4bit(71)			;0010
		jnc	wa00100
		prepare_g4bit(72)			;00101
		jnc	wa001010
		prepare_g4bit(73)			;001011
		jnc	wa0010110
		add	cx,21			;0010111=>21
		jmp	save_g3
wa0010110:      prepare_g4bit(74)			;0010110
		jnc	wa00101100
		add	cx,44			;00101101=>44
		jmp	save_g3
wa00101100:     add	cx,43			;00101100=>43
		jmp	save_g3
wa001010:       prepare_g4bit(75)			;001010
		jnc	wa0010100
		prepare_g4bit(76)			;0010101
		jnc	wa00101010
		add	cx,42			;00101011=>42
		jmp	save_g3
wa00101010:     add	cx,41			;00101010=>41
		jmp	save_g3
wa0010100:      prepare_g4bit(77)			;0010100
		jnc	wa00101000
		add	cx,40			;00101001=>40
		jmp	save_g3
wa00101000:     add	cx,39			;00101000=>39
		jmp	save_g3
wa00100:        prepare_g4bit(78)			;00100
		jnc	wa001000
		prepare_g4bit(79)			;001001
		jnc	wa0010010
		add	cx,26			;0010011=>26
		jmp	save_g3
wa0010010:      prepare_g4bit(80)			;0010010
		jnc	wa00100100
		add	cx,54			;00100101=>54
		jmp	save_g3
wa00100100:     add	cx,53			;00100100=>53
		jmp	save_g3
wa001000:       add	cx,12			;001000=>12
		jmp	save_g3
wa000:          prepare_g4bit(81)			;000
		jnc	wa0000
		prepare_g4bit(82)			;0001
		jnc	wa00010
		prepare_g4bit(83)			;00011
		jnc	wa000110
		add	cx,1			;000111=>1
		jmp	save_g3
wa000110:       prepare_g4bit(84)			;000110
		jnc	wa0001100
		prepare_g4bit(85)			;0001101
		jnc	wa00011010
		add	cx,32			;00011011=>32
		jmp	save_g3
wa00011010:	add	cx,31			;00011010=>31
		jmp	save_g3
wa0001100:      add	cx,19			;0001100=>19
		jmp	save_g3
wa00010:        prepare_g4bit(86)			;00010
		jnc	wa000100
		prepare_g4bit(87)			;000101
		jnc	wa0001010
		prepare_g4bit(88)			;0001011
		jnc	wa00010110
		add	cx,38			;00010111=>38
		jmp	save_g3
wa00010110:     add	cx,37			;00010110=>37
		jmp	save_g3
wa0001010:      prepare_g4bit(89)			;0001010
		jnc	wa00010100
		add	cx,36			;00010101=>36
		jmp	save_g3
wa00010100:     add	cx,35			;00010100=>35
		jmp	save_g3
wa000100:       prepare_g4bit(90)			;000100
		jnc	wa0001000
		prepare_g4bit(91)			;0001001
		jnc	wa00010010
		add	cx,34			;00010011=>34
		jmp	save_g3
wa00010010:     add	cx,33			;00010010=>33
		jmp	save_g3
wa0001000:      add	cx,20			;0001000=>20
		jmp	save_g3
wa0000:         prepare_g4bit(92)			;0000
		jnc	wa00000
		prepare_g4bit(93)			;00001
		jnc	wa000010
		add	cx,13			;000011=>13
		jmp	save_g3
wa000010:       prepare_g4bit(94)			;000010
		jnc	wa0000100
		prepare_g4bit(95)			;0000101
		jnc	wa00001010
		add	cx,48			;00001011=>48
		jmp	save_g3
wa00001010:     add	cx,47			;00001010=>47
		jmp	save_g3
wa0000100:      add	cx,23			;0000100=>23
		jmp	save_g3
wa00000:        prepare_g4bit(96)			;00000
		jnc	wa000000
		prepare_g4bit(97)			;000001
		jnc	wa0000010
		add	cx,22			;0000011=>22
		jmp	save_g3
wa0000010:      prepare_g4bit(98)			;0000010
		jnc	wa00000100
		add	cx,46			;00000101=>46
		jmp	save_g3
wa00000100:     add	cx,45			;00000100=>45
		jmp	save_g3
wa000000:       prepare_g4bit(99)			;000000
		jnc	wa0000000
		prepare_g4bit(100)			;0000001
		jnc	wa00000010
		add	cx,30			;00000011=>30
		jmp	save_g3
wa00000010:     add	cx,29			;00000010=>29
		jmp	save_g3
wa0000000:      prepare_g4bit(101)			;0000000
		jnc	wa00000000
		prepare_g4bit(102)			;00000001
		jnc	wa000000010
		prepare_g4bit(103)			;000000011
		jnc	wa0000000110
		prepare_g4bit(104)			;0000000111
		jnc	wa00000001110
		prepare_g4bit(105)			;00000001111
		jnc	wa000000011110
		add	cx,2560			;000000011111=>2560
		jmp	wg3
wa000000011110: add	cx,2496			;000000011110=>2496
		jmp	wg3
wa00000001110:  prepare_g4bit(106)			;00000001110
		jnc	wa000000011100
		add	cx,2432			;000000011101=>2432
		jmp	wg3
wa000000011100: add	cx,2368			;000000011100=>2368
		jmp	wg3
wa0000000110:   prepare_g4bit(107)			;0000000110
		jnc	wa00000001100
		add	cx,1920			;00000001101=>1920
		jmp	wg3
wa00000001100:  add	cx,1856			;00000001100=>1856
		jmp	wg3
wa000000010:    prepare_g4bit(108)			;000000010
		jnc	wa0000000100
		prepare_g4bit(109)			;0000000101
		jnc	wa00000001010
		prepare_g4bit(110)			;00000001011
		jnc	wa000000010110
		add	cx,2304			;000000010111=>2304
		jmp	wg3
wa000000010110: add	cx,2240			;000000010110=>2240
		jmp	wg3
wa00000001010:  prepare_g4bit(111)			;00000001010
		jnc	wa000000010100
		add	cx,2176			;000000010101=>2176
		jmp	wg3
wa000000010100: add	cx,2112			;000000010100=>2112
		jmp	wg3
wa0000000100:	prepare_g4bit(112)			;0000000100
		jnc	wa00000001000
		prepare_g4bit(113)			;00000001001
		jnc	wa000000010010
		add	cx,2048			;000000010011=>2048
		jmp	wg3
wa000000010010: add	cx,1984			;000000010010=>1984
		jmp	wg3
wa00000001000:  add	cx,1792			;00000001000=>1792
		jmp	wg3
wa00000000:     mov	cx,-1			;error
		jmp	save_g3
;
;	BlackG3 function decodes g3 info in horizontal encoding
;				Registers used:
;					Input	EAX -g4buffer
;						ESI -g4bufcnt
;						 BX -bitcnt
;                               	Output	 CX -runlength (if>=0)
;						    -error code(if -1)
;					Doesn't use other regs
bg3:		prepare_g4bit(114)
		jnc	ba0
		prepare_g4bit(115)			;1
		jnc	ba10
		add	cx,2			;11=>2
		jmp	save_g3
ba10:		add	cx,3			;10=>3
		jmp	save_g3
ba0:		prepare_g4bit(116)			;0
		jnc	ba00
		prepare_g4bit(117)			;01
		jnc	ba010
		add	cx,4			;011=>4
		jmp	save_g3
ba010:          add	cx,1			;010=>1
		jmp	save_g3
ba00:           prepare_g4bit(118)			;00
		jnc	ba000
		prepare_g4bit(119)			;001
		jnc	ba0010
		add	cx,5			;0011=>5
		jmp	save_g3
ba0010:		add	cx,6			;0010=>6
		jmp	save_g3
ba000:		prepare_g4bit(120)			;000
		jnc	ba0000
		prepare_g4bit(121)			;0001
		jnc	ba00010
		add	cx,7			;00011=>7
		jmp	save_g3
ba00010:        prepare_g4bit(122)			;00010
		jnc	ba000100
		add	cx,8			;000101=>8
		jmp	save_g3
ba000100:       add	cx,9			;000100=>9
		jmp	save_g3
ba0000:         prepare_g4bit(123)			;0000
		jnc	ba00000
		prepare_g4bit(124)			;00001
		jnc	ba000010
		prepare_g4bit(125)			;000011
		jnc	ba0000110
		add	cx,12			;0000111=>12
		jmp	save_g3
ba0000110:	prepare_g4bit(126)			;0000110
		jnc	ba00001100
		prepare_g4bit(127)			;00001101
		jnc	ba000011010
		prepare_g4bit(128)			;000011011
		jnc	ba0000110110
		jmp	save_g3			;0000110111=>0
ba0000110110:   prepare_g4bit(129)			;0000110110
		jnc	ba00001101100
		prepare_g4bit(130)			;00001101101
		jnc	ba000011011010
		add	cx,43			;000011011011=>43
		jmp	save_g3
ba000011011010: add	cx,42			;000011011010=>42
		jmp	save_g3
ba00001101100:	add	cx,21			;00001101100=>21
		jmp	save_g3
ba000011010:	prepare_g4bit(131)			;000011010
		jnc	ba0000110100
		prepare_g4bit(132)			;0000110101
		jnc	ba00001101010
		prepare_g4bit(133)			;00001101011
		jnc	ba000011010110
		add	cx,39			;000011010111=>39
		jmp	save_g3
ba000011010110:	add	cx,38			;000011010110=>38
		jmp	save_g3
ba00001101010:	prepare_g4bit(134)			;00001101010
		jnc	ba000011010100
		add	cx,37			;000011010101=>37
		jmp	save_g3
ba000011010100: add	cx,36			;000011010100=>36
		jmp	save_g3
ba0000110100:   prepare_g4bit(135)			;0000110100
		jnc	ba00001101000
		prepare_g4bit(136)			;00001101001
		jnc	ba000011010010
		add	cx,35			;000011010011=>35
		jmp	save_g3
ba000011010010:	add	cx,34			;000011010010=>34
		jmp	save_g3
ba00001101000:	add	cx,20			;00001101000=>20
		jmp	save_g3
ba00001100:	prepare_g4bit(137)			;00001100
		jnc	ba000011000
		prepare_g4bit(138)			;000011001
		jnc	ba0000110010
		prepare_g4bit(139)			;0000110011
		jnc	ba00001100110
		add	cx,19			;00001100111=>19
		jmp	save_g3
ba00001100110:	prepare_g4bit(140)			;00001100110
		jnc	ba000011001100
		add	cx,29			;000011001101=>29
		jmp	save_g3
ba000011001100:	add	cx,28			;000011001100=>28
		jmp	save_g3
ba0000110010:	prepare_g4bit(141)		;0000110010
		jnc	ba00001100100
		prepare_g4bit(142)			;00001100101
		jnc	ba000011001010
		add	cx,27			;000011001011=>27
		jmp	save_g3
ba000011001010:	add	cx,26			;000011001010=>26
		jmp	save_g3
ba00001100100:	prepare_g4bit(143)			;00001100100
		jnc	ba000011001000
		add	cx,192			;000011001001=>192
		jmp	bg3
ba000011001000:	add	cx,128			;000011001000=>128
		jmp	bg3
ba000011000:	add	cx,15			;000011000=>15
		jmp	save_g3
ba000010:	prepare_g4bit(144)			;000010
		jnc	ba0000100
		add	cx,11			;0000101=>11
		jmp	save_g3
ba0000100:	add	cx,10			;0000100=>10
		jmp	save_g3
ba00000:        prepare_g4bit(145)			;00000
		jnc	ba000000
		prepare_g4bit(146)			;000001
		jnc	ba0000010
		prepare_g4bit(147)			;0000011
		jnc	ba00000110
		add	cx,14			;00000111=>14
		jmp	save_g3
ba00000110:	prepare_g4bit(148)			;00000110
		jnc	ba000001100
		prepare_g4bit(149)			;000001101
		jnc	ba0000011010
		prepare_g4bit(150)			;0000011011
		jnc	ba00000110110
		add	cx,22			;00000110111=>22
		jmp	save_g3
ba00000110110:	prepare_g4bit(151)			;00000110110
		jnc	ba000001101100
		add	cx,41			;000001101101=>41
		jmp	save_g3
ba000001101100:	add	cx,40			;000001101100=>40
		jmp	save_g3
ba0000011010:	prepare_g4bit(152)			;0000011010
		jnc	ba00000110100
		prepare_g4bit(153)			;00000110101
		jnc	ba000001101010
		add	cx,33			;000001101011=>33
		jmp	save_g3
ba000001101010:	add	cx,32			;000001101010=>32
		jmp	save_g3
ba00000110100:	prepare_g4bit(154)			;00000110100
		jnc	ba000001101000
		add	cx,31			;000001101001=>31
		jmp	save_g3
ba000001101000:	add	cx,30			;000001101000=>30
		jmp	save_g3
ba000001100:	prepare_g4bit(155)			;000001100
		jnc	ba0000011000
		prepare_g4bit(156)			;0000011001
		jnc	ba00000110010
		prepare_g4bit(157)			;00000110011
		jnc	ba000001100110
		add	cx,63			;000001100111=>63
		jmp	save_g3
ba000001100110:	add	cx,62			;000001100110=>62
		jmp	save_g3
ba00000110010:	prepare_g4bit(158)			;00000110010
		jnc	ba000001100100
		add	cx,49			;000001100101=>49
		jmp	save_g3
ba000001100100:	add	cx,48			;000001100100=>48
		jmp	save_g3
ba0000011000:	add	cx,17			;0000011000=>17
		jmp	save_g3
ba0000010:	prepare_g4bit(159)			;0000010
		jnc	ba00000100
		prepare_g4bit(160)			;00000101
		jnc	ba000001010
		prepare_g4bit(161)			;000001011
		jnc	ba0000010110
		add	cx,16			;0000010111=>16
		jmp	save_g3
ba0000010110:	prepare_g4bit(162)			;0000010110
		jnc	ba00000101100
		prepare_g4bit(163)			;00000101101
		jnc	ba000001011010
		add	cx,256			;000001011011=>256
		jmp	bg3
ba000001011010:	add	cx,61			;000001011010=>61
		jmp	save_g3
ba00000101100:  prepare_g4bit(164)			;00000101100
		jnc	ba000001011000
		add	cx,58			;000001011001=>58
		jmp	save_g3
ba000001011000:	add	cx,57			;000001011000=>57
		jmp	save_g3
ba000001010:   	prepare_g4bit(165)			;000001010
		jnc	ba0000010100
		prepare_g4bit(166)			;0000010101
		jnc	ba00000101010
		prepare_g4bit(167)			;00000101011
		jnc	ba000001010110
		add	cx,47			;000001010111=>47
		jmp	save_g3
ba000001010110:	add	cx,46			;000001010110=>46
		jmp	save_g3
ba00000101010:	prepare_g4bit(168)			;00000101010
		jnc	ba000001010100
		add	cx,45			;000001010101=>45
		jmp	save_g3
ba000001010100:	add	cx,44			;000001010100=>44
		jmp	save_g3
ba0000010100:	prepare_g4bit(169)			;0000010100
		jnc	ba00000101000
		prepare_g4bit(170)			;00000101001
		jnc	ba000001010010
		add	cx,51			;000001010011=>51
		jmp	save_g3
ba000001010010:	add	cx,50			;000001010010=>50
		jmp	save_g3
ba00000101000:	add	cx,23			;00000101000=>23
		jmp	save_g3
ba00000100:	add	cx,13			;00000100=>13
		jmp	save_g3
ba000000:	prepare_g4bit(171)			;000000
		jnc	ba0000000
		prepare_g4bit(172)			;0000001
		jnc	ba00000010
		prepare_g4bit(173)			;00000011
		jnc	ba000000110
		prepare_g4bit(174)			;000000111
		jnc	ba0000001110
		add	cx,64			;0000001111=>64
		jmp	bg3
ba0000001110:	prepare_g4bit(175)			;0000001110
		jnc	ba00000011100
		prepare_g4bit(176)			;00000011101
		jnc	ba000000111010
		prepare_g4bit(177)			;000000111011
		jnc	ba0000001110110
		add	cx,1216			;0000001110111=>1216
		jmp	bg3
ba0000001110110:add	cx,1152			;0000001110110=>1152
		jmp	bg3
ba000000111010:	prepare_g4bit(178)			;000000111010
		jnc	ba0000001110100
		add	cx,1088			;0000001110101=>1088
		jmp	bg3
ba0000001110100:add	cx,1024			;0000001110100=>1024
		jmp	bg3
ba00000011100:  prepare_g4bit(179)			;00000011100
		jnc	ba000000111000
		prepare_g4bit(180)			;000000111001
		jnc	ba0000001110010
		add	cx,960			;0000001110011=>960
		jmp	bg3
ba0000001110010:add	cx,896			;0000001110010=>896
		jmp	bg3
ba000000111000:	add	cx,54			;000000111000=>54
		jmp	save_g3
ba000000110:	prepare_g4bit(181)			;000000110
		jnc	ba0000001100
		prepare_g4bit(182)			;0000001101
		jnc	ba00000011010
		prepare_g4bit(183)			;00000011011
		jnc	ba000000110110
		add	cx,53			;000000110111=>53
		jmp	save_g3
ba000000110110:	prepare_g4bit(184)			;000000110110
		jnc	ba0000001101100
		add	cx,576			;0000001101101=>576
		jmp	bg3
ba0000001101100:add	cx,512			;0000001101100=>512
		jmp	bg3
ba00000011010:	prepare_g4bit(185)			;00000011010
		jnc	ba000000110100
		add	cx,448			;000000110101=>448
		jmp	bg3
ba000000110100:	add	cx,384			;000000110100=>384
		jmp	bg3
ba0000001100:	prepare_g4bit(186)			;0000001100
		jnc	ba00000011000
		prepare_g4bit(187)			;00000011001
		jnc	ba000000110010
		add	cx,320			;000000110011=>320
		jmp	bg3
ba000000110010:	prepare_g4bit(188)			;000000110010
		jnc	ba0000001100100
		add	cx,1728			;0000001100101=>1728
		jmp	bg3
ba0000001100100:add	cx,1664			;0000001100100=>1664
		jmp	bg3
ba00000011000:	add	cx,25			;00000011000=>25
		jmp	save_g3
ba00000010:	prepare_g4bit(189)			;00000010
		jnc	ba000000100
		prepare_g4bit(190)			;000000101
		jnc	ba0000001010
		prepare_g4bit(191)			;0000001011
		jnc	ba00000010110
		add	cx,24			;00000010111=>24
		jmp	save_g3
ba00000010110:	prepare_g4bit(192)			;00000010110
		jnc	ba000000101100
		prepare_g4bit(193)			;000000101101
		jnc	ba0000001011010
		add	cx,1600			;0000001011011=>1600
		jmp	bg3
ba0000001011010:add	cx,1536			;0000001011010=>1536
		jmp	bg3
ba000000101100:	add	cx,60			;000000101100=>60
		jmp	save_g3
ba0000001010:   prepare_g4bit(194)			;0000001010
		jnc	ba00000010100
		prepare_g4bit(195)			;00000010101
		jnc	ba000000101010
		add	cx,59			;000000101011=>59
		jmp	save_g3
ba000000101010:	prepare_g4bit(196)			;000000101010
		jnc	ba0000001010100
		add	cx,1472			;0000001010101=>1472
		jmp	bg3
ba0000001010100:add	cx,1408			;0000001010100=>1408
		jmp	bg3
ba00000010100:	prepare_g4bit(197)			;00000010100
		jnc	ba000000101000
		prepare_g4bit(198)			;000000101001
		jnc	ba0000001010010
		add	cx,1344			;0000001010011=>1344
		jmp	bg3
ba0000001010010:add	cx,1280			;0000001010010=>1280
		jmp	bg3
ba000000101000:	add	cx,56			;000000101000=>56
		jmp	save_g3
ba000000100:	prepare_g4bit(199)			;000000100
		jnc	ba0000001000
		prepare_g4bit(200)			;0000001001
		jnc	ba00000010010
		prepare_g4bit(201)			;00000010011
		jnc	ba000000100110
		add	cx,55			;000000100111=>55
		jmp	save_g3
ba000000100110:	prepare_g4bit(202)			;000000100110
		jnc	ba0000001001100
		add	cx,832			;0000001001101=>832
		jmp	bg3
ba0000001001100:add	cx,768			;0000001001100=>768
		jmp	bg3
ba00000010010:	prepare_g4bit(203)			;00000010010
		jnc	ba000000100100
		prepare_g4bit(204)			;000000100101
		jnc	ba0000001001010
		add	cx,704			;0000001001011=>704
		jmp	bg3
ba0000001001010:add	cx,640			;0000001001010=>640
		jmp	bg3
ba000000100100:	add	cx,52			;000000100100=>52
		jmp	save_g3
ba0000001000:	add	cx,18			;0000001000=>18
		jmp	save_g3
ba0000000:	prepare_g4bit(205)			;0000000
		jnc	ba00000000
		prepare_g4bit(206)			;00000001
		jnc	ba000000010
		prepare_g4bit(207)			;000000011
		jnc	ba0000000110
		prepare_g4bit(208)			;0000000111
		jnc	ba00000001110
		prepare_g4bit(209)			;00000001111
		jnc	ba000000011110
		add	cx,2560			;000000011111=>2560
		jmp	bg3
ba000000011110:	add	cx,2496			;000000011110=>2496
		jmp	bg3
ba00000001110:	prepare_g4bit(210)			;00000001110
		jnc	ba000000011100
		add     cx,2432			;000000011101=>2432
		jmp	bg3
ba000000011100:	add	cx,2368			;000000011100=>2368
		jmp	bg3
ba0000000110:	prepare_g4bit(211)			;0000000110
		jnc	ba00000001100
		add	cx,1920			;00000001101=>1920
		jmp	bg3
ba00000001100:	add	cx,1856			;00000001100=>1856
		jmp	bg3
ba000000010:	prepare_g4bit(212)			;000000010
		jnc	ba0000000100
		prepare_g4bit(213)			;0000000101
		jnc	ba00000001010
		prepare_g4bit(214)			;00000001011
		jnc	ba000000010110
		add	cx,2304			;000000010111=>2304
		jmp	bg3
ba000000010110:	add	cx,2240			;000000010110=>2240
		jmp	bg3
ba00000001010:	prepare_g4bit(215)			;00000001010
		jnc	ba000000010100
		add	cx,2176			;000000010101=>2176
		jmp	bg3
ba000000010100:	add	cx,2112			;000000010100=>2112
		jmp	bg3
ba0000000100:   prepare_g4bit(216)			;0000000100
		jnc	ba00000001000
		prepare_g4bit(217)			;00000001001
		jnc	ba000000010010
		add	cx,2048			;000000010011=>2048
		jmp	bg3
ba000000010010:	add	cx,1984			;000000010010=>1984
		jmp	bg3
ba00000001000:	add	cx,1792			;00000001000=>1792
		jmp	bg3
ba00000000:	mov	cx,-1			;error
		jmp	save_g3


finish_g4rl:    cld
                mov ebp ,valebp
                mov  esi, valesi
                mov  edi, valedi
				mov  retval, eax
	}
    return retval;
}
//////////////////////////////////////////////////////////////////
int __stdcall g4bin2s(BYTE  *g4buffer, 
                      WORD  *binbuffer, 
                      DWORD linesperstrip, 
                      DWORD *_binbufcnt, 
                      WORD  _image_width) //  IN PIXEL
{   
DLL_THREAD_MANAGEMENT();

    pref_line = ref_line;
	pcod_line=cod_line;
	pblack=black;
	pwhite= white; 
    __asm
    {  
    	mov DWORD PTR valebp, ebp
	    mov DWORD PTR valesi, esi
	    mov DWORD PTR valedi, edi
	    mov eax,  g4buffer
		mov edx,  binbuffer
		mov ebx,  linesperstrip		;length
        mov ecx,  _binbufcnt	    ;binbufcnt
		
		mov	di,_image_width  ;[ebp+16]
		mov	image_width,di
		mov	g4bufcnt,0
		mov	binbufcnt,0
		mov	passvalue,0
		mov	bitcnt,8
		mov	bin_bitcnt,15
		mov	binbufcntp,ecx
		mov	linecnt,bx     ;Initializes linecnt with linesperstrip

length_loop:	mov	a0,-1
		mov	i,0
		mov	j,0
		mov	bx,image_width
		mov	ecx,pref_line
		cmp	binbufcnt,0
		jne	width_loop
		mov	[ecx],bx                ;Initializes ref_line and b1
		mov	b1,bx                   ;for first line in strip
width_loop:	mov	bx,b1
		cmp     bx,image_width
		jne	calc_b2                 ;if b1 at end of line
		mov	b2,bx			;b2=b1=image_width
		jmp	g4_tree
calc_b2:	mov	ebp,i
		inc	ebp
		add	bx,[ecx][ebp*2]
		mov	b2,bx			;b2=b1+ref_line[i+1]
	;Uses EAX(g4buf),ESI(g4bufcnt),BX(bitcnt)
	;EAX is preserved through the functions called, BX and ESI are not
	;Passes left and right position through CX(-3 to +3)
	;returns error or correct op from horizontal in CX
	;return towards the end of width_loop at end_g4_code
g4_tree:        mov	bx,bitcnt
		mov	esi,g4bufcnt
		inc	bx
		cmp	bx,8
		jne	g4same
		mov	bx,0
		inc	esi
g4same:		bt	[eax][esi],bx
		jnc	g4a0
		mov	g4bufcnt,esi
		mov	bitcnt,bx			;1=>V(0)
		mov    	cx,0
		jmp	vert_left
g4a0:		inc	bx  				;0
		cmp	bx,8
		jne	g4s0
		mov	bx,0
		inc	esi
g4s0:		bt	[eax][esi],bx
		jnc	g4a00
		inc	bx				;01
		cmp	bx,8
		jne	g4s01
		mov	bx,0
		inc	esi
g4s01:          mov	g4bufcnt,esi
		mov	bitcnt,bx
		bt	[eax][esi],bx
		jnc	g4a010
		mov	cx,1                            ;011=>VR(1)
		jmp	vert_right
g4a010:		mov	cx,-1				;010=>VL(1)
		jmp	vert_left
g4a00:		inc	bx				;00
		cmp	bx,8
		jne	g4s00
		mov	bx,0
		inc	esi
g4s00:		bt	[eax][esi],bx
		jnc	g4a000
		mov	g4bufcnt,esi
		mov	bitcnt,bx
		jmp	horizont                	;001=>H
g4a000:		inc	bx				;000
		cmp	bx,8
		jne	g4s000
		mov	bx,0
		inc	esi
g4s000:		bt	[eax][esi],bx
		jnc	g4a0000
		mov	g4bufcnt,esi
		mov	bitcnt,bx
		mov	cx,b2       			;0001=>P
		sub	cx,a0
		add	passvalue,cx
		mov	cx,b2
		mov	a0,cx
		inc	i
		inc	i
		mov	ebx,pref_line
		mov	ebp,i
		add	cx,[ebx][ebp*2]
		mov	b1,cx
		mov	ecx,0
		jmp	end_g4_code
g4a0000:	inc	bx				;0000
		cmp	bx,8
		jne	g4s0000
		mov	bx,0
		inc	esi
g4s0000:	bt	[eax][esi],bx
		jnc	g4a00000
		inc	bx				;00001
		cmp	bx,8
		jne	g4s00001
		mov	bx,0
		inc	esi
g4s00001:       mov	bitcnt,bx
		mov	g4bufcnt,esi
		bt	[eax][esi],bx
		jnc	g4a000010
		mov	cx,2				;000011=>VR(2)
		jmp	vert_right
g4a000010:	mov	cx,-2				;000010=>VL(2)
		jmp	vert_left
g4a00000:	inc	bx				;00000
		cmp	bx,8
		jne	g4s00000
		mov	bx,0
		inc	esi
g4s00000:	bt	[eax][esi],bx
		jnc	g4a000000
		inc	bx				;000001
		cmp	bx,8
		jne	g4s000001
		mov	bx,0
		inc	esi
g4s000001:	mov	bitcnt,bx
		mov	g4bufcnt,esi
		bt	[eax][esi],bx
		jnc	g4a0000010
		mov	cx,3				;0000011=>VR(3)
		jmp	vert_right
g4a0000010:	mov	cx,-3				;0000010=>VL(3)
		jmp	vert_left
g4a000000:      mov	edi,binbufcnt
		mov	eax,binbufcntp
		mov	[eax],edi
		mov	eax,-1                          ;return error
		jmp	finish_g4rl
;
end_g4_code:	cmp	ecx,-1
		je	g4a000000
		mov	ecx,pref_line
		mov	bx,a0
		cmp	bx,image_width
		jne	width_loop
		mov	edi,binbufcnt
;
		mov	ebx,bin_bitcnt
		cmp	bx,15
		je	nopadding
		mov	si,[edx][edi]
		mov	ebp,pwhite
		and	si,[ebp][ebx*2]
		mov	[edx][edi],si
		inc	edi
		inc	edi
nopadding:	mov	bin_bitcnt,15
		mov	binbufcnt,edi
		mov	di,linecnt
		dec	di
		mov	linecnt,di
		jnz	update_ref
		mov	edi,binbufcnt
		mov	eax,binbufcntp			;return binbufcnt
		mov	[eax],edi
		mov	eax,0
		jmp finish_g4rl
update_ref:	mov     ecx,j           		;prepare ref line
		mov     esi,pcod_line
		mov	edi,pref_line
		rep	movsw
		mov	cx,b1				;prepare first b1
		mov	edi,pref_line
		mov	cx,[edi]
		mov	b1,cx
		jmp	length_loop
;
;	VERT_LEFT function solves the vertical left and zero codes
;				Registers used:
;					Input	EAX -g4buffer
;						EDX -rlbuffer
;						ECX -position (0 to -3)
;                               	Output	ECX -correct (if 0)
;					Uses all the other regs except ESI
;
;
vert_left:	mov	edi,binbufcnt
		mov	ebp,j
		cmp	ebp,0
		jnz	save_vl
		mov	bx,passvalue
		dec	bx
		mov	passvalue,bx
save_vl:	add	cx,b1
		mov	a1,cx
		sub	cx,a0                  ;b1-pos-a0
		add	cx,passvalue	       ;b1-pos-a0+passvalue
		mov	ebx,pcod_line
		mov	[ebx][ebp*2],cx
;
		mov	ebx,bin_bitcnt
		mov	si,[edx][edi]
		bt	ebp,0
		jc	vlb_makebin
vlw_makebin:    cmp	cx,0
		jz      vl_endbin              ;If 0 don't write anything
		cmp	bx,15
		jne	vlw_bin1
		cmp	cx,32
		js 	vlw_bin3
		mov	si,cx
		and	si,001fh
		shr	cx,5
vlw_bin2:	mov	dword ptr [edx][edi],0
		add	edi,4
		dec	cx
		jnz	vlw_bin2
		cmp	si,0
		je	vl_endbin
		mov	cx,si
vlw_bin3:	mov	word ptr [edx][edi],0
		cmp	cx,16
		js	vlw_bin4
		add	edi,2
		mov	word ptr [edx][edi],0
		sub	cx,16
vlw_bin4:       sub	bx,cx
		jmp	vl_endbin
vlw_bin1:       mov	ebp,pwhite
		inc	bx
		cmp	cx,bx
		js	vlw_bin6
		sub	cx,bx
		dec	bx
		and	si,[ebp][ebx*2]
		mov     [edx][edi],si
		add	edi,2
		mov	bx,15
		jmp	vlw_makebin
vlw_bin6:	dec	bx
		and	si,[ebp][ebx*2]
		sub	bx,cx
		mov	[edx][edi],si
		jmp	vl_endbin
vlb_makebin:    cmp	cx,0
		jz      vl_endbin              ;If 0 don't write anything
		cmp	bx,15
		jne	vlb_bin1
		cmp	cx,32
		js 	vlb_bin3
		mov	si,cx
		and	si,001fh
		shr	cx,5
vlb_bin2:	mov	dword ptr [edx][edi],0ffffffffh
		add	edi,4
		dec	cx
		jnz	vlb_bin2
		cmp	si,0
		je	vl_endbin
		mov	cx,si
vlb_bin3:	mov	word ptr [edx][edi],0ffffh
		cmp	cx,16
		js	vlb_bin4
		add	edi,2
		mov	word ptr [edx][edi],0ffffh
		sub	cx,16
vlb_bin4:       sub	bx,cx
		jmp	vl_endbin
vlb_bin1:       mov	ebp,pblack
		inc	bx
		cmp	cx,bx
		js	vlb_bin6
		sub	cx,bx
		dec	bx
		or	si,[ebp][ebx*2]
		mov     [edx][edi],si
		add	edi,2
		mov	bx,15
		jmp	vlb_makebin
vlb_bin6:	dec	bx
		or	si,[ebp][ebx*2]
		sub	bx,cx
		mov	[edx][edi],si
vl_endbin:	mov	bin_bitcnt,ebx
		mov     ebx,pcod_line
		mov	ebp,j
		mov	cx,a1
		cmp	cx,image_width
		jbe	inside_vl
		sub	cx,image_width
		sub	[ebx][ebp*2],cx
		mov	cx,image_width
inside_vl:	inc	ebp
		mov	j,ebp
		mov	binbufcnt,edi
		mov	a0,cx
		mov	ebp,i
		mov	ebx,pref_line
		mov	di,b1
		sub	di,[ebx][ebp*2]
		cmp	di,a0
		jbe	left_b1
		dec	ebp
		jmp	fin_vl
left_b1:	mov	di,b1
		cmp	di,image_width
		jae	fin_vl
		inc	ebp
		add	di,[ebx][ebp*2]
fin_vl:		mov	i,ebp
		mov	b1,di
		mov	passvalue,0
		mov	ecx,0
		jmp	end_g4_code
;
;	VERT_RIGHT function solves the vertical right codes
;				Registers used:
;					Input	EAX -g4buffer
;						EDX -rlbuffer
;						ECX -position (1 to 3)
;                               	Output	ECX -correct (if 0)
;					Uses all the other regs except ESI
;
vert_right:	mov	edi,binbufcnt
		mov	ebp,j
		cmp	ebp,0
		jnz	save_vr
		mov	bx,passvalue
		dec 	bx
		mov	passvalue,bx
save_vr:	add	cx,b1			;pos+b1
		mov	a1,cx			;a1=b1+pos
		sub	cx,a0			;pos+b1-a0
		add	cx,passvalue
		mov	ebx,pcod_line
		mov	[ebx][ebp*2],cx
;
		mov	ebx,bin_bitcnt
		mov	si,[edx][edi]
		bt	ebp,0
		jc	vrb_makebin
vrw_makebin:    cmp	cx,0
		jz      vr_endbin              ;If 0 don't write anything
		cmp	bx,15
		jne	vrw_bin1
		cmp	cx,32
		js 	vrw_bin3
		mov	si,cx
		and	si,001fh
		shr	cx,5
vrw_bin2:	mov	dword ptr [edx][edi],0
		add	edi,4
		dec	cx
		jnz	vrw_bin2
		cmp	si,0
		je	vr_endbin
		mov	cx,si
vrw_bin3:	mov	word ptr [edx][edi],0
		cmp	cx,16
		js	vrw_bin4
		add	edi,2
		mov	word ptr [edx][edi],0
		sub	cx,16
vrw_bin4:       sub	bx,cx
		jmp	vr_endbin
vrw_bin1:       mov	ebp,pwhite
		inc	bx
		cmp	cx,bx
		js	vrw_bin6
		sub	cx,bx
		dec	bx
		and	si,[ebp][ebx*2]
		mov     [edx][edi],si
		add	edi,2
		mov	bx,15
		jmp	vrw_makebin
vrw_bin6:	dec	bx
		and	si,[ebp][ebx*2]
		sub	bx,cx
		mov	[edx][edi],si
		jmp	vr_endbin
vrb_makebin:    cmp	cx,0
		jz      vr_endbin              ;If 0 don't write anything
		cmp	bx,15
		jne	vrb_bin1
		cmp	cx,32
		js 	vrb_bin3
		mov	si,cx
		and	si,001fh
		shr	cx,5
vrb_bin2:	mov	dword ptr [edx][edi],0ffffffffh
		add	edi,4
		dec	cx
		jnz	vrb_bin2
		cmp	si,0
		je	vr_endbin
		mov	cx,si
vrb_bin3:	mov	word ptr [edx][edi],0ffffh
		cmp	cx,16
		js	vrb_bin4
		add	edi,2
		mov	word ptr [edx][edi],0ffffh
		sub	cx,16
vrb_bin4:       sub	bx,cx
		jmp	vr_endbin
vrb_bin1:       mov	ebp,pblack
		inc	bx
		cmp	cx,bx
		js	vrb_bin6
		sub	cx,bx
		dec	bx
		or	si,[ebp][ebx*2]
		mov     [edx][edi],si
		add	edi,2
		mov	bx,15
		jmp	vrb_makebin
vrb_bin6:	dec	bx
		or	si,[ebp][ebx*2]
		sub	bx,cx
		mov	[edx][edi],si
vr_endbin: 	mov	bin_bitcnt,ebx
		mov     ebx,pcod_line
		mov	ebp,j
		mov	cx,a1
		cmp	cx,image_width
		jbe	inside_vr
		sub	cx,image_width
		sub	[ebx][ebp*2],cx
		mov	cx,image_width
inside_vr:	inc	ebp
		mov	j,ebp
		mov	binbufcnt,edi
		mov	a0,cx			;a0=a1
		mov	ebp,i
		mov	ebx,pref_line
		mov	di,b1
		inc	ebp
		add	di,[ebx][ebp*2]
make_ivr:       cmp	cx,di
		jb	fin_vr
		cmp	di,image_width
		jae	fin_vr
		inc	ebp
		add	di,[ebx][ebp*2]
		cmp	di,image_width
		jae	fin_vr
		inc	ebp
		add	di,[ebx][ebp*2]
		jmp	make_ivr
fin_vr:		mov	i,ebp
		mov	b1,di
		mov	passvalue,0
		mov	ecx,0
		jmp	end_g4_code
;
;	HORIZONT function solves the horizontal codes
;				Registers used:
;					Input	EAX -g4buffer
;						EDX -rlbuffer
;                               	Output	ECX -correct (if 0)
;						    -error code(if -1)
;					Uses all the other regs
horizont:	mov	cnt,2
		mov	edi,binbufcnt
		mov	ebp,j
;	dec passvalue if the first ellement in line
		mov	flag,0
		cmp	ebp,0
		jnz	read_g3
		mov	cx,passvalue
		cmp	cx,0
		jz	nopass
		mov	flag,1
		jmp	read_g3
;	read g3 info in cx register
nopass:		mov	a0,0
read_g3:	mov	cx,0
		mov	bx,bitcnt
		mov	esi,g4bufcnt
		bt	ebp,0			;see if j even or odd
		jnc	wg3			;white g3
		jmp	bg3			;black g3
;	save g3 info from cx in rl buffer
save_g3:        mov	bitcnt,bx 		;save new bitcnt
		mov	g4bufcnt,esi
		cmp	cx,0                    ;if -1 error code return
		js	error_code
		add	a0,cx
		add	cx,passvalue
		sub	cx,flag
		mov	ebx,pcod_line
		mov	[ebx][ebp*2],cx		;save rl in the coding line
;
		mov	ebx,bin_bitcnt
		mov	si,[edx][edi]
		bt	ebp,0
		jc	hb_makebin
hw_makebin:    	cmp	cx,0
		jz      h_endbin              ;If 0 don't write anything
		cmp	bx,15
		jne	hw_bin1
		cmp	cx,32
		js 	hw_bin3
		mov	si,cx
		and	si,001fh
		shr	cx,5
hw_bin2:	mov	dword ptr [edx][edi],0
		add	edi,4
		dec	cx
		jnz	hw_bin2
		cmp	si,0
		je	h_endbin
		mov	cx,si
hw_bin3:	mov	word ptr [edx][edi],0
		cmp	cx,16
		js	hw_bin4
		add	edi,2
		mov	word ptr [edx][edi],0
		sub	cx,16
hw_bin4:        sub	bx,cx
		jmp	h_endbin
hw_bin1:        mov	ebp,pwhite
		inc	bx
		cmp	cx,bx
		js	hw_bin6
		sub	cx,bx
		dec	bx
		and	si,[ebp][ebx*2]
		mov     [edx][edi],si
		add	edi,2
		mov	bx,15
		jmp	hw_makebin
hw_bin6:	dec	bx
		and	si,[ebp][ebx*2]
		sub	bx,cx
		mov	[edx][edi],si
		jmp	h_endbin
hb_makebin:	cmp	cx,0
		jz      h_endbin              ;If 0 don't write anything
		cmp	bx,15
		jne	hb_bin1
		cmp	cx,32
		js 	hb_bin3
		mov	si,cx
		and	si,001fh
		shr	cx,5
hb_bin2:	mov	dword ptr [edx][edi],0ffffffffh
		add	edi,4
		dec	cx
		jnz	hb_bin2
		cmp	si,0
		je	h_endbin
		mov	cx,si
hb_bin3:	mov	word ptr [edx][edi],0ffffh
		cmp	cx,16
		js	hb_bin4
		add	edi,2
		mov	word ptr [edx][edi],0ffffh
		sub	cx,16
hb_bin4:        sub	bx,cx
		jmp	h_endbin
hb_bin1:        mov	ebp,pblack
		inc	bx
		cmp	cx,bx
		js	hb_bin6
		sub	cx,bx
		dec	bx
		or	si,[ebp][ebx*2]
		mov     [edx][edi],si
		add	edi,2
		mov	bx,15
		jmp	hb_makebin
hb_bin6:	dec	bx
		or	si,[ebp][ebx*2]
		sub	bx,cx
		mov	[edx][edi],si
h_endbin: 	mov	bin_bitcnt,ebx
		mov     ebx,pcod_line
		mov	ebp,j
		mov	cx,a0
		cmp	cx,image_width
		jbe	inside_line             ;If exceeding image_width,
		sub	cx,image_width		;adjust at image_width
		sub	[ebx][ebp*2],cx         ;both cod_line[j] and pixcnt
		mov	cx,image_width
inside_line:	mov	passvalue,0
		mov	a0,cx
		inc	ebp
		dec	cnt
		mov	flag,0
		mov	j,ebp
		jnz	read_g3
		mov	binbufcnt,edi           ;save new binbufcnt
		mov	ebx,pref_line
		mov	ebp,i
		mov	di,b1
make_i:		cmp	cx,di
		jb	fin_horiz
		cmp	di,image_width
		jae	fin_horiz
		inc	ebp
		add	di,[ebx][ebp*2]
		cmp	di,image_width
		jae	fin_horiz
		inc	ebp
		add	di,[ebx][ebp*2]
		jmp	make_i
fin_horiz:	mov	i,ebp
		mov	b1,di
		mov	ecx,0
		jmp	end_g4_code
error_code:	mov	ecx,-1
		jmp     end_g4_code
;
;	WhiteG3 function decodes g3 info in horizontal encoding
;				Registers used:
;					Input	EAX -g4buffer
;						ESI -g4bufcnt
;						 BX -bitcnt
;                               	Output	 CX -runlength (if>=0)
;						    -error code(if -1)
;					Doesn't use other regs
wg3:       	inc	bx
		cmp	bx,8
		jne	wsame
		mov	bx,0
		inc	esi
wsame:		bt      [eax][esi],bx
		jnc	wa0
		inc	bx			;1
		cmp	bx,8
		jne	ws1
		mov	bx,0
		inc	esi
ws1:		bt	[eax][esi],bx
		jnc	wa10
		inc	bx			;11
		cmp	bx,8
		jne	ws11
		mov	bx,0
		inc	esi
ws11:		bt	[eax][esi],bx
		jnc	wa110
		inc	bx			;111
		cmp	bx,8
		jne	ws111
		mov	bx,0
		inc	esi
ws111:		bt	[eax][esi],bx
		jnc	wa1110
		add	cx,7			;1111=>7
		jmp	save_g3
wa1110:         add	cx,6			;1110=>6
		jmp	save_g3
wa110:          inc	bx			;110
		cmp	bx,8
		jne	ws110
		mov	bx,0
		inc	esi
ws110:		bt	[eax][esi],bx
		jnc	wa1100
		inc	bx			;1101
		cmp	bx,8
		jne	ws1101
		mov	bx,0
		inc	esi
ws1101:		bt	[eax][esi],bx
		jnc	wa11010
		add	cx,64			;11011=>64
		jmp	wg3
wa11010:        inc	bx			;11010
		cmp	bx,8
		jne	ws11010
		mov	bx,0
		inc	esi
ws11010:	bt	[eax][esi],bx
		jnc	wa110100
		add	cx,15			;110101=>15
		jmp	save_g3
wa110100:       add	cx,14			;110100=>14
		jmp	save_g3
wa1100:		add	cx,5			;1100=>5
		jmp	save_g3
wa10:           inc	bx			;10
		cmp	bx,8
		jne	ws10
		mov	bx,0
		inc	esi
ws10:		bt	[eax][esi],bx
		jnc	wa100
		inc	bx			;101
		cmp	bx,8
		jne	ws101
		mov	bx,0
		inc	esi
ws101:		bt	[eax][esi],bx
		jnc	wa1010
		add	cx,4			;1011=>4
		jmp	save_g3
wa1010:         inc	bx			;1010
		cmp	bx,8
		jne	ws1010
		mov	bx,0
		inc	esi
ws1010:		bt	[eax][esi],bx
		jnc	wa10100
		inc	bx			;10101
		cmp	bx,8
		jne	ws10101
		mov	bx,0
		inc	esi
ws10101:	bt	[eax][esi],bx
		jnc	wa101010
		add	cx,17			;101011=>17
		jmp	save_g3
wa101010:       add	cx,16			;101010=>16
		jmp	save_g3
wa10100:        add	cx,9			;10100=>9
		jmp	save_g3
wa100:          inc	bx			;100
		cmp	bx,8
		jne     ws100
		mov	bx,0
		inc	esi
ws100:		bt	[eax][esi],bx
		jnc	wa1000
		inc	bx			;1001
		cmp	bx,8
		jne	ws1001
		mov	bx,0
		inc	esi
ws1001:		bt	[eax][esi],bx
		jnc	wa10010
		add	cx,8			;10011=>8
		jmp	save_g3
wa10010:        add	cx,128			;10010=>128
		jmp	wg3
wa1000:         add	cx,3			;1000=>3
		jmp	save_g3
wa0:            inc	bx			;0
		cmp	bx,8
		jne	ws0
		mov	bx,0
		inc	esi
ws0:		bt	[eax][esi],bx
		jnc	wa00
		inc	bx			;01
		cmp	bx,8
		jne	ws01
		mov	bx,0
		inc	esi
ws01:		bt	[eax][esi],bx
		jnc	wa010
		inc	bx			;011
		cmp	bx,8
		jne	ws011
		mov	bx,0
		inc	esi
ws011:		bt	[eax][esi],bx
		jnc	wa0110
		add	cx,2			;0111=>2
		jmp	save_g3
wa0110:         inc	bx			;0110
		cmp	bx,8
		jne	ws0110
		mov	bx,0
		inc	esi
ws0110:		bt	[eax][esi],bx
		jnc	wa01100
		inc	bx			;01101
		cmp	bx,8
		jne	ws01101
		mov	bx,0
		inc	esi
ws01101:	bt	[eax][esi],bx
		jnc	wa011010
		inc	bx			;011011
		cmp	bx,8
		jne	ws011011
		mov	bx,0
		inc	esi
ws011011:	bt	[eax][esi],bx
		jnc	wa0110110
		add	cx,256			;0110111=>256
		jmp	wg3
wa0110110:      inc	bx			;0110110
		cmp	bx,8
		jne	ws0110110
		mov	bx,0
		inc	esi
ws0110110:	bt	[eax][esi],bx
		jnc	wa01101100
		inc	bx			;01101101
		cmp	bx,8
		jne	ws01101101
		mov	bx,0
		inc	esi
ws01101101:	bt	[eax][esi],bx
		jnc	wa011011010
		add	cx,1408			;011011011=>1408
		jmp	wg3
wa011011010:    add	cx,1344			;011011010=>1344
		jmp	wg3
wa01101100:     inc	bx			;01101100
		cmp	bx,8
		jne	ws01101100
		mov	bx,0
		inc	esi
ws01101100:	bt	[eax][esi],bx
		jnc	wa011011000
		add	cx,1280			;011011001=>1280
		jmp	wg3
wa011011000:    add	cx,1216			;011011000=>1216
		jmp	wg3
wa011010:       inc	bx			;011010
		cmp	bx,8
		jne	ws011010
		mov	bx,0
		inc	esi
ws011010:	bt	[eax][esi],bx
		jnc	wa0110100
		inc	bx			;0110101
		cmp	bx,8
		jne	ws0110101
		mov	bx,0
		inc	esi
ws0110101:	bt	[eax][esi],bx
		jnc	wa01101010
		inc	bx			;01101011
		cmp	bx,8
		jne	ws01101011
		mov	bx,0
		inc	esi
ws01101011:	bt	[eax][esi],bx
		jnc	wa011010110
		add	cx,1152			;011010111=>1152
		jmp	wg3
wa011010110:    add	cx,1088			;011010110=>1088
		jmp	wg3
wa01101010:     inc	bx			;01101010
		cmp	bx,8
		jne	ws01101010
		mov	bx,0
		inc	esi
ws01101010:	bt	[eax][esi],bx
		jnc	wa011010100
		add	cx,1024			;011010101=>1024
		jmp	wg3
wa011010100:    add	cx,960			;011010100=>960
		jmp	wg3
wa0110100:      inc	bx			;0110100
		cmp	bx,8
		jne	ws0110100
		mov	bx,0
		inc	esi
ws0110100:	bt	[eax][esi],bx
		jnc	wa01101000
		inc	bx			;01101001
		cmp	bx,8
		jne	ws01101001
		mov	bx,0
		inc	esi
ws01101001:	bt	[eax][esi],bx
		jnc	wa011010010
		add	cx,896			;011010011=>896
		jmp	wg3
wa011010010:    add	cx,832			;011010010=>832
		jmp	wg3
wa01101000:     add	cx,576			;01101000=>576
		jmp	wg3
wa01100:        inc	bx			;01100
		cmp	bx,8
		jne	ws01100
		mov	bx,0
		inc	esi
ws01100:	bt	[eax][esi],bx
		jnc	wa011000
		inc	bx			;011001
		cmp	bx,8
		jne	ws011001
		mov	bx,0
		inc	esi
ws011001:	bt	[eax][esi],bx
		jnc	wa0110010
		inc	bx			;0110011
		cmp	bx,8
		jne	ws0110011
		mov	bx,0
		inc	esi
ws0110011:	bt	[eax][esi],bx
		jnc	wa01100110
		add	cx,640			;01100111=>640
		jmp	wg3
wa01100110:     inc	bx			;01100110
		cmp	bx,8
		jne	ws01100110
		mov	bx,0
		inc	esi
ws01100110:	bt	[eax][esi],bx
		jnc	wa011001100
		add	cx,768			;011001101=>768
		jmp	wg3
wa011001100:    add	cx,704			;011001100=>704
		jmp	wg3
wa0110010:      inc	bx			;0110010
		cmp	bx,8
		jne	ws0110010
		mov	bx,0
		inc	esi
ws0110010:	bt	[eax][esi],bx
		jnc	wa01100100
		add	cx,512			;01100101=>512
		jmp	wg3
wa01100100:     add	cx,448			;01100100=>448
		jmp	wg3
wa011000:       add	cx,1664			;011000=>1664
		jmp	wg3
wa010:          inc	bx			;010
		cmp	bx,8
		jne	ws010
		mov	bx,0
		inc	esi
ws010:		bt	[eax][esi],bx
		jnc	wa0100
		inc	bx			;0101
		cmp	bx,8
		jne	ws0101
		mov	bx,0
		inc	esi
ws0101:		bt	[eax][esi],bx
		jnc	wa01010
		inc	bx			;01011
		cmp	bx,8
		jne	ws01011
		mov	bx,0
		inc	esi
ws01011:	bt	[eax][esi],bx
		jnc	wa010110
		add	cx,192			;010111=>192
		jmp	wg3
wa010110:       inc	bx			;010110
		cmp	bx,8
		jne	ws010110
		mov	bx,0
		inc	esi
ws010110:	bt	[eax][esi],bx
		jnc	wa0101100
		inc	bx			;0101101
		cmp	bx,8
		jne	ws0101101
		mov	bx,0
		inc	esi
ws0101101:	bt	[eax][esi],bx
		jnc	wa01011010
		add	cx,58			;01011011=>58
		jmp	save_g3
wa01011010:     add	cx,57			;01011010=>57
		jmp	save_g3
wa0101100:      inc	bx			;0101100
		cmp	bx,8
		jne	ws0101100
		mov	bx,0
		inc	esi
ws0101100:	bt	[eax][esi],bx
		jnc	wa01011000
		add	cx,56			;01011001=>56
		jmp	save_g3
wa01011000:     add	cx,55			;01011000=>55
		jmp	save_g3
wa01010:        inc	bx			;01010
		cmp	bx,8
		jne	ws01010
		mov	bx,0
		inc	esi
ws01010:	bt	[eax][esi],bx
		jnc	wa010100
		inc	bx			;010101
		cmp	bx,8
		jne	ws010101
		mov	bx,0
		inc	esi
ws010101:	bt	[eax][esi],bx
		jnc	wa0101010
		add	cx,25			;0101011=>25
		jmp	save_g3
wa0101010:      inc	bx			;0101010
		cmp	bx,8
		jne	ws0101010
		mov	bx,0
		inc	esi
ws0101010:	bt	[eax][esi],bx
		jnc	wa01010100
		add	cx,52			;01010101=>52
		jmp	save_g3
wa01010100:     add	cx,51			;01010100=>51
		jmp	save_g3
wa010100:       inc	bx			;010100
		cmp	bx,8
		jne	ws010100
		mov	bx,0
		inc	esi
ws010100:	bt	[eax][esi],bx
		jnc	wa0101000
		inc	bx			;0101001
		cmp	bx,8
		jne	ws0101001
		mov	bx,0
		inc	esi
ws0101001:	bt	[eax][esi],bx
		jnc	wa01010010
		add	cx,50			;01010011=>50
		jmp	save_g3
wa01010010:     add	cx,49			;01010010=>49
		jmp	save_g3
wa0101000:      add	cx,24			;0101000=>24
		jmp	save_g3
wa0100:         inc	bx			;0100
		cmp	bx,8
		jne	ws0100
		mov	bx,0
		inc	esi
ws0100:		bt	[eax][esi],bx
		jnc	wa01000
		inc	bx			;01001
		cmp	bx,8
		jne	ws01001
		mov	bx,0
		inc	esi
ws01001:	bt	[eax][esi],bx
		jnc	wa010010
		inc	bx			;010011
		cmp	bx,8
		jne	ws010011
		mov	bx,0
		inc	esi
ws010011:	bt	[eax][esi],bx
		jnc	wa0100110
		add	cx,18			;0100111=>18
		jmp	save_g3
wa0100110:	inc	bx			;0100110
		cmp	bx,8
		jne	ws0100110
		mov	bx,0
		inc	esi
ws0100110:	bt	[eax][esi],bx
		jnc	wa01001100
		inc	bx			;01001101
		cmp	bx,8
		jne	ws01001101
		mov	bx,0
		inc	esi
ws01001101:	bt	[eax][esi],bx
		jnc	wa010011010
		add	cx,1728			;010011011=>1728
		jmp	wg3
wa010011010:    add	cx,1600			;010011010=>1600
		jmp	wg3
wa01001100:     inc	bx			;01001100
		cmp	bx,8
		jne	ws01001100
		mov	bx,0
		inc	esi
ws01001100:	bt	[eax][esi],bx
		jnc	wa010011000
		add	cx,1536			;010011001=>1536
		jmp	wg3
wa010011000:    add	cx,1472			;010011000=>1472
		jmp	wg3
wa010010:       inc	bx			;010010
		cmp	bx,8
		jne	ws010010
		mov	bx,0
		inc	esi
ws010010:	bt	[eax][esi],bx
		jnc	wa0100100
		inc	bx			;0100101
		cmp	bx,8
		jne	ws0100101
		mov	bx,0
		inc	esi
ws0100101:	bt	[eax][esi],bx
		jnc	wa01001010
		add	cx,60			;01001011=>60
		jmp	save_g3
wa01001010:     add	cx,59			;01001010=>59
		jmp	save_g3
wa0100100:      add	cx,27			;0100100=>27
		jmp	save_g3
wa01000:        add	cx,11			;01000=>11
		jmp	save_g3
wa00:           inc	bx			;00
		cmp	bx,8
		jne	ws00
		mov	bx,0
		inc	esi
ws00:		bt	[eax][esi],bx
		jnc	wa000
		inc	bx			;001
		cmp	bx,8
		jne	ws001
		mov	bx,0
		inc	esi
ws001:		bt	[eax][esi],bx
		jnc	wa0010
		inc	bx			;0011
		cmp	bx,8
		jne	ws0011
		mov	bx,0
		inc	esi
ws0011:		bt	[eax][esi],bx
		jnc	wa00110
		add	cx,10			;00111=>10
		jmp	save_g3
wa00110:        inc	bx			;00110
		cmp	bx,8
		jne	ws00110
		mov	bx,0
		inc	esi
ws00110:	bt	[eax][esi],bx
		jnc	wa001100
		inc	bx			;001101
		cmp	bx,8
		jne	ws001101
		mov	bx,0
		inc	esi
ws001101:	bt	[eax][esi],bx
		jnc	wa0011010
		inc	bx			;0011011
		cmp	bx,8
		jne	ws0011011
		mov	bx,0
		inc	esi
ws0011011:	bt	[eax][esi],bx
		jnc	wa00110110
		add	cx,384			;00110111=>384
		jmp	wg3
wa00110110:     add	cx,320			;00110110=>320
		jmp	wg3
wa0011010:      inc	bx			;0011010
		cmp	bx,8
		jne	ws0011010
		mov	bx,0
		inc	esi
ws0011010:	bt	[eax][esi],bx
		jnc	wa00110100
		add	cx,0			;00110101=>0
		jmp	save_g3
wa00110100:     add	cx,63			;00110100=>63
		jmp	save_g3
wa001100:       inc	bx			;001100
		cmp	bx,8
		jne	ws001100
		mov	bx,0
		inc	esi
ws001100:	bt	[eax][esi],bx
		jnc	wa0011000
		inc	bx			;0011001
		cmp	bx,8
		jne	ws0011001
		mov	bx,0
		inc	esi
ws0011001:	bt	[eax][esi],bx
		jnc	wa00110010
		add	cx,62			;00110011=>62
		jmp	save_g3
wa00110010:     add	cx,61			;00110010=>61
		jmp	save_g3
wa0011000:      add	cx,28			;0011000=>28
		jmp	save_g3
wa0010:         inc	bx			;0010
		cmp	bx,8
		jne	ws0010
		mov	bx,0
		inc	esi
ws0010:		bt	[eax][esi],bx
		jnc	wa00100
		inc	bx			;00101
		cmp	bx,8
		jne	ws00101
		mov	bx,0
		inc	esi
ws00101:	bt	[eax][esi],bx
		jnc	wa001010
		inc	bx			;001011
		cmp	bx,8
		jne	ws001011
		mov	bx,0
		inc	esi
ws001011:	bt	[eax][esi],bx
		jnc	wa0010110
		add	cx,21			;0010111=>21
		jmp	save_g3
wa0010110:      inc	bx			;0010110
		cmp	bx,8
		jne	ws0010110
		mov	bx,0
		inc	esi
ws0010110:	bt	[eax][esi],bx
		jnc	wa00101100
		add	cx,44			;00101101=>44
		jmp	save_g3
wa00101100:     add	cx,43			;00101100=>43
		jmp	save_g3
wa001010:       inc	bx      		;001010
		cmp	bx,8
		jne	ws001010
		mov	bx,0
		inc	esi
ws001010:	bt	[eax][esi],bx
		jnc	wa0010100
		inc	bx      		;0010101
		cmp	bx,8
		jne	ws0010101
		mov	bx,0
		inc	esi
ws0010101:	bt	[eax][esi],bx
		jnc	wa00101010
		add	cx,42			;00101011=>42
		jmp	save_g3
wa00101010:     add	cx,41			;00101010=>41
		jmp	save_g3
wa0010100:      inc	bx			;0010100
		cmp	bx,8
		jne	ws0010100
		mov	bx,0
		inc	esi
ws0010100:	bt	[eax][esi],bx
		jnc	wa00101000
		add	cx,40			;00101001=>40
		jmp	save_g3
wa00101000:     add	cx,39			;00101000=>39
		jmp	save_g3
wa00100:        inc	bx			;00100
		cmp	bx,8
		jne	ws00100
		mov	bx,0
		inc	esi
ws00100:	bt	[eax][esi],bx
		jnc	wa001000
		inc	bx			;001001
		cmp	bx,8
		jne	ws001001
		mov	bx,0
		inc	esi
ws001001:	bt	[eax][esi],bx
		jnc	wa0010010
		add	cx,26			;0010011=>26
		jmp	save_g3
wa0010010:      inc	bx			;0010010
		cmp	bx,8
		jne	ws0010010
		mov	bx,0
		inc	esi
ws0010010:	bt	[eax][esi],bx
		jnc	wa00100100
		add	cx,54			;00100101=>54
		jmp	save_g3
wa00100100:      add	cx,53			;00100100=>53
		jmp	save_g3
wa001000:       add	cx,12			;001000=>12
		jmp	save_g3
wa000:          inc	bx			;000
		cmp	bx,8
		jne	ws000
		mov	bx,0
		inc	esi
ws000:		bt	[eax][esi],bx
		jnc	wa0000
		inc	bx			;0001
		cmp	bx,8
		jne	ws0001
		mov	bx,0
		inc	esi
ws0001:		bt	[eax][esi],bx
		jnc	wa00010
		inc	bx			;00011
		cmp	bx,8
		jne	ws00011
		mov	bx,0
		inc	esi
ws00011:	bt	[eax][esi],bx
		jnc	wa000110
		add	cx,1			;000111=>1
		jmp	save_g3
wa000110:       inc	bx			;000110
		cmp	bx,8
		jne	ws000110
		mov	bx,0
		inc	esi
ws000110:	bt	[eax][esi],bx
		jnc	wa0001100
		inc	bx			;0001101
		cmp	bx,8
		jne	ws0001101
		mov	bx,0
		inc	esi
ws0001101:	bt	[eax][esi],bx
		jnc	wa00011010
		add	cx,32			;00011011=>32
		jmp	save_g3
wa00011010:	add	cx,31			;00011010=>31
		jmp	save_g3
wa0001100:      add	cx,19			;0001100=>19
		jmp	save_g3
wa00010:        inc	bx			;00010
		cmp	bx,8
		jne	ws00010
		mov	bx,0
		inc	esi
ws00010:	bt	[eax][esi],bx
		jnc	wa000100
		inc	bx			;000101
		cmp	bx,8
		jne	ws000101
		mov	bx,0
		inc	esi
ws000101:	bt	[eax][esi],bx
		jnc	wa0001010
		inc	bx			;0001011
		cmp	bx,8
		jne	ws0001011
		mov	bx,0
		inc	esi
ws0001011:	bt	[eax][esi],bx
		jnc	wa00010110
		add	cx,38			;00010111=>38
		jmp	save_g3
wa00010110:     add	cx,37			;00010110=>37
		jmp	save_g3
wa0001010:      inc	bx			;0001010
		cmp	bx,8
		jne	ws0001010
		mov	bx,0
		inc	esi
ws0001010:	bt	[eax][esi],bx
		jnc	wa00010100
		add	cx,36			;00010101=>36
		jmp	save_g3
wa00010100:     add	cx,35			;00010100=>35
		jmp	save_g3
wa000100:       inc	bx			;000100
		cmp	bx,8
		jne	ws000100
		mov	bx,0
		inc	esi
ws000100:	bt	[eax][esi],bx
		jnc	wa0001000
		inc	bx			;0001001
		cmp	bx,8
		jne	ws0001001
		mov	bx,0
		inc	esi
ws0001001:	bt	[eax][esi],bx
		jnc	wa00010010
		add	cx,34			;00010011=>34
		jmp	save_g3
wa00010010:     add	cx,33			;00010010=>33
		jmp	save_g3
wa0001000:      add	cx,20			;0001000=>20
		jmp	save_g3
wa0000:         inc	bx			;0000
		cmp	bx,8
		jne	ws0000
		mov	bx,0
		inc	esi
ws0000:		bt	[eax][esi],bx
		jnc	wa00000
		inc	bx			;00001
		cmp	bx,8
		jne	ws00001
		mov	bx,0
		inc	esi
ws00001:	bt	[eax][esi],bx
		jnc	wa000010
		add	cx,13			;000011=>13
		jmp	save_g3
wa000010:       inc	bx			;000010
		cmp	bx,8
		jne	ws000010
		mov	bx,0
		inc	esi
ws000010:	bt	[eax][esi],bx
		jnc	wa0000100
		inc	bx			;0000101
		cmp	bx,8
		jne	ws0000101
		mov	bx,0
		inc	esi
ws0000101:	bt	[eax][esi],bx
		jnc	wa00001010
		add	cx,48			;00001011=>48
		jmp	save_g3
wa00001010:     add	cx,47			;00001010=>47
		jmp	save_g3
wa0000100:      add	cx,23			;0000100=>23
		jmp	save_g3
wa00000:        inc	bx			;00000
		cmp	bx,8
		jne	ws00000
		mov	bx,0
		inc	esi
ws00000:	bt	[eax][esi],bx
		jnc	wa000000
		inc	bx			;000001
		cmp	bx,8
		jne	ws000001
		mov	bx,0
		inc	esi
ws000001:	bt	[eax][esi],bx
		jnc	wa0000010
		add	cx,22			;0000011=>22
		jmp	save_g3
wa0000010:      inc	bx			;0000010
		cmp	bx,8
		jne	ws0000010
		mov	bx,0
		inc	esi
ws0000010:	bt	[eax][esi],bx
		jnc	wa00000100
		add	cx,46			;00000101=>46
		jmp	save_g3
wa00000100:     add	cx,45			;00000100=>45
		jmp	save_g3
wa000000:       inc	bx     			;000000
		cmp	bx,8
		jne	ws000000
		mov	bx,0
		inc	esi
ws000000:	bt	[eax][esi],bx
		jnc	wa0000000
		inc	bx     			;0000001
		cmp	bx,8
		jne	ws0000001
		mov	bx,0
		inc	esi
ws0000001:	bt	[eax][esi],bx
		jnc	wa00000010
		add	cx,30			;00000011=>30
		jmp	save_g3
wa00000010:     add	cx,29			;00000010=>29
		jmp	save_g3
wa0000000:      inc	bx			;0000000
		cmp	bx,8
		jne	ws0000000
		mov	bx,0
		inc	esi
ws0000000:	bt	[eax][esi],bx
		jnc	wa00000000
		inc	bx			;00000001
		cmp	bx,8
		jne	ws00000001
		mov	bx,0
		inc	esi
ws00000001:	bt	[eax][esi],bx
		jnc	wa000000010
		inc	bx			;000000011
		cmp	bx,8
		jne	ws000000011
		mov	bx,0
		inc	esi
ws000000011:	bt	[eax][esi],bx
		jnc	wa0000000110
		inc	bx			;0000000111
		cmp	bx,8
		jne	ws0000000111
		mov	bx,0
		inc	esi
ws0000000111:	bt	[eax][esi],bx
		jnc	wa00000001110
		inc	bx			;00000001111
		cmp	bx,8
		jne	ws00000001111
		mov	bx,0
		inc	esi
ws00000001111:	bt	[eax][esi],bx
		jnc	wa000000011110
		add	cx,2560			;000000011111=>2560
		jmp	wg3
wa000000011110: add	cx,2496			;000000011110=>2496
		jmp	wg3
wa00000001110:  inc	bx			;00000001110
		cmp	bx,8
		jne	ws00000001110
		mov	bx,0
		inc	esi
ws00000001110:	bt	[eax][esi],bx
		jnc	wa000000011100
		add	cx,2432			;000000011101=>2432
		jmp	wg3
wa000000011100: add	cx,2368			;000000011100=>2368
		jmp	wg3
wa0000000110:   inc	bx			;0000000110
		cmp	bx,8
		jne	ws0000000110
		mov	bx,0
		inc	esi
ws0000000110:	bt	[eax][esi],bx
		jnc	wa00000001100
		add	cx,1920			;00000001101=>1920
		jmp	wg3
wa00000001100:  add	cx,1856			;00000001100=>1856
		jmp	wg3
wa000000010:    inc	bx			;000000010
		cmp	bx,8
		jne	ws000000010
		mov	bx,0
		inc	esi
ws000000010:	bt	[eax][esi],bx
		jnc	wa0000000100
		inc	bx			;0000000101
		cmp	bx,8
		jne	ws0000000101
		mov	bx,0
		inc	esi
ws0000000101:	bt	[eax][esi],bx
		jnc	wa00000001010
		inc	bx			;00000001011
		cmp	bx,8
		jne	ws00000001011
		mov	bx,0
		inc	esi
ws00000001011:	bt	[eax][esi],bx
		jnc	wa000000010110
		add	cx,2304			;000000010111=>2304
		jmp	wg3
wa000000010110: add	cx,2240			;000000010110=>2240
		jmp	wg3
wa00000001010:  inc	bx			;00000001010
		cmp	bx,8
		jne	ws00000001010
		mov	bx,0
		inc	esi
ws00000001010:	bt	[eax][esi],bx
		jnc	wa000000010100
		add	cx,2176			;000000010101=>2176
		jmp	wg3
wa000000010100: add	cx,2112			;000000010100=>2112
		jmp	wg3
wa0000000100:	inc	bx			;0000000100
		cmp	bx,8
		jne	ws0000000100
		mov	bx,0
		inc	esi
ws0000000100:	bt	[eax][esi],bx
		jnc	wa00000001000
		inc	bx			;00000001001
		cmp	bx,8
		jne	ws00000001001
		mov	bx,0
		inc	esi
ws00000001001:	bt	[eax][esi],bx
		jnc	wa000000010010
		add	cx,2048			;000000010011=>2048
		jmp	wg3
wa000000010010: add	cx,1984			;000000010010=>1984
		jmp	wg3
wa00000001000:  add	cx,1792			;00000001000=>1792
		jmp	wg3
wa00000000:     mov	cx,-1			;error
		jmp	save_g3
;
;	BlackG3 function decodes g3 info in horizontal encoding
;				Registers used:
;					Input	EAX -g4buffer
;						ESI -g4bufcnt
;						 BX -bitcnt
;                               	Output	 CX -runlength (if>=0)
;						    -error code(if -1)
;					Doesn't use other regs
bg3:		inc	bx
		cmp	bx,8
		jne	bsame
		mov	bx,0
		inc	esi
bsame:		bt      [eax][esi],bx
		jnc	ba0
		inc	bx			;1
		cmp	bx,8
		jne	bs1
		mov	bx,0
		inc	esi
bs1:		bt	[eax][esi],bx
		jnc	ba10
		add	cx,2			;11=>2
		jmp	save_g3
ba10:		add	cx,3			;10=>3
		jmp	save_g3
ba0:		inc	bx			;0
		cmp	bx,8
		jne	bs0
		mov	bx,0
		inc	esi
bs0:		bt	[eax][esi],bx
		jnc	ba00
		inc	bx			;01
		cmp	bx,8
		jne	bs01
		mov	bx,0
		inc	esi
bs01:		bt	[eax][esi],bx
		jnc	ba010
		add	cx,4			;011=>4
		jmp	save_g3
ba010:          add	cx,1			;010=>1
		jmp	save_g3
ba00:           inc	bx			;00
		cmp	bx,8
		jne	bs00
		mov	bx,0
		inc	esi
bs00:		bt	[eax][esi],bx
		jnc	ba000
		inc	bx			;001
		cmp	bx,8
		jne	bs001
		mov	bx,0
		inc	esi
bs001:		bt	[eax][esi],bx
		jnc	ba0010
		add	cx,5			;0011=>5
		jmp	save_g3
ba0010:		add	cx,6			;0010=>6
		jmp	save_g3
ba000:		inc	bx			;000
		cmp	bx,8
		jne	bs000
		mov	bx,0
		inc	esi
bs000:		bt	[eax][esi],bx
		jnc	ba0000
		inc	bx			;0001
		cmp	bx,8
		jne	bs0001
		mov	bx,0
		inc	esi
bs0001:		bt	[eax][esi],bx
		jnc	ba00010
		add	cx,7			;00011=>7
		jmp	save_g3
ba00010:        inc	bx			;00010
		cmp	bx,8
		jne	bs00010
		mov	bx,0
		inc	esi
bs00010:	bt	[eax][esi],bx
		jnc	ba000100
		add	cx,8			;000101=>8
		jmp	save_g3
ba000100:       add	cx,9			;000100=>9
		jmp	save_g3
ba0000:         inc	bx			;0000
		cmp	bx,8
		jne	bs0000
		mov	bx,0
		inc	esi
bs0000:		bt	[eax][esi],bx
		jnc	ba00000
		inc	bx			;00001
		cmp	bx,8
		jne	bs00001
		mov	bx,0
		inc	esi
bs00001:	bt	[eax][esi],bx
		jnc	ba000010
		inc	bx			;000011
		cmp	bx,8
		jne	bs000011
		mov	bx,0
		inc	esi
bs000011:	bt	[eax][esi],bx
		jnc	ba0000110
		add	cx,12			;0000111=>12
		jmp	save_g3
ba0000110:	inc	bx			;0000110
		cmp	bx,8
		jne	bs0000110
		mov	bx,0
		inc	esi
bs0000110:	bt	[eax][esi],bx
		jnc	ba00001100
		inc	bx			;00001101
		cmp	bx,8
		jne	bs00001101
		mov	bx,0
		inc	esi
bs00001101:	bt	[eax][esi],bx
		jnc	ba000011010
		inc	bx			;000011011
		cmp	bx,8
		jne	bs000011011
		mov	bx,0
		inc	esi
bs000011011:	bt	[eax][esi],bx
		jnc	ba0000110110
		jmp	save_g3			;0000110111=>0
ba0000110110:   inc	bx			;0000110110
		cmp	bx,8
		jne	bs0000110110
		mov	bx,0
		inc	esi
bs0000110110:	bt	[eax][esi],bx
		jnc	ba00001101100
		inc	bx			;00001101101
		cmp	bx,8
		jne	bs00001101101
		mov	bx,0
		inc	esi
bs00001101101:	bt	[eax][esi],bx
		jnc	ba000011011010
		add	cx,43			;000011011011=>43
		jmp	save_g3
ba000011011010: add	cx,42			;000011011010=>42
		jmp	save_g3
ba00001101100:	add	cx,21			;00001101100=>21
		jmp	save_g3
ba000011010:	inc	bx			;000011010
		cmp	bx,8
		jne	bs000011010
		mov	bx,0
		inc	esi
bs000011010:	bt	[eax][esi],bx
		jnc	ba0000110100
		inc	bx			;0000110101
		cmp	bx,8
		jne	bs0000110101
		mov	bx,0
		inc	esi
bs0000110101:	bt	[eax][esi],bx
		jnc	ba00001101010
		inc	bx			;00001101011
		cmp	bx,8
		jne	bs00001101011
		mov	bx,0
		inc	esi
bs00001101011:	bt	[eax][esi],bx
		jnc	ba000011010110
		add	cx,39			;000011010111=>39
		jmp	save_g3
ba000011010110:	add	cx,38			;000011010110=>38
		jmp	save_g3
ba00001101010:	inc	bx			;00001101010
		cmp	bx,8
		jne	bs00001101010
		mov	bx,0
		inc	esi
bs00001101010:	bt	[eax][esi],bx
		jnc	ba000011010100
		add	cx,37			;000011010101=>37
		jmp	save_g3
ba000011010100: add	cx,36			;000011010100=>36
		jmp	save_g3
ba0000110100:   inc	bx			;0000110100
		cmp	bx,8
		jne	bs0000110100
		mov	bx,0
		inc	esi
bs0000110100:	bt	[eax][esi],bx
		jnc	ba00001101000
		inc	bx			;00001101001
		cmp	bx,8
		jne	bs00001101001
		mov	bx,0
		inc	esi
bs00001101001:	bt	[eax][esi],bx
		jnc	ba000011010010
		add	cx,35			;000011010011=>35
		jmp	save_g3
ba000011010010:	add	cx,34			;000011010010=>34
		jmp	save_g3
ba00001101000:	add	cx,20			;00001101000=>20
		jmp	save_g3
ba00001100:	inc	bx			;00001100
		cmp	bx,8
		jne	bs00001100
		mov	bx,0
		inc	esi
bs00001100:	bt	[eax][esi],bx
		jnc	ba000011000
		inc	bx			;000011001
		cmp	bx,8
		jne	bs000011001
		mov	bx,0
		inc	esi
bs000011001:	bt	[eax][esi],bx
		jnc	ba0000110010
		inc	bx			;0000110011
		cmp	bx,8
		jne	bs0000110011
		mov	bx,0
		inc	esi
bs0000110011:	bt	[eax][esi],bx
		jnc	ba00001100110
		add	cx,19			;00001100111=>19
		jmp	save_g3
ba00001100110:	inc	bx			;00001100110
		cmp	bx,8
		jne	bs00001100110
		mov	bx,0
		inc	esi
bs00001100110:	bt	[eax][esi],bx
		jnc	ba000011001100
		add	cx,29			;000011001101=>29
		jmp	save_g3
ba000011001100:	add	cx,28			;000011001100=>28
		jmp	save_g3
ba0000110010:	inc	bx			;0000110010
		cmp	bx,8
		jne	bs0000110010
		mov	bx,0
		inc	esi
bs0000110010:	bt	[eax][esi],bx
		jnc	ba00001100100
		inc	bx			;00001100101
		cmp	bx,8
		jne	bs00001100101
		mov	bx,0
		inc	esi
bs00001100101:	bt	[eax][esi],bx
		jnc	ba000011001010
		add	cx,27			;000011001011=>27
		jmp	save_g3
ba000011001010:	add	cx,26			;000011001010=>26
		jmp	save_g3
ba00001100100:	inc	bx			;00001100100
		cmp	bx,8
		jne	bs00001100100
		mov	bx,0
		inc	esi
bs00001100100:	bt	[eax][esi],bx
		jnc	ba000011001000
		add	cx,192			;000011001001=>192
		jmp	bg3
ba000011001000:	add	cx,128			;000011001000=>128
		jmp	bg3
ba000011000:	add	cx,15			;000011000=>15
		jmp	save_g3
ba000010:	inc	bx			;000010
		cmp	bx,8
		jne	bs000010
		mov	bx,0
		inc	esi
bs000010:	bt	[eax][esi],bx
		jnc	ba0000100
		add	cx,11			;0000101=>11
		jmp	save_g3
ba0000100:	add	cx,10			;0000100=>10
		jmp	save_g3
ba00000:        inc	bx			;00000
		cmp	bx,8
		jne	bs00000
		mov	bx,0
		inc	esi
bs00000:	bt	[eax][esi],bx
		jnc	ba000000
		inc	bx			;000001
		cmp	bx,8
		jne	bs000001
		mov	bx,0
		inc	esi
bs000001:	bt	[eax][esi],bx
		jnc	ba0000010
		inc	bx			;0000011
		cmp	bx,8
		jne	bs0000011
		mov	bx,0
		inc	esi
bs0000011:	bt	[eax][esi],bx
		jnc	ba00000110
		add	cx,14			;00000111=>14
		jmp	save_g3
ba00000110:	inc	bx			;00000110
		cmp	bx,8
		jne	bs00000110
		mov	bx,0
		inc	esi
bs00000110:	bt	[eax][esi],bx
		jnc	ba000001100
		inc	bx			;000001101
		cmp	bx,8
		jne	bs000001101
		mov	bx,0
		inc	esi
bs000001101:	bt	[eax][esi],bx
		jnc	ba0000011010
		inc	bx			;0000011011
		cmp	bx,8
		jne	bs0000011011
		mov	bx,0
		inc	esi
bs0000011011:	bt	[eax][esi],bx
		jnc	ba00000110110
		add	cx,22			;00000110111=>22
		jmp	save_g3
ba00000110110:	inc	bx			;00000110110
		cmp	bx,8
		jne	bs00000110110
		mov	bx,0
		inc	esi
bs00000110110:	bt	[eax][esi],bx
		jnc	ba000001101100
		add	cx,41			;000001101101=>41
		jmp	save_g3
ba000001101100:	add	cx,40			;000001101100=>40
		jmp	save_g3
ba0000011010:	inc	bx			;0000011010
		cmp	bx,8
		jne	bs0000011010
		mov	bx,0
		inc	esi
bs0000011010:	bt	[eax][esi],bx
		jnc	ba00000110100
		inc	bx			;00000110101
		cmp	bx,8
		jne	bs00000110101
		mov	bx,0
		inc	esi
bs00000110101:	bt	[eax][esi],bx
		jnc	ba000001101010
		add	cx,33			;000001101011=>33
		jmp	save_g3
ba000001101010:	add	cx,32			;000001101010=>32
		jmp	save_g3
ba00000110100:	inc	bx			;00000110100
		cmp	bx,8
		jne	bs00000110100
		mov	bx,0
		inc	esi
bs00000110100:	bt	[eax][esi],bx
		jnc	ba000001101000
		add	cx,31			;000001101001=>31
		jmp	save_g3
ba000001101000:	add	cx,30			;000001101000=>30
		jmp	save_g3
ba000001100:	inc	bx			;000001100
		cmp	bx,8
		jne	bs000001100
		mov	bx,0
		inc	esi
bs000001100:	bt	[eax][esi],bx
		jnc	ba0000011000
		inc	bx			;0000011001
		cmp	bx,8
		jne	bs0000011001
		mov	bx,0
		inc	esi
bs0000011001:	bt	[eax][esi],bx
		jnc	ba00000110010
		inc	bx			;00000110011
		cmp	bx,8
		jne	bs00000110011
		mov	bx,0
		inc	esi
bs00000110011:	bt	[eax][esi],bx
		jnc	ba000001100110
		add	cx,63			;000001100111=>63
		jmp	save_g3
ba000001100110:	add	cx,62			;000001100110=>62
		jmp	save_g3
ba00000110010:	inc	bx			;00000110010
		cmp	bx,8
		jne	bs00000110010
		mov	bx,0
		inc	esi
bs00000110010:	bt	[eax][esi],bx
		jnc	ba000001100100
		add	cx,49			;000001100101=>49
		jmp	save_g3
ba000001100100:	add	cx,48			;000001100100=>48
		jmp	save_g3
ba0000011000:	add	cx,17			;0000011000=>17
		jmp	save_g3
ba0000010:	inc	bx			;0000010
		cmp	bx,8
		jne	bs0000010
		mov	bx,0
		inc	esi
bs0000010:	bt	[eax][esi],bx
		jnc	ba00000100
		inc	bx			;00000101
		cmp	bx,8
		jne	bs00000101
		mov	bx,0
		inc	esi
bs00000101:	bt	[eax][esi],bx
		jnc	ba000001010
		inc	bx			;000001011
		cmp	bx,8
		jne	bs000001011
		mov	bx,0
		inc	esi
bs000001011:	bt	[eax][esi],bx
		jnc	ba0000010110
		add	cx,16			;0000010111=>16
		jmp	save_g3
ba0000010110:	inc	bx			;0000010110
		cmp	bx,8
		jne	bs0000010110
		mov	bx,0
		inc	esi
bs0000010110:	bt	[eax][esi],bx
		jnc	ba00000101100
		inc	bx			;00000101101
		cmp	bx,8
		jne	bs00000101101
		mov	bx,0
		inc	esi
bs00000101101:	bt	[eax][esi],bx
		jnc	ba000001011010
		add	cx,256			;000001011011=>256
		jmp	bg3
ba000001011010:	add	cx,61			;000001011010=>61
		jmp	save_g3
ba00000101100:  inc	bx			;00000101100
		cmp	bx,8
		jne	bs00000101100
		mov	bx,0
		inc	esi
bs00000101100:	bt	[eax][esi],bx
		jnc	ba000001011000
		add	cx,58			;000001011001=>58
		jmp	save_g3
ba000001011000:	add	cx,57			;000001011000=>57
		jmp	save_g3
ba000001010:	inc	bx			;000001010
		cmp	bx,8
		jne	bs000001010
		mov	bx,0
		inc	esi
bs000001010:	bt	[eax][esi],bx
		jnc	ba0000010100
		inc	bx			;0000010101
		cmp	bx,8
		jne	bs0000010101
		mov	bx,0
		inc	esi
bs0000010101:	bt	[eax][esi],bx
		jnc	ba00000101010
		inc	bx			;00000101011
		cmp	bx,8
		jne	bs00000101011
		mov	bx,0
		inc	esi
bs00000101011:	bt	[eax][esi],bx
		jnc	ba000001010110
		add	cx,47			;000001010111=>47
		jmp	save_g3
ba000001010110:	add	cx,46			;000001010110=>46
		jmp	save_g3
ba00000101010:	inc	bx			;00000101010
		cmp	bx,8
		jne	bs00000101010
		mov	bx,0
		inc	esi
bs00000101010:	bt	[eax][esi],bx
		jnc	ba000001010100
		add	cx,45			;000001010101=>45
		jmp	save_g3
ba000001010100:	add	cx,44			;000001010100=>44
		jmp	save_g3
ba0000010100:	inc	bx			;0000010100
		cmp	bx,8
		jne	bs0000010100
		mov	bx,0
		inc	esi
bs0000010100:	bt	[eax][esi],bx
		jnc	ba00000101000
		inc	bx			;00000101001
		cmp	bx,8
		jne	bs00000101001
		mov	bx,0
		inc	esi
bs00000101001:	bt	[eax][esi],bx
		jnc	ba000001010010
		add	cx,51			;000001010011=>51
		jmp	save_g3
ba000001010010:	add	cx,50			;000001010010=>50
		jmp	save_g3
ba00000101000:	add	cx,23			;00000101000=>23
		jmp	save_g3
ba00000100:	add	cx,13			;00000100=>13
		jmp	save_g3
ba000000:	inc	bx			;000000
		cmp	bx,8
		jne	bs000000
		mov	bx,0
		inc	esi
bs000000:	bt	[eax][esi],bx
		jnc	ba0000000
		inc	bx			;0000001
		cmp	bx,8
		jne	bs0000001
		mov	bx,0
		inc	esi
bs0000001:	bt	[eax][esi],bx
		jnc	ba00000010
		inc	bx			;00000011
		cmp	bx,8
		jne	bs00000011
		mov	bx,0
		inc	esi
bs00000011:	bt	[eax][esi],bx
		jnc	ba000000110
		inc	bx			;000000111
		cmp	bx,8
		jne	bs000000111
		mov	bx,0
		inc	esi
bs000000111:	bt	[eax][esi],bx
		jnc	ba0000001110
		add	cx,64			;0000001111=>64
		jmp	bg3
ba0000001110:	inc	bx			;0000001110
		cmp	bx,8
		jne	bs0000001110
		mov	bx,0
		inc	esi
bs0000001110:	bt	[eax][esi],bx
		jnc	ba00000011100
		inc	bx			;00000011101
		cmp	bx,8
		jne	bs00000011101
		mov	bx,0
		inc	esi
bs00000011101:	bt	[eax][esi],bx
		jnc	ba000000111010
		inc	bx			;000000111011
		cmp	bx,8
		jne	bs000000111011
		mov	bx,0
		inc	esi
bs000000111011:	bt	[eax][esi],bx
		jnc	ba0000001110110
		add	cx,1216			;0000001110111=>1216
		jmp	bg3
ba0000001110110:add	cx,1152			;0000001110110=>1152
		jmp	bg3
ba000000111010:	inc	bx			;000000111010
		cmp	bx,8
		jne	bs000000111010
		mov	bx,0
		inc	esi
bs000000111010:	bt	[eax][esi],bx
		jnc	ba0000001110100
		add	cx,1088			;0000001110101=>1088
		jmp	bg3
ba0000001110100:add	cx,1024			;0000001110100=>1024
		jmp	bg3
ba00000011100:  inc	bx			;00000011100
		cmp	bx,8
		jne	bs00000011100
		mov	bx,0
		inc	esi
bs00000011100:	bt	[eax][esi],bx
		jnc	ba000000111000
		inc	bx			;000000111001
		cmp	bx,8
		jne	bs000000111001
		mov	bx,0
		inc	esi
bs000000111001:	bt	[eax][esi],bx
		jnc	ba0000001110010
		add	cx,960			;0000001110011=>960
		jmp	bg3
ba0000001110010:add	cx,896			;0000001110010=>896
		jmp	bg3
ba000000111000:	add	cx,54			;000000111000=>54
		jmp	save_g3
ba000000110:	inc	bx			;000000110
		cmp	bx,8
		jne	bs000000110
		mov	bx,0
		inc	esi
bs000000110:	bt	[eax][esi],bx
		jnc	ba0000001100
		inc	bx			;0000001101
		cmp	bx,8
		jne	bs0000001101
		mov	bx,0
		inc	esi
bs0000001101:	bt	[eax][esi],bx
		jnc	ba00000011010
		inc	bx			;00000011011
		cmp	bx,8
		jne	bs00000011011
		mov	bx,0
		inc	esi
bs00000011011:	bt	[eax][esi],bx
		jnc	ba000000110110
		add	cx,53			;000000110111=>53
		jmp	save_g3
ba000000110110:	inc	bx			;000000110110
		cmp	bx,8
		jne	bs000000110110
		mov	bx,0
		inc	esi
bs000000110110:	bt	[eax][esi],bx
		jnc	ba0000001101100
		add	cx,576			;0000001101101=>576
		jmp	bg3
ba0000001101100:add	cx,512			;0000001101100=>512
		jmp	bg3
ba00000011010:	inc	bx			;00000011010
		cmp	bx,8
		jne	bs00000011010
		mov	bx,0
		inc	esi
bs00000011010:	bt	[eax][esi],bx
		jnc	ba000000110100
		add	cx,448			;000000110101=>448
		jmp	bg3
ba000000110100:	add	cx,384			;000000110100=>384
		jmp	bg3
ba0000001100:	inc	bx			;0000001100
		cmp	bx,8
		jne	bs0000001100
		mov	bx,0
		inc	esi
bs0000001100:	bt	[eax][esi],bx
		jnc	ba00000011000
		inc	bx			;00000011001
		cmp	bx,8
		jne	bs00000011001
		mov	bx,0
		inc	esi
bs00000011001:	bt	[eax][esi],bx
		jnc	ba000000110010
		add	cx,320			;000000110011=>320
		jmp	bg3
ba000000110010:	inc	bx			;000000110010
		cmp	bx,8
		jne	bs000000110010
		mov	bx,0
		inc	esi
bs000000110010:	bt	[eax][esi],bx
		jnc	ba0000001100100
		add	cx,1728			;0000001100101=>1728
		jmp	bg3
ba0000001100100:add	cx,1664			;0000001100100=>1664
		jmp	bg3
ba00000011000:	add	cx,25			;00000011000=>25
		jmp	save_g3
ba00000010:	inc	bx			;00000010
		cmp	bx,8
		jne	bs00000010
		mov	bx,0
		inc	esi
bs00000010:	bt	[eax][esi],bx
		jnc	ba000000100
		inc	bx			;000000101
		cmp	bx,8
		jne	bs000000101
		mov	bx,0
		inc	esi
bs000000101:	bt	[eax][esi],bx
		jnc	ba0000001010
		inc	bx			;0000001011
		cmp	bx,8
		jne	bs0000001011
		mov	bx,0
		inc	esi
bs0000001011:	bt	[eax][esi],bx
		jnc	ba00000010110
		add	cx,24			;00000010111=>24
		jmp	save_g3
ba00000010110:	inc	bx			;00000010110
		cmp	bx,8
		jne	bs00000010110
		mov	bx,0
		inc	esi
bs00000010110:	bt	[eax][esi],bx
		jnc	ba000000101100
		inc	bx			;000000101101
		cmp	bx,8
		jne	bs000000101101
		mov	bx,0
		inc	esi
bs000000101101:	bt	[eax][esi],bx
		jnc	ba0000001011010
		add	cx,1600			;0000001011011=>1600
		jmp	bg3
ba0000001011010:add	cx,1536			;0000001011010=>1536
		jmp	bg3
ba000000101100:	add	cx,60			;000000101100=>60
		jmp	save_g3
ba0000001010:   inc	bx			;0000001010
		cmp	bx,8
		jne	bs0000001010
		mov	bx,0
		inc	esi
bs0000001010:	bt	[eax][esi],bx
		jnc	ba00000010100
		inc	bx			;00000010101
		cmp	bx,8
		jne	bs00000010101
		mov	bx,0
		inc	esi
bs00000010101:	bt	[eax][esi],bx
		jnc	ba000000101010
		add	cx,59			;000000101011=>59
		jmp	save_g3
ba000000101010:	inc	bx			;000000101010
		cmp	bx,8
		jne	bs000000101010
		mov	bx,0
		inc	esi
bs000000101010:	bt	[eax][esi],bx
		jnc	ba0000001010100
		add	cx,1472			;0000001010101=>1472
		jmp	bg3
ba0000001010100:add	cx,1408			;0000001010100=>1408
		jmp	bg3
ba00000010100:	inc	bx			;00000010100
		cmp	bx,8
		jne	bs00000010100
		mov	bx,0
		inc	esi
bs00000010100:	bt	[eax][esi],bx
		jnc	ba000000101000
		inc	bx			;000000101001
		cmp	bx,8
		jne	bs000000101001
		mov	bx,0
		inc	esi
bs000000101001:	bt	[eax][esi],bx
		jnc	ba0000001010010
		add	cx,1344			;0000001010011=>1344
		jmp	bg3
ba0000001010010:add	cx,1280			;0000001010010=>1280
		jmp	bg3
ba000000101000:	add	cx,56			;000000101000=>56
		jmp	save_g3
ba000000100:	inc	bx			;000000100
		cmp	bx,8
		jne	bs000000100
		mov	bx,0
		inc	esi
bs000000100:	bt	[eax][esi],bx
		jnc	ba0000001000
		inc	bx			;0000001001
		cmp	bx,8
		jne	bs0000001001
		mov	bx,0
		inc	esi
bs0000001001:	bt	[eax][esi],bx
		jnc	ba00000010010
		inc	bx			;00000010011
		cmp	bx,8
		jne	bs00000010011
		mov	bx,0
		inc	esi
bs00000010011:	bt	[eax][esi],bx
		jnc	ba000000100110
		add	cx,55			;000000100111=>55
		jmp	save_g3
ba000000100110:	inc	bx			;000000100110
		cmp	bx,8
		jne	bs000000100110
		mov	bx,0
		inc	esi
bs000000100110:	bt	[eax][esi],bx
		jnc	ba0000001001100
		add	cx,832			;0000001001101=>832
		jmp	bg3
ba0000001001100:add	cx,768			;0000001001100=>768
		jmp	bg3
ba00000010010:	inc	bx			;00000010010
		cmp	bx,8
		jne	bs00000010010
		mov	bx,0
		inc	esi
bs00000010010:	bt	[eax][esi],bx
		jnc	ba000000100100
		inc	bx			;000000100101
		cmp	bx,8
		jne	bs000000100101
		mov	bx,0
		inc	esi
bs000000100101:	bt	[eax][esi],bx
		jnc	ba0000001001010
		add	cx,704			;0000001001011=>704
		jmp	bg3
ba0000001001010:add	cx,640			;0000001001010=>640
		jmp	bg3
ba000000100100:	add	cx,52			;000000100100=>52
		jmp	save_g3
ba0000001000:	add	cx,18			;0000001000=>18
		jmp	save_g3
ba0000000:	inc	bx			;0000000
		cmp	bx,8
		jne	bs0000000
		mov	bx,0
		inc	esi
bs0000000:	bt	[eax][esi],bx
		jnc	ba00000000
		inc	bx			;00000001
		cmp	bx,8
		jne	bs00000001
		mov	bx,0
		inc	esi
bs00000001:	bt	[eax][esi],bx
		jnc	ba000000010
		inc	bx			;000000011
		cmp	bx,8
		jne	bs000000011
		mov	bx,0
		inc	esi
bs000000011:	bt	[eax][esi],bx
		jnc	ba0000000110
		inc	bx			;0000000111
		cmp	bx,8
		jne	bs0000000111
		mov	bx,0
		inc	esi
bs0000000111:	bt	[eax][esi],bx
		jnc	ba00000001110
		inc	bx			;00000001111
		cmp	bx,8
		jne	bs00000001111
		mov	bx,0
		inc	esi
bs00000001111:	bt	[eax][esi],bx
		jnc	ba000000011110
		add	cx,2560			;000000011111=>2560
		jmp	bg3
ba000000011110:	add	cx,2496			;000000011110=>2496
		jmp	bg3
ba00000001110:	inc	bx			;00000001110
		cmp	bx,8
		jne	bs00000001110
		mov	bx,0
		inc	esi
bs00000001110:	bt	[eax][esi],bx
		jnc	ba000000011100
		add     cx,2432			;000000011101=>2432
		jmp	bg3
ba000000011100:	add	cx,2368			;000000011100=>2368
		jmp	bg3
ba0000000110:	inc	bx			;0000000110
		cmp	bx,8
		jne	bs0000000110
		mov	bx,0
		inc	esi
bs0000000110:	bt	[eax][esi],bx
		jnc	ba00000001100
		add	cx,1920			;00000001101=>1920
		jmp	bg3
ba00000001100:	add	cx,1856			;00000001100=>1856
		jmp	bg3
ba000000010:	inc	bx			;000000010
		cmp	bx,8
		jne	bs000000010
		mov	bx,0
		inc	esi
bs000000010:	bt	[eax][esi],bx
		jnc	ba0000000100
		inc	bx			;0000000101
		cmp	bx,8
		jne	bs0000000101
		mov	bx,0
		inc	esi
bs0000000101:	bt	[eax][esi],bx
		jnc	ba00000001010
		inc	bx			;00000001011
		cmp	bx,8
		jne	bs00000001011
		mov	bx,0
		inc	esi
bs00000001011:	bt	[eax][esi],bx
		jnc	ba000000010110
		add	cx,2304			;000000010111=>2304
		jmp	bg3
ba000000010110:	add	cx,2240			;000000010110=>2240
		jmp	bg3
ba00000001010:	inc	bx			;00000001010
		cmp	bx,8
		jne	bs00000001010
		mov	bx,0
		inc	esi
bs00000001010:	bt	[eax][esi],bx
		jnc	ba000000010100
		add	cx,2176			;000000010101=>2176
		jmp	bg3
ba000000010100:	add	cx,2112			;000000010100=>2112
		jmp	bg3
ba0000000100:   inc	bx			;0000000100
		cmp	bx,8
		jne	bs0000000100
		mov	bx,0
		inc	esi
bs0000000100:	bt	[eax][esi],bx
		jnc	ba00000001000
		inc	bx			;00000001001
		cmp	bx,8
		jne	bs00000001001
		mov	bx,0
		inc	esi
bs00000001001:	bt	[eax][esi],bx
		jnc	ba000000010010
		add	cx,2048			;000000010011=>2048
		jmp	bg3
ba000000010010:	add	cx,1984			;000000010010=>1984
		jmp	bg3
ba00000001000:	add	cx,1792			;00000001000=>1792
		jmp	bg3
ba00000000:	mov	cx,-1			;error
		jmp	save_g3

finish_g4rl:    
                cld
                mov ebp ,valebp
                mov  esi, valesi
                mov  edi, valedi
				mov  retval, EAX 
	}
    return retval;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
} // extern "C"
///////////////////////////////////////////////////////////////////////////////////////////////////

