// PdaGDI.cpp: implementation of the PdaGDI class.
///////////////////////////////////////////////////////////////////////////////////////////////////
#include "StdAfx.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////
PixColor    BlackBrushBlck             [( 8 *  8)];
PixColor    WhiteBrushBlck             [( 8 *  8)];
PixColor    GreyBrushBlck              [( 8 *  8)];
PixColor    LightGreyBrushBlck         [( 8 *  8)];

///////////////////////////////////////////////////////////////////////////////////////////////////
PdaGDI      ThePdaGDISnapShot;
PdaGDI      ThePdaGDI;
#define EMU_TOOL_HEIGHT 398
///////////////////////////////////////////////////////////////////////////////////////////////////
Byte      InitPdaScreen             (PByte ScreenPtr,        UShort ScreenWidth,     UShort ScreenHeight,
                                     UShort  VirScreenWidth, UShort VirScreenHeight, Byte MenuHeight)
{
PdaRect  EmptyRect                 = {0,0,0,0};
PdaRect  ScreenClipRect            = {0,0,VirScreenWidth - 1, VirScreenHeight - 1};

	ThePdaGDI.CBLen                = sizeof(PdaGDI);

	ThePdaGDI.Copy                 = 0;
	ThePdaGDI.PenMode              = 0;

	ThePdaGDI.ResetContext           ();

	// SURFACE...
	ThePdaGDI.SurfacePtr           = ScreenPtr;                         // Palm.ScreenPointer;
	ThePdaGDI.SurfaceWidth         = VirScreenWidth;                    // Palm.VirtualScreenWidth;
	ThePdaGDI.SurfaceHeight        = VirScreenHeight + EMU_TOOL_HEIGHT; // Palm.MemoryScreenHeight;
	ThePdaGDI.SurfaceWidthInByte   = VirScreenWidth;                    // Palm.VScreenWidthInByte;
	ThePdaGDI.SurfaceMemLen        = ThePdaGDI.SurfaceWidthInByte * ThePdaGDI.SurfaceHeight; // Palm.VScreenBufferSize;


	ThePdaGDI.ClipRectangle        = EmptyRect;
	ThePdaGDI.ClipAddrRectangle    = EmptyRect;
    SetClipRect                      (&ScreenClipRect);

    FillMemory (BlackBrushBlck,      sizeof(BlackBrushBlck),     BlackPoint);
    FillMemory (WhiteBrushBlck,      sizeof(WhiteBrushBlck),     WhitePoint);
    FillMemory (GreyBrushBlck,       sizeof(GreyBrushBlck),      DarkGreyPoint);
    FillMemory (LightGreyBrushBlck,  sizeof(LightGreyBrushBlck), LightGreyPoint);
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
//     Low Level Function
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
// NO MULTIPLICATION VERSION
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static void SetOnePixel          (long AddrX, long AddrY)
{
	PBYTE ScreenPtr  = &ThePdaGDI.SurfacePtr[(AddrY + AddrX)];
	*ScreenPtr       = ThePdaGDI.CurrentPenColor;
}
__forceinline static PixColor GetPixelColor    (long AddrX, long AddrY)
{
	PBYTE ScreenPtr  = &ThePdaGDI.SurfacePtr[(AddrY + AddrX)];
	return *ScreenPtr;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static void PaintOneMonoPoint  (int X, int Y)
{
/*  TO BE IMPLEMENTED...
	PBYTE ScreenPtr  = &ThePdaGDI.SurfacePtr[((Y * ThePdaGDI.SurfaceWidthInByte) + X)];
	*ScreenPtr       = ThePdaGDI.CurrentPenColor;
*/
}
__forceinline static void PaintOneColorPoint(int X, int Y)
{
long AddrX, AddrY;

    AddrX            = X;
    AddrY            = (Y * ThePdaGDI.SurfaceWidthInByte);
    SetPenPixel        (AddrX, AddrY);
}
__forceinline static void PaintOnePoint      (int X, int Y)
{
    PaintOneColorPoint(X, Y);
}
__forceinline static PixColor GetPointColor      (int X, int Y)
{
	PBYTE ScreenPtr  = &ThePdaGDI.SurfacePtr[((Y * ThePdaGDI.SurfaceWidthInByte) + X)];
	return *ScreenPtr;
}
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
void  ( *ROP_Function) (LPBYTE ScreenPtr, PixColor TheColor);
///////////////////////////////////////////////////////////////////////////////////////////////////
void ROP_MaskDst    (LPBYTE ScreenPtr, PixColor TheColor)
{
    if(*ScreenPtr   != ThePdaGDI.CurrentMaskColor){
       *ScreenPtr    = TheColor;
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void ROP_MaskSrc    (LPBYTE ScreenPtr, PixColor TheColor)
{
    if(TheColor     != ThePdaGDI.CurrentMaskColor){
       *ScreenPtr    = TheColor;
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void ROP_XorDst    (LPBYTE ScreenPtr, PixColor TheColor)
{
    *ScreenPtr       = TheColor ^ *ScreenPtr;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void ROP_XorSrc    (LPBYTE ScreenPtr, PixColor TheColor)
{
    *ScreenPtr      ^= TheColor;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void ROP_OrDst    (LPBYTE ScreenPtr, PixColor TheColor)
{
    *ScreenPtr       = TheColor | *ScreenPtr;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void ROP_OrSrc    (LPBYTE ScreenPtr, PixColor TheColor)
{
    *ScreenPtr      |= TheColor;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void ROP_AndDst    (LPBYTE ScreenPtr, PixColor TheColor)
{
    *ScreenPtr       = TheColor & *ScreenPtr;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void ROP_AndSrc    (LPBYTE ScreenPtr, PixColor TheColor)
{
    *ScreenPtr      &= TheColor;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void ROP_ExcDst    (LPBYTE ScreenPtr, PixColor TheColor)
{
    *ScreenPtr       = TheColor &~ *ScreenPtr;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void ROP_ExcSrc    (LPBYTE ScreenPtr, PixColor TheColor)
{
    *ScreenPtr       = *ScreenPtr &~TheColor;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
#if 0 // KEEP FOR ARCHIVE REASON
__forceinline static void SetPenPixel          (long CurrX, long CurrY)
{
int      LoopOnPenHeight;
WORD     BrushX, BrushY;
long     StartX, StartY, DeltaX, DeltaY;
PBYTE    ScreenPtr;

    if(ThePdaGDI.CurrentMaskMode){
       SetMaskedPenPixel (CurrX, CurrY);
       return;
    }
    StartX = CurrX; DeltaX = CurrX  + ThePdaGDI.CurrentPenSize.cx;
    StartY = CurrY; DeltaY = StartY;

    for(LoopOnPenHeight = 0; LoopOnPenHeight  < ThePdaGDI.CurrentPenSize.cy; LoopOnPenHeight++){
       DeltaY  += ThePdaGDI.SurfaceWidthInByte;
    }

    if(ClipRectangle(&StartX, &StartY, &DeltaX, &DeltaY, &ThePdaGDI.ClipAddrRectangle) == FALSE){
       return ;
    }
    for( CurrY           = StartY; CurrY < DeltaY; CurrY += ThePdaGDI.SurfaceWidthInByte)
    {
       ScreenPtr         = &ThePdaGDI.SurfacePtr[CurrY + StartX];

       for( CurrX        = StartX; CurrX < DeltaX; CurrX ++)
       {
           *ScreenPtr++  = ThePdaGDI.CurrentPenColor;
       }
    }
}
#else
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall SetPenPixel          (long CurrX, long CurrY)
{
int      LoopOnPenHeight;
WORD     BrushX, BrushY;
int     StartX, StartY, DeltaX, DeltaY;
PBYTE    ScreenPtr;

    StartX = CurrX; DeltaX = CurrX  + ThePdaGDI.CurrentPenSize.cx;
    StartY = CurrY; DeltaY = StartY;

    for(LoopOnPenHeight = 0; LoopOnPenHeight  < ThePdaGDI.CurrentPenSize.cy; LoopOnPenHeight++){
       DeltaY  += ThePdaGDI.SurfaceWidthInByte;
    }

    if(ClipPdaRectangle(&StartX, &StartY, &DeltaX, &DeltaY, &ThePdaGDI.ClipAddrRectangle) == FALSE){
       return ;
    }
    switch(ThePdaGDI.CurrentMaskMode){
    case ROP_MASKSRC:         ROP_Function         = ROP_MaskSrc;  goto ROP_PROCESS;
    case ROP_MASKDST:         ROP_Function         = ROP_MaskDst;  goto ROP_PROCESS;
    case ROP_XORSRC:          ROP_Function         = ROP_XorSrc;   goto ROP_PROCESS;
    case ROP_XORDST:          ROP_Function         = ROP_XorDst;   goto ROP_PROCESS;
    case ROP_ORSRC:           ROP_Function         = ROP_OrSrc;    goto ROP_PROCESS;
    case ROP_ORDST:           ROP_Function         = ROP_OrDst;    goto ROP_PROCESS;
    case ROP_ANDSRC:          ROP_Function         = ROP_AndSrc;   goto ROP_PROCESS;
    case ROP_ANDDST:          ROP_Function         = ROP_AndDst;   goto ROP_PROCESS;
    case ROP_EXCSRC:          ROP_Function         = ROP_ExcSrc;   goto ROP_PROCESS;
    case ROP_EXCDST:          ROP_Function         = ROP_ExcDst;   goto ROP_PROCESS;
         ROP_PROCESS:
         for( CurrY           = StartY; CurrY < DeltaY; CurrY += ThePdaGDI.SurfaceWidthInByte){
            ScreenPtr         = &ThePdaGDI.SurfacePtr[CurrY + StartX];
            for( CurrX        = StartX; CurrX < DeltaX; CurrX ++, ScreenPtr++){
               (*ROP_Function) (ScreenPtr, ThePdaGDI.CurrentPenColor);
            }
         }
         break;

    case ROP_COPY:
         for( CurrY           = StartY; CurrY < DeltaY; CurrY += ThePdaGDI.SurfaceWidthInByte){
            ScreenPtr         = &ThePdaGDI.SurfacePtr[CurrY + StartX];
            for( CurrX        = StartX; CurrX < DeltaX; CurrX ++, ScreenPtr++){
                *ScreenPtr    = ThePdaGDI.CurrentPenColor;
            }
         }
         break;
    }
}
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall InvertPdaMonoRect(PPdaRect TheRect)
{DLL_THREAD_MANAGEMENT();
int     StartX, StartY, CurrX, CurrY, DeltaX,    DeltaY;
PBYTE    ScreenPtr;
long     ScreenPos = 0;

	StartY             = TheRect->top;
    StartX             = TheRect->left;
    DeltaX             = TheRect->right;
    DeltaY             = TheRect->bottom;

    if(ClipPdaRectangle(&StartX, &StartY, &DeltaX, &DeltaY, &ThePdaGDI.ClipRectangle) == FALSE){
       return ;
    }
    ScreenPos          = StartY  * ThePdaGDI.SurfaceWidthInByte;

    switch(ThePdaGDI.CurrentMaskMode){
    case ROP_MASKSRC:         ROP_Function         = ROP_MaskSrc;  goto ROP_PROCESS;
    case ROP_MASKDST:         ROP_Function         = ROP_MaskDst;  goto ROP_PROCESS;
    case ROP_XORSRC:          ROP_Function         = ROP_XorSrc;   goto ROP_PROCESS;
    case ROP_XORDST:          ROP_Function         = ROP_XorDst;   goto ROP_PROCESS;
    case ROP_ORSRC:           ROP_Function         = ROP_OrSrc;    goto ROP_PROCESS;
    case ROP_ORDST:           ROP_Function         = ROP_OrDst;    goto ROP_PROCESS;
    case ROP_ANDSRC:          ROP_Function         = ROP_AndSrc;   goto ROP_PROCESS;
    case ROP_ANDDST:          ROP_Function         = ROP_AndDst;   goto ROP_PROCESS;
    case ROP_EXCSRC:          ROP_Function         = ROP_ExcSrc;   goto ROP_PROCESS;
    case ROP_EXCDST:          ROP_Function         = ROP_ExcDst;   goto ROP_PROCESS;
         ROP_PROCESS:
         for( CurrY           = StartY; CurrY <= DeltaY; CurrY ++){
            ScreenPtr         = &ThePdaGDI.SurfacePtr[ScreenPos + StartX];
            for( CurrX        = StartX; CurrX <= DeltaX; CurrX ++, ScreenPtr++){
               if((*ScreenPtr  == BlackPoint) || (*ScreenPtr  == WhitePoint)){
                 (*ROP_Function) (ScreenPtr, (Not *ScreenPtr));
               }
            }
            ScreenPos += ThePdaGDI.SurfaceWidthInByte;
         }
         break;

    case ROP_COPY:
         for( CurrY           = StartY; CurrY <= DeltaY; CurrY ++){
            ScreenPtr         = &ThePdaGDI.SurfacePtr[ScreenPos + StartX];
            for( CurrX        = StartX; CurrX <= DeltaX; CurrX ++, ScreenPtr++){
               if((*ScreenPtr  == BlackPoint) || (*ScreenPtr  == WhitePoint)){
                  *ScreenPtr    = Not *ScreenPtr;
               }
            }
            ScreenPos        += ThePdaGDI.SurfaceWidthInByte;
         }
         break;
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall ColorFillRect(PPdaRect TheRect, PixColor ThisColor)
{DLL_THREAD_MANAGEMENT();
int     StartX, StartY, CurrX, CurrY, DeltaX,    DeltaY;
PBYTE    ScreenPtr;
long     ScreenPos = 0;

	StartY             = TheRect->top;
    StartX             = TheRect->left;
    DeltaX             = TheRect->right;
    DeltaY             = TheRect->bottom;

    if(ClipPdaRectangle(&StartX, &StartY, &DeltaX, &DeltaY, &ThePdaGDI.ClipRectangle) == FALSE){
       return ;
    }
    ScreenPos          = StartY  * ThePdaGDI.SurfaceWidthInByte;

    switch(ThePdaGDI.CurrentMaskMode){
    case ROP_MASKSRC:         ROP_Function         = ROP_MaskSrc;  goto ROP_PROCESS;
    case ROP_MASKDST:         ROP_Function         = ROP_MaskDst;  goto ROP_PROCESS;
    case ROP_XORSRC:          ROP_Function         = ROP_XorSrc;   goto ROP_PROCESS;
    case ROP_XORDST:          ROP_Function         = ROP_XorDst;   goto ROP_PROCESS;
    case ROP_ORSRC:           ROP_Function         = ROP_OrSrc;    goto ROP_PROCESS;
    case ROP_ORDST:           ROP_Function         = ROP_OrDst;    goto ROP_PROCESS;
    case ROP_ANDSRC:          ROP_Function         = ROP_AndSrc;   goto ROP_PROCESS;
    case ROP_ANDDST:          ROP_Function         = ROP_AndDst;   goto ROP_PROCESS;
    case ROP_EXCSRC:          ROP_Function         = ROP_ExcSrc;   goto ROP_PROCESS;
    case ROP_EXCDST:          ROP_Function         = ROP_ExcDst;   goto ROP_PROCESS;
         ROP_PROCESS:
         for( CurrY           = StartY; CurrY <= DeltaY; CurrY ++){
            ScreenPtr         = &ThePdaGDI.SurfacePtr[ScreenPos + StartX];
            for( CurrX        = StartX; CurrX <= DeltaX; CurrX ++, ScreenPtr++){
               (*ROP_Function) (ScreenPtr, ThisColor);
            }
            ScreenPos += ThePdaGDI.SurfaceWidthInByte;
         }
         break;

    case ROP_COPY:
         for( CurrY           = StartY; CurrY <= DeltaY; CurrY ++){
            ScreenPtr         = &ThePdaGDI.SurfacePtr[ScreenPos + StartX];
            for( CurrX        = StartX; CurrX <= DeltaX; CurrX ++, ScreenPtr++){
                *ScreenPtr    = ThisColor;
            }
            ScreenPos        += ThePdaGDI.SurfaceWidthInByte;
         }
         break;
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
// TO DO: BitBLit(long SrcX, long SrcY, long SrcW, long SrcH, long DstX, long DstY, long DstW, long DstH, PBYTE TheData)
// TO DO: BitBLitRect(PPdaRect SrcRect, PPdaRect DstRect, PBYTE TheData)
///////////////////////////////////////////////////////////////////////////////////////////////////
void BitblitColorData(long X, long Y, long W, long H, PBYTE TheData)
{
int      StartX, StartY, CurrX, CurrY, DeltaX,    DeltaY;
LONG     RowLooper,      ColLooper;
LONG     StartData = 0,  DataLooper = 0;
LONG     ScreenPos;
BOOL     IsInClip;

    StartX  = X;
    StartY  = Y;
    DeltaX  = (X + W);
    DeltaY  = (Y + H);

    if(ClipPdaRectangle(&StartX, &StartY, &DeltaX, &DeltaY, &ThePdaGDI.ClipRectangle) == FALSE){
       return ;
    }
    ScreenPos           = Y  * ThePdaGDI.SurfaceWidthInByte;

    switch(ThePdaGDI.CurrentMaskMode){
    case ROP_MASKSRC:         ROP_Function         = ROP_MaskSrc;  goto ROP_PROCESS;
    case ROP_MASKDST:         ROP_Function         = ROP_MaskDst;  goto ROP_PROCESS;
    case ROP_XORSRC:          ROP_Function         = ROP_XorSrc;   goto ROP_PROCESS;
    case ROP_XORDST:          ROP_Function         = ROP_XorDst;   goto ROP_PROCESS;
    case ROP_ORSRC:           ROP_Function         = ROP_OrSrc;    goto ROP_PROCESS;
    case ROP_ORDST:           ROP_Function         = ROP_OrDst;    goto ROP_PROCESS;
    case ROP_ANDSRC:          ROP_Function         = ROP_AndSrc;   goto ROP_PROCESS;
    case ROP_ANDDST:          ROP_Function         = ROP_AndDst;   goto ROP_PROCESS;
    case ROP_EXCSRC:          ROP_Function         = ROP_ExcSrc;   goto ROP_PROCESS;
    case ROP_EXCDST:          ROP_Function         = ROP_ExcDst;   goto ROP_PROCESS;
         ROP_PROCESS:
         for(RowLooper          = Y; RowLooper < DeltaY; RowLooper ++){

            if(RowLooper       >= StartY){
               PBYTE ScreenPtr  = &ThePdaGDI.SurfacePtr[(ScreenPos + X)];
               for(ColLooper    = X; ColLooper < DeltaX; ColLooper ++){

                  if(ColLooper >= StartX){
                     (*ROP_Function) (ScreenPtr, TheData[DataLooper]);
                  }
                  DataLooper++;   ScreenPtr++;
               }
            }
            ScreenPos          += ThePdaGDI.SurfaceWidthInByte;
            StartData          += W;
            DataLooper          = StartData;
         }
         break;

    case ROP_COPY:
         for(RowLooper          = Y; RowLooper < DeltaY; RowLooper ++){

            if(RowLooper       >= StartY){
               PBYTE ScreenPtr  = &ThePdaGDI.SurfacePtr[(ScreenPos + X)];
               for(ColLooper    = X; ColLooper < DeltaX; ColLooper ++){

                  if(ColLooper >= StartX){
                     *ScreenPtr = TheData[DataLooper];
                  }
                  DataLooper++;   ScreenPtr++;
               }
            }
            ScreenPos          += ThePdaGDI.SurfaceWidthInByte;
            StartData          += W;
            DataLooper          = StartData;
         }
         break;
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall BrushFill(int StartX, int StartY, int DeltaX, int DeltaY)
{DLL_THREAD_MANAGEMENT();
WORD     CurrX,    CurrY;
WORD     BrushX,   BrushY;
long     ScreenPos;
PBYTE    ScreenPtr;

    if(ClipPdaRectangle(&StartX, &StartY, &DeltaX, &DeltaY, &ThePdaGDI.ClipRectangle) == FALSE){
       return ;
    }
    ScreenPos          = StartY  * ThePdaGDI.SurfaceWidthInByte + StartX;

    switch(ThePdaGDI.CurrentMaskMode){
    case ROP_MASKSRC:         ROP_Function         = ROP_MaskSrc;  goto ROP_PROCESS;
    case ROP_MASKDST:         ROP_Function         = ROP_MaskDst;  goto ROP_PROCESS;
    case ROP_XORSRC:          ROP_Function         = ROP_XorSrc;   goto ROP_PROCESS;
    case ROP_XORDST:          ROP_Function         = ROP_XorDst;   goto ROP_PROCESS;
    case ROP_ORSRC:           ROP_Function         = ROP_OrSrc;    goto ROP_PROCESS;
    case ROP_ORDST:           ROP_Function         = ROP_OrDst;    goto ROP_PROCESS;
    case ROP_ANDSRC:          ROP_Function         = ROP_AndSrc;   goto ROP_PROCESS;
    case ROP_ANDDST:          ROP_Function         = ROP_AndDst;   goto ROP_PROCESS;
    case ROP_EXCSRC:          ROP_Function         = ROP_ExcSrc;   goto ROP_PROCESS;
    case ROP_EXCDST:          ROP_Function         = ROP_ExcDst;   goto ROP_PROCESS;
         ROP_PROCESS:
         for( CurrY         = StartY; CurrY <= DeltaY; CurrY ++)
         {
            BrushY          = CurrY & (ThePdaGDI.CurrentBrushSize.cy - 1);
            ScreenPtr       = &ThePdaGDI.SurfacePtr[(ScreenPos)];
            for( CurrX      = StartX; CurrX <= DeltaX; CurrX ++){

              BrushX        = CurrX & (ThePdaGDI.CurrentBrushSize.cx - 1);
              (*ROP_Function) (ScreenPtr, (ThePdaGDI.CurrentBrushColor[BrushX + (BrushY << ThePdaGDI.CurrentBrushfactor)]));
              ScreenPtr++;
            }
            ScreenPos      += ThePdaGDI.SurfaceWidthInByte;
         }
         break;

    case ROP_COPY:
         for( CurrY         = StartY; CurrY <= DeltaY; CurrY ++)
         {
            BrushY          = CurrY & (ThePdaGDI.CurrentBrushSize.cy - 1);
            ScreenPtr       = &ThePdaGDI.SurfacePtr[(ScreenPos)];
            for( CurrX      = StartX; CurrX <= DeltaX; CurrX ++){

              BrushX        = CurrX & (ThePdaGDI.CurrentBrushSize.cx - 1);
              *ScreenPtr  = ThePdaGDI.CurrentBrushColor[BrushX + (BrushY << ThePdaGDI.CurrentBrushfactor)];
              ScreenPtr++;
            }
            ScreenPos      += ThePdaGDI.SurfaceWidthInByte;
         }
         break;
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall BrushFillRect(PPdaRect TheRect)
{DLL_THREAD_MANAGEMENT();
WORD  StartX, StartY, CurrX, CurrY, DeltaX,    DeltaY;

	StartY             = TheRect->top;
    StartX             = TheRect->left;
    DeltaX             = TheRect->right;
    DeltaY             = TheRect->bottom;

    BrushFill(StartX, StartY, DeltaX, DeltaY);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
void     __stdcall PaintLine (int X1, int Y1, int X2, int Y2)
{DLL_THREAD_MANAGEMENT();
long  StartX,    StartY,  DeltaX, DeltaY,  StepX,     StepY,     DivX,       DivY;
long  AddrX,     AddrY,   DestX,  DestY,   CurrX = 0, CurrY = 0, RoundX = 0, RoundY = 0;

    if((X1       > X2)){
       AddrX     = X2;                         AddrY     = Y2   * ThePdaGDI.SurfaceWidthInByte;
       DestX     = X1;                         DestY     = Y1   * ThePdaGDI.SurfaceWidthInByte;
       StartX    = (X2 << 12);                 DeltaX    = (X1 << 12);
       StartY    = (Y2 << 12);                 DeltaY    = (Y1 << 12);
    } else {
       AddrX     = X1;                         AddrY     = Y1   * ThePdaGDI.SurfaceWidthInByte;
       DestX     = X2;                         DestY     = Y2   * ThePdaGDI.SurfaceWidthInByte;
       StartX    = (X1 << 12);                 DeltaX    = (X2 << 12);
       StartY    = (Y1 << 12);                 DeltaY    = (Y2 << 12);
    }
    DivX         = (abs(X1 - X2));             DivX      = ((DivX == 0) ? 1 : DivX);
    DivY         = (abs(Y1 - Y2));             DivY      = ((DivY == 0) ? 1 : DivY);

    if(DivX      > DivY){
       StepX     = ((DeltaX - StartX) / DivX); StepY     = ((DeltaY - StartY) / DivX);
    } else {
       StepX     = ((DeltaX - StartX) / DivY); StepY     = ((DeltaY - StartY) / DivY);
    }
    SetPenPixel     (AddrX, AddrY);
    if(StepY     < 0){

       do{

          CurrX       += StepX;                RoundX    = (CurrX >> 12);
          CurrY       += StepY;                RoundY    = (CurrY >> 12);
          if(RoundX){
             AddrX++;
             CurrX    -= (RoundX << 12);
          }
          if(RoundY){
             AddrY    -= ThePdaGDI.SurfaceWidthInByte;
             CurrY    -= (RoundY << 12);
          }
          SetPenPixel     (AddrX, AddrY);


       } while((AddrX < DestX) || (AddrY > DestY));

    } else {

       do{

          CurrX       += StepX;                RoundX    = (CurrX >> 12);
          CurrY       += StepY;                RoundY    = (CurrY >> 12);
          if(RoundX){
             AddrX++;
             CurrX    -= (RoundX << 12);
          }
          if(RoundY){
             AddrY    += ThePdaGDI.SurfaceWidthInByte;
             CurrY    -= (RoundY << 12);
          }

          SetPenPixel     (AddrX, AddrY);

       } while((AddrX < DestX) || (AddrY < DestY));
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static void SetQuadrantPixels(LPPOINT CenterPoint, LPPOINT CurrentPoint)
{
    if(CurrentPoint->x != 0)
    {
       // PAINT BOTTOM-LEFT QUADRANT
       PaintOnePoint(CenterPoint->x - CurrentPoint->x, CenterPoint->y + CurrentPoint->y);
       // PAINT BOTTOM-RIGHT QUADRANT
       PaintOnePoint(CenterPoint->x + CurrentPoint->x, CenterPoint->y + CurrentPoint->y);

       if(CurrentPoint->y != 0)
       {
          // PAINT TOP-RIGHT QUADRANT
          PaintOnePoint(CenterPoint->x + CurrentPoint->x, CenterPoint->y - CurrentPoint->y);
          // PAINT TOP-LEFT QUADRANT
          PaintOnePoint(CenterPoint->x - CurrentPoint->x, CenterPoint->y - CurrentPoint->y);
       }
    } else {
       // PAINT Y BOTTOM AXIS QUADRANT
       PaintOnePoint(CenterPoint->x, CenterPoint->y + CurrentPoint->y);
       if( CurrentPoint->y != 0){
          // PAINT Y TOP AXIS QUADRANT
          PaintOnePoint(CenterPoint->x, CenterPoint->y - CurrentPoint->y);
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static void SetArcPixels(LPPOINT CenterPoint, LPPOINT CurrentPoint, int Quadrant)
{
    if(CurrentPoint->x != 0)
    {
       if(Quadrant     == BOTTOM_LEFT_QUADRANT){
          // PAINT BOTTOM-LEFT QUADRANT
          PaintOnePoint(CenterPoint->x - CurrentPoint->x, CenterPoint->y + CurrentPoint->y);
       } else
       if(Quadrant     == BOTTOM_RIGHT_QUADRANT){
          // PAINT BOTTOM-RIGHT QUADRANT
          PaintOnePoint(CenterPoint->x + CurrentPoint->x, CenterPoint->y + CurrentPoint->y);
       } else
       if(CurrentPoint->y != 0)
       {
          if(Quadrant     == TOP_RIGHT_QUADRANT){
             // PAINT TOP-RIGHT QUADRANT
             PaintOnePoint(CenterPoint->x + CurrentPoint->x, CenterPoint->y - CurrentPoint->y);
          } else
          if(Quadrant     == TOP_LEFT_QUADRANT){
             // PAINT TOP-LEFT QUADRANT
             PaintOnePoint(CenterPoint->x - CurrentPoint->x, CenterPoint->y - CurrentPoint->y);
          }
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static void FillArcPixels (LPPOINT CenterPoint, LPPOINT CurrentPoint, int Quadrant)
{

    if(CurrentPoint->x != 0)
    {
       if(Quadrant     == BOTTOM_LEFT_QUADRANT){
          BrushFill   (CenterPoint->x - CurrentPoint->x,
                       CenterPoint->y,
                       CenterPoint->x,
                       CenterPoint->y + CurrentPoint->y);
       } else
       if(Quadrant     == BOTTOM_RIGHT_QUADRANT){
          BrushFill   (CenterPoint->x,
                       CenterPoint->y,
                       CenterPoint->x + CurrentPoint->x,
                       CenterPoint->y + CurrentPoint->y);
       } else
       if(CurrentPoint->y != 0)
       {
          if(Quadrant     == TOP_RIGHT_QUADRANT){
             BrushFill   (CenterPoint->x,
                          CenterPoint->y - CurrentPoint->y + ThePdaGDI.CurrentPenSize.cy,
                          CenterPoint->x + CurrentPoint->x,
                          CenterPoint->y                  );
          } else
          if(Quadrant     == TOP_LEFT_QUADRANT){
             BrushFill   (CenterPoint->x - CurrentPoint->x,
                          CenterPoint->y - CurrentPoint->y + ThePdaGDI.CurrentPenSize.cy,
                          CenterPoint->x                  ,
                          CenterPoint->y                  );
          }
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
__forceinline static void SetPieLines(LPPOINT CenterPoint, LPPOINT CurrentPoint, int Quadrant)
{
    if(Quadrant     == BOTTOM_LEFT_QUADRANT){
       PaintLine (CenterPoint->x, CenterPoint->y, CenterPoint->x - CurrentPoint->x,  CenterPoint->y + CurrentPoint->y);
    } else
    if(Quadrant     == BOTTOM_RIGHT_QUADRANT){
       PaintLine (CenterPoint->x, CenterPoint->y, CenterPoint->x + CurrentPoint->x,  CenterPoint->y + CurrentPoint->y);
    } else
    if(Quadrant     == TOP_RIGHT_QUADRANT){
       PaintLine (CenterPoint->x, CenterPoint->y, CenterPoint->x + CurrentPoint->x,  CenterPoint->y - CurrentPoint->y);
    } else
    if(Quadrant     == TOP_LEFT_QUADRANT){
       PaintLine (CenterPoint->x, CenterPoint->y, CenterPoint->x - CurrentPoint->x,  CenterPoint->y - CurrentPoint->y);
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall PaintRoundRectangle (PPdaRect TheRect)
{DLL_THREAD_MANAGEMENT();
int     MaxThickness     = min((GetPRectWidth(TheRect) >> 1), (GetPRectHeight(TheRect) >> 1));
PdaRect LocalRect        = *TheRect;
PdaRect CornerRect       = *TheRect;
int     Roundness        = ThePdaGDI.CurrentBorderRoundness;

    if((ThePdaGDI.CurrentPenSize.cx > MaxThickness)
    || (ThePdaGDI.CurrentPenSize.cy > MaxThickness)){
       return FALSE;
    }
    if(Roundness > MaxThickness){
       return FALSE;
    } else
    if((Roundness < 2) && (Roundness > -2) ){
       Roundness = 0;
    }
    if(Roundness){

       if(ThePdaGDI.CurrentFillMode){

          BrushFill (TheRect->left   + Roundness, // FILL THE CENTER
                     TheRect->top    + Roundness,
                     TheRect->right  - Roundness,
                     TheRect->bottom - Roundness);

          BrushFill (TheRect->left             ,  // FILL THE LEFT SIDE
                     TheRect->top    + Roundness,
                     TheRect->left   + Roundness,
                     TheRect->bottom - Roundness);

          BrushFill (TheRect->right  - Roundness, // FILL THE RIGHT SIDE
                     TheRect->top    + Roundness,
                     TheRect->right,
                     TheRect->bottom - Roundness);

          BrushFill (TheRect->left   + Roundness, // FILL THE TOP SIDE
                     TheRect->top               ,
                     TheRect->right  - Roundness,
                     TheRect->top    + Roundness);

          BrushFill (TheRect->left   + Roundness, // FILL THEBOTTOM SIDE
                     TheRect->bottom - Roundness,
                     TheRect->right  - Roundness,
                     TheRect->bottom);
       }
       LocalRect           = *TheRect;
       // PAINT LEFT TOP CORNER
       CornerRect.left   = LocalRect.left;
       CornerRect.top    = LocalRect.top     + (Roundness << 1);
       CornerRect.right  = LocalRect.left    + (Roundness << 1);
       CornerRect.bottom = LocalRect.top;
       NormalizePdaRect    (&CornerRect);
       PaintArc            (&CornerRect, TOP_LEFT_QUADRANT);

       // PAINT TOP LINE
	   PaintLine (LocalRect.left + (Roundness), LocalRect.top, LocalRect.right  - (Roundness), LocalRect.top);

       // PAINT TOP RIGHT CORNER
       CornerRect.left   = LocalRect.right   - (Roundness << 1);
       CornerRect.top    = LocalRect.top;
       CornerRect.right  = LocalRect.right;
       CornerRect.bottom = LocalRect.top     + (Roundness << 1);
       NormalizePdaRect    (&CornerRect);
       PaintArc            (&CornerRect, TOP_RIGHT_QUADRANT);

       // PAINT RIGHT LINE
	   PaintLine (LocalRect.right, LocalRect.top + (Roundness), LocalRect.right, LocalRect.bottom - (Roundness));

       // PAINT BOTTOM RIGHT CORNER
       CornerRect.left   = LocalRect.right;
       CornerRect.top    = LocalRect.bottom  - (Roundness << 1);
       CornerRect.right  = LocalRect.right   - (Roundness << 1);
       CornerRect.bottom = LocalRect.bottom;
       NormalizePdaRect    (&CornerRect);
       PaintArc            (&CornerRect, BOTTOM_RIGHT_QUADRANT);

       // PAINT BOTTOM LINE
	   PaintLine (LocalRect.right - Roundness,   LocalRect.bottom, LocalRect.left + Roundness, LocalRect.bottom);

       // PAINT BOTTOM LEFT CORNER
       CornerRect.left   = LocalRect.left    + (Roundness << 1);
       CornerRect.top    = LocalRect.bottom;
       CornerRect.right  = LocalRect.left;
       CornerRect.bottom = LocalRect.bottom  - (Roundness << 1);
       NormalizePdaRect    (&CornerRect);
       PaintArc            (&CornerRect, BOTTOM_LEFT_QUADRANT);

       // PAINT LEFT LINE
	   PaintLine (LocalRect.left, LocalRect.bottom - Roundness, LocalRect.left, LocalRect.top + Roundness);
    } else {
       if(ThePdaGDI.CurrentFillMode){
          BrushFillRect(TheRect);
       }
       LocalRect           = *TheRect;
	   PaintLine (LocalRect.left,   LocalRect.top,    LocalRect.right,    LocalRect.top);     // PAINT TOP LINE
	   PaintLine (LocalRect.right,  LocalRect.top,    LocalRect.right,    LocalRect.bottom);  // PAINT RIGHT LINE
	   PaintLine (LocalRect.right,  LocalRect.bottom, LocalRect.left,     LocalRect.bottom);  // PAINT BOTTOM LINE
	   PaintLine (LocalRect.left,   LocalRect.bottom, LocalRect.left,     LocalRect.top);     // PAINT LEFT LINE
    }
	return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall PaintPdaSymbol  (PPdaRect  TheRect, BYTE ThisSymbol, BYTE SymbolLen, BYTE Style)
{
CHAR  TheSymbol[2] = {0, 0};
BYTE  SymbolWidth  = ThePdaGDI.CurrentFontSize.cx * SymbolLen;
WORD  SymbolXPos, SymbolYPos;

    if(Style & PDASTYLE_BORDER){
       SetBrushColor        (LightGreyBrushBlck);
       Paint3DRectangle     (TheRect, Style);
    }

    ThePdaGDI.CurrentFont = PDASYMBOL;
    TheSymbol[0]          = ThisSymbol;
    if(SymbolLen          > 1){
       TheSymbol[1]       = (ThisSymbol + 1);
    }
    SymbolXPos            = ((TheRect->left + (GetPRectWidth (TheRect)  >> 1)) - (SymbolWidth >> 1));
    SymbolYPos            = ((TheRect->top  + (GetPRectHeight(TheRect)  >> 1)) - (ThePdaGDI.CurrentFontSize.cy >> 1));
    PaintStringLine         (SymbolXPos, SymbolYPos, (LPCSTR)TheSymbol, SymbolLen);
    ThePdaGDI.CurrentFont = PDAFONT;

    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall Paint3DRectangle (PPdaRect TheRect, BYTE Style)
{DLL_THREAD_MANAGEMENT();
int     MaxThickness     = min((GetPRectWidth(TheRect) >> 1), (GetPRectHeight(TheRect) >> 1));
PdaRect ThisRect        = *TheRect;
BYTE    Colors [4];

    if(ThePdaGDI.Current3DMode){

       if((ThePdaGDI.CurrentPenSize.cx > MaxThickness)
       || (ThePdaGDI.CurrentPenSize.cy > MaxThickness)){
          return FALSE;
       }
       if(ThePdaGDI.CurrentFillMode){
          BrushFillRect(TheRect);
       }

       if(Style        & PDASTYLE_POPED){
            Colors [0] = WhitePoint;     Colors [1] = BlackPoint;
            Colors [2] = LightGreyPoint; Colors [3] = DarkGreyPoint;

       } else if(Style & PDASTYLE_PRESSED){
            Colors [0] = DarkGreyPoint;  Colors [1] = WhitePoint;
            Colors [2] = BlackPoint;     Colors [3] = LightGreyPoint;

       } else if(Style & PDASTYLE_SELECTED){

       }
       SetPenColor (Colors [0]);
       PaintLine (ThisRect.left,   ThisRect.top,    ThisRect.right,    ThisRect.top);     // PAINT TOP LINE
	   PaintLine (ThisRect.left,   ThisRect.bottom, ThisRect.left,     ThisRect.top);     // PAINT LEFT LINE

       SetPenColor (Colors [1]);
       PaintLine (ThisRect.right,  ThisRect.top,    ThisRect.right,    ThisRect.bottom);  // PAINT RIGHT LINE
	   PaintLine (ThisRect.right,  ThisRect.bottom, ThisRect.left,     ThisRect.bottom);  // PAINT BOTTOM LINE

       SetPenColor (Colors [2]);
	   PaintLine ((ThisRect.left   + ThePdaGDI.CurrentPenSize.cy), (ThisRect.top    + ThePdaGDI.CurrentPenSize.cx),
                  (ThisRect.right  - ThePdaGDI.CurrentPenSize.cy), (ThisRect.top    + ThePdaGDI.CurrentPenSize.cx));
	   PaintLine ((ThisRect.left   + ThePdaGDI.CurrentPenSize.cy), (ThisRect.bottom - ThePdaGDI.CurrentPenSize.cx),
                  (ThisRect.left   + ThePdaGDI.CurrentPenSize.cy), (ThisRect.top    + ThePdaGDI.CurrentPenSize.cx));

       SetPenColor (Colors [3]);
	   PaintLine ((ThisRect.right  - ThePdaGDI.CurrentPenSize.cy), (ThisRect.top    + ThePdaGDI.CurrentPenSize.cx),
                  (ThisRect.right  - ThePdaGDI.CurrentPenSize.cy), (ThisRect.bottom - ThePdaGDI.CurrentPenSize.cx));
	   PaintLine ((ThisRect.right  - ThePdaGDI.CurrentPenSize.cy), (ThisRect.bottom - ThePdaGDI.CurrentPenSize.cx),
                  (ThisRect.left   + ThePdaGDI.CurrentPenSize.cy), (ThisRect.bottom - ThePdaGDI.CurrentPenSize.cx));
    } else {
       PaintRectangle (TheRect);
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall PaintRectangle (PPdaRect TheRect)
{DLL_THREAD_MANAGEMENT();
int     MaxThickness     = min((GetPRectWidth(TheRect) >> 1), (GetPRectHeight(TheRect) >> 1));
PdaRect LocalRect        = *TheRect;

    if((ThePdaGDI.CurrentPenSize.cx > MaxThickness)
    || (ThePdaGDI.CurrentPenSize.cy > MaxThickness)){
       return FALSE;
    }
    if(ThePdaGDI.CurrentFillMode){
       BrushFillRect(TheRect);
    }
    PaintLine (LocalRect.left,   LocalRect.top,    LocalRect.right,    LocalRect.top);     // PAINT TOP LINE
	PaintLine (LocalRect.right,  LocalRect.top,    LocalRect.right,    LocalRect.bottom);  // PAINT RIGHT LINE
	PaintLine (LocalRect.right,  LocalRect.bottom, LocalRect.left,     LocalRect.bottom);  // PAINT BOTTOM LINE
	PaintLine (LocalRect.left,   LocalRect.bottom, LocalRect.left,     LocalRect.top);     // PAINT LEFT LINE
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
//        |
//        |__
//        |A |
// ----------B-----
//        |
//        |
//        |
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall PaintEllipse(PPdaRect TheRect)
{DLL_THREAD_MANAGEMENT();
POINT     CenterPoint;
POINT     CurrentPoint;
int       HalfWidth    = (GetPRectWidth(TheRect)  >> 1);
int       HalfHeight   = (GetPRectHeight(TheRect) >> 1);
long      SquareOfA    = HalfWidth * HalfWidth;
long      TwoSquareOfA = 2 * SquareOfA;
long      SquareOfB    = HalfHeight * HalfHeight;
long      TwoSquareOfB = 2 * SquareOfB;
long      Direction,     DeltaX, DeltaY;

    CenterPoint.x      = TheRect->left     + HalfWidth;
    CenterPoint.y      = TheRect->top      + HalfHeight;
    CurrentPoint.x     = 0;
    CurrentPoint.y     = HalfHeight;

    if((HalfWidth == 0 ) || (HalfHeight == 0)){
       return FALSE;
    }
    //INITIALIZE DECISION VARIABLE AND INCREMENTS
    Direction  = SquareOfB - SquareOfA * HalfHeight + SquareOfA / 4;
    DeltaX     = 0;
    DeltaY     = TwoSquareOfA * HalfHeight;

    while(DeltaX < DeltaY ) // DO WHILE SLOPE > -1
    {
       SetQuadrantPixels(&CenterPoint, &CurrentPoint);
       if (Direction     > 0){
          if(ThePdaGDI.CurrentFillMode){
             BrushFill (CenterPoint.x - CurrentPoint.x,     CenterPoint.y - CurrentPoint.y + ThePdaGDI.CurrentPenSize.cy,
                        CenterPoint.x + CurrentPoint.x,     CenterPoint.y + CurrentPoint.y - 1);
          }
          CurrentPoint.y--;
          DeltaY        -= TwoSquareOfA;
          Direction     -= DeltaY;

       }
       CurrentPoint.x++;
       DeltaX           += TwoSquareOfB;
       Direction        += SquareOfB + DeltaX;
    }
    // SLOPE <= -1
    Direction +=(3 * (SquareOfA - SquareOfB) / 2 - (DeltaX + DeltaY)) / 2;

    while(CurrentPoint.y >= 0) // DO UNTIL X_AXIS IS REACHED
    {
       SetQuadrantPixels(&CenterPoint, &CurrentPoint);

       if(Direction      < 0){
          CurrentPoint.x++;
          DeltaX        += TwoSquareOfB;
          Direction     += DeltaX;
       }
       if(ThePdaGDI.CurrentFillMode){
          BrushFill (CenterPoint.x - CurrentPoint.x, CenterPoint.y - CurrentPoint.y + ThePdaGDI.CurrentPenSize.cy,
                     CenterPoint.x + CurrentPoint.x, CenterPoint.y + CurrentPoint.y - 1);
       }
       CurrentPoint.y--;
       DeltaY           -= TwoSquareOfA;
       Direction        += SquareOfA -DeltaY;
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall PaintArc(PPdaRect TheRect, int Quadrant)
{DLL_THREAD_MANAGEMENT();
POINT     CenterPoint;
POINT     CurrentPoint;
int       HalfWidth    = (GetPRectWidth(TheRect)  >> 1);
int       HalfHeight   = (GetPRectHeight(TheRect) >> 1);
long      SquareOfA    = HalfWidth * HalfWidth;
long      TwoSquareOfA = 2 * SquareOfA;
long      SquareOfB    = HalfHeight * HalfHeight;
long      TwoSquareOfB = 2 * SquareOfB;
long      Direction,     DeltaX, DeltaY;

    CenterPoint.x      = TheRect->left     + HalfWidth;
    CenterPoint.y      = TheRect->top      + HalfHeight;
    CurrentPoint.x     = 0;
    CurrentPoint.y     = HalfHeight;

    if((HalfWidth == 0 )|| (HalfHeight == 0)){
       return FALSE;
    }
    //INITIALIZE DECISION VARIABLE AND INCREMENTS
    Direction  = SquareOfB - SquareOfA * HalfHeight + SquareOfA / 4;
    DeltaX     = 0;
    DeltaY     = TwoSquareOfA * HalfHeight;

    while(DeltaX < DeltaY ) // DO WHILE SLOPE > -1
    {
       SetArcPixels(&CenterPoint, &CurrentPoint, Quadrant);
       if (Direction     > 0){
          if(ThePdaGDI.CurrentFillMode){
             FillArcPixels (&CenterPoint, &CurrentPoint, Quadrant);
          }
          CurrentPoint.y--;
          DeltaY        -= TwoSquareOfA;
          Direction     -= DeltaY;
       }
       CurrentPoint.x++;
       DeltaX           += TwoSquareOfB;
       Direction        += SquareOfB + DeltaX;
    }
    // SLOPE <= -1
    Direction +=(3 * (SquareOfA - SquareOfB) / 2 - (DeltaX + DeltaY)) / 2;

    while(CurrentPoint.y >= 0) // DO UNTIL X_AXIS IS REACHED
    {
       if(ThePdaGDI.CurrentFillMode){
          FillArcPixels (&CenterPoint, &CurrentPoint, Quadrant);
       }
       SetArcPixels(&CenterPoint, &CurrentPoint, Quadrant);

       if(Direction      < 0){
          CurrentPoint.x++;
          DeltaX        += TwoSquareOfB;
          Direction     += DeltaX;
       }
       CurrentPoint.y--;
       DeltaY           -= TwoSquareOfA;
       Direction        += SquareOfA -DeltaY;
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall PaintPie(PPdaRect TheRect, int Quadrant)
{DLL_THREAD_MANAGEMENT();
POINT     CenterPoint,    CurrentPoint,   StartPoint;
int       HalfWidth    = (GetPRectWidth(TheRect)  >> 1);
int       HalfHeight   = (GetPRectHeight(TheRect) >> 1);
long      SquareOfA    = HalfWidth * HalfWidth;
long      TwoSquareOfA = 2 * SquareOfA;
long      SquareOfB    = HalfHeight * HalfHeight;
long      TwoSquareOfB = 2 * SquareOfB;
long      Direction,     DeltaX, DeltaY;

    CenterPoint.x      = TheRect->left     + HalfWidth;
    CenterPoint.y      = TheRect->top      + HalfHeight;
    CurrentPoint.x     = 0;
    CurrentPoint.y     = HalfHeight;

    if((HalfWidth == 0 )|| (HalfHeight == 0)){
       return FALSE;
    }
    //INITIALIZE DECISION VARIABLE AND INCREMENTS
    Direction  = SquareOfB - SquareOfA * HalfHeight + SquareOfA / 4;
    DeltaX     = 0;
    DeltaY     = TwoSquareOfA * HalfHeight;

    StartPoint = CurrentPoint;

    while(DeltaX < DeltaY ) // DO WHILE SLOPE > -1
    {
       SetArcPixels(&CenterPoint, &CurrentPoint, Quadrant);
       if (Direction     > 0){
          if(ThePdaGDI.CurrentFillMode){
             FillArcPixels (&CenterPoint, &CurrentPoint, Quadrant);
          }
          CurrentPoint.y--;
          DeltaY        -= TwoSquareOfA;
          Direction     -= DeltaY;
       }
       CurrentPoint.x++;
       DeltaX           += TwoSquareOfB;
       Direction        += SquareOfB + DeltaX;
    }
    // SLOPE <= -1
    Direction +=(3 * (SquareOfA - SquareOfB) / 2 - (DeltaX + DeltaY)) / 2;

    while(CurrentPoint.y > 0) // DO UNTIL X_AXIS IS REACHED
    {
       if(ThePdaGDI.CurrentFillMode){
          FillArcPixels (&CenterPoint, &CurrentPoint, Quadrant);
       }
       SetArcPixels(&CenterPoint, &CurrentPoint, Quadrant);

       if(Direction      < 0){
          CurrentPoint.x++;
          DeltaX        += TwoSquareOfB;
          Direction     += DeltaX;
       }
       CurrentPoint.y--;
       DeltaY           -= TwoSquareOfA;
       Direction        += SquareOfA -DeltaY;
    }
    SetArcPixels(&CenterPoint, &CurrentPoint, Quadrant);
    SetPieLines (&CenterPoint, &StartPoint, Quadrant);
    SetPieLines (&CenterPoint, &CurrentPoint, Quadrant);
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
// TEXT & FONT
///////////////////////////////////////////////////////////////////////////////////////////////////
//
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __forceinline ApplyColorStrikeThroughLine (PBYTE ColorPtr, int ThisStrLen, int ColorLenInByte)
{
int    Looper,       PixelCount = (ThisStrLen * ThePdaGDI.CurrentFontSize.cx)
                                + abs(ThePdaGDI.ItalicSlant);
PBYTE  TheColoredBuffer         = ColorPtr;
int    Thickness                = (ThePdaGDI.CurrentFontSize.cy >> 3);
       Thickness                = (Thickness ? Thickness : 1);

    TheColoredBuffer           += ((ColorLenInByte * (ThePdaGDI.CurrentFontSize.cy >> 1)) - (Thickness >> 1) );
    while(Thickness-- > 0){
       for(Looper = 0; Looper       < PixelCount; Looper++){
          TheColoredBuffer[Looper]  = ThePdaGDI.UnderLineColor;
       }
       TheColoredBuffer            += ColorLenInByte;
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __forceinline ApplyColorUnderLine (PBYTE ColorPtr, int ThisStrLen, int ColorLenInByte)
{
int    Looper,     Step,          PixelCount = (ThisStrLen * ThePdaGDI.CurrentFontSize.cx)
                                             + abs(ThePdaGDI.ItalicSlant);
PBYTE  TheColoredBuffer         = ColorPtr;
int    Thickness                = (ThePdaGDI.CurrentFontSize.cy >> 3);
       Thickness                = (Thickness ? Thickness : 1);

    TheColoredBuffer           += (ColorLenInByte * (ThePdaGDI.CurrentFontBaseLine));
    Step                        = ThePdaGDI.UnderLineDotInterval; Step = (Step ? Step : 1);

    while(Thickness-- > 0){
       for(Looper = 0; Looper          < PixelCount; Looper += Step){
          if(TheColoredBuffer[Looper] != ThePdaGDI.CurrentFontForeColor){
             TheColoredBuffer[Looper]  = ThePdaGDI.UnderLineColor;
          }
       }
       TheColoredBuffer            += ColorLenInByte;
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall ResizeTextLineToColor (PBYTE TheColorOutputButffer, PBYTE TheMonoStrBuffer, int ThisStrLen, int MonoLenInByte)
{DLL_THREAD_MANAGEMENT();
int      AddrX,   AddrY,  DeltaX,   DeltaY, ColorLineWidthInByte, TheMonoByte = 0, TheMonoPixel = 0;
long     StepX,   StepY,  TheNextMonoPixel = 0, TheNextMonoLine = 0;
BYTE     OnePixel;

    StepX            =  ((long)(DefFontWidth  << 10) / (long)ThePdaGDI.CurrentFontSize.cx);
    StepY            =  ((long)(DefFontHeight << 10) / (long)ThePdaGDI.CurrentFontSize.cy);

    ColorLineWidthInByte  = (ThePdaGDI.CurrentFontSize.cx * ThisStrLen);
    DeltaY                =  ThePdaGDI.CurrentFontSize.cy * ColorLineWidthInByte;
    DeltaX                =  ColorLineWidthInByte;
    ///////////////////////////////////////////////////////////////////////////////////////////////
    for(AddrY = 0; AddrY < DeltaY; AddrY += ColorLineWidthInByte){

       for(AddrX = 0; AddrX < DeltaX; AddrX++){

          OnePixel           = TheMonoStrBuffer[TheMonoByte];
          if(((OnePixel    <<= (TheMonoPixel)) & 0x80))
          {
             TheColorOutputButffer[AddrX + AddrY] = ThePdaGDI.CurrentFontForeColor;
          }
          // RECALC NEW POSITION FOR INPUT PIXEL
          TheNextMonoPixel        += StepX;
          TheMonoPixel             = ((TheNextMonoPixel >> 10)  & 7);
          TheMonoByte              = ((TheNextMonoPixel >> 10) >> 3);
       }
       TheNextMonoLine            += StepY;
       while((TheNextMonoLine     >> 10)){
          TheMonoStrBuffer        += MonoLenInByte;
          TheNextMonoLine         -= (1 << 10);
       }
       TheNextMonoPixel            = 0;
       TheMonoByte                 = 0;
       TheMonoPixel                = 0;
    }
    ///////////////////////////////////////////////////////////////////////////////////////////////
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
void MonoShiftLineRight (PBYTE MonoPtr, int MonoLenInByte, WORD LineShift)
{
PBYTE        CurrSrc,       CurrDst;
int          ByteShift   = (LineShift >> 3);
int          BitShift    = (LineShift  & 7);
int          LoopCount   = (MonoLenInByte - 1) - ByteShift;
WORD         TempBytes;

    CurrSrc              = (MonoPtr   + (MonoLenInByte - 1) - ByteShift);
    CurrDst              = (MonoPtr   + (MonoLenInByte - 1));

    // TOP SPEED FULL BLOW
    while(LoopCount--){
       TempBytes         = ((*CurrSrc-- ));
       TempBytes        |= ((*CurrSrc ) << 8);
       TempBytes       >>= BitShift;
       *CurrDst--        = TempBytes & 0xFF;
    }
    // FILL THE REST... CONDITIONNALLY
    while(CurrDst       >= MonoPtr){
       if(CurrSrc       >= MonoPtr){
          TempBytes      = ((*CurrSrc-- ));
       } else {
          TempBytes      = 0;
       }
       if(CurrSrc       >= MonoPtr){
          TempBytes     |= ((*CurrSrc ) << 8);
       }
       TempBytes       >>= BitShift;
       *CurrDst--        = TempBytes & 0xFF;
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall ApplyMonoItalicStyle (PBYTE MonoPtr, int ThisStrLen, int MonoLenInByte)
{DLL_THREAD_MANAGEMENT();
int      Slantproperty           = abs(ThePdaGDI.ItalicSlant);
long     StartX,     CurrX,      StepX,      DeltaX;
long     StartY,     CurrY,      StepY,      DeltaY;
int      LineShift;

    StartX        = 0; CurrX  = 0;
    DeltaX        = (ThisStrLen            * DefFontWidth);
    StepX         = (Slantproperty << 10) / DefFontHeight;

    if(ThePdaGDI.ItalicSlant < 0) {
       StartY     = 0;
       DeltaY     = ((DefFontHeight - 2) * MonoLenInByte);
       StepY      = MonoLenInByte;

       for(CurrY = StartY; CurrY <  DeltaY; CurrY += StepY)
       {
          LineShift     = CurrX >> 10;
          if(LineShift >= 1){
             MonoShiftLineRight (&MonoPtr[CurrY], MonoLenInByte, LineShift);
          }
          CurrX        += StepX;
       }
    } else {
       StartY     = ((DefFontHeight - 1) * MonoLenInByte);
       DeltaY     = 0;
       StepY      = -MonoLenInByte;

       for(CurrY = StartY; CurrY >  DeltaY; CurrY += StepY)
       {
          LineShift     = CurrX >> 10;
          if(LineShift >= 1){
             MonoShiftLineRight (&MonoPtr[CurrY], MonoLenInByte, LineShift);
          }
          CurrX        += StepX;
       }
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void __stdcall PrepareSingleMonoLine (PBYTE MonoPtr, LPCSTR TheLineText, int ThisStrLen, int MonoLenInByte)
{DLL_THREAD_MANAGEMENT();
int   ThisChar = 0, LoopForFontChar, LoopForLine;
int   ThisCharArray;

    for(LoopForLine = 0; LoopForLine < ThisStrLen; LoopForLine++)
    {
       if(( TheLineText[LoopForLine] >= MINFONTCHAR)
       && (TheLineText[LoopForLine] <= MAXFONTCHAR)){
          ThisCharArray         = ((BYTE)TheLineText[LoopForLine]) * DefFontHeight;
          ThisChar              = 0; // ONLY IN RECTANGULAR MEM

          for(LoopForFontChar   = 0; LoopForFontChar < DefFontHeight; LoopForFontChar ++)
          {
//             MonoPtr[ThisChar]  = PDAFONT [ ThisCharArray ];
             MonoPtr[ThisChar]  = ThePdaGDI.CurrentFont [ ThisCharArray ];

             ThisCharArray     += 1;
             ThisChar          += MonoLenInByte; // 1 BYTE PER CHAR // ONLY IN RECTANGULAR MEM
          }
          MonoPtr              += 1;
       }
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall PaintStringLine(long DstX, long DstY, LPCSTR TheTextLine, int ThisStrLen)
{DLL_THREAD_MANAGEMENT();
PBYTE    MonoPtr         = &UncompressTempBuffer[0];
PBYTE    ColorPtr        = TempImageBuffer;
int      SlantProxy      = (abs(ThePdaGDI.ItalicSlant) + 7) & ~7;
int      ProxyStringLen  = ThisStrLen + (SlantProxy / 8);

int      MonoLenInByte   = ProxyStringLen   * (DefFontWidth / 8);
int      ColorLenInByte  = ProxyStringLen   * ThePdaGDI.CurrentFontSize.cx;
int      ColorLenInPixel = ProxyStringLen   * ThePdaGDI.CurrentFontSize.cx;
int      TheBufferLen    = ColorLenInByte   * ThePdaGDI.CurrentFontSize.cy;
PixColor OldMaskColor;
int      OldMaskMode;

    // CORRECT LINE NOT TO OVERRIDE VSREEN BOUDARY
    if(ColorLenInPixel   > ThePdaGDI.SurfaceWidth){
       // RECALC EVERYTHING BASE ON A NEW TRUNCANATED STRING...

       ThisStrLen        = (ThePdaGDI.SurfaceWidth - SlantProxy) / ThePdaGDI.CurrentFontSize.cx;
       ProxyStringLen    = ThisStrLen + (SlantProxy / 8);
       MonoLenInByte     = ProxyStringLen   * (DefFontWidth / 8);
       ColorLenInByte    = ProxyStringLen   * ThePdaGDI.CurrentFontSize.cx;
       ColorLenInPixel   = ProxyStringLen   * ThePdaGDI.CurrentFontSize.cx;
       TheBufferLen      = ColorLenInByte   * ThePdaGDI.CurrentFontSize.cy;
    }
    if(TheBufferLen      > sizeof(TempImageBuffer)){
       return FALSE;
    }
    FillMemory(MonoPtr,   TheBufferLen, 0);
    FillMemory(ColorPtr,  TheBufferLen, ThePdaGDI.CurrentFontBackColor);
    PrepareSingleMonoLine (MonoPtr, TheTextLine, ThisStrLen, MonoLenInByte);

    if(ThePdaGDI.ItalicSlant){
       ApplyMonoItalicStyle (MonoPtr, ThisStrLen, MonoLenInByte);
    }
    ResizeTextLineToColor   (ColorPtr, MonoPtr, ProxyStringLen, MonoLenInByte);

    if((ThePdaGDI.CurrentUnderLineMode) && (ThePdaGDI.CurrentFontBaseLine)) {
       ApplyColorUnderLine (ColorPtr, ThisStrLen, ColorLenInByte);
    }
    if((ThePdaGDI.CurrentStrikeThroughMode)) {
       ApplyColorStrikeThroughLine (ColorPtr, ThisStrLen, ColorLenInByte);
    }
    if(ThePdaGDI.CurrentFontBackMode == PDAFONT_TRANSPARENT){

       OldMaskMode                    = ThePdaGDI.CurrentMaskMode;
       OldMaskColor                   = ThePdaGDI.CurrentMaskColor;
       ThePdaGDI.CurrentMaskMode      = (ROP_MASKSRC);
       ThePdaGDI.CurrentMaskColor     = (ThePdaGDI.CurrentFontBackColor);
    }
    BitblitColorData (DstX, DstY, ColorLenInByte, ThePdaGDI.CurrentFontSize.cy, ColorPtr);

    if(ThePdaGDI.CurrentFontBackMode == PDAFONT_TRANSPARENT){
       ThePdaGDI.CurrentMaskMode      = (OldMaskMode);
       ThePdaGDI.CurrentMaskColor     = (OldMaskColor);
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
int GetCalcTextRect (PPdaRect TheRect, LPCSTR TheString, int ThisStrLen, int MaxRowLen, int BreakOnWords)
{
int Looper, CurrWidth     = abs(ThePdaGDI.ItalicSlant),
            MaxWidth      = abs(ThePdaGDI.ItalicSlant),
            MaxRowWidth   = (MaxRowLen * ThePdaGDI.CurrentFontSize.cx) + abs(ThePdaGDI.ItalicSlant),
            CurrLineLen   = 0,
            Currheight    = ThePdaGDI.CurrentFontSize.cy,
            CurrLineCount = 1,
            LastWordBreak = 0;

    for(Looper = 0; Looper < ThisStrLen; Looper++){
       switch(TheString[Looper]){
       case 0:
            goto BreakRectNow;
       case '\r':
            break;
       case '\n':
       BreakLineNow:
            CurrLineCount += 1;
            Currheight    += ThePdaGDI.CurrentFontSize.cy;
            MaxWidth       = min(max(MaxWidth, CurrWidth), MaxRowWidth);
            CurrLineLen    = 0;
            CurrWidth      = abs(ThePdaGDI.ItalicSlant);
            LastWordBreak  = 0;
            break;
       case '\t':
            // COMPUTE THE NEXT TABSTOP RELATIVE TO THE CURRENT POS IN LINE...
            if(ThePdaGDI.CurrTabStep){
               int RelativeTabPos       = (CurrLineLen / ThePdaGDI.CurrTabStep * ThePdaGDI.CurrTabStep)
                                        + ThePdaGDI.CurrTabStep;
               int RelativePos          = RelativeTabPos - CurrLineLen;

               CurrWidth               += (RelativePos * ThePdaGDI.CurrentFontSize.cx);
               CurrLineLen             += RelativePos;
               LastWordBreak            = Looper + 1;
               goto CheckMaxRowLen;
            }
       default:
            if((TheString[Looper] >= MINFONTCHAR)
            && (TheString[Looper] <= MAXFONTCHAR)){
               CurrWidth          += ThePdaGDI.CurrentFontSize.cx;
               CurrLineLen        += 1;
               if((BreakOnWords)  && ((BYTE)TheString[Looper] == ' ')){
                  LastWordBreak    = Looper + 1;
               }
       CheckMaxRowLen:
               if(CurrLineLen     >= MaxRowLen){
                  if(LastWordBreak){
                     Looper        = LastWordBreak;
                  }
                  goto BreakLineNow;
               }
            }
            break;
       }
    }
    BreakRectNow:
    MaxWidth         = min(max(MaxWidth, CurrWidth), MaxRowWidth);
    TheRect->right  += (MaxWidth);
    TheRect->bottom += Currheight;
    return CurrLineCount;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
int GetTextRowLen (LPCSTR TheString, int ThisStrLen, int MaxRowLen, int BreakOnWords)
{
int Looper, CurrLineLen   = 0,
            LastWordBreak = 0;

    for(Looper = 0; Looper < ThisStrLen; Looper++){
       switch(TheString[Looper]){
       case 0:
            goto BreakLineNow;
       case '\r':
            break;
       case '\n':
            goto BreakLineNow;
       case '\t':
            // COMPUTE THE NEXT TABSTOP RELATIVE TO THE CURRENT POS IN LINE...
            if(ThePdaGDI.CurrTabStep){
               int RelativeTabPos       = (CurrLineLen / ThePdaGDI.CurrTabStep * ThePdaGDI.CurrTabStep)
                                        + ThePdaGDI.CurrTabStep;
               int RelativePos          = RelativeTabPos - CurrLineLen;

               CurrLineLen             += RelativePos;
               LastWordBreak            = Looper + 1;
               goto CheckMaxRowLen;
               break;
            }
       default:
            if((TheString[Looper] >= MINFONTCHAR)
            && (TheString[Looper] <= MAXFONTCHAR)){
               CurrLineLen        += 1;
               if((BreakOnWords)  && ((BYTE)TheString[Looper] == ' ')){
                  LastWordBreak    = Looper + 1;
               }
       CheckMaxRowLen:
               if(CurrLineLen     >= MaxRowLen){
                  if(LastWordBreak){
                     CurrLineLen   = LastWordBreak;
                  }
                  goto BreakLineNow;
               }
            }
            break;
       }
    }
BreakLineNow:
    return (CurrLineLen);
}
///////////////////////////////////////////////////////////////////////////////////////////////////
// TO DO...
// N.B. TABSTOP AND EXPANDTABS IS NOT IMPLEMENTED YET...
// NEITHER IS USEPREFIX
// IF THE LAST CHAR ON A ROW IS A SPACE OR TAB IT SHOULD BE TRIMED..
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL __stdcall PdaDrawText (LPCSTR TheString, int ThisStrLen, PPdaRect TheRect, int Options)
{DLL_THREAD_MANAGEMENT();
int  UsePrefix     = ((Options & DT_NOPREFIX) == 0);
int  ExpandTabs    = ((Options & DT_EXPANDTABS));
int  TabStep       = ((Options & DT_TABSTOP) ? (Options >> 8) : (ExpandTabs ? 4 : 0));
int  BreakOnWords  = ((Options & DT_WORDBREAK));
int  UseSingleLine = ((Options & DT_SINGLELINE));
///////////////////////////////////////////////////////////////////////////////////////////////////
int     OldTabStep    = ThePdaGDI.CurrTabStep;
PdaRect OldClipRect   = ThePdaGDI.ClipRectangle;
PdaRect CalcTextRect  = {0,0,0,0};
PdaRect NewClipRect   = {0,0,0,0};
int     RectWidth,      RectHeight,  RectCenter,  RectMiddle, PureWidth,  AlignX,  AlignY;
int     CalcWidth,      CalcHeight;
int     Looper, RowLen, RowX, RowY,  CurrRow = 0, RowCount,   MaxRowLen,  MaxRowCount;

    NormalizePdaRect(TheRect);
    if((IsAbNormalPdaRect(TheRect))){
       return FALSE;
    }
    NewClipRect   = *TheRect;
    // CLIP THE NEW CLIP AREA RECT WITHIN THE CONFINE OF THE CURRENT CLIPPED AREA...
    ClipPdaRect(&NewClipRect, &ThePdaGDI.ClipRectangle);
    // SET GDI TO CURRENT NEED
    ThePdaGDI.CurrTabStep     = TabStep;
    SetClipRect(&NewClipRect);

    if(ThePdaGDI.CurrentFontBackMode == PDAFONT_OPAQUE){
       ColorFillRect(TheRect, ThePdaGDI.CurrentFontBackColor);
    }
    RectWidth     = GetPRectWidth(TheRect);
    RectHeight    = GetPRectHeight(TheRect);
    RectCenter    = RectWidth  >> 1;
    RectMiddle    = RectHeight >> 1;
    PureWidth     = (RectWidth  - abs(ThePdaGDI.ItalicSlant)); PureWidth = ((PureWidth > 0) ? PureWidth : 0 );
    MaxRowLen     = (PureWidth  / ThePdaGDI.CurrentFontSize.cx) + 1;
    MaxRowCount   = (RectHeight / ThePdaGDI.CurrentFontSize.cy) + 1;

    switch((Options & ((DT_LEFT | DT_CENTER | DT_RIGHT | DT_TOP | DT_VCENTER | DT_BOTTOM)))){
    case (DT_LEFT    | DT_TOP)        : AlignX = 0;            AlignY = 0; break;
    case (DT_CENTER  | DT_TOP)        : AlignX = RectCenter;   AlignY = 0; break;
    case (DT_RIGHT   | DT_TOP)        : AlignX = RectWidth;    AlignY = 0; break;

    case (DT_LEFT    | DT_VCENTER)    : AlignX = 0;            AlignY = RectMiddle; break;
    case (DT_CENTER  | DT_VCENTER)    : AlignX = RectCenter;   AlignY = RectMiddle; break;
    case (DT_RIGHT   | DT_VCENTER)    : AlignX = RectWidth;    AlignY = RectMiddle; break;

    case (DT_LEFT    | DT_BOTTOM)     : AlignX = 0;            AlignY = RectHeight; break;
    case (DT_CENTER  | DT_BOTTOM)     : AlignX = RectCenter;   AlignY = RectHeight; break;
    case (DT_RIGHT   | DT_BOTTOM)     : AlignX = RectWidth;    AlignY = RectHeight; break;
    }
    RowCount = GetCalcTextRect (&CalcTextRect, TheString, ThisStrLen, MaxRowLen, BreakOnWords);
    RowCount = (UseSingleLine ? 1 : min(RowCount, MaxRowCount));

    // FOR Y ALIGNMENT WE ONLY NEED TO SET THE FIRST ROW THE OTHER WILL FOLLOW...
    ///////////////////////////////////////////////////////////////////////////////////////////////
    if((Options  & DT_TOP)){
       RowY      = 0;
    } else
    if((Options  & DT_VCENTER)){
       RowY      = (AlignY  - (RowCount * ThePdaGDI.CurrentFontSize.cy >> 1)); RowY = ((RowY < 0) ? 0 : RowY);
    } else {    // DT_BOTTOM
       RowY      = (AlignY  - (RowCount * ThePdaGDI.CurrentFontSize.cy));      RowY = ((RowY < 0) ? 0 : RowY);
    }
    RowY    += TheRect->top;

    // PROCEED ROW BY ROW...
    ///////////////////////////////////////////////////////////////////////////////////////////////
    for(Looper  = 0; Looper <= RowCount; Looper++){

       RowLen   = GetTextRowLen   (&TheString[CurrRow], (ThisStrLen - CurrRow), MaxRowLen, BreakOnWords);
       // SET ALIGNEMENT FOR THIS ROW
       if((Options  & DT_LEFT)){
          RowX      = 0;
       } else
       if((Options  & DT_CENTER)){
          RowX      = (AlignX  - (RowLen * ThePdaGDI.CurrentFontSize.cx >> 1)); RowX = ((RowX < 0) ? 0 : RowX);
       } else {    // DT_RIGHT
          RowX      = (AlignX  - (RowLen * ThePdaGDI.CurrentFontSize.cx));      RowX = ((RowX < 0) ? 0 : RowX);
       }
       RowX    += TheRect->left;

       PaintStringLine(RowX, RowY, &TheString[CurrRow],  RowLen);

       CurrRow += RowLen;
       RowY    += ThePdaGDI.CurrentFontSize.cy;
    }
    ///////////////////////////////////////////////////////////////////////////////////////////////

    // RESET GDI
    ThePdaGDI.CurrTabStep     = TabStep;
    SetClipRect(&OldClipRect);
    return TRUE;
}


///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
// BITMAP
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL   __stdcall PdaLoadBitmap  (long X, long Y, LPROMBYTE ImageData)
{DLL_THREAD_MANAGEMENT();
PPdaBitmapRes ThisImageFormat = (PPdaBitmapRes)ImageData;
UINT          WidthInByte,      UncompressedSize, InputSize = ThisImageFormat->BlockSize;
CString       Info;
PBYTE         SrcBuffer       = (PBYTE)&ImageData[sizeof(PdaBitmapRes)];
BOOL          IsTransparent   = FALSE;

    switch(ThisImageFormat->BitPerPixel){
    case 1:  WidthInByte  = ((ThisImageFormat->Width + 15) & ~15) / 8; break;
    case 4:  WidthInByte  = ((ThisImageFormat->Width +  3) & ~ 3) / 2; break;
    case 8:  WidthInByte  = ((ThisImageFormat->Width +  1) & ~ 1);     break;
    default: WidthInByte  = 0; // UNSUPPORTED
             break;
    }
    if(WidthInByte       == 0){
       return FALSE;
    }
    UncompressedSize      = WidthInByte * ThisImageFormat->Height;
/*
    InitUnZipInfo (X, Y, ThisImageFormat->Width, ThisImageFormat->Height, ThisImageFormat->BitPerPixel, InputSize,
                   1, 0, ThePdaGDI.SurfacePtr, SrcBuffer);
*/
    InitUnZipFrame (X, Y, ThisImageFormat->Width, ThisImageFormat->Height, ThisImageFormat->BitPerPixel, FALSE,
                    InputSize, 1, 0, ThePdaGDI.SurfacePtr, SrcBuffer);

    switch(ThisImageFormat->Compression & 0x7F){
    case PD_COMPRESS_ZIP:
         if(UnzipImageFrame () != Z_OK){
    	    EchoImageError(-3, InputSize);
            return FALSE;
	     }
         break;
    case PD_COMPRESS_NONE:
         if((UncompressedSize > InputSize) || (PaintUnCompresedFrame () != Z_OK)){
            EchoImageError(0,  InputSize);
            return FALSE;
         }
         break;
    default:
         EchoImageError(0,  InputSize);
         return FALSE;
    }
    RepaintIPalm();
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
// ************************************************************************************************
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
// PDA RECT SUPPORT
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  __stdcall ClipPdaRectangle  (int *StartX, int *StartY, int *DeltaX, int *DeltaY, PPdaRect ThisClipRect)
{
PdaRect ThisRect;

    ThisRect.left  = *StartX;    ThisRect.right   = *DeltaX;
    ThisRect.top   = *StartY;    ThisRect.bottom  = *DeltaY;
    if(IsEmptyPdaRect(&ThisRect)){
       return FALSE;
    }
    if(IsIntersectPdaRect(&ThisRect, ThisClipRect) ){

       if(ThisRect.left     < ThisClipRect->left){
          *StartX           = ThisClipRect->left;
       } else
       if(ThisRect.left     > ThisClipRect->right){
          *StartX           = ThisClipRect->right;
       }
       if(ThisRect.right    > ThisClipRect->right){
          *DeltaX           = ThisClipRect->right;
       } else
       if(ThisRect.right    < ThisClipRect->left){
          *DeltaX           = ThisClipRect->left;
       }
       if(ThisRect.top      < ThisClipRect->top){
          *StartY           = ThisClipRect->top;
       } else
       if(ThisRect.top      > ThisClipRect->bottom){
          *StartY           = ThisClipRect->bottom;
       }
       if(ThisRect.bottom   > ThisClipRect->bottom){
          *DeltaY           = ThisClipRect->bottom;
       } else
       if(ThisRect.bottom   < ThisClipRect->top){
          *DeltaY           = ThisClipRect->top;
       }
       return TRUE;
    }
    return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  __stdcall IsIntersectPdaRect(PPdaRect ThisRect, PPdaRect ThatRect)
{
    if((ThisRect->left  > ThatRect->right)  || (ThisRect->right  < ThatRect->left)) {
       return FALSE;
    }
    if((ThisRect->top   > ThatRect->bottom) || (ThisRect->bottom < ThatRect->top)) {
       return FALSE;
    }
    return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
void  __stdcall NormalizePdaRect(PPdaRect ThisRect)
{
int TempPos;

    if(ThisRect->left     > ThisRect->right){
       TempPos            = ThisRect->left;
       ThisRect->left     = ThisRect->right;
       ThisRect->right    = TempPos;
    }
	if(ThisRect->top      > ThisRect->bottom){
		TempPos           = ThisRect->top;
		ThisRect->top     = ThisRect->bottom;
		ThisRect->bottom  = TempPos;
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////
BOOL  __stdcall ClipPdaRect (PPdaRect ThisRect, PPdaRect ThisClipRect)
{
    if(IsEmptyPdaRect(ThisRect)){
       return FALSE;
    }
    if(IsIntersectPdaRect     (ThisRect, ThisClipRect) ){

       if(ThisRect->left    < ThisClipRect->left){
          ThisRect->left    = ThisClipRect->left;
       } else
       if(ThisRect->left    > ThisClipRect->right){
          ThisRect->left    = ThisClipRect->right;
       }
       if(ThisRect->right   < ThisClipRect->left){
          ThisRect->right   = ThisClipRect->left;
       } else
       if(ThisRect->right   > ThisClipRect->right){
          ThisRect->right   = ThisClipRect->right;
       }
       if(ThisRect->top     < ThisClipRect->top){
          ThisRect->top     = ThisClipRect->top;
       } else
       if(ThisRect->top     > ThisClipRect->bottom){
          ThisRect->top     = ThisClipRect->bottom;
       }
       if(ThisRect->bottom  < ThisClipRect->top){
          ThisRect->bottom  = ThisClipRect->top;
       } else
       if(ThisRect->bottom  > ThisClipRect->bottom){
          ThisRect->bottom  = ThisClipRect->bottom;
       }
       return TRUE;
    }
    return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////
#if 0
ROMBYTE PDAFONT [] = { // Wednesday, March 05, 2003, 11:21:39:  ; Binary Font Table Generated.
        0x00, 0x50, 0x70, 0x70, 0x50, 0x28, 0x28, 0x38, 0x10, 0x10, 0x18, 0x08, 0x08, 0x0C, 0x00, 0x00, // Asc: 0
        0x00, 0x7E, 0x7C, 0x78, 0x7C, 0x6E, 0x46, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 1
        0x00, 0x7E, 0x3E, 0x1E, 0x3E, 0x76, 0x62, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 2
        0x00, 0x00, 0x00, 0x00, 0x7E, 0xC3, 0xA5, 0x99, 0x99, 0xA5, 0xC3, 0x7E, 0x00, 0x00, 0x00, 0x00, // Asc: 3
        0x00, 0x18, 0x3C, 0x7E, 0x7E, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 4
        0x00, 0x7E, 0x7C, 0x78, 0x7C, 0x6E, 0x46, 0x00, 0x00, 0x66, 0x24, 0x18, 0x18, 0x24, 0x66, 0x00, // Asc: 5
        0x00, 0x7E, 0x3E, 0x1E, 0x3E, 0x76, 0x62, 0x00, 0x00, 0x66, 0x24, 0x18, 0x18, 0x24, 0x66, 0x00, // Asc: 6
        0x00, 0x00, 0x18, 0x3C, 0x3C, 0x3C, 0x3C, 0x3C, 0x7E, 0xFF, 0x10, 0x38, 0x10, 0x00, 0x00, 0x00, // Asc: 7
        0x00, 0x70, 0x50, 0x70, 0x50, 0x70, 0x00, 0x1C, 0x10, 0x1C, 0x04, 0x1C, 0x00, 0x00, 0x00, 0x00, // Asc: 8
        0x00, 0x40, 0x40, 0x40, 0x48, 0x4C, 0x7E, 0x7E, 0x4C, 0x48, 0x40, 0x40, 0x40, 0x00, 0x00, 0x00, // Asc: 9
        0x00, 0x40, 0x40, 0x40, 0x40, 0x70, 0x00, 0x1C, 0x10, 0x1C, 0x10, 0x10, 0x10, 0x00, 0x00, 0x00, // Asc: 10
        0x00, 0x50, 0x50, 0x70, 0x50, 0x50, 0x00, 0x70, 0x50, 0x70, 0x00, 0x70, 0x70, 0x50, 0x00, 0x00, // Asc: 11
        0x00, 0x70, 0x40, 0x70, 0x40, 0x40, 0x40, 0x1C, 0x10, 0x1C, 0x10, 0x10, 0x10, 0x00, 0x00, 0x00, // Asc: 12
        0x00, 0x00, 0x00, 0x06, 0x06, 0x06, 0x16, 0x36, 0x76, 0xFE, 0x70, 0x30, 0x10, 0x00, 0x00, 0x00, // Asc: 13
        0x00, 0x08, 0x18, 0x38, 0x7F, 0xFF, 0x7F, 0x3B, 0x1B, 0x0B, 0x03, 0x03, 0xFF, 0xFF, 0x00, 0x00, // Asc: 14
        0x00, 0x02, 0x02, 0x02, 0x0A, 0x1A, 0x3E, 0x3E, 0x1A, 0x0A, 0x02, 0x02, 0x02, 0x00, 0x00, 0x00, // Asc: 15
        0x00, 0x18, 0x3C, 0x7E, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00, 0xFF, 0xAB, 0xD5, 0xAB, 0xFF, 0x00, // Asc: 16
        0x00, 0xFA, 0x92, 0x92, 0xD3, 0x00, 0x7C, 0x7C, 0x0C, 0x0C, 0x0C, 0x3F, 0x1E, 0x0C, 0x00, 0x00, // Asc: 17
        0x00, 0xFF, 0x00, 0x56, 0x76, 0x76, 0x00, 0xFF, 0x00, 0x18, 0x3C, 0x7E, 0x18, 0x18, 0x18, 0x00, // Asc: 18
        0x00, 0xFF, 0x81, 0xBD, 0x7E, 0x3C, 0x18, 0x18, 0x18, 0x18, 0x24, 0x4A, 0xB5, 0xFF, 0xFF, 0x00, // Asc: 19
        0x00, 0x18, 0x3C, 0x7E, 0x18, 0xFF, 0xFF, 0x18, 0xFF, 0xC5, 0xAB, 0xD5, 0xAB, 0xFF, 0x00, 0x00, // Asc: 20
        0x00, 0x02, 0x02, 0x02, 0x0A, 0x1A, 0x3E, 0x3E, 0x1A, 0x0A, 0x02, 0x02, 0x02, 0x00, 0x00, 0x00, // Asc: 21
        0xFC, 0x98, 0x98, 0xF8, 0xF8, 0x98, 0x98, 0xF8, 0xF8, 0x98, 0x98, 0xF8, 0xF8, 0x98, 0x9C, 0xFF, // Asc: 22
        0x3F, 0x19, 0x19, 0x1F, 0x1F, 0x19, 0x19, 0x1F, 0x1F, 0x19, 0x19, 0x1F, 0x1F, 0x19, 0x39, 0xFF, // Asc: 23
        0x00, 0x3C, 0x3C, 0x42, 0x66, 0x66, 0xFF, 0x83, 0xC7, 0x83, 0xC7, 0x83, 0xFF, 0x00, 0x00, 0x00, // Asc: 24
        0x00, 0x3C, 0x5A, 0x81, 0xC7, 0x89, 0x99, 0xDB, 0x89, 0x91, 0xE3, 0x81, 0x5A, 0x3C, 0x00, 0x00, // Asc: 25
        0x00, 0x00, 0x00, 0x18, 0x3C, 0x5A, 0x5A, 0x66, 0x66, 0x5A, 0x5A, 0x3C, 0x18, 0x00, 0x00, 0x00, // Asc: 26
        0x00, 0x70, 0x40, 0x70, 0x40, 0x70, 0x1C, 0x10, 0x1C, 0x04, 0x1C, 0x0E, 0x08, 0x08, 0x0E, 0x00, // Asc: 27
        0x00, 0x00, 0x30, 0x38, 0x2C, 0xE6, 0x83, 0x83, 0xE6, 0x2C, 0x38, 0x30, 0x00, 0x00, 0x00, 0x00, // Asc: 28
        0x00, 0x00, 0x0C, 0x1C, 0x34, 0x67, 0xC1, 0xC1, 0x67, 0x34, 0x1C, 0x0C, 0x00, 0x00, 0x00, 0x00, // Asc: 29
        0x00, 0x00, 0x00, 0x18, 0x3C, 0x66, 0xC3, 0x81, 0xE7, 0x24, 0x24, 0x24, 0x3C, 0x00, 0x00, 0x00, // Asc: 30
        0x00, 0x00, 0x00, 0x3C, 0x24, 0x24, 0x24, 0xE7, 0x81, 0xC3, 0x66, 0x3C, 0x18, 0x00, 0x00, 0x00, // Asc: 31
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Char ' '
        0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x18, 0x18, 0x00, 0x00, 0x00, // Char '!'
        0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Char '"'
        0x00, 0x00, 0x66, 0x66, 0xFF, 0xFF, 0x66, 0x66, 0xFF, 0xFF, 0x66, 0x66, 0x00, 0x00, 0x00, 0x00, // Char '#'
        0x18, 0x18, 0x3E, 0x7E, 0x60, 0x60, 0x7C, 0x3E, 0x06, 0x06, 0x7E, 0x7C, 0x18, 0x18, 0x00, 0x00, // Char '$'
        0x00, 0x00, 0x66, 0x66, 0x6C, 0x0C, 0x18, 0x18, 0x30, 0x36, 0x66, 0x66, 0x00, 0x00, 0x00, 0x00, // Char '%'
        0x38, 0x7C, 0x6C, 0x6C, 0x38, 0x38, 0x70, 0x70, 0xDE, 0xDE, 0xCC, 0xCC, 0xFE, 0x76, 0x00, 0x00, // Char '&'
        0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Char '''
        0x00, 0x0C, 0x18, 0x38, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x18, 0x18, 0x0C, 0x00, 0x00, 0x00, // Char '('
        0x00, 0x30, 0x18, 0x1C, 0x0C, 0x0C, 0x0C, 0x0C, 0x0C, 0x0C, 0x18, 0x18, 0x30, 0x00, 0x00, 0x00, // Char ')'
        0x00, 0x00, 0x66, 0x66, 0x3C, 0x3C, 0xFF, 0xFF, 0x3C, 0x3C, 0x66, 0x66, 0x00, 0x00, 0x00, 0x00, // Char '*'
        0x00, 0x00, 0x00, 0x18, 0x18, 0x18, 0x7E, 0x7E, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, // Char '+'
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0C, 0x0C, 0x0C, 0x18, 0x10, // Char ','
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7E, 0x7E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Char '-'
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, // Char '.'
        0x00, 0x06, 0x06, 0x06, 0x0C, 0x0C, 0x18, 0x18, 0x30, 0x30, 0x60, 0x60, 0x60, 0x00, 0x00, 0x00, // Char '/'
        0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x6E, 0x76, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char '0'
        0x00, 0x18, 0x18, 0x38, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x3C, 0x3C, 0x00, 0x00, 0x00, // Char '1'
        0x00, 0x3C, 0x7E, 0x66, 0x06, 0x0E, 0x1C, 0x38, 0x70, 0x60, 0x60, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Char '2'
        0x00, 0x3C, 0x7E, 0x66, 0x06, 0x06, 0x1C, 0x1C, 0x06, 0x06, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char '3'
        0x00, 0x0C, 0x0C, 0xCC, 0xCC, 0xCC, 0xCC, 0xFE, 0x7E, 0x0C, 0x0C, 0x0C, 0x0C, 0x00, 0x00, 0x00, // Char '4'
        0x00, 0x7E, 0x7E, 0x60, 0x60, 0x7C, 0x7E, 0x06, 0x06, 0x06, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char '5'
        0x00, 0x3C, 0x7E, 0x66, 0x60, 0x7C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char '6'
        0x00, 0x7E, 0x7E, 0x06, 0x06, 0x0C, 0x0C, 0x18, 0x18, 0x30, 0x30, 0x30, 0x30, 0x00, 0x00, 0x00, // Char '7'
        0x00, 0x3C, 0x7E, 0x66, 0x66, 0x3C, 0x3C, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char '8'
        0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x7E, 0x3E, 0x06, 0x06, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char '9'
        0x00, 0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, // Char ':'
        0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x30, 0x20, // Char ';'
        0x00, 0x00, 0x00, 0x07, 0x0E, 0x1C, 0x38, 0x70, 0x38, 0x1C, 0x0E, 0x07, 0x00, 0x00, 0x00, 0x00, // Char '<'
        0x00, 0x00, 0x00, 0x00, 0x7E, 0x7E, 0x00, 0x00, 0x7E, 0x7E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Char '='
        0x00, 0x00, 0x00, 0xE0, 0x70, 0x38, 0x1C, 0x0E, 0x1C, 0x38, 0x70, 0xE0, 0x00, 0x00, 0x00, 0x00, // Char '>'
        0x00, 0x00, 0x3C, 0x7E, 0x66, 0x06, 0x0C, 0x0C, 0x18, 0x18, 0x00, 0x18, 0x18, 0x00, 0x00, 0x00, // Char '?'
        0x00, 0x38, 0x7C, 0xE6, 0xC2, 0xDA, 0xD6, 0xD6, 0xDC, 0xC0, 0x62, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char '@'
        0x00, 0x00, 0x18, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x7E, 0x7E, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Char 'A'
        0x00, 0x00, 0x7C, 0x7E, 0x66, 0x66, 0x7E, 0x7C, 0x66, 0x66, 0x66, 0x7E, 0x7C, 0x00, 0x00, 0x00, // Char 'B'
        0x00, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x60, 0x60, 0x60, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char 'C'
        0x00, 0x00, 0x78, 0x7C, 0x6E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x6E, 0x7C, 0x78, 0x00, 0x00, 0x00, // Char 'D'
        0x00, 0x00, 0x7E, 0x7E, 0x60, 0x60, 0x7C, 0x7C, 0x60, 0x60, 0x60, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Char 'E'
        0x00, 0x00, 0x7E, 0x7E, 0x60, 0x60, 0x7C, 0x7C, 0x60, 0x60, 0x60, 0x60, 0x60, 0x00, 0x00, 0x00, // Char 'F'
        0x00, 0x00, 0x3C, 0x7E, 0x66, 0x60, 0x60, 0x6E, 0x6E, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char 'G'
        0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x7E, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Char 'H'
        0x00, 0x00, 0x3C, 0x3C, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x3C, 0x3C, 0x00, 0x00, 0x00, // Char 'I'
        0x00, 0x00, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char 'J'
        0x00, 0x00, 0x66, 0x66, 0x6C, 0x6C, 0x78, 0x78, 0x6C, 0x6C, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Char 'K'
        0x00, 0x00, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Char 'L'
        0x00, 0x00, 0xC6, 0xC6, 0xEE, 0xEE, 0xFE, 0xD6, 0xD6, 0xC6, 0xC6, 0xC6, 0xC6, 0x00, 0x00, 0x00, // Char 'M'
        0x00, 0x00, 0x66, 0x66, 0x76, 0x76, 0x7E, 0x7E, 0x6E, 0x6E, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Char 'N'
        0x00, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char 'O'
        0x00, 0x00, 0x7C, 0x7E, 0x66, 0x66, 0x66, 0x7E, 0x7C, 0x60, 0x60, 0x60, 0x60, 0x00, 0x00, 0x00, // Char 'P'
        0x00, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x6A, 0x3C, 0x0E, 0x06, 0x00, // Char 'Q'
        0x00, 0x00, 0x7C, 0x7E, 0x66, 0x66, 0x66, 0x7E, 0x7C, 0x6C, 0x66, 0x66, 0x63, 0x00, 0x00, 0x00, // Char 'R'
        0x00, 0x00, 0x3E, 0x7E, 0x60, 0x60, 0x70, 0x3C, 0x1E, 0x06, 0x06, 0x7E, 0x7C, 0x00, 0x00, 0x00, // Char 'S'
        0x00, 0x00, 0x7E, 0x7E, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, // Char 'T'
        0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char 'U'
        0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x3C, 0x3C, 0x18, 0x18, 0x00, 0x00, 0x00, // Char 'V'
        0x00, 0x00, 0xC6, 0xC6, 0xC6, 0xC6, 0xD6, 0xD6, 0xFE, 0xFE, 0xEE, 0xC6, 0x82, 0x00, 0x00, 0x00, // Char 'W'
        0x00, 0x00, 0x66, 0x66, 0x66, 0x3C, 0x3C, 0x18, 0x3C, 0x3C, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Char 'X'
        0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x3C, 0x3C, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, // Char 'Y'
        0x00, 0x00, 0x7E, 0x7E, 0x06, 0x0C, 0x1C, 0x18, 0x38, 0x30, 0x60, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Char 'Z'
        0x00, 0x00, 0x3C, 0x3C, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x3C, 0x3C, 0x00, 0x00, 0x00, // Char '['
        0x00, 0x00, 0x60, 0x60, 0x60, 0x30, 0x30, 0x18, 0x1C, 0x0C, 0x06, 0x06, 0x06, 0x00, 0x00, 0x00, // Char '\'
        0x00, 0x00, 0x3C, 0x3C, 0x0C, 0x0C, 0x0C, 0x0C, 0x0C, 0x0C, 0x0C, 0x3C, 0x3C, 0x00, 0x00, 0x00, // Char ']'
        0x00, 0x10, 0x10, 0x38, 0x38, 0x6C, 0x6C, 0xC6, 0xC6, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Char '^'
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFE, 0xFE, 0x00, 0x00, 0x00, // Char '_'
        0x20, 0x30, 0x38, 0x1C, 0x0C, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Char '`'
        0x00, 0x00, 0x00, 0x00, 0x3C, 0x3E, 0x06, 0x06, 0x3E, 0x7E, 0x66, 0x7E, 0x3E, 0x00, 0x00, 0x00, // Char 'a'
        0x00, 0x00, 0x00, 0x60, 0x60, 0x60, 0x7C, 0x7E, 0x66, 0x66, 0x66, 0x7E, 0x7C, 0x00, 0x00, 0x00, // Char 'b'
        0x00, 0x00, 0x00, 0x00, 0x3C, 0x7E, 0x66, 0x60, 0x60, 0x60, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char 'c'
        0x00, 0x00, 0x00, 0x06, 0x06, 0x06, 0x3E, 0x7E, 0x66, 0x66, 0x66, 0x7E, 0x3E, 0x00, 0x00, 0x00, // Char 'd'
        0x00, 0x00, 0x00, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x7E, 0x60, 0x60, 0x7E, 0x3E, 0x00, 0x00, 0x00, // Char 'e'
        0x00, 0x00, 0x00, 0x0E, 0x1E, 0x18, 0x18, 0x7E, 0x7E, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, // Char 'f'
        0x00, 0x00, 0x00, 0x00, 0x3A, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3E, 0x06, 0x1E, 0x3E, // Char 'g'
        0x00, 0x00, 0x00, 0x60, 0x60, 0x60, 0x7C, 0x7C, 0x66, 0x66, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Char 'h'
        0x00, 0x00, 0x18, 0x18, 0x00, 0x38, 0x38, 0x18, 0x18, 0x18, 0x18, 0x3C, 0x3C, 0x00, 0x00, 0x00, // Char 'i'
        0x00, 0x00, 0x0C, 0x0C, 0x00, 0x0C, 0x0C, 0x0C, 0x0C, 0x0C, 0x0C, 0x0C, 0x0C, 0x1C, 0x38, 0x70, // Char 'j'
        0x00, 0x00, 0x00, 0x60, 0x66, 0x6E, 0x6C, 0x78, 0x7C, 0x7C, 0x66, 0x67, 0x63, 0x00, 0x00, 0x00, // Char 'k'
        0x00, 0x00, 0x00, 0x38, 0x38, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x3C, 0x3C, 0x00, 0x00, 0x00, // Char 'l'
        0x00, 0x00, 0x00, 0x00, 0x6C, 0xFE, 0xFE, 0xD6, 0xD6, 0xD6, 0xD6, 0xC6, 0xC6, 0x00, 0x00, 0x00, // Char 'm'
        0x00, 0x00, 0x00, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Char 'n'
        0x00, 0x00, 0x00, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char 'o'
        0x00, 0x00, 0x00, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x7C, 0x60, 0x60, 0x60, // Char 'p'
        0x00, 0x00, 0x00, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3E, 0x06, 0x06, 0x06, // Char 'q'
        0x00, 0x00, 0x00, 0x00, 0x5C, 0x76, 0x66, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x00, 0x00, 0x00, // Char 'r'
        0x00, 0x00, 0x00, 0x00, 0x3C, 0x7E, 0x60, 0x70, 0x3C, 0x0E, 0x06, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char 's'
        0x00, 0x00, 0x18, 0x18, 0x7E, 0x7E, 0x18, 0x18, 0x18, 0x18, 0x18, 0x1E, 0x0E, 0x00, 0x00, 0x00, // Char 't'
        0x00, 0x00, 0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char 'u'
        0x00, 0x00, 0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x24, 0x3C, 0x18, 0x18, 0x00, 0x00, 0x00, // Char 'v'
        0x00, 0x00, 0x00, 0x00, 0x82, 0xC6, 0xD6, 0xD6, 0xD6, 0xFE, 0xEE, 0xC6, 0x82, 0x00, 0x00, 0x00, // Char 'w'
        0x00, 0x00, 0x00, 0x00, 0x66, 0x66, 0x3C, 0x3C, 0x18, 0x3C, 0x3C, 0x66, 0x66, 0x00, 0x00, 0x00, // Char 'x'
        0x00, 0x00, 0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3E, 0x06, 0x1E, 0x3C, // Char 'y'
        0x00, 0x00, 0x00, 0x00, 0x7E, 0x7E, 0x06, 0x0E, 0x1C, 0x38, 0x70, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Char 'z'
        0x00, 0x07, 0x0C, 0x0C, 0x0C, 0x1C, 0x78, 0x78, 0x1C, 0x0C, 0x0C, 0x0C, 0x07, 0x00, 0x00, 0x00, // Char '{'
        0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, // Char '|'
        0x00, 0xE0, 0x30, 0x30, 0x30, 0x38, 0x1E, 0x1E, 0x38, 0x30, 0x30, 0x30, 0xE0, 0x00, 0x00, 0x00, // Char '}'
        0x00, 0x00, 0x00, 0x00, 0x00, 0x62, 0xF2, 0xBE, 0x9C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Char '~'
        0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x3C, 0x24, 0x66, 0x42, 0xC3, 0xFF, 0x00, 0x00, 0x00, // Char ''
        0x7E, 0x3C, 0x5A, 0x66, 0x66, 0x66, 0x42, 0x00, 0x42, 0x66, 0x66, 0x66, 0x5A, 0x3C, 0x7E, 0x00, // Asc: 128
        0x00, 0x00, 0x02, 0x06, 0x06, 0x06, 0x02, 0x00, 0x02, 0x06, 0x06, 0x06, 0x02, 0x00, 0x00, 0x00, // Asc: 129
        0x7E, 0x3C, 0x1A, 0x06, 0x06, 0x06, 0x1A, 0x3C, 0x58, 0x60, 0x60, 0x60, 0x58, 0x3C, 0x7E, 0x00, // Asc: 130
        0x7E, 0x3C, 0x1A, 0x06, 0x06, 0x06, 0x1A, 0x3C, 0x1A, 0x06, 0x06, 0x06, 0x1A, 0x3C, 0x7E, 0x00, // Asc: 131
        0x00, 0x00, 0x42, 0x66, 0x66, 0x66, 0x5A, 0x3C, 0x1A, 0x06, 0x06, 0x06, 0x02, 0x00, 0x00, 0x00, // Asc: 132
        0x7E, 0x3C, 0x58, 0x60, 0x60, 0x60, 0x58, 0x3C, 0x1A, 0x06, 0x06, 0x06, 0x1A, 0x3C, 0x7E, 0x00, // Asc: 133
        0x00, 0x00, 0x40, 0x60, 0x60, 0x60, 0x58, 0x3C, 0x5A, 0x66, 0x66, 0x66, 0x5A, 0x3C, 0x7E, 0x00, // Asc: 134
        0x7E, 0x3C, 0x1A, 0x06, 0x06, 0x06, 0x02, 0x00, 0x02, 0x06, 0x06, 0x06, 0x02, 0x00, 0x00, 0x00, // Asc: 135
        0x7E, 0x3C, 0x5A, 0x66, 0x66, 0x66, 0x5A, 0x3C, 0x5A, 0x66, 0x66, 0x66, 0x5A, 0x3C, 0x7E, 0x00, // Asc: 136
        0x7E, 0x3C, 0x5A, 0x66, 0x66, 0x66, 0x5A, 0x3C, 0x1A, 0x06, 0x06, 0x06, 0x02, 0x00, 0x00, 0x00, // Asc: 137
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7E, 0x7E, 0x3C, 0x3C, 0x18, 0x18, 0x00, 0x00, 0x00, // Asc: 138
        0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x3C, 0x3F, 0x3F, 0x3C, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 139
        0x00, 0x00, 0x18, 0x18, 0x3C, 0x3C, 0x7E, 0x7E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 140
        0x00, 0x00, 0x00, 0x00, 0x00, 0x0C, 0x3C, 0xFC, 0xFC, 0x3C, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 141
        0xA3, 0xC5, 0x89, 0x91, 0xA3, 0xC5, 0x89, 0x91, 0xA3, 0xC5, 0x89, 0x91, 0xA3, 0xC5, 0x89, 0x91, // Asc: 142
        0xFF, 0x44, 0x22, 0x11, 0x88, 0x44, 0x22, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 143
        0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, // Asc: 144
        0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 145
        0x00, 0x7E, 0x81, 0xBD, 0xA5, 0xA5, 0xBD, 0x81, 0xB5, 0xB5, 0xAD, 0xAD, 0x81, 0x7E, 0x00, 0x00, // Asc: 146
        0xFF, 0xC3, 0xDB, 0xDB, 0xC3, 0xFF, 0xC3, 0xDF, 0xC7, 0xDF, 0xFF, 0xC3, 0xDF, 0xC7, 0xDF, 0xDF, // Asc: 147
        0xFF, 0x81, 0x81, 0x99, 0x81, 0x99, 0x81, 0xFF, 0xFF, 0x81, 0x99, 0x81, 0x99, 0x81, 0x81, 0xFF, // Asc: 148
        0x00, 0x00, 0x00, 0x00, 0xFF, 0x81, 0x81, 0x99, 0x99, 0x81, 0x81, 0xFF, 0x00, 0x00, 0x00, 0x00, // Asc: 149
        0x00, 0x00, 0x00, 0x3F, 0x40, 0x7F, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x3F, 0x00, 0x00, // Asc: 150
        0x00, 0x00, 0x78, 0x84, 0x04, 0xF4, 0x0C, 0x04, 0x04, 0x04, 0x04, 0x04, 0x0C, 0xF8, 0x00, 0x00, // Asc: 151
        0x00, 0x00, 0x00, 0x04, 0x0C, 0x1C, 0x7C, 0x7E, 0x7E, 0x7C, 0x1C, 0x0C, 0x04, 0x00, 0x00, 0x00, // Asc: 152
        0x00, 0x00, 0x40, 0x20, 0x50, 0x28, 0xA8, 0x54, 0x54, 0xA8, 0x28, 0x50, 0x20, 0x40, 0x00, 0x00, // Asc: 153
        0x00, 0x03, 0x04, 0x05, 0x09, 0x0A, 0x0A, 0x0A, 0x1F, 0x10, 0x10, 0x10, 0x10, 0x10, 0x1F, 0x00, // Asc: 154
        0x00, 0xF0, 0x08, 0xE8, 0x24, 0x14, 0x14, 0x14, 0xFE, 0x26, 0x0A, 0x26, 0x0A, 0x26, 0xFE, 0x00, // Asc: 155
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 156
        0x00, 0x00, 0x00, 0x00, 0x02, 0x02, 0x06, 0x04, 0x0C, 0x08, 0x58, 0x50, 0x70, 0x20, 0x20, 0x00, // Asc: 157
        0x00, 0xF1, 0x5B, 0x55, 0x51, 0x51, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 158
        0x00, 0x7C, 0x54, 0x10, 0x10, 0x10, 0x00, 0x44, 0x6C, 0x54, 0x44, 0x44, 0x00, 0x00, 0x00, 0x00, // Asc: 159
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, // Asc: 160
        0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, // Asc: 161
        0x00, 0x00, 0x02, 0x04, 0x3C, 0x7E, 0x6A, 0x48, 0x50, 0x76, 0x3C, 0x38, 0x20, 0x40, 0x00, 0x00, // Asc: 162
        0x00, 0x38, 0x7C, 0x66, 0x60, 0x60, 0x30, 0x7C, 0x7C, 0x30, 0x30, 0x26, 0x7E, 0x7C, 0x00, 0x00, // Asc: 163
        0x00, 0x00, 0x00, 0x00, 0x66, 0x3C, 0x24, 0x24, 0x3C, 0x66, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 164
        0x00, 0x00, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x18, 0x7E, 0x7E, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, // Asc: 165
        0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, // Asc: 166
        0x00, 0x00, 0x00, 0x3C, 0x66, 0x38, 0x38, 0x6C, 0x36, 0x1C, 0x1C, 0x66, 0x3C, 0x00, 0x00, 0x00, // Asc: 167
        0x00, 0x6C, 0x6C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 168
        0x00, 0x00, 0x00, 0x38, 0x44, 0x92, 0xAA, 0xA2, 0xAA, 0x92, 0x44, 0x38, 0x00, 0x00, 0x00, 0x00, // Asc: 169
        0x00, 0x30, 0x08, 0x38, 0x48, 0x48, 0x48, 0x38, 0x00, 0x78, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 170
        0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x36, 0x6C, 0x6C, 0x36, 0x12, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 171
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7E, 0x7E, 0x06, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 172
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 173
        0x00, 0x00, 0x00, 0x38, 0x44, 0xB2, 0xAA, 0xB2, 0xAA, 0xA6, 0x44, 0x38, 0x00, 0x00, 0x00, 0x00, // Asc: 174
        0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 175
        0x00, 0x78, 0x78, 0xCC, 0xCC, 0xCC, 0x78, 0x78, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 176
        0x00, 0x00, 0x00, 0x18, 0x18, 0x7E, 0x7E, 0x18, 0x18, 0x00, 0x00, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Asc: 177
        0x00, 0x00, 0x38, 0x08, 0x38, 0x20, 0x38, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 178
        0x00, 0x00, 0x38, 0x08, 0x38, 0x08, 0x38, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 179
        0x00, 0x0C, 0x18, 0x30, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 180
        0x00, 0x00, 0x00, 0x00, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6E, 0x7E, 0x60, 0x60, 0x60, 0x00, // Asc: 181
        0x00, 0x1E, 0x3E, 0x7E, 0x7E, 0x7E, 0x3E, 0x1E, 0x06, 0x06, 0x06, 0x06, 0x06, 0x00, 0x00, 0x00, // Asc: 182
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 183
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x10, 0x08, 0x08, 0x30, // Asc: 184
        0x00, 0x10, 0x30, 0x10, 0x10, 0x38, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 185
        0x00, 0x3C, 0x3C, 0x66, 0x66, 0x66, 0x66, 0x3C, 0x3C, 0x00, 0x7E, 0x7E, 0x00, 0x00, 0x00, 0x00, // Asc: 186
        0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x6C, 0x36, 0x36, 0x6C, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 187
        0x00, 0x30, 0x70, 0x30, 0x36, 0x3C, 0x18, 0x36, 0x66, 0x4A, 0x1A, 0x1F, 0x02, 0x02, 0x00, 0x00, // Asc: 188
        0x00, 0x20, 0x60, 0x20, 0x26, 0x2C, 0x18, 0x3E, 0x6A, 0x42, 0x0E, 0x18, 0x1E, 0x00, 0x00, 0x00, // Asc: 189
        0x00, 0x70, 0x10, 0x70, 0x76, 0x1C, 0x78, 0x36, 0x66, 0x4A, 0x1A, 0x1F, 0x02, 0x02, 0x00, 0x00, // Asc: 190
        0x00, 0x00, 0x18, 0x18, 0x00, 0x18, 0x18, 0x18, 0x30, 0x62, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 191
        0x70, 0x38, 0x18, 0x3C, 0x7E, 0x66, 0x66, 0x7E, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Asc: 192
        0x0E, 0x1C, 0x18, 0x3C, 0x7E, 0x66, 0x66, 0x7E, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Asc: 193
        0x18, 0x3C, 0x5A, 0x3C, 0x7E, 0x66, 0x66, 0x7E, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Asc: 194
        0x36, 0x6C, 0x18, 0x3C, 0x7E, 0x66, 0x66, 0x7E, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Asc: 195
        0x66, 0x66, 0x18, 0x3C, 0x7E, 0x66, 0x66, 0x7E, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Asc: 196
        0x18, 0x24, 0x3C, 0x18, 0x3C, 0x7E, 0x66, 0x66, 0x7E, 0x7E, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Asc: 197
        0x00, 0x00, 0x1E, 0x3E, 0x6E, 0x68, 0xC8, 0x8E, 0xFE, 0xF8, 0xC8, 0xCE, 0xCE, 0x00, 0x00, 0x00, // Asc: 198
        0x00, 0x00, 0x3C, 0x7C, 0x66, 0x66, 0x60, 0x60, 0x60, 0x60, 0x66, 0x3E, 0x3C, 0x0C, 0x38, 0x38, // Asc: 199
        0x70, 0x38, 0x7E, 0x7E, 0x60, 0x60, 0x7C, 0x7C, 0x60, 0x60, 0x60, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Asc: 200
        0x0E, 0x1C, 0x7E, 0x7E, 0x60, 0x60, 0x7C, 0x7C, 0x60, 0x60, 0x60, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Asc: 201
        0x18, 0x3C, 0x66, 0x7E, 0x7E, 0x60, 0x60, 0x7C, 0x7C, 0x60, 0x60, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Asc: 202
        0x66, 0x66, 0x5A, 0x7E, 0x60, 0x60, 0x7C, 0x7C, 0x60, 0x60, 0x60, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Asc: 203
        0x70, 0x38, 0x7E, 0x7E, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Asc: 204
        0x0E, 0x1C, 0x7E, 0x7E, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Asc: 205
        0x18, 0x3C, 0x66, 0x7E, 0x7E, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Asc: 206
        0x66, 0x66, 0x00, 0x7E, 0x7E, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Asc: 207
        0x00, 0x00, 0x78, 0x6C, 0x66, 0x66, 0xF6, 0xF6, 0x66, 0x66, 0x6E, 0x7C, 0x78, 0x00, 0x00, 0x00, // Asc: 208
        0x36, 0x6C, 0x64, 0x66, 0x76, 0x76, 0x7E, 0x7E, 0x6E, 0x6E, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Asc: 209
        0x70, 0x38, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 210
        0x0E, 0x1C, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 211
        0x18, 0x3C, 0x66, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 212
        0x36, 0x6C, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 213
        0x66, 0x66, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 214
        0x00, 0x00, 0x00, 0x00, 0x00, 0x66, 0x3C, 0x18, 0x18, 0x3C, 0x66, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 215
        0x00, 0x00, 0x3E, 0x7C, 0x62, 0x66, 0x6E, 0x7E, 0x76, 0x66, 0x46, 0x3E, 0x7C, 0x00, 0x00, 0x00, // Asc: 216
        0x70, 0x38, 0x42, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 217
        0x0E, 0x1C, 0x42, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 218
        0x18, 0x3C, 0x42, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 219
        0x66, 0x66, 0x42, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 220
        0x0E, 0x1C, 0x42, 0x66, 0x66, 0x66, 0x66, 0x3C, 0x3C, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, // Asc: 221
        0x00, 0x00, 0x00, 0x60, 0x60, 0x7E, 0x7F, 0x63, 0x63, 0x63, 0x7E, 0x7C, 0x60, 0x60, 0x60, 0x00, // Asc: 222
        0x00, 0x00, 0x00, 0x3C, 0x66, 0x66, 0x66, 0x6C, 0x66, 0x66, 0x66, 0x66, 0x6C, 0x00, 0x00, 0x00, // Asc: 223
        0x00, 0x70, 0x38, 0x00, 0x3C, 0x3E, 0x06, 0x06, 0x3E, 0x7E, 0x66, 0x66, 0x3E, 0x00, 0x00, 0x00, // Asc: 224
        0x00, 0x0E, 0x1C, 0x00, 0x3C, 0x3E, 0x06, 0x06, 0x3E, 0x7E, 0x66, 0x66, 0x3E, 0x00, 0x00, 0x00, // Asc: 225
        0x00, 0x18, 0x3C, 0x42, 0x3C, 0x3E, 0x06, 0x06, 0x3E, 0x7E, 0x66, 0x66, 0x3E, 0x00, 0x00, 0x00, // Asc: 226
        0x00, 0x00, 0x36, 0x6C, 0x3C, 0x3C, 0x06, 0x06, 0x3E, 0x7E, 0x66, 0x66, 0x3E, 0x00, 0x00, 0x00, // Asc: 227
        0x00, 0x00, 0x66, 0x66, 0x3C, 0x3E, 0x06, 0x06, 0x3E, 0x7E, 0x66, 0x66, 0x3E, 0x00, 0x00, 0x00, // Asc: 228
        0x00, 0x1C, 0x36, 0x1C, 0x3C, 0x3E, 0x06, 0x06, 0x3E, 0x7E, 0x66, 0x66, 0x3E, 0x00, 0x00, 0x00, // Asc: 229
        0x00, 0x00, 0x00, 0x00, 0x7E, 0x7E, 0x0A, 0x0A, 0x7A, 0xFE, 0xC8, 0xC8, 0x7E, 0x00, 0x00, 0x00, // Asc: 230
        0x00, 0x00, 0x00, 0x00, 0x3C, 0x7E, 0x66, 0x60, 0x60, 0x60, 0x66, 0x3C, 0x18, 0x0C, 0x18, 0x30, // Asc: 231
        0x00, 0x70, 0x38, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x7E, 0x60, 0x60, 0x7E, 0x3E, 0x00, 0x00, 0x00, // Asc: 232
        0x00, 0x0E, 0x1C, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x7E, 0x60, 0x60, 0x7E, 0x3E, 0x00, 0x00, 0x00, // Asc: 233
        0x00, 0x18, 0x3C, 0x66, 0x3C, 0x7E, 0x66, 0x66, 0x7E, 0x60, 0x60, 0x7E, 0x3E, 0x00, 0x00, 0x00, // Asc: 234
        0x00, 0x00, 0x66, 0x66, 0x3C, 0x7E, 0x66, 0x66, 0x7E, 0x60, 0x60, 0x7E, 0x3E, 0x00, 0x00, 0x00, // Asc: 235
        0x00, 0x70, 0x38, 0x00, 0x38, 0x38, 0x18, 0x18, 0x18, 0x18, 0x18, 0x3C, 0x3C, 0x00, 0x00, 0x00, // Asc: 236
        0x00, 0x0E, 0x1C, 0x00, 0x38, 0x38, 0x18, 0x18, 0x18, 0x18, 0x18, 0x3C, 0x3C, 0x00, 0x00, 0x00, // Asc: 237
        0x00, 0x18, 0x3C, 0x66, 0x38, 0x38, 0x18, 0x18, 0x18, 0x18, 0x18, 0x3C, 0x3C, 0x00, 0x00, 0x00, // Asc: 238
        0x00, 0x00, 0x66, 0x66, 0x38, 0x38, 0x18, 0x18, 0x18, 0x18, 0x18, 0x3C, 0x3C, 0x00, 0x00, 0x00, // Asc: 239
        0x00, 0x7C, 0x30, 0x7C, 0x08, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 240
        0x00, 0x00, 0x36, 0x6C, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Asc: 241
        0x00, 0x70, 0x38, 0x00, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 242
        0x00, 0x0E, 0x1C, 0x00, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 243
        0x00, 0x18, 0x3C, 0x66, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 244
        0x00, 0x00, 0x36, 0x6C, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 245
        0x00, 0x00, 0x66, 0x66, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 246
        0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x00, 0x7E, 0x00, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, // Asc: 247
        0x00, 0x00, 0x00, 0x00, 0x3C, 0x7E, 0x6E, 0x6E, 0x66, 0x76, 0x76, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 248
        0x00, 0x70, 0x38, 0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 249
        0x00, 0x0E, 0x1C, 0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 250
        0x00, 0x18, 0x3C, 0x66, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 251
        0x00, 0x00, 0x66, 0x66, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 252
        0x00, 0x0E, 0x1C, 0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3E, 0x06, 0x1E, 0x3E, // Asc: 253
        0x00, 0x00, 0x60, 0x60, 0x60, 0x7C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x7C, 0x60, 0x60, 0x60, // Asc: 254
        0x00, 0x00, 0x66, 0x66, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3E, 0x06, 0x1E, 0x3E  // Asc: 255
};
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////
#if 1 // it is now in PDAOS
ROMBYTE PDAFONT [] = { // Friday, March 14, 2003, 21:26:47:  ; Binary Font Table Generated.
        0x00, 0x50, 0x70, 0x70, 0x50, 0x28, 0x28, 0x38, 0x10, 0x10, 0x18, 0x08, 0x08, 0x0C, 0x00, 0x00, // Asc: 0
        0x00, 0x7E, 0x7C, 0x78, 0x7C, 0x6E, 0x46, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 1
        0x00, 0x7E, 0x3E, 0x1E, 0x3E, 0x76, 0x62, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 2
        0x00, 0x00, 0x00, 0x00, 0x7E, 0xC3, 0xA5, 0x99, 0x99, 0xA5, 0xC3, 0x7E, 0x00, 0x00, 0x00, 0x00, // Asc: 3
        0x00, 0x18, 0x3C, 0x7E, 0x7E, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 4
        0x00, 0x7E, 0x7C, 0x78, 0x7C, 0x6E, 0x46, 0x00, 0x00, 0x66, 0x24, 0x18, 0x18, 0x24, 0x66, 0x00, // Asc: 5
        0x00, 0x7E, 0x3E, 0x1E, 0x3E, 0x76, 0x62, 0x00, 0x00, 0x66, 0x24, 0x18, 0x18, 0x24, 0x66, 0x00, // Asc: 6
        0x00, 0x00, 0x18, 0x3C, 0x3C, 0x3C, 0x3C, 0x3C, 0x7E, 0xFF, 0x10, 0x38, 0x10, 0x00, 0x00, 0x00, // Asc: 7
        0x00, 0x70, 0x50, 0x70, 0x50, 0x70, 0x00, 0x1C, 0x10, 0x1C, 0x04, 0x1C, 0x00, 0x00, 0x00, 0x00, // Asc: 8
        0x00, 0x40, 0x40, 0x40, 0x48, 0x4C, 0x7E, 0x7E, 0x4C, 0x48, 0x40, 0x40, 0x40, 0x00, 0x00, 0x00, // Asc: 9
        0x00, 0x40, 0x40, 0x40, 0x40, 0x70, 0x00, 0x1C, 0x10, 0x1C, 0x10, 0x10, 0x10, 0x00, 0x00, 0x00, // Asc: 10
        0x00, 0x50, 0x50, 0x70, 0x50, 0x50, 0x00, 0x70, 0x50, 0x70, 0x00, 0x70, 0x70, 0x50, 0x00, 0x00, // Asc: 11
        0x00, 0x70, 0x40, 0x70, 0x40, 0x40, 0x40, 0x1C, 0x10, 0x1C, 0x10, 0x10, 0x10, 0x00, 0x00, 0x00, // Asc: 12
        0x00, 0x00, 0x00, 0x06, 0x06, 0x06, 0x16, 0x36, 0x76, 0xFE, 0x70, 0x30, 0x10, 0x00, 0x00, 0x00, // Asc: 13
        0x00, 0x08, 0x18, 0x38, 0x7F, 0xFF, 0x7F, 0x3B, 0x1B, 0x0B, 0x03, 0x03, 0xFF, 0xFF, 0x00, 0x00, // Asc: 14
        0x00, 0x02, 0x02, 0x02, 0x0A, 0x1A, 0x3E, 0x3E, 0x1A, 0x0A, 0x02, 0x02, 0x02, 0x00, 0x00, 0x00, // Asc: 15
        0x00, 0x18, 0x3C, 0x7E, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00, 0xFF, 0xAB, 0xD5, 0xAB, 0xFF, 0x00, // Asc: 16
        0x00, 0xFA, 0x92, 0x92, 0xD3, 0x00, 0x7C, 0x7C, 0x0C, 0x0C, 0x0C, 0x3F, 0x1E, 0x0C, 0x00, 0x00, // Asc: 17
        0x00, 0xFF, 0x00, 0x56, 0x76, 0x76, 0x00, 0xFF, 0x00, 0x18, 0x3C, 0x7E, 0x18, 0x18, 0x18, 0x00, // Asc: 18
        0x00, 0xFF, 0x81, 0xBD, 0x7E, 0x3C, 0x18, 0x18, 0x18, 0x18, 0x24, 0x4A, 0xB5, 0xFF, 0xFF, 0x00, // Asc: 19
        0x00, 0x18, 0x3C, 0x7E, 0x18, 0xFF, 0xFF, 0x18, 0xFF, 0xC5, 0xAB, 0xD5, 0xAB, 0xFF, 0x00, 0x00, // Asc: 20
        0x00, 0x02, 0x02, 0x02, 0x0A, 0x1A, 0x3E, 0x3E, 0x1A, 0x0A, 0x02, 0x02, 0x02, 0x00, 0x00, 0x00, // Asc: 21
        0x00, 0x00, 0x00, 0x3F, 0x40, 0x7F, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x3F, 0x00, 0x00, // Asc: 22
        0x00, 0x00, 0x78, 0x84, 0x04, 0xF4, 0x0C, 0x04, 0x04, 0x04, 0x04, 0x04, 0x0C, 0xF8, 0x00, 0x00, // Asc: 23
        0x00, 0x03, 0x04, 0x05, 0x09, 0x0A, 0x0A, 0x0A, 0x1F, 0x10, 0x10, 0x10, 0x10, 0x10, 0x1F, 0x00, // Asc: 24
        0x00, 0xF0, 0x08, 0xE8, 0x24, 0x14, 0x14, 0x14, 0xFE, 0x26, 0x0A, 0x26, 0x0A, 0x26, 0xFE, 0x00, // Asc: 25
        0x00, 0x00, 0x00, 0x18, 0x3C, 0x5A, 0x5A, 0x66, 0x66, 0x5A, 0x5A, 0x3C, 0x18, 0x00, 0x00, 0x00, // Asc: 26
        0x00, 0x70, 0x40, 0x70, 0x40, 0x70, 0x1C, 0x10, 0x1C, 0x04, 0x1C, 0x0E, 0x08, 0x08, 0x0E, 0x00, // Asc: 27
        0x00, 0x00, 0x30, 0x38, 0x2C, 0xE6, 0x83, 0x83, 0xE6, 0x2C, 0x38, 0x30, 0x00, 0x00, 0x00, 0x00, // Asc: 28
        0x00, 0x00, 0x0C, 0x1C, 0x34, 0x67, 0xC1, 0xC1, 0x67, 0x34, 0x1C, 0x0C, 0x00, 0x00, 0x00, 0x00, // Asc: 29
        0x00, 0x00, 0x00, 0x18, 0x3C, 0x66, 0xC3, 0x81, 0xE7, 0x24, 0x24, 0x24, 0x3C, 0x00, 0x00, 0x00, // Asc: 30
        0x00, 0x00, 0x00, 0x3C, 0x24, 0x24, 0x24, 0xE7, 0x81, 0xC3, 0x66, 0x3C, 0x18, 0x00, 0x00, 0x00, // Asc: 31
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Char ' '
        0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x18, 0x18, 0x00, 0x00, 0x00, // Char '!'
        0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Char '"'
        0x00, 0x00, 0x66, 0x66, 0xFF, 0xFF, 0x66, 0x66, 0xFF, 0xFF, 0x66, 0x66, 0x00, 0x00, 0x00, 0x00, // Char '#'
        0x18, 0x18, 0x3E, 0x7E, 0x60, 0x60, 0x7C, 0x3E, 0x06, 0x06, 0x7E, 0x7C, 0x18, 0x18, 0x00, 0x00, // Char '$'
        0x00, 0x00, 0x66, 0x66, 0x6C, 0x0C, 0x18, 0x18, 0x30, 0x36, 0x66, 0x66, 0x00, 0x00, 0x00, 0x00, // Char '%'
        0x38, 0x7C, 0x6C, 0x6C, 0x38, 0x38, 0x70, 0x70, 0xDE, 0xDE, 0xCC, 0xCC, 0xFE, 0x76, 0x00, 0x00, // Char '&'
        0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Char '''
        0x00, 0x0C, 0x18, 0x38, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x18, 0x18, 0x0C, 0x00, 0x00, 0x00, // Char '('
        0x00, 0x30, 0x18, 0x1C, 0x0C, 0x0C, 0x0C, 0x0C, 0x0C, 0x0C, 0x18, 0x18, 0x30, 0x00, 0x00, 0x00, // Char ')'
        0x00, 0x00, 0x66, 0x66, 0x3C, 0x3C, 0xFF, 0xFF, 0x3C, 0x3C, 0x66, 0x66, 0x00, 0x00, 0x00, 0x00, // Char '*'
        0x00, 0x00, 0x00, 0x18, 0x18, 0x18, 0x7E, 0x7E, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, // Char '+'
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0C, 0x0C, 0x0C, 0x18, 0x10, // Char ','
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7E, 0x7E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Char '-'
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, // Char '.'
        0x00, 0x06, 0x06, 0x06, 0x0C, 0x0C, 0x18, 0x18, 0x30, 0x30, 0x60, 0x60, 0x60, 0x00, 0x00, 0x00, // Char '/'
        0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x6E, 0x76, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char '0'
        0x00, 0x18, 0x18, 0x38, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x3C, 0x3C, 0x00, 0x00, 0x00, // Char '1'
        0x00, 0x3C, 0x7E, 0x66, 0x06, 0x0E, 0x1C, 0x38, 0x70, 0x60, 0x60, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Char '2'
        0x00, 0x3C, 0x7E, 0x66, 0x06, 0x06, 0x1C, 0x1C, 0x06, 0x06, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char '3'
        0x00, 0x0C, 0x0C, 0xCC, 0xCC, 0xCC, 0xCC, 0xFE, 0x7E, 0x0C, 0x0C, 0x0C, 0x0C, 0x00, 0x00, 0x00, // Char '4'
        0x00, 0x7E, 0x7E, 0x60, 0x60, 0x7C, 0x7E, 0x06, 0x06, 0x06, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char '5'
        0x00, 0x3C, 0x7E, 0x66, 0x60, 0x7C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char '6'
        0x00, 0x7E, 0x7E, 0x06, 0x06, 0x0C, 0x0C, 0x18, 0x18, 0x30, 0x30, 0x30, 0x30, 0x00, 0x00, 0x00, // Char '7'
        0x00, 0x3C, 0x7E, 0x66, 0x66, 0x3C, 0x3C, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char '8'
        0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x7E, 0x3E, 0x06, 0x06, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char '9'
        0x00, 0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, // Char ':'
        0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x30, 0x20, // Char ';'
        0x00, 0x00, 0x00, 0x07, 0x0E, 0x1C, 0x38, 0x70, 0x38, 0x1C, 0x0E, 0x07, 0x00, 0x00, 0x00, 0x00, // Char '<'
        0x00, 0x00, 0x00, 0x00, 0x7E, 0x7E, 0x00, 0x00, 0x7E, 0x7E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Char '='
        0x00, 0x00, 0x00, 0xE0, 0x70, 0x38, 0x1C, 0x0E, 0x1C, 0x38, 0x70, 0xE0, 0x00, 0x00, 0x00, 0x00, // Char '>'
        0x00, 0x00, 0x3C, 0x7E, 0x66, 0x06, 0x0C, 0x0C, 0x18, 0x18, 0x00, 0x18, 0x18, 0x00, 0x00, 0x00, // Char '?'
        0x00, 0x38, 0x7C, 0xE6, 0xC2, 0xDA, 0xD6, 0xD6, 0xDC, 0xC0, 0x62, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char '@'
        0x00, 0x00, 0x18, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x7E, 0x7E, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Char 'A'
        0x00, 0x00, 0x7C, 0x7E, 0x66, 0x66, 0x7E, 0x7C, 0x66, 0x66, 0x66, 0x7E, 0x7C, 0x00, 0x00, 0x00, // Char 'B'
        0x00, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x60, 0x60, 0x60, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char 'C'
        0x00, 0x00, 0x78, 0x7C, 0x6E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x6E, 0x7C, 0x78, 0x00, 0x00, 0x00, // Char 'D'
        0x00, 0x00, 0x7E, 0x7E, 0x60, 0x60, 0x7C, 0x7C, 0x60, 0x60, 0x60, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Char 'E'
        0x00, 0x00, 0x7E, 0x7E, 0x60, 0x60, 0x7C, 0x7C, 0x60, 0x60, 0x60, 0x60, 0x60, 0x00, 0x00, 0x00, // Char 'F'
        0x00, 0x00, 0x3C, 0x7E, 0x66, 0x60, 0x60, 0x6E, 0x6E, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char 'G'
        0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x7E, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Char 'H'
        0x00, 0x00, 0x3C, 0x3C, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x3C, 0x3C, 0x00, 0x00, 0x00, // Char 'I'
        0x00, 0x00, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char 'J'
        0x00, 0x00, 0x66, 0x66, 0x6C, 0x6C, 0x78, 0x78, 0x6C, 0x6C, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Char 'K'
        0x00, 0x00, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Char 'L'
        0x00, 0x00, 0xC6, 0xC6, 0xEE, 0xEE, 0xFE, 0xD6, 0xD6, 0xC6, 0xC6, 0xC6, 0xC6, 0x00, 0x00, 0x00, // Char 'M'
        0x00, 0x00, 0x66, 0x66, 0x76, 0x76, 0x7E, 0x7E, 0x6E, 0x6E, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Char 'N'
        0x00, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char 'O'
        0x00, 0x00, 0x7C, 0x7E, 0x66, 0x66, 0x66, 0x7E, 0x7C, 0x60, 0x60, 0x60, 0x60, 0x00, 0x00, 0x00, // Char 'P'
        0x00, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x6A, 0x3C, 0x0E, 0x06, 0x00, // Char 'Q'
        0x00, 0x00, 0x7C, 0x7E, 0x66, 0x66, 0x66, 0x7E, 0x7C, 0x6C, 0x66, 0x66, 0x63, 0x00, 0x00, 0x00, // Char 'R'
        0x00, 0x00, 0x3E, 0x7E, 0x60, 0x60, 0x70, 0x3C, 0x1E, 0x06, 0x06, 0x7E, 0x7C, 0x00, 0x00, 0x00, // Char 'S'
        0x00, 0x00, 0x7E, 0x7E, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, // Char 'T'
        0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char 'U'
        0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x3C, 0x3C, 0x18, 0x18, 0x00, 0x00, 0x00, // Char 'V'
        0x00, 0x00, 0xC6, 0xC6, 0xC6, 0xC6, 0xD6, 0xD6, 0xFE, 0xFE, 0xEE, 0xC6, 0x82, 0x00, 0x00, 0x00, // Char 'W'
        0x00, 0x00, 0x66, 0x66, 0x66, 0x3C, 0x3C, 0x18, 0x3C, 0x3C, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Char 'X'
        0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x3C, 0x3C, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, // Char 'Y'
        0x00, 0x00, 0x7E, 0x7E, 0x06, 0x0C, 0x1C, 0x18, 0x38, 0x30, 0x60, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Char 'Z'
        0x00, 0x00, 0x3C, 0x3C, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x3C, 0x3C, 0x00, 0x00, 0x00, // Char '['
        0x00, 0x00, 0x60, 0x60, 0x60, 0x30, 0x30, 0x18, 0x1C, 0x0C, 0x06, 0x06, 0x06, 0x00, 0x00, 0x00, // Char '\'
        0x00, 0x00, 0x3C, 0x3C, 0x0C, 0x0C, 0x0C, 0x0C, 0x0C, 0x0C, 0x0C, 0x3C, 0x3C, 0x00, 0x00, 0x00, // Char ']'
        0x00, 0x10, 0x10, 0x38, 0x38, 0x6C, 0x6C, 0xC6, 0xC6, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Char '^'
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFE, 0xFE, 0x00, 0x00, 0x00, // Char '_'
        0x20, 0x30, 0x38, 0x1C, 0x0C, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Char '`'
        0x00, 0x00, 0x00, 0x00, 0x3C, 0x3E, 0x06, 0x06, 0x3E, 0x7E, 0x66, 0x7E, 0x3E, 0x00, 0x00, 0x00, // Char 'a'
        0x00, 0x00, 0x60, 0x60, 0x60, 0x7C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x7C, 0x00, 0x00, 0x00, // Char 'b'
        0x00, 0x00, 0x00, 0x00, 0x3C, 0x7E, 0x66, 0x60, 0x60, 0x60, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char 'c'
        0x00, 0x00, 0x06, 0x06, 0x06, 0x3E, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3E, 0x00, 0x00, 0x00, // Char 'd'
        0x00, 0x00, 0x00, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x7E, 0x60, 0x60, 0x7E, 0x3E, 0x00, 0x00, 0x00, // Char 'e'
        0x00, 0x00, 0x0E, 0x1E, 0x18, 0x18, 0x18, 0x7E, 0x7E, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, // Char 'f'
        0x00, 0x00, 0x00, 0x00, 0x3A, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3E, 0x06, 0x1E, 0x3E, // Char 'g'
        0x00, 0x00, 0x60, 0x60, 0x60, 0x7C, 0x7C, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Char 'h'
        0x00, 0x00, 0x18, 0x18, 0x00, 0x38, 0x38, 0x18, 0x18, 0x18, 0x18, 0x3C, 0x3C, 0x00, 0x00, 0x00, // Char 'i'
        0x00, 0x00, 0x18, 0x18, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x38, 0x70, 0xE0, // Char 'j'
        0x00, 0x00, 0x60, 0x60, 0x66, 0x6E, 0x6C, 0x78, 0x7C, 0x7C, 0x66, 0x67, 0x63, 0x00, 0x00, 0x00, // Char 'k'
        0x00, 0x00, 0x38, 0x38, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x3C, 0x3C, 0x00, 0x00, 0x00, // Char 'l'
        0x00, 0x00, 0x00, 0x00, 0x6C, 0xFE, 0xFE, 0xD6, 0xD6, 0xD6, 0xD6, 0xC6, 0xC6, 0x00, 0x00, 0x00, // Char 'm'
        0x00, 0x00, 0x00, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Char 'n'
        0x00, 0x00, 0x00, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char 'o'
        0x00, 0x00, 0x00, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x7C, 0x60, 0x60, 0x60, // Char 'p'
        0x00, 0x00, 0x00, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3E, 0x06, 0x06, 0x06, // Char 'q'
        0x00, 0x00, 0x00, 0x00, 0x5C, 0x76, 0x66, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x00, 0x00, 0x00, // Char 'r'
        0x00, 0x00, 0x00, 0x00, 0x3C, 0x7E, 0x60, 0x70, 0x3C, 0x0E, 0x06, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char 's'
        0x00, 0x00, 0x18, 0x18, 0x7E, 0x7E, 0x18, 0x18, 0x18, 0x18, 0x18, 0x1E, 0x0E, 0x00, 0x00, 0x00, // Char 't'
        0x00, 0x00, 0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Char 'u'
        0x00, 0x00, 0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x24, 0x3C, 0x18, 0x18, 0x00, 0x00, 0x00, // Char 'v'
        0x00, 0x00, 0x00, 0x00, 0x82, 0xC6, 0xD6, 0xD6, 0xD6, 0xFE, 0xEE, 0xC6, 0x82, 0x00, 0x00, 0x00, // Char 'w'
        0x00, 0x00, 0x00, 0x00, 0x66, 0x66, 0x3C, 0x3C, 0x18, 0x3C, 0x3C, 0x66, 0x66, 0x00, 0x00, 0x00, // Char 'x'
        0x00, 0x00, 0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x24, 0x3C, 0x18, 0x18, 0x30, 0x70, 0x60, // Char 'y'
        0x00, 0x00, 0x00, 0x00, 0x7E, 0x7E, 0x06, 0x0E, 0x1C, 0x38, 0x70, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Char 'z'
        0x00, 0x07, 0x0C, 0x0C, 0x0C, 0x1C, 0x78, 0x78, 0x1C, 0x0C, 0x0C, 0x0C, 0x07, 0x00, 0x00, 0x00, // Char '{'
        0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, // Char '|'
        0x00, 0xE0, 0x30, 0x30, 0x30, 0x38, 0x1E, 0x1E, 0x38, 0x30, 0x30, 0x30, 0xE0, 0x00, 0x00, 0x00, // Char '}'
        0x00, 0x00, 0x00, 0x00, 0x00, 0x62, 0xF2, 0xBE, 0x9C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Char '~'
        0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x3C, 0x24, 0x66, 0x42, 0xC3, 0xFF, 0x00, 0x00, 0x00, // Char ''
        0x7E, 0x3C, 0x5A, 0x66, 0x66, 0x66, 0x42, 0x00, 0x42, 0x66, 0x66, 0x66, 0x5A, 0x3C, 0x7E, 0x00, // Asc: 128
        0x00, 0x00, 0x02, 0x06, 0x06, 0x06, 0x02, 0x00, 0x02, 0x06, 0x06, 0x06, 0x02, 0x00, 0x00, 0x00, // Asc: 129
        0x7E, 0x3C, 0x1A, 0x06, 0x06, 0x06, 0x1A, 0x3C, 0x58, 0x60, 0x60, 0x60, 0x58, 0x3C, 0x7E, 0x00, // Asc: 130
        0x7E, 0x3C, 0x1A, 0x06, 0x06, 0x06, 0x1A, 0x3C, 0x1A, 0x06, 0x06, 0x06, 0x1A, 0x3C, 0x7E, 0x00, // Asc: 131
        0x00, 0x00, 0x42, 0x66, 0x66, 0x66, 0x5A, 0x3C, 0x1A, 0x06, 0x06, 0x06, 0x02, 0x00, 0x00, 0x00, // Asc: 132
        0x7E, 0x3C, 0x58, 0x60, 0x60, 0x60, 0x58, 0x3C, 0x1A, 0x06, 0x06, 0x06, 0x1A, 0x3C, 0x7E, 0x00, // Asc: 133
        0x00, 0x00, 0x40, 0x60, 0x60, 0x60, 0x58, 0x3C, 0x5A, 0x66, 0x66, 0x66, 0x5A, 0x3C, 0x7E, 0x00, // Asc: 134
        0x7E, 0x3C, 0x1A, 0x06, 0x06, 0x06, 0x02, 0x00, 0x02, 0x06, 0x06, 0x06, 0x02, 0x00, 0x00, 0x00, // Asc: 135
        0x7E, 0x3C, 0x5A, 0x66, 0x66, 0x66, 0x5A, 0x3C, 0x5A, 0x66, 0x66, 0x66, 0x5A, 0x3C, 0x7E, 0x00, // Asc: 136
        0x7E, 0x3C, 0x5A, 0x66, 0x66, 0x66, 0x5A, 0x3C, 0x1A, 0x06, 0x06, 0x06, 0x02, 0x00, 0x00, 0x00, // Asc: 137
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7E, 0x7E, 0x3C, 0x3C, 0x18, 0x18, 0x00, 0x00, 0x00, // Asc: 138
        0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x3C, 0x3F, 0x3F, 0x3C, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 139
        0x00, 0x00, 0x18, 0x18, 0x3C, 0x3C, 0x7E, 0x7E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 140
        0x00, 0x00, 0x00, 0x00, 0x00, 0x0C, 0x3C, 0xFC, 0xFC, 0x3C, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 141
        0xA3, 0xC5, 0x89, 0x91, 0xA3, 0xC5, 0x89, 0x91, 0xA3, 0xC5, 0x89, 0x91, 0xA3, 0xC5, 0x89, 0x91, // Asc: 142
        0xFF, 0x44, 0x22, 0x11, 0x88, 0x44, 0x22, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 143
        0x00, 0x18, 0x3C, 0x7E, 0x7E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7E, 0x7E, 0x3C, 0x18, 0x00, 0x00, // Asc: 144
        0xFF, 0x81, 0x81, 0x99, 0x81, 0x99, 0x81, 0xFF, 0xFF, 0x81, 0x99, 0x81, 0x99, 0x81, 0x81, 0xFF, // Asc: 145
        0x00, 0x00, 0x3F, 0x3F, 0x38, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x38, 0x3F, 0x3F, 0x00, 0x00, // Asc: 146
        0x00, 0x00, 0xFC, 0xFC, 0x0C, 0x0C, 0x0C, 0x0C, 0x0C, 0x0C, 0x0C, 0x1C, 0xFC, 0xFC, 0x00, 0x00, // Asc: 147
        0x00, 0x00, 0x3F, 0x3F, 0x38, 0x30, 0x30, 0x34, 0x37, 0x33, 0x31, 0x38, 0x3F, 0x3F, 0x00, 0x00, // Asc: 148
        0x00, 0x00, 0xFC, 0xFC, 0x0C, 0x2C, 0x6C, 0xCC, 0x8C, 0x8C, 0x0C, 0x1C, 0xFC, 0xFC, 0x00, 0x00, // Asc: 149
        0x00, 0x00, 0x03, 0x0F, 0x1C, 0x18, 0x30, 0x30, 0x30, 0x30, 0x18, 0x1C, 0x0F, 0x03, 0x00, 0x00, // Asc: 150
        0x00, 0x00, 0xC0, 0xF0, 0x38, 0x18, 0x0C, 0x0C, 0x0C, 0x0C, 0x18, 0x38, 0xF0, 0xC0, 0x00, 0x00, // Asc: 151
        0x00, 0x00, 0x03, 0x0F, 0x1C, 0x18, 0x31, 0x33, 0x33, 0x31, 0x18, 0x1C, 0x0F, 0x03, 0x00, 0x00, // Asc: 152
        0x00, 0x00, 0xC0, 0xF0, 0x38, 0x18, 0x8C, 0xCC, 0xCC, 0x8C, 0x18, 0x38, 0xF0, 0xC0, 0x00, 0x00, // Asc: 153
        0x00, 0x00, 0x00, 0x04, 0x0C, 0x1C, 0x7C, 0x7E, 0x7E, 0x7C, 0x1C, 0x0C, 0x04, 0x00, 0x00, 0x00, // Asc: 154
        0x00, 0x00, 0x40, 0x20, 0x50, 0x28, 0xA8, 0x54, 0x54, 0xA8, 0x28, 0x50, 0x20, 0x40, 0x00, 0x00, // Asc: 155
        0x00, 0x00, 0x00, 0x00, 0xFF, 0x81, 0x81, 0x99, 0x99, 0x81, 0x81, 0xFF, 0x00, 0x00, 0x00, 0x00, // Asc: 156
        0x00, 0x00, 0x00, 0x00, 0x02, 0x02, 0x06, 0x04, 0x0C, 0x08, 0x58, 0x50, 0x70, 0x20, 0x20, 0x00, // Asc: 157
        0x00, 0xF1, 0x5B, 0x55, 0x51, 0x51, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 158
        0x00, 0x7C, 0x54, 0x10, 0x10, 0x10, 0x00, 0x44, 0x6C, 0x54, 0x44, 0x44, 0x00, 0x00, 0x00, 0x00, // Asc: 159
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, // Asc: 160
        0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, // Asc: 161
        0x00, 0x00, 0x02, 0x04, 0x3C, 0x7E, 0x6A, 0x48, 0x50, 0x76, 0x3C, 0x38, 0x20, 0x40, 0x00, 0x00, // Asc: 162
        0x00, 0x38, 0x7C, 0x66, 0x60, 0x60, 0x30, 0x7C, 0x7C, 0x30, 0x30, 0x26, 0x7E, 0x7C, 0x00, 0x00, // Asc: 163
        0x00, 0x00, 0x00, 0x00, 0x66, 0x3C, 0x24, 0x24, 0x3C, 0x66, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 164
        0x00, 0x00, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x18, 0x7E, 0x7E, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, // Asc: 165
        0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, // Asc: 166
        0x00, 0x00, 0x00, 0x3C, 0x66, 0x38, 0x38, 0x6C, 0x36, 0x1C, 0x1C, 0x66, 0x3C, 0x00, 0x00, 0x00, // Asc: 167
        0x00, 0x6C, 0x6C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 168
        0x00, 0x00, 0x00, 0x38, 0x44, 0x92, 0xAA, 0xA2, 0xAA, 0x92, 0x44, 0x38, 0x00, 0x00, 0x00, 0x00, // Asc: 169
        0x00, 0x30, 0x08, 0x38, 0x48, 0x48, 0x48, 0x38, 0x00, 0x78, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 170
        0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x36, 0x6C, 0x6C, 0x36, 0x12, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 171
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7E, 0x7E, 0x06, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 172
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 173
        0x00, 0x00, 0x00, 0x38, 0x44, 0xB2, 0xAA, 0xB2, 0xAA, 0xA6, 0x44, 0x38, 0x00, 0x00, 0x00, 0x00, // Asc: 174
        0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 175
        0x00, 0x78, 0x78, 0xCC, 0xCC, 0xCC, 0x78, 0x78, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 176
        0x00, 0x00, 0x00, 0x18, 0x18, 0x7E, 0x7E, 0x18, 0x18, 0x00, 0x00, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Asc: 177
        0x00, 0x00, 0x38, 0x08, 0x38, 0x20, 0x38, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 178
        0x00, 0x00, 0x38, 0x08, 0x38, 0x08, 0x38, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 179
        0x00, 0x0C, 0x18, 0x30, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 180
        0x00, 0x00, 0x00, 0x00, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 0x6E, 0x7E, 0x60, 0x60, 0x60, 0x00, // Asc: 181
        0x00, 0x1E, 0x3E, 0x7E, 0x7E, 0x7E, 0x3E, 0x1E, 0x06, 0x06, 0x06, 0x06, 0x06, 0x00, 0x00, 0x00, // Asc: 182
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 183
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x10, 0x08, 0x08, 0x30, // Asc: 184
        0x00, 0x10, 0x30, 0x10, 0x10, 0x38, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 185
        0x00, 0x3C, 0x3C, 0x66, 0x66, 0x66, 0x66, 0x3C, 0x3C, 0x00, 0x7E, 0x7E, 0x00, 0x00, 0x00, 0x00, // Asc: 186
        0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x6C, 0x36, 0x36, 0x6C, 0x48, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 187
        0x00, 0x30, 0x70, 0x30, 0x36, 0x3C, 0x18, 0x36, 0x66, 0x4A, 0x1A, 0x1F, 0x02, 0x02, 0x00, 0x00, // Asc: 188
        0x00, 0x20, 0x60, 0x20, 0x26, 0x2C, 0x18, 0x3E, 0x6A, 0x42, 0x0E, 0x18, 0x1E, 0x00, 0x00, 0x00, // Asc: 189
        0x00, 0x70, 0x10, 0x70, 0x76, 0x1C, 0x78, 0x36, 0x66, 0x4A, 0x1A, 0x1F, 0x02, 0x02, 0x00, 0x00, // Asc: 190
        0x00, 0x00, 0x18, 0x18, 0x00, 0x18, 0x18, 0x18, 0x30, 0x62, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 191
        0x70, 0x38, 0x18, 0x3C, 0x7E, 0x66, 0x66, 0x7E, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Asc: 192
        0x0E, 0x1C, 0x18, 0x3C, 0x7E, 0x66, 0x66, 0x7E, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Asc: 193
        0x18, 0x3C, 0x5A, 0x3C, 0x7E, 0x66, 0x66, 0x7E, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Asc: 194
        0x36, 0x6C, 0x18, 0x3C, 0x7E, 0x66, 0x66, 0x7E, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Asc: 195
        0x66, 0x66, 0x18, 0x3C, 0x7E, 0x66, 0x66, 0x7E, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Asc: 196
        0x18, 0x24, 0x3C, 0x18, 0x3C, 0x7E, 0x66, 0x66, 0x7E, 0x7E, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Asc: 197
        0x00, 0x1E, 0x3E, 0x6E, 0x68, 0xC8, 0x8E, 0x8E, 0xFE, 0xF8, 0xC8, 0xCE, 0xCE, 0x00, 0x00, 0x00, // Asc: 198
        0x00, 0x00, 0x3C, 0x7C, 0x66, 0x66, 0x60, 0x60, 0x60, 0x60, 0x66, 0x3E, 0x3C, 0x0C, 0x38, 0x38, // Asc: 199
        0x70, 0x38, 0x7E, 0x7E, 0x60, 0x60, 0x7C, 0x7C, 0x60, 0x60, 0x60, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Asc: 200
        0x0E, 0x1C, 0x7E, 0x7E, 0x60, 0x60, 0x7C, 0x7C, 0x60, 0x60, 0x60, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Asc: 201
        0x18, 0x3C, 0x66, 0x7E, 0x7E, 0x60, 0x60, 0x7C, 0x7C, 0x60, 0x60, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Asc: 202
        0x66, 0x66, 0x5A, 0x7E, 0x60, 0x60, 0x7C, 0x7C, 0x60, 0x60, 0x60, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Asc: 203
        0x70, 0x38, 0x7E, 0x7E, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Asc: 204
        0x0E, 0x1C, 0x5A, 0x7E, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Asc: 205
        0x18, 0x3C, 0x66, 0x7E, 0x7E, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Asc: 206
        0x66, 0x66, 0x5A, 0x7E, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x7E, 0x7E, 0x00, 0x00, 0x00, // Asc: 207
        0x00, 0x00, 0x78, 0x6C, 0x66, 0x66, 0xF6, 0xF6, 0x66, 0x66, 0x6E, 0x7C, 0x78, 0x00, 0x00, 0x00, // Asc: 208
        0x36, 0x6C, 0x64, 0x66, 0x76, 0x76, 0x7E, 0x7E, 0x6E, 0x6E, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Asc: 209
        0x70, 0x38, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 210
        0x0E, 0x1C, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 211
        0x18, 0x3C, 0x66, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 212
        0x36, 0x6C, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 213
        0x66, 0x66, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 214
        0x00, 0x00, 0x00, 0x00, 0x00, 0x66, 0x3C, 0x18, 0x18, 0x3C, 0x66, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 215
        0x00, 0x00, 0x3E, 0x7C, 0x62, 0x66, 0x6E, 0x7E, 0x76, 0x66, 0x46, 0x3E, 0x7C, 0x00, 0x00, 0x00, // Asc: 216
        0x70, 0x38, 0x42, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 217
        0x0E, 0x1C, 0x42, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 218
        0x18, 0x3C, 0x42, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 219
        0x66, 0x66, 0x42, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 220
        0x0E, 0x1C, 0x42, 0x66, 0x66, 0x66, 0x66, 0x3C, 0x3C, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, // Asc: 221
        0x00, 0x00, 0x00, 0x60, 0x60, 0x7E, 0x7F, 0x63, 0x63, 0x63, 0x7E, 0x7C, 0x60, 0x60, 0x60, 0x00, // Asc: 222
        0x00, 0x00, 0x00, 0x3C, 0x66, 0x66, 0x66, 0x6C, 0x66, 0x66, 0x66, 0x66, 0x6C, 0x00, 0x00, 0x00, // Asc: 223
        0x00, 0x70, 0x38, 0x00, 0x3C, 0x3E, 0x06, 0x06, 0x3E, 0x7E, 0x66, 0x66, 0x3E, 0x00, 0x00, 0x00, // Asc: 224
        0x00, 0x0E, 0x1C, 0x00, 0x3C, 0x3E, 0x06, 0x06, 0x3E, 0x7E, 0x66, 0x66, 0x3E, 0x00, 0x00, 0x00, // Asc: 225
        0x00, 0x18, 0x3C, 0x42, 0x3C, 0x3E, 0x06, 0x06, 0x3E, 0x7E, 0x66, 0x66, 0x3E, 0x00, 0x00, 0x00, // Asc: 226
        0x00, 0x00, 0x36, 0x6C, 0x3C, 0x3C, 0x06, 0x06, 0x3E, 0x7E, 0x66, 0x66, 0x3E, 0x00, 0x00, 0x00, // Asc: 227
        0x00, 0x00, 0x66, 0x66, 0x3C, 0x3E, 0x06, 0x06, 0x3E, 0x7E, 0x66, 0x66, 0x3E, 0x00, 0x00, 0x00, // Asc: 228
        0x00, 0x1C, 0x36, 0x1C, 0x3C, 0x3E, 0x06, 0x06, 0x3E, 0x7E, 0x66, 0x66, 0x3E, 0x00, 0x00, 0x00, // Asc: 229
        0x00, 0x00, 0x00, 0x00, 0x7E, 0x7E, 0x0A, 0x0A, 0x7A, 0xFE, 0xC8, 0xC8, 0x7E, 0x00, 0x00, 0x00, // Asc: 230
        0x00, 0x00, 0x00, 0x00, 0x3C, 0x7E, 0x66, 0x60, 0x60, 0x60, 0x66, 0x3C, 0x18, 0x0C, 0x18, 0x30, // Asc: 231
        0x00, 0x70, 0x38, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x7E, 0x60, 0x60, 0x7E, 0x3E, 0x00, 0x00, 0x00, // Asc: 232
        0x00, 0x0E, 0x1C, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x7E, 0x60, 0x60, 0x7E, 0x3E, 0x00, 0x00, 0x00, // Asc: 233
        0x00, 0x18, 0x3C, 0x66, 0x3C, 0x7E, 0x66, 0x66, 0x7E, 0x60, 0x60, 0x7E, 0x3E, 0x00, 0x00, 0x00, // Asc: 234
        0x00, 0x00, 0x66, 0x66, 0x3C, 0x7E, 0x66, 0x66, 0x7E, 0x60, 0x60, 0x7E, 0x3E, 0x00, 0x00, 0x00, // Asc: 235
        0x00, 0x70, 0x38, 0x00, 0x38, 0x38, 0x18, 0x18, 0x18, 0x18, 0x18, 0x3C, 0x3C, 0x00, 0x00, 0x00, // Asc: 236
        0x00, 0x0E, 0x1C, 0x00, 0x38, 0x38, 0x18, 0x18, 0x18, 0x18, 0x18, 0x3C, 0x3C, 0x00, 0x00, 0x00, // Asc: 237
        0x00, 0x18, 0x3C, 0x66, 0x38, 0x38, 0x18, 0x18, 0x18, 0x18, 0x18, 0x3C, 0x3C, 0x00, 0x00, 0x00, // Asc: 238
        0x00, 0x00, 0x66, 0x66, 0x38, 0x38, 0x18, 0x18, 0x18, 0x18, 0x18, 0x3C, 0x3C, 0x00, 0x00, 0x00, // Asc: 239
        0x00, 0x7C, 0x30, 0x7C, 0x08, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 240
        0x00, 0x00, 0x36, 0x6C, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, // Asc: 241
        0x00, 0x70, 0x38, 0x00, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 242
        0x00, 0x0E, 0x1C, 0x00, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 243
        0x00, 0x18, 0x3C, 0x66, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 244
        0x00, 0x00, 0x36, 0x6C, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 245
        0x00, 0x00, 0x66, 0x66, 0x00, 0x3C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 246
        0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x00, 0x7E, 0x00, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, // Asc: 247
        0x00, 0x00, 0x00, 0x00, 0x3C, 0x7E, 0x6E, 0x6E, 0x66, 0x76, 0x76, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 248
        0x00, 0x70, 0x38, 0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 249
        0x00, 0x0E, 0x1C, 0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 250
        0x00, 0x18, 0x3C, 0x66, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 251
        0x00, 0x00, 0x66, 0x66, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x3C, 0x00, 0x00, 0x00, // Asc: 252
        0x00, 0x0E, 0x1C, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x24, 0x3C, 0x18, 0x18, 0x30, 0x70, 0x60, // Asc: 253
        0x00, 0x00, 0x60, 0x60, 0x60, 0x7C, 0x7E, 0x66, 0x66, 0x66, 0x66, 0x7E, 0x7C, 0x60, 0x60, 0x60, // Asc: 254
        0x00, 0x66, 0x66, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x24, 0x3C, 0x18, 0x18, 0x30, 0x70, 0x60 // Asc: 255
};
ROMBYTE IDR_DESKMENU  [] = { //  PdaRC Generated Tuesday, March 23, 2004, 11:39:15 Size: 1462
0x00, 0x04, 0x00, 0x5A, 0x77, 0x03, 0xB6, 0x05,  //BYTE:MajorVersion, BYTE:Compression, WORD:SizeOfBlock, WORD:UncompressSize
0x78, 0xDA, 0xCD, 0x53, 0x4D, 0x8C, 0x14, 0x45, 0x14, 0xFE, 0xAA, 0x8A, 0x81, 0x06, 0x44, 0x7A,
0xC1, 0x55, 0x11, 0x74, 0x4B, 0x05, 0x05, 0x54, 0xD8, 0x19, 0x67, 0x87, 0x41, 0x51, 0x71, 0x7A,
0xD8, 0x65, 0x75, 0x76, 0xA7, 0xD9, 0x5D, 0x58, 0x36, 0x51, 0x93, 0xDA, 0x99, 0xDA, 0x99, 0xCE,
0xF4, 0x74, 0x8F, 0x35, 0xDD, 0xB0, 0x6B, 0x88, 0xC6, 0xC4, 0x83, 0xC6, 0x70, 0x23, 0xD1, 0xC3,
0x7A, 0x91, 0x90, 0xA8, 0x31, 0xC4, 0x98, 0x60, 0x62, 0x22, 0x7A, 0xD1, 0x60, 0x62, 0x62, 0x62,
0x42, 0xBC, 0x18, 0x2E, 0x26, 0xC6, 0x83, 0x5C, 0xB8, 0x12, 0x0E, 0x56, 0x57, 0xF7, 0x2E, 0x6A,
0xF4, 0xEE, 0xA5, 0xEB, 0x7B, 0xDF, 0xAB, 0x7A, 0x3F, 0xDF, 0x7B, 0x0D, 0xAC, 0x53, 0x5F, 0xE4,
0x6C, 0x06, 0x58, 0x34, 0x07, 0xC2, 0x36, 0x01, 0x6B, 0x06, 0x61, 0xD3, 0xED, 0xB0, 0x73, 0x43,
0x40, 0x6E, 0x27, 0xAC, 0xB5, 0xFB, 0x80, 0x75, 0x65, 0x7D, 0xA1, 0x02, 0xAC, 0xAF, 0x69, 0xFE,
0x04, 0xB0, 0xE1, 0x25, 0x60, 0xE3, 0x3C, 0x70, 0x47, 0x1B, 0xD8, 0xE4, 0x03, 0x77, 0x2A, 0xD8,
0xEC, 0xB4, 0x7E, 0x77, 0x06, 0xD6, 0xE6, 0x37, 0x01, 0xFB, 0x2D, 0xD8, 0x6B, 0xDE, 0x06, 0x06,
0xCE, 0x02, 0x5B, 0xDE, 0x87, 0xB5, 0xF5, 0x3C, 0x70, 0xD7, 0x45, 0x7D, 0xE7, 0x4B, 0x60, 0xF0,
0x1B, 0xE0, 0xEE, 0xEF, 0x80, 0x7B, 0x7E, 0xD0, 0xB1, 0x7E, 0x86, 0xBB, 0xFE, 0x17, 0xE0, 0xDE,
0x5F, 0x81, 0x6D, 0xD7, 0x81, 0xFB, 0x6E, 0xC2, 0xC1, 0x00, 0xC1, 0xF6, 0x2D, 0x04, 0x3B, 0xB6,
0x11, 0x07, 0xBB, 0x09, 0xEE, 0xDF, 0x43, 0xF0, 0xC0, 0x08, 0xB1, 0xD7, 0x1E, 0x22, 0x18, 0x1A,
0x25, 0xE0, 0x75, 0x82, 0x07, 0xE7, 0x08, 0x1E, 0x92, 0xC4, 0x7A, 0x58, 0x11, 0xEC, 0x7C, 0x83,
0xB8, 0x1B, 0xCE, 0x12, 0xEC, 0x7A, 0x8F, 0xE0, 0x91, 0x65, 0x62, 0x3D, 0x7A, 0x5E, 0xBF, 0xFB,
0x98, 0x60, 0xF7, 0x27, 0x04, 0x7B, 0x2E, 0x12, 0x6B, 0xEF, 0x25, 0x6D, 0x7F, 0x45, 0xAC, 0xC7,
0x2E, 0x13, 0x3C, 0x7E, 0x85, 0xD8, 0xF6, 0x55, 0x82, 0x27, 0x7E, 0x23, 0xD8, 0xF7, 0x07, 0xC1,
0xFE, 0x1B, 0x04, 0xC3, 0x37, 0x09, 0xF2, 0x39, 0x8A, 0x82, 0x4D, 0xF1, 0xE4, 0x0E, 0x8A, 0xE2,
0x2E, 0x8A, 0x91, 0xFD, 0x14, 0xA5, 0x83, 0x14, 0x07, 0xAA, 0x14, 0x65, 0x97, 0xE2, 0xE0, 0xCB,
0x14, 0x4F, 0xB5, 0x28, 0x9E, 0x56, 0x14, 0x87, 0x5E, 0xA7, 0xB6, 0xFD, 0x2E, 0xC5, 0x33, 0xCB,
0x14, 0xCF, 0x7E, 0x48, 0xF1, 0xDC, 0x47, 0x14, 0x87, 0x3F, 0xA7, 0x78, 0xFE, 0x32, 0x45, 0xE5,
0x7B, 0x0A, 0xE7, 0x2A, 0x45, 0xF5, 0x1A, 0xC5, 0x91, 0xDF, 0x29, 0x46, 0x6F, 0x50, 0x8C, 0xDD,
0xA2, 0x38, 0x6A, 0x31, 0x8C, 0x0F, 0x32, 0xBC, 0x30, 0xC4, 0xF0, 0xE2, 0x5E, 0x86, 0x5A, 0x89,
0xB9, 0x1B, 0x1D, 0xC6, 0x27, 0xC6, 0x99, 0x83, 0x49, 0x66, 0x93, 0x3A, 0xC3, 0xE4, 0x2B, 0xFA,
0xEC, 0x32, 0xD4, 0xCF, 0xE8, 0xF3, 0x1D, 0x06, 0xF7, 0x9C, 0xF6, 0x2D, 0x33, 0xEB, 0xD8, 0x07,
0xEC, 0xF0, 0xD4, 0x05, 0xC6, 0xA7, 0x3F, 0x65, 0x98, 0xF9, 0x8C, 0xD1, 0xE3, 0x97, 0xD8, 0x00,
0xF9, 0x9A, 0xE1, 0xC4, 0xB7, 0xCC, 0x66, 0x57, 0x18, 0x66, 0x7F, 0x64, 0x38, 0xF9, 0x13, 0xC3,
0xDC, 0x35, 0x56, 0x95, 0xFD, 0x0E, 0x92, 0x4F, 0x14, 0xF6, 0x50, 0x0F, 0xB8, 0xEF, 0x05, 0x12,
0xAE, 0xF0, 0x82, 0x08, 0xAE, 0x0C, 0x30, 0xED, 0xBD, 0x26, 0x13, 0xC0, 0x87, 0xF9, 0x22, 0x1F,
0x36, 0x28, 0xAF, 0x51, 0x7E, 0x15, 0x15, 0x0D, 0x2A, 0xAE, 0x72, 0x45, 0xC3, 0x39, 0xA1, 0x1F,
0x2A, 0xCC, 0xB6, 0xBD, 0x48, 0xA2, 0xE2, 0x8B, 0x46, 0x07, 0x53, 0xB2, 0x89, 0x31, 0x25, 0x75,
0xC8, 0x8A, 0x1F, 0x4B, 0x8C, 0x7A, 0xBE, 0x8F, 0x89, 0xB0, 0x29, 0x75, 0x4E, 0xD4, 0x17, 0x16,
0xD2, 0x44, 0x09, 0x9B, 0x65, 0x32, 0xB0, 0xA0, 0x61, 0x21, 0x85, 0x69, 0xDC, 0x55, 0xB6, 0xFC,
0x2F, 0x29, 0x6A, 0x5E, 0xAB, 0x1D, 0xF1, 0x31, 0x25, 0x96, 0x30, 0x23, 0x17, 0x23, 0x8C, 0x86,
0xAA, 0x2B, 0x22, 0x1C, 0x0F, 0x9A, 0x52, 0x99, 0xB6, 0xA6, 0x23, 0xE5, 0x75, 0x64, 0xD4, 0x56,
0x61, 0xDC, 0x6A, 0xA7, 0x3C, 0x17, 0x41, 0x93, 0xF7, 0x0D, 0xCF, 0xD3, 0x88, 0x18, 0x8F, 0x84,
0xEF, 0x35, 0x74, 0xC1, 0xA7, 0xA4, 0xEA, 0x4B, 0x9E, 0x99, 0x98, 0x51, 0x22, 0xE8, 0xF7, 0x84,
0x92, 0x5A, 0x99, 0x7A, 0x4F, 0xBC, 0x9A, 0x34, 0x11, 0x06, 0x11, 0x4F, 0x0B, 0xAF, 0x4F, 0xCE,
0xF0, 0xE2, 0x62, 0x39, 0x05, 0xE5, 0xC5, 0x7C, 0x29, 0x45, 0x07, 0x12, 0x5D, 0x0A, 0x29, 0xCE,
0x27, 0x8D, 0x15, 0x86, 0x33, 0xA3, 0x94, 0x78, 0xB2, 0x5B, 0x25, 0x23, 0x5F, 0xA1, 0xAC, 0x75,
0x57, 0xA2, 0xA5, 0x44, 0xAF, 0x8D, 0x9A, 0x5C, 0x88, 0xE0, 0xE8, 0x5C, 0x52, 0x61, 0x2A, 0xE9,
0x4B, 0x17, 0xA0, 0x07, 0x34, 0xE1, 0x35, 0x9B, 0xBE, 0xEE, 0x37, 0x8C, 0xA2, 0xB0, 0x0B, 0xCC,
0x86, 0xAA, 0x59, 0x51, 0x52, 0x74, 0x30, 0x19, 0xF2, 0xC4, 0x98, 0x37, 0x86, 0x69, 0x84, 0xEB,
0xF6, 0x65, 0x4B, 0xB7, 0x1A, 0x34, 0xFF, 0xA6, 0x52, 0x55, 0xA8, 0x8E, 0x19, 0x41, 0x2A, 0x97,
0x81, 0x09, 0xC7, 0xD3, 0xE9, 0xAC, 0x88, 0x98, 0x60, 0x43, 0x27, 0x83, 0x4B, 0xC9, 0x04, 0x65,
0x37, 0xB5, 0xC4, 0x7F, 0x51, 0xDB, 0x90, 0x73, 0xD2, 0xF7, 0xC3, 0xD3, 0x19, 0x9D, 0x19, 0xC6,
0xE1, 0x2C, 0x89, 0x95, 0xB0, 0x06, 0x1A, 0xD2, 0x8D, 0x55, 0xCF, 0x5F, 0xA9, 0x21, 0x33, 0xD2,
0xB2, 0x2B, 0xBA, 0xC8, 0xFF, 0x28, 0x9B, 0xFF, 0x3F, 0xEB, 0x9E, 0x90, 0x41, 0x5C, 0xD0, 0x2B,
0xD7, 0x4F, 0x86, 0xA4, 0xBF, 0x7A, 0x41, 0x6B, 0x7A, 0x79, 0xF4, 0xA2, 0x22, 0x3B, 0x79, 0x4A,
0x63, 0x3A, 0x9E, 0xF7, 0x0D, 0x93, 0xD8, 0x2B, 0xDE, 0xDB, 0xBE, 0x7F, 0xBC, 0x02, 0x9C, 0xB6,
0x6C, 0x74, 0x74, 0xF5, 0x5A, 0x99, 0xB8, 0xAB, 0xFF, 0x1C, 0xA1, 0x70, 0xF4, 0x48, 0xCD, 0x85,
0x17, 0x88, 0x46, 0xE4, 0x9D, 0x4A, 0x53, 0x17, 0xB1, 0xB4, 0x64, 0x00, 0x1F, 0x41, 0x1C, 0xEB,
0x7F, 0xB9, 0x1B, 0xF2, 0xAA, 0x27, 0xFC, 0xB0, 0x05, 0x47, 0xF8, 0x8D, 0xD8, 0x17, 0x91, 0x5E,
0xEB, 0x3F, 0x01, 0xB6, 0x04, 0x88, 0xA8
};
///////////////////////////////////////////////////////////////////////////////////////////////////
ROMBYTE BITMAP_PAINTMENU  [] = { // Binary image Table Generated.
0x20, 0x03, 0x20, 0x00, 0x01, 0x5A, 0x3B, 0x03,  // WORD:Width, WORD:Height, BYTE:BitPerPixel, BYTE:Compression, WORD:ImageSize
0x78, 0xDA, 0xD5, 0xD6, 0x5F, 0x48, 0x53, 0x51, 0x1C, 0x07, 0xF0, 0x3B, 0xA7, 0x0E, 0x41, 0x1B,
0x3D, 0x55, 0x94, 0x1A, 0x04, 0x0A, 0xF5, 0x62, 0x5D, 0x24, 0x7C, 0xD0, 0x1B, 0xF8, 0x1A, 0xF8,
0x24, 0xBD, 0x06, 0x95, 0xBD, 0x89, 0xA4, 0xB9, 0x1B, 0xEE, 0xEE, 0x08, 0x82, 0x7B, 0x4A, 0x03,
0x1F, 0x22, 0x22, 0xB5, 0xA7, 0xB0, 0xA7, 0x9E, 0xF2, 0xC1, 0x07, 0x97, 0x46, 0x85, 0x58, 0x7B,
0xEA, 0x49, 0x6C, 0x2B, 0xB2, 0x15, 0x64, 0xFE, 0x59, 0xB5, 0xCD, 0xDD, 0x73, 0xBE, 0xFD, 0xEE,
0x39, 0x73, 0x8E, 0x10, 0xBC, 0x93, 0x2D, 0xE8, 0xB0, 0x71, 0xEE, 0x76, 0xC7, 0xFD, 0xEC, 0xF7,
0xFB, 0x9D, 0xDF, 0xB9, 0x17, 0xF8, 0x7F, 0xC6, 0xB0, 0x26, 0x87, 0x77, 0x9F, 0xD9, 0x5B, 0x2A,
0x83, 0xA9, 0x89, 0xEF, 0x33, 0xF3, 0x52, 0x1B, 0x26, 0x1D, 0x24, 0xCA, 0x6C, 0x04, 0xA1, 0x8C,
0xD0, 0xAE, 0xA9, 0xF9, 0x4A, 0x66, 0x04, 0x55, 0xFE, 0x79, 0xF0, 0xC5, 0x62, 0xED, 0x63, 0x78,
0x78, 0x50, 0xA1, 0x3C, 0x80, 0x44, 0xA1, 0x61, 0xD3, 0x3B, 0x7D, 0x58, 0xC3, 0x9A, 0x0B, 0xF4,
0xAE, 0xAF, 0x3C, 0xE7, 0xC1, 0xE5, 0xC9, 0xEB, 0xCD, 0x38, 0xC7, 0x4D, 0x23, 0x67, 0x68, 0x37,
0x39, 0xEC, 0x46, 0x08, 0xCD, 0xE3, 0x24, 0x8D, 0xD3, 0xD7, 0x29, 0x26, 0xC3, 0x1E, 0xD6, 0x80,
0x08, 0x43, 0x9A, 0xB2, 0x9B, 0xA1, 0x23, 0xCD, 0x28, 0xC2, 0x18, 0xAD, 0x4C, 0xE0, 0x0A, 0xBF,
0x35, 0x55, 0x60, 0xA4, 0xFD, 0x10, 0xF3, 0x5B, 0x4E, 0x10, 0xA2, 0x0B, 0xD8, 0x98, 0x07, 0x9C,
0x97, 0x80, 0x30, 0xC6, 0x01, 0x1D, 0xF8, 0x0D, 0xC4, 0x44, 0x31, 0xC6, 0x42, 0x30, 0x81, 0x66,
0x7E, 0xA3, 0x2B, 0x67, 0x18, 0x64, 0xC4, 0x7D, 0x74, 0xB9, 0xF7, 0xB0, 0x19, 0x44, 0x92, 0x8C,
0x18, 0x5D, 0x92, 0x61, 0xBA, 0x02, 0x3C, 0x9E, 0x02, 0xC2, 0xAE, 0x8D, 0x7C, 0x3D, 0x96, 0xB7,
0xC9, 0xE8, 0xE4, 0x57, 0xFD, 0x39, 0xA3, 0x3D, 0x67, 0x38, 0x71, 0xD0, 0x65, 0x2C, 0x32, 0xE8,
0xCF, 0x6F, 0x48, 0x23, 0xAB, 0x9D, 0x04, 0xDE, 0xF9, 0x90, 0x65, 0xEE, 0xE2, 0xF8, 0xB1, 0xBA,
0x32, 0x37, 0x37, 0xC8, 0xCD, 0xCB, 0xE1, 0xCA, 0x2D, 0xB4, 0xE5, 0xD7, 0x55, 0xE0, 0x2C, 0xAD,
0x2B, 0xDB, 0x89, 0xE3, 0x97, 0x53, 0x16, 0x98, 0x54, 0x0F, 0x9F, 0xAC, 0x09, 0x19, 0x3F, 0xB5,
0x2A, 0x69, 0x24, 0xFD, 0x45, 0x19, 0x6A, 0x39, 0x05, 0xC9, 0xA0, 0x1C, 0x40, 0x58, 0x81, 0x56,
0x5A, 0x57, 0xAF, 0x72, 0xF5, 0xA0, 0xD8, 0x9E, 0x31, 0xEC, 0x50, 0xE3, 0x67, 0xA5, 0xF1, 0x5D,
0xAB, 0x26, 0xE3, 0x3E, 0xD6, 0x67, 0x0F, 0x61, 0xD8, 0x64, 0xE8, 0xCA, 0xA8, 0xAD, 0xE4, 0x18,
0x39, 0xA1, 0xE2, 0xA0, 0x00, 0xA6, 0x0D, 0xD8, 0x1E, 0xD9, 0x97, 0x64, 0x7C, 0xD5, 0x2A, 0x80,
0xE8, 0x14, 0xD6, 0x9E, 0x14, 0x55, 0x8F, 0xBC, 0x21, 0x86, 0x94, 0x71, 0x7E, 0xC1, 0x82, 0x27,
0xA3, 0xE2, 0xA0, 0x00, 0xDE, 0xD0, 0x32, 0xBE, 0x24, 0x7F, 0x53, 0x60, 0xC4, 0x8F, 0xB9, 0x8B,
0x23, 0xAB, 0xD6, 0xD5, 0x9E, 0xC1, 0xC2, 0xBE, 0xF0, 0x11, 0x2B, 0xD0, 0xFE, 0x96, 0x8C, 0x34,
0xF5, 0x47, 0x95, 0xAC, 0xC7, 0x67, 0xCA, 0xD7, 0x69, 0x86, 0x8F, 0x8B, 0xF9, 0x5C, 0x91, 0xF1,
0x29, 0x85, 0x58, 0xBA, 0x58, 0x23, 0xE3, 0x18, 0xBA, 0x7E, 0xA1, 0xC7, 0x0A, 0x3C, 0x5A, 0x22,
0x63, 0x93, 0x89, 0xA7, 0x33, 0xB0, 0xA9, 0x67, 0xB6, 0x29, 0x5F, 0xF7, 0x8C, 0x5C, 0x1C, 0xB2,
0xE6, 0x39, 0x63, 0xC7, 0xBD, 0x61, 0x36, 0x22, 0x0A, 0x24, 0x79, 0x28, 0xC4, 0x16, 0xF5, 0x8E,
0x6A, 0x2B, 0xF0, 0xE0, 0xA5, 0x05, 0x6F, 0x9C, 0x89, 0xEE, 0x6E, 0x70, 0x3A, 0x93, 0x71, 0xF2,
0xA5, 0x0C, 0xAF, 0x5A, 0xBB, 0xEE, 0x0D, 0x55, 0x8F, 0x6A, 0x1E, 0x62, 0x8E, 0x91, 0xE0, 0xAC,
0x83, 0x4D, 0xE8, 0x1D, 0x21, 0x6B, 0xA0, 0x75, 0xA9, 0x1E, 0xBE, 0x08, 0x13, 0xD3, 0x35, 0x70,
0xCE, 0xD8, 0x23, 0x94, 0x2F, 0xC3, 0xD9, 0x4C, 0x64, 0x0F, 0x52, 0xF7, 0x85, 0xFD, 0x88, 0x78,
0x11, 0x5B, 0x70, 0x11, 0x07, 0x5F, 0x99, 0xED, 0x5D, 0xFF, 0xC0, 0x43, 0x66, 0x4F, 0x27, 0x5D,
0x8C, 0xB3, 0xC9, 0x21, 0xDD, 0x31, 0x6E, 0x67, 0x5E, 0xDF, 0xC5, 0x38, 0x19, 0x5D, 0x6B, 0x72,
0x43, 0x16, 0x74, 0x76, 0x5B, 0x1A, 0x72, 0x2F, 0x19, 0x93, 0x7B, 0xC9, 0x45, 0xEA, 0xF3, 0x55,
0xB8, 0x37, 0xFA, 0x9B, 0x68, 0x17, 0x99, 0xE2, 0x2C, 0xAA, 0xCB, 0x7A, 0x0C, 0x34, 0x34, 0xD4,
0x21, 0x4A, 0xC6, 0xCC, 0x37, 0x69, 0xE0, 0x0C, 0xE5, 0x4B, 0x1A, 0xC3, 0x35, 0x06, 0x22, 0x77,
0x0C, 0xDA, 0x13, 0x6D, 0xD3, 0x8B, 0x48, 0x85, 0x9B, 0x38, 0x1E, 0x2A, 0xA3, 0xAF, 0x85, 0x32,
0x62, 0x70, 0x96, 0x08, 0x8F, 0xE8, 0xB4, 0xAE, 0x06, 0x1A, 0x05, 0x19, 0x71, 0xC8, 0x38, 0x9C,
0x31, 0x91, 0xBF, 0xDF, 0x08, 0xA8, 0x37, 0xD0, 0xE2, 0xCE, 0xD8, 0xED, 0x8F, 0x50, 0xFF, 0x66,
0x14, 0x82, 0x71, 0x96, 0x54, 0x7B, 0xC9, 0x40, 0x5B, 0xA2, 0x0E, 0xD8, 0x92, 0x7B, 0xFB, 0x5F,
0x63, 0xCF, 0x88, 0xB8, 0x8C, 0x23, 0x3B, 0x07, 0x04, 0x06, 0xC9, 0xF8, 0xD2, 0x45, 0x9B, 0x38,
0x67, 0x19, 0x65, 0x0C, 0x1E, 0x5D, 0xA8, 0x2F, 0xD5, 0x7D, 0x30, 0x6F, 0x98, 0x4D, 0xD7, 0xE8,
0x9E, 0xC3, 0x99, 0x9D, 0x33, 0x3C, 0x91, 0xF6, 0x52, 0xDF, 0x6B, 0x65, 0x0F, 0x26, 0xC9, 0x10,
0xF2, 0x88, 0xF7, 0x69, 0x9A, 0x55, 0x96, 0x67, 0x9F, 0x84, 0x33, 0x1B, 0xEA, 0xF3, 0xE8, 0xF1,
0x92, 0x1B, 0xA6, 0x13, 0x8D, 0xDF, 0x31, 0xE4, 0x53, 0x9C, 0xC5, 0xC6, 0x4E, 0xF1, 0xB2, 0xC4,
0x51, 0x38, 0x8B, 0xC6, 0xF2, 0x1B, 0x25, 0x7C, 0x86, 0x3B, 0xE8, 0x79, 0x97, 0xAC, 0xD4, 0xC1,
0xD3, 0xE1, 0x87, 0xF6, 0x0F, 0xC6, 0x1F, 0x99, 0xE8, 0x65, 0xCF
};
ROMBYTE PDASYMBOL [] = { // Tuesday, April 06, 2004, 12:01:33:  ; Binary Font Table Generated.
0x00, 0x00, 0x00, 0x00, 0x00, 0x06, 0x1E, 0x7E, 0x7E, 0x1E, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 168 LEFT   SCROLL
0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x3C, 0x3C, 0x7E, 0x7E, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 169 TOP    SCROLL
0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x78, 0x7E, 0x7E, 0x78, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 170 RIGHT  SCROLL
0x00, 0x00, 0x00, 0x00, 0x00, 0x7E, 0x7E, 0x3C, 0x3C, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 171 BOTTOM SCROLL
0x00, 0x18, 0x3C, 0x7E, 0x7E, 0xFF, 0xFF, 0x00, 0x00, 0xFF, 0xFF, 0x7E, 0x7E, 0x3C, 0x18, 0x00, // Asc: 172 SPIN   BOX VERTICAL
0xFF, 0x81, 0x81, 0x99, 0x81, 0x99, 0x81, 0xFF, 0xFF, 0x81, 0x99, 0x81, 0x99, 0x81, 0x81, 0xFF, // Asc: 173 DOUBLE THUMB
0xFF, 0x81, 0x81, 0x99, 0x99, 0x81, 0x81, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 174 SINGLE THUMB
0xA3, 0xC5, 0x89, 0x91, 0xA3, 0xC5, 0x89, 0x91, 0xA3, 0xC5, 0x89, 0x91, 0xA3, 0xC5, 0x89, 0x91, // Asc: 175 GRAD   SCROLL VERTICAL
0xFF, 0x44, 0x22, 0x11, 0x88, 0x44, 0x22, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // Asc: 176 GRAD   SCROLL HORIZONTAL
0x00, 0x00, 0x3F, 0x3F, 0x38, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x38, 0x3F, 0x3F, 0x00, 0x00, // Asc: 177 CHECKBOX EMPTY   PART 1
0x00, 0x00, 0xFC, 0xFC, 0x1C, 0x0C, 0x0C, 0x0C, 0x0C, 0x0C, 0x0C, 0x1C, 0xFC, 0xFC, 0x00, 0x00, // Asc: 178 CHECKBOX EMPTY   PART 2
0x00, 0x00, 0x3F, 0x3F, 0x38, 0x30, 0x30, 0x34, 0x37, 0x33, 0x31, 0x38, 0x3F, 0x3F, 0x00, 0x00, // Asc: 179 CHECKBOX CHECKED PART 1
0x00, 0x00, 0xFC, 0xFC, 0x0C, 0x2C, 0x6C, 0xCC, 0x8C, 0x8C, 0x0C, 0x1C, 0xFC, 0xFC, 0x00, 0x00, // Asc: 180 CHECKBOX CHECKED PART 2
0x00, 0x00, 0x03, 0x0F, 0x1C, 0x18, 0x30, 0x30, 0x30, 0x30, 0x18, 0x1C, 0x0F, 0x03, 0x00, 0x00, // Asc: 181 RADIOBOX EMPTY   PART 1
0x00, 0x00, 0xC0, 0xF0, 0x38, 0x18, 0x0C, 0x0C, 0x0C, 0x0C, 0x18, 0x38, 0xF0, 0xC0, 0x00, 0x00, // Asc: 182 RADIOBOX EMPTY   PART 2
0x00, 0x00, 0x03, 0x0F, 0x1C, 0x18, 0x31, 0x33, 0x33, 0x31, 0x18, 0x1C, 0x0F, 0x03, 0x00, 0x00, // Asc: 183 RADIOBOX CHECKED PART 1
0x00, 0x00, 0xC0, 0xF0, 0x38, 0x18, 0x8C, 0xCC, 0xCC, 0x8C, 0x18, 0x38, 0xF0, 0xC0, 0x00, 0x00, // Asc: 184 RADIOBOX CHECKED PART 2
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7E, 0x7E, 0x00, 0x00, 0x00, 0x00, // Asc: 185 MINIMIZE BUTTON
0x00, 0x00, 0x00, 0xFF, 0xFF, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0xFF, 0x00, 0x00, 0x00, 0x00, // Asc: 186 MAXIMIZE BUTTOM
0x00, 0x00, 0x00, 0x00, 0x00, 0xC3, 0x66, 0x3C, 0x18, 0x3C, 0x66, 0xC3, 0x00, 0x00, 0x00, 0x00  // Asc: 187 CLOSE    BUTTON
};
ROMBYTE IDR_PDAMENU  [] = { //  PdaRC Generated Friday, April 23, 2004, 13:21:50 Size: 109
0x00, 0x04, 0x00, 0x5A, 0x69, 0x00, 0x6D, 0x00,  //BYTE:MajorVersion, BYTE:Compression, WORD:SizeOfBlock, WORD:UncompressSize
0x78, 0xDA, 0x05, 0xC1, 0xB1, 0x0E, 0x82, 0x30, 0x14, 0x40, 0xD1, 0x0B, 0x82, 0x54, 0x13, 0x13,
0x06, 0x47, 0x37, 0x16, 0x16, 0x46, 0x16, 0x37, 0xA2, 0x6B, 0xD5, 0x5F, 0x68, 0x78, 0x4F, 0x43,
0x28, 0x2D, 0xA1, 0xFC, 0x7F, 0x3C, 0x07, 0xCC, 0x79, 0xA1, 0xCE, 0xC1, 0x98, 0x12, 0x4E, 0x17,
0xC8, 0xAE, 0x90, 0xDF, 0xE0, 0xD0, 0x40, 0xD1, 0x42, 0xD9, 0xC1, 0xB1, 0x87, 0xEA, 0x8E, 0x8D,
0xA2, 0x3C, 0x35, 0xCD, 0x7B, 0x5C, 0x79, 0x07, 0x3F, 0x05, 0x65, 0x10, 0xD9, 0x34, 0x25, 0x86,
0x9F, 0x06, 0x71, 0x58, 0x5D, 0x22, 0x0F, 0xE7, 0x47, 0x5E, 0x71, 0xD7, 0xD5, 0x09, 0xD6, 0x4D,
0x9E, 0xCF, 0xA6, 0x5F, 0xFE, 0x4B, 0x37, 0x16, 0x96
};
ROMBYTE IDD_APPDLG  [] = { //  PdaRC Generated Friday, April 23, 2004, 14:03:48 Size: 476
0x00, 0x05, 0x00, 0x5A, 0xD4, 0x00, 0xDC, 0x01,  //BYTE:MajorVersion, BYTE:Compression, WORD:SizeOfBlock, WORD:UncompressSize
0x78, 0xDA, 0x63, 0x50, 0x60, 0x00, 0x82, 0x34, 0xA6, 0x73, 0x0C, 0x0C, 0x1C, 0x02, 0x0C, 0xB8,
0x81, 0x01, 0x94, 0x56, 0x61, 0xE0, 0x62, 0x62, 0x61, 0xF0, 0x63, 0x90, 0x60, 0x60, 0x62, 0x68,
0x80, 0x8A, 0x6D, 0x60, 0x44, 0x55, 0x9B, 0x80, 0xC4, 0x06, 0xA9, 0x57, 0x00, 0xAB, 0x67, 0x86,
0xAB, 0xDF, 0xC2, 0x88, 0x6A, 0xEE, 0x04, 0x34, 0xF5, 0x36, 0x60, 0xF5, 0x2C, 0x70, 0xF5, 0x3B,
0x19, 0x51, 0xCD, 0x3E, 0x80, 0xA6, 0x3E, 0x02, 0xAC, 0x9E, 0x15, 0xAE, 0xFE, 0x00, 0x92, 0x7A,
0x90, 0xD9, 0x1F, 0x90, 0xD4, 0xAB, 0x01, 0xCD, 0x65, 0x61, 0xF8, 0xC5, 0x78, 0x8C, 0x81, 0x91,
0xA1, 0x19, 0x2A, 0x76, 0x0C, 0x49, 0x3D, 0xC8, 0x6C, 0x05, 0x46, 0x14, 0xF5, 0x4C, 0x9B, 0x18,
0xA2, 0x80, 0xE6, 0xB3, 0x33, 0x34, 0x42, 0xC5, 0x8E, 0x23, 0xC9, 0x83, 0xCC, 0x0E, 0x60, 0x44,
0x75, 0x4F, 0x09, 0xD8, 0x3D, 0x6C, 0x70, 0xF7, 0x9C, 0x40, 0x92, 0x07, 0x99, 0xDD, 0x80, 0xA2,
0x9E, 0x8D, 0x69, 0x01, 0xD0, 0x7C, 0x21, 0x06, 0x0E, 0x86, 0x26, 0xA8, 0xD8, 0x05, 0x24, 0xF9,
0x00, 0xB4, 0xB0, 0xF5, 0x4B, 0x2D, 0x67, 0x08, 0x4E, 0x2C, 0x4B, 0x65, 0x70, 0x49, 0xCD, 0x49,
0x2D, 0x49, 0x65, 0x70, 0xCE, 0xC9, 0x2F, 0x4E, 0x05, 0x8A, 0xFB, 0xE4, 0xE7, 0x67, 0x2B, 0x94,
0x16, 0x30, 0x04, 0xA7, 0x26, 0x16, 0x25, 0x67, 0x28, 0x94, 0xA4, 0x56, 0x94, 0x30, 0x00, 0x00,
0x94, 0x4B, 0x29, 0x10
};
ROMBYTE IDD_CALC  [] = { //  PdaRC Generated Thursday, May 13, 2004, 14:19:54 Size: 1059
0x00, 0x05, 0x00, 0x5A, 0x61, 0x01, 0x23, 0x04,  //BYTE:MajorVersion, BYTE:Compression, WORD:SizeOfBlock, WORD:UncompressSize
0x78, 0xDA, 0x65, 0xD3, 0xBD, 0x4A, 0x03, 0x41, 0x14, 0x86, 0xE1, 0x6F, 0x66, 0x62, 0x8C, 0x31,
0xC6, 0x35, 0x2E, 0x12, 0x44, 0x24, 0x86, 0x68, 0xE3, 0x5F, 0xFC, 0xD7, 0x42, 0x10, 0x82, 0x60,
0x25, 0x56, 0x62, 0x99, 0x60, 0x1B, 0x30, 0x48, 0xEC, 0xE3, 0x1D, 0xA4, 0x4A, 0x6D, 0x6D, 0x65,
0x6D, 0x95, 0x0B, 0xB0, 0x10, 0xAF, 0xC0, 0x4B, 0x48, 0x2F, 0xA2, 0x7B, 0x76, 0x86, 0xE3, 0x39,
0x71, 0x8B, 0x6C, 0xD8, 0x3C, 0xBC, 0xCC, 0x07, 0x59, 0xB7, 0x92, 0x85, 0xC5, 0x07, 0x5E, 0x81,
0x38, 0x82, 0xBF, 0x46, 0x0E, 0xFF, 0xAE, 0x7A, 0xB8, 0xD7, 0x12, 0x5D, 0x49, 0x3E, 0xAB, 0xC9,
0xBD, 0x17, 0x9E, 0x7D, 0x8D, 0xF9, 0xA6, 0xF8, 0x5E, 0xC3, 0x46, 0xF0, 0x8E, 0xFD, 0xB7, 0xD3,
0xDD, 0xBE, 0xF2, 0xD7, 0xC1, 0x67, 0xD8, 0xFF, 0x38, 0xDD, 0x1E, 0x2A, 0xDF, 0x0B, 0x7E, 0x82,
0xBD, 0xC9, 0xFC, 0xFD, 0x4E, 0xED, 0x91, 0xF2, 0xCF, 0xC1, 0x67, 0xD9, 0x3B, 0xE1, 0xA9, 0x5D,
0x31, 0xD2, 0x5B, 0x5C, 0xA4, 0x7E, 0x92, 0x7D, 0x56, 0x78, 0x6A, 0x5F, 0x19, 0xBD, 0xD7, 0xFB,
0x1C, 0xFB, 0x9C, 0xF0, 0xD4, 0xEE, 0x19, 0xBD, 0xD7, 0xFB, 0x29, 0xF6, 0x79, 0xE1, 0xA9, 0xFD,
0x62, 0xF4, 0x5E, 0xEF, 0xF3, 0xEC, 0x0B, 0xC2, 0x53, 0xFB, 0xD3, 0xE8, 0xBD, 0xDE, 0x4F, 0xB3,
0x2F, 0x0A, 0x4F, 0xED, 0xC8, 0xEA, 0xBD, 0x9D, 0xD4, 0x17, 0xD8, 0x47, 0xC2, 0x53, 0xFB, 0xCC,
0xEA, 0xBD, 0xDE, 0xCF, 0xB0, 0x2F, 0x09, 0x4F, 0xED, 0x8E, 0xD5, 0x7B, 0xBD, 0x2F, 0xB2, 0x8F,
0x85, 0xA7, 0xF6, 0x93, 0xD5, 0x7B, 0xBD, 0x9F, 0x65, 0xBF, 0x20, 0x3C, 0xB5, 0xDF, 0xAD, 0xDE,
0xEB, 0x7D, 0xC4, 0xBE, 0x2C, 0x7C, 0xDA, 0x76, 0x7A, 0xEF, 0x00, 0x97, 0x89, 0x9F, 0x63, 0xBF,
0x28, 0x3C, 0xB5, 0xEB, 0x4E, 0x9F, 0x7F, 0x90, 0xF6, 0x4B, 0xEC, 0x97, 0x84, 0xA7, 0x76, 0xD3,
0xE9, 0xF3, 0x78, 0x1F, 0xB3, 0x5F, 0x16, 0x9E, 0xDA, 0x7D, 0xA7, 0xF7, 0x7A, 0x3F, 0xCF, 0xBE,
0x22, 0x3C, 0xB5, 0x87, 0xC2, 0xAF, 0x25, 0xE7, 0xCF, 0xE0, 0x0D, 0x65, 0x18, 0x3C, 0x86, 0x67,
0x55, 0xF9, 0xFF, 0x1F, 0x7B, 0x37, 0x1B, 0xAD, 0xF6, 0xED, 0x43, 0xBB, 0xD5, 0xBD, 0xBB, 0xC7,
0x11, 0x8E, 0x71, 0x82, 0x06, 0x1A, 0xE7, 0xD8, 0xC7, 0x01, 0x0E, 0xB1, 0x8E, 0x4D, 0xEC, 0x60,
0x17, 0x7B, 0xB8, 0xC1, 0x76, 0xF2, 0x66, 0x6E, 0xE1, 0x14, 0xAB, 0xC0, 0x2F, 0x0C, 0xF5, 0x42,
0xD5
};
ROMBYTE IDD_DIALOG  [] = { //  PdaRC Generated Tuesday, April 06, 2004, 17:37:47 Size: 722
0x00, 0x05, 0x00, 0x5A, 0x5A, 0x01, 0xD2, 0x02,  //BYTE:MajorVersion, BYTE:Compression, WORD:SizeOfBlock, WORD:UncompressSize
0x78, 0xDA, 0x75, 0xD2, 0x3F, 0x4B, 0xC3, 0x40, 0x18, 0x06, 0xF0, 0xE7, 0xAE, 0x5A, 0x15, 0x8B,
0x64, 0x70, 0x50, 0x71, 0x08, 0x12, 0x4A, 0x07, 0x07, 0xDB, 0x0F, 0xA0, 0x62, 0xBA, 0x59, 0x30,
0x68, 0x67, 0x31, 0xB6, 0x07, 0x06, 0x35, 0x29, 0x6D, 0xA0, 0x0E, 0x82, 0xAD, 0xFF, 0x40, 0x5D,
0x1C, 0x1C, 0xFA, 0x09, 0xC4, 0x51, 0xF4, 0x0B, 0x38, 0x76, 0x53, 0x37, 0xC7, 0x0E, 0xE2, 0x28,
0xCE, 0x4E, 0xBE, 0x67, 0x8F, 0xF0, 0x56, 0xF0, 0x0E, 0xEE, 0xC2, 0x7B, 0xBF, 0x7B, 0xEE, 0x1D,
0x92, 0x5A, 0x02, 0x0D, 0x4F, 0x7E, 0x02, 0x19, 0x0B, 0xFF, 0x8F, 0x05, 0xB3, 0x3B, 0x48, 0xD3,
0x2C, 0x60, 0x12, 0x02, 0xC7, 0xA6, 0x56, 0x93, 0x83, 0x76, 0x8B, 0x7D, 0x67, 0xB1, 0x48, 0xFE,
0x06, 0x53, 0x90, 0x68, 0x9B, 0x5A, 0x53, 0x0E, 0xE6, 0x5E, 0x33, 0xEF, 0x88, 0x37, 0xF2, 0x1E,
0xE5, 0xA7, 0xD0, 0x32, 0xB5, 0x03, 0x39, 0x98, 0xFD, 0xC4, 0xBD, 0x9C, 0x17, 0x7D, 0x3F, 0x94,
0xF8, 0x23, 0xE6, 0x75, 0xF6, 0x17, 0xF7, 0xF8, 0x20, 0x5F, 0xC6, 0x2C, 0xC6, 0x13, 0x7F, 0xCE,
0xBC, 0xCE, 0xB6, 0x05, 0xEF, 0x3F, 0x8D, 0x1C, 0x3A, 0x38, 0xC4, 0x30, 0x4E, 0x4C, 0xED, 0x82,
0x79, 0x9D, 0xED, 0x31, 0xEF, 0xCC, 0xDC, 0xD1, 0x9D, 0x0E, 0x42, 0xBA, 0x77, 0x66, 0x6A, 0x97,
0xCC, 0xEB, 0xEC, 0x96, 0xF1, 0x57, 0x54, 0x77, 0xA6, 0x57, 0x44, 0x8E, 0xD2, 0x3D, 0x8C, 0x24,
0xFE, 0x81, 0x79, 0x9D, 0x7D, 0x6F, 0xFC, 0xA3, 0xEC, 0xF7, 0x9F, 0xFD, 0xED, 0x3F, 0x93, 0xF4,
0xDF, 0x65, 0x5E, 0x67, 0xF7, 0x78, 0x3F, 0xA9, 0x6F, 0x51, 0xC2, 0x1C, 0x4A, 0x18, 0xC5, 0xA9,
0xA9, 0x3D, 0x33, 0xAF, 0xB3, 0x2D, 0xC9, 0x7D, 0x57, 0x6C, 0xC2, 0xA2, 0x39, 0x96, 0xF8, 0x17,
0x76, 0xAE, 0xB3, 0x97, 0xB9, 0x97, 0xEF, 0xB8, 0x45, 0x8F, 0x5E, 0x98, 0x48, 0xFC, 0x2B, 0x3B,
0xB7, 0xFE, 0xFC, 0x1B, 0x1B, 0xB1, 0x1F, 0x07, 0x15, 0xC0, 0xDD, 0x51, 0x95, 0xDD, 0x3C, 0xD6,
0xFD, 0x6A, 0x10, 0xE5, 0xB1, 0xB6, 0x4A, 0x47, 0x6E, 0xB4, 0xBF, 0x1D, 0xD9, 0x65, 0xD5, 0x88,
0xA1, 0x17, 0xDB, 0xCE, 0x9B, 0xBD, 0x80, 0xA2, 0x0A, 0x83, 0x86, 0xED, 0x46, 0xB1, 0x22, 0x57,
0xAC, 0x47, 0x35, 0xBB, 0x1A, 0x35, 0x43, 0x78, 0x2A, 0x56, 0x75, 0x5A, 0x43, 0xBA, 0xEC, 0x87,
0x15, 0xB5, 0xA7, 0x5F, 0xF8, 0x01, 0x43, 0x13, 0x49, 0x0C
};
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////

